cordova.define("pluservice-plugin-applauncher.AppLauncher", function(require, exports, module) {

var exec = require('cordova/exec');

function AppLauncher() {
    console.log('plugin AppLauncher ok');
}

AppLauncher.prototype.Launch = function (appNameSpace, appSchema, win, fail) {
    console.log("Launcing App: " + appNameSpace + " - " + appSchema);
    exec(win, fail, 'AppLauncher', 'launchApp', [appNameSpace, appSchema]);
};

AppLauncher.prototype.SendSMS = function (phoneNumber, messagetext, win, fail) {
    console.log("App launcher: SendSMS to " + phoneNumber + " msg: " + messagetext);
    var urlSchemeT = "mycicero://sendsms?phonenumber={0}&text={1}";
    var urlScheme = urlSchemeT.format(encodeURIComponent(phoneNumber), encodeURIComponent(messagetext));
    //return cordova.exec(win, fail, 'AppLauncher', 'sendSMS', [phoneNumber, messagetext]);
    exec(win, fail, 'AppLauncher', 'launchApp', ["mycicero", urlScheme]);
};

AppLauncher.prototype.SavePhoto = function (imageData, win, fail) {
    console.log("App launcher: Save photo " + imageData);
    var urlScheme = "mycicero://savephoto?base64=" + encodeURIComponent(imageData);
    //return cordova.exec(win, fail, 'AppLauncher', 'savePhoto', [imageData]);
    exec(win, fail, 'AppLauncher', 'launchApp', ["mycicero", urlScheme]);
};

AppLauncher.prototype.convertToBase64 = function (imageLocalPath, win, fail) {
    console.log("App launcher: convertToBase64 " + imageLocalPath);
    var urlScheme = "mycicero://picturetobase64?imagepath=" + encodeURIComponent(imageLocalPath); // &targetsize=1024 per specificare la dimensione massima (in pixel)
    //return cordova.exec(win, fail, 'AppLauncher', 'savePhoto', [imageData]);
    exec(win, fail, 'AppLauncher', 'launchApp', ["mycicero", urlScheme]);
};

AppLauncher.prototype.generateQrCodeBase64 = function (code, win, fail) {
    console.log("App launcher: generateQrCodeBase64 " + code);
    var urlScheme = "mycicero://generateqr?code=" + encodeURIComponent(code); // &targetsize=1024 per specificare la dimensione massima (in pixel)
    //return cordova.exec(win, fail, 'AppLauncher', 'savePhoto', [imageData]);
    exec(win, fail, 'AppLauncher', 'launchApp', ["mycicero", urlScheme]);
};

AppLauncher.prototype.closeMyCicero = function () {
    var win = function () { console.log("Closing App..."); };
    var fail = function () { console.log("Errore nella chiusura di myCicero!"); };
    exec(win, fail, 'AppLauncher', 'closeMyCicero', []);
};

AppLauncher.prototype.getQueryStringLaunchingParamsFromUrlSchema = function (win, fail) {
    console.log("App launcher: getQueryStringLaunchingParamsFromUrlSchema");
    exec(win, fail, 'AppLauncher', 'getQueryStringLaunchingParamsFromUrlSchema', []);
};

AppLauncher.prototype.urlToBase64Image = function(url, win, fail) {
  console.log("AppLauncher: urlToBase64Image");
  var urlScheme = "mycicero://urltobase64?url=" + encodeURIComponent(url); // &targetsize=1024 per specificare la dimensione massima (in pixel)
  //return cordova.exec(win, fail, 'AppLauncher', 'savePhoto', [imageData]);
  exec(win, fail, 'AppLauncher', 'launchApp', ["mycicero", urlScheme]);
}

if (!window.plugins) {
    window.plugins = {};
}
if (!window.plugins.applauncher) {
    window.plugins.applauncher = new AppLauncher();
}

window.getQueryStringLaunchingParamsFromUrlSchema = function (success, fail) {
    console.log("App launcher: getQueryStringLaunchingParamsFromUrlSchema");
    if (window.plugins.applauncher) {
        try {
            console.log("APPLAUNCHER IS DEFINED");
            window.plugins.applauncher.getQueryStringLaunchingParamsFromUrlSchema(success, fail);
        } catch (errore) {
            console.log("Errore nell'inizializzazione di APPLAUNCHER");
            console.log(errore);
        }
    } else {
        console.log("APPLAUNCHER plugin not defined!");
    }
}


window.LaunchApp = function (namespace, appschema) {
    console.log("App launcher: LaunchApp " + namespace);
    if (window.plugins.applauncher) {
        try {
            console.log("APPLAUNCHER IS DEFINED");
            window.plugins.applauncher.Launch(namespace, appschema, function (retVal) {
                console.log("window.plugins.applauncher.launchApp CALLBACK");

            }, function () {
                console.log("APPLAUNCHER Error Callback");
            });
        } catch (errore) {
            console.log("Errore nell'inizializzazione di APPLAUNCHER");
            console.log(errore);
        }
    } else {
        console.log("APPLAUNCHER plugin not defined!");
    }
}

window.SendSMS = function (phoneNumber, messagetext) {
    //  console.log("App launcher: SendSMS to " + phoneNumber+ " msg: "+messagetext);
    if (window.plugins.applauncher) {
        try {
            console.log("APPLAUNCHER IS DEFINED");
            window.plugins.applauncher.SendSMS(phoneNumber, messagetext, function (retVal) {
                console.log("window.plugins.applauncher.sendSMS CALLBACK");

            }, function () {
                console.log("APPLAUNCHER sendSMS Error Callback");
            });
        } catch (errore) {
            console.log("Errore nell'inizializzazione di APPLAUNCHER");
            console.log(errore);
        }
    } else {
        console.log("APPLAUNCHER plugin not defined!");
    }
}


window.SaveBase64Photo = function (base64string, success, fail) {
    if (window.plugins.applauncher) {
        window.plugins.applauncher.SavePhoto(base64string, success, fail);
    }
}

window.ConvertPictureToBase64 = function (picturePath, success, fail) {
    if (window.plugins.applauncher) {
        window.plugins.applauncher.convertToBase64(picturePath, success, fail);
    }
}

window.shouldCancelBackButton = function() {
    return "true"; // blocco la gestione del back lato Phonegap
    // e delego tutto alla gestione lato javascript su Core.js
}

});
