﻿var translation = {
    storeAll: function() {
        function logError(msg, data) {
            console.error(msg, data);
            if (common && !common.isAmbienteProdOrCld()) alert(msg);
        }

        var self = this;
        if (lngModel && lngModel.availableLanguages && lngModel.availableLanguages.length) {
            // window.localStorage.setItem("res_en", JSON.stringify(this.en));
            lngModel.availableLanguages.map(function(languageKey) {
                if (self.hasOwnProperty(languageKey)) {
                    try {
                        window.localStorage.setItem('res_' + languageKey, JSON.stringify(self[languageKey]));
                    } catch (ex) {
                        logError('Errore nel salvataggio della chiave ' + languageKey + ' nel local storage', ex);
                    }
                } else {
                    logError('Chiave ' + languageKey + ' mancante in translations.js');
                }
            });
        } else {
            logError(
                'Attenzione: quando viene chiamato storeAll() di translations.js il LanguageModel non è ancora disponibile!!!'
            );
        }
    },

    /*### GENERATED_CONTENT ###*/

    it: {
        translation: {
            account: {
                accedi: 'Accedi',
                accountNonAttivo: 'Account non confermato',
                benvenuto: 'Benvenuto!',
                cambiaPassword: 'Cambia password',
                cambioEmailInserisciPinPage: {
                    annullaModifiche: 'Annulla modifiche',
                    errorePin: 'Errore: il PIN inserito non è corretto',
                    inserisciPin: 'PIN',
                    istruzioniInserisciPIN: "Inserisci il PIN contenuto nell'email inviata a",
                    operazioneAvvenutaInfo: 'Operazione avvenuta con successo',
                    operazioneAvvenutaTitle: 'Email modificata con successo',
                },
                cambioEmailPage: {
                    cambiaEmail: 'Cambia email',
                    emailAttuale: 'Email attuale',
                    eseguiCambioEmail: 'Procedi',
                    inserisciNuovaEmail: 'Scegli una nuova email',
                    istruzioniPIN:
                        'Riceverai un’email di verifica con un codice PIN che dovrai inserire nella schermata seguente.',
                    validazioneEmailInCorso: 'Verifica in corso',
                },
                cambioPasswordPage: {
                    erroreCambioPassword:
                        "Si è verificato un errore durante il cambio della password. Si prega di contattare l'assistenza.",
                    info:
                        'La password deve essere composta da <span class="{0}">un minimo di 8</span> a <span class="{1}">un massimo di 26</span> caratteri di cui <span class="{2}">almeno uno deve essere un numero</span>. <span class="{3}">Non sono ammessi caratteri speciali</span>.<br/><span class="{4}">La nuova password e quella attuale devono essere diverse</span>.',
                    infoPassword:
                        'La password deve avere lunghezza minima di 8 caratteri e deve includere almeno un numero.',
                    inserisciNuovaPassword: 'Scegli una nuova password',
                    inserisciPassword: 'Password attuale',
                    inserisciVecchiaPassword:
                        'Vuoi cambiare la password? Per questioni di sicurezza, devi inserire quella attuale:',
                    mostraPassword: 'Mostra password',
                    passwordDiverse: 'Le due password devono coincidere',
                    passwordUguali: 'La nuova password e la vecchia password devono essere diverse',
                    procedi: 'Procedi',
                    ripetiNuovaPassword: 'Ripeti nuova password',
                    success:
                        'La tua password è stata correttamente modificata. Effettua nuovamente il login con il tuo username e la nuova password.',
                },
                completaRegistrazione: "Completa l'iscrizione",
                completaRegistrazioneMsg: "Per procedere con questo account devi completare l'iscrizione.",
                confermaLogout:
                    "Procedendo l'utente attuale verrà disconnesso. Potrai accedere nuovamente inserendo username e password.",
                connessioneAssente: 'Autenticazione utente fallita: connessione internet assente',
                dataIscrizione: 'Iscritto Il',
                datiErrati: 'Autenticazione utente fallita: utente e/o password errati',
                datiNonCorretti: 'Nome utente o password non corretti',
                effettuaLogout: 'Effettua logout',
                eliminazioneDati: {
                    eliminazioneLabel:
                        'Cliccando su “Procedi” il suo account sarà disconnesso ed i suoi dati saranno eliminati ai sensi del Regolamento UE 2016/679 (GDPR) NB: dopo tale operazione si potrà utilizzare l’App in sola modalità consultazione.',
                    eliminazioneTitle: 'ATTENZIONE: operazione irreversibile.',
                    errorTitle: 'Si è verificato un errore',
                    successoTitle: 'Operazione avvenuta con successo',
                    successolabel: 'I tuo dati verranno cancellati entro un giorno lavorativo',
                },
                emailInesistente: "L'indirizzo che hai fornito non risulta associato a un account attivo",
                emailNonValida: 'Email non valida',
                emailVuota: 'Inserisci il tuo indirizzo email',
                login: 'Login',
                loginPage: {
                    accedi: 'Accedi con il tuo account:',
                    effettuaAccesso: "Effettua l'accesso",
                    iscrivitiAmyCicero: 'Iscriviti!',
                    mostraPassword: 'mostra password',
                    nessunAccount: 'Non hai un account?',
                    seHaiGiaUnAccount:
                        'Se hai gi&agrave; un account con <span class="highlighted">autobus.it</span> puoi utilizzare le stesse credenziali',
                },
                logout: 'Logout',
                logoutEffettuato: 'Logout effettuato con successo',
                logoutUtente: 'Logout utente',
                passwordDimenticata: 'Password dimenticata',
                passwordDimenticataPage: {
                    email: 'Indirizzo e-mail',
                    erroreResetPassword:
                        "Si è verificato un errore durante il reset della password. Si prega di contattare l'assistenza.",
                    impossibileResettarePassword:
                        "Impossibile resettare la password. Si prega di contattare l'assistenza.",
                    info:
                        'Inserisci l’indirizzo email scelto in fase di registrazione. Riceverai una password di accesso temporanea.',
                    sendPasswordTemporanea: 'Invia password',
                    success:
                        '<p>Ti è stata inviata una password temporanea all\'indirizzo: </p><p class="textAlignCenter"><b>{0}</b></p><p>Non hai ricevuto le istruzioni?<ul><li class="fontSizeTiny">Controlla la casella di posta indesiderata</li><li class="fontSizeTiny">Controlla l\'indirizzo email inserito</li><li class="fontSizeTiny">Riprova tra qualche minuto</li><li class="fontSizeTiny">Potresti non aver usato l\'indirizzo inserito per la tua registrazione al servizio</li></ul></p>',
                },
                passwordNonValida: 'Password non valida',
                profilo: {
                    accedi: 'Accedi al tuo profilo',
                    accediAccount: 'Login',
                    gestioneTarghe: 'Gestione Targhe Sosta',
                    gestisciCarteCredito: 'Gestisci Carte di Credito',
                    header: 'Profilo Utente',
                    impostazioniNotifica: 'Impostazioni notifiche',
                    preferenzeSosta: 'Preferenze Sosta',
                    uploadImmagineProfiloFail:
                        "Impossibile modificare l'immagine del profilo. Per favore, riprova più tardi.",
                    uploadImmagineProfiloRetry:
                        "Si è verificato un problema durante l'invio dell'immagine al server. Vuoi riprovare?",
                    uploadImmagineProfiloWait:
                        'L’immagine è stata salvata ed è in fase di elaborazione, pertanto potrebbe non essere subito visibile.',
                    v2: {
                        apps: {
                            header: 'App correlate',
                        },
                        associaTessera: 'Associa nuova tessera',
                        cambiaFotoProfilo: 'Cambia foto profilo',
                        chattaConAssistenza: 'Chatta con noi',
                        condividi: 'Condividi...',
                        datiFatturazione: {
                            aggiungiProfiloFatturazione: 'Aggiungi profilo di fatturazione',
                            attivaFatturazione: 'Mi interessa la fattura...',
                            confermaEliminazioneProfilo: 'Sei sicuro di voler eliminare il profilo di fatturazione?',
                            confermaModificaProfilo: 'Sei sicuro di voler modificare il profilo di fatturazione?',
                            confermaRitornoAlProfilo: 'Vuoi tornare ugualmente alla schermata del profilo?',
                            genericError: 'Compilare correttamente i campi obbligatori evidenziati in rosso',
                            header: 'Dati Fatturazione',
                            infoFatturazione:
                                'Attenzione: la fattura/ricevuta sar&agrave inviata mensilmente via email solo per i servizi ed i gestori che la prevedono.</br>Per tutti, verr&agrave sempre comunque inviata la conferma di pagamento effettuato',
                            label: 'Dati di fatturazione',
                            modificaProfiloFatturazione: 'Modifica profilo di fatturazione',
                            modificheSalvate: 'Le modifiche effettuate sono state salvate con successo',
                            profiloSalvato: 'I dati del profilo di fatturazione sono stati salvati con successo',
                            rimuoviProfilo: 'Rimuovi profilo...',
                        },
                        datiPersonali: {
                            cambia: 'Cambia',
                            haiTesseraAssociata: 'Hai una tessera associata',
                            header: 'Dati personali',
                            label: 'Dati personali',
                            nonPuoiModificareDati:
                                'I dati anagrafici sono già stati certificati per cui non è possibile apportare modifiche. Per ogni esigenza, inviaci una mail ad ',
                            perCancellareUtente: 'Per farlo è necessario inviarci una richiesta a',
                            vuoiCancellareUtente: 'Vuoi eliminare il tuo profilo?',
                        },
                        elencoMovimenti: 'Elenco movimenti',
                        eliminaDatiPersonali: 'Elimina dati personali',
                        eliminazioneDatiPersonali: 'Eliminazione dati personali/cancellazione account',
                        eliminazioneDatiPersonaliModalContent:
                            "Sei sicuro di voler cancellare i tuoi dati? <br> Ricorda: L'operazione è <b>irreversibile</b>",
                        esci: 'Esci',
                        gestioneAffiliazioni: 'Gestione affiliazioni',
                        gestioneCarte: 'Gestione carte',
                        gestioneCreditiMobilita: 'Gestione crediti di mobilità',
                        ilTuoCredito: 'Il tuo credito',
                        linguaApplicazione: 'Lingua applicazione',
                        notifichePush: 'Notifiche push',
                        preferenzeConsultazione: {
                            deselezionaTutto: 'Deseleziona tutto',
                            erroreCaricamento:
                                'Si è verificato un errore durante il caricamento delle preferenze. Riprovare più tardi.',
                            erroreSalvataggio:
                                'Si è verificato un errore durante il salvataggio delle preferenze. Riprovare più tardi.',
                            header: 'Preferenze di consultazione',
                            infoGestione: 'Gestisci e modifica le tue preferenze di consultazione dei contenuti',
                            label: 'Preferenze di consultazione',
                            nessunServizioInPreferenze:
                                "Non hai memorizzato nessun servizio tra le tue preferenze. Puoi gestire le tue preferenze nella sezione 'Preferenze di consultazione' accessibile direttamente dal tuo profilo. Se desideri visualizzare tutti i servizi clicca di nuovo su 'Applica preferenze' per rimuovere il filtro sulla visibilità dei contenuti.",
                            salvaModifiche: 'Salva modifiche',
                            selezionaTutto: 'Seleziona tutto',
                        },
                        preferenzePush: {
                            header: 'Notifiche push',
                        },
                        ricaricaCredito: 'Ricarica credito',
                        sosta: {
                            comePagare: 'Come pagare',
                            gestioneTarghe: 'Gestione targhe',
                            gestisciZsr: 'Gestisci Codice Abbonato',
                            header: 'Sosta e ZTL',
                            preferenze: 'Preferenze',
                        },
                        tesseraAssociataConSuccesso: 'Tessera {0} associata con successo!',
                        tiPiaceMyCicero: 'Ti piace myCicero?',
                        trasporto: {
                            header: 'Trasporto',
                            notificheScadenzaTitolo: 'Notifiche scadenza titoli',
                            scadenzaTitoli: {
                                description:
                                    "Attiva le notifiche per l'avviso circa la scadenza imminente dei titoli di viaggio",
                                header: 'Notifiche scadenza titoli',
                            },
                            tessere: 'Tessere',
                        },
                        vaiAlleTessere: 'Vai alle tessere',
                    },
                },
                registrati: 'Registrati',
                settings: {
                    allFavConfermaDelete:
                        'Procedendo verranno rimosse dal device tutte le soluzioni e le fermate preferite memorizzate. Questa attività non è annullabile.',
                    allFavRimossi: 'Fermate e soluzioni preferite sono state rimosse',
                    cardAssociate: 'Card associate a questo utente',
                    fermateFavConfermaDelete:
                        'Procedendo verranno rimosse dal device tutte le fermate preferite memorizzate. Questa attività non è annullabile.',
                    fermateFavRimosse: 'Le fermate preferite sono state rimosse',
                    gestisciPosizione: 'Gestisci posizione',
                    pulisciDati: 'Pulisci dati sul device',
                    raggioRicerca: 'Raggio ricerca intorno a posizione',
                    rimuoviFermateFav: 'Rimuovi fermate preferite',
                    rimuoviSoluzioniFav: 'Rimuovi soluzioni preferite',
                    soluzioniFavConfermaDelete:
                        'Procedendo verranno rimosse dal device tutte le soluzioni preferite memorizzate. Questa attività non è annullabile.',
                    soluzioniFavRimosse: 'Le soluzioni preferite sono state rimosse',
                    utenteAssociatoCard: 'Questo utente è associato alla card',
                },
                utente: 'Utente',
                zsr: {
                    associaZSRDescriptionHTML:
                        '<span>Collega il profilo utente (a cui è associata la targa dell’autoveicolo) all’abbonamento per la sosta su stalli strisce blu</span>',
                    associaZSRHeading: 'Associa Codice Abbonato',
                    associazioneFail: 'Codice non riconosciuto',
                    associazioneSuccess: 'Codice associato',
                    codiceIdZSR: 'Codice abbonato',
                    comeOttengo: 'Come lo ottengo?',
                    dataDiNascita: 'Data di nascita',
                    failureHeading: 'Codice non riconosciuto',
                    idZSR: 'idZSR: ',
                    riprovaAssociazione: 'Riprova associazione',
                    successHeading: 'Codice associato',
                },
            },
            affiliazioni: {
                common: {
                    budgetMensile: 'Budget mensile: <span class="bold secondary">{0}</span>',
                    confermaFineSostaChild:
                        'Effettuato pagamento con credito di <span class="bold secondary">{0}</span>:',
                    descrizioneTarga: 'Nome breve',
                    numeroTarga: 'Numero targa',
                    rimuoviAffiliazione: 'Rimuovi affiliazione',
                    serviziAbilitati: 'Servizi abilitati',
                    sosta: 'Sosta',
                    sostaTargheLimitate: 'Sosta solo con targhe',
                    spesaMensile: 'Spesa mensile: <span class="bold secondary">{0}</span>',
                    targaGiaInserita: "{0} è già presente nell'elenco delle targhe autorizzate",
                    trasporto: 'Trasporto',
                },
                creaModificaAffiliazione: {
                    aggiorna: 'Aggiorna',
                    alias: 'Alias',
                    aliasEsempio: 'es. Mario Rossi',
                    emailInfoPlaceholder: 'es. mario.rossi@gmail.com, luca.verdi@gmail.com',
                    erroreValidazioneEmail: "Il formato dell'indirizzo email '{0}' non è corretto",
                    erroreValidazioneImportoSpesaMassimaMensile: 'Scegli il limite di spesa mensile',
                    headerSezione: {
                        durataLimite: 'Durata e limite mensile',
                        sosta: 'Sosta e ztl',
                        trasporto: 'Trasporto',
                    },
                    infoEmail:
                        'Inserisci le email degli utenti che possono effettuare acquisti con il tuo credito, separati da una virgola.',
                    inviaRichiesta: 'Invia richiesta',
                    limitaDurata: 'Limita durata',
                    limitaSpesa: 'Limita spesa mensile (€)',
                    messaggioRichiestaAffiliazione: 'La richiesta di affiliazione è stata inviata',
                    messaggioRimozioneAffiliazione: "L'affiliazione è stata rimossa",
                    messaggioUpdateAffiliazione: "L'affiliazione è stata aggiornata",
                    modificaAffiliazione: 'Modifica affiliazione',
                    nuovaAffiliazione: 'Nuova affiliazione',
                    permettiPagamento: 'Permetti pagamento',
                    qualsiasiTarga: 'Qualsiasi targa',
                    spesaAttuale: 'Spesa mensile attuale: ',
                    targheAbilitate: '{0} targhe impostate',
                    targheSpecifiche: 'Con targhe specifiche',
                },
                dettaglioAffiliazione: {
                    limiteSpesaMensile: 'Limite spesa mensile',
                    seiAbilitato: 'Sei abilitato ad utilizzare il credito di',
                    spesaAttuale: 'Spesa attuale',
                },
                elencoMovimenti: {
                    delegatoA: 'Pagamento delegato a',
                    pagatoPer: 'Pagamento Effettuato da',
                },
                gestioneAffiliazioni: {
                    cercaNomeEmail: 'Cerca nome o email',
                    creaNuova: 'Crea nuova',
                    funzionalita: 'Funzionalità',
                    gestioneTargheRicorrenti: 'Gestione targhe condivise',
                    infoAffiliazioneChild:
                        "Questo è il luogo dove potrai verificare l'elenco degli<br/>utenti che ti hanno abilitato ad utilizzare il<br/>loro borsellino per effettuare i tuoi acquisti e pagamenti.",
                    infoAffiliazioneParent:
                        'Puoi permettere ad altri utenti di utilizzare il tuo credito <br/> per effettuare i loro acquisti. Puoi scegliere se  limitarne l’uso ad un determinato periodo di tempo o a specifiche targhe.',
                    richiesteInAttesa: 'Richieste in attesa',
                    tabs: {
                        childView: 'Paga con',
                        parentView: 'Permetti pagamenti a',
                    },
                    title: 'Gestione affiliazioni',
                },
                gestioneTargheAutorizzate: {
                    aggiungiRiccorrenti: 'Aggiungi a targhe condivise',
                    elencoAutorizzate: 'Elenco targhe autorizzate',
                    gestisciRiccorrenti: 'Gestisci targhe condivise',
                    importaRicorrenti: 'Importa da targhe condivise',
                    infoTargheRicorrenti:
                        'Potrai assegnare questa targa ad altri permessi senza doverla reinserire ogni volta.',
                    inserisciTargaConRicorrenti: 'Oppure inserisci una nuova targa',
                    inserisciTargaSenzaRicorrenti: 'Inserisci una nuova targa',
                    targaInRicorrenti:
                        "{0} è presente nell'elenco delle targhe condivise. Puoi importare una o più targhe condivise dall'apposita sezione 'Importa da targhe condivise'",
                    targheAutorizzate: 'Autorizzate da {0}',
                    title: 'Gestione targhe autorizzate',
                },
                gestioneTargheRicorrenti: {
                    aggiungiTarga: 'Aggiungi targa condivisa',
                    elencoRicorrenti: 'Elenco targhe condivise',
                    title: 'Targhe condivise',
                },
                importaTargheRicorrenti: {
                    descInfoTargheRicorrenti:
                        'Scegliendo di assegnare “Tutte le targhe”, permetterai l’uso di quelle già registrate e anche di quelle che aggiungerai in futuro. Altrimenti puoi selezionare solo quelle che vuoi rendere disponibili.',
                    title: 'Importa da targhe condivise',
                    titleInfoTargheRicorrenti: "Scegli le targhe da associare all'utente",
                    tutte: 'Tutte le targhe',
                },
                richiestaAffiliazione: {
                    durataModalita: 'Durata e modalità',
                    info: 'Vorrebbe permetterti di utilizzare il suo credito per effettuare i tuoi pagamenti',
                    messaggioAffiliazioneAccettata: "L'affiliazione è stata accettata",
                    messaggioAffiliazioneRifiutata: "L'affiliazione è stata rifiutata",
                    spesaMassimaMensile: 'Spesa massima mensile',
                    title: 'Richiesta di affiliazione',
                },
            },
            amt: {
                homepage: {
                    benvenutiCatania: '<span>Benvenuti a </span><span class="bold">Catania</span>',
                    biglietteriaTitle: 'Rivendite e Biglietterie',
                    carSharingTitle: 'Carsharing',
                    parcheggiTitle: 'Parcheggi',
                    trasportoAcquisti: 'Acquisti',
                    trasportoAcquisto: 'Acquisto',
                    trasportoSubtitle: 'Info & Ticket',
                    trasportoTitle: 'Trasporto',
                },
            },
            amtab: {
                homepage: {
                    autobus: 'autobus',
                    sosta: 'sosta',
                },
            },
            app: {
                appBloccata: 'App bloccata',
                cambioDispositivo: 'Cambio Dispositivo',
                description: 'Benvenuti su $t(app.name)!',
                dontAskAnymore: 'Non lo chiedere più',
                exitMessage: 'Sei sicuro di voler uscire dalla applicazione?',
                exitTitle: 'Conferma uscita',
                fineSupportoIOS6Messaggio:
                    'Gentile utente, la versione del tuo sistema operativo risulta essere inferiore alla 7. Questa versione del sistema operativo non ci permette di essere al passo con gli ultimi sviluppi tecnologici. La prossima versione di myCicero non sarà quindi più compatibile con il tuo sistema operativo. Per continuare ad utilizzare i nostri servizi aggiorna iOS alla versione 7 o successive.',
                grazieMyCiceroTemplate:
                    'Grazie per aver utilizzato i nostri servizi. Se li hai trovati utili perché non lasci un commento su {0}?',
                iOSNotCompatible:
                    'Per acquistare i titoli ATAC occorre aggiornare il proprio dispositivo alla versione 8 o superiore. Per ulteriori informazioni, contattare lo 071 920 7000 o mandare una mail ad assistenza@mycicero.it',
                msgCambioDispositivo:
                    '{0} ha già acquistato titoli con un altro telefono. Se confermi, i titoli già acquistati non saranno più disponibili nel precedente telefono. Per ulteriori informazioni, contattare lo 071 920 7000 o assistenza@mycicero.it',
                msgTelefonoImpegnatoAltroAccount:
                    'Questo telefono è stato già usato per acquistare titoli da un altro utente. Per ulteriori informazioni, contattare lo 071 9207000 o assistenza@mycicero.it',
                name: 'Wepps',
                no: 'No',
                pubblicaRecensione: 'Pubblica Recensione',
                recensisciMyCicero: "Recensisci l'applicazione",
                ricordaDopo: 'Ricordamelo dopo',
                supportoIOS6: 'Aggiornamento sistema',
                updateAppMessage: 'Per favore aggiorna l’applicazione all’ultima versione disponibile',
                waitdetail: 'Richiesta in corso',
                waitmessage: 'Attendere',
                wpNonCompatibile:
                    'Per acquistare i titoli ATAC occorre uno smartphone iOS o Android. Per ulteriori informazioni, contattare lo 071 920 7000 o mandare una mail ad assistenza@mycicero.it',
                yes: 'Si',
            },
            arriva: {
                homepage: {
                    navette: 'Servizi speciali',
                },
            },
            aspo: {
                fatturazioneDisclaimer:
                    'Attenzione: la ricevuta sarà inviata mensilmente via email solo per i servizi della sosta. Per tutti verrà comunque inviata la conferma di pagamento effettuato tramite email .',
                qrCodeFermata: 'QR Code fermata',
                qrCodeFermataSubtitle: 'info fermata',
                rivendite: 'Rivendite e biglietterie',
            },
            atc: {
                homepage: {
                    benvenutiLaSpezia: '<span class="bold">Benvenuti a </span><span class="bold">La Spezia</span>',
                },
                trasporto: {
                    acquistaBiglietti: 'Acquista Biglietti',
                    calcolaPercorso: 'Calcola Percorso',
                    fermateOrari: 'Fermate Ed orari',
                    mieiTitoli: 'I Miei Titoli',
                },
            },
            atcgo: {
                acquistaBigliettiHTML: 'Acquista<br/>biglietti',
                calcolaPercorsoHTML: 'Calcola<br/>percorso',
                fermateOrariHTML: 'Fermate<br/>e orari',
                luoghi: 'Luoghi',
                mieiTitoliHTML: 'I miei<br/>titoli',
            },
            autoguidovie: {
                AcquistaBiglietti: 'Acquista<br/>biglietti',
                CalcolaPercorso: 'Calcola percorso',
                CalcolaPercorsoHTML: 'Calcola<br/>percorso',
                ElencoMovimenti: 'Elenco<br/>movimenti',
                FermateOrari: 'Orari e fermate',
                FermateOrariHTML: 'Orari e<br/>fermate',
                MieiTitoli: 'I miei<br/>titoli',
                ServiziTuristici: 'Servizi<br />Turistici',
            },
            autoricarica: {
                labelToggleAttiva: 'Attiva',
                title: 'Autoricarica',
            },
            avm: {
                addAnagraficaDisclaimer:
                    'Per richiedere l’emissione di fatture inerenti i servizi di trasporto pubblico locale o mobilità integrata (sosta strisce blu) gestiti da AVM/Actv, compila il form al seguente link: <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/richiesta-fattura\',true)">http://bit.ly/richiesta-fattura</a>.<br />Una volta compilato il form, riceverai il “codice cliente” e potrai richiedere l’emissione di fatture inerenti i titoli di viaggio del trasporto pubblico locale acquistati tramite AVM Venezia Official App compilando il modulo seguente:',
                addAnagraficaDisclaimer2:
                    'Attenzione: la fattura/ricevuta sarà inviata mensilmente via email da AVM solo dopo l’inserimento del Codice Cliente. Per tutti verrà sempre comunque inviata la conferma di pagamento effettuato.',
                addAnagraficaError1: 'Devi compilare i campi della form.',
                addAnagraficaError2: "Solo un campo tra 'Partita IVA' e 'Codice Fiscale' può essere compilato.",
                addAnagraficaError3: "Almeno un campo tra 'Codice Fiscale' e 'Partita IVA' deve essere specificato.",
                addAnagraficaError4: "E' necessario specificare un 'Codice Cliente'.",
                addAnagraficaErrorANV: 'Account non valido',
                addAnagraficaErrorBLK: 'Account bloccato',
                addAnagraficaErrorECF: "Codice Fiscale o Partita IVA non corrispondente all'account",
                addAnagraficaErrorERR: 'Si è verificato un errore.',
                addAnagraficaErrorINV: 'Input non valido',
                addAnagraficaErrorNFD: 'Id Cliente non trovato',
                areaNonServitaHtml:
                    'Verifica sulla segnaletica verticale se la zona è a pagamento.</br> Assicurati che il puntatore sia collocato sulla carreggiata ed eventualmente scegli la via dove sosti dalla voce “ELENCO”. </br> Per problemi tecnici, compila il webform <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/AssistenzaAppAVM\',true)">http://bit.ly/AssistenzaAppAVM</a>',
                benvenutiVenezia: '<span>Benvenuti a </span><span class="bold">Venezia</span>',
                calcolaPercorso: 'Calcola il percorso',
                caricaIlTuoVoucher: 'Carica il tuo voucher',
                caricaVoucher: 'Carica voucher',
                caricaVoucherDescription: 'Inserisci il codice PNR Venezia Unica del tuo voucher.',
                caricaVoucherPlaceholder: 'Inserisci il tuo voucher',
                caricoCliente:
                    'È a carico del cliente valutare la validità di tempo residua prima di intraprendere il viaggio.',
                condizioniContent:
                    "<div> <h2><strong>TERMINI E CONDIZIONI D’USO AVM VENEZIA OFFICIAL APP</strong></h2> <h3><strong>1. Ambito di applicazione</strong></h3> <p>I presenti termini e condizioni d’uso disciplinano il rapporto tra l’Utente e l’Azienda Veneziana per la Mobilità spa (di seguito per brevità AVM) per quanto concerne l’acquisto di titoli di viaggio per il trasporto pubblico locale tramite l’utilizzo di AVM Venezia official APP<br/> I termini, le condizioni e le prescrizioni che regolamentano le operazioni e le modalità di accesso e d’uso del trasporto pubblico e che stabiliscono obblighi e responsabilità del trasportatore e del trasportato sono contenuti nelle Condizioni Generali di Trasporto pubblicate sul sito www.avmspa.it.<br/> L’App può essere scaricata ed utilizzata solamente su smartphone, non è quindi possibile l' utilizzo su dispositivi quali tablet e/o simili</p><h3><strong>2. Valore dei termini e condizioni d’uso</strong></h3> <p> Con il download dell’applicazione dallo store associato al sistema operativo e con la propria registrazione all’applicativo, l’Utente accetta integralmente tutti i presenti termini e condizioni d’uso, nessuno escluso.<br/> AVM si riserva la facoltà di modificare unilateralmente in qualsiasi momento i presenti termini e condizioni d’uso. È esclusivo onere dell’Utente verificare, ad ogni accesso alla App, se sono state apportate eventuali modifiche; l’utilizzo dell’App implica integrale accettazione delle stesse.</p><h3><strong>3. Disposizioni di utilizzo</strong></h3> <p>L’acquisto di un titolo di viaggio tramite l’App avviene a rischio esclusivo dell’Utente. L’Utente deve provvedere a proteggere il proprio dispositivo mobile dall’accesso non autorizzato. Al fine di minimizzare eventuali danni, l’Utente si impegna a segnalare tempestivamente ad AVM qualsiasi sospetto di utilizzo non autorizzato o in modalità non autorizzata del proprio account utilizzato per accedere all’App.<br/> Per procedere al primo acquisto di titoli di viaggio è necessario che l’Utente esegua l’operazione di registrazione, inserendo i dati richiesti dall’App. Per tutti i successivi acquisti sarà sufficiente che l’Utente esegua il login inserendo il proprio indirizzo e-mail e la propria password.<br/> A seguito della registrazione, l’Utente diventerà unico responsabile per tutte le attività condotte attraverso il proprio account. AVM declina ogni responsabilità relativa a errori commessi dall’Utente durante la registrazione.<br/> Ai fini della fruizione del servizio, il cliente dovrà fornire ad AVM i propri dati personali, l’indirizzo e-mail e il numero di cellulare associato allo smartphone sul quale viene scaricata l’App. E’ responsabilità dell’Utente verificare la corretta registrazione dei propri dati.<br/> L’Utente è l’unico ed esclusivo responsabile della segretezza della propria password. Ove abbia ragione di ritenere che terzi abbiano avuto accesso o siano venuti a conoscenza della password, l’Utente deve immediatamente modificare la propria password.</p><h3><strong>4. Modalità di funzionamento</strong></h3> <p>Il titolo di viaggio deve essere acquistato prima di accedere ai mezzi di trasporto. Per ciascun dispositivo mobile è consentito acquistare più titoli di viaggio per passeggeri che viaggiano insieme.<br/> I pagamenti possono essere eseguiti esclusivamente tramite carta di credito, comprese carte prepagate aderenti ai circuiti Visa e Mastercard i cui dati devono essere inseriti a seguito della registrazione o in fase di acquisto. Una volta conclusa la transazione verrà inviata una quietanza di pagamento all’indirizzo di po-sta elettronica dell’Utente.<br/> I titoli di viaggio acquistati tramite l’App dovranno essere sempre convalidati prima dell’inizio del viaggio.<br/> Sui varchi di accesso ai mezzi di trasporto dotati di tornello e letto QR Code, l’Utente dovrà visualizzare il QR Code associato al titolo di viaggio e scansionarlo sul lettore posto sul varco. Dal momento della scansione del QR Code decorrerà il termine di validità del titolo di viaggio.<br/> In tutti i casi in cui il tornello non sia dotato di lettore QR Code o non vi sia la presenza del tornello (es. nei mezzi automobilistici), la convalida dovrà essere effettuata cliccando su di una apposita icona sul dispositi-vo cellulare. In questi casi, la decorrenza del termine di validità sarà posticipata di 3 (tre) minuti.<br/> È onere dell’Utente garantire il buon funzionamento del dispositivo mobile per tutta la durata del viaggio, onde poter esibire il biglietto elettronico convalidato visualizzandolo sul dispositivo cellulare, su richiesta del personale di controllo. La mancata esibizione del titolo di viaggio dovuta a cattivo funzionamento del dispositivo mobile comporta le medesime conseguenze previste e sanzionate per irregolarità nei titoli di viaggio nelle Condizioni Generali di Trasporto.</p><h3><strong>Reclami e responsabilità</strong></h3> <p> Qualsiasi operazione volontaria od involontaria eseguita dall’Utente che comporti la perdita dei titoli di viaggio rimane a carico esclusivo dello stesso inclusi, a titolo esemplificativo, i casi di disinstallazione dell' App, malfunzionamento e formattazione dispositivo, smarrimento dello stesso.<br/> I titoli di viaggio acquistati vengono memorizzati esclusivamente sul dispositivo con cui è stato effettuato l'acquisto, non sono perciò trasferibili ad altri dispositivi mobili.<br/> AVM rimborserà il titolo di viaggio solamente nel caso in cui si sia verificato un addebito a causa di un’errata elaborazione della transazione da imputare al sistema di pagamento.</p><h3><strong>Recesso</strong></h3> <p> Salvo quanto stabilito al punto precedente, l’Utente può disinstallare l’App dal proprio dispositivo mobile in qualsiasi momento e senza alcun preavviso e può inoltre richiedere l’eliminazione del proprio account tramite mail con esplicita richiesta al servizio clienti App.</p><h3><strong>Norme sulla privacy</strong></h3> <p> Installando l’App, l’Utente dichiara e accetta che AVM possa accedere, conservare e trattare i dati personali dell’Utente e qualsiasi contenuto associato all’uso dell’App, se richiesto per legge o se tali attività siano necessarie per l’uso dell’App ovvero dei servizi forniti attraverso l’App, nel pieno rispetto del Dlgs 196/2003 “Codice in materia di protezione dei dati personali”.<br/> L’Utente riconosce e accetta che l’uso dell’App può prevedere la trasmissione di dati attraverso reti di comunicazione elettronica.<br/> Informazioni più dettagliate sull’utilizzo dei dati personali da parte di AVM sono disponibili sul sito www.avmspa.it. Il titolare del trattamento è l’Azienda Veneziana della Mobilità spa con sede in Venezia, Isola Nova del Tronchetto 33.</p><h3><strong>Proprietà intellettuale</strong></h3> <p>Scaricando l’APP, l’Utente accetta e riconosce che la stessa è protetto dalle normative in materia di proprietà intellettuale, e dalle altre disposizioni applicabili, incluso, in via esemplificativa, il diritto d’autore. L’Utente accetta di utilizzare tali informazioni coperte da privativa e materiali esclusivamente per l’utilizzo del servizio offerto nel rispetto delle disposizioni dei presenti Termini e Condizioni d’Uso. Nessuna parte della App e dei prodotti offerti può essere riprodotta in qualsiasi forma né con alcun mezzo, ad eccezione di quanto espressamente concesso nelle presenti condizioni. L’Utente accetta di non modificare, affittare, noleggiare, prestare, vendere, distribuire, o creare opere derivate basate sulla presente App, in alcun modo, e non potrà sfruttare l’App o i prodotti acquistati in modo non autorizzato.<br/> Tutti i diritti d’autore relativi all’App sono di proprietà di AVM e/o dei suoi concessori di licenza. L’utilizzo di ogni componente dell’App, eccetto che per l’uso consentito dai presenti termini e condizioni, è strettamente proibito e viola i diritti di proprietà intellettuale di terzi e può esporre l’Utente a sanzioni civili e penali, inclusi possibili danni pecuniari, per violazione dei diritti d’autore.<br/> AVM, il logo AVM e gli altri marchi del Gruppo AVM, segni grafici e loghi utilizzati in connessione con l’App costituiscono marchi o marchi registrati del Gruppo AVM. L’Utente non ha alcun diritto o licenza d’uso con riferimento ad alcuno dei marchi menzionati e all’utilizzo di tali marchi.</p></div>",
                condizioniHeader: 'TERMINI E CONDIZIONI',
                condizioniVeneziaUnica: 'Condizioni Venezia Unica',
                infoMobilita: 'Orari Corse da/per Istituti Scolastici',
                messageCondizioniBorsellino:
                    "Ho preso visione delle <a class='condizioni-borsellino'>condizioni di utilizzo</a> del credito.",
                messaggioInformativoSosta: 'Verifica sulla segnaletica verticale se la zona è a pagamento.',
                ricercaOrari: 'Ricerca orari alle fermate',
                sezioneVoucher: 'Trovi i titoli nella sezione "I miei voucher"',
                sostaItem: 'attiva/e',
                sostaSubTitle: 'Info & Ticket',
                sostaTitle: 'Sosta',
                trasportoItem: 'acquisti',
                trasportoSubTitle: 'Info & Ticket',
                trasportoTitle: 'Trasporto',
                vaiAiVoucher: 'Vai ai miei voucher',
                verificaAcquisto:
                    'Verifica nella sezione "Acquista titoli Actv" se esistono soluzioni tariffarie più convenienti rispetto alle tue esigenze di viaggio (titoli con tessera o biglietti a tempo)',
                viaggia: {
                    abbonamenti: 'Acquista titoli su Venezia Unica',
                    acquistoOd: 'Acquista titoli extraurbani',
                    acquistoOdTessera: 'Acquista titoli extraurbani su Venezia Unica',
                    header: 'Viaggia',
                    tariffaFissa: 'Acquista titoli a tempo',
                },
                voucherItem: 'Voucher',
                voucherSubTitle: 'Voucher',
                voucherTitle: 'Carica il tuo',
            },
            biglietto: {
                acquistatoIl: 'Acquistato il',
                atac: {
                    aimop: {
                        descrizioneAggiuntiva:
                            'Il titolo viene emesso con le date di decorrenza e scadenza predefinite, quindi viene acquistato già attivo. Gli abbonamenti acquistati entro il giorno 24 di ogni mese, vengono attivati al momento dell´acquisto perché validi nel mese corrente. Quelli acquistati in seguito, saranno attivati automaticamente il 1 giorno del mese successivo',
                        note:
                            'Per viaggiare in metropolitana, mostra il QRCode al lettore ottico del tornello, oppure, se si dispone di un dispositivo Android dotato di tecnologia NFC, avvicinare lo smartphone al lettore NFC presente sul tornello.',
                        tipoValidazione: 'Attivato automaticamente',
                    },
                    bit100: {
                        descrizioneAggiuntiva:
                            'Valido 100 minuti dalla prima attivazione su tutti i mezzi di superficie (bus, tram e filobus). Per la metro, il titolo sarà valido per una sola corsa, anche su più linee senza oltrepassare i tornelli',
                        note:
                            "<p class='bold'>Validità:</p><p>100 minuti dalla prima attivazione su Bus, Filobus, Tram e Metro C. 1 sola corsa per Metro A, B, B1 anche su più linee senza oltrepassare i tornelli. 1 sola corsa con i Treni.</p><p class='bold'>Ambito di Utilizzo:</p><p>Può essere utilizzato su tutti i servizi di superficie e Metro del circuito Metrebus: Bus, Tram, Filobus e Metro ATAC, mezzi di trasporto RomaTPL e Cotral, Ferrovia Roma-Lido e Ferrovia Roma – Viterbo</p><p class='bold'>Come si usa</p><p>Il titolo assume validità solo se attivato. Per viaggiare in metro, mostra il QrCode al lettore ottico del tornello oppure, se si dispone di un dispositivo dotato di tecnologia NFC, apri il titolo ed avvicina lo smartphone al lettore NFC presente sul tornello. Al momento dell’attivazione, per Metro A, B e B1, partirà un contatore per cui avrai 2 minuti di tempo per accedere ai tornelli.</p>",
                        tipoValidazione: 'Manuale al primo utilizzo, prima di salire sui mezzi',
                    },
                    brm24: {
                        descrizioneAggiuntiva: 'Valido 24 ore dalla prima attivazione',
                        note:
                            'Per viaggiare in metropolitana, mostra il QRCode al lettore ottico del tornello, oppure, se si dispone di un dispositivo Android dotato di tecnologia NFC, avvicinare lo smartphone al lettore NFC presente sul tornello.',
                        tipoValidazione: 'Manuale al primo utilizzo, prima di salire sui mezzi',
                    },
                    brm48: {
                        descrizioneAggiuntiva: 'Valido 48 ore dalla prima attivazione',
                        note:
                            'Per viaggiare in metropolitana, mostra il QRCode al lettore ottico del tornello, oppure, se si dispone di un dispositivo Android dotato di tecnologia NFC, avvicinare lo smartphone al lettore NFC presente sul tornello.',
                        tipoValidazione: 'Manuale al primo utilizzo, prima di salire sui mezzi',
                    },
                    brm72: {
                        descrizioneAggiuntiva: 'Valido 72 ore dalla prima attivazione',
                        note:
                            'Per viaggiare in metropolitana, mostra il QRCode al lettore ottico del tornello, oppure, se si dispone di un dispositivo Android dotato di tecnologia NFC, avvicinare lo smartphone al lettore NFC presente sul tornello',
                        tipoValidazione: 'Manuale al primo utilizzo, prima di salire sui mezzi',
                    },
                    hai2Minuti: 'Hai 2 minuti di tempo per accedere ai tornelli',
                    vuoiAttivareTitolo: 'Vuoi attivare il titolo?',
                    vuoiAttivareTitoloBus:
                        '<div class="secondary textAlignCenter fontSizeHuge">Vuoi salire in bus o entrare in metro C?</div><div class=\'marginTop\'>Partirà il conteggio del tempo di validità.<br />Per entrare in metro, mostra il QrCode ai lettori ottici del tornello.</div>',
                    vuoiEntrareMetro:
                        '<div class="secondary textAlignCenter fontSizeHuge">Vuoi entrare in Metro A, B, B1?</div><div class=\'marginTop\'>Per entrare, entro 2 minuti mostra il QrCode ai lettori ottici del tornello.<br/>Il titolo è valido per una sola corsa in metro.</div>',
                    vuoiSalireTreno:
                        '<div class="secondary textAlignCenter fontSizeHuge">Vuoi salire in Treno?</div><div class=\'marginTop\'>Il titolo è valido per una sola corsa in treno.<br />Scegli la stazione di partenza:</div>',
                },
                attiva: 'Attiva',
                attivaESaliBus: 'Attiva e sali sul:',
                attivaEdEntraMetro: 'Attiva ed Entra in:',
                attivaMsg: 'Attiva il biglietto per poterlo utilizzare',
                attivaPer: 'Attiva per',
                attivato: 'Attivato',
                attivatoIl: 'Attivato il',
                attivatoMetro: 'Validazione metro:',
                attivatoPer: 'Attivato per',
                attivatoTreno: 'Validazione treno:',
                attivazioneBus: 'Attivazione Bus, Metro C',
                attivazioneMetro: 'Attivazione Metro A, B, B1',
                attivazioneNFC: 'Attivazione tramite NFC',
                attivazioneTitolo: 'Attivazione titolo',
                attivazioneTreno: 'Attivazione Treno',
                avvisoTitoliLocali:
                    '<span>I titoli sono memorizzati solo sullo smartphone. Per maggiori informazioni clicca {0}qui{1}</span>',
                avvisoTitoliLocaliMail:
                    'I titoli sono memorizzati sullo smartphone. per maggiori informazioni contatta {0}',
                avvisoTitoliLocaliNoLink: 'I titoli sono memorizzati solo sullo smartphone.',
                cercaTitolo: 'Cerca Titolo di Viaggio',
                chiediCodice: 'Chiedi al conducente le informazioni per attivare il titolo',
                codiceNonValido: 'Codice non valido',
                confermaAttivazione:
                    'Se confermi, il titolo sarà attivato e partirà il conteggio del tempo di validità',
                confermaMetro: 'Se confermi, hai due minuti di tempo per entrare nella metro.',
                confermaMetroAttivazione:
                    'Se confermi, il titolo sarà attivato, partirà il conteggio del tempo di validità ed avrai poi due minuti di tempo per entrare nella metro.',
                costoTitolo: 'Costo del titolo',
                daAttivare: 'Da attivare',
                dataEmissione: 'Data emissione',
                dataScadenza: 'Data scadenza',
                entraInMetro: 'Metro',
                entraMetro: 'Entra in:',
                error: {
                    corseEsaurite: 'Corse esaurite',
                    datiNonCongrui: 'Dati non congrui',
                    erroreAntiPassback: 'Errore controllo anti-passback',
                    erroreApplicativo: "Errore dell'applicativo",
                    erroreValidazioneMultipla: 'Errore validazione multipla stesso account',
                    impossibileValidare: 'Impossibile validare il biglietto',
                    titoloNonValido: 'Il titolo non è valido',
                },
                fermataSalita: 'Fermata di salita',
                finoA: 'Fino a',
                header: 'Biglietto',
                identificativo: 'Identificativo',
                inFaseDiAttivazione: 'Servizio in fase di attivazione',
                infoAcquistoAnnullato: "Transazione annullata dall'utente",
                infoAcquistoEffettuato: 'Puoi trovare il biglietto acquistato nella sezione "I miei titoli".',
                infoAcquistoFallito: 'Non è stato possibile effettuare al transazione.',
                infoAcquistoFallitoVix:
                    'Non è stato possibile effettuare la transazione. Effettuare nuovamente la procedura di acquisto.',
                infoAcquistoSiaeEffettuato: 'Puoi trovare il biglietto acquistato nella sezione "Eventi".',
                infoCodiceManuale: 'In caso di mancata lettura del codice, rivolgersi al conducente',
                inserisciQualcosaPartenza: 'Inserisci la via, la zona o la fermata di partenza',
                istruzioniAttivazione: 'Premi "Valida" per validare il Titolo di Viaggio',
                istruzioniDownloadTitoliAsincroni:
                    'Una volta completato l\'acquisto, per scaricare il titolo entra nella sezione "I miei Titoli" dell\'App',
                istruzioniDownloadTitoliAsincroniTrasporto:
                    'Una volta completato l\'acquisto, per scaricare il titolo entra nella sezione "Trasporto" dell\'App',
                istruzioniObliterazione: 'Premi "Valida" per validare il Titolo di Viaggio',
                localita: 'Località',
                multicorsa: {
                    MultiCorsa: 'Carnet',
                    attivaAltro: 'Valida corse',
                    attivaDefault: 'Attiva',
                    attivaPrimo: 'Valida corse',
                    attivaUltimo: 'Valida corsa',
                    attivoFinoA: 'Corsa valida fino alle:',
                    confermaRivalidazione: 'Le corse attive in questo momento verranno archiviate come scadute.',
                    corseAttive: 'Corse attive: ',
                    corseDaAttivare: 'corse residue',
                    corseRimaste: 'Corse: ',
                    daAttivare: 'Corsa non validata',
                    info: 'Per validare le corse, passa {0} volte il QR Code davanti al tornello.',
                    quantiAttivare: 'Quante corse vuoi attivare?',
                    scaduto: 'Scaduta',
                    tickets: 'Corse',
                    tutteCorseScadute: 'Tutte le corse sono scadute',
                    validoDa: 'Corsa valida dalle:',
                },
                nfcNotSupported:
                    'Il tuo smartphone è abilitato al servizio NFC. Questa versione di android però, non permette a myCicero di accedere a questa funzionalità.',
                nfcOFF:
                    'Con il tuo smartphone puoi utilizzare la validazione tramite NFC. Questa funzionalità, però, risulta disattivata. Vuoi attivarla?',
                nfcON:
                    'Complimenti! Il tuo smartphone ti permette di validare questo titolo di viaggio semplicemente avvicinando il dispositivo al lettore NFC ove presente.',
                noPosPartenzaRilevata: 'Impossibile rilevare la posizione di partenza.',
                nonAcquistabileContrattiInsufficienti:
                    'Il titolo non è acquistabile perché la scheda non ha contratti sufficienti',
                nonAncoraUtilizzabile: 'Non ancora utilizzabile',
                nonAttivato: 'Titolo non attivato',
                nonEffettuata: 'Non effettuata',
                nonObliterato: 'Titolo non validato',
                nonValidato: 'Titolo non validato',
                notificaMessaggio: '{0} scadrà alle {1}',
                notificaTitolo: 'Il titolo scadrà a breve',
                nuovaAttivazione: 'Nuova attivazione',
                nuovaValidazione: 'Nuova validazione',
                oblitera: 'Attiva',
                obliteratoIl: 'Obliterato il',
                piuCorse: 'Più corse',
                precedente: 'Vai al biglietto precedente',
                premiAttiva: 'La mancata attivazione comporta una sanzione.',
                premiValida:
                    'Premi "Nuova validazione" prima di salire sul mezzo. La mancata attivazione comporta una sanzione.',
                primaAttivazione: 'Attivato',
                qrCodeScaduto: 'QR Code Scaduto',
                saliInBus: 'Bus',
                saliSulTreno: 'Attiva titolo',
                saraValidoTra: 'Il titolo sarà valido tra ',
                scaduto: 'Scaduto',
                scadutoIl: 'Scaduto il',
                selezionaFermataSalita: 'Se la conosci, seleziona la fermata di salita',
                selezionaStazioneSalita: 'Seleziona stazione di partenza:',
                singolaCorsa: '1 sola corsa',
                stazioneSalita: 'Stazione di salita:',
                successivo: 'Vai al biglietto successivo',
                tempoRestante: 'Tempo restante',
                termsConditions: "<span>Ho preso visione ed accetto le </span><a href='#'>condizioni di utilizzo</a>",
                tipologiaBiglietto: 'Tipologia biglietto',
                titoliImpersonali: 'Titoli di viaggio impersonali',
                titoloAttivo: 'Titolo di viaggio attivo',
                titoloAttivoFinoAl: 'Titolo attivo fino al',
                titoloDiViaggio: 'Titolo di Viaggio',
                titoloLocale: 'Questo titolo si trova solo sul tuo smartphone.',
                titoloNonAttivo: 'Titolo non attivo',
                titoloScaduto: 'Il titolo è scaduto',
                titoloScadutoAlle: 'Titolo scaduto alle',
                treno: 'Treno',
                ultimaValidazione: 'Ultima Validazione',
                utilizzabileDalAl: 'Utilizzabile dal {0} al {1}',
                utilizzabileFinoA: 'Utilizzabile fino al {0}',
                utilizzabileIl: 'Utilizzabile il {0}',
                utilizzabileIlGiorno: 'Utilizzabile il giorno:',
                utilizzabileOggi: 'Utilizzabile oggi',
                vaiAlBiglietto: 'Vai al biglietto',
                valida: 'Nuova attivazione',
                validaMsg: 'Valida il biglietto per poterlo utilizzare',
                validatoIl: 'Validata il:',
                valido: 'Valido',
                validoFinoAl: 'Valido fino al',
                warningAccessoMetro: 'Attraversa il varco di accesso </br> alla metropolitana entro',
            },
            bikeSharing: {
                aggiungiBici: "Aggiungi un'altra bici",
                alertPrenotazioneAccorciata:
                    'La durata del noleggio è stata ridotta in base al regolamento applicato nella struttura selezionata.',
                alertPrenotazioneAllungata:
                    'La durata del noleggio è stata incrementata in base al regolamento applicato nella struttura selezionata. Questo non comporta alcun costo aggiuntivo per te.',
                alertPrenotazioneAnnullata: 'La prenotazione è stata annullata.',
                altreFunzionalita: 'Altre funzionalità',
                annullaPrenotazione: 'Annulla Prenotazione',
                bici: 'Bici',
                biciPrenotataPerHtmlTemplate: 'La bici rimarr&agrave; prenotata per {0}',
                bicicletta: 'Bicicletta:',
                biciclette: 'Biciclette:',
                bikePoint: 'Bike Point:',
                bikePointChiuso: 'Bike point chiuso',
                bikePointChiusoInfo: 'Durante l’orario di chiusura del bike-point non è possibile prenotare',
                bikePointPrelievo: 'Prelievo:',
                bikePointRiconsegna: 'Riconsegna:',
                btnPrenota: 'Prenota una bici',
                cantBook: 'Non puoi prenotare',
                cercaBikePoint: 'Cerca Bike Point',
                cercaPerNomeIndirizzo: 'Cerca per indirizzo o nome',
                confermaBici: 'Preleva bici',
                consegnaInRitardo: 'Avresti dovuto riconsegnare entro:',
                contattaci: 'Contattaci',
                dettaglioCorsa: 'Dettaglio Corsa',
                elencoPrenotazioniRecenti: 'Elenco operazioni recenti...',
                elencoStrutture: 'Bike Point',
                emptyPoint: 'Bike Point vuoto',
                haiPrenotazione: 'Hai una prenotazione per {0} bici',
                haiRiconsegnatoInRitardo: 'Completato (in ritardo)',
                importoMyCicero: 'Pagato con myCicero:',
                importoOra: 'Se riconsegni ora:',
                importoTotale: 'Importo totale:',
                infoPoint: 'Info Bike Point',
                infoPrelievo: 'Il mezzo verrà prenotato per il periodo selezionato.',
                infoPrenotazione0: 'Il noleggio include assicurazione, tasse e mappa di Roma',
                infoPrenotazione1:
                    'Hai 30 minuti di tempo per prelevare la/le bici, altrimenti la richiesta verrà annullata automaticamente (non sarà addebitato nessun costo).',
                infoPrenotazione2: 'La prenotazione sarà attivata automaticamente quando preleverai la/le bici.',
                infoPrenotazione3:
                    "L'orario impostato non è vincolante per la riconsegna dei veicoli e sarà comunque possibile terminare il noleggio in anticipo. Verrà addebitato il costo in base all'orario di prelievo effettivo secondo la tariffazione vigente.",
                infoRitardo: 'La mancata riconsegna è stata annotata da myCicero. Riconsegna la bici prima possibile.',
                inserisciCodiceBici: 'Inserisci codice bici',
                inserisciNumeroBici: 'Inserisci numero bici',
                istruzioni: {
                    bloccoSbloccoSaldo:
                        'Per poter bloccare o sbloccare le bici, devi avere un saldo borsellino maggiore o uguale al costo del noleggio',
                    buonaPedalata: '3) Buona pedalata!',
                    cosaDevoFare: 'Cosa devo fare?',
                    inserisciCodice: 'Inserisci o scansiona il codice di tutte le bici della tua prenotazione',
                    mostraCodice: 'mostra il codice',
                    mostraIlCodice: '2) Una volta sul posto mostra il codice prenotazione al gestore.',
                    mostraSuMappa: 'mostra su mappa',
                    raggiungiIlBikePoint: '1) Raggiungi, entro le {0}, il Bike Point "{1}"',
                    ricordatiDiRiconsegnare:
                        '4) Ricordati di riconsegnare le bici entro {0} in uno dei Bike Point aderenti al servizio',
                    semplice: 'Semplice',
                    termineNoleggioSelfService:
                        'Prima di terminare il noleggio, assicurati di avere riagganciato al bike point tutte le bici noleggiate.',
                },
                leMiePrenotazioni: 'Le mie prenotazioni',
                limitePrenotazioni: 'Hai raggiunto il numero massimo di prenotazioni',
                mezzoPrenotatoPeriodoSelezionato: 'Il mezzo verrà prenotato per il periodo selezionato',
                mostaCodicePrenotazione: 'Mostra Codice Prenotazione',
                nessunRecente: 'Niente da visualizzare',
                noBikes: 'Nessuna bici disponibile al momento.',
                noBikesInPoint: 'Nessun veicolo disponibile nella struttura selezionata',
                noResult: 'La ricerca non ha prodotto nessun risultato',
                noleggi: 'Noleggi attivi',
                operazioneNonAutorizzata: 'Operazione non autorizzata',
                orario: 'Orario di utilizzo',
                orarioApertura: 'Orario di apertura',
                prelevaEntro: 'Preleva entro:',
                prelievo: 'Puoi prelevare la bici entro: ',
                prelievoEffettuato: 'Prelievo effettuato: ',
                prelievoEntro: 'Prelievo entro: ',
                prenota: 'Prenota',
                prenotazioni: 'Prenotazioni',
                preventivoPrenotazione: 'Preventivo prenotazione:',
                problemi: 'Per qualsiasi problema o disservizio',
                recenti: 'Recenti',
                ricalcoloPreventivoInCorso: 'Ricalcolo preventivo in corso...',
                ricaricaBorsellino: 'Ricarica il borsellino per effettuare la prenotazione.',
                ricaricaBorsellino2:
                    'Ricarica il borsellino se vuoi pagare l’intero importo con MyCicero altrimenti corrisponderai la differenza all’operatore del bike-point.',
                riconsegna: 'Devi riconsegnarla entro: ',
                riconsegnaEffettuata: 'Riconsegna effettuata:',
                riconsegnaEntro: 'Riconsegna entro:',
                sblocca: 'Sblocca',
                scegliTipologia: 'scegli tipologia',
                seiInRitardo: 'Sei in ritardo per la riconsegna',
                templateMessaggioPreventivo:
                    'Se prelevi ora i mezzi prenotati e li riconsegni all’ora selezionata spenderai: {0}',
                terminaNoleggio: 'Termina il noleggio',
                titles: {
                    bikeSharing: 'Bike',
                    conferma: 'Conferma',
                    dettaglioCorsa: 'Dettaglio Corsa',
                    prenotaBici: 'Prenota Bici',
                    scegliBikePoint: 'Scegli Bike Point',
                },
                visualizzaRecenti: 'Elenco Movimenti',
            },
            busitaliaveneto: {
                acquistaBiglietti: 'Acquista biglietti',
                calcolaPercorso: 'Calcola percorso',
                fermateOrari: 'Fermate ed orari',
            },
            carPoolingTaxiCondiviso: {
                bacheca: {
                    cercaConducenti: 'Cerca conducenti',
                    cercaOfferteRichieste: 'Cerca offerte e richieste degli utenti',
                    cercaPasseggeri: 'Cerca passeggeri',
                },
                common: {
                    annullaRichiesta: 'Annulla richiesta',
                    annullaRichiestaError: 'Impossibile annullare la richiesta. Prenotazione non trovata.',
                    annullaRichiestaMessage: 'Annullare definitivamente la richiesta?',
                    bacheca: 'Bacheca',
                    carInfo: 'Info veicolo:',
                    chiamaTaxi: 'Chiama taxi',
                    commento: 'Commento',
                    confermaPrenotazioneTaxi: 'Conferma prenotazione taxi',
                    confermaPrenotazioneTaxiMessage:
                        "Confermando la prenotazione del taxi condiviso gli altri utenti riceveranno una notifica della conferma del taxi.<br/><br/>Troverai le tue richieste nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    confermaRichiesta: 'Conferma richiesta',
                    confermaRichiestaMessage: 'Sei sicuro di voler confermare la richiesta?',
                    confermaValutazione: 'Conferma valutazione',
                    corsaEliminata: 'Corsa eliminata',
                    corsaEliminataMessage: 'La corsa è stata eliminata definitivamente.',
                    dettaglio: 'Dettaglio',
                    elencoPasseggeri: 'Elenco passeggeri',
                    eliminaCorsa: 'Elimina corsa',
                    eliminaCorsaMessage: 'Eliminare definitivamente la corsa?',
                    ferryInfo: 'Info traghetto:',
                    filtra: 'Filtra',
                    filtraOfferte: 'Filtra offerte',
                    filtraRichieste: 'Filtra richieste',
                    filtraStoricoViaggi: 'Filtra storico viaggi',
                    filtriAttiviNum: '{0} filtri attivi',
                    filtroAttivoNum: '{0} filtro attivo',
                    iMieiViaggi: 'I miei viaggi',
                    inserisciRichiesta: 'Inserisci richiesta',
                    inviaOfferta: 'Invia offerta',
                    inviaRichiesta: 'Invia richiesta',
                    iscrizione: 'Iscrizione',
                    mappa: 'Mappa',
                    minimoPasseggeri: 'Minimo passeggeri',
                    nessunRisultato: 'Nessun risultato',
                    numeroPostiDisponibili: 'Numero posti disponibili',
                    numeroPostiRichiesti: 'Numero posti richiesti',
                    offertaPassaggio: 'Offerta passaggio',
                    offriCorsaPerViaggioCercato: 'Offri una corsa per il viaggio cercato',
                    offriUnPassaggio: 'Offri un passaggio',
                    partecipaTaxiCondiviso: 'Partecipa a taxi condiviso',
                    passeggeriAccompagnati: 'Passeggeri accompagnati',
                    postiConfermatiNum: '{0} posti confermati',
                    postoConfermatoNum: '{0} posto confermato',
                    prenotazioneTaxiConfermata: 'Prenotazione taxi confermata',
                    procediRichiesta: 'Procedi con la richiesta',
                    pubblicaRichiesta: 'Pubblica la tua richiesta',
                    pubblicaValutazione: 'Pubblica valutazione',
                    pubblicaValutazioneMessage:
                        'Pubblicando la valutazione tutti gli utenti potranno visualizzare la tua recensione',
                    rendiDisponibileAuto: 'Rendi disponibile la tua auto',
                    ricercaNoRisultati: 'La ricerca non ha prodotto risultati',
                    richiestaAnnullata: 'Richiesta annullata',
                    richiestaPassaggioInviata: 'Richiesta di passaggio inviata',
                    richiestaPubblicata:
                        "La tua richiesta è stata pubblicata.<br/><br/>Troverai la tua richiesta nella sezione <b class='primary'>I miei viaggi</b>",
                    richiestaRifiutata: 'Richiesta rifiutata',
                    richiestaTaxiCondiviso: 'Richiesta Taxi condiviso',
                    richiestaTaxiCondivisoNum: '{0} utente partecipa al Taxi condiviso',
                    richiesteTaxiCondivisoNum: '{0} utenti partecipano al Taxi condiviso',
                    riepilogoOfferta: 'Riepilogo offerta',
                    riepilogoRichiesta: 'Riepilogo richiesta',
                    rifiutaRichiesta: 'Rifiuta richiesta',
                    rifiutaRichiestaError: 'Impossibile rifiutare la richiesta. Prenotazione non trovata.',
                    rifiutaRichiestaMessage: 'Annullare definitivamente la richiesta?',
                    storicoViaggi: 'Storico viaggi',
                    taxiCondiviso: 'Taxi condiviso',
                    tornaOfferta: "Torna all'offerta",
                    valutaConducente: 'Valuta conducente',
                    valutaPasseggeri: 'Valuta passeggeri',
                    valutaPasseggero: 'Valuta passeggero',
                    valutaUtente: 'Valuta utente',
                    valutazione: 'Valutazione',
                    viaggiAttivi: 'Viaggi attivi',
                    viaggiCompletati: 'Viaggi completati',
                    viaggiConTaxiCondiviso: 'Viaggi con taxi condiviso',
                    viaggiDaConducente: 'Viaggi da conducente',
                    viaggiDaPasseggero: 'Viaggi da passeggero',
                },
                offriPassaggio: {
                    partenzaArrivoModificate:
                        'Modificando la partenza o la destinazione rispetto a quelle di partenza le soluzioni potrebbero non essere più compatibili con la richiesta del passeggero.',
                },
                pubblicaRichiesta: {
                    infoRichiestaCarPooling:
                        'Inviando la richiesta pubblicherai nella sezione Bacheca due richieste distinte una per Car Pooling ed una per Taxi Condiviso. Riceverai notifiche tramite email quando altri utenti inseriranno offerte di viaggio o richieste di Taxi Condiviso compatibili con la tua esigenza di viaggio.',
                    infoRichiestaCarPoolingTaxiCondiviso:
                        'Inviando la richiesta pubblicherai nella sezione Bacheca due richieste distinte una per Car Pooling ed una per Taxi Condiviso. Riceverai notifiche tramite email quando altri utenti inseriranno offerte di viaggio o richieste di Taxi Condiviso compatibili con la tua esigenza di viaggio.',
                    infoRichiestaNoAmbito:
                        'Seleziona almeno un ambito, tra Car Pooling e Taxi Condiviso, per cui inserire una richiesta nella sezione Bacheca.',
                    infoRichiestaTaxiCondiviso:
                        'Inviando la richiesta pubblicherai nella sezione Bacheca una richiesta per Taxi Condiviso. Riceverai notifiche tramite email quando altri utenti inseriranno richieste di Taxi Condiviso compatibili con la tua esigenza di viaggio.',
                    pubblicaRichiestaCarPooling: 'Pubblica richiesta di condivisione corsa Car Pooling',
                    pubblicaRichiestaTaxiCondiviso: 'Pubblica richiesta di condivisione corsa in Taxi',
                },
                riepilogoOfferta: {
                    informazioniOffertaPassaggioPubblicata:
                        "Attendi che altri utenti ti contattino tramite email o cerca subito i passeggeri per il tuo viaggio tra le richieste compatibili con l'offerta pubblicata. <br/><br/>Troverai la tua richiesta nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    informazioniVeicolo: 'Informazioni veicolo',
                    informazioniVeicoloPlaceholder: 'Targa, marca, modello',
                    offertaPassaggioPubblicata: 'Offerta passaggio pubblicata',
                    selezionaMezzoDiTrasporto: 'Scegli il mezzo di trasporto con cui arriverai',
                    selezionaTraghettoElba: "Scegli traghetto con cui arriverai all'Isola d'Elba",
                },
                riepilogoRichiesta: {
                    richiestaInoltrataConducente:
                        "La tua richiesta è stata inoltrata al conducente <b class='primary'>{0}</b>.<br/><br/>Attendi che il conducente confermi la tua richiesta oppure chiamalo per avere aggiornamenti.<br/><br/>Troverai la tua richiesta nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    richiestaInoltrataConducenti:
                        "La tua richiesta è stata inoltrata ai conducenti <b class='primary'>{0}</b>.<br/><br/>Attendi che i conducenti confermino la tua richiesta oppure chiamali per avere aggiornamenti.<br/><br/>Troverai le tue richieste nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    richiestaInoltrataTaxiCondiviso:
                        "Hai inviato la tua partecipazione al taxi condiviso.<br/><br/>Chiama gli altri partecipanti per avere aggiornamenti sulla prenotazione del taxi.<br/><br/>Troverai la tua richiesta nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    richiesteInoltrate:
                        "Le tue richieste sono state inoltrate.<br/><br/>Le troverai nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    richiesteInoltrateTaxiCondiviso:
                        "Hai inviato la tua partecipazione ai taxi condivisi.<br/><br/>Chiama gli altri partecipanti per avere aggiornamenti sulla prenotazione dei taxi.<br/><br/>Troverai la tue richieste nella sezione <b class='primary'>I MIEI VIAGGI</b>",
                    richiesteInviate: 'Richieste inviate',
                    richiestePassaggioInviate: 'Richieste di passaggio inviate',
                },
                soluzioniDiViaggio: {
                    posizioniNonValide: 'Posizioni di partenza e arrivo non valide.',
                },
            },
            cercaOd: {
                destinazione: 'Destinazione',
                header: 'Cerca su tratta',
                nessunTitoloTrovato: 'Non ci sono soluzioni per i criteri immessi',
                origine: 'Origine',
                voglioArrivareA: 'Voglio arrivare a',
                voglioPartireDa: 'Voglio partire da',
            },
            common: {
                Targa: 'Targa',
                aPartireDa: 'A partire da',
                aPiedi: 'A piedi',
                accedi: 'Accedi',
                accetta: 'Accetta',
                acquista: 'Acquista',
                acquistaCon: 'Acquista con',
                acquistabile: 'Acquistabile',
                acquisto: 'Acquisto',
                acquistoABuonFine: "L'acquisto è andato a buon fine",
                acquistoEffettuato: 'Acquisto Effettuato',
                adesso: 'Adesso',
                agevolazioni: 'Agevolazioni',
                aggiungi: 'Aggiungi',
                al: 'Al',
                alAlle: 'Al {0} alle {1}',
                andataRitorno: 'Andata / Ritorno',
                anni: 'anni',
                annulla: 'Annulla',
                annullaOperazione: 'Annulla operazione',
                annullata: 'Annullata',
                applicaPreferenze: 'Applica preferenze',
                apriQrCode: 'Apri QR Code',
                arrivo: 'Arrivo',
                associaCarta: 'Registra Carta',
                attendere: 'Attendere',
                attenzione: 'Attenzione',
                attiva: 'Valida',
                attivaBorsellino: 'Attiva Borsellino Trasporto Pubblico',
                attivaNuovoTitolo: 'Attiva nuove corse',
                attivato: 'Validato',
                auto: 'Auto',
                autocompleteTypes: {
                    EVENTI: 'Eventi',
                    FERMATE: 'Fermate',
                    INDIRIZZO: 'Indirizzi',
                    LINEE: 'Linee',
                    LOCALITA: 'Località',
                    POI: 'Poi',
                },
                avanti: 'Avanti',
                backHome: 'Torna alla Home',
                benvenuto: 'Benvenuto',
                benvenutoNelMondoMyCicero: 'Benvenuto nel mondo myCicero.',
                benvenutoNelMondoVettore: 'Benvenuto nel mondo {0}.',
                calcolaPercorso: 'Calcola percorso',
                cambiCorsa: 'cambi',
                cambia: 'Cambia',
                cambiaCitta: 'Cambia città',
                cambiaImmagine: 'Cambia',
                cambioCorsa: 'cambio',
                cancella: 'Cancella',
                cancellata: 'Cancellata',
                caratteri: 'caratteri',
                carica: 'Carica',
                caricaFile: 'Carica',
                caricamento: 'Caricamento...',
                carriers: 'Vettori',
                carrozza: 'Carrozza',
                centro: 'zona centro',
                cerca: 'Cerca...',
                chiudi: 'Chiudi',
                chiuso: 'Chiuso',
                cities: 'Città',
                clickPerMaggioriInfo: 'Clicca qui per maggiori informazioni...',
                codiceTransazione: 'Codice transazione',
                cognome: 'Cognome',
                comune: 'Comune',
                comuneArrivo: 'Comune di arrivo',
                comuneNonValido: 'Comune non valido o non coperto dal servizio.',
                comunePartenza: 'Comune di partenza',
                con: 'con',
                condividiViaggio: 'Condividi il viaggio',
                condizioniUtilizzoHtml: 'Accetto le <a href="#" class="lnkCondizioni">condizioni di utilizzo</a>',
                conducente: 'Conducente',
                conferma: 'Conferma',
                confermaAcquisto: 'Conferma acquisto',
                confermaContinua: 'Sei sicuro di voler continuare?',
                confermaEChiudi: 'Conferma e Chiudi',
                confermaNonChiedere: 'Non ricordarmelo più.',
                confermaSelezione: 'Conferma selezione',
                confermaUscitaApp: "Sei sicuro di voler uscire dall'applicazione?",
                contattaAssistenza: "Si prega di contattare l'assistenza",
                contattaIlGestore: 'Contatta il gestore',
                contattiEdEntiCoinvolti: 'Contatti ed Enti Coinvolti',
                continua: 'Continua',
                copertura: 'Copertura Zone',
                corse: 'Corse',
                creaTessera: 'Crea tessera',
                crediti: 'Crediti',
                dal: 'Dal',
                dalAlle: 'Dal {0} alle {1}',
                dalleAlle: 'Dalle {0} alle {1}',
                data: 'Data',
                dataSvolgimento: 'Data di svolgimento',
                datiSalvati: 'Dati salvati',
                descrizione: 'Nome breve',
                dettaglio: 'Dettaglio',
                domani: 'Domani',
                durata: 'Durata',
                e: 'e',
                elencoMovimenti: {
                    tipo: {
                        abbSosta: 'Acquisto Abbonamento',
                        ricarica: 'Ricarica',
                        sosta: 'Sosta',
                        utilizzoCredito: 'Utilizzo Credito',
                    },
                },
                elimina: 'elimina',
                emesso: 'Emesso',
                emptyList: 'Nessun elemento presente',
                errore: 'Attenzione',
                erroreCaricamento:
                    'Si è verificato un errore. Non è stato possibile caricare i dati, riprova più tardi',
                erroreComunicazioneServer: 'Errore di comunicazione con il server',
                erroreConnessione: 'Si è verificato un errore. Verifica la connessione di rete e riprova',
                erroreConnessioneServer: 'Impossibile collegarsi al server',
                erroreDownloadTitoli: 'Si è verificato un errore durante il download dei titoli. Riprova più tardi.',
                erroreFormatoQrCode: 'Formato codice QR errato',
                errorePagamento:
                    "Si è verificato un errore nel pagamento. Si prega di effettuare nuovamente l'acquisto.",
                erroreSalvataggio:
                    'Si è verificato un errore. Non è stato possibile salvare le modifiche, riprova più tardi.',
                erroreScansioneQrCode: 'Si è verificato un errore durante la scansione del QR code.',
                erroreSconosciuto: 'Si è verificato un errore',
                eventi: 'Eventi',
                evviva: 'Evviva',
                fa: '{0} fa',
                filters: 'Filtri',
                filtra: 'Filtra',
                filtri: 'filtri',
                filtro: 'filtro',
                finoA: 'Fino a',
                finoATuttoIl: 'Fino a tutto il',
                finoAl: 'fino al',
                giorni: 'giorni',
                giornoAlle: '{0} alle {1}',
                googlePlay: {
                    legal: 'Google Play e il logo di Google Play sono marchi di Google LLC.',
                },
                home: 'Home',
                ieri: 'Ieri',
                ilDalleAlle: 'Il {0} dalle {1} alle {2}',
                illimitato: 'Illimitato',
                importo: 'Importo',
                importoTotale: 'Importo Totale',
                impossibileEseguireOperazione: "Impossibile eseguire l'operazione",
                impossibileVisualizzareQrCode: 'Impossibile visualizzare il QR Code',
                impostazioni: 'Impostazioni',
                indietro: 'Indietro',
                indirizzo: 'Indirizzo',
                indirizzoArrivo: 'Indirizzo di arrivo',
                indirizzoPartenza: 'Indirizzo di partenza',
                inevidenza: 'In evidenza',
                info: 'Informazioni',
                infoAbbreviato: 'Info',
                infoBiglietto: '',
                infoNonDisponibili: 'Non sono disponibili ulteriori informazioni',
                infoTraghetto: 'Info traghetto:',
                infoVeicolo: 'Info veicolo:',
                ingrandisci: 'Ingrandisci',
                inizia: 'Inizia',
                inizio: 'Inizio',
                inserisciCodicePromo: 'Inserisci il codice',
                intornoA: 'Intorno a',
                inviaRisposta: 'Invia risposta',
                io: 'Io',
                itinerario: 'Itinerario',
                leggi: 'Leggi',
                leggiTutto: 'Leggi tutto...',
                liberi: 'Liberi',
                libero: 'Libero',
                lingua: 'Lingua',
                link: 'link',
                loadMore: 'Carica altri...',
                longTermParkingPanel: {
                    finoA: 'Fino a',
                    prenotazioneDal: 'Prenotazione dal',
                },
                luoghi: 'Luoghi',
                mappa: 'Mappa',
                mesi: 'mesi',
                mezzo: 'Mezzo',
                mieiTitoli: 'I miei titoli',
                minuti: 'Minuti',
                minutiLower: 'minuti',
                minutiShort: 'min',
                mobilita: 'Mobilità',
                modalita: 'Modalità',
                modifica: 'Modifica',
                mostraTutti: 'Mostra tutti',
                mostraTutto: 'Mostra tutto',
                movimenti: 'Movimenti',
                msgAtacLockedOutUntil:
                    'Per questioni di sicurezza legate alla recente migrazione, la gestione dei tuoi titoli ATAC è momentaneamente sospesa; potrai tornare ad utilizzare i titoli alle ore {1}',
                nascondi: 'Nascondi...',
                nessun: 'Nessun',
                nessunDettaglioTrovato: 'Nessun dettaglio trovato',
                nessuno: 'Nessuno',
                newsNotifiche: 'News e Notifiche',
                newsNotificheUnread: '{0} News e Notifiche',
                nfcSpentoDesc: 'Attivalo dalle impostazioni del telefono per validare il titolo di viaggio',
                nfcSpentoWarning: 'NFC disattivo sul tuo dispositivo.',
                no: 'No',
                noCameraPermission: 'Non hai i permessi per accedere alla fotocamera.',
                noRicerchePreferite: 'Non ci sono ricerche preferite',
                noRicercheRecenti: 'Non ci sono ricerche recenti',
                noRisultati: 'Non ci sono risultati per questa ricerca.',
                noRisultatiRicerca: 'Non ci sono risultati per la ricerca.',
                noRisultatiVisibili: 'Non ci sono risultati visibili.',
                nome: 'Nome',
                nomeCompleto: 'Nome e cognome',
                nonAcquistabile: 'Non acquistabile',
                nonAttiva: 'Non attiva',
                nonConfermata: 'Non confermata',
                nonOra: 'Non ora',
                notifica: 'Notifica',
                numCartafreccia: 'N° Cartafreccia',
                nuova: 'Nuova',
                nuovaAttivazione: 'Nuova Attivazione',
                obbligatorio: '(obbligatorio)',
                oggi: 'Oggi',
                ok: 'Ok',
                operazioneEseguita: 'Operazione eseguita',
                operazioneFallita: 'Operazione fallita',
                opzioni: 'opzioni',
                ora: 'Ora',
                oraDelGiorno: "<span class='bold'>{0}</span> del {1}",
                orariEfermate: 'Orari e fermate',
                orario: 'Ora',
                ore: 'ore',
                ottimo: 'Ottimo',
                paga: 'Paga',
                parcheggiNavette: 'Parcheggi con navette',
                parcheggia: 'Parcheggia',
                partenza: 'Partenza',
                partners: 'Partners',
                passeggeri: 'Passeggeri',
                passeggero: 'Passeggero',
                plusAutoricarica: {
                    labelCartaDiCreditoNecessaria: 'Serve una Carta di Credito memorizzata',
                    labelMemorizza: 'Memorizza',
                    labelRicaricaAutomatica: 'Imposta autoricarica',
                    labelRicaricaAutomaticaAttiva: 'Autoricarica attiva',
                    labelRicaricaAutomaticaNonDisponibile: 'Ricarica automatica non disponibile',
                },
                plusCartaDiCredito: {
                    labelElimina: 'Elimina',
                    labelProprietario: 'PROPRIETARIO',
                    labelValidita: 'VALID<br/>THRU',
                },
                posti: 'Posti',
                posto: 'Posto',
                preferite: 'Preferite',
                preferiti: 'Preferiti',
                prefissoData: 'il',
                prezzo: 'Prezzo',
                primaAttivazione: 'Prima validazione:',
                procedi: 'Procedi',
                prodotti: 'Prodotti',
                promoOK: 'Promozione assegnata',
                prosegui: 'Prosegui',
                qrCodeFermata: 'QR Code Fermata',
                quando: 'Quando',
                quantita: 'Quantità',
                raggiungici: 'Raggiungici',
                realtaAumentata: 'Realtà Aumentata',
                recenti: 'Recenti',
                refresh: 'Aggiorna',
                reset: 'Reset',
                results: 'Risultati',
                ricarica: 'Ricarica',
                ricerca: 'Ricerca',
                riceviAssistenza: 'Per assistenza visitare la pagina:',
                rifiuta: 'Rifiuta',
                rifiutata: 'Rifiutata',
                rimuoviFiltri: 'Rimuovi filtri',
                riprova: 'Riprova',
                risultatiPer: 'Risultati per ',
                rivendite: 'Rivendite e biglietterie',
                salta: 'Salta passaggio',
                salva: 'Salva',
                salvaNeiPreferiti: 'Salva nei preferiti',
                salvaProcedi: 'Salva e procedi...',
                salve: 'Salve',
                scadenza: 'Scadenza: ',
                scanQrCode: 'Scannerizza QrCode',
                scegliRitorno: 'Scegli ritorno',
                scegliTipologia: 'Scegli una tipologia per filtrare',
                secureCode: 'Secure Code Mobile',
                secureCodeMyCicero: 'myCicero Secure Code',
                secureCodeRecover:
                    'Non essendo recuperabile, se lo hai perso devi eliminare e registrare nuovamente la tua carta di credito.',
                seiSicuro: 'Sei sicuro?',
                seleziona: 'Seleziona',
                selezionaMemorizza: 'Seleziona e memorizza scelta',
                selezionaPosizioneMappa: 'Seleziona in mappa',
                sempre: 'Sempre',
                servizi: 'Servizi',
                serviziAggiuntivi: 'Servizi aggiuntivi:',
                share: 'Condividi',
                sharing: {
                    header: 'Ti piace myCicero?',
                    provaMyCicero: 'Prova myCicero!',
                    sharingMessage:
                        "Se utilizzi i mezzi pubblici o vuoi un sistema intelligente, rapido ed economico per pagare la sosta comodamente da app, dovresti provare myCicero! myCicero è l'unica app che ti permette di lasciare l'auto e muoverti con i mezzi pubblici, accompagnandoti in ogni fase del viaggio. Un'app per tanti servizi.  - Paga solo i minuti effettivi di sosta e acquista i permessi per le ZTL.  - Soluzioni di viaggio integrate ai collegamenti locali ed ai biglietti.  - Linee locali e nazionali con acquisto di biglietti ed abbonamenti.  - Orari e biglietti in un click, avvicina lo smartphone ai tornelli ed entra. ",
                    shortText: "Condividi l'app con i tuoi amici!",
                    text: 'Ti piace myCicero? Condividi',
                },
                socialMedia: 'Social media',
                soloAndata: 'Solo Andata',
                sosta: 'Sosta',
                spese: 'Spese',
                sulista: 'Lista',
                sumappa: 'Mappa',
                targa: 'Numero targa',
                tariffa: 'Tariffa',
                telefono: 'Telefono',
                tempoScaduto: 'Tempo scaduto',
                terminaApp: 'Chiudi applicazione',
                termsCondition: 'Ho letto le condizioni di utilizzo',
                timeoutPagamentoBigliettoTrasportoMessage:
                    "L’elaborazione sta impiegando più tempo del previsto. Prima di riprovare, attendere qualche secondo e verificare se il titolo viene scaricato nella sezione 'I miei titoli' o se si riceve la conferma di acquisto via e-mail.",
                timeoutPagamentoMessage:
                    'L’elaborazione sta impiegando più tempo del previsto. Prima di riprovare, attendere qualche secondo e verificare se si riceve la conferma di acquisto via e-mail.',
                timeoutPagamentoTitle: 'Timeout della connessione',
                tipo: 'Tipo:',
                tipologia: 'Tipologia',
                tornaAllaHome: 'Torna alla home',
                tornaIndietro: 'Torna indietro',
                totale: 'Totale',
                tours: 'Tour',
                tra: 'tra {0}',
                trasporto: 'Trasporto',
                tuttaLaSettimana: 'Tutta la settimana',
                tutteTipologie: 'Tutte le tipologie',
                tutti: 'Tutti',
                utente: 'Utente',
                utenti: 'Utenti',
                utilizzabileIl: 'Utilizzabile il giorno:',
                utilizzoTitoliAtac: 'Utilizzo titoli ATAC',
                vaiAlTitolo: 'Vai al titolo',
                vaiAllaPagina: 'Vai alla pagina',
                valida: 'VALIDA',
                validoDal: 'Valido dal',
                validoFinoAl: 'Valido fino al',
                validoFinoAlle: 'Valido fino alle',
                validoIlGiorno: 'Valido il giorno',
                validoTra: 'Valido tra',
                verifico: 'Verifico...',
                verifying: 'Sto verificando ...',
                version: 'Versione',
                vettore: 'Vettore',
                viaggi: 'Viaggi',
                viaggio: 'Viaggio',
                visitaIlSito: 'visita il sito',
                yes: 'Sì',
                zonaNonCoperta: 'Ti trovi in una zona non coperta dal servizio.',
            },
            credito: {
                aci: {
                    descrRedirect: 'Cliccando sul pulsante si verr&agrave; condotti alla pagina di pagamento ACI.',
                    descrizione: 'Paga con ACI pay',
                },
                acquistoConBorsellino: 'Acquista utilizzando il credito',
                acquistoConBorsellinoMyCicero: 'Acquista utilizzando il credito myCicero',
                acquistoConBorsellinoTrasporto: 'Acquista utilizzando il credito Trasporto Pubblico',
                acquistoSisalAbbSosta:
                    'Non appena avrai completato l\'acquisto troverai l\'abbonamento nella sezione "Sosta e ZTL - Agevolazioni / Abbonamenti".',
                acquistoSisalRicaricaBorsellino:
                    "Non appena avrai completato l'acquisto il credito del borsellino verrà aggiornato.",
                alertConnessioneCadutaAcquistoAbb:
                    "C'è stata una caduta della connettività e non è garantito che l'operazione di acquisto sia andata a buon fine. Verifica se l'abbonamento appena acquistato si trova nella sezione 'I miei Abbonamenti', altrimenti effettua di nuovo l'acquisto.",
                attivaBorsellinoTrasportoPubblico: 'Attiva il borsellino Trasporto Pubblico',
                bemoov: {
                    descrRedirect:
                        'Verrai reindirizzato ad una pagina esterna dove ti verrà chiesto di inserire il codice OTP e il CV2 della carta di credito associata.',
                    descrUsoNumeroTelefono: 'Verrà inviato un codice OTP di conferma via SMS al numero specificato',
                    inserisciNumeroTelefono: 'Inserisci il numero di telefono abbinato al conto',
                },
                clearCodice: 'Elimina Codice',
                controllaCodice: 'Controlla Codice',
                credito: 'Credito',
                creditoBorsellinoInsufficiente:
                    'Il credito rimanente sul borsellino non è sufficente per effettuare questo acquisto.',
                creditoInsufficiente: 'Credito non sufficiente',
                creditoResiduo: 'Credito residuo',
                creditoSosta: 'Credito sosta',
                datiPagamento: 'Dati Pagamento',
                dettaglioAcquisto: 'Dettaglio Attività di acquisto',
                dettaglioAttivitaRicarica: 'Dettaglio attività di ricarica credito',
                effettuaPagamento: 'Effettua pagamento',
                effettuaPagamentoPer: 'Effettua pagamento per',
                erroreCaricamento:
                    'Si è verificato un errore. Non è stato possibile caricare i dati, riprova più tardi',
                erroreSalvataggio:
                    'Si è verificato un errore. Non è stato possibile salvare le modifiche, riprova più tardi',
                gestionePagamento: 'Gestione Pagamento',
                importoAcquisto: 'Importo Acquisto',
                infoAcquistiSmartphoneHTML:
                    'Per gli acquisti da smartphone registra una carta di credito tramite la quale potrai, in tutta sicurezza, acquistare abbonamenti e ricaricare il tuo credito sosta. <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Registrane una con pochi clic</a>.',
                infoAttivaBorsellinoHTML:
                    'È possibile utilizzare il credito pre caricato su un borsellino virtuale. Per attivarlo è sufficiente accedere all\'<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">area riservata</a>.',
                infoConfermaPagamento:
                    "Premendo il pulsante si procederà alla transazione prelevando l'importo dalla Carta di Credito specificata.",
                infoConfermaPagamentoBorsellino:
                    "Premendo il pulsante si procederà alla transazione prelevando l'importo dal Credito",
                infoConfermaPagamentoBorsellinoMyCicero:
                    "Premendo il pulsante si procederà alla transazione prelevando l'importo dal Credito myCicero",
                infoConfermaPagamentoBorsellinoTemplate:
                    "Premendo il pulsante si procederà alla transazione prelevando l'importo dal Borsellino {0} ",
                infoConfermaPagamentoRedirect: 'Verrai reindirizzato a una pagina esterna',
                infoRicaricaBorsellinoHTML:
                    'Puoi ricaricare il borsellino direttamente dal tuo telefono (<a data-bind="tap: gotoRicarica">clicca qui</a>) o puoi accedere, tramite un PC, all\'<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">area riservata</a>.',
                infoRicaricaBorsellinoShortHTML:
                    'Puoi ricaricare il borsellino , tramite un PC, all\'<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">area riservata</a>.',
                inserisciCodiceCouponRicarica: 'Inserisci Codice Coupon',
                inserisciDatiCarta: 'Inserisci i dettagli della carta di credito',
                inserisciSecureCode: 'Inserisci il Secure Code Mobile',
                inserisciSecureCodeMyCicero: 'Inserisci il myCicero Secure Code',
                metodoPagamento: 'Metodo di pagamento',
                noCreditCard: 'Acquista utilizzando una carta di credito',
                nonRicordi: 'Non lo ricordi?',
                pagaCon: 'Paga con ',
                payCreditOneShot: 'Effettua il pagamento utilizzando una carta di credito senza registrarla',
                paypal: {
                    info1: 'Paga automaticamente tramite il tuo conto PayPal.',
                    info2: 'Cliccando il pulsante effettuerai immediatamente il pagamento tramite PayPal.',
                    titolo: 'PayPal<sup>TM</sup>',
                },
                paypalexp: {
                    descrRedirect: 'Cliccando sul pulsante si verr&agrave; condotti alla pagina di pagamento PayPal.',
                    descrizione: 'Pagamento paypal express checkout',
                },
                paypalric: {
                    descrRedirect: 'Cliccando sul pulsante effettuerai immediatamente il pagamento tramite Paypal.',
                    descrizione: 'Paga col tuo conto paypal',
                },
                prenotazioneSisal: 'Hai una prenotazione per <br/> &euro;&nbsp;{0}',
                prenotazioneSisalAbb: 'Hai una prenotazione per <br/> un abbonamento di &euro;&nbsp;{0}',
                prenotazioneSisalRic: 'Hai una prenotazione per <br/> una ricarica di &euro;&nbsp;{0}',
                promoTitoli: 'Promozione Titoli',
                redirectToCCInfo:
                    'Verrai reindirizzato ad una pagina esterna nella quale ti verranno chiesti i dati della carta di credito.',
                registraCartaCredito: 'Nuova carta di credito...',
                ricarica: 'Ricarica',
                ricaricaBorsellino: 'Ricarica Borsellino',
                ricaricaCoupon: 'Hai un coupon?',
                ricaricaCouponNonValido: 'Il codice non è valido o è scaduto.',
                ricaricaCouponUsaCodice: 'Effettua la ricarica...',
                ricaricaCouponVerificaCodiceBtn: 'Verifica codice',
                ricaricaCredito: 'Ricarica Credito',
                ricaricaSuccess: 'Ricarica effettuata correttamente',
                richiediPagamento: 'Richiedi pagamento',
                richiediPagamentoPer: 'Richiedi pagamento per ',
                saldo: 'Saldo',
                saldoAttuale: 'Saldo Credito Attuale',
                saldoFuturo: 'Saldo Credito',
                satispay: {
                    bonus:
                        '&euro; 5,00 di bonus se ti <u onclick="openLinkOnBrowser(\'https://www.satispay.com/promo/mycicero\')">iscrivi</u> al servizio!',
                    completaPagamento: "Completa il pagamento sull'app Satispay",
                    confermaCompletato: 'Non appena riceveremo conferma, l’acquisto verrà completato',
                    inserisciNumero: 'Inserisci il numero di telefono abbinato al tuo conto Satispay',
                    risultatoAcquisto: "Non appena riceveremo conferma da Satispay l'acquisto verrà completato.",
                    titolo: 'Satispay',
                    verraiRediretto: "Potrai completare il pagamento nell'app <strong>Satispay</strong>",
                },
                scegliCartaCredito: 'Scegli una carta di credito tra quelle associate',
                scegliImporto: "Scegli l'importo con cui ricaricare il tuo credito",
                scegliMetodoPagamento: 'Scegli un metodo di pagamento',
                screenSaved: "Inoltre ho appena registrato un'immagine nella tua galleria fotografica.",
                secureCodeErrato: 'Secure Code errato',
                secureCodeReminder:
                    'Il Secure Code Mobile è il tuo codice personale di 5 caratteri numerici che hai immesso al momento della registrazione della carta di credito.',
                secureCodeReminderMyCicero:
                    'Il myCicero Secure Code è il tuo codice personale di 5 caratteri numerici che hai immesso al momento della registrazione della carta di credito.',
                sisalCommissioni1: "Il costo dell'operazione verrà maggiorato da una",
                sisalCommissioni2: 'commissione SisalPay',
                sisalCommissioni3: "che dipende dall'importo del pagamento.",
                sisalGeneraCod: 'Genera codice per ',
                sisalInfoAcquisto:
                    'Per acquistare la ricarica, recati in uno dei <u>Punti SisalPay</u> abilitati e comunica i seguienti parametri...',
                sisalInfoAcquisto2:
                    'Raggiungi un <span class="underline primary">Punto SisalPay</span> quindi chiedi al negoziante di effettuare un pagamento su autobus.it – myCicero e comunica il codice PNR di prenotazione seguente.',
                sisalInfoAcquisto3:
                    'Raggiungi un punto SisalPay e chiedi di effettuare un pagamento su "Autobus.it/myCicero" comunicando il codice PNR che trovi sopra.',
                sisalInfoMaggiorazioneHtml:
                    'il costo dell\'operazione verrà maggiorato della commissione applicata da SisalPay, proporzionale al valore del pagamento. Per ulteriori informazioni, segui <span class="underline primary">questo link</span>.',
                sisalInviatoPerEmail: "Questo codice ti è stato inviato per e-mail all'indirizzo ",
                sisalMostraRivendite: 'Mostra elenco Punti SisalPay',
                sisalPay: 'SisalPay',
                sisalPayDescription:
                    'Dopo il click verrà generato il PNR da comunicare al Punto Vendita SisalPay tramite il quale potrai effettuare il pagamento.',
                sisalPuntiVendita: 'Punti SisalPay',
                sisalRaggiungi:
                    'Per effettuare il pagamento, raggiungi un Punto Vendita SisalPay quindi chiedi al negoziante di effettuare un pagamento su autobus.it – myCicero e comunica il codice PNR che verrà generato',
                sisalbill: {
                    completaPagamento: 'Transazione effettuata',
                    completaPagamentoFallita: 'Transazione fallita',
                    confermaCompletato: '',
                    confermaCompletatoAbbonamentoSosta:
                        'Una volta completato l\'acquisto per scaricare il titolo, entra nella sezione "Agevolazioni" ed aggiorna l\'elenco',
                    confermaCompletatoBorsellino: 'Il credito del borsellino è stato aggiornato',
                    confermaCompletatoFallita: 'Si è verificato un errore durante il pagamento',
                    confermaCompletatoTitoli: 'Puoi trovare il biglietto acquistato nella sezione "i miei titoli"',
                    risultatoAcquisto: "Non appena riceveremo conferma da Sisal&nbsp;Bill l'acquisto verrà completato.",
                    risultatoAcquistoBorsellino:
                        "Non appena riceveremo conferma da Sisal&nbsp;Bill l'acquisto verrà completato.",
                },
                staiAcquistando: 'Stai per acquistare:',
                staiPagando: 'Stai per pagare:',
                staiPrenotando: 'Stai per prenotare il pagamento di:',
                stpay: {
                    descr: '<p>Satispay è un sistema di pagamento indipendente da carte di credito e debito.</p>',
                    iscrivitiSubito: 'Iscriviti subito al servizio e ricevi 5€ di bonus',
                },
                usaIlCredito: {
                    info1: 'Ricarica il tuo Credito e utilizzalo per pagare tutti i servizi myCicero.',
                    info1Branded: 'Ricarica il tuo Credito e utilizzalo per pagare tutti i servizi.',
                    info2:
                        'Eviti così di inserire ogni volta i dati della tua carta e non hai alcuna commissione aggiuntiva. Tanti sono i metodi di pagamento abilitati.',
                    info2Branded:
                        'Eviti così di inserire ogni volta i dati della tua carta e non hai alcuna commissione aggiuntiva.',
                    ricaricaCredito: 'Ricarica credito',
                    titolo: 'Perchè conviene',
                },
            },
            dettaglioSinteticoFermata: {
                direzione: '{0}',
                distanzaDaTe: '{0} da te',
            },
            dettaglioSisnteticoBus: {
                direzione: 'Direzione: {0}',
                distanzaDaTe: 'Fermata a {0} da te',
            },
            difonzo: {
                acquistaTitoli: 'Acquista titoli',
                fermateEdOrari: 'Fermate ed orari',
                mieiTitoli: 'I miei titoli',
                soluzioniDiViaggio: 'Soluzioni di viaggio',
            },
            dolomiti: {
                AcquistaBiglietti: 'Acquista biglietti',
                CalcolaPercorso: 'Calcola percorso',
                Eventi: 'Eventi',
                FermateOrari: 'Fermate ed orari',
                Luoghi: 'Luoghi',
                MieiTitoli: 'I miei titoli',
                ServiziTuristici: 'Servizi turistici',
            },
            eav: {
                AcquistaBiglietti: 'Acquista<br/>titoli',
                CalcolaPercorsoHTML: 'Pianifica<br/>viaggio',
                CampaniaExpress: 'Campania Express',
                CampaniaExpressHTML: 'Campania<br/>Express',
                CumaExpress: 'Cuma Express',
                CumaExpressHTML: 'Cuma<br/>Express',
                FermateOrari: 'Fermate e Orari',
                FermateOrariHTML: 'Fermate<br/>e orari',
                MieiTitoli: 'I Miei Titoli',
                bigliettiBus: 'Biglietti Bus',
                bigliettiFunivia: 'Biglietti Funivia',
                bigliettiTreno: 'Biglietti Treno',
                fermate: 'Fermate',
            },
            elbasharing: {
                bachecaTab: {
                    conducenti: 'Conducenti',
                    passeggeri: 'Passeggeri',
                    taxi: 'Taxi',
                },
                common: {
                    cercaUnPassaggio: 'Cerca una soluzione di viaggio',
                    filtraLabel: 'Filtra',
                    filtriAttivi: 'Filtri attivi',
                    filtroAttivo: 'Filtro attivo',
                    infomobilita: 'Infomobilità',
                    nuovaRicerca: 'Nuova ricerca',
                    trovaSoluzioneViaggio: 'Trova il viaggio più adatto a te',
                },
                homepage: {
                    bacheca: 'Bacheca',
                    consultaOfferteRichieste: 'Consulta offerte e richieste attive',
                    controllaViaggi: 'Controlla i tuoi viaggi',
                    iMieiViaggi: 'I miei viaggi',
                    offriUnPassaggio: 'Offri un passaggio',
                    partecipaOpinione: 'Partecipa con la tua opinione',
                    questionari: 'Questionari',
                    rendiDisponibileAuto: 'Rendi disponibile la tua auto',
                    servizi: 'Servizi',
                    viviIlTerritorio: 'Vivi il territorio',
                },
                review: {
                    reviewLabel: 'Recensioni da altri viaggiatori:',
                },
                soluzioniDiViaggio: {
                    posizioniNonValideOffriPassaggio:
                        "È possibile offrire un passaggio solo con partenza e arrivo all'interno dell'Isola d'Elba.",
                    posizioniNonValideRichiediPassaggio:
                        "È possibile richiedere un passaggio solo con partenza e arrivo all'interno dell'Isola d'Elba.",
                },
                tabelloneOrari: {
                    intornoAllIndirizzo: "Intorno all'indirizzo",
                },
                taxiCondivisoStatus: {
                    taxiStatus: 'Confermato',
                },
                vetrinaVettori: {
                    description:
                        'Per maggiori informazioni su orari ufficiali ed acquisto biglietti di viaggio, è possibile consultare le pagine web dei vettori del trasporto locale, CTT Nord e Tiemme',
                },
            },
            event: {
                allCategories: 'Tutte le Categorie',
                arrivi: 'Arrivi',
                caricaAltriEventi: 'Carica altri Eventi',
                definisciRaggio: 'Definisci raggio ricerca intorno a: ',
                dettaglio: 'Dettaglio Evento',
                elenco: 'Elenco',
                entroIl: 'Eventi entro',
                eventi: 'Eventi',
                eventiCorrelati: 'Eventi correlati',
                finePrevista: 'Fine prevista',
                inPartenzaEntro: 'Tour in partenza entro',
                info: 'Info',
                infoContatti: {
                    cellulare: 'Cellulare',
                    email: 'Email',
                    facebook: 'Facebook',
                    organizzatoDa: 'Organizzato da',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Telefono',
                    vaiAlSito: 'Vai al sito',
                },
                ingresso: 'Ingresso',
                inizio: 'Inizio',
                itinerariCorrelati: 'Itinerari che passano da qui',
                itinerario: 'Itinerario',
                mappa: 'Mappa',
                noEventi: 'Nessun evento in programma',
                nomeEvent: 'Nome Evento',
                ospiti: 'Ospiti importanti',
                partenze: 'Partenze',
                prossimiEventi: 'Prossimi eventi',
                prossimiEventiPoi: 'Prossimi eventi in questo luogo',
                quando: 'Quando',
                raggioRicerca: 'Raggio di ricerca',
                searchAllCat: 'Cerca su tutte le categorie',
                selezionaEvento: 'Seleziona un evento',
                serviziUtili: 'Servizi utili',
                specialitaCorrelate: 'Prodotti correlati',
                tab: {
                    allegati: 'Allegati',
                    info: 'Info',
                    mappa: 'Mappa',
                },
                vetrina: 'Vetrina',
                warnTariffe:
                    "Il prezzo mostrato si riferisce alla tariffa base. Verifica all'interno per il listino completo.",
                when: {
                    '30days': {
                        long: 'Prossimi 30 giorni',
                        short: '30 giorni',
                    },
                    '7days': {
                        long: 'Prossimi 7 giorni',
                        short: '7 giorni',
                    },
                    specifica: 'Giorno Specifico...',
                    today: {
                        long: 'Oggi',
                        short: 'Oggi',
                    },
                    tomorrow: {
                        long: 'Domani',
                        short: 'Domani',
                    },
                },
            },
            flussoPagamento: {
                acquistoAbbSosta:
                    'Trovi l\'abbonamento acquistato nella sezione "Sosta e ZTL - Agevolazioni / Abbonamenti".',
                acquistoBigliettoTrasporto: 'Trovi il titolo acquistato nella sezione "Trasporto".',
                acquistoRicaricaBorsellino: 'Il credito del borsellino è stato aggiornato.',
                acquistoSatispayAbbSosta:
                    'Non appena riceveremo conferma da Satispay troverai l\'abbonamento nella sezione "Sosta e ZTL - Agevolazioni / Abbonamenti".',
                acquistoSatispayBigliettoTrasporto:
                    'Non appena riceveremo conferma da Satispay troverai l\'abbonamento nella sezione "Trasporto".',
                acquistoSatispayRicaricaBorsellino:
                    'Non appena riceveremo conferma da Satispay il credito del borsellino verrà aggiornato.',
                attesaConfermaSatispay: 'In attesa di conferma Satispay',
                attesaTransazioneSatispay: 'Alcune transazioni possono impiegare più tempo del previsto.',
                confermaPinCode: 'Conferma PIN Code',
                creditoMyCicero: 'Credito myCicero',
                creditoPrecedente: 'Credito precedente',
                errorePagamento: 'Si è verificato un errore durante il pagamento.',
                importoAcquisto: 'Importo acquisto',
                messaggioTransazioneFallita: "Si è verificato un errore e non siamo riusciti a completare l'attività.",
                pagamentoSanzioneEseguito:
                    "A breve riceverai un'e-mail con la ricevuta del pagamento effettuato. Potrai verificare la transazione nell'elenco movimenti del tuo profilo utente.",
                pagamentoSkidataEseguito:
                    "Recati all'uscita del parcheggio ed inserisci il biglietto nella colonnina per alzare la sbarra.",
                pinErrato: 'PIN Errato',
                richiestaAcquistoSatispayAbbSosta:
                    'Non appena avrai completato l\'acquisto troverai l\'abbonamento nella sezione "Sosta e ZTL - Agevolazioni / Abbonamenti".',
                richiestaAcquistoSatispayBigliettoTrasporto:
                    'Non appena avrai completato l\'acquisto troverai l\'abbonamento nella sezione "Trasporto".',
                richiestaAcquistoSatispayRicaricaBorsellino:
                    "Non appena avrai completato l'acquisto il credito del borsellino verrà aggiornato.",
                saldoAttuale: 'Saldo attuale',
                scegliAltriMetodi: 'Oppure scegli',
                scegliCarta: 'Scegli Carta',
                scorriPerPagare: 'Scorri per pagare',
                transazioneAnnullata: "Transazione annullata dall'utente.",
                transazioneEffettuata: 'Transazione effettuata.',
                transazioneFallita: 'Transazione fallita.',
                usaAltraCarta: "Paga con un'altra carta...",
                verificaTransazioneSatispay: 'Verifica transazione',
            },
            flybus: {
                gtSearch: {
                    soluzioniDiViaggio: 'Soluzioni</br>di viaggio',
                },
                homepage: {
                    elencoMovimenti: 'Elenco</br>movimenti',
                    myTickets: 'I miei</br>biglietti',
                    ricaricaCredito: 'Ricarica</br>credito',
                    soluzioniDiViaggio: 'Soluzioni</br>di viaggio',
                    subtitle:
                        '<span class="bold">Acquista il tuo viaggio</span><span style="font-weight: 200"></br>in autobus</br>per le Dolomiti</span>',
                },
            },
            geocode: {
                fail: 'Rilevamento posizione non riuscito',
                indirizziTrovati: 'Indirizzi trovati',
                istruzioniChangePositionPageHtml:
                    'Digita un indirizzo, poi clicca <div class="ui-icon-plus-submit" style="width:16px;height:15px;display:inline-block;"></div> per iniziare la ricerca',
                lookForPos: 'Rilevamento posizione in corso...',
                noLocalitaTrovata: 'Nessuna località individuata',
                nodata: {
                    empty: "nessuna localita' individuata",
                },
                posNotAvailable: 'Posizione non disponibile.',
                slowGeocoder: 'Il geocoder sta impiegando troppo tempo a rispondere',
            },
            gps: {
                abilitaGpsHtml:
                    'le impostazioni della privacy impediscono l\'accesso alla posizione corrente: puoi modificarle in qualsiasi momento dal pannello</br><a href="#position-page">opzioni > gestisci posizione</a>',
                addressNotFound: 'Indirizzo non trovato.',
                auto: 'GPS',
                buona: 'Buona',
                cambiaIndirizzo: 'Cambia indirizzo',
                cambiaPosizione: 'Cambia posizione',
                discreta: 'Discreta',
                eccellente: 'Eccellente',
                enable: 'abilita rilevamento posizione tramite GPS',
                errors: {
                    '0': 'Servizio di localizzazione non supportato',
                    '1': 'Impossibile accedere ai servizi di localizzazione',
                    '2': 'Posizione corrente non rilevata',
                    '3': 'Posizione corrente non rilevata',
                    '4': 'Operazione cancellata',
                    '410': 'Errore http',
                    authorizationDenied: 'Non hai fornito i permessi per la localizzazione.',
                    genericInObliteration:
                        'Posizione non disponibile, verifica che il servizio di localizzazione sia attivo.',
                    hardwareDisabled: 'Localizzazione GPS disattivata.',
                    positionUnavailable: 'Impossibile recuperare la posizione corrente.',
                },
                info:
                    'le informazioni relative alla posizione sono utilizzate esclusivamente per fornire un servizio preciso ed affidabile: la tutela della privacy è estremamente importante per PluService, pertanto la tua posizione non verrà mai utilizzata senza il tuo consenso; inoltre, PluService non registra in nessun modo la tua posizione sui propri server.',
                infoAttivaGps:
                    "Per funzionare al meglio l'applicazione ha bisogno che il gps ed il rilevamento della posizione da rete siano attivi",
                infoAttivaGpsIphone:
                    'Per un corretto funzionamento di myCicero è utile avere il rilevamento gps attivo.',
                inserisciPosizione: 'inserisci indirizzo',
                manuale: 'manuale',
                miaPosizione: 'La mia posizione',
                noGps:
                    'Il GPS potrebbe essere spento o disabilitato, oppure ci si potrebbe trovare in una zona senza segnale.',
                nuovoIndirizzo: 'Nuovo indirizzo',
                portamiQui: 'Portami qui',
                posAttuale: 'posizione attuale',
                posNonDisponibile: 'Posizione non disponibile',
                posRilevata: 'La tua posizione rilevata è',
                posizioneNonDefinita: 'Posizione corrente non definita',
                precisione: 'Precisione',
                rilevaPosizione: 'rileva posizione',
                rilevamentoPosInCorso: 'Rilevamento posizione...',
                scarsa: 'Scarsa',
                searching: 'Sto localizzando...',
                segnaleDebole: 'segnale GPS debole',
                tuaPosizione: 'Ti trovi',
            },
            home: {
                all: 'Tutte',
                en: 'inglese',
                gps: 'da gps',
                it: 'italiano',
                manual: 'indirizzo',
                manualdialog: {
                    header: 'indirizzo',
                    placeholder: 'inserisci indirizzo',
                },
                optionsdialog: {
                    header: 'opzioni',
                },
                search: 'cerca nei dintorni',
            },
            iccrea: {
                cambiaZona: 'Cambia zona',
                homeTitle: 'CartaBCC Club<br />ti dà il benvenuto a <b>{0}</b>',
                hometitleNoPos: 'CartaBCC Club<br />ti da il benvenuto',
                serviziTuttaItalia: 'I nostri servizi sono attivi in tutta Italia.',
                tutorial: {
                    subtitle1: 'Tutti i servizi più utili per risparmiare tempo e denaro in un click.',
                    subtitle2: 'Paghi solo i minuti effettivi senza bisogno delle colonnine per il parcheggio.',
                    subtitle3: 'Scopri gli sconti e i coupon dedicati nei negozi intorno a te.',
                    subtitle4: "Acquista l'abbonamento e i biglietti del treno o de lbus tramite app senza più file.",
                    subtitle5:
                        "Puoi accedere direttamente con le credenziali di CartaBCC, effettuando il login dall'app MyCartaBCC.",
                    subtitle6:
                        "Ricarica il borsellino dell'app con CartaBCC o Satispay e paga con un semplice click tutti i servizi sul territorio!",
                    title1: 'CartaBCC sempre al tuo fianco!',
                    title2: 'Risparmia sul parcheggio',
                    title3: 'La convenienza dello shopping con CartaBCC!',
                    title4: 'Prendere un treno o un autobus non è mai stato così semplice!',
                    title5: 'Non è necessario registrarsi!',
                    title6: 'Ricarica il tuo credito',
                },
            },
            inserimentoPin: {
                placeholder: '5 cifre',
            },
            insiel: {
                centralinoUffici: 'Centralino Uffici Villa Chiozza tel',
                infoPrezziBiglietti: 'Info prezzi biglietti',
                luoghi: 'Luoghi e Territorio',
                mobilitaRegione: 'Mobilità in Regione',
                progetto:
                    'Progetto cofinanziato dall\'Unione Europea con il POR FESR 2007- 2013 – attività 3.2.b "Sviluppo servizi informatici avanzati per il sistema turismo"',
                scopriEventi: 'Scopri tutti gli Eventi',
            },
            isosta: {
                abb: {
                    abbonamenti: 'Agevolazioni / Abbonamenti',
                    abbonamentiSubTitle: 'Giornalieri e Abbonamenti',
                    abbonamento: 'Agevolazione / Abbonamento',
                    acquista: 'Acquista',
                    acquistoAbbonamenti: 'Acquisto',
                    attivi: 'Attive',
                    cambioTargaFail: 'Cambio targa non effettuato',
                    cambioTargaSuccess: 'Cambio targa effettuato con successo',
                    campoNonValido: 'I campi evidenziati in rosso hanno un valore non valido',
                    campoObbligatorio: 'I campi evidenziati in rosso sono obbligatori',
                    caricaAbbonamentiErroreTesto: 'Errore : Impossibile caricare gli abbonamenti',
                    caricaAbbonamentiErroreTitolo: 'Carica Abbonamenti',
                    categoriaAbbonamento: 'Category',
                    confermaAcquistoAbbSovrapposto: "Vuoi comunque procedere con l'acquisto?",
                    dataFineValidita: 'Fino al:',
                    dataInizioValidita: 'Valido dal:',
                    datiAggiuntivi: 'Dati Aggiuntivi:',
                    datiIncompleti:
                        "Dati abbonamento incompleti. Prova a riaprire l'abbonamento, o contatta l'assistenza se il problema persiste!",
                    erroreCambioTargaListaAbb:
                        'Cambio targa effettuato, ma non è possibile recuperare gli abbonamenti localmente. Si verrà quindi rimandati alla pagina principale degli abbonamenti.',
                    failAcquistoAbb: "Acquisto abbonamento fallito! Si prega di contattare l'assistenza",
                    infoTipologiaNonAcquistabileDaUtente:
                        'Il tuo utente è sprovvisto dei necessari permessi e autorizzazioni per acquistare questa tipologia di abbonamento.',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Una volta completato l\'acquisto per scaricare il titolo, entra nella sezione "Agevolazioni" ed aggiorna l\'elenco',
                    noAbbInCorsoDiValidita: 'Non sono stati trovati abbonamenti / agevolazioni in corso di validità',
                    noAbbNonAttivi: 'Non sono stati trovati abbonamenti / agevolazioni non ancora attivi',
                    noAbbScaduti: 'Non sono stati trovati abbonamenti / agevolazioni scaduti',
                    noAgevolazioni: 'Non hai ancora agevolazioni o abbonamenti.',
                    noAgevolazioniZtl: 'Non hai ancora alcun titolo ZTL.',
                    noZtlInCorsoDiValidita: 'Non sono stati trovati permessi in corso di validità',
                    noZtlNonAttivi: 'Non sono stati trovati permessi non ancora attivi',
                    noZtlScaduti: 'Non sono stati trovati permessi scaduti',
                    nonAcquistabile: 'Abbonamento non acquistabile',
                    nonAncoraAttivi: 'Non attivi',
                    oraFineValidita: 'Alle ore:',
                    oraInizioValidita: 'Dalle ore:',
                    ore: ' ore ',
                    oreMeno: ' - ore ',
                    scaduti: 'Scadute',
                    scegliComuneAreaSosta: 'Seleziona il comune',
                    scegliTipoAbbonamento: 'Scegli la tipologia...',
                    scegliTitolo: 'Seleziona il Titolo',
                    scegliVeicolo: 'Scegli il veicolo',
                    successAcquistoAbb: 'Acquisto concluso con successo!',
                    tipoAbbonamento: 'Tipo',
                    tipologiaNonAcquistabileDaUtente: 'Tipologia di abbonamento non acquistabile da questo utente.',
                    validitaAbbonamento: 'Validità',
                    warnAbbSovrapposto: 'Hai già alcuni titoli validi nel periodo indicato:',
                },
                accettoCondizioniTerminiServizio: 'Accetto <action>le Condizioni e i Termini del Servizio</action>',
                affinaRicerca: 'Prova ad inserire un indirizzo più preciso...',
                attivaServizio: 'Attiva servizio',
                attivaServizioTesto: 'Per sostare è necessario inserire i dati di un veicolo',
                attivazioneAccediPreferenzeAziendaHtml:
                    'Accedi con un PC all\'area riservata su <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span>, sezione dati anagrafici, quindi compila i dati necessari per essere registrato come azienda/professionista e ricevere fattura/ricevuta.',
                attivazioneAccediPreferenzeAziendaTitle: "Sei un'azienda/professionista?",
                attivazioneAccediPreferenzeHtml:
                    'Per stabilire come pagare, gestire le tue preferenze sosta o richiedere fattura, entra nel tuo profilo.',
                attivazioneAccediPreferenzeTitle: 'Gestisci le tue preferenze',
                attivazioneCompletata: 'Hai attivato il servizio "{0}"',
                attivazioneCompletataInfo: '',
                attivazioneCompletataInfo1: '<i><b class="underline">Ricarica il tuo credito</b></i>',
                attivazioneCompletataInfo2: '<i> ed inizia a sostare pagando solo i minuti effettivi.</i>',
                attivazionePromemoriaHeader: 'Non dimenticare di ricaricare il Credito Sosta',
                attivazionePromemoriaText: 'Per parcheggiare sarà necessario ricaricare il tuo Credito Sosta',
                autoricarica: {
                    erroreCaricamento:
                        'Si è verificato un errore. Non è stato possibile caricare i dati, riprova più tardi',
                    erroreSalvataggio:
                        'Si è verificato un errore. Non è stato possibile salvare le modifiche, riprova più tardi',
                    infoAutoricarica:
                        'Il servizio consente di ricaricare automaticamente il tuo credito quando scende al di sotto di una soglia da te impostata.',
                    labelAttiva: 'Attiva autoricarica',
                    labelCartaDiCreditoNecessaria:
                        'Per utilizzare questo servizio è necessario memorizzare una Carta di Credito.',
                    labelDisattiva: 'Disattiva autoricarica',
                    labelProcedi: 'Procedi',
                    labelSaldoInferioreA: 'Quando il saldo è inferiore a',
                    labelTaglioRicarica: 'Effettua una ricarica di',
                    titolo: 'Autoricarica',
                },
                avvisoInizioSostaDomani:
                    'Se non termini o prolunghi prima la sosta, questa verrà chiusa automaticamente <span class="bold">domani</span> alle <span class="bold">{0}</span>',
                avvisoInizioSostaIl:
                    'Se non termini o prolunghi prima la sosta, questa verrà chiusa automaticamente il <span class="bold">{0}</span> alle <span class="bold">{1}</span>',
                avvisoInizioSostaOggi:
                    'Se non termini o prolunghi prima la sosta, questa verrà chiusa automaticamente <span class="bold">oggi</span> alle <span class="bold">{0}</span>',
                calendar: {
                    aggiungiPromemoria: 'Aggiungi promemoria',
                    askAggiungiPromemoria:
                        'Vuoi che il tuo smartphone ti ricordi la scadenza del periodo di sosta 15 minuti prima della scadenza?',
                    nonAggiungere: 'Non aggiungerlo',
                    procedi: 'Procedi',
                    text:
                        'Un promemoria verrà aggiunto al tuo calendario. Ti avviserà 15 minuti prima della scadenza della sosta.',
                    title: 'Aggiungere promemoria?',
                },
                caricaAltrePromozioni: 'Carica altre promozioni',
                cercaLocalita: 'Cerca località',
                codiceStallo: 'Codice stallo',
                codiceStalloPlaceholder: 'Inserisci il codice dello stallo',
                condizioniServizio: 'Condizioni e Termini del Servizio',
                countdownPagamento: 'Hai {0} secondi per procedere al pagamento',
                daConfermareEntro: 'Da confermare entro',
                dettaglioPrenotazione: {
                    annulla: 'Annulla prenotazione',
                    cognome: 'Cognome',
                    confermaAnnulla: 'Sei sicuro di voler annullare la prenotazione?',
                    cosaFare: 'Cosa devo fare?',
                    datiAggiuntivi: 'Dati aggiuntivi',
                    email: 'E-mail',
                    erroreAnnulla: 'Impossibile annullare la prenotazione',
                    importo: 'Importo',
                    importoSosta: 'Importo sosta',
                    importoTotale: 'Totale pagato',
                    indirizzo: 'Indirizzo',
                    intestazioneInfoPrenotazione: 'Info prenotazione',
                    messaggioInformativoSostaAttiva:
                        "Per terminare la sosta recati all'autorimessa e richiedi l'uscita del veicolo. Ti verrà addebitato solo il costo della sosta in base all'orario di ingresso effettivo secondo la tariffazione vigente.",
                    messaggioInformativoSostaPrenotata:
                        "Mostra la prenotazione al gestore per accedere al parcheggio. In caso di ingresso prima dell'orario prenotato o di uscita oltre il termine previsto nell'ordine di ore 4 (quattro), il prezzo sarà aumentato di conseguenza.",
                    modelloVeicolo: 'Modello del veicolo',
                    nome: 'Nome',
                    nonSpecificato: 'Non specificato',
                    numeroPasseggeri: 'Passeggeri',
                    numeroVolo: 'Numero volo',
                    provenienzaVolo: 'Provenienza volo',
                    serviziAggiuntivi: 'Servizi aggiuntivi',
                    sitoWeb: 'Sito web',
                    targa: 'Targa',
                    telefono: 'Telefono',
                    titolo: 'Prenotazione',
                },
                disambiguaDescrizione:
                    "Abbiamo trovato più aree di sosta attorno alla tua posizione. Seleziona l'area in cui ti trovi, consultando la segnaletica verticale o il parcometro più vicino.",
                disambiguaHeading: 'Zone di sosta multipla',
                disambiguaLabel: 'Scegli dove sostare',
                disambiguaTitolo: 'Zone di sosta multipla',
                durataSosta: 'Durata sosta:',
                elencoMovimenti: 'Elenco Movimenti',
                elencoParcheggi: 'Elenco Parcheggi',
                findMyCar: {
                    aggiungiPosizione: 'Aggiungi',
                    cancellaPosizione: 'Cancella questa posizione',
                    cancellaPosizioneTesto:
                        'Vuoi cancellare questa posizione? Questa operazione non è annullabile e non disattiverà eventuali soste attive.',
                    cancellaPosizioniTesto:
                        'Vuoi cancellare le posizioni memorizzate? Questa operazione non è annullabile e non disattiverà eventuali soste attive.',
                    clean: 'Pulisci',
                    erroreSalvataggio:
                        'Si è verificato un errore durante il salvataggio della posizione. Per favore, riprova.',
                    header: 'Trova la mia auto',
                    inserisciPosizione: 'Inserisci indirizzo...',
                    nessunaPosizioneSalvata: 'Nessuna auto in sosta',
                    oppureUsaMappa: 'Oppure premi sulla mappa:',
                    posizione: 'Posizione',
                    posizioni: 'Posizioni',
                    posizioniRecenti: 'Recenti',
                    posizioniSalvate: 'Elenco Posizioni',
                    pulisci: 'Pulisci',
                    pulisciPosizioni: 'Pulisci posizioni',
                    pulisciQuestaPosizione: 'Pulisci questa posizione',
                    salvaPosizione: 'Conferma',
                    targaOrDescrizione: 'Targa o descrizione',
                    whereIsMyCar: "Dov'è la mia auto?",
                },
                fineSosta: 'Fine Sosta',
                finoA: 'Fino a',
                fraBrevePotraiRipetere: "Fra breve potrai ripetere l'operazione...",
                gestioneCarte: {
                    aggiungiCarta: 'Aggiungi Carta',
                    confermaEliminazione: 'Vuoi rimuovere la carta di credito che termina per',
                    scaduta: 'Scaduta',
                    titolo: 'Carte di Credito',
                },
                importoSosta: 'Importo Sosta',
                importoSostaAttuale: 'Importo Sosta Attuale',
                importoSostaPrevisto: 'Importo previsto',
                indirizzoZona: 'Cerca per via o zona di sosta',
                infoMemoComunePreferito:
                    'Se scegli di memorizzare la città indicata, questa verrà selezionata ogni volta che myCicero non riesce a recuperare la tua posizione.',
                infoStalloLabel: 'Dove trovo il numero di stallo?',
                ingressoAlleOre: 'Ingresso alle ore:',
                inizioSosta: {
                    altreZoneDiSosta: 'Altre zone di sosta',
                    askRegistraPosizione:
                        'Grazie al GPS ho rilevato la posizione precisa della tua auto. Vuoi registrarla in modo da ritrovarla con facilità?',
                    avvisoDisattivazioneAutomaticaSosta: 'La sosta verrà disattivata automaticamente',
                    avvisoTermineSosta: 'La sosta verrà terminata',
                    calcoloImporto: 'Calcolo importo',
                    confermaInizioSosta: 'Conferma Inizio Sosta',
                    finePrevistaMediaHide: 'Fine Prevista:',
                    finoQuando: 'Fino a quando vuoi sostare?',
                    impossibileCalcolareImporto: "Errore : Impossibile completare il calcolo dell'importo",
                    infoCoupon: 'Come funziona?',
                    infoCouponNoLogin: 'Hai un coupon? Effettua il login per inserire il codice',
                    infoLimiteTariffario: 'In questa area di sosta non è consentito sostare oltre:',
                    infoPrezzoTariffario: "L'importo tariffario ti permette di sostare comunque fino a:",
                    infoTariffeSu: 'Info e tariffe su ',
                    iniziaSosta: 'Inizia Sosta',
                    inizio: 'Inizio:',
                    noParcheggiRecenti: 'Non sono presenti parcheggi recenti',
                    noParkingsInAddress:
                        'Non abbiamo trovato aree di sosta coperte dal servizio corrispondenti alla tua ricerca.',
                    noParkingsInCity: 'Nel comune selezionato non sono presenti zone adibite al parcheggio',
                    noParkingsInCitySeason:
                        'Nel comune selezionato la sosta ha tariffazione stagionale. Al momento non sono presenti aree di sosta a pagamento coperte dal nostro servizio.',
                    parcheggiRecenti: 'Parcheggi Recenti',
                    placeholderCoupon: 'Inserisci il codice del tuo Coupon',
                    promozioniIntornoATe: 'Promozioni intorno a te',
                    recenti: 'Recenti',
                    registraPosizione: 'Registrazione posizione',
                    registraPosizioneAuto: 'Memorizza posizione auto',
                    salvaPosizionePrefix: 'Salva la posizione GPS attualmente rilevata',
                    salvaPosizioneShort: "Ricorda la posizione dell'auto per questa sosta",
                    salvaPosizioneSuffix: 'come posizione del veicolo per questa sosta',
                    scegliParcheggio: 'Scegli Parcheggio',
                    scopriCoupon: 'Vuoi sostare gratis? Scopri come!',
                    scopriCoupon1: 'Vuoi sostare gratis?',
                    scopriCoupon2: 'Scopri come...',
                    success: 'Inizio sosta registrato correttamente',
                },
                inizioSostaAutorimesse: {
                    avviaNavigatore: 'Avvia navigatore',
                    cercaPerNomeIndirizzo: 'Cerca per indirizzo o nome',
                    chiudereSosta:
                        "Per chiudere la sosta recati all'autorimessa e richiedi l'uscita del veicolo.<br/>Ti verrà addebitato solo il costo della sosta in base all'orario di ingresso effettivo secondo la tariffazione vigente.",
                    cittaNonSupportata:
                        'La città in cui ti trovi non è supportata, abbiamo scelto quella supportata più vicina.',
                    creditoInsufficiente:
                        'Il tuo credito non è sufficiente per effettuare la sosta. Per sostare devi ricaricare il tuo credito sosta.',
                    dataOraPerPreventivo: 'Prevedi di sostare da adesso alle:',
                    durataEccessiva: 'Preventivo costo non calcolabile per soste superiori a 7 giorni',
                    elencoStrutture: 'Elenco strutture',
                    emissioneFattura:
                        'Se richiesta, la fattura generata da MyCicero non include l’importo corrisposto direttamente al gestore dell’autorimessa ma solo quello pagato tramite la piattaforma stessa.',
                    finePrevista: 'Fine prevista:',
                    importoTotale: 'Importo totale per questa durata:',
                    infoTariffe:
                        "La tariffa in vigore presso l'autorimessa non è frazionabile per i minuti effettivi di sosta ma prevede solo ore intere",
                    iniziaSostaEntroTrentaMin:
                        'La richiesta di sosta verrà cancellata automaticamente se non accedi al parcheggio entro 30 minuti. Non sarà addebitato nessun costo.',
                    inizioSosta: 'Inizio sosta:',
                    inizioSostaRichiesto: 'Richiesta inizio sosta inoltrata correttamente.',
                    noResult: 'La ricerca non ha prodotto risultati',
                    parcheggioAlCompleto: 'Parcheggio chiuso',
                    ricaricaIlBorsellino:
                        'Ricarica il borsellino se vuoi pagare l’intero importo con MyCicero altrimenti corrisponderai la differenza all’operatore dell’autorimessa.',
                    richiediInizioSosta: 'Richiedi inizio sosta',
                    sostaSaraAttivata:
                        "La sosta sarà attivata quando l'operatore al parcheggio verificherà il tuo ingresso. L'orario impostato non è vincolante per l'uscita dal parcheggio e sarà comunque possibile terminare la sosta in anticipo. Verrà addebitato il costo in base all'orario di ingresso effettivo secondo la tariffazione vigente.",
                    statoSosta: {
                        attiva: 'Sosta attiva',
                        conclusa: 'Sosta conclusa',
                        inAttesa: 'Scadenza entro: ',
                    },
                },
                insertCode: {
                    confirmDescription:
                        "Scannerizza con il tuo smartphone il codice stampato sul fronte del biglietto per visualizzare l'importo da pagare",
                    confirmTitle: 'Hai un biglietto sosta prelevato da un parcheggio in struttura?',
                    description:
                        "Inserisci il codice stampato sul fronte del biglietto per visualizzare l'importo da pagare",
                    nonMostrarePiu: 'Non mostrare più questo messaggio',
                    okGoOn: 'Ok, vai avanti',
                    placeholder: 'Inserisci il codice del biglietto',
                    title: 'Hai un biglietto sosta prelevato da un parcheggio in struttura?',
                    verifica: 'Verifica',
                },
                laMiaAuto: 'La mia auto',
                map: {
                    areaNonServitaDaTitle: 'Area non servita da {0}',
                    areaNonServitaDesc:
                        'Verifica se la zona è a pagamento sulla segnaletica verticale o nel parcometro più vicino.',
                    areaNonServitaHtml:
                        'Per informazioni contattaci allo <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> o <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">via chat</a>',
                    areaNonServitaTitle: 'Area non servita',
                    avviaNavigatore: 'Avvia navigatore',
                    cambiaCitta: 'Cambia città',
                    caricamentoCompletato: 'Caricamento completato!',
                    caricamentoLento: 'Il caricamento sta impiegando più tempo del previsto...',
                    caricamentoMappa: 'Caricamento mappa...',
                    cercaIndirizzo: 'Cerca indirizzo',
                    disclaimerBtnText: 'Ho capito',
                    disclaimerText: 'Assicurati di indicare esattamente dove il tuo veicolo è posizionato',
                    ingrandisciMappa: 'Aumenta lo zoom per individuare la zona di sosta',
                    localitaSconosciuta: 'Località sconosciuta',
                    mappaSosta: 'Mappa sosta',
                    noIsostaLayer: 'Impossibile recuperare le zone abilitate',
                    posizioneAmbiguaTemplateString:
                        'La posizione corrente è a cavallo di {0} aree di sosta diverse. Seleziona quella in cui ti trovi:',
                    postiLiberi: 'Posti liberi',
                    postoLibero: 'Posto libero',
                    ricercaHeaderTemplate: 'Cerca a {0}',
                    ricercaLocalitaInCorso: 'Ricerca località in corso...',
                    ricercaPlaceholder: 'Indirizzo, luoghi, punti di interesse...',
                    scegliPosizione: "Tocca un'area di sosta...",
                    staiVedendo: 'Stai vedendo:',
                    zonaImprecisa:
                        'Verifica la correttezza della zona di sosta sulla segnaletica verticale o nel parcometro più vicino',
                    zonaNonCoperta:
                        'In {0} al momento non ci risultano zone a pagamento.<br/>In caso di dubbio, contattaci allo <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> o <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">via chat</a>',
                    zonaSenzaParcheggi: 'Qui al momento non ci sono zone a pagamento. Ti risulta il contrario?',
                },
                memorizzaComunePreferito: 'Memorizza come Città Abituale',
                minuti: 'minuti',
                minuto: 'minuto',
                modalitaPagamento: {
                    attivaPagamentoContestuale: 'Attiva pagamento a consumo',
                    erroreCaricamento:
                        'Si è verificato un errore. Non è stato possibile caricare i dati, riprova più tardi',
                    erroreNessunaCartaDiCredito:
                        'Per attivare il pagamento contestuale devi registrare una carta di credito',
                    erroreSalvataggio:
                        'Si è verificato un errore. Non è stato possibile salvare le modifiche, riprova più tardi',
                    infoCostiPagamentoContestuale:
                        'Prevede l’addebito dell’importo della singola sosta direttamente sulla Carta di Credito registrata. Questo servizio prevede <b>un costo aggiuntivo di € 0,08</b> per ogni sosta con un importo minimo della transazione pari a € 0,20.',
                    infoCostiPagamentoContestualeActv:
                        'Prevede l’addebito dell’importo della singola sosta direttamente sulla Carta di Credito registrata.',
                    infoCostiPagamentoContestualeRoger:
                        'Prevede l’addebito dell’importo della singola sosta direttamente su carta di credito registrata.',
                    infoCredito:
                        'Il tuo credito, caricandolo tramite Carta di Credito, Satispay, PayPal o recandoti presso un punto vendita abilitato SisalPay. <b>Questa modalità NON prevede costi aggiuntivi.</b> Il credito può essere usato anche per acquistare titoli di viaggio e per tutti gli altri servizi disponibili.',
                    infoCreditoACTV:
                        '<b>Questa modalità NON prevede costi aggiuntivi.</b> Il credito può essere usato anche per acquistare titoli di viaggio e per tutti gli altri servizi disponibili.',
                    infoCreditoRoger:
                        'Il tuo credito, caricandolo tramite Carta di Credito. Il credito può essere usato anche per acquistare titoli di viaggio e per tutti gli altri servizi disponibili.',
                    labelCartaDiCreditoNecessaria:
                        'Per utilizzare questo servizio è necessario memorizzare una Carta di Credito.',
                    labelCredito: 'Credito',
                    labelModalita: 'Paga ogni sosta con:',
                    labelNoCarteRegistrate: 'Non hai carte registrate.',
                    labelPagamentoContestuale: 'Pagamento contestuale',
                    labelProcedi: 'Procedi',
                    labelRegistraCarta: 'Registra una carta',
                    labelRicarica: 'Ricarica',
                    labelSaldo: 'Saldo credito',
                    labelScegliCartaDiCredito: 'Scegli la Carta di Credito tra quelle registrate:',
                    labelUtilizzaQuestaCarta: 'Utilizza questa carta di credito registrata:',
                    titolo: 'Come pagare',
                },
                mostraParcheggi: 'Mostra Parcheggi',
                numeroStallo: 'Numero Stallo',
                ongoingNotification: {
                    extendButtonLabel: 'Prolunga 30 min',
                    message: 'fino alle {0}',
                    stopButtonLabel: 'Termina',
                    title: '{0} in sosta',
                },
                oopsAnnullaSosta: 'Oops! Annulla sosta.',
                parcheggiGestiti: {
                    avvisoDurataPrenotazione:
                        'La prenotazione verrà eliminata automaticamente alla scadenza del periodo selezionato',
                    avvisoOrarioNonConsentito:
                        'L’orario di arrivo al parcheggio dovrà essere compreso tra le {0} e le {1} in base al regolamento applicato nella struttura selezionata.',
                    avvisoSostaNonDisponibile:
                        'Non è possibile prenotare il parcheggio per le date selezionate, riprovare inserendo date diverse',
                    avvisoTermineSosta: 'Il servizio termina alle <span class="bold">{0}</span>.',
                    cantAddService:
                        'Non è stato possibile inserire iseguenti servizi richiesti: <ul><% _.forEach(articlesKo, function(article) { %> <li><%- article.descArticolo %></li> <% }); %></ul>',
                    cercaAeroportoLocalita: 'Cerca per nome o località',
                    cercaAeroportoTitle: 'Scegli luogo',
                    cercaPlaceholder: 'Cerca per nome o località',
                    condizioni: 'Dichiaro di aver preso visione e di accettare le <em>condizioni di servizio</em>',
                    confermaConPagamento: 'Prenota e paga ora',
                    confermaSenzaPagamento: 'Prenota e paga a fine sosta',
                    dataInizioSostaNonConsentita: 'Non è possibile prenotare il parcheggio prima del {0} alle ore {1}',
                    erroreAggiornamentoPrezzi:
                        'Non è stato possibile aggiornare il totale per i giorni selezionati. Riprova più tardi.',
                    erroreGenericoDisponibilita:
                        "La verifica della disponibilità del parcheggio con il gestore non è andata a buon fine. Riprova in un secondo momento o contatta l'assistenza.",
                    importoPagato: 'Importo pagato',
                    importoTotaleDurata: 'Importo totale per questa durata',
                    info: {
                        mail: 'Mail',
                        orarioAp: 'Orari di apertura',
                        servizi: 'Servizi inclusi',
                        sitoWeb: 'Sito Web',
                        social: 'Social',
                        telefono: 'Telefono',
                        tipo: 'Tipo',
                        tipoPosti: 'Tipologia posti',
                    },
                    infoDesigna:
                        'Mostra il QR code alla colonnina di accesso del parcheggio. Ricordati di ritirare il ticket cartaceo rilasciato dalla colonnina per l’uscita dal parcheggio o per corrispondere l’eventuale differenza alla cassa, nel caso di uscita al di fuori del periodo prenotato.',
                    infoPrenotazioneEffettuata:
                        'Puoi trovare la prenotazione del parcheggio nella sezione “Sosta e ZTL”',
                    intestazionePrenotazione: 'Prenotazione di 1 posto auto per la targa',
                    istruzioniDownloadTitoli:
                        'Una volta completato l\'acquisto, troverai la prenotazione nella sezione "Sosta" dell\'app',
                    menuTitle: 'Parcheggi gestiti',
                    nessunParcheggioRecente: 'Non sono presenti parcheggi recenti',
                    nessunRisultato: 'La ricerca non ha prodotto nessun risultato',
                    parkAvail: 'Il parcheggio è disponibile.',
                    parkNotAvail: 'Nelle date specificate il parcheggio è al completo.',
                    placeholderRicercaTestuale: 'Cerca per nome',
                    postiNonPrenotabili: '{0} posti liberi',
                    postiNonPrenotabiliEsauriti: 'Nessun posto libero',
                    prenota: 'Prenota',
                    prenotaParcheggio: 'Prenota parcheggio',
                    prenotazioneSosta: 'Prenotazione sosta',
                    richiediDisponibilita: 'Richiedi disponibilità',
                    scegliParcheggioTitle: 'Scegli parcheggio',
                    tabCondizioni: 'Condizioni',
                    tabElenco: 'Elenco',
                    tabInfo: 'Info',
                    tabMappa: 'Mappa',
                    tabRecenti: 'Recenti',
                    tabTariffe: 'Tariffe',
                    titleConferma: 'Prenota sosta',
                    titleConfermata: 'Prenotazione confermata',
                    titleDettaglio: 'Dettaglio',
                    titlePrenota: 'Prenota sosta',
                    tutteLeAree: 'Tutte le località',
                    vaiAllaPrenotazione: 'Vai alla prenotazione',
                    verificaDisponibilita: 'Verifica disponibilità',
                    verificaDisponibilitaInCorso: 'Stiamo contattando il gestore del parcheggio',
                    visualizzaPrenotazione: 'Visualizza Prenotazione',
                },
                parcheggio: 'Parcheggio',
                posizioneNonDisponibile: 'Non riesco a determinare la tua posizione',
                preferenzeSosta: {
                    categorieAgevolate: 'Categorie agevolate gestite',
                    disclaimerCategorieSosta:
                        "L'utente si assume la responsabilità di quanto dichiarato, ai sensi delle normative di legge",
                    erroreSalvataggio:
                        'Si è verificato un errore. Non è stato possibile salvare le modifiche, riprova più tardi',
                    etichettaDurataDueOre: '120 minuti',
                    etichettaDurataFineGiornata: 'Fine giornata',
                    etichettaDurataQuattroOre: '240 minuti',
                    etichettaDurataUnOra: '60 minuti',
                    infoAreaNotifiche:
                        'Prolunga e termina la sosta con un clic direttamente dall’ Area Notifiche del tuo dispositivo.',
                    infoCategorieUtente:
                        'In alcune città sono previste delle agevolazioni tariffarie per particolari categorie. Se rientri in una di queste, attiva la relativa voce per usufruire delle tariffe a te riservate.',
                    infoCittaAbituale:
                        'Questa città verra automaticamente selezionata quando non è possibile recuperare la posizione via GPS.',
                    infoDurataSosta:
                        'I minuti impostati verranno utilizzati in fase di attivazione sosta per proporre la durata prevista.<br/>L\'opzione "Fine giornata" vuol dire che il termine sosta sarà impostato uguale all\'orario di fine pagamento della zona scelta oppure fino ad esaurimento del credito disponibile, se questo non è sufficiente per arrivare a fine giornata',
                    infoNotificheSms:
                        'Il costo del servizio è di € 0,08 per SMS ricevuto.<br/>Se attivi e termini la sosta tramite SMS le notifiche sono automatiche e non possono essere disattivate.',
                    labelAreaNotifiche: 'Notifiche dispositivo',
                    labelAttiva: 'Attiva',
                    labelCittaAbituale: 'Città abituale:',
                    labelDurataSosta: 'Durata sosta proposta:',
                    labelInLista: 'In lista',
                    labelInMappa: 'In mappa',
                    labelNotificheSms: 'Conferma Sosta SMS',
                    labelScegli: 'Scegli',
                    labelSmsFineSosta: 'Conferma fine sosta',
                    labelSmsInizioSosta: 'Conferma inizio sosta',
                    labelVisualizzazioneCercaParcheggio: 'Quando cerchi il parcheggio preferisci la visualizzazione',
                    mieCategorie: 'Le mie categorie agevolate',
                    titolo: 'Preferenze Sosta',
                },
                prenotazioneDal: 'Prenotazione dal',
                procedi: 'Procedi',
                prolunga: 'Prolunga',
                prolungaSosta: 'Prolunga Sosta',
                prolungaSostaFail: 'Impossibile prolungare la sosta',
                prolungaSostaSuccess: 'Prolungamento sosta registrato correttamente',
                qrCode: {
                    accediEntroLeOre: 'Accedi entro le ore',
                    accediPagaAllUscita: "Vuoi accedere al parcheggio ora e pagare all'uscita?",
                    entraNelParcheggio: 'Entra nel parcheggio',
                    erroreGenerazioneQrCode: 'Si è verificato un errore durante la generazione del QR Code',
                    esciDalParcheggio: 'Esci dal parcheggio',
                    esciDalParcheggioScansionaQrCode:
                        "Recati all'uscita del parcheggio e scansiona il QR Code alla sbarra",
                    infoIngressoQrCode:
                        "<span class='bold'>Scansiona</span> il <span class='bold'>QR Code</span> alla colonnina d'ingresso e ritira il ticket. Ricordati che hai <span class='bold'>15 minuti</span> per entrare nel parcheggio.",
                    infoPagamentoClassico:
                        'In alternativa puoi pagare inserendo il ticket nella cassa automatica del parcheggio.',
                    infoUscitaQrCode:
                        "<span class='bold'>Paga dall'app</span> cliccando sul pannellino della <span class='bold'>sosta attiva</span>.</br><span class='bold'>Scansiona il QR Code</span> alla colonnina di uscita.",
                    ingressoEffettuatoAlleOre: 'Ingresso effettuato alle ore',
                    nuovoQrCode: 'Nuovo QR Code',
                    pagamentoClassico: 'Pagamento classico',
                    perEntrare: 'Per entrare',
                    perUscire: 'Per uscire',
                    qrCodeScaduto: 'Il tuo QR Code è scaduto, richiedine uno nuovo!',
                    tornaAllaSosta: 'Torna alla Sosta',
                    visualizzaQrCode: 'Visualizza QR Code',
                },
                reminderUscita: 'Ricordati che hai 15 minuti per uscire dal parcheggio dopo il pagamento.',
                ricaricaCredito: 'Ricarica Credito',
                ricaricaCreditoAssociaCarta: 'Ricarica il credito o associa Carta...',
                rifSosta: 'Rif. Sosta',
                salvaPosizione: 'Salva posizione',
                scegliArea: 'Seleziona la zona',
                scegliCitta: 'Scegli città',
                selezionaComune: 'Seleziona un comune:',
                selezionaFineSosta: "Seleziona l'orario previsto di fine sosta.",
                servizioNonAttivo: 'Non hai ancora attivato il servizio "Soste e ZTL". Ci vuole un attimo.',
                skidata: {
                    activateIn: 'Dovrai attivare il biglietto entro: ',
                    bsb: 'Biglietto Sosta Breve',
                    cassaAutomatica: 'Cassa automatica',
                    disambiguaStruttura: 'Seleziona il parcheggio',
                    emissioneFattura:
                        'Se richiesta, la fattura generata da MyCicero non include l’importo corrisposto direttamente al gestore dell’autorimessa ma solo quello pagato tramite la piattaforma stessa.',
                    expiredTicket: 'Biglietto Generato Scaduto.',
                    garage: 'Garage: ',
                    generationOk: 'Biglietto generato correttamente',
                    goToHome: 'Torna Alla Home',
                    infoStruttura:
                        'la sosta verrà attivata quando si utilizzerà il QR code per alzare la sbarra nel parcheggio. Verrà addebitato il costo in base all’orario di ingresso effettivo secondo la tariffazione vigente.',
                    labelHour: ' ora',
                    labelHours: ' ore',
                    labelMinute: ' min',
                    labelMinutes: ' min',
                    labelSecond: ' sec',
                    labelSeconds: ' sec',
                    pagamentoOk: 'Pagamento avvenuto con successo',
                    pagamentoOkDescHtmlTemplate:
                        'Il pagamento della sosta nel parcheggio <span class="bold">{0}</span> è stato completato con successo.',
                    parcheggiInStruttura: 'Parcheggi in Struttura',
                    remainingTime: 'Tempo rimanente: ',
                    scansioneBiglietto: 'Scansione biglietto',
                    statusActive: 'Sosta attiva',
                    statusExpired: 'Biglietto scaduto',
                    statusGenerated: 'Attivare la sosta entro:',
                    statusPaid: 'Uscire dal parcheggio entro:',
                    subscription: 'Abbonamento',
                },
                sosta: 'Sosta',
                sostaAPagamento: 'Strisce blu',
                sostaAutorimesse: 'Garage',
                sostaFinoA: 'Sosta fino a',
                sostaValidaFinoA: 'Sosta valida fino a',
                sosteAttive: 'Attiva/e',
                sosteParcheggi: 'Sosta e ZTL',
                sostePrenotate: 'Prenotazioni',
                stallo: 'Stallo:',
                stalloMancante: "E' necessario inserire il numero dello stallo",
                stalloNonValido: 'Numero stallo errato',
                stalloTargaUsataDiRecente: 'Hai già attivato una sosta su questa targa di recente.',
                stalloUsatoDiRecente: '',
                stalloX: 'Stallo {0}',
                talloncinoInviatoInfo: 'Il talloncino relativo a questa targa è stato inviato al tuo account email',
                targhe: {
                    aggiungi: 'Nuova targa',
                    attr: {
                        disponibile: 'Disponibile',
                        occasionale: 'Libera',
                        occupata: 'Utilizzata',
                        principale: 'Principale',
                        secondaria: 'Secondaria',
                    },
                    cambiaTarga: 'Cambia Targa',
                    conferma: 'Conferma',
                    confermaFormatoTarga:
                        'La targa inserita ha un formato diverso da quello standard. Vuoi procedere ugualmente?',
                    confermaIvioTalloncino: 'Operazione conclusa',
                    confermaRimozioneTarga: 'Vuoi eliminare definitivamente questa targa?',
                    descrizioneBreve: 'Descrizione breve',
                    erroreComuniTalloncino:
                        "Si è verificato un errore. Non è stato possibile recuperare l'elenco dellè città, riprova più tardi",
                    impossibileCambiareTarga: 'Non è possibile cambiare targa',
                    inUso: 'in uso',
                    infoCancellazioneTargaPrincipale: 'La targa preferita non può essere cancellata',
                    infoTalloncino: 'Riceverai una e-mail con il talloncino da esporre in ',
                    infoTalloncinoCitta: 'alcune città.',
                    infoTalloncinoObbligatorioParte1: "All'indirizzo ",
                    infoTalloncinoObbligatorioParte2:
                        ' verrà inviata una e-mail con il talloncino da esporre obbligatoriamente nei comuni di: ',
                    infoTargaPrincipale1:
                        'La <span class="bold">targa preferita</span> verrà proposta automaticamente ad ogni inizio sosta.',
                    infoTargaPrincipale2: 'Inoltre è utilizzata per i servizi SMS e NoCall.',
                    infoTargaPrincipaleInUso:
                        "La targa attualmente selezionata come preferita è in uso in questo momento, pertanto non puoi scegliere un'altra targa come preferita.",
                    infoTargaPrincipaleInUsoHeader: 'Targa preferita in uso',
                    infoTargaPrincipaleOwn:
                        'Questa è la <span class="bold">targa preferita</span>.<br/>Verrà proposta automaticamente ad ogni inizio sosta. Inoltre è utilizzata per i servizi SMS e NoCall.',
                    inserisciDatiTarga: 'Per utilizzare il servizio è necessario registrare i dati di un veicolo:',
                    inserisciTargaOccasionale: 'Inserisci la targa da utilizzare per questa sosta:',
                    inviaTalloncino: 'Invia talloncino',
                    limiteRaggiunto: 'Hai già raggiunto il numero massimo di targhe che è possibile registrare',
                    memorizza: 'Memorizza',
                    'memorizza e scegli': 'Memorizza e scegli',
                    modificaTarga: 'Modifica Targa',
                    nessunaTargaRegistrata: 'Nessuna targa',
                    noCallInfoTarga: 'Per i servizi "No Call/SMS" verrà sempre utilizzata questa targa.',
                    nuova: 'Nuova targa',
                    propostaDefault: 'proposta di default',
                    registraneUna: 'Registrane una',
                    registrazionePrimaTargaOk: 'Hai registrato la targa',
                    registrazioneTargaKo: 'Si è verificato un errore nella registrazione della targa',
                    registrazioneTargaOk:
                        'Modifiche apportate con successo.<br/>Il talloncino relativo a questa targa è stato inviato al tuo account email<br/>{0}',
                    rendiTargaPrincipale: 'Targa preferita',
                    rendiTargaPrincipaleKo: 'Non è stato possibile memorizzare questa targa come preferita.',
                    rimozioneTargaKo: 'Si è verificato un errore nella rimozione della targa',
                    rimozioneTargaOk: 'Targa rimossa con successo.',
                    rimuovi: 'Rimuovi Targa',
                    rules: {
                        accettaCondizioni: 'Devi accettare le condizioni e i termini del servizio',
                        troppoCorta: 'La targa deve contenere più di 3 caratteri',
                    },
                    salvaInviaTalloncino: 'Salva ed invia il talloncino',
                    scegliTarga: 'Seleziona una delle targhe associate per iniziare la sosta.',
                    scegliTargaShort: 'Personali',
                    targaNonValida: 'Targa non valida',
                    targaOccasionale: 'Targa occasionale',
                    targaPrincipale: 'Targa preferita',
                    targaSecondaria: 'Targa secondaria',
                    targaVeicolo: 'Targa veicolo',
                    targheRegistrate: 'Targhe Registrate',
                    targheSosta: 'Gestione Targhe',
                    targheSostaRegistra: 'Registra targa',
                    troppeTarghe: 'Attenzione! Non è gestito il caso in cui sono presenti più di 2 targhe!',
                },
                termina: 'Stop',
                terminaSosta: 'Termina Sosta',
                terminaSostaPrefix: 'Stai terminando la sosta',
                terminaSostaSuccess: 'Fine sosta registrata correttamente',
                terminaSostaSuffix: 'minuti prima della fine prevista',
                termineBreve: 'La sosta terminerà a breve',
                termineSpecifico: 'La sosta terminerà il {0} alle ore {1}',
                trovaLaMiaAuto: 'Trova la mia auto',
                ultimi30MovFinoAlGiorno: 'Ultimi 30 movimenti fino al giorno',
                usaMyCicero: 'Usa myCicero...',
                uscitaAlleOre: 'Uscita alle ore:',
                validaFinoA: 'Valida fino a',
                ztl: {
                    label: 'Permessi ZTL',
                    subtitle: 'Zone a Traffico Limitato',
                },
            },
            lardini: {
                aggiornamentoRisultatiInCorso: 'Aggiornamento risultati in corso',
                catalogoBuoni: 'Catalogo Buoni',
                classifica: 'Classifica',
                infoGiornataCampionato: '{0}° Giornata - {1}',
                inizioAlle: 'Inizio alle: {0}',
                livescore: 'Livescore',
                mondoLardiniFilottrano: 'Il mondo Lardini Filottrano',
                parcheggiaCon: 'Parcheggia con',
                partiteDel: 'Partite del {0}',
                partiteLive: 'Le Partite LIVE',
                rilasciaPerAggiornare: 'Rilascia per aggiornare i risultati',
                scopriNovita: 'Scopri le novità',
                scorriVersoIlBassoPerAggiornare: 'Scorri verso il basso per aggiornare i risultati',
                sponsor: 'Sponsor',
                tableClassifica: {
                    labelSquadre: 'Nome squadra',
                    partiteGiocate: 'Partite giocate',
                    partiteGiocateShort: 'PG',
                    partitePerse: 'Partite perse',
                    partitePerseShort: 'PP',
                    partiteVinte: 'Partite vinte',
                    partiteVinteShort: 'PV',
                    punti: 'Punti',
                    puntiShort: 'PT',
                    setPersi: 'Set persi',
                    setPersiShort: 'SP',
                    setVinti: 'Set vinti',
                    setVintiShort: 'SV',
                },
                viaggiaCon: 'Viaggia con',
                visualizzaParzialiSet: 'Visualizza parziali set',
            },
            lecceclick: {
                bagniPubblici: 'Bagni pubblici',
                colonnineAutoEnel: 'Colonnine auto Enel',
                defibrillatori: 'Defibrillatori',
                esperienze: 'Esperienze',
                fontanelleAcquaPotabile: 'Acqua potabile',
                giochi: 'Giochi',
                gioco: '',
                infoProgettoEuropeo:
                    'Progetto finanziato dall’Unione Europea sul P.O.R. Puglia 2014-2020, Fondo FESR, Azione2.2',
                itinerari: 'Itinerari',
                parcheggiPubbliciPrivati: 'Parcheggi pubblici privati',
                runninCity: "Runnin'City",
                servizi: 'Servizi',
                wifiHotspot: 'Wifi hotspot',
            },
            media: {
                acquisisciImmagine: "Acquisisci un'immagine",
                fotocamera: 'Fotocamera',
                gallery: 'Immagini salvate',
                importaGallery: "Importa un'immagine salvata",
                scattaFoto: 'Scatta una foto',
                sceltaFotoGallery: 'Vuoi scattare una foto oppure importare una delle tue immagini salvate?',
            },
            mobilita: {
                acquistaDiNuovo: 'Acquista di nuovo',
                acquistiRecenti: 'Acquisti recenti',
                biglietteria: 'Biglietteria',
                cercaFermata: 'Cerca fermata',
                cercaIndirizzo: 'Cerca per indirizzo',
                cercaLinea: 'Cerca linea',
                cercaPerCodice: 'Cerca per codice',
                cercaPerCodiceOrDescrizioneFermata: 'Codice o descrizione fermata',
                cercaPerCodiceOrDescrizioneLinea: 'Cerca per codice o descrizione',
                cercaPerFermata: 'Cerca per fermata',
                cercaPerNumero: 'Cerca per numero',
                cercaPerStazione: 'Cerca per stazione',
                cercaStazione: 'Cerca stazione',
                cercaTreno: 'Cerca treno',
                cittaOrLocalita: 'Città o località',
                codiceDescrizioneFermata: 'Codice / Descrizione fermata',
                codiceDescrizioneLinea: 'Codice / Descrizione linea',
                codiceFermata: 'Oppure codice fermata',
                codiceLinea: 'Oppure codice linea',
                codiceOrDescrizioneFermata: 'Codice o descrizione fermata',
                codiceOrDescrizioneLinea: 'Codice o descrizione linea',
                deleteAllConfirmMsg: 'Se confermi, TUTTI i titoli scaduti di "{0}" verranno eliminati dal dispositivo.',
                deleteConfirmMsg: 'Se confermi, il titolo verrà eliminato dal dispositivo',
                dettaglioFermata: 'Dettaglio Fermata',
                fermate: 'Orari Fermata',
                fermateIntorno: 'Fermate intorno',
                fermatePreferite: 'Fermate preferite',
                header: 'Trasporto',
                inserisciIDati: 'Per procedere inserisci i dati richiesti',
                intornoA: 'Intorno a',
                intornoAllIndirizzo: "Intorno all'indirizzo di partenza/destinazione",
                linea: 'Linea',
                linee: 'Orari Linea',
                lineePreferite: 'Linee preferite',
                lineeServite: 'Linee servite',
                mieiTitoli: 'I miei titoli',
                navette: 'Navette',
                needToLogin: ' per visualizzare i biglietti acquistati',
                nessunRisultato: 'Nessun risultato trovato',
                nessunaSoluzione: 'Nessuna soluzione',
                noTitoliAttiviScaduti: 'Non ci sono titoli da attivare o scaduti',
                numeroOrCodiceTreno: 'Numero o codice treno',
                numeroTreno: 'Numero Treno',
                ogniXminuti: 'Ogni {0} min.',
                orariAlleFermateLinee: 'Orari alle fermate e linee',
                parlaConNoi: 'Parla con noi',
                popolari: 'I più popolari',
                reti: 'Reti',
                scegliPercorso: 'Scegli percorso',
                searchingTickets: 'Sto cercando biglietti acquistati',
                stazione: 'Stazione',
                stazioni: 'Stazioni',
                stazioniIntorno: 'Stazioni intorno',
                stazioniPreferite: 'Stazioni preferite',
                tabelloneOrari: 'Tabellone Orari',
                titoliAttivi: 'Titoli attivi',
                trattaXdiY: 'Tratta {0} di {1}',
                treni: 'Trenitalia',
                tuttiPassaggi: 'Tutti i passaggi',
            },
            momup: {
                AcquistaBiglietti: 'Acquista biglietti',
                CalcolaPercorso: 'Calcola percorso',
                Eventi: 'Eventi',
                FermateOrari: 'Fermate ed orari',
                Luoghi: 'Luoghi',
                MieiTitoli: 'I miei titoli',
                abilitaNfc: "Abilita l'NFC sulle impostazioni del dispositivo per poter leggere le card NFC",
                letturaTessera: 'Lettura tessera',
                letturaTitoli: 'Leggi titoli',
                navette: 'Treviso AirBus - Biglietti turistici',
                nfc: {
                    arrival: 'Loc.',
                    article: 'Articolo',
                    contract: 'Contratto',
                    dataOraFineValidita: 'Data fine validità',
                    dataOraValidazione: 'Data ora validazione',
                    departure: 'Loc. Partenza',
                    endDate: 'Fine validità',
                    fermata: 'Fermata',
                    linea: 'Linea',
                    residuals: 'Corse residue',
                    startDate: 'Inizio validità',
                    vediValidazioni: 'Vedi validazioni',
                },
                scansiona: 'Scansiona',
                scansioneFallita: 'Errore scansione',
                scopriAltreApp: 'Scopri il mondo Mom',
            },
            mp: {
                archeologia: 'Archeologia',
                arteStoria: 'Arte & storia',
                bikeTrekking: 'Bike & Trekking',
                cominciaViaggio: 'Comincia il viaggio...',
                contattaci: 'Contattaci',
                culturaTradizione: 'Cultura & tradizione',
                eccellenze: 'Eccellenze',
                esperienze: 'Esperienze',
                eventi: 'Eventi',
                facebook: 'Seguici su FB',
                instagram: 'Instagram',
                itinerari: 'Itinerari',
                luoghi: 'Luoghi',
                mail: 'Contatti',
                naturaScienza: 'Natura & scienza',
                ospitalita: 'Ospitalità',
                prodotti: 'Prodotti',
                scegliMuseo: 'Scegli il tuo Museo...',
                sosta: 'Sosta',
                trasporto: 'Trasporto',
                youtube: 'YouTube',
            },
            mycicero: {
                biglietteria: {
                    header: 'Biglietteria',
                },
                changePosition: {
                    header: 'Cerca città',
                    inputPlaceholder: 'Cerca città',
                    noResults: 'Scegli la città e scopri tutti i servizi myCicero',
                },
                home: {
                    descrizioneSosta: 'Strisce blu, parcehggi, ztl',
                    descrizioneViaggia: 'Treno, bus, metro, nave',
                    highlightTitle: 'In evidenza',
                    titoloSosta: 'Parcheggia',
                    titoloViaggia: 'Viaggia',
                },
                viaggia: {
                    abbonamenti: 'Abbonamenti',
                    abbonamentiExt: 'Abbonamenti',
                    acquistoOd: 'Acquisto da soluzioni di viaggio',
                    acquistoOdTessera: 'Cerca tariffa',
                    acquistoSMS: 'Acquista via SMS',
                    bigliettiSuPrenotazione: 'Biglietti a prenotazione',
                    header: 'Viaggia',
                    multiacquisto: 'Servizi turistici',
                    tariffaFissa: 'Biglietti a tariffa fissa',
                },
            },
            mytrasfer: {
                acquistaBiglietti: 'Acquista biglietti',
                calcolaPercorso: 'Calcola percorso',
                fermateOrari: 'Fermate ed orari',
            },
            navette: {
                allResults: 'Tutti i risultati',
                anErrorOccurredRetry: 'Si è verificato un errore. <b>Riprova</b>',
                busAndStops: 'Autobus e fermate',
                cercaPlaceHolder: 'Cerca per nome',
                cosaVedere: 'Cosa vedere',
                detinazione: 'Destinazione',
                durata: 'Durata',
                emptyPoiList: 'Nessun risultato',
                infoArrivoPrevistoNonDisponibili: 'Informazioni passaggio non disponibili',
                infoDirezioneNonDisponibili: 'Informazioni direzione non disponibili',
                infoNomeFermataNonDisponibile: 'Nome fermata non disponibile',
                infoNonDisponibili: 'Non sono disponibili ulteriori informazioni',
                informazioni: 'Informazioni',
                kmTotali: 'Km totali',
                navettaDaEPer: 'Navette DA e PER:',
                searchByNameOrLocation: 'Cerca per nome o località',
                serviziTuristici: 'Servizi turistici',
                social: 'Social',
                tab: {
                    agenda: 'Agenda',
                    condizioni: 'Condizioni',
                    dettagli: 'Dettagli',
                    info: 'Info',
                    itinerario: 'Itinerario',
                    mappa: 'Mappa',
                    orari: 'Orari',
                    partenzeArrivi: 'Partenze e arrivi',
                    tappe: 'Tappe',
                },
                tappe: 'Tappe',
                telefono: 'Telefono',
                'title-elenco': 'Navette',
                titleMenu: 'Navette',
                updatingData: 'Aggiornamento in corso...',
                web: 'Web',
            },
            notification: {
                connectionErrorHeader: 'Connessione non disponibile',
                connectionErrorMessage: 'Impossibile collegarsi al server: verificare la connessione dati e riprovare.',
                errorGeneric: "Non è stato possibile completare l'operazione, si è verificato un errore.",
                noConnection: 'Connessione non disponibile.',
                offline: 'Offline',
                successGeneric: 'Operazione eseguita con successo.',
                successGenericHeader: 'Successo',
                templateBorsellinoSosta: 'Credito: &euro; {0}',
                templateContactUs: 'Contattaci...',
                templateCreditoNonDisponibile: 'Errore nel ricalcolo del credito',
                templateRicalcoloCredito: 'Ricalcolo credito in corso...',
            },
            notify: {
                header: 'attenzione',
                questionAreaTariffabile: 'Ritieni che questa zona faccia parte di un’area tariffabile?',
                segnalaAnomalie: 'Segnala Anomalie',
            },
            plusPayment: {
                cambiaMetodo: 'Altro metodo',
                confermaInizioSosta: 'Conferma Inizio Sosta',
                effettuaLogin: 'Effettua il Login',
                erroreAggiornamentoMetodiDiPagamento:
                    'Non è stato possibile aggiornare i metodi di pagamento. Controlla la tua connessione internet e riprova.',
                erroreAggiornamentoSaldoBorsellino:
                    'Non è stato possibile aggiornare il credito. Controlla la tua connessione internet e riprova.',
                erroreAggiornamentoSaldoBorsellinoParent:
                    'Non è stato possibile aggiornare il credito di {0}. Controlla la tua connessione internet e riprova.',
                ilTuoProfilo: 'Il tuo profilo',
                modalitaPagamentoNonSupportata: 'Al momento non è possibile pagare con la modalità selezionata',
                nessunMetodoAlternativo: 'Nessun metodo di pagamento alternativo disponibile',
                paga: 'Paga',
                pagaConBorsellinoParent: 'Paga con {0}',
                pagaConCartaDiCredito: 'Carta Registrata',
                profiloPagamento: 'Profilo di</br>pagamento',
                ricaricaCreditoMyCicero: 'Ricarica credito',
                usaCreditoMyCicero: 'Paga subito con credito',
                usaIlCredito: 'Ricarica il Credito myCicero. Conviene!',
                usaIlCreditoBranded: 'Ricarica il tuo credito',
            },
            poi: {
                apriMacrocategoria: 'Apri macrocategoria',
                categoria: 'Categoria',
                categorie: 'Categorie',
                categorieSelezionate: 'Categorie selezionate',
                contatti: {
                    email: 'mail',
                    fax: 'fax',
                    header: 'Contatti',
                    tel: 'tel',
                    url: 'web',
                },
                deselezionaTutto: 'Nessuna',
                dettaglio: 'Localita',
                elenco: 'Elenco',
                espositori: 'Espositori',
                eventi: 'Eventi',
                eventiCorrelati: 'Eventi correlati',
                header: 'Punti di interesse',
                info: 'Info e Contatti',
                infoContatti: {
                    cellulare: 'Cellulare',
                    email: 'Email',
                    facebook: 'Facebook',
                    gestione: 'Gestione',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Telefono',
                    vaiAlSito: 'Vai al sito',
                },
                istruzioniNoCategorie: 'Scegli una categoria',
                itinerariCorrelati: 'Itinerari che passano da qui',
                loadMore: 'Carica altri POI',
                luoghiCorrelati: 'Luoghi correlati',
                macrocategorie: 'Macrocategorie',
                mappa: 'Mappa',
                nessunPoiTrovato: 'Nessun risultato corrispondente ai criteri di ricerca selezionati',
                ospiti: 'Ospiti importanti',
                placeholderRicerca: 'Cerca...',
                posizioneNonCoperta: 'La tua posizione non si trova in una zona coperta.',
                promozioni: {
                    promoPerTe: 'Promozioni a te riservate',
                    promoPerTutti: 'Disponibile a tutti gli utenti',
                },
                ricercaInfoTerritorio: 'Per quale territorio cerchi informazioni?',
                ricercaTutteCategorie: 'Cerca in tutte le categorie',
                scegliCategoria: 'Seleziona',
                scegliPoi: 'Seleziona un POI',
                scegliTerritorio: 'Elenco zone coperte. Quale scegli?',
                selezionaPoi: 'Seleziona un POI',
                selezionaTutto: 'Tutte',
                serviziInclusi: 'Servizi inclusi',
                serviziUtili: 'Servizi utili',
                specialitaCorrelate: 'Prodotti correlati',
                staiCercandoAllCategories: 'In tutte le categorie',
                tab: {
                    allegati: 'Allegati',
                    info: 'Info',
                    mappa: 'Mappa',
                },
                tutteLeCategorie: 'Tutte le categorie',
                vetrina: 'Vetrina',
                virtualTour: {
                    info: 'La Visita Virtuale verrà aperta in una finestra del browser di questo dispositivo',
                    intro: 'Se vuoi scoprire le meraviglie di questo luogo, naviga con la Visita Virtuale',
                    lancia: 'Lancia Visita Virtuale...',
                },
            },
            primoAvvio: {
                tutorial: {
                    biglietti: {
                        testo: 'Acquisti biglietti e abbonamenti in un click',
                        titolo: 'Niente più code',
                    },
                    borsellino: {
                        testo: 'E utilizzalo per pagare tutti i servizi',
                        titolo: 'Ricarica il tuo credito',
                    },
                    buoniMotivi: {
                        testo: 'I buoni motivi per amare myCicero',
                        titolo: 'Da leccarsi i baffi',
                    },
                    dolomiti: {
                        scopriLeBellezze: {
                            testo: 'Scopri le bellezze dolomitiche con noi',
                        },
                    },
                    masterpass: {
                        testo: 'Con Masterpass di Mastercard è sicuro e hai subito un bonus',
                        titolo: 'Registra la tua carta',
                    },
                    seguiIlViaggio: {
                        testo: 'Puntualità, prossime fermate e orari di arrivo',
                        titolo: 'Segui il viaggio in treno',
                    },
                    soluzioniDiViaggio: {
                        testo: 'Soluzioni integrate con treno, bus e metro',
                        titolo: 'Pianifica il viaggio',
                    },
                    sosta: {
                        testo: 'Paghi solo i minuti effettivi',
                        titolo: 'Risparmia sul parcheggio',
                    },
                },
            },
            profilazione: {
                accedi: 'Accedi',
                accediAccount: 'Sei già registrato',
                aci: {
                    registrazioneEseguiLogin:
                        'Esegui il login per utilizzare le funzionalità messe a disposizione da ACI al tuo account myCicero.',
                    registrazioneUtenteEsistenteConTessera:
                        "Tessera socio ACI correttamente associata all'utente myCicero corrispondente all'utente ACI.",
                    registrazioneUtenteNuovoConTessera:
                        "Registrazione avvenuta. Trovi le credenziali per accedere nell'email inviata all'indirizzo associato al tuo account ACI. Ti è stata attivata la tessera socio ACI.",
                    registrazioneUtenteNuovoSenzaTessera:
                        "Registrazione avvenuta. Trovi le credenziali per accedere nell'email inviata all'indirizzo associato al tuo account ACI.",
                },
                activateServices: 'Attiva i servizi in un minuto',
                alreadySubscribed: 'Hai già un account?',
                associaFoto: 'Associa Foto',
                azienda: 'Azienda',
                benvenuto: 'Benvenuto ',
                cambiaEmail: 'Cambia email',
                cap: 'C.A.P.',
                cartaRegistrata: 'Carta registrata',
                cell: 'Tel. Cellulare',
                cellFormatInvalid: 'Numero Cellulare non valido.',
                cellulare: 'Telefono cellulare',
                checkAccetto: 'Accetto la ',
                checkComunicazioni: 'Ricevi le comunicazioni e le novità',
                checkCondizioniPrivacy: 'Accetto le ',
                checkCondizioniUtilizzo: 'Ho letto le ',
                checkCondizioniUtilizzoAlternativelabel: "Ho letto l'",
                chiudi: 'Chiudi',
                citta: 'Città',
                cittaNascita: 'Comune di nascita',
                cittaResidenza: 'Comune di residenza',
                codTessera: 'Numero Tessera',
                codiceCliente: 'Codice Cliente',
                codiceFiscale: 'Codice Fiscale',
                codiceUnivocoDestinatario: 'Codice Univoco Destinatario',
                cognome: 'Cognome',
                cohesion: {
                    erroreRegistrazione: 'Registrazione tramite Cohesion fallita',
                    labelHtml: 'Registrazione tramite <b>Cohesion 2.0</b>:',
                },
                condizioniAltriFini: 'Liberatoria invio promozioni',
                condizioniCommerciali: 'Informazioni Commerciali',
                condizioniContrattuali: 'condizioni contrattuali',
                condizioniDiUtilizzo: "condizioni d'utilizzo",
                condizioniDiUtilizzoAlternativeLabel: 'informativa privacy',
                condizioniFiniCommerciali: 'Liberatoria invio materiale informativo',
                condizioniIscritti: 'Informativa iscritti',
                condizioniPrivacy: 'condizioni privacy',
                condizioniUtilizzo: "Condizioni d'utilizzo",
                condizioniUtilizzoCredito: 'Condizioni utilizzo Credito',
                condizioniUtilizzoGenerali: 'Condizioni Generali di Utilizzo',
                condizioniUtilizzoPrivacy: 'Condizioni di utilizzo e privacy',
                condizioniUtilizzoSosta: 'Condizioni utilizzo Sosta',
                condizioniUtilizzoTrasporto: 'Condizioni utilizzo Trasporto',
                confirmRollback: 'Questo annullerà le informazioni inserite fino ad ora. Vuoi procedere?',
                confirmation: 'Conferma PIN',
                contattaAssistenza: "Contatta l'assistenza",
                continuaSenzaRegistrazione: 'Continua senza registrazione',
                continuaSenzaRegistrazioneAvvertimento:
                    'Procedendo senza registrazione non sarà consentito effettuare acquisti',
                controllaCodice: 'Controlla Codice',
                controllaEmail: "Controlla che l'account di posta inserito sia corretto.",
                creaUtente: 'Crea il tuo utente',
                creaUtenteDesc: 'Crea il tuo utente in un minuto...',
                dataNascita: 'Data di Nascita',
                descrizionePromo: 'Hai un codice promozionale? inseriscilo qui ed attiva la promozione',
                ebbeneSi: 'Si, ricomincia',
                email: 'Indirizzo e-mail',
                emailConfirmed: 'Account email confermato con successo',
                emailReminder:
                    ' Ricordati di confermare il tuo indirizzo email tramite il link inviato. Puoi farlo anche in un secondo momento.',
                emailSent: 'E-mail inviata a ',
                erroreRegistrazioneCarta: 'La registrazione dell Carta di Credito non è andata a buon fine.',
                esclamaBenvenuto: 'Benvenuto!',
                fatturazioneElettronica: 'Fatturazione elettronica',
                fine: 'Fine',
                indirizzo: 'Indirizzo',
                indirizzoResidenza: 'Indirizzo di residenza',
                infoMoficaDati:
                    'Per eventuali modifiche, prima di confermare, contatta assistenza@mycicero.it o chiama allo 071 920 7000',
                infoNecessaria: 'Informazione necessaria.',
                informativaFatturazione:
                    "L'emissione di fattura per  i titoli di sosta o di viaggio (tratte urbane) non è obbligatoria perché FUORI CAMPO IVA, in quanto regolamentata dall’art. 74 DPR 633/72, lettera e), che introduce il regime di monofase nella disciplina iva. Nel caso si richieda fattura, questa dovrà essere emessa e gestita come fattura elettronica, con inevitabile aggravio di costi anche per l’acquirente che dovrà conservare la fattura elettronicamente. Pertanto si consiglia, ove possibile, di scaricare la spesa sostenuta attraverso la  ricevuta emessa contestualmente ad ogni acquisto gratuitamente. Se invece si necessita della fattura, sarà emessa un’unica fattura mensile riepilogativa di tutte le soste attivate nelle vare città servite da myCicero, con un addebito massimo annuale di €1,2/anno. Con grande piacere vogliamo ricordare che i servizi per il pagamento della sosta e del trasporto (bus-metro-treni) offerti da myCicero, a differenza di altri competitor, non prevedono canoni periodici,  né commissioni a carico del Cliente.",
                informativaPrivacy: 'Informativa area iscritti',
                inizia: 'Inizia',
                insertPinCode: 'Inserisci codice attivazione',
                intestatario: 'Estremi della tessera',
                inviaSms: 'Invia SMS',
                inviaSmsConferma: 'Sì, invia',
                inviaSmsInfo: 'Sto per inviare nuovamente il codice di attivazione via sms. Sei sicuro?',
                iscrizione: 'Sei iscritto con',
                iscrizioneNonCompletataPopupAnnullaEdElimina: 'Annulla ed elimina utente',
                iscrizioneNonCompletataPopupCompletaIscrizione: 'Completa iscrizione',
                iscrizioneNonCompletataPopupMsg: 'Si è provato a creare un utente ma la procedura è stata interrotta',
                iscrizioneNonCompletataPopupTitle: 'Iscrizione non completata',
                iscrizioneServizi: 'Se sei già iscritto a uno di questi servizi, puoi utilizzare le stesse credenziali',
                localitaProvenienza: 'Località di provenienza del volo',
                messaggioAssociaFoto:
                    'ATTENZIONE: Questa foto verrà riportata sul tuo abbonamento e non sarà possibile cambiarla',
                modelloVeicolo: 'Modello veicolo',
                modelloVeicoloObbligatorio: 'Modello veicolo',
                modelloVeicoloOpzionale: 'Modello veicolo (opzionale)',
                msgAssistenzaActv: 'app.support@avmspa.it',
                msgAssistenzaDefault: 'assistenza@mycicero.it e call center 071 920 7000',
                nazione: 'Nazione',
                nazioneNascita: 'Nazione di nascita',
                nome: 'Nome',
                nonHaiTessera: 'Non hai una tessera?',
                normativaPrivacy: 'Normativa sulla Privacy',
                numVolo: 'Num. volo di ritorno',
                numeroTelefonoConfermato: 'Numero telefonico confermato',
                numeroVerde: 'Num. Verde',
                nuovoUtente: 'Nuovo utente',
                partitaIva: 'Partita Iva',
                password: 'Password',
                passwordConfirm: 'Reinserisci Password',
                passwordNotMatch: 'Le password non corrispondono.',
                pecEmail: 'PEC destinatario',
                perAssistenza: 'Per assistenza inviare una email a:',
                perAssistenzaActv: 'Per assistenza inviare una email a:',
                perAssistenzaSito: 'Per assistenza cliccare sul seguente ',
                perAssistenzaTelefono: 'Oppure chiama:',
                perAssistenzaUlteriore: 'Per problematiche sulla ricezione dei biglietti:',
                perInfo: 'Per informazioni: ',
                perUlterioriInfo: 'Per ulteriori informazioni: ',
                perUlterioriInfoInfoActv: 'Per ulteriori informazioni: ',
                pinCode: 'Conferma Codice',
                pinCodeDesc: 'Ti abbiamo inviato un SMS con un codice di attivazione',
                privato: 'Privato',
                procedi: 'Procedi',
                profiloPreferito: 'Profilo preferito',
                profiloPreferitoMessage: 'Questo profilo verrà utilizzato come intestazione delle fatture emesse',
                promoCodePlaceholder: 'Inserisci il codice promozionale',
                promozioni: 'Promozioni',
                provincia: 'Prov.',
                ragioneSociale: 'Ragione sociale',
                recapiti: 'Recapiti',
                registraNuovoUtente: 'Iscriviti come nuovo utente',
                registratiOra: 'Registrati ora',
                registrationCompleted: 'Registrazione Completata.',
                registrationFailed: 'Registrazione fallita',
                registrazione1: 'Registrazione 1/2',
                registrazione2: 'Registrazione 2/2',
                reinviaSMS: 'Invia di nuovo',
                requiredFields: 'Compilare tutti i campi obbligatori.',
                resendBtn: 'Si, invialo.',
                resendOk: 'Ho appena inviato nuovamente il codice di attivazione via SMS. Dovresti riceverlo a breve.',
                resendText: 'Sto per inviare nuovamente il codice di attivazione via SMS. Sei sicuro?',
                resended: 'Codice inviato',
                rightNumber: 'Il numero è corretto?',
                rimuoviProfilo: 'Rimuovi profilo',
                salvaModifiche: 'Salva le modifiche',
                sendSms: ' Invio sms e mail di conferma ...',
                sendingEmailDesc: "Inoltre sto inviando un'email con un link di attivazione all'indirizzo: ",
                sendingSmsDesc: 'Sto inviando il codice di conferma tramite SMS al numero: ',
                smsNotSent: 'SMS non inviato a ',
                smsSent: 'SMS inviato a ',
                splitPayment: 'Azienda in regime di Split Payment',
                startAgain: 'Cambia numero',
                targaObbligatoria: 'Targa veicolo',
                targaOpzionale: 'Targa veicolo (opzionale)',
                titoliAtac: 'Titoli ATAC',
                titoloPersonale: 'Inserisci e/o controlla i dati della tessera abbonato prima di confermare',
                titoloPesonale: 'Tessera Trasporto',
                usaCodice: 'Utilizza il codice',
                username: 'Username',
                vaiAllApp: "Inizia ad usare l'app",
                vediPromo: 'Visualizza promozioni attive',
                verificaCodiceSms: 'Verifica codice SMS',
                wrongNumber: 'Il numero è sbagliato?',
            },
            profiloUtente: {
                carte: 'Carte di Credito Registrate',
                impostazioniNotifiche: {
                    description:
                        "Prolunga e Termina la sosta con un click direttamente dall'Area Notifiche del tuo dispositivo.",
                    header: 'Integrazione area notifiche',
                    title: 'Impostazioni notifiche',
                    toggleActive: 'Disattiva',
                    toggleInactive: 'Attiva',
                },
                mostraCod: 'Mostra Codice Utente',
                nessunaCarta: 'Nessuna carta di credito',
                nessunaTessera: 'Nessuna tessera associata',
                pref: 'Preferenze',
                tessere: 'Tessere e Contratti',
                title: 'Profilo Utente',
            },
            promozione: {
                atmaBullet1:
                    'Fai scannerizzare dal lettore posto sulle eco compattatrici il codice a barre che identifica il tuo utente',
                atmaBullet2: 'Inserisci solo le bottiglie in PET da 0,5 a 2 litri e ricevi il tuo ecobonus',
                atmaBullet3: 'Acquista i biglietti usando il bonus accumulato',
                bullet1:
                    'Fai scannerizzare dal lettore posto sulle eco compattatrici il codice a barre che identifica il tuo utente',
                bullet2:
                    'Inserisci solo bottiglie in PET da 0,5 a 2 litri e ricevi il tuo ecobonus. Puoi inserirne al massimo 30 al giorno.',
                bullet3: 'Acquista i titoli usando il bonus accumulato',
                caricaNuovoBuono: 'Carica nuovo buono',
                caricaNuovoCredito: 'Carica nuovo credito',
                compraAtac: 'Acquista titoli B+',
                compraAtma: 'Acquista titoli ATMA',
                dataOraMovimento: 'Data e Ora',
                descrizione: "Puoi usufruire dell'importo per </br> acquistare titoli",
                descrizioneMovimento: 'Descrizione',
                elencoPromozioniMobilita: {
                    nessunaPromozione: 'Nessuna promozione presente',
                    title: 'Elenco crediti',
                },
                importoMovimento: 'Importo',
                invalidTxt: 'Il dato inserito non rispetta il formato previsto',
                istruzioniPrincipaliHTML:
                    '<span class="bold">Ricicla le tue bottiglie di plastica e potrai accumulare credito per acquistare biglietti e abbonamenti <span class="bold atac-red">ATAC</span></span>',
                istruzioniPrincipaliHTMLATMA:
                    '<span class="bold">Ricicla le tue bottiglie di plastica e potrai accumulare credito per acquistare biglietti ATMA</span>',
                labelProfilo: 'ATAC Roma +Ricicli +Viaggi',
                labelProfiloAtma: 'ATMA Ancona Riciclo Bottiglie',
                labelSaldo: 'Saldo',
                movimenti: 'Movimenti',
                noMovimenti: 'Non ci sono movimenti da visualizzare',
                scadenza: 'Scadenza ',
                titoliBAtac: 'B+ ATAC',
                titoliBAtma: 'ATMA',
                tuttiMovimenti: 'Tutti i movimenti',
                txtInstructions:
                    'Inserisci i dati richiesti e verifica il codice buono per ricaricare il credito relativo a',
                ultimiMovimenti: 'Ultimi movimenti',
                usaCreditiMobilita: 'Utilizza crediti di mobilità',
                utilizzoEcobonus: 'Utilizzo Ecobonus (€ {0})',
            },
            rockinroma: {
                atac: 'Biglietti ATAC',
                festival: 'Festival',
                lineUp: 'Lineup',
                location: 'Location',
                mieiTitoli: 'I miei titoli',
                tickets: 'Tickets',
                travel: 'Travel',
                treniDelRock: 'Treni post concerto',
            },
            rss: {
                dettaglioHeader: 'Dettaglio',
                filterPlaceholder: 'Cerca...',
                latestNews: 'Ultime Notizie',
                news: 'News',
                newsFontiNotificheHeader: 'Lista feeds',
                newsNotificheHeader: 'News e Notifiche',
                noResults: 'Nessun risultato',
                scegliFeed: 'Scegli il feed',
                updating: 'Controllo news...',
            },
            rundetails: {
                nodata: {
                    empty: 'nessun dettaglio trovato',
                },
                realTime: {
                    arrivoPrevisto: 'Arrivo previsto',
                    arrivoReale: 'Reale',
                    arrivoStimato: 'Stimato',
                    binarioPrevisto: 'Binario previsto',
                    binarioReale: 'Reale',
                    inAnticipo: 'in anticipo',
                    inOrario: 'in orario',
                    inRitardo: 'in ritardo',
                    minuti: 'minuti',
                    minuto: 'minuto',
                    partenzaPrevista: 'Partenza prevista',
                    partenzaReale: 'Reale',
                    ultimoRilevamento: 'Ultimo rilevamento: ',
                },
            },
            sanzioni: {
                cercaVerbale: 'Cerca verbale',
                codiceFiscale: 'Codice fiscale',
                codiceInfrazione: 'Codice infrazione',
                cognome: 'Cognome',
                cognomeSanzionato: 'Cognome sanzionato',
                controllareDatiInseriti: 'Controllare i dati inseriti.',
                data: 'Data',
                dataNascita: 'Data di nascita',
                dataVerbale: 'Data del verbale',
                datiIncompleti: 'Dati incompleti',
                datiSanzionato: 'Dati sanzionato',
                datiVerbale: 'Dati verbale',
                descrizione: 'Descrizione',
                dettaglioVerbale: 'Dettaglio verbale',
                erroreIdSistema: 'IdSistema non specificato',
                idVerbale: 'Id verbale',
                importoBiglietto: 'Importo del biglietto',
                infoDatiVerbale: 'Inserisci i dati necessari per la ricerca del verbale.',
                noVettoriAbilitatiPagamentoSanzioni: 'Nessun vettore abilitato per il pagamento delle sanzioni.',
                nome: 'Nome',
                nomeSanzionato: 'Nome sanzionato',
                numero: 'Numero',
                numeroVerbale: 'Numero verbale',
                pagamentoSanzioni: 'Pagamento sanzioni',
                sanzionato: 'Sanzionato',
                sanzione: 'Sanzione',
                serialeVerbale: 'Seriale verbale',
                serie: 'Serie',
                speseAmministrative: 'Spese amministrative',
                totale: 'Totale',
                verbale: 'Verbale',
                verbaleNonPagabile: '<b>Verbale già pagato</b>',
                verbaleNonTrovato: '<b>Verbale non trovato</b><br>Controllare i dati inseriti.',
            },
            selectPositionOnMap: {
                areaNonServitaHtml:
                    'Per informazioni contattaci allo <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> o <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">via chat</a>',
                areaNonServitaLabel: 'Selezionare un punto su mappa valido.',
                areaNonServitaTitle: 'Area non servita',
                disclaimerBtn: 'Ho capito',
                disclaimerMsg: 'Assicurati di indicare correttamente la posizione',
                ricercaLocalitaInCorso: 'Ricerca località in corso...',
                scegli: 'Scegli',
                warningAumentaZoom: 'Aumenta lo zoom',
                warningZoomInsufficiente: 'Aumenta lo zoom, per individuare la tua posizione',
            },
            selezionaModalitaDiPagamento: {
                comeVuoiPagare: 'Come vuoi pagare?',
                modalita: {
                    acipg: 'ACI Pay',
                    amonw: 'Carte di Pagamento',
                    bbol: '',
                    bill: 'Bill by SisalPay',
                    brsel: 'Credito myCicero',
                    cc: '',
                    ccric: 'Carte di Pagamento',
                    'ccs-2-s': '',
                    mpass: 'Masterpass™',
                    pbemo: 'BeMoov',
                    ppay: 'Postepay',
                    ppexp: 'PayPal',
                    ppric: 'PayPal',
                    sisal: 'SisalPay',
                    stpay: 'SatisPay®',
                },
            },
            serCom: {
                NessunServizioAzienda: "Non ci sono servizi abilitati per l'utente con profilo aziendale",
                NessunServizioPrivato: "Non ci sono servizi abilitati per l'utente privato",
                avvisiPagamento: {
                    header: 'Avvisi di pagamento',
                    inScadenza: 'In scadenza e da pagare',
                },
                azienda: 'Azienda',
                certificazioneInfoHTML:
                    "Per visualizzare gli avvisi di pagamento inviati dagli enti, devi essere un utente certificato. Per certificare il tuo utente è sufficiente recarti, munito di documento di riconoscimento, negli uffici di uno dei comuni abilitati, oppure utilizzare, nell'area riservata web accessibile da pc, le credenziali di uno dei sistemi di certificazione federati (Cohesion)",
                comune: 'Comune',
                comuniRecenti: 'Comuni visualizzati di recente',
                comuniSerCom: 'Comuni che espongono Servizi Comunali',
                contattaAssistenza: "Si prega di contattare l'assistenza",
                contatti: 'Contatti',
                costoServizio: 'Costo del servizio',
                dataInfrazione: 'Data infrazione',
                elencoMovimenti: {
                    header: 'Elenco Movimenti',
                    noResults: 'Non sono presenti movimenti nel periodo specificato',
                    ricercaMovimenti: 'Effettua ricerca',
                },
                mainHeader: 'Servizi Comunali',
                nessunImportoDovuto: "L'importo dovuto è pari a 0, nessun pagamento necessario!",
                news: {
                    header: 'News e Comunicazioni',
                },
                oraInfrazione: 'Ora infrazione',
                pagamentiSpontanei: {
                    compilaTutto: 'Attenzione: compilare tutti i campi richiesti',
                    header: 'Pagamento servizi',
                    pagSpontaneo: 'Pagamento Spontaneo',
                },
                pagamento: {
                    dataEmissione: 'Data Emissione',
                    dataFine: 'Data Fine',
                    dataInizio: 'Data Inizio',
                    dataSanzione: 'Data Sanzione',
                    dataScadenza: 'Data Scadenza',
                    descr: 'Descrizione',
                    errorePagamento: 'Si è verificato un errore durante il pagamento.',
                    header: 'Pagamento',
                    importoDaPagare: 'Importo da pagare',
                    importoNonValido: 'Importo non valido.',
                    pagamentoGuidato: 'Pagamento Guidato',
                    scegliData: 'Scegli Data',
                    soggetto: 'Soggetto',
                    targa: 'Targa',
                    verbale: 'Verbale',
                },
                pagamentoEffettuato: 'Pagamento Effettuato',
                pagamentoNonAbilitato: 'Pagamento non abilitato',
                privato: 'Privato',
                richiediCert: 'Richiedi Certificazione',
                richiediCertInfoHTML:
                    'Verrai condotto alla tua area riservata web accessibile <strong>tramite PC tradizionale.</strong>',
                segnalazioni: {
                    cat: 'Categoria',
                    descr: 'Descrizione',
                    header: 'Segnalazioni',
                    img: 'Immagine',
                    indirizzo: 'Indirizzo segnalazione',
                    inserite: 'Segnalazioni inserite',
                    invia: 'Invia segnalazione',
                    noCategorie: 'Non sono disponibili categorie per la tua posizione.',
                    nuova: {
                        abbandona: 'Abbandona la segnalazione ed esci',
                        attendiCaricamentoImmagine: "Attendi il caricamento dell'immagine...",
                        caricamentoImmagineFallito: "Caricamento dell'immagine fallito",
                        fail: 'Impossibile salvare la segnalazione!',
                        header: 'Nuova segnalazione',
                        inserisciQui: 'Inserisci qui la segnalazione',
                        success: 'Segnalazione salvata con successo',
                        torna: 'Torna alla segnalazione',
                    },
                    subCat: 'Sottocategoria',
                    tue: 'Le tue segnalazioni',
                    welcome: 'Benvenuto!',
                    welcomeIntroTemplate:
                        '<p>In questa pagina puoi inviare una segnalazione al {0}.</p><p>Per prima cosa, scegli una fra le {1} categorie disponibili:</p>',
                },
                serviziAbilitatiAzienda: "Servizi abilitati per l'utente con profilo aziendale",
                serviziAbilitatiPrivato: "Servizi abilitati per l'utente privato",
                tipoSoggetto: 'Tipo soggetto',
                tornaAiServizi: 'Torna ai servizi',
                totale: 'Totale',
                transazioneOK: 'La transazione è andata a buon fine',
                utenteNonCertificato: 'Utente non certificato',
            },
            siae: {
                acquistaBiglietti: 'Acquista biglietti',
                chooseSector: {
                    apriMappa: 'Apri mappa',
                    headerScegliDaLista: 'Selezione posti automatica',
                    headerScegliDaMappa: 'Selezione posti manuale',
                    noSettori: 'Nessun settore trovato',
                    scegliBiglietti: 'Scegli i biglietti',
                },
                mieiBiglietti: 'I miei biglietti',
                myTickets: {
                    mieiTitoli: 'I miei biglietti',
                    passati: 'Passati',
                    validi: 'Validi',
                },
                posto: 'Posto',
                seasonTicket: 'Abbonamento',
                settore: 'Settore',
                ticketDetails: {
                    carta: 'Carta',
                    cfOrganizzazione: 'CF Org.',
                    cfTitolo: 'CF Tit.',
                    data: 'Data',
                    idSistema: 'ID Sistema',
                    progressiva: 'Progressivo',
                    sf: 'S.F.',
                    tipoEvento: 'Tipo Evento',
                },
                ticketsSummary: {
                    commissioni: 'Commissioni di servizio',
                    pagaConCarta: 'Paga con carta di credito',
                    prevendita: 'Prevendita',
                    removeTicketConfirm: 'Sei sicuro di voler rimuovere questo articolo?',
                    staiPerAcquistare: 'Stai per acquistare',
                },
            },
            smartArea: {
                cambiaCitta: 'Cambia città...',
                confermaReset: 'Verranno cancellati tutti i dati della Smart Area memorizzati localmente.',
                defaultTitleHtml: 'Il mondo dei servizi smart',
                nonScegliNulla: 'Non scegliere nulla...',
                oppureAreaSmartHtml: 'Oppure seleziona un territorio <i>smart</i>:',
                reset: 'Cancella i dati locali della Smart Area',
                resetDone: 'Dati cancellati. Al tuo prossimo accesso alla home page, i dati verranno ricaricati.',
                scegli: 'Scegli città smart',
                seiQui: 'Sei qui ',
                selezionaAreaSmart: 'Seleziona un territorio o una città smart',
                servizioNonDisponibile: 'Servizio non disponibile al momento.',
            },
            solutions: {
                acquista: {
                    aPiedi: 'a piedi',
                    arrivo: 'arrivo',
                    articolo: 'articolo',
                    dilloAlVettore: 'Sì, mi piacerebbe poter acquistare questa soluzione di viaggio',
                    dilloAlVettorePre: 'La soluzione di viaggio non è ancora acquistabile. Vuoi segnalarcelo?',
                    dilloAlVettoreStatement: 'La soluzione di viaggio non è ancora acquistabile.',
                    durata: 'durata',
                    fromStop: 'dalla fermata',
                    header: 'Acquista soluzione',
                    importo: 'importo',
                    infoAddizionali: 'Info addizionali',
                    nonDisponibile: 'Non disponibile',
                    partenza: 'partenza',
                    toStop: 'alla fermata',
                    tratta: 'tratta',
                },
                dialog: {
                    partenzaArrivoUguali: 'Partenza e destinazione coincidono. Non esistono soluzioni di viaggio.',
                },
                fav: {
                    header: 'Salva Soluzione',
                    info:
                        'Registra questa soluzione di viaggio tra i Preferiti" per poterla richiamare velocemente in futuro"',
                },
                form: {
                    cercasoluzioni: 'Cerca Soluzioni di Viaggio',
                    elimina: 'Cancella',
                    itinerariPreferiti: 'Itinerari preferiti',
                    nessunPreferito: 'Nessun preferito',
                    preferiti: 'Preferiti',
                    recenti: 'Recenti',
                    searchbutton: 'Cerca',
                },
                list: {
                    arrivi: 'arrivi',
                    arrivo: 'arrivo',
                    loadMore: 'Carica ulteriori soluzioni',
                    ordinaPerDataArrivoAsc: 'Per ora di arrivo',
                    ordinaPerDataDiPartenzaAsc: 'Per ora di partenza',
                    ordinaPerDataDiPartenzaDesc: 'Orario partenza ↓',
                    ordinaPerDurataTragittoAsc: 'Per durata',
                    ordinaPerDurataTragittoDesc: 'Durata viaggio ↓',
                    ordinaPerNumCambiAsc: 'Numero cambi',
                    ordinaPerPrezzoAsc: 'Prezzo più basso',
                    ordinaPerPrezzoDesc: 'Prezzo più alto',
                    ordinaRisultati: 'Ordina le soluzioni',
                    partenza: 'partenza',
                    partenze: 'partenze',
                },
                nodata: {
                    empty: 'Nessuna soluzione di viaggio trovata',
                },
                nome: 'Nome Soluzione',
                type: {
                    auto: 'Auto',
                    autobus: 'Solo Autobus',
                    busTreni: 'Autobus e Treni',
                    pedonale: 'Pedonale',
                    treno: 'Solo Treno',
                },
            },
            stopdetails: {
                nodata: {
                    empty: 'no details found',
                },
                settings: 'Impostazioni Fermata',
            },
            stops: {
                arrivi: 'Arrivi alla fermata',
                fav: {
                    conferma: 'La fermata è stata aggiunta alle tue fermate preferite',
                    header: 'Salva Fermata',
                    info: 'Registra questa fermata tra i "Preferiti" per poterla richiamare velocemente in futuro',
                    nomePreferito: 'Nome Preferito',
                },
                partenze: 'Partenze dalla fermata',
            },
            summerjamboree: {
                alloggi: 'Dove alloggiare',
                festival: 'Il festival',
                foodAndBeverages: 'Food & Drink',
                locations: 'Le locations',
                mappa: 'La mappa',
                mercatino: 'Vintage Market',
                navette: 'Treno del rock e navette',
                programma: 'Il programma',
            },
            sunsen: {
                cercaAlloggio: 'Cerca alloggio',
                elencoTornei: 'Elenco Tornei',
                home: {
                    classifica: 'Risultati e classifiche',
                    eventi: 'Eventi',
                    informazioni: 'Informazioni',
                    iscrizioni: 'Iscrizioni',
                    partners: 'Partners',
                    sosta: 'Sosta',
                    trasporto: 'Trasporto',
                },
            },
            taxi: {
                common: {
                    aggiornatoAlle: 'Aggiornato alle',
                    descrAnnullata: 'Prenotazione annullata',
                    descrArrivato: 'Arrivato',
                    descrConfermata: 'Prenotazione confermata',
                    descrDaConfermare: 'In attesa di conferma',
                    descrInArrivo: 'In arrivo tra {0} minuti',
                    descrPagato: 'Pagato (€ {0})',
                    ultimoAggiornamento: 'Ultimo aggiornamento',
                },
                dettaglio: {
                    annullaPrenotazione: 'Annulla prenotazione',
                    dataAssegnazione: 'Data assegnazione',
                    pagaTaxi: 'Paga taxi',
                    promptHeader: 'Annulla',
                    promptKo: 'No',
                    promptMessage: 'Sei sicuro di voler annullare questa prenotazione?',
                    promptOk: 'Sì',
                    title: 'Dettaglio prenotazione',
                },
                home: {
                    aggiornamentoInCorso: 'Aggiornamento dati in corso...',
                    miePrenotazioni: 'Le mie prenotazioni',
                    paga: 'Paga',
                    prenota: 'Richiedi',
                    title: 'Ricerca Taxi',
                },
                mappa: {
                    disclaimerBtn: 'Ho capito',
                    disclaimerMsg: 'Assicurati di indicare esattamente dove ti trovi',
                    procedi: 'Procedi',
                    title: 'Ricerca taxi',
                    warningZoomInsufficiente: 'Aumenta lo zoom, per individuare la tua posizione',
                },
                pagamento: {
                    importoViaggio: 'Importo viaggio',
                    numeroLicenza: 'Numero licenza',
                    pagamentoEffettuato: 'Il pagamento della corsa è stato effettuato con successo.',
                    promptNumeroLicenza: 'Chiedi al tassista il suo numero di licenza',
                    scansiona: 'Scansiona',
                    scegliComePagare: 'Scegli come pagare',
                    title: 'Paga taxi',
                    totale: 'Totale',
                },
                prenotazione: {
                    conferma: 'Conferma',
                    promptHeader: 'Ricerca taxi',
                    promptMessage: 'Siamo in attesa di ricevere conferma dalla centrale operativa.',
                    promptNote:
                        'Riceverai una mail di conferma quando la prenotazione sarà accettata e il taxi assegnato. Nel caso di richiesta in differita, questo avverrà pochi minuti prima dell’orario indicato.',
                    title: 'Richiesta taxi',
                },
            },
            tessere: {
                EliminaFail: "Si è verificato un errore durante l'eliminazione della tessera.",
                EliminaSuccess: 'La tessera è stata eliminata.',
                EliminaTesseraConf: 'Vuoi davvero eliminare questa tessera?',
                aggiungiTesseraTrasporto: 'Aggiungi tessera...',
                apriControllo: 'Apri controllo',
                attivaTessera: 'Attiva tessera',
                card: 'Card',
                cerca: 'Cerca Tessera',
                cercaAttiva: 'Cerca la Tessera e attivala...',
                cercaPlaceHolder: 'Nome Tessera o contratto',
                chiudiControllo: 'Chiudi controllo',
                codice: 'Codice Tessera',
                dettagliTessera: 'Dettagli Tessera e contratto',
                haiTessera: 'Hai una tessera?',
                identificativoTessera: 'Identificativo tessera',
                inAttesaValidazione: 'In attesa di conferma.',
                inserisciCodice: 'Inserisci il codice della tessera',
                inserisciIdentificativoTessera:
                    'Inserisci il numero identificativo della tessera per procedere all’acquisto del titolo di viaggio',
                noResultTessere: 'Nessuna tessera disponibile',
                noResultTessereTrasporto: 'Nessuna tessera disponibile',
                nomeTesseraContratto: 'Nome tessera o contratto',
                nonAttiva: 'Tessera non ancora attiva',
                rimuovi: 'Rimuovi Tessera',
                scegliVettoreTessera: 'Scegli il vettore',
                siHoTesseraVettore: 'Sì, ho una tessera ',
                tessera: 'Tessera: ',
                tesseraRegistrata: 'Tessera registrata con successo',
                toBeCertified: "Questa tessera richiede una certificazione manuale da parte dell'amministratore",
                tutte: 'Tutte le tessere',
                valida: 'Tessera valida',
                validita: 'Validità',
                verifica: 'Verifica',
            },
            tir: {
                login: {
                    appName: 'TRANSPark',
                    appNonDisponibile: "L'applicazione non &egrave; al momento disponibile su Windows Phone",
                    areeStazioni: 'Aree di sosta e stazioni di rifornimento',
                    cerca: 'Cerca movimenti',
                    cercaParcheggi: 'Cerca Parcheggi',
                    codice: 'User code',
                    scarica: "Scarica l'app",
                    targa: 'Targa veicolo',
                    testo1:
                        'Progetto europeo (<a href="javascript:openLinkOnBrowser(\'http://www.cogistics.eu\')">www.cogistics.eu</a>) pilota a Trieste per la promozione del servizio di sosta TIR.',
                    testo2:
                        'Di seguito, gli autotrasportatori possono visualizzare le soste effettuate presso l’area di sosta dell’Interporto di Trieste nella sezione Movimenti Soste oppure trovare aree di sosta e stazioni di rifornimento attraverso il link all’app Transpark di IRU.',
                    testo3: "Riservato agli autotrasportatori in sosta presso l'Interporto di Trieste.",
                    title: 'Sosta TIR',
                    titoloApp: 'App TransPark',
                    titoloMovimenti: 'Visualizza Movimenti Soste',
                },
                movimenti: {
                    nessuno: 'Non sono presenti movimenti.',
                    title: 'Elenco movimenti',
                },
            },
            tours: {
                allCategories: 'Tutte le Categorie',
                arrivi: 'Arrivi',
                cercaPrenota: 'Cerca e Prenota un Tour',
                definisciRaggio: 'Definisci raggio ricerca intorno a: ',
                dettaglio: 'Dettaglio Tour',
                elenco: 'Elenco',
                inPartenzaEntro: 'Tour in partenza entro',
                info: 'Info',
                itinerario: 'Itinerario',
                mappa: 'Mappa',
                nomeTour: 'Nome Tour',
                partenze: 'Partenze',
                raggioRicerca: 'Raggio di ricerca: ',
                vetrina: 'Vetrina',
                viaggioOrg: 'Viaggi Organizzati',
                warnTariffe:
                    "Il prezzo mostrato si riferisce alla tariffa base. Verifica all'interno per il listino completo.",
            },
            tplfvg: {
                AcquistaBiglietti: 'Acquista biglietti',
                CalcolaPercorso: 'Calcola percorso',
                Eventi: 'Eventi',
                FermateOrari: 'Fermate e orari',
                Luoghi: 'Luoghi',
                MieiTitoli: 'I miei titoli',
                ServiziTuristici: 'Servizi turistici',
                accediRegistrati: 'Accedi / Registrati',
                loginMessage:
                    'Per poter utilizzare questa app è necessario accedere come utente registrato <b>TPLFVG</b>.',
                newsEventi: 'Infomobilità ed eventi',
                rivendite: 'Rivendite',
            },
            trasportoGT: {
                accedi: {
                    header: 'Accedi al GT',
                },
                elencoMovimenti: {
                    header: 'Elenco Movimenti',
                },
                header: 'Bus a lunga percorrenza',
                mieiAbbonamenti: {
                    goToMyAbbonamenti: 'Vai a "I miei Abbonamenti"',
                    header: 'I miei Abbonamenti',
                    infoTitoliAcquistati:
                        'Puoi trovare il titolo di viaggio nella sezione "I Miei Abbonamenti" del "Trasporto GT"',
                },
                mieiBiglietti: {
                    aggiornaElenco: 'Aggiorna Elenco...',
                    elencoBigliettiDaObliterare: 'Elenco titoli acquistati da obliterare',
                    elencoBigliettiScaduti: 'Elenco titoli scaduti',
                    elencoBigliettiUsati: 'Elenco titoli utilizzati',
                    elencoBigliettiValidi: 'Elenco titoli in corso di validità',
                    goToMyTickets: 'Vai a "I miei Titoli"',
                    header: 'I miei Titoli',
                    infoTitoliAcquistati:
                        'Il titolo acquistato lo puoi trovare nella sezione "I Miei Titoli" del "Trasporto Interregionale"',
                    nessunBigliettoTrovato: 'Non sono stati trovati titoli di viaggio',
                    obliterati: 'Obliterati e validi',
                    ore: 'ore',
                    partenza: 'Partenza',
                    scadenzaTime: 'valido fino a',
                    validoFinoAl: 'Valido fino al',
                },
                soluzioniViaggio: {
                    andata: 'Andata',
                    arrivoA: 'Arrivo a',
                    avvisoDataDifferente:
                        'Non ci sono soluzioni per la data scelta.  Seguono le prime soluzioni disponibili.',
                    cercaFraLocalitaElencate: 'Cerca tra le località elencate',
                    cercaSoluzioni: 'Soluzioni di Viaggio',
                    descrizioneViaggio: 'Descrizione del viaggio',
                    dettaglio: 'Dettaglio Soluzione',
                    dettaglioAndata: 'Dettaglio Andata',
                    dettaglioRitorno: 'Dettaglio Ritorno',
                    header: 'Soluzioni di Viaggio',
                    infoCoperturaHTML:
                        "<b>Il sistema</b> sta coprendo l'intero territorio nazionale. Verifica quali comuni della tua zona sono raggiunti dal servizio di trasporto interregionale...",
                    infoPasseggero: 'Informazioni sul passeggero',
                    localitaDestinazione: 'Località di destinazione',
                    localitaPartenza: 'Località di partenza',
                    maxUnCambio: 'Al massimo un cambio',
                    mostraSoluzioni: 'Mostra Soluzioni',
                    mostraTutteLeDestinazioni:
                        'Sto mostrando tutte le destinazioni raggiungibili dalla località di partenza',
                    nessunCambio: 'Nessun cambio',
                    nomeObbligatorio: 'Nominativo obbligatorio',
                    partenzaDa: 'Partenza da',
                    riassuntoInfoAcquisto: 'Riassunto informazioni acquisto',
                    ritorno: 'Ritorno',
                    scegliDataRitorno: 'Scegli la data di ritorno',
                    scegliRitorno: 'Scegli viaggio di ritorno',
                    scegliTariffa: 'Scegli una tariffa',
                    selezionaDest: 'Seleziona località di destinazione',
                    soluzioneSenzaPosti: 'la soluzione selezionata non ha posti liberi disponibili',
                    tariffa: 'Tariffa',
                    tratta: 'Tratta',
                    tutteLeSoluzioni: 'Tutte le soluzioni',
                    viaggioRitorno: 'Viaggio di ritorno',
                    zoneCoperte: 'Zone raggiunte dal servizio',
                },
            },
            trasportoRegionale: {
                acquistaBiglietti: 'Acquista Titoli',
                acquistaSMS: {
                    acquistaAltroBiglietto: 'Acquista un altro biglietto',
                    confermaAcquistoTitolo: 'Il titolo di viaggio è stato acquistato',
                    elencoTitoliAcquistabili: 'Elenco dei titoli acquistabili',
                    erroreAcquisto: "Si è verificato un errore. Desideri riprovare l'acquisto?",
                    header: 'Acquista con SMS',
                    infoObliterazioneAuto: 'Il biglietto appena acquistato è stato obliterato automaticamente',
                    infoObliterazioneBiglietti: 'ogni biglietto acquistato va obliterato prima di essere utilizzato',
                    invioManualeSmsInfo:
                        'Impossibile inviare il messaggio. Manda un sms al numero {0} con il testo {1}',
                    invioManualeSmsTitle: 'Invio manuale SMS',
                    noArticoliVendibili: 'Non esistono articoli vendibili',
                    riassuntoInfoBiglietto: 'Riassunto informazioni biglietto',
                    richiestaInoltrataInfo:
                        'Gentile cliente, se la richiesta è andata a buon fine riceverà a breve il titolo acquistato via sms',
                    richiestaInoltrataTitle: 'Richiesta inoltrata',
                },
                acquistaScaffale: {
                    elencoTitoliAcquistabili: 'Titoli acquistabili a tariffa fissa',
                    elencoTitoliAcquistabiliActv: 'Elenco titoli di viaggio ACTV acquistabili',
                    elencoTitoliAcquistabiliMomup: 'Titoli acquistabili a tariffa fissa senza sovraprezzo',
                    gotoTitoliGT: 'Acquista titoli con prenotazione',
                    gotoTitoliSMS: 'Acquista con SMS',
                    header: 'Acquista Titoli',
                    headerActv: 'Acquista titoli ACTV',
                    infoAcquistoSms:
                        "Questo titolo di viaggio verrà acquistato utilizzando il <span class='bold'>credito telefonico</span> associato al numero di telefono che stai utilizzando.<br/> <br/>Il sistema di vendita SMS non prevede l'acquisto di titoli di viaggio di importi diversi ed inferiori rispetto a quelli di corsa completa da capolinea a capolinea. Non sono pertanto previsti rimborsi per di viaggi di percorrenza inferiore.</br> </br>Tutti i titoli di viaggio non sono rimborsabili<br/> <br/>Dopo l'invio della richiesta, riceverai un SMS di conferma da utilizzare come titolo di viaggio",
                    infoCoperturaATAC:
                        'I titoli possono essere utilizzati su tutti i servizi di superficie del circuito Metrebus: bus, tram e filobus Atac, mezzi di trasporto Roma TPL e Cotral.<br />In metropolitana il servizio è utilizzabile sulle linee A, B, B1, ferrovia Roma-Lido e sulla stazione Flaminio della ferrovia Roma-Viterbo.<br /><br />A breve il servizio sarà attivo sull’intera tratta Roma-Viterbo e sulla linea C.<br />',
                    infoCostiSms:
                        "Al costo del biglietto va aggiunto il costo dell'SMS di richiesta, che varia in base all'operatore telefonico di appartenenza.",
                    infoObliterazioneAuto: 'il titolo appena acquistato è stato obliterato automaticamente',
                    infoObliterazioneBiglietti: 'ogni biglietto acquistato va obliterato prima di essere utilizzato',
                    infoObliterazioneContestuale: "L'obliterazione è contestuale all'acquisto.",
                    infoTrenitaliaATAC:
                        'Come da direttiva Atac Spa, i titoli elettronici (Bit 100 e AIMOP) non sono momentaneamente validi sui mezzi Trenitalia. Per qualsiasi esigenza può contattarci scrivendo ad assistenza@mycicero.it o chiamando il numero 0719207000.',
                    noArticoliVendibili: 'Non esistono articoli vendibili',
                    origineDestinazione: 'Acquista da soluzioni di viaggio',
                    polimetrica: 'Abbonamenti extraurbani',
                    polimetrica2: 'Abbonamenti extraurbani',
                    riassuntoInfoBiglietto: 'Riassunto informazioni biglietto',
                    rinnovaAbbonamenti: 'Rinnova abbonamenti',
                    scegliTitoliTessera: 'Acquista titoli con tessera',
                    scegliTitoliTesseraActv: 'Acquista titoli con tessera',
                    smsDiAcquisto: 'Numero di telefono: {0} <br/> Messaggio: {1}',
                    titoliGT: 'Titoli con prenotazione',
                    titoliTessera: 'Titoli su tessera',
                    titoloSelezioneTessera: 'Acquista titoli su tessera',
                },
                acquistoTitoli: {
                    acquistaGratis: 'Scarica gratuitamente',
                    scegliComePagare: 'Scegli come pagare',
                    scegliComePagareFmt: 'Scegli come pagare {0}',
                    scegliTipologia: 'Scegli tipologia',
                    tipiDiAttivazione: {
                        automatica: 'Il titolo è attivo già al momento dell’acquisto.',
                        multipla:
                            'Il titolo va attivato manualmente al primo utilizzo. Occorre inoltre validare ad ogni accesso ai mezzi di trasporto.',
                        normale: 'Il titolo va attivato manualmente al primo utilizzo.',
                        obbligatoria: 'Il titolo va attivato manualmente al primo utilizzo.',
                    },
                    tipoDiAttivazione: 'Tipo di validazione:',
                },
                alCompleto: 'Completo',
                anticipo: 'Anticipo',
                arrivi: 'Arrivi',
                avvisoSD:
                    'Gentile utente, abbiamo verificato la possibile comparsa di anomalie di funzionamento quando l’applicazione è installata nella memoria esterna (scheda SD); per questa ragione dalle prossime versioni l’applicazione verrà installata solo nella memoria interna. Per evitare disservizi ti invitiamo a procedere, sin da ora ed in autonomia, allo spostamento manuale. Ci scusiamo per il disagio. Per ogni informazione contattaci su Assistenza@mycicero.it o allo 071 920 7000',
                avvisoSDAVM:
                    'Gentile utente, a seguito di anomalie che si verificano quando l’applicazione è installata nella scheda SD, dalle prossime versioni  verrà installata solo nella memoria interna. Per evitare disservizi ti invitiamo a procedere sin da ora allo spostamento manuale. Ci scusiamo per il disagio. Per informazioni scrivi su app.support@avmspa.it',
                cercaFermate: {
                    cercoPassaggi: 'Cerco Passaggi...',
                    codDescriz: 'Codice / Descrizione',
                    comune: 'Comune in cui cercare',
                    elencoFermate: 'Elenco Fermate',
                    elencoFermateTuaPosizione: 'Elenco fermate intorno alla posizione',
                    header: 'Cerca Fermate',
                    headerActv: 'Ricerca orari e percorsi',
                    indirizzo: 'Indirizzo',
                    indirizzoFermata: 'Indirizzo/Fermata',
                    inserisciIndirizzo: 'Inserisci indirizzo',
                    intornoA: 'Mostra fermate intorno a:',
                    lineeServite: 'Linee Servite',
                    mostra: 'Mostra Fermate',
                    mostraFermate: 'Mostra Fermate ...',
                    msgNoFermatePreferite:
                        'Non ci sono fermate preferite registrate.</p><p>Per aggiungerne una premi il tasto Salva" nel dettaglio di ogni singola fermata.</p>"',
                    nessunaFermata: 'Nessuna fermata trovata.',
                    nessunaLocalita: 'Nessuna località trovata',
                    noFermateVicine: 'Non ci sono fermate vicine alla posizione corrente',
                    noLineeServite: 'Nessuna linea servita',
                    noPassaggi: 'Non ci sono passaggi',
                    oppure: 'Oppure...',
                    passaggiNonPrevisti: 'Non sono previsti arrivi/partenze',
                    ricerca: 'Ricerca Fermate',
                    ricercheRecenti: 'Ricerche Recenti',
                    stazioneIndirizzo: 'Stazione o indirizzo',
                    tramiteCodDescr: 'Tramite codice o descrizione',
                    tuttiPassaggi: 'Tutti i passaggi a questa fermata',
                },
                cercaLinee: {
                    comune: 'Comune in cui cercare',
                    header: 'Cerca Linee',
                    indirizzo: 'Indirizzo...',
                    intornoA: 'Linee che passano intorno a',
                    mostra: 'Mostra Linee',
                    nessunaLineaTrovata: 'Non sono state trovate linee',
                    oppure: 'Oppure...',
                    ricerchePreferite: 'Preferiti',
                    ricercheRecenti: 'Recenti',
                    tramiteCodDescr: 'Tramite codice o descrizione',
                },
                cercaLocalita: 'Cerca località',
                cercaVettore: 'Cerca vettore',
                comuneAziendaEvento: 'Comune / Azienda / Evento',
                daConvalidare: 'Da convalidare',
                daObliterare: 'Da obliterare',
                daValidare: 'Da attivare',
                dettaglioCorsa: 'Dettaglio Corsa',
                dettaglioLinea: {
                    dettaglioLinea: 'Dettaglio Linea',
                    dimentica: 'Dimentica',
                    disponibilitaFermate: 'Disponibilità fermate:',
                    nessunaCoincidenza: 'Nessuna coincidenza',
                    nessunaFermata: 'Nessuna fermata',
                    ricorda: 'Ricorda',
                },
                elencoFermate: 'Fermate',
                elencoFermateA: 'Elenco fermate a: ',
                elencoLinee: {
                    descrizione: 'Descrizione',
                    direzione: 'Direzione',
                    elencoLinee: 'Elenco Linee nelle vicinanze',
                    elencoPercorsi: 'Percorsi della linea',
                    haiCercato: 'Hai cercato:',
                    noPercorsi: 'Non ci sono percorsi',
                    noSoluzioniVisibili: 'Nessuna linea',
                    nonDisponibile: 'Non Disponibile',
                    passaggio: 'Passaggio previsto',
                    passaggioAlle: 'Passaggio Alle',
                    passaggioOgni: 'Passaggi Ogni',
                },
                elencoMovimenti: {
                    header: 'Elenco Movimenti',
                },
                fermata: 'Fermata',
                fermate: 'Fermate',
                header: 'Trasporto Regionale',
                linee: 'Elenco Linee',
                mieiAbbonamenti: {
                    abbonamentiNonTrovati: 'Non ci sono abbonamenti validi su questo device.',
                    acquistaRinnova: 'Acquista/Rinnova',
                    articoliDisponibili: 'Articoli disponibili',
                    elencoAbbonamenti: 'Elenco Abbonamenti',
                    elencoTessereAttive: 'Tessere Attive',
                    extraUrbano: 'Extraurbano',
                    goToMyAbbonamenti: 'Vai a "Abbonamenti"',
                    header: 'Abbonamenti',
                    infoAbbonamentiNonTrovati:
                        'Non ci sono abbonamenti validi su questo device. Prova a caricare gli abbonamenti già esistenti cliccando il pulsante qui sopra.',
                    infoRequisitiAcquistoHTML:
                        'Per effettuare l\'acquisto è necessario associare una tessera del vettore scelto. Puoi aggiungerne una con pochi click, accedendo alla tua area riservata su <a href="#" style="text-decoration: none;">www.mycicero.it</a> tramite un PC tradizionale. A breve sarà possibile effettuare questa operazione anche da dispositivo mobile',
                    infoTitoliAcquistati:
                        'Puoi trovare il titolo di viaggio nella sezione "Abbonamenti" del "Trasporto Regionale""',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Una volta completato l\'acquisto per scaricare il titolo, entra nella sezione "Abbonamenti" ed aggiorna l\'elenco',
                    nessunaTesseraValida:
                        'Non risultano abbonamenti associati alle tue tessere, non è possibile procedere al rinnovo, per acquistare un nuovo abbonamento rivolgiti al tuo vettore.',
                    rinnovaAbbonamento: 'Rinnova Abbonamento',
                    scegliTessera: 'Scegli Tessera',
                    scegliVettoreAbbonamento: "Scegli il vettore di cui vuoi acquistare o rinnovare l'abbonamento.",
                    selezionaArticolo: "Seleziona l'articolo",
                    soluzioniPossibili: 'Soluzioni possibili',
                    templateTratta: 'Da {0} a {1}',
                    ultimaObliterazione: 'Ultima obliterazione',
                    urbano: 'Urbano',
                    validitaLinee: 'Valido per le linee',
                },
                mieiBiglietti: {
                    acquista: 'Acquista Titolo',
                    attivi: 'Attivi',
                    daobliterare: 'Da attivare',
                    elencoBigliettiDaObliterare: 'Elenco titoli acquistati da obliterare',
                    elencoBigliettiUsati: 'Elenco titoli utilizzati',
                    elencoBigliettiValidi: 'Elenco titoli in corso di validità',
                    finoAl: 'Fino al',
                    goToMyTickets: 'Visualizza titoli',
                    header: 'I miei Titoli',
                    infoTitoliAcquistati: 'Puoi trovare il titolo di viaggio nella sezione "Trasporto"',
                    noTitoliAttivi: 'Non sono stati trovati titoli attivi',
                    noTitoliDaObliterare: 'Non sono stati trovati titoli da validare',
                    noTitoliScaduti: 'Non sono stati trovati titoli scaduti',
                    obliterati: 'Obliterati e validi',
                    scadenzaTime: 'valido fino a',
                    scaduti: 'Scaduti',
                    validita: 'Validità',
                    validoDal: 'Valido dal',
                    validoFinoAl: 'Valido fino al',
                },
                mostraAltreFermate: 'Mostra altre fermate',
                mostraAltreLinee: 'Mostra altre linee',
                mostraAltreStazioni: 'Mostra altre stazioni',
                mostraAltriPassaggi: 'Mostra altri passaggi',
                obliterazioneAutomatica: 'Obliterazione automatica',
                partenze: 'Partenze',
                passaggi: 'Passaggi',
                percorsi: 'Percorsi',
                prossimoTra: 'Il prossimo è ',
                pulisci: 'Pulisci',
                ricaricaCredito: {
                    header: 'Ricarica Credito',
                    ricaricaActvWarning:
                        'Il credito residuo eventualmente presente a fronte di acquisti effettuati o da ricariche effettuate e non utilizzate, non è in alcun modo rimborsabile.',
                },
                ritardo: 'Ritardo',
                scaduti: 'Scaduti',
                scegliVettore: 'Cerca per comune, azienda o evento:',
                scegliVettorePlaceholder: 'Azienda/Evento',
                seiVicino: 'ti trovi qui vicino',
                servizioNonAttivo: 'Non hai ancora attivato il servizio "Trasporto pubblico". Ci vuole un attimo.',
                soluzioniViaggio: {
                    cercaCollegamentiLocali: 'Cerca collegamenti locali',
                    cercaSoluzioni: 'Cerca Soluzioni',
                    elencoSoluzioni: 'Elenco Soluzioni',
                    frequenzaOgni: 'Ogni',
                    header: 'Soluzioni di Viaggio',
                    headerAndata: 'Soluzioni di Andata',
                    headerRitorno: 'Soluzioni di Ritorno',
                    invertiDirezione: 'Inverti Direzione',
                    mostra: 'Mostra:',
                    mostraSuMappa: 'Itinerario su mappa',
                    nessunCollegamentoLocale: 'Nessun collegamento locale',
                    nessunaDestinazione: 'Nessuna destinazione trovata per il criterio di ricerca specificato',
                    nessunaSoluzione: 'Nessuna Soluzione di Viaggio trovata',
                    noSoluzioniVisibili: 'Non ci sono soluzioni visibili.',
                    nonAcquistabile: 'Soluzione non acquistabile',
                    nonTuttiBigliettiAcquistabili: 'Non tutti i biglietti sono acquistabili',
                    ordinaPerOrarioArrivo: 'Ordina per orario di arrivo',
                    ordinaPerOrarioPartenza: 'Ordina per orario di partenza',
                    ordinaPerSoluzioniAcquistabili: 'Ordina per soluzioni acquistabili',
                    ordinaPerTempoTotale: 'Ordina per tempo totale',
                    salvaRicercaPreferitaInfo:
                        'Per aggiungerne una premi il tasto "Salva" nella pagina di risultato della ricerca Soluzione di Viaggio.',
                    scambia: 'Scambia',
                    tempoTotale: 'Tempo totale',
                    tuttiBigliettiAcquistabili: 'Tutti i biglietti sono acquistabili',
                },
                tipoServizio: 'Tipo Servizio',
                trenitalia: {
                    altreInfo: 'Altre informazioni',
                    cartaFreccia: 'CartaFRECCIA',
                    condizioni:
                        "Il biglietto Elettronico regionale è emesso già convalidato. Non è possibile anticipare la partenza, non è ammesso il cambio del biglietto e non è rimborsabile. Il biglietto è nominativo e associato a nome e cognome inserito all'atto della registrazione on line o nei dati del viaggiatore; il biglietto acquistato online per viaggi sui treni regionali deve essere esibito - su richiesta del personale di controlleria - in formato cartaceo (prima di partire, stampa il PDF allegato alla mail di acquisto) oppure tramite schermata da supporto informatico (pc, tablet, smartphone) in grado di visualizzare correttamente file .pdf, unitamente ad un valido documento di identità.",
                    condizioniAcquistoTrenitalia:
                        'Accetto le <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/tcom/Informazioni/Condizioni-Generali-di-trasporto/Condizioni-Generali-di-trasporto\',true)">condizioni di trasporto</a> del vettore e ho letto l\'<a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/cms-file/html/trenitalia/Informativa_sulla_privacy.html\',true)">informativa sulla privacy</a>.',
                    infoTariffa: 'Info Tariffa',
                    menu: 'Trenitalia',
                    modificaBigliettoHeader: 'Modifica Biglietto',
                    modificaBigliettoMessage:
                        "<div class='textAlignLeft'><p>Per effettuare:<br/><ul><li>il cambio della prenotazione (data/ora di partenza)</li><li>il cambio del biglietto (città di partenza o arrivo; tipologia di biglietto; numero di viaggiatori etc)</li><li>la richiesta di rimborso per rinuncia al viaggio</li></ul></p><p class='bold'>Recati alla stazione ferroviaria più vicina e mostra questo titolo di viaggio.</p></div>",
                    percorsoFerroviario: 'Percorso',
                    popupDiniego: {
                        cancelLabel: 'Non voglio lasciare dati contatto',
                        confirmLabel: 'Inserisci dati contatto',
                        content:
                            'Non hai indicato dati di contatto per tutti i passeggeri. Trenitalia non potrà contattarli relativamente a questo viaggio',
                        title: 'Attenzione',
                    },
                    riepilogo: 'Riepilogo',
                    stazioneArrivo: 'Stazione di Arrivo',
                    stazioneNonValida: 'Stazione non valida',
                    stazionePartenza: 'Stazione di Partenza',
                    tariffe: 'Tariffe',
                    viaggioAndata: 'Viaggio di andata',
                    viaggioRitorno: 'Viaggio di ritorno',
                    vuoiModificareIlBiglietto: 'Vuoi modificare il biglietto?',
                },
                tutteLeLocalita: 'Tutte le località',
                vaiAlleImpostazioni: 'Vai alle impostazioni',
                validazioneAutomatica: 'Titolo validato automaticamente',
                zoneServite: {
                    header: 'Zone Coperte dal Servizio',
                },
            },
            travels: {
                details: {
                    header: 'details',
                },
            },
            treasureHunt: {
                abbandonaSquadra: 'Sei sicuro di voler abbandonare la squadra?',
                aggiornaProcedi: 'Aggiorna e procedi',
                aggiungiGiocatore: 'Aggiungi giocatore',
                cacciaAlTesoro: 'Caccia al tesoro',
                checkVideoCaricato: 'Sei sicuro di aver caricato il video e di voler proseguire?',
                codiceSquadra: 'Codice Squadra',
                comeFunziona: 'Come funziona?',
                compilaCampi: 'Compila i campi',
                compitoCompletato: 'Compito completato',
                completaPagamenti: 'Completa i pagamenti',
                countDownInizioGiocoAfter: 'Il gioco è iniziato da {0}',
                countDownInizioGiocoBefore: "Mancano {0} all'inizio del gioco",
                countDownInizioGiocoSame: 'Ci siamo...',
                createTeam: 'Voglio creare una nuova squadra',
                erroreAggiungiGiocatore: 'Impossibile aggiungere la persona alla propria squadra.',
                erroreCaricamentoGiochi:
                    'Si è verificato un errore durante il caricamento dei giochi. Riprovare più tardi.',
                erroreCaricamentoGioco:
                    'Si è verificato un errore durante il caricamento del gioco. Riprovare più tardi.',
                erroreCheckLocation: 'Spiacenti.<br />Si è verificato un errore.',
                erroreInfoTeam: 'Impossibile recuperare le info del team',
                erroreRimozioneGiocatoreQuotaPagata:
                    'Impossibile rimuovere il giocatore perché ha già pagato la quota di iscrizione.',
                erroreRimozioneGiocatoreQuotaSquadraPagata:
                    'Impossibile rimuovere il giocatore perché ha pagato la quota di iscrizione della squadra.',
                faseRisoltaDalTeam: 'Il tuo gruppo ha già risolto questa fase.',
                garaFinita: 'La gara è finita.',
                giocaNoSmartphone:
                    'In questa modalità il giocatore parteciperà alla Caccia ma non potrà utilizzare il suo smartphone.',
                giocatori: 'giocatori',
                gpsGenericError:
                    'Spiacenti.<br />Non hai fornito i permessi per recuperare la posizione GPS.Spiacenti.<br />Si è verificato un errore.',
                gpsPermissionDenied: 'Spiacenti.<br />Non hai fornito i permessi per recuperare la posizione GPS.',
                gpsPositionUnavailable: 'Spiacenti.<br />Non  è stato possibile recuperare la posizione GPS.',
                gpsTimeout:
                    "Spiacenti.<br/>Si è verificato un errore con il GPS. <br />Controlla lo stato dell'antenna GPS ed i permessi e riavvia l'app.",
                graziePerLaRisposta: 'Grazie per la risposta!',
                indizio: 'Indizio',
                infoIscrizione:
                    "L'iscrizione di ciascuno è valida a pagamento avvenuto. La squadra potrà giocare quando tutte le quote sono state pagate.",
                invitaGiocatore:
                    'Invia un invito ad un nuovo giocatore. Riceverà un codice tramite il quale potrà accedere direttamente al gruppo {0}.',
                invitaGiocatoreNoEmail:
                    "Il giocatore non ha un'email o un contatto social? Aggiungilo tu direttamente a {0}.",
                iscrizioneSquadra: 'Iscrizione squadra',
                iscrizioniChiuse: 'Siamo spiacenti, ma non puoi iscriverti a questa gara.',
                itinerariSorpresa: 'Itinerari a sorpresa',
                itinerarioSorpresa: 'Itinerario a sorpresa',
                joinTeam: 'Sono stato invitato ed ho un codice',
                luogo: 'Luogo',
                luogoGiusto: 'Complimenti!<br />È il luogo giusto.',
                luogoSbagliato: 'Spiacenti.<br />Non è il luogo giusto.',
                nessunGioco:
                    "Presto potrai trovare giochi divertenti per scoprire le bellezze della città di Lecce!<br />Cacce al tesoro, quiz e itinerari a sorpresa ti guideranno nei luoghi più caratteristici, attraverso la storia, l'arte e l'enogastronomia di una delle città più belle d'Italia.",
                nomeSquadra: 'Nome della squadra',
                nomeSquadraErrore: 'Massimo di 20 caratteri',
                pagaQuotaGiocatore: "Sei sicuro di voler pagare per il giocatore '{0}'",
                pagaQuotaSquadra: 'Sei sicuro di voler pagare la quota di iscrizione della squadra?',
                pagamentiNonCompletati: 'Non hai ancora completato i pagamenti',
                prossimoIndizioConPenalita: 'Prossimo indizio (ma perdi {0} punti)',
                quizzone: 'Quizzone',
                quotaGiocatoreNonPagata:
                    'Uno dei membri della squadra non ha pagato la quota. Eliminalo o paga la sua quota',
                quotaSquadraNonPagata: 'Per proseguire è necessario pagare la quota della squadra',
                raggiungiLuogo: 'Raggiungi il luogo',
                rimuoviGiocatore: 'Sei sicuro di voler rimuovere {0}?',
                rispostaEsatta: 'Risposta esatta',
                rispostaSbgliata: 'Risposta sbagliata',
                scegliNomeSquadra: 'Scegli un nome simpatico e facile da ricordare',
                shareEvent: "Condividi l'evento con i tuoi amici",
                svelamiLuogo: 'Sì, svelami il luogo',
                svelamiLuogoConPenalita: 'Svelami il luogo (ma perdo {0} punti)',
                tornaAlGioco: 'Torna al gioco',
                tornaAllInizio: "No, torna all'inizio",
                traguardo: 'Traguardo',
                verificaLuogo: 'Verifica se sono arrivato nel luogo giusto',
                whoo: 'Whoo-hoo!',
            },
            tua: {
                AcquistaBiglietti: 'Acquista<br/>titoli',
                AcquistaBigliettiHTML: 'Acquista<br/>titoli',
                CalcolaPercorsoHTML: 'Calcola<br/>percorso',
                FermateOrariHTML: 'Fermate<br/>ed orari',
                MieiTitoli: 'I miei<br/>titoli',
                MieiTitoliHTML: 'I miei<br/>titoli',
                SostaInAbruzzoHTML: 'Sosta in<br/>Abruzzo',
                UltimeNotizieHTML: 'Ultime<br/>notizie',
                bigliettiTariffaFissa: 'Biglietti a tariffa fissa',
                soluzioneNonAcquistabile:
                    'Purtroppo questo biglietto non è acquistabile al momento.<br/>Vuoi sapere quando sarà possibile?<br/><br/>Contattaci al numero <a href="tel:800762622">800762622</a> o manda una mail ad <a href="mailto:infotrasporto@mycicero.it">infotrasporto@mycicero.it</a>',
            },
            turismo: {
                buoniDisponibili: 'Buoni disponibili',
                buoniEsauriti: 'Buoni esauriti',
                buoniUtilizzati: 'Buoni utilizzati',
                caricaAltri: 'Mostra altri 10',
                caricamentoInCorso: 'Caricamento in corso',
                cerca: 'Cerca',
                cercaCoupon: 'Cerca Offerte Speciali',
                cercaCouponPlaceholder: "Cerca un'offerta",
                cercaEventi: 'Cerca Eventi',
                cercaEventiPlaceholder: 'Cerca un evento',
                cercaIndirizzoPlaceholder: 'Indirizzo o località',
                cercaItinerariPlaceholder: 'Cerca un itinerario',
                cercaItinerario: 'Cerca Itinerari',
                cercaPoi: 'Cerca Luoghi',
                cercaPoiPlaceholder: 'Cerca un luogo',
                cercaProdotti: 'Cerca prodotti',
                cercaProdottiPlaceholder: 'Cerca un prodotto',
                cercaServiziPlaceholder: 'Cerca un servzio',
                cercaServizio: 'Cerca Servizi',
                concluso: 'Concluso',
                condizioni: 'Condizioni',
                costoDelBuono: 'Costo del buono:',
                costoInCrediti: 'Costo in crediti:',
                couponCorrelati: 'Qui trovi anche',
                couponGratuito:
                    'Questo buono è gratuito e puoi averlo senza consumare crediti: ti basta cliccare su "Ottieni il buono" per poterlo attivare.',
                creditiConvertiti: 'Crediti convertiti:',
                creditiPerCouponsPresso: 'Hai ancora {0} crediti che puoi trasformare in buoni da spendere presso {1}',
                creditiPerCouponsTerminatiPresso: 'Non hai crediti sufficienti per ottenere buoni presso {0}',
                creditiResiduiTotali: 'Crediti residui totali',
                creditiRimanenti: 'Crediti rimanenti:',
                creditiTotali: 'Crediti totali:',
                creditoPerCouponsPresso: 'Hai ancora {0} credito che puoi trasformare in buoni da spendere presso {1}',
                dataAlle: '{0} alle {1}',
                dataCreazione: 'Data creazione:',
                dataDalleAlle: '{0} dalle {1} alle {2}',
                dataInizioDalleDataFineAlle: 'Dal {0} alle {1} al {2} alle {3}',
                dataInizioDataFine: 'Dal {0} al {1}',
                dataOra: 'Data e ora',
                detail: {
                    cellulare: 'Cellulare',
                    certificazioni: 'Certificazioni',
                    citta: 'Città',
                    contatto: 'Contatto',
                    costs: 'Ingresso',
                    couponCorrelati: 'Offerte speciali',
                    email: 'E-mail',
                    eventiCorrelati: 'Eventi correlati',
                    facebook: 'Facebook',
                    fax: 'Fax',
                    gestione: 'Gestione',
                    giorno: 'Giorno {0}',
                    header: 'Contatti',
                    indirizzo: 'Indirizzo',
                    itinerariCorrelati: 'Itinerari correlati',
                    luoghiCorrelati: 'Luoghi correlati',
                    navetteCorrelate: 'Navette che ti portano qui',
                    note: 'Note',
                    ospiti: 'Ospiti importanti',
                    promo: 'Promozioni',
                    propostoDa: 'Proposto da',
                    quando: 'Quando',
                    scaricaAllegati: 'Scarica i documenti allegati',
                    serviziInclusi: 'Servizi inclusi',
                    serviziUtili: 'Servizi utili',
                    sitoWeb: 'Sito web',
                    sitoWebOrganizzatore: 'Sito web organizzatore',
                    social: 'Social',
                    specialitaCorrelate: 'Prodotti correlati',
                    tappa: 'Tappa {0}:',
                    tel: 'Tel',
                    telefono: 'Telefono',
                    temi: 'Temi',
                    troviAnche: 'Promo correlate',
                    url: 'web',
                    vaiAlSito: 'Vai al sito',
                    zoneProduzione: 'Zone di produzione',
                },
                details: 'Dettagli',
                dettagli: 'Dettagli',
                diarioDiViaggio: 'Diario',
                downloads: 'Downloads',
                error: {
                    cantFilterAroundYou:
                        'Impossibile impostare il filtro "Intorno a te" se la posizione GPS non è disponibile.',
                    cantOrderByDistance:
                        'Impossibile impostare l\'ordinamento "Per distanza" se la posizione GPS non è disponibile.',
                },
                erroreGenerazioneQrCode: 'Si è verificato un errore durante la generazione del QR Code',
                esperienze: 'Esperienze',
                estendiRaggioRicerca: 'Estendi raggio di ricerca',
                eventi: 'Eventi',
                favorites: {
                    errorAddFavorites:
                        'Si è verificato un errore durante il salvataggio del preferito. Assicurarsi di essere connessi ad internet e riprovare.',
                    errorDeleteFavorites:
                        'Si è verificato un errore durante la cancellazione del preferito. Assicurarsi di essere connessi ad internet e riprovare.',
                    errorGetFavorites: 'Si è verificato un errore durante il caricamento dei preferiti.',
                    errorUpdateFavorites:
                        'Si è verificato un errore durante la modifica del preferito. Assicurarsi di essere connessi ad internet e riprovare.',
                },
                filters: {
                    afternoon: 'Pomeriggio',
                    allDay: 'Tutto il giorno',
                    aroundYou: 'Intorno a te',
                    cosa: 'Cosa',
                    dataSpecifica: 'Scegli data specifica',
                    everywhere: 'Ovunque',
                    fasciaOraria: 'Fascia oraria',
                    morning: 'Mattina',
                    night: 'Sera',
                    oggi: 'Oggi',
                    perData: 'Per data',
                    perDistanza: 'Per distanza',
                    perRilevanza: 'Per rilevanza',
                    perScadenza: 'In scadenza',
                    perSconto: 'Per sconto',
                    periodoSpecifico: 'Scegli periodo specifico',
                    prossimi30Giorni: 'Nei prossimi 30 giorni',
                    prossimi7Giorni: 'Nei prossimi 7 giorni',
                    quando: 'Quando',
                },
                filtra: 'Filtra',
                filtraEventi: 'Filtra eventi',
                filtraItinerari: 'Filtra itinerari',
                filtraLuoghi: 'Filtra luoghi',
                filtraOrdina: 'Filtra e ordina',
                filtraProdotti: 'Filtra i prodotti',
                filtraPromo: 'Filtra promo',
                filtraServizi: 'Filtra servizi',
                inserisciNota: 'Inserisci una nota...',
                itinerari: 'Itinerari',
                leggiCondizioni: 'Leggi le condizioni',
                luoghi: 'Luoghi',
                mostraQrCodeAllaCassa: 'Mostra il QR Code alla cassa per utilizzare il buono',
                neiParaggi: 'Nei paraggi',
                nessunPreferitoSalvato: 'Questa sezione è vuota per il momento.',
                noAvailableCoupons: 'Troverai qui i buoni da utilizzare',
                noCreditsReport: 'Qui troverai il riepilogo dei tuoi crediti',
                noResults: 'Nessun risultato trovato',
                noUsedCoupons: 'Troverai qui il riepilogo dei buoni che hai utilizzato',
                note: 'Note',
                numCrediti: '{0} crediti',
                numOfRemainingCoupons: '{0} buoni</br>rimanenti',
                offerteSpeciali: 'Offerte speciali',
                oneRemainingCoupon: '1 buono</br>rimanente',
                ora: 'Ora',
                ordina: 'Ordina',
                ordinaEventi: 'Ordina eventi',
                ordinaItinerari: 'Ordina itinerari',
                ordinaLuoghi: 'Ordina luoghi',
                ordinaPromo: 'Ordina promo',
                ordinaServizi: 'Ordina servizi',
                ottieniBuoni: 'Ottieni buoni',
                pisteCiclabili: 'Piste ciclabili',
                preferiti: 'Preferiti',
                preferitiDiarioViaggio: 'Preferiti e diario di viaggio',
                presso: 'Presso: {0}',
                prodotti: 'Prodotti',
                prodottiTipici: 'Prodotti tipici',
                promo: 'Promo',
                quantiBuoniVuoi: 'Quanti buoni vuoi?',
                ricercaIncorso: 'Ricerca in corso',
                rimuoviDataOra: 'Rimuovi data e ora',
                rimuoviOrario: 'Rimuovi orario',
                risultatiEntro: 'Hai cercato entro {0}',
                saldoRimanente: 'Saldo rimanente',
                scansionaQrCode: 'Scansiona QR Code',
                scansionaQrCodeAllaCassa: 'Scansiona il QR Code presente alla cassa',
                scaricaAllegati: '',
                scegliData: 'Scegli data',
                sconto: 'Sconto',
                servizi: 'Servizi',
                serviziUtili: 'Servizi utili',
                shopping: 'Shopping',
                toccaPerIngrandire: 'Tocca per ingrandire',
                trasformaCreditoInBuoni: 'Trasforma il tuo credito in buoni',
                trasformaTotCreditoInBuoni:
                    "Stai per utilizzare <span class='secondary bold'>{0}</span> per ottenere un buono sconto del valore di <span class='secondary bold'>{1}€</span> da spendere presso questo sponsor.",
                tuoiCreditiBuoni: 'I tuoi crediti e buoni',
                unCredito: '1 credito',
                utilizzaTuoiCrediti: 'Utilizza i tuoi crediti',
                utilizzatoIl: 'Utilizzato il:',
                validoFinoA: 'Valido fino a',
                valoreBuono: 'Valore buono:',
                valoreBuonoPressoSponsor: 'Questo sponsor mette a disposizione buoni da {0}€.',
                valoreCumulativoBuono: 'Valore cumulativo buono:',
                valoreInEuro: 'Valore in euro:',
                withinRange: 'Fino a {0}',
            },
            unicoc: {
                acquistaTicket: 'Acquista Ticket',
                calcolaPercorso: 'Calcola Il Percorso',
                mieiTitoli: 'I Miei Titoli',
                puntiVendita: 'Punti Vendita',
                trovaTariffa: 'Trova La Tariffa',
            },
            ventis: {
                cambiaZona: 'Cambia zona',
                effettuaLogin: 'Effettua il login',
                homeTitle: 'Ventis ti dà il benvenuto a {0}',
                hometitleNoPos: 'Ventis ti dà il benvenuto',
                infoCredito:
                    'Il tuo credito, caricandolo tramite Carta di Credito, MasterPass o Satispay. <b>Questa modalità NON prevede costi aggiuntivi.</b> Il credito può essere usato anche per acquistare titoli di viaggio e per tutti gli altri servizi disponibili.',
                loginMessage:
                    'Per poter utilizzare questa app è necessario accedere come utente registrato <b>Ventis</b>.',
                registrati: 'Registrati',
                requisitiAccesso: '',
                serviziTuttaItalia: 'I nostri servizi sono attivi in tutta Italia.',
                tutorial: {
                    subtitle1: 'Scopri i vantaggi riservati ai clienti Ventis',
                    subtitle2: 'Con Ventis Mobility paghi solo i minuti effettivi',
                    subtitle3: "Comodamente dall'app Ventis Mobility con un click",
                    subtitle4: 'Il sito da non perdere troverai grandi marchi con sconti fino al 70%',
                    subtitle5: 'Comodità e risparmio su misura per te',
                    subtitle6: '',
                    title1: 'Benvenuto in Ventis Mobility',
                    title2: 'Risparmia sul parcheggio',
                    title3: 'Acquista i biglietti di treno, bus e metro',
                    title4: 'Ventis.it',
                    title5: 'Tutto in una sola app',
                    title6: '',
                },
            },
            visitRomagna: {
                dormi: 'Dormi',
                erroreCaricamentoDati: 'Si è verificato un errore durante il caricamento dei dati.',
                fermati: 'Fermati',
                mostraTuttiEventi: 'Mostra tutti gli eventi',
                muoviti: 'Muoviti',
            },
        },
    },
    en: {
        translation: {
            account: {
                accedi: 'Login',
                accountNonAttivo: 'Account not verified',
                benvenuto: 'Welcome!',
                cambiaPassword: 'Change password',
                cambioEmailInserisciPinPage: {
                    annullaModifiche: 'Cancel the changes',
                    errorePin: 'Error: the PIN you entered is not correct',
                    inserisciPin: 'PIN',
                    istruzioniInserisciPIN:
                        'Please enter PIN verification code which you will find in the email sent to',
                    operazioneAvvenutaInfo: 'Operation successfully completed',
                    operazioneAvvenutaTitle: 'Your email has been successfully modified ',
                },
                cambioEmailPage: {
                    cambiaEmail: 'Change the email address',
                    emailAttuale: 'Current email',
                    eseguiCambioEmail: 'Confirm',
                    inserisciNuovaEmail: 'Choose a new email',
                    istruzioniPIN:
                        'You will receive an email with a verification code which shall be entered in the following screen.',
                    validazioneEmailInCorso: 'Currently verifying',
                },
                cambioPasswordPage: {
                    erroreCambioPassword:
                        'An error occurred during password change. Please, get in touch with our help desk to receive assistance.',
                    info:
                        'The new password must be composed by a minimum of<span class={0}">8</span> to a maximum of <span class="{1}">26</span> characters and <span class="{2}">contain at least a number</span>. <span class="{3}">Special characters are not allowed</span>.<br/><span class="{4}">The new password must differ from the previous password</span>."',
                    infoPassword:
                        'The password must include at least 8 characters, of which at least one shall be a number.',
                    inserisciNuovaPassword: 'New password',
                    inserisciPassword: 'Current password',
                    inserisciVecchiaPassword:
                        'Do you want to change password? For safety reasons please insert your current password:',
                    mostraPassword: 'Show password',
                    passwordDiverse: 'The two passwords must be corresponding',
                    passwordUguali: 'The new password must correspond with the old one',
                    procedi: 'Go-ahead',
                    ripetiNuovaPassword: 'Confirm new password',
                    success:
                        'Password was successfully changed. Please, login again with your username and new password.',
                },
                completaRegistrazione: 'Complete the Registration',
                completaRegistrazioneMsg: 'To proceed with this account, registration must be completed',
                confermaLogout:
                    'By proceeding, the current user will be disconnected. You will be able to login again by entering your username and password.',
                connessioneAssente: 'Login failed: internet is unreachable',
                dataIscrizione: 'Signed up on',
                datiErrati: 'Login failed: wrong username or password',
                datiNonCorretti: 'Wrong username or password',
                effettuaLogout: 'Logout',
                eliminazioneDati: {
                    eliminazioneLabel:
                        'Clicking on “Proceed” your account will be disconnected and your data will be cancelled pursuant to Regulation EU 2016/679 (GDPR) Note: after this operation you will be able to use the app for consultation',
                    eliminazioneTitle: 'WARNING: irreversible operation.',
                    errorTitle: 'An error occurred',
                    successoTitle: 'The operation was successfull',
                    successolabel: 'Your data will be cancelled within a working day',
                },
                emailInesistente: 'The e-mail address provided is not associated to any active account',
                emailNonValida: 'Invalid email',
                emailVuota: 'Insert your e-mail address',
                login: 'Login',
                loginPage: {
                    accedi: 'Log in to your account:',
                    effettuaAccesso: 'Login',
                    iscrivitiAmyCicero: 'Sign up!',
                    mostraPassword: 'show password',
                    nessunAccount: "Don't you have an account?",
                    seHaiGiaUnAccount:
                        'If you already registered an account with <span class="highlighted"> autobus.it</span>, you can use the same credentials',
                },
                logout: 'Logout',
                logoutEffettuato: 'User disconnected',
                logoutUtente: 'User logout',
                passwordDimenticata: 'Forgot your password?',
                passwordDimenticataPage: {
                    email: 'Email address',
                    erroreResetPassword:
                        'An error occurred while resetting your password. Please, get in touch with our help desk to receive assistance',
                    impossibileResettarePassword:
                        'The system cannot reset your password at the moment. Please, try again later or get in touch with our help desk to receive further assistance',
                    info:
                        'Write the email address you used for the registration. You will receive a temporary password.',
                    sendPasswordTemporanea: 'Send me a temporary password',
                    success:
                        '<p>A temporary password was sent to the email address: </p><p class="textAlignCenter"><b>{0}</b></p><p>No instruction received?<ul><li class="fontSizeTiny">Check your spam</li><li class="fontSizeTiny">Check the email address rpovided</li><li class="fontSizeTiny">Try again in a few minutes</li><li class="fontSizeTiny">You could have used a different email address for your registration</li></ul></p>',
                },
                passwordNonValida: 'Invalid password',
                profilo: {
                    accedi: 'Log into your profile',
                    accediAccount: 'Login',
                    gestioneTarghe: 'Manage your registered cars',
                    gestisciCarteCredito: 'Manage Credit Cards',
                    header: 'User Profile',
                    impostazioniNotifica: 'Notification settings',
                    preferenzeSosta: 'Parking options',
                    uploadImmagineProfiloFail: 'It is impossible to modify your user image. Please, try later',
                    uploadImmagineProfiloRetry:
                        'A problem occurred while sending the image to the server. Would you like to try again?',
                    uploadImmagineProfiloWait:
                        'The image was saved and is now being processed, so it could not be immediately visible',
                    v2: {
                        apps: {
                            header: 'Connected app',
                        },
                        associaTessera: 'Associate a new travel card',
                        cambiaFotoProfilo: 'Change your profile image',
                        chattaConAssistenza: 'Chat with our support service',
                        condividi: 'Share…',
                        datiFatturazione: {
                            aggiungiProfiloFatturazione: 'Add the invoicing data',
                            attivaFatturazione: 'I need the invoice',
                            confermaEliminazioneProfilo: 'Are you sure you want to delete the invoicing data?',
                            confermaModificaProfilo: 'Are you sure you want to change the invoicing data?',
                            confermaRitornoAlProfilo: 'Would like to go back to your profile page anyway?',
                            genericError: 'Fill correctly the mandatory gaps in red',
                            header: 'Invoicing data',
                            infoFatturazione:
                                'Please notice that the invoice/receipt will be sent by email only for the parking companies and for the services which provide issuance of invoice/receipt: in all the other cases, a payment confirmation will be sent',
                            label: 'Invoicing data',
                            modificaProfiloFatturazione: 'Change the invoicing data ',
                            modificheSalvate: 'Your changes have been saved',
                            profiloSalvato: 'Your invoicing data have been saved',
                            rimuoviProfilo: 'Delete the account…',
                        },
                        datiPersonali: {
                            cambia: 'Change',
                            haiTesseraAssociata: 'You have a card associated',
                            header: 'Personal data',
                            label: 'Personal data',
                            nonPuoiModificareDati:
                                'Your personal data have already been updated and cannot be further modified. For any requests, please send an email to',
                            perCancellareUtente: 'Please send a request to',
                            vuoiCancellareUtente: 'Would you like to delete your account?',
                        },
                        elencoMovimenti: 'Transaction list',
                        eliminaDatiPersonali: 'Cancel personal data',
                        eliminazioneDatiPersonali: 'Cancel personal data/account cancellation',
                        eliminazioneDatiPersonaliModalContent:
                            'Are you sure you want to cancel your data? <br> Remember: This operation is <b>irreversible</b>',
                        esci: 'Exit',
                        gestioneAffiliazioni: 'Manage affiliation',
                        gestioneCarte: 'Manage your cards',
                        gestioneCreditiMobilita: 'Mobility credits managing',
                        ilTuoCredito: 'Your credit',
                        linguaApplicazione: 'App language',
                        notifichePush: 'Push notifications',
                        preferenzeConsultazione: {
                            deselezionaTutto: 'Deselect all',
                            erroreCaricamento: 'An error occurred during favourites loading. Please, try later.',
                            erroreSalvataggio: 'An error occurred during favourites saving. Please, try later.',
                            header: 'Browsing Preferences',
                            infoGestione: 'Manage and edit your content browsing preferences',
                            label: 'Browsing Preferences',
                            nessunServizioInPreferenze:
                                'You have saved no services in your preferences. You can manage your preferences in "Consulting preferences" accessible by your profile. If you prefer to see all services click again on "Apply preferences" to remove filter on content visibility.',
                            salvaModifiche: 'Deselect all',
                            selezionaTutto: 'Select all',
                        },
                        preferenzePush: {
                            header: 'Push notifications',
                        },
                        ricaricaCredito: 'Top up credit',
                        sosta: {
                            comePagare: 'How to pay',
                            gestioneTarghe: 'Manage your cars',
                            gestisciZsr: 'Manage Seasonal Ticket Code',
                            header: 'Parking and ZTL',
                            preferenze: 'Preferences',
                        },
                        tesseraAssociataConSuccesso: 'Card {0} successfully associated!',
                        tiPiaceMyCicero: 'Do you like myCicero?',
                        trasporto: {
                            header: 'Transport',
                            notificheScadenzaTitolo: 'Notice about tickets expiry date',
                            scadenzaTitoli: {
                                description: 'Enable notice about imminent expiry date of tickets',
                                header: 'Notification for ticket expiry date ',
                            },
                            tessere: 'Travel Cards',
                        },
                        vaiAlleTessere: 'Go to your cards',
                    },
                },
                registrati: 'Sign up',
                settings: {
                    allFavConfermaDelete:
                        'If proceeding, all saved stops and solutions will be removed. This operation cannot be undone.',
                    allFavRimossi: 'Favourite stops and solutions removed',
                    cardAssociate: 'Cards linked to this user',
                    fermateFavConfermaDelete:
                        'By proceeding, all saved stops will be removed. This operation cannot be undone.',
                    fermateFavRimosse: 'Favourite stops have been removed',
                    gestisciPosizione: 'Handle localization',
                    pulisciDati: 'Remove personal data from device',
                    raggioRicerca: 'Range of search around your position',
                    rimuoviFermateFav: 'Remove favourite stops',
                    rimuoviSoluzioniFav: 'Remove favourite solutions',
                    soluzioniFavConfermaDelete:
                        'By proceeding, all saved solutions will be removed. This operation cannot be undone.',
                    soluzioniFavRimosse: 'Favourite solutions removed',
                    utenteAssociatoCard: 'This user is linked to the card',
                },
                utente: 'User',
                zsr: {
                    associaZSRDescriptionHTML:
                        '<span>Link your profile (where your plate number is registered) to the subscription for parking on blue lines</span>',
                    associaZSRHeading: 'Combine Member Code',
                    associazioneFail: 'Non recognized code',
                    associazioneSuccess: 'Partner code',
                    codiceIdZSR: 'Member code',
                    comeOttengo: 'How can I have it?',
                    dataDiNascita: 'Date of birth',
                    failureHeading: 'Code not recognized',
                    idZSR: 'ZSRid: ',
                    riprovaAssociazione: 'Try association again',
                    successHeading: 'Associated code',
                },
            },
            affiliazioni: {
                common: {
                    budgetMensile: 'Your monthly budget with wallet is: <span class="bold secondary">{0}</span>',
                    confermaFineSostaChild: 'Payed with credit of <span class="bold secondary">{0}</span>:',
                    descrizioneTarga: 'Short name',
                    numeroTarga: 'Number plate',
                    rimuoviAffiliazione: 'Remove affiliation',
                    serviziAbilitati: 'Enabled services',
                    sosta: 'Parking',
                    sostaTargheLimitate: 'Park only with number plates',
                    spesaMensile: 'Your monthly cost is: <span class="bold secondary">{0}</span>',
                    targaGiaInserita: '{0} is already registered into the list of authorized number plates ',
                    trasporto: 'Transport',
                },
                creaModificaAffiliazione: {
                    aggiorna: 'Refresh',
                    alias: 'Alias',
                    aliasEsempio: 'eg. Mario Rossi',
                    emailInfoPlaceholder: 'eg. mario.rossi@gmail.com, luca.verdi@gmail.com',
                    erroreValidazioneEmail: "Email address format '{0}' is not correct",
                    erroreValidazioneImportoSpesaMassimaMensile: 'Choose monthly limit expense',
                    headerSezione: {
                        durataLimite: 'Monthly duration and limit',
                        sosta: 'Parking and ztl',
                        trasporto: 'Transport',
                    },
                    infoEmail:
                        'Please, insert the email addresses of users who can buy using your wallet. Please, separate each address by a comma.',
                    inviaRichiesta: 'Send request',
                    limitaDurata: 'Duration limit',
                    limitaSpesa: 'Monthly cost limit (€)',
                    messaggioRichiestaAffiliazione: 'Affiliation request sent',
                    messaggioRimozioneAffiliazione: 'Affiliation removed',
                    messaggioUpdateAffiliazione: 'Affiliation refreshed',
                    modificaAffiliazione: 'Modify affiliation',
                    nuovaAffiliazione: 'New affiliation',
                    permettiPagamento: 'Allow payment',
                    qualsiasiTarga: 'Any number plate',
                    spesaAttuale: 'Current monthly expenditure: ',
                    targheAbilitate: '{0} registered number plates',
                    targheSpecifiche: 'With specific number plates',
                },
                dettaglioAffiliazione: {
                    limiteSpesaMensile: 'Monthly cost limit',
                    seiAbilitato: 'You can use credit of ',
                    spesaAttuale: 'Current cost',
                },
                elencoMovimenti: {
                    delegatoA: 'Payment authorized to',
                    pagatoPer: 'Payment fulfilled by',
                },
                gestioneAffiliazioni: {
                    cercaNomeEmail: 'Search name or mail',
                    creaNuova: 'Search new',
                    funzionalita: 'Functions',
                    gestioneTargheRicorrenti: 'Shared number plates',
                    infoAffiliazioneChild:
                        'In this place you can check the list of<br/>users who have shared their<br/>wallet with you.',
                    infoAffiliazioneParent:
                        'You can share<br/>your wallet with some users, allowing them to make their own<br/>purchases and payments. You can choose to limit<br/>some services access. In addition you can define<br/>a list of number plates for parking.',
                    richiesteInAttesa: 'Waiting requests',
                    tabs: {
                        childView: 'Pay by',
                        parentView: 'Allow payments to',
                    },
                    title: 'Manage affiliations',
                },
                gestioneTargheAutorizzate: {
                    aggiungiRiccorrenti: 'Add shared number plates',
                    elencoAutorizzate: 'List of authorized number plates',
                    gestisciRiccorrenti: 'Shared number plates',
                    importaRicorrenti: 'Import by shared number plates ',
                    infoTargheRicorrenti:
                        'You can assign this number plate to other permissions without insert it again anytime',
                    inserisciTargaConRicorrenti: 'Or insert a new number plate',
                    inserisciTargaSenzaRicorrenti: 'Insert a new number plate',
                    targaInRicorrenti:
                        "{0} is registered in the list of shared number plates. You can import one or more number plates into section 'Import by shared number plates'",
                    targheAutorizzate: 'Allowed by {0}',
                    title: 'Authorized shared number plates',
                },
                gestioneTargheRicorrenti: {
                    aggiungiTarga: 'Add shared number plate',
                    elencoRicorrenti: 'Shared number plates list',
                    title: 'Shared number plates ',
                },
                importaTargheRicorrenti: {
                    descInfoTargheRicorrenti:
                        'If you chose to assign "All number plates" you will allow both the use of those already registered and of those that you will add in the future. Otherwhise you can select only the ones that you want to make available.',
                    title: 'Import other shared number plates ',
                    titleInfoTargheRicorrenti: 'Choose the number plates to associate to the user',
                    tutte: 'All',
                },
                richiestaAffiliazione: {
                    durataModalita: 'Duration and modalities',
                    info: 'would like to share his/her wallet with you',
                    messaggioAffiliazioneAccettata: 'Affiliation accepted',
                    messaggioAffiliazioneRifiutata: 'Affiliation refused',
                    spesaMassimaMensile: 'Greatest monthly cost',
                    title: 'Affiliation request',
                },
            },
            amt: {
                homepage: {
                    benvenutiCatania: '<span>Welcome in</span><span class="bold">Catania</span>',
                    biglietteriaTitle: 'Ticket offices and stores',
                    carSharingTitle: 'Carsharing',
                    parcheggiTitle: 'Parking',
                    trasportoAcquisti: 'Purchases',
                    trasportoAcquisto: 'Purchase',
                    trasportoSubtitle: 'Info & Ticket',
                    trasportoTitle: 'Transport',
                },
            },
            amtab: {
                homepage: {
                    autobus: 'autobus',
                    sosta: 'parking',
                },
            },
            app: {
                appBloccata: 'App locked',
                cambioDispositivo: 'Device change',
                description: 'Welcome to $t(app.name)!',
                dontAskAnymore: "Don't ask me anymore",
                exitMessage: 'Are you sure you want to log out?',
                exitTitle: 'Logout',
                fineSupportoIOS6Messaggio:
                    'Dear user, your operating system version is lower than the 7. This version does not make us able to be up with last technological developments. The next myCicero version will not be compatible with your operating system. In order to be able using our services update iOS to the version 7 or successives. ',
                grazieMyCiceroTemplate:
                    'Thanks for using our services. If you think they are useful, why don’t you leave a comment on {0}?',
                iOSNotCompatible:
                    'To buy ATAC tickets, your mobile phone should be updated at least to version 8. For further information, call 071 920 7000 or send an email to assistenza@mycicero.it',
                msgCambioDispositivo:
                    '{0} has already bought tickets with another mobile phone. If you confirm, the tickets which were previously bought will no longer be available in the old device. For further information, call 071 920 7000 or write an email to assistenza@mycicero.it',
                msgTelefonoImpegnatoAltroAccount:
                    'This device has already been used by another user for buying tickets. For further information, call 071 9207000 or write an email to assistenza@mycicero.it',
                name: 'Wepps',
                no: 'No',
                pubblicaRecensione: 'Publish Review',
                recensisciMyCicero: 'Review the app',
                ricordaDopo: 'Remember me later',
                supportoIOS6: 'System upgrade',
                updateAppMessage: 'Please, update the app to the latest version',
                waitdetail: 'Request in progress',
                waitmessage: 'Please wait',
                wpNonCompatibile:
                    'To buy ATAC tickets it is necessary to have an iOS or Android smartphone. For any further information, please call the (+39) 071 920 7000 or send an e-mail to assistenza@mycicero.it',
                yes: 'Yes',
            },
            arriva: {
                homepage: {
                    navette: 'Special services',
                },
            },
            aspo: {
                fatturazioneDisclaimer:
                    'Attention please: payment receipt will be monthly sent by email for parking services only. All users will receive a payment confirm per email.',
                qrCodeFermata: 'QR code scan',
                qrCodeFermataSubtitle: 'Bus stop info',
                rivendite: 'Ticket offices and stores',
            },
            atc: {
                homepage: {
                    benvenutiLaSpezia: 'Welcome to La Spezia',
                },
                trasporto: {
                    acquistaBiglietti: 'Buy tickets',
                    calcolaPercorso: 'Plan route',
                    fermateOrari: 'Stops and schedules',
                    mieiTitoli: 'My tickets         ',
                },
            },
            atcgo: {
                acquistaBigliettiHTML: 'Buy<br/>tickets',
                calcolaPercorsoHTML: 'Calculate<br/>route',
                fermateOrariHTML: 'Stops<br/>and schedules',
                luoghi: 'Places',
                mieiTitoliHTML: 'My<br/>tickets',
            },
            autoguidovie: {
                AcquistaBiglietti: 'Buy<br/>tickets',
                CalcolaPercorso: 'Plan route',
                CalcolaPercorsoHTML: 'Plan<br/>route',
                ElencoMovimenti: 'Transactions</br>list',
                FermateOrari: 'Stops and schedules',
                FermateOrariHTML: 'Stops and<br/>schedules',
                MieiTitoli: 'My<br/>tickets',
                ServiziTuristici: 'Tourist<br />services',
            },
            autoricarica: {
                labelToggleAttiva: 'Activate',
                title: 'Automatic topup',
            },
            avm: {
                addAnagraficaDisclaimer:
                    'To require invoices for local public transport services or integrated mobility (on-street parking) managed by AVM/Actv, please fill in the form in this link: <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/request-an-invoice\',true)">http://bit.ly/request-an-invoice</a>. <br /> Once that you have completed the form, you will receive the “client code” and you’ll be able to require invoices for local public transport tickets bought by AVM Venezia Official App, filling out the following form:',
                addAnagraficaDisclaimer2:
                    'Warnig: invoice/receipt will be sent monthly by AVM only after providing Client Code. To all our clients will always be sent payment confirmation.',
                addAnagraficaError1: 'You need to fill up this form',
                addAnagraficaError2: "You can fill only the category field 'VAT number' or 'Fiscal Code'.",
                addAnagraficaError3: "One field at least between 'VAT number' and 'Fiscal Code' has to be filled.",
                addAnagraficaError4: "You have to specify a 'Client Code'",
                addAnagraficaErrorANV: 'Not valid account',
                addAnagraficaErrorBLK: 'Account locked',
                addAnagraficaErrorECF: "VAT number' or 'Fiscal Code' not corresponding to account.",
                addAnagraficaErrorERR: 'An error occurred',
                addAnagraficaErrorINV: 'Not valid Input',
                addAnagraficaErrorNFD: 'Client Id not found',
                areaNonServitaHtml:
                    'Check if in this area the parking is subject to payment by reading the closest vertical road sign. </br>Be sure that the pointer is placed in the center of the roadway and optionally choose the route where you are parking from the item "LIST". </br> For technical problems, fill in the WebForm <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/AssistanceAppAVM\',true)">http://bit.ly/AssistanceAppAVM</a>',
                benvenutiVenezia: '<span>Welcome in </span><span class="bold">Venice</span>',
                calcolaPercorso: 'Calculate route',
                caricaIlTuoVoucher: 'Charge your voucher',
                caricaVoucher: 'Charge voucher',
                caricaVoucherDescription: 'Insert Venezia Unica PNR code of your voucher',
                caricaVoucherPlaceholder: 'Insert your voucher',
                caricoCliente:
                    'It is up to the customer to evaluate the remaining time validity before starting the journey.',
                condizioniContent:
                    "<div> <h2><strong>TERMS AND CONDITIONS OF USE</strong></h2> <h3><strong>1. Field of application</strong></h3> <p>These Terms and Conditions of Use govern the relationship between the User and Azienda Veneziana per la Mobilità (hereafter referred to as AVM) regarding the purchase of local public transport tickets through the use of AVM Venezia official APP<br/> Terms, conditions and regulations governing operations and methods of access and use of public transport, obligations and responsibilities of the transport company and passenger can be found in General Transport Conditions published on site.<br/> The APP can only be downloaded and used on smartphones.</p><h3><strong>2. Meaning of terms and conditions of use</strong></h3> <p>When the user registers and downloads the APP, compatible with his/her smartphone's operating system, he (the user) completely accepts, and is subject to all the associated store's terms and conditions of use, without exception.<br/> AVM reserves the right to unilaterally modify in any moment, these present terms and conditions of use. Each time the user accesses the APP, it is his responsibility to verify any possible modifications; the APP's use implies total acceptance of the terms and conditions.</p><h3><strong>3. Instructions for use</strong></h3> <p>The purchase of a travel ticket through the APP is at the User's exclusive risk. For this purpose the user must protect his mobile device from unauthorized use. In order to minimize possible damages, the User undertakes to immediately advise AVM regarding any suspect of unauthorized use of the smartphone, his account or the APP.<br/> When using the APP (i.e. purchasing a ticket) for the first time, the User must follow the registration instructions and insert the information required by the APP. For any further purchases, the User need only log in by inserting his e-mail address and password.<br/> Once registered, the User is the only person responsible for all activities conducted through his personal account. AVM declines any responsibility relating to errors committed by the User during the registration.<br/> For correct service, when the user downloads the APP onto his smartphone, he must give AVM his personal information, e-mail address and the smartphone device phone number. It is the User's responsibility to verify the correct registration of his personal information.<br/> The User is the only person responsible for the secrecy of his password: should the User suspect of such secrecy being violated, he must immediately modify his password.</p><h3><strong>4. Method of use</strong></h3> <p>Tickets must be purchased before accessing transport means. The User is permitted to purchase tickets for anyone travelling with him.<br/> Payment can only be made with a credit card, including prepaid ones adhering to the Visa/Mastercard circuit The User's credit card information must be inserted after registration or when buying. Once the transaction has been concluded, a receipt of payment will be sent to the User's e-mail address.<br/> Ticket purchased through an APP, must always be validated before the journey begins.<br/> At public transport access areas equipped with turnstiles and QR code readers, the user must visualize the pertinent QR Code and insert the smartphone into the slot. The validity period of the ticket begins, at the moment of scanning.<br/> If the turnstile does not have a QR code reader, or even in the case of a turnstile not being present (e.g. for bus services) validation can be carried out by clicking on the specific icon on the smartphone screen. In this case, validation will be postponed by three minutes.<br/> It is the User's responsibility to guarantee the good functioning of his mobile phone device for the whole length of his journey, should a ticket controller consider it necessary to visualize the validated ticket. Failure to do so, because of bad or incorrect functioning of the mobile device involves the same penalties, as those foreseen and approved for ticket irregularities in General Transport Conditions.</p><h3><strong>Complaints and responsibility</strong></h3> <p>It is not possible to refund or change tickets purchased through the APP.<br/> It is not possible to transfer tickets to other mobile devices. They can be only used in conjunction with the device from which the transaction was done. Any malfunction causing the loss of a ticket or any travel document is solely and exclusively the user's responsibility, and in no case will AVM provide a refund for lost/irrecoverable tickets.<br/> AVM will only refund in the case of a wrong debit determined as an error in the system of payment.</p><h3><strong>Right of Withdrawal</strong></h3> <p>The User can uninstall the APP in any moment and without giving any notice.<br/> Any tickets that have already been purchased and not used, will not be refunded.<br/> <h3><strong>Norms on Privacy</strong></h3> <p>When the User installs the App, he declares and accepts AVM to access, keep and process his personal information and any contents associated with the APP's use, if required by law or if such activities are necessary for the APP's use, i.e. services provided through the APP, in respect of Legislative Decree 196/2003 “Regulations regarding management of personal information”.<br/> The User acknowledges and accepts the use of the APP as a means of electronically transmitting information in communication networks.<br/> More details about how AVM manages personal information is available from site.<br/> Ownership information: Azienda Veneziana della Mobilità spa, Isola Nova del Tronchetto 33, Venice.</p><h3><strong>Intellectual Property</strong></h3> <p>By downloading the APP, the User accepts and acknowledges that it is protected by legislation regarding intellectual property, and other applicable regulations, including, but not limited to, copyrights. The User accepts to use such information covered by monopoly and material exclusively for the use of the service offered, while respecting regulations in the present Terms and Conditions of Use. No part of the APP nor products offered, can be reproduced in any form, nor with any means, excepting that permitted in the present conditions. The User accepts not to modify, rent, hire, lend, sell, distribute, or create anything based on this present APP, in any way, and may not exploit the APP or the products purchased in an unauthorized way.<br/> All copyrights related to the APP are AVM property and/or its licensees. The use of any APP component, except for use permitted under these Terms and Conditions, is strictly prohibited; it violates third party intellectual property rights and may subject the User to civil and penal fines, including possible monetary damage, for violation of copyrights.<br/> AVM, the AVM logo and other AVM Group trademarks/brands, graphic symbols and logos used in connection with the APP represent brands or registered brands of the AVM group. The User has no right or authorization to use, or make reference to any brand mentioned.</p></div>",
                condizioniHeader: 'TERMS AND CONDITIONS',
                condizioniVeneziaUnica: 'Venezia Unica terms of use',
                infoMobilita: ' Rides timetables from/to educational institutes',
                messageCondizioniBorsellino:
                    "I have read and understood <a class='condizioni-borsellino'>Terms and Conditions</a> of credit usage.",
                messaggioInformativoSosta: 'Verify on signage if you have to pay in this area.',
                ricercaOrari: 'Search timetables at stops',
                sezioneVoucher: 'You find tickets in section "my vouchers"',
                sostaItem: 'active',
                sostaSubTitle: 'Info & Ticket',
                sostaTitle: 'Parking',
                trasportoItem: 'Purchases',
                trasportoSubTitle: 'Info & Ticket',
                trasportoTitle: 'Transport',
                vaiAiVoucher: 'Go to my vouchers',
                verificaAcquisto:
                    "Check out 'Buy Tickets' section if there are cheaper tariff solutions compared to your travel needs (card tickets or day tickets)",
                viaggia: {
                    abbonamenti: 'Buy tickets on Venezia Unica',
                    acquistoOd: 'Buy out-of-town tickets',
                    acquistoOdTessera: 'Buy out-of-town tickets on Venezia Unica',
                    header: 'Travel',
                    tariffaFissa: 'Buy time-specific ticket',
                },
                voucherItem: 'Voucher',
                voucherSubTitle: 'Voucher',
                voucherTitle: 'Charge your',
            },
            biglietto: {
                acquistatoIl: 'Purchased at',
                atac: {
                    aimop: {
                        descrizioneAggiuntiva:
                            'Tickets are issued with effective and expiry date, that means they are already active. Seasonal tickets bought within the 24th of each month are also already active because they are valid for the current month. Seasonal tickets bought after the 24th are automatically valid from the following month.',
                        note:
                            'To travel by subway trains show the QRCode to the scanner of the tickets barriers, or, if you have an Android device with NFC, place it near the NFC reader on the barriers.',
                        tipoValidazione: 'Automatically activated',
                    },
                    bit100: {
                        descrizioneAggiuntiva:
                            'Valid for 100 minutes after first validation on surface transit (bus, tram and trolleybus). For the subway, the ticket will be valid for a single ride, even on more lines without need to cross the ticket barriers.',
                        note:
                            "<p class='bold'>Validity:</p><p>100 minutes validity from first activation on Bus, Trolleybus, Tram and Metro C. 1 ride only for Metro A, B, B1 also for more lines without need to cross the barriers. 1 ride only for Trains.</p><p class='bold'>Area of use:</p><p> It can be used for all Metrebus surface transport services: Bus, Trolleybus, Tram and Metro C, RomaTPL and Cotral means of transport, Ferrovia Roma-Lido e Ferrovia Roma  – Viterbo</p><p class='bold'>How you can use it</p><p>Ticket is valid only if activated. To travel in the metro, show the QrCode to the scanner on the barrier. If you have a device with NFC technology, open the ticket on the screen and put it in contact with the NFC reader on the barrier. After ticket activation for Metro A, B and B1, you will have2 minutes to cross the barriers.</p>",
                        tipoValidazione: 'Instructions for first use, before entering the means',
                    },
                    brm24: {
                        descrizioneAggiuntiva: 'Valid for 24 hours from first activation',
                        note:
                            'To travel by subway trains show the QRCode to the scanner of the tickets barriers, or, if you have an Android device with NFC, place it near the NFC reader on the barriers.',
                        tipoValidazione: 'Instructions for first use, before entering the means',
                    },
                    brm48: {
                        descrizioneAggiuntiva: 'Valid for 48 hours from first activation',
                        note:
                            'To travel by subway trains show the QRCode to the scanner of the tickets barriers, or, if you have an Android device with NFC, place it near the NFC reader on the barriers.',
                        tipoValidazione: 'Instructions for first use, before entering the means',
                    },
                    brm72: {
                        descrizioneAggiuntiva: 'Valid for 72 hours from first activation',
                        note:
                            'To travel by subway trains show the QRCode to the scanner of the tickets barriers, or, if you have an Android device with NFC, place it near the NFC reader on the barriers.',
                        tipoValidazione: 'Instructions for first use, before entering the means',
                    },
                    hai2Minuti: 'You have 2 minutes to cross the barriers',
                    vuoiAttivareTitolo: 'Do you want to activate the ticket?',
                    vuoiAttivareTitoloBus:
                        '<div class="secondary textAlignCenter fontSizeHuge">Do you want to climb into the bus or enter in the Metro C?</div><div class=\'marginTop\'>Validity time counting will start.<br/>To access the subway, show the QrCode to the to the scanner on tickets barriers.</div>',
                    vuoiEntrareMetro:
                        '<div class="secondary textAlignCenter fontSizeHuge">Do you want to enter in Metro A, B, B1?</div><div class=\'marginTop\'>To access the subway, show within two minutes the QrCode to the scanner on tickets barriers.<br/>Ticket is valid for one train ride on the subway.</div>',
                    vuoiSalireTreno:
                        '<div class="secondary textAlignCenter fontSizeHuge">Do you want to climb into the train?</div><div class=\'marginTop\'>Ticket is valid for one train ride on train.<br />Choose the departure station:</div>',
                },
                attiva: 'Activate',
                attivaESaliBus: 'Activate your ticket to use it:',
                attivaEdEntraMetro: 'Activate and enter in:',
                attivaMsg: 'Activate the ticket to use it',
                attivaPer: 'Active for',
                attivato: 'Activated',
                attivatoIl: 'Activated on',
                attivatoMetro: 'Subway validation:',
                attivatoPer: 'Activated for',
                attivatoTreno: 'Train validation:',
                attivazioneBus: 'Bus, Metro C activation',
                attivazioneMetro: 'Activation Metro A, B, B1',
                attivazioneNFC: 'NFC activation',
                attivazioneTitolo: 'Ticket activation',
                attivazioneTreno: 'Train Activation',
                avvisoTitoliLocali:
                    'Tickets are saved on the smartphone only. For further information click {0}here{1}',
                avvisoTitoliLocaliMail:
                    'The tickets have been saved on your smartphone. For further information contact {0}',
                avvisoTitoliLocaliNoLink: 'Tickets are saved on the smartphone only.',
                cercaTitolo: 'Search ticket',
                chiediCodice: 'Ask the driver information for title activation',
                codiceNonValido: 'Code invalid',
                confermaAttivazione:
                    'If you confirm, the ticket will be activated and the validity time counting will start',
                confermaMetro: 'If you confirm, you have 2 minutes time to access the subway.',
                confermaMetroAttivazione:
                    'If you confirm, the ticket will be activated, the validity time counting will start and you will have 2 minutes time to access the subway.',
                costoTitolo: 'Ticket cost',
                daAttivare: 'To be activated',
                dataEmissione: 'Issue date',
                dataScadenza: 'Expiry date',
                entraInMetro: 'Subway',
                entraMetro: 'Enter in:',
                error: {
                    corseEsaurite: 'No more bus solutions available',
                    datiNonCongrui: 'Uncorrect data',
                    erroreAntiPassback: 'Anti-passback control error',
                    erroreApplicativo: 'Application error',
                    erroreValidazioneMultipla: 'Multiple validation on same account error',
                    impossibileValidare: 'It is impossible to activate the ticket',
                    titoloNonValido: 'The ticket is not valid',
                },
                fermataSalita: 'Boarding Stop',
                finoA: 'Up tp',
                header: 'Ticket',
                identificativo: 'Identification',
                inFaseDiAttivazione: 'Service being activated',
                infoAcquistoAnnullato: 'The transaction was cancelled by the customer',
                infoAcquistoEffettuato: 'The purchsed ticket is available in the section "My tickets".',
                infoAcquistoFallito: 'We were unable to complete your transaction.',
                infoAcquistoFallitoVix: 'We were unable to complete your transaction. Plese try again.',
                infoAcquistoSiaeEffettuato: 'The purchsed ticket is available in the section "Events".',
                infoCodiceManuale: 'In case of failed code reading, turn to the driver',
                inserisciQualcosaPartenza: 'Insert address, zone or stop of departure',
                istruzioniAttivazione: 'Press "Validate" to validate the Ticket',
                istruzioniDownloadTitoliAsincroni:
                    'Once you have completed the purchasing process, it is possible to download the ticket by entering the page "My tickets" of the App',
                istruzioniDownloadTitoliAsincroniTrasporto:
                    'Once you have completed the purchasing process, it is possible to download the ticket by entering the page "Transport" of the App',
                istruzioniObliterazione: 'Click "Validate" to validate your ticket',
                localita: 'Place',
                multicorsa: {
                    MultiCorsa: 'Carnet',
                    attivaAltro: 'Validate runs',
                    attivaDefault: 'Activate',
                    attivaPrimo: 'Validate runs',
                    attivaUltimo: 'Validate run',
                    attivoFinoA: 'Run valid to:',
                    confermaRivalidazione: 'Used tickets will be filed together with those expired.',
                    corseAttive: 'Active rides:',
                    corseDaAttivare: 'Residual trips',
                    corseRimaste: 'Rides:',
                    daAttivare: 'Run not validated',
                    info: 'To validate the runs, rub the Qr Code over the turnstile {0} times.',
                    quantiAttivare: 'How many runs to activate?',
                    scaduto: 'Expired',
                    tickets: 'Runs',
                    tutteCorseScadute: 'All rides are expired',
                    validoDa: 'Run valid from:',
                },
                nfcNotSupported:
                    'NFC service is available for your smartphone. However, with this android version myCicero cannot access this function.',
                nfcOFF:
                    'With your smartphone, you can use the NFC activation. However, this function is not active. Would you like to activate it?',
                nfcON:
                    'Congratulation! With your smartphone you can activate this ticket, by simply bringing the device near to the NFC reader, where available.',
                noPosPartenzaRilevata: 'Impossible to detect your departing position.',
                nonAcquistabileContrattiInsufficienti:
                    'You cannot purchase this ticket because the board has no enough contracts',
                nonAncoraUtilizzabile: 'Not usable now',
                nonAttivato: 'Ticket non-activated',
                nonEffettuata: 'Not done',
                nonObliterato: 'Ticket not validated',
                nonValidato: 'Ticket not validated',
                notificaMessaggio: '{0} it will expire at {1}',
                notificaTitolo: 'The ticket will expire soon',
                nuovaAttivazione: 'New activation',
                nuovaValidazione: 'New validation',
                oblitera: 'Activate',
                obliteratoIl: 'Validated on',
                piuCorse: ' More rides',
                precedente: 'Go to previous ticket',
                premiAttiva: 'Failure to ticket validation leads to penalty',
                premiValida:
                    'Press "Validate" before to climb into the means of transport. Failure to ticket validation leads to penalty.',
                primaAttivazione: 'Active',
                qrCodeScaduto: 'QR Code expired',
                saliInBus: 'Bus',
                saliSulTreno: 'Train',
                saraValidoTra: 'The ticket will be valid into',
                scaduto: 'Expired',
                scadutoIl: 'Expired on',
                selezionaFermataSalita: 'If you know it, please select your bus boarding stop',
                selezionaStazioneSalita: 'Select station:',
                singolaCorsa: '1 ride',
                stazioneSalita: 'Station:',
                successivo: 'Go to next ticket',
                tempoRestante: 'Time remaining',
                termsConditions: " <span>I have read and agree to the </span><a href='#'> terms and conditions</a>",
                tipologiaBiglietto: 'Ticket typology',
                titoliImpersonali: 'Impersonal ticket',
                titoloAttivo: 'Active ticket',
                titoloAttivoFinoAl: 'Ticket active till',
                titoloDiViaggio: 'Ticket',
                titoloLocale: 'You can find this ticket on your smartphone only',
                titoloNonAttivo: 'Ticket not active',
                titoloScaduto: 'Ticket is expired',
                titoloScadutoAlle: 'Ticket expired at',
                treno: 'Train',
                ultimaValidazione: 'Last validation',
                utilizzabileDalAl: 'Usable from {0} to {1}',
                utilizzabileFinoA: 'Usable until {0}',
                utilizzabileIl: 'Usable on {0}',
                utilizzabileIlGiorno: 'Usable on day:',
                utilizzabileOggi: 'Usable today',
                vaiAlBiglietto: 'Go to the ticket',
                valida: 'New validation',
                validaMsg: 'Validate the ticket to be able using it',
                validatoIl: 'Validated on:',
                valido: 'Valid',
                validoFinoAl: 'Valid until',
                warningAccessoMetro: 'Go through subway entry barrier </br> by',
            },
            bikeSharing: {
                aggiungiBici: 'Add another bicycle',
                alertPrenotazioneAccorciata:
                    'The rent period has been reduced according to the regulation applied in the selected structure.',
                alertPrenotazioneAllungata:
                    'The rent period has been increased according to the regulation applied in the selected structure. This does not imply any extra costs.',
                alertPrenotazioneAnnullata: 'Reservation was cancelled',
                altreFunzionalita: 'Other functionalities ',
                annullaPrenotazione: 'Cancel the booking',
                bici: 'Bicycle',
                biciPrenotataPerHtmlTemplate: 'The bicycle will be booked for {0}',
                bicicletta: 'Bicycle:',
                biciclette: 'Bicycle:',
                bikePoint: 'Bike Point:',
                bikePointChiuso: 'Bike point closed',
                bikePointChiusoInfo: 'During closing time of bike- point is not possible to make a reservation',
                bikePointPrelievo: 'Picking up:',
                bikePointRiconsegna: 'Redelivery:',
                btnPrenota: 'book a bicycle',
                cantBook: 'You cannot book',
                cercaBikePoint: 'Search a Bike Point',
                cercaPerNomeIndirizzo: 'Search by address or name',
                confermaBici: 'Get the bike',
                consegnaInRitardo: 'You were supposed to return it within:',
                contattaci: 'Contact us',
                dettaglioCorsa: 'Run details',
                elencoPrenotazioniRecenti: 'List of recent operations...',
                elencoStrutture: 'Bike Point',
                emptyPoint: 'Bike Point empty',
                haiPrenotazione: 'You have a booking for {0} bicycle(s)',
                haiRiconsegnatoInRitardo: 'Completed (in delay)',
                importoMyCicero: 'Paid through myCicero:',
                importoOra: 'If you return it now:',
                importoTotale: 'Total Amount:',
                infoPoint: 'Bike Point information',
                infoPrelievo: 'The bicycle will be been booked for the selected period',
                infoPrenotazione0: 'The rental includes insurance cover, taxes and a map of Rome',
                infoPrenotazione1:
                    '30 minutes available to pick up the bike/s, otherwise your request will be automatically deleted (no costs will be charged)',
                infoPrenotazione2: 'Booking will be active when the bike-point operator will give you the bikes.',
                infoPrenotazione3:
                    'The time scheduled is not binding for returning the vehicle, it is also possible to stop the rental time in advance. The cost will be charged depending on the effective time needed and under the existing tariff.',
                infoRitardo:
                    'Mycicero has taken note of the missing delivery. Please return the bicycle as soon as possible',
                inserisciCodiceBici: 'Insert bike code',
                inserisciNumeroBici: 'Insert bike number',
                istruzioni: {
                    bloccoSbloccoSaldo:
                        'To block and unlock the bikes, your wallet balance has to be superior or the same to the rental cost',
                    buonaPedalata: 'Have a good ride!',
                    cosaDevoFare: 'What should I do?',
                    inserisciCodice: 'Insert or scan the codes of all your bikes reservation',
                    mostraCodice: 'show the code',
                    mostraIlCodice: '2) Show the booking code to the station dealer.',
                    mostraSuMappa: 'show on the map',
                    raggiungiIlBikePoint: '1) Reach, within {0}, the Bike Point "{1}"',
                    ricordatiDiRiconsegnare:
                        '4) Do not forget to return the bicycles within {0} in one of the our Bike Points',
                    semplice: 'Easy',
                    termineNoleggioSelfService:
                        'Before the rent end make sure to have hooked all rented bike to the bike point',
                },
                leMiePrenotazioni: 'My bookings',
                limitePrenotazioni: 'You reached the maximum amount of bookings',
                mezzoPrenotatoPeriodoSelezionato: 'The item will be booked for the selected period',
                mostaCodicePrenotazione: 'show the booking code',
                nessunRecente: 'Nothing to show',
                noBikes: 'No bicycle available at the moment',
                noBikesInPoint: 'No item available in the selected station',
                noResult: 'No results for this search available',
                noleggi: 'Active rentals',
                operazioneNonAutorizzata: 'Non allowed operation',
                orario: 'service hours',
                orarioApertura: 'Opening hours',
                prelevaEntro: 'Pick up within:',
                prelievo: 'You can pick up the bicycle within:',
                prelievoEffettuato: 'The pick-up was made:',
                prelievoEntro: 'Pick-up within:',
                prenota: 'Book',
                prenotazioni: 'Bookings',
                preventivoPrenotazione: 'Booking estimate:',
                problemi: 'For every problem or malfunction',
                recenti: 'Recent',
                ricalcoloPreventivoInCorso: 'Estimated amount currently recalculated..',
                ricaricaBorsellino: 'Recharge the wallet to make a reservation.',
                ricaricaBorsellino2:
                    'Recharge the wallet if you want to pay the entire amount by MyCicero, otherwise you will pay the gap to the bike-point operator. ',
                riconsegna: 'You must return it within: ',
                riconsegnaEffettuata: 'Return made:',
                riconsegnaEntro: 'Return within:',
                sblocca: 'Unlock',
                scegliTipologia: 'Choose the typology',
                seiInRitardo: 'You are late for returning the item',
                templateMessaggioPreventivo:
                    'If you now pick up booked means and redeliver them at selected time you will spend: {0}',
                terminaNoleggio: 'End rental',
                titles: {
                    bikeSharing: 'Bike',
                    conferma: 'Confirm',
                    dettaglioCorsa: 'Run details',
                    prenotaBici: 'Book a bicycle',
                    scegliBikePoint: 'Choose a bike point',
                },
                visualizzaRecenti: 'Transactions list',
            },
            busitaliaveneto: {
                acquistaBiglietti: 'Buy tickets',
                calcolaPercorso: 'Calculate route',
                fermateOrari: 'Stops and schedules',
            },
            carPoolingTaxiCondiviso: {
                bacheca: {
                    cercaConducenti: 'Find drivers',
                    cercaOfferteRichieste: 'Find offers and users requests',
                    cercaPasseggeri: 'Find passengers',
                },
                common: {
                    annullaRichiesta: 'Remove request',
                    annullaRichiestaError: 'Impossible to cancel your request. Reservation not found.',
                    annullaRichiestaMessage: 'Do you want to definitely remove your request? ',
                    bacheca: 'Dashboard',
                    carInfo: 'Vehicle info:',
                    chiamaTaxi: 'Call for taxi ride',
                    commento: 'Comment',
                    confermaPrenotazioneTaxi: 'Confirm taxi reservation',
                    confermaPrenotazioneTaxiMessage:
                        "Confirming the reservation for shared ride with taxi the other users will receive the confirmation.<br/><br/>You will find all your requests in section <b class='primary'>MY TRAVELS</b>",
                    confermaRichiesta: 'Confirm your request',
                    confermaRichiestaMessage: 'Are you sure to confirm your request?',
                    confermaValutazione: 'Confirm the rating score',
                    corsaEliminata: 'The ride has been cancelled ',
                    corsaEliminataMessage: 'This ride has been definitively cancelled',
                    dettaglio: 'Detail',
                    elencoPasseggeri: 'Passengers list',
                    eliminaCorsa: 'Cancel ride',
                    eliminaCorsaMessage: 'Do you want to cancel the ride definitively?',
                    ferryInfo: 'Ferry info:',
                    filtra: 'Filter',
                    filtraOfferte: 'Filter offers',
                    filtraRichieste: 'Filter requests',
                    filtraStoricoViaggi: 'Filter trips history',
                    filtriAttiviNum: '{0} active filters',
                    filtroAttivoNum: '{0} active filter',
                    iMieiViaggi: 'My trips',
                    inserisciRichiesta: 'Insert request',
                    inviaOfferta: 'Send offer',
                    inviaRichiesta: 'Send request',
                    iscrizione: 'Registration',
                    mappa: 'Map',
                    minimoPasseggeri: 'Minimum number of passengers',
                    nessunRisultato: 'No results',
                    numeroPostiDisponibili: 'Number of seats available',
                    numeroPostiRichiesti: 'Number of seats required',
                    offertaPassaggio: 'Offer for a ride share',
                    offriCorsaPerViaggioCercato: 'Offer a ride for the selected trip',
                    offriUnPassaggio: 'Offer for a shared ride',
                    partecipaTaxiCondiviso: 'Join for a shared ride with taxi',
                    passeggeriAccompagnati: 'Carried  passengers',
                    postiConfermatiNum: '{0} seats confirmed',
                    postoConfermatoNum: '{0} seat confirmed',
                    prenotazioneTaxiConfermata: 'Taxi reservation confirmed',
                    procediRichiesta: 'Send your request',
                    pubblicaRichiesta: 'Publish your request',
                    pubblicaValutazione: 'Publish the rating score',
                    pubblicaValutazioneMessage: 'Publishing your rating score, all can see your comment',
                    rendiDisponibileAuto: 'Offer a shared ride with your car',
                    ricercaNoRisultati: 'The research have no results ',
                    richiestaAnnullata: 'Request removed',
                    richiestaPassaggioInviata: 'Request for sharing the ride has been sent',
                    richiestaPubblicata:
                        "We published your request.<br/><br/>It will be available in section <b class='primary'>my travels</b>",
                    richiestaRifiutata: 'You request has not been accepted',
                    richiestaTaxiCondiviso: 'Request for sharing a ride with taxi',
                    richiestaTaxiCondivisoNum: '{0} passenger for your request to share a taxi ride',
                    richiesteTaxiCondivisoNum: '{0} passengers for your request to share a taxi ride',
                    riepilogoOfferta: 'Offer overview',
                    riepilogoRichiesta: 'Request overview',
                    rifiutaRichiesta: 'Do not accept the request',
                    rifiutaRichiestaError: "The request can't be rejected. Reservation not found.",
                    rifiutaRichiestaMessage: 'Do you want to cancel the request definitively ?',
                    storicoViaggi: 'Trips history',
                    taxiCondiviso: 'Shared Taxi',
                    tornaOfferta: 'Back to the offer',
                    valutaConducente: 'Send you rating score for the driver',
                    valutaPasseggeri: 'Send you rating score for the passengers',
                    valutaPasseggero: 'Send you rating score for the passenger',
                    valutaUtente: 'Send you rating score for the user',
                    valutazione: 'Rating',
                    viaggiAttivi: 'Active trips',
                    viaggiCompletati: 'Completed trips',
                    viaggiConTaxiCondiviso: 'Travels with shared taxi',
                    viaggiDaConducente: 'Trips as driver',
                    viaggiDaPasseggero: 'Trips as passenger',
                },
                offriPassaggio: {
                    partenzaArrivoModificate:
                        'Changing origin or destination, travel options could be no longer compatible with the passenger request',
                },
                pubblicaRichiesta: {
                    infoRichiestaCarPooling:
                        'Sending this request you will share in your Dashboard two different requests, one for Car Pooling and one for Shared Taxi. You will receive a notification by email when other users will insert travel offers or requests for Taxi Condiviso compatible with your travel  needs.',
                    infoRichiestaCarPoolingTaxiCondiviso:
                        'Sending this request you will share in your Dashboard two different requests, one for Car Pooling and one for Shared Taxi. You will receive a notification by email when other users will insert travel offers or requests for Shared Taxi compatible with your travel needs.',
                    infoRichiestaNoAmbito:
                        'Please, select at least one option, for which you want to publish a request in the dashboard',
                    infoRichiestaTaxiCondiviso:
                        'Sending this request you will share in your Dashboard  a request for Shared Taxi. You will receive a notification by email when other users will insert requests for Shared Taxi compatible with your travel needs.',
                    pubblicaRichiestaCarPooling: 'Publish your request for Car Pooling ',
                    pubblicaRichiestaTaxiCondiviso: 'Publish your request for Taxi ride sharing',
                },
                riepilogoOfferta: {
                    informazioniOffertaPassaggioPubblicata:
                        "Please wait that other users contact you by email or search passengers for your travel among requests that are compatible with the offer published.<br/><br/>You will find your request in section <b class='primary'>MY TRIPS</b>",
                    informazioniVeicolo: 'Vehicle information',
                    informazioniVeicoloPlaceholder: 'Plate number, brand, model',
                    offertaPassaggioPubblicata: 'Car pooling offer has been published',
                    selezionaMezzoDiTrasporto: 'Choose the transport mode of your arrival',
                    selezionaTraghettoElba: 'Choose the ferry for your arrival',
                },
                riepilogoRichiesta: {
                    richiestaInoltrataConducente:
                        "Your request was sent to the driver <b class='primary'>{0}</b>.<br/><br/>Please wait that the driver confirm your request or call her/him for updates.<br/><br/>You will find your requests in section <b class='primary'>MY TRAVELS</b>",
                    richiestaInoltrataConducenti:
                        "Your request was sent to the drivers <b class='primary'>{0}</b>.<br/><br/>Please wait that the drivers confirm your request or call them for updates.<br/><br/>You will find your requests in section<b class='primary'>MY TRAVELS</b>",
                    richiestaInoltrataTaxiCondiviso:
                        "You sent your participation to shared taxi ride.<br/><br/>Call other passengers to be updated on taxi reservation.<br/><br/>You will find your request in section <b class='primary'>MY TRAVELS</b>",
                    richiesteInoltrate:
                        "Your requests have been sent.<br/><br/>You will find them in section <b class='primary'>MY TRAVELS</b>",
                    richiesteInoltrateTaxiCondiviso:
                        "You sent your participation to shared taxi ride.<br/><br/>Call other passengers to be updated on taxi reservation.<br/><br/>You will find your request in section <b class='primary'>MY TRAVELS</b>",
                    richiesteInviate: 'Requests have been sent',
                    richiestePassaggioInviate: 'Requests for car pooling have been sent',
                },
                soluzioniDiViaggio: {
                    posizioniNonValide: 'Origin and destinations are not valid',
                },
            },
            cercaOd: {
                destinazione: 'Destination',
                header: 'Search by route',
                nessunTitoloTrovato: 'No solutions found for the criteria entered',
                origine: 'Origin',
                voglioArrivareA: 'I would like to go to',
                voglioPartireDa: 'I would like to leave from ',
            },
            common: {
                Targa: 'Car registration number',
                aPartireDa: 'From',
                aPiedi: 'By walking',
                accedi: 'Login',
                accetta: 'Agree',
                acquista: 'Purchase',
                acquistaCon: 'Purchase with',
                acquistabile: 'Purchasable',
                acquisto: 'Purchase',
                acquistoABuonFine: 'Purchase was successfully completed',
                acquistoEffettuato: 'Purchase completed',
                adesso: 'Now',
                agevolazioni: 'Benefits',
                aggiungi: 'Add',
                al: 'To',
                alAlle: 'The {0} at {1}',
                andataRitorno: 'Round trip',
                anni: 'years',
                annulla: 'Cancel',
                annullaOperazione: 'Cancel',
                annullata: 'Cancelled',
                applicaPreferenze: 'Apply preferences',
                apriQrCode: 'Open QR Code',
                arrivo: 'Arrival',
                associaCarta: 'Register a Credit Card',
                attendere: 'Wait',
                attenzione: 'Warning',
                attiva: 'Activate',
                attivaBorsellino: 'Activate Public Transport e-Wallet',
                attivaNuovoTitolo: 'Activate a new ticket',
                attivato: 'Activated',
                auto: 'Car',
                autocompleteTypes: {
                    EVENTI: 'Events',
                    FERMATE: 'Stops',
                    INDIRIZZO: 'Addresses',
                    LINEE: 'Lines',
                    LOCALITA: 'Places',
                    POI: 'Then',
                },
                avanti: 'Next',
                backHome: 'back Home',
                benvenuto: 'Welcome',
                benvenutoNelMondoMyCicero: 'Welcome in myCicero.',
                benvenutoNelMondoVettore: 'Welcome in {0}.',
                calcolaPercorso: 'Calculate route',
                cambiCorsa: 'Connections',
                cambia: 'Change',
                cambiaCitta: 'Change town',
                cambiaImmagine: 'Change',
                cambioCorsa: 'Connection',
                cancella: 'Delete',
                cancellata: 'Cancelled',
                caratteri: 'Character',
                carica: 'Upload',
                caricaFile: 'Upload',
                caricamento: 'Loading...',
                carriers: 'Carriers',
                carrozza: 'Coach',
                centro: 'City Center',
                cerca: 'Search...',
                chiudi: 'Close',
                chiuso: 'Closed',
                cities: 'Cities',
                clickPerMaggioriInfo: 'Click here for more info...',
                codiceTransazione: 'Transaction code',
                cognome: 'Surname',
                comune: 'City',
                comuneArrivo: 'City of Arrival',
                comuneNonValido: 'City not covered by the service.',
                comunePartenza: 'City of Departure',
                con: 'with',
                condividiViaggio: 'Share your travel',
                condizioniUtilizzoHtml: 'I accept <a href="#" class="lnkCondizioni">terms & conditions</a>',
                conducente: 'Driver',
                conferma: 'Confirm',
                confermaAcquisto: 'Purchase confirmation',
                confermaContinua: 'Are you sure you want to continue?',
                confermaEChiudi: 'Save and Continue',
                confermaNonChiedere: 'Do not show this again',
                confermaSelezione: 'Confirm selection',
                confermaUscitaApp: 'Do you really want to exit the application?',
                contattaAssistenza: 'Please, get in touch with our help desk',
                contattaIlGestore: 'Contact the manager',
                contattiEdEntiCoinvolti: 'Contacts and authorities under agreements',
                continua: 'Continue',
                copertura: 'Areas Covered',
                corse: 'Runs',
                creaTessera: 'Create transport card',
                crediti: 'Credits',
                dal: 'From',
                dalAlle: 'From {0} at {1}',
                dalleAlle: 'From {0} to {1}',
                data: 'Date',
                dataSvolgimento: 'Date',
                datiSalvati: 'Data saved',
                descrizione: 'Description',
                dettaglio: 'Detail',
                domani: 'Tomorrow',
                durata: 'Duration',
                e: 'and',
                elencoMovimenti: {
                    tipo: {
                        abbSosta: 'Buy a long-term parking permit',
                        ricarica: 'Top up your credit',
                        sosta: 'Parking',
                        utilizzoCredito: 'Credit use',
                    },
                },
                elimina: 'delete',
                emesso: 'Issued',
                emptyList: 'No element found',
                errore: 'Warning',
                erroreCaricamento: 'An error has occurred. Data could not be loaded, please try again later',
                erroreComunicazioneServer: 'Comunication server error',
                erroreConnessione: 'An error has occurred. Please verify your internet connection and try again.',
                erroreConnessioneServer: 'Error during connection with remote server',
                erroreDownloadTitoli: 'During ticket dowloading an error has occurred. Please, try later.',
                erroreFormatoQrCode: 'Wrong QR Code format',
                errorePagamento: 'An error occurred while trying to pay. Please try again.',
                erroreSalvataggio: 'An error has occurred. The changes made were not saved, please try again later',
                erroreScansioneQrCode: 'An error occurred during the QR code scan.',
                erroreSconosciuto: 'An unkwnown error has occurred',
                eventi: 'Events',
                evviva: 'Hurray',
                fa: '{0} ago',
                filters: 'Filters',
                filtra: 'Filter',
                filtri: 'Filters',
                filtro: 'filter',
                finoA: 'Until ',
                finoATuttoIl: 'Until the whole',
                finoAl: 'until',
                giorni: 'days',
                giornoAlle: '{0} at {1}',
                googlePlay: {
                    legal: 'Google Play and the Google Play logo are trademarks of Google LLC.',
                },
                home: 'Home',
                ieri: 'Yesterday',
                ilDalleAlle: 'The {0} from {1} to {2}',
                illimitato: 'Unlimited',
                importo: 'Amount',
                importoTotale: 'Total Amount',
                impossibileEseguireOperazione: 'The operation could not be performed ',
                impossibileVisualizzareQrCode: 'Impossible to show the QR Code',
                impostazioni: 'Settings',
                indietro: 'Back',
                indirizzo: 'Address',
                indirizzoArrivo: 'Address of Arrival',
                indirizzoPartenza: 'Address of Departure',
                inevidenza: 'Highlights',
                info: 'Info',
                infoAbbreviato: 'Info',
                infoBiglietto: '',
                infoNonDisponibili: 'Further information are not available',
                infoTraghetto: 'Ferry info:',
                infoVeicolo: 'Vehicle info:',
                ingrandisci: 'Zoom',
                inizia: 'Start',
                inizio: 'home',
                inserisciCodicePromo: 'Insert code',
                intornoA: 'Around',
                inviaRisposta: 'Send reply',
                io: 'Me',
                itinerario: 'Route',
                leggi: 'Read',
                leggiTutto: 'Read all..',
                liberi: 'Free',
                libero: 'Free',
                lingua: 'Language',
                link: 'link',
                loadMore: 'Load more...',
                longTermParkingPanel: {
                    finoA: 'Until ',
                    prenotazioneDal: 'Booking from ',
                },
                luoghi: 'Places',
                mappa: 'Map',
                mesi: 'months',
                mezzo: 'Vehicle',
                mieiTitoli: 'My tickets',
                minuti: 'Minutes',
                minutiLower: 'minutes',
                minutiShort: 'min',
                mobilita: 'Mobility',
                modalita: 'Mode',
                modifica: 'Modify',
                mostraTutti: 'Show all',
                mostraTutto: 'Show all',
                movimenti: 'Transactions',
                msgAtacLockedOutUntil:
                    'For security reasons related to the recent migration, ATAC tickets are temporarily not available; they will be available again at {1}',
                nascondi: 'Hide...',
                nessun: 'No',
                nessunDettaglioTrovato: 'No details found',
                nessuno: 'No',
                newsNotifiche: 'News and notices',
                newsNotificheUnread: '{0} unread news',
                nfcSpentoDesc: 'Turn it on in the settings of your phone to validate your ticket',
                nfcSpentoWarning: 'NFC is off on your device.',
                no: 'No',
                noCameraPermission: 'You have no licence to access the camera',
                noRicerchePreferite: 'No favourite searches found',
                noRicercheRecenti: 'No recent searches available',
                noRisultati: 'No results for this search available',
                noRisultatiRicerca: 'No results found.',
                noRisultatiVisibili: 'No visible results available',
                nome: 'First name',
                nomeCompleto: 'Name and surname',
                nonAcquistabile: 'Not purchasable',
                nonAttiva: 'Not active',
                nonConfermata: 'Not confirmed',
                nonOra: 'Not now',
                notifica: 'Notification',
                numCartafreccia: 'Cartafreccia Number',
                nuova: 'New',
                nuovaAttivazione: 'New activation',
                obbligatorio: '(required)',
                oggi: 'Today',
                ok: 'Ok',
                operazioneEseguita: 'Task completed',
                operazioneFallita: 'Operation failed',
                opzioni: 'options',
                ora: 'Hour',
                oraDelGiorno: "<span class='bold'>{0}</span> of {1}",
                orariEfermate: 'Timetable and stops',
                orario: 'Time',
                ore: 'hours',
                ottimo: 'Great',
                paga: 'Pay',
                parcheggiNavette: 'Park&ride (shuttles)',
                parcheggia: 'Parking',
                partenza: 'departure',
                partners: 'Partners',
                passeggeri: 'Passengers',
                passeggero: 'Passenger',
                plusAutoricarica: {
                    labelCartaDiCreditoNecessaria: 'A credit card shall be registered',
                    labelMemorizza: 'Save',
                    labelRicaricaAutomatica: 'Set the automatic topup',
                    labelRicaricaAutomaticaAttiva: 'The automatic topup option is on',
                    labelRicaricaAutomaticaNonDisponibile: 'Automatic topup not available',
                },
                plusCartaDiCredito: {
                    labelElimina: 'Delete',
                    labelProprietario: 'OWNER ',
                    labelValidita: 'VALID<br/>THRU',
                },
                posti: 'Seats',
                posto: 'Seat',
                preferite: 'Bookmarks',
                preferiti: 'Bookmarks',
                prefissoData: 'on',
                prezzo: 'Price',
                primaAttivazione: 'First validation:',
                procedi: 'Proceed',
                prodotti: 'Products',
                promoOK: 'Promotion assigned',
                prosegui: 'Go ahead',
                qrCodeFermata: 'Bus-stop QR Code ',
                quando: 'When',
                quantita: 'Quantity',
                raggiungici: 'Reach us',
                realtaAumentata: 'Augmented reality',
                recenti: 'Most recent',
                refresh: 'Refresh',
                reset: 'Reset',
                results: 'Results',
                ricarica: 'Top Up',
                ricerca: 'Search',
                riceviAssistenza: 'For our customer services visit the page:',
                rifiuta: 'Deny',
                rifiutata: 'Refused',
                rimuoviFiltri: 'Remove filters',
                riprova: 'Try again',
                risultatiPer: 'Results for ',
                rivendite: 'Ticket booths and shops',
                salta: 'Skip',
                salva: 'Save',
                salvaNeiPreferiti: 'Save as Bookmarks',
                salvaProcedi: 'Save and continue...',
                salve: 'Hi',
                scadenza: 'Expiry Date: ',
                scanQrCode: 'Scan QrCode',
                scegliRitorno: 'Choose return trip',
                scegliTipologia: 'Choose a category to filter',
                secureCode: 'Mobile Secure Code',
                secureCodeMyCicero: 'myCicero Secure Code',
                secureCodeRecover:
                    'Since it cannot be retrieved, if you have lost it, you have to delete and register again your credit card.',
                seiSicuro: 'Are you sure?',
                seleziona: 'Select',
                selezionaMemorizza: 'Select and save',
                selezionaPosizioneMappa: 'Select in map',
                sempre: 'always',
                servizi: 'Services',
                serviziAggiuntivi: 'Additional services:',
                share: 'Share',
                sharing: {
                    header: 'Do you like myCicero?',
                    provaMyCicero: 'Try myCicero!',
                    sharingMessage:
                        'If you use public means of transport or if you are looking for an intelligent, fast and cheap system to pay the parking from an app, you should definitely try myCicero! myCicero is the only app enabling you to park your car and to travel by using public means of transport, the app will support you in every step of your journey. A single app for many services. - You can only pay the real minutes of parking and buy restricted traffic areas permits. - Travel solutions integrated with local connections and tickets. - Local and national lines with tickets and season tickets on sale. - Timetable and tickets in a click, get your smartphone close to the ticket gate and enter. ',
                    shortText: 'Share the app with your friends!',
                    text: 'Do you like myCicero? Share it!',
                },
                socialMedia: 'Social media',
                soloAndata: 'One way',
                sosta: 'Parking',
                spese: 'Costs',
                sulista: 'List',
                sumappa: 'Map',
                targa: 'Vehicle number plate',
                tariffa: 'Rate',
                telefono: 'Phone',
                tempoScaduto: 'Expired time',
                terminaApp: 'Close the app',
                termsCondition: 'I’ve read and agree to the Terms and Conditions',
                timeoutPagamentoBigliettoTrasportoMessage:
                    "Elaboration is requiring longer than expected. Before trying again, please wait a few seconds and check if the ticket is available in section 'My tickets' or if you have received the confirmation email.",
                timeoutPagamentoMessage:
                    'Elaboration is requiring longer than expected. Before trying again, please wait a few seconds and check if you have received the confirmation email.',
                timeoutPagamentoTitle: 'Connection timeout',
                tipo: 'Type:',
                tipologia: 'Type',
                tornaAllaHome: 'Back to the home',
                tornaIndietro: 'Back',
                totale: 'Total',
                tours: 'Tour',
                tra: 'in {0}',
                trasporto: 'Transport',
                tuttaLaSettimana: 'The whole week',
                tutteTipologie: 'All the typologies',
                tutti: 'all',
                utente: 'User',
                utenti: 'Users',
                utilizzabileIl: 'Usable at:',
                utilizzoTitoliAtac: 'ATAC Tickets Management',
                vaiAlTitolo: 'Go to the ticket',
                vaiAllaPagina: 'To page',
                valida: 'VALID',
                validoDal: 'Valid from',
                validoFinoAl: 'Valid until',
                validoFinoAlle: 'Valid until',
                validoIlGiorno: 'Valid on',
                validoTra: 'Valid in',
                verifico: 'Verifying...',
                verifying: 'Verifying...',
                version: 'Version',
                vettore: 'Operator',
                viaggi: 'Trips',
                viaggio: 'Trip',
                visitaIlSito: 'visit the website',
                yes: 'Yes',
                zonaNonCoperta: 'The city you are in is not covered by the service',
            },
            credito: {
                aci: {
                    descrRedirect: 'By clicking on the button you will be redirected to the ACI payment page.',
                    descrizione: 'Make the payment with ACI pay',
                },
                acquistoConBorsellino: 'Buy using your credit',
                acquistoConBorsellinoMyCicero: 'Buy using your myCicero credit',
                acquistoConBorsellinoTrasporto: 'Buy using your public transport credit',
                acquistoSisalAbbSosta:
                    'After completing the purchase, your parking permit will be available in the section "Discounts".',
                acquistoSisalRicaricaBorsellino: 'After completing the purchase, your credit will be updated',
                alertConnessioneCadutaAcquistoAbb:
                    'Connection lost during transaction. The operation could not have been successfully completed. Please verify that the new Subscription is correctly displayed in your Subscriptions List: if not, try to purchase it again',
                attivaBorsellinoTrasportoPubblico: 'Activate your Public Transport e-Wallet',
                bemoov: {
                    descrRedirect:
                        'You will be redirected to an external page and you will be asked to enter the OTP code and the CV2of your linked credit card',
                    descrUsoNumeroTelefono: 'An OTP code will be sent via SMS to the indicated number for confirmation',
                    inserisciNumeroTelefono: 'Please enter the phone number associated with your account',
                },
                clearCodice: 'Delete Code',
                controllaCodice: 'Check Code',
                credito: 'Credit',
                creditoBorsellinoInsufficiente: 'Insufficient credit available in the e-Wallet for this purchase',
                creditoInsufficiente: 'Insufficient credit',
                creditoResiduo: 'Remaining credit',
                creditoSosta: 'Parking credit',
                datiPagamento: 'Payment data',
                dettaglioAcquisto: 'Purchase detail',
                dettaglioAttivitaRicarica: 'Details of processed credit top-ups ',
                effettuaPagamento: 'Buy',
                effettuaPagamentoPer: 'Pay',
                erroreCaricamento: 'An error has occurred. Data could not be loaded, please try again later',
                erroreSalvataggio: 'An error has occurred. The changes made were not saved, please try again later',
                gestionePagamento: 'Handle payment',
                importoAcquisto: 'Purchase Amount',
                infoAcquistiSmartphoneHTML:
                    'By registering a Credit Card, you will be able to buy subscriptions and top up your parking credit in full safety directly on your smartphone. <a href="#" onclick="javascript:openLinkOnBrowser(getLinkRegistraCarta(),true)">Register a card now</a>!"',
                infoAttivaBorsellinoHTML:
                    'It is possible to pay by using the credit pre-charged in an e-Wallet. In order to activate it, visit your <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">private accout</a> (by PC)."',
                infoConfermaPagamento:
                    'By pushing this button, the chosen amount will be charged to the selected Credit Card',
                infoConfermaPagamentoBorsellino:
                    'By pushing this button, the chosen amount will be charged to your e-Wallet',
                infoConfermaPagamentoBorsellinoMyCicero:
                    'By pushing this button, the chosen amount will be charged to your e-Wallet',
                infoConfermaPagamentoBorsellinoTemplate:
                    'By pushing this button, the chosen amount will be charged to your {0} e-Wallet',
                infoConfermaPagamentoRedirect: 'You will be redirected to an external web page',
                infoRicaricaBorsellinoHTML:
                    'You can charge your e- wallet directly from your phone (<a data-bind=tap: gotoRicarica">click here</a>) or from a PC entering into your <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">private accout</a>."',
                infoRicaricaBorsellinoShortHTML:
                    'You can top up your e-wallet with a PC in your <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">private accout</a>."',
                inserisciCodiceCouponRicarica: 'Insert Coupon Code',
                inserisciDatiCarta: 'Enter the credit card details',
                inserisciSecureCode: 'Insert your Mobile Secure Code',
                inserisciSecureCodeMyCicero: 'Insert your myCicero Secure Code',
                metodoPagamento: 'Payment method',
                noCreditCard: 'Make a purchase by credit card',
                nonRicordi: 'Forgot your code?',
                pagaCon: 'Pay with ',
                payCreditOneShot: 'Pay the amount without registering a credit card',
                paypal: {
                    info1: 'Pay automatically with your PayPal account.',
                    info2: 'By clicking on the button, you will immediately pay via PayPal.',
                    titolo: 'PayPal<sup>TM</sup>',
                },
                paypalexp: {
                    descrRedirect: 'By clicking on this button, you will be redirected to PayPal payment.',
                    descrizione: 'Paypal express checkout payment',
                },
                paypalric: {
                    descrRedirect: 'By clicking on the button "Yes", you will pay through PayPal.',
                    descrizione: 'Pay with your paypal account',
                },
                prenotazioneSisal: 'You have a reservation<br/>of &euro;&nbsp;{0}',
                prenotazioneSisalAbb: 'You have a reservation<br/>of &euro;&nbsp;{0}',
                prenotazioneSisalRic: 'You have a reservation to<br/> charge a credit of &euro;&nbsp;{0}',
                promoTitoli: 'Promotion',
                redirectToCCInfo:
                    'You will be redirected to an external secure web page and you will be asked to provide your credit card data',
                registraCartaCredito: 'New credit card...',
                ricarica: 'Recharge',
                ricaricaBorsellino: 'Charge your credit',
                ricaricaCoupon: 'Do you have a coupon?',
                ricaricaCouponNonValido: 'Code is invalid or expired',
                ricaricaCouponUsaCodice: 'Search...',
                ricaricaCouponVerificaCodiceBtn: 'Verify code',
                ricaricaCredito: 'Charge your credit',
                ricaricaSuccess: 'Operation successfully completed',
                richiediPagamento: 'Payment request',
                richiediPagamentoPer: 'Request a payment for',
                saldo: 'Balance',
                saldoAttuale: 'Balance Current Credit',
                saldoFuturo: 'Balance Future Credit',
                satispay: {
                    bonus:
                        '&euro; 5,00 bonus if you <u onclick="openLinkOnBrowser(\'https://www.satispay.com/promo/mycicero\')">register</u> to the service!',
                    completaPagamento:
                        'Complete the payment in the app <span style="font-weight: bold">SatisPay</span>',
                    confermaCompletato: 'As soon as we receive confirmation, the purchase will be completed',
                    inserisciNumero: 'Please enter the phone number associated with your Satispay account',
                    risultatoAcquisto:
                        'After completing the purchase, the ticket will be available in the section "Transport"',
                    titolo: 'Satispay',
                    verraiRediretto: 'You can complete the payment in the app <strong>Satispay</strong>',
                },
                scegliCartaCredito: 'Choose one of your registered Credit Cards',
                scegliImporto: 'Choose the amount to top-up on your credit',
                scegliMetodoPagamento: 'Choose a payment method',
                screenSaved: 'A picture of this code has been saved on your phone gallery',
                secureCodeErrato: 'Wrong Secure Code',
                secureCodeReminder:
                    'Mobile Secure Code is a secret 5 digit number that you entered during the registration of the credit card.',
                secureCodeReminderMyCicero:
                    'myCicero Secure Code is a secret 5 digit number that you entered during the registration of the credit card.',
                sisalCommissioni1: 'Besides the cost of operation, you will have to pay also',
                sisalCommissioni2: 'a SisalPay fee',
                sisalCommissioni3: 'which is proportionate to the amount payed',
                sisalGeneraCod: 'Create a code for',
                sisalInfoAcquisto:
                    'In order to purchase a credit charge, go to one of the authorized <u>SisalPay Points of Sale</u> and provide the following parameters...',
                sisalInfoAcquisto2:
                    'Please go to a <span class="underline primary">SisalPay Point of Sale</span> and ask the retailer to make a payment on autobus.it - myCicero and and communicate the following PNR code.',
                sisalInfoAcquisto3:
                    'Go to a SisalPay Point of Sale and ask the retailer to make a payment on autobus.it - myCicero and communicate the related PNR code.',
                sisalInfoMaggiorazioneHtml:
                    'To the cost of thetransaction will be increased with an additional fee applied by SisalPay, in proportion to the amount to be paid. For further information, please visit <span class="underline primary">this link</span>.',
                sisalInviatoPerEmail: 'This code has been sent to your e-mail address',
                sisalMostraRivendite: 'Display the list of SisalPay agencies',
                sisalPay: 'SisalPay',
                sisalPayDescription:
                    'After clicking, a PNR code will be generated and it will be submitted to the SisalPay agency to proceed with payment',
                sisalPuntiVendita: 'SisalPay points of sale',
                sisalRaggiungi:
                    'In order to make a payment, please go to a SisalPay Point of Sale and ask the retailer to make a payment on autobus.it – myCicero and communicate the PNR code that will be generated',
                sisalbill: {
                    completaPagamento: 'Complete the payment with Bill',
                    completaPagamentoFallita: 'Transaction failed',
                    confermaCompletato: 'As soon as we will receive the confirmation, the purchase will be completed',
                    confermaCompletatoAbbonamentoSosta:
                        'Once completed the purchase, you can download the ticket in section "Facilitations" and update the list',
                    confermaCompletatoBorsellino: 'Wallet credit updated',
                    confermaCompletatoFallita: 'En error occurred during payment',
                    confermaCompletatoTitoli: 'Ticket available in section "my tickets"',
                    risultatoAcquisto:
                        'As soon as we will receive the confirmation from Sisal&nbsp;Bill  the purchase will be completed.',
                    risultatoAcquistoBorsellino:
                        'As soon as we will receive the confirmation from Sisal&nbsp;Bill  the purchase will be completed.',
                },
                staiAcquistando: 'You are about to purchase:',
                staiPagando: 'You are about to pay:',
                staiPrenotando: 'You are about to book the payment of:',
                stpay: {
                    descr:
                        '<p>Satispay is a payment system independent from traditional methods such as debit and credit cards.</p>',
                    iscrivitiSubito: 'Join now to receive your 5€ welcome bonus',
                },
                usaIlCredito: {
                    info1: 'Top up your credit and use it to pay myCicero services.',
                    info1Branded: 'Recharge your credit and use it to pay all services',
                    info2:
                        "So you won't have to enter your credit card data each time! No extra charge. A wide range of payment methods available",
                    info2Branded: "So you won't have to enter your credit card data each time! No extra charge.",
                    ricaricaCredito: 'Top up your credit',
                    titolo: "Because it's convenient",
                },
            },
            dettaglioSinteticoFermata: {
                direzione: '{0}',
                distanzaDaTe: '{0} from you',
            },
            dettaglioSisnteticoBus: {
                direzione: 'Direction: {0}',
                distanzaDaTe: 'Stops at {0} from you',
            },
            difonzo: {
                acquistaTitoli: 'Buy tickets',
                fermateEdOrari: 'Stops and shedules',
                mieiTitoli: 'My tickets',
                soluzioniDiViaggio: 'Travel solutions',
            },
            dolomiti: {
                AcquistaBiglietti: 'Buy tickets',
                CalcolaPercorso: 'Plan route',
                Eventi: 'Events',
                FermateOrari: 'Stops and timetables',
                Luoghi: 'Places',
                MieiTitoli: 'My tickets',
                ServiziTuristici: 'Tourist services',
            },
            eav: {
                AcquistaBiglietti: 'Buy<br/>tickets',
                CalcolaPercorsoHTML: 'Plan<br/>route',
                CampaniaExpress: 'Campania Express',
                CampaniaExpressHTML: 'Campania<br/>Express',
                CumaExpress: 'Cuma Express',
                CumaExpressHTML: 'Cuma<br/>Express',
                FermateOrari: 'Stops and timetables',
                FermateOrariHTML: 'Stops<br/>and schedules',
                MieiTitoli: 'My<br/>tickets',
                bigliettiBus: 'Bus tickets',
                bigliettiFunivia: 'Cablecar tickets',
                bigliettiTreno: 'Train tickets',
                fermate: 'Stops',
            },
            elbasharing: {
                bachecaTab: {
                    conducenti: 'Drivers',
                    passeggeri: 'Passengers',
                    taxi: 'Taxi',
                },
                common: {
                    cercaUnPassaggio: 'Find travel options ',
                    filtraLabel: 'Filter',
                    filtriAttivi: 'Active filters',
                    filtroAttivo: 'Active filter',
                    infomobilita: 'Infomobility',
                    nuovaRicerca: 'New search',
                    trovaSoluzioneViaggio: 'Find your travel solution',
                },
                homepage: {
                    bacheca: 'Dashboard',
                    consultaOfferteRichieste: 'Look at active offers and requests',
                    controllaViaggi: 'Check your travels',
                    iMieiViaggi: 'My travels',
                    offriUnPassaggio: 'Offer a car pooling ride',
                    partecipaOpinione: 'Give your opinion',
                    questionari: 'Questionnaires',
                    rendiDisponibileAuto: 'Offer a car pooling ride',
                    servizi: 'Services',
                    viviIlTerritorio: 'Experience Elba',
                },
                review: {
                    reviewLabel: 'Comments received:',
                },
                soluzioniDiViaggio: {
                    posizioniNonValideOffriPassaggio: 'It is possible to offer a ride only within Elba island',
                    posizioniNonValideRichiediPassaggio: 'It is possible to request a ride only within Elba island',
                },
                tabelloneOrari: {
                    intornoAllIndirizzo: 'Nearby (address)',
                },
                taxiCondivisoStatus: {
                    taxiStatus: 'Confirmed',
                },
                vetrinaVettori: {
                    description:
                        'For further information about timetables and ticket purchase please go to local transport companies , CTT Nord and Tiemme',
                },
            },
            event: {
                allCategories: 'All the categories',
                arrivi: 'Arrivals',
                caricaAltriEventi: 'add other events',
                definisciRaggio: 'define a distance range around:',
                dettaglio: 'Event detail',
                elenco: 'List',
                entroIl: 'Events within',
                eventi: 'Events',
                eventiCorrelati: 'Related events',
                finePrevista: 'expected end',
                inPartenzaEntro: 'Tour departing within',
                info: 'Information',
                infoContatti: {
                    cellulare: 'Mobile',
                    email: 'Email',
                    facebook: 'Facebook',
                    organizzatoDa: 'Orgaised by',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Phone',
                    vaiAlSito: 'Go to the website',
                },
                ingresso: 'Entrance',
                inizio: 'Start ',
                itinerariCorrelati: 'Itineraries passing through here',
                itinerario: 'Itinerary',
                mappa: 'Map',
                noEventi: 'No event scheduled',
                nomeEvent: 'Event name',
                ospiti: 'Important guests',
                partenze: 'Departures',
                prossimiEventi: 'Next events',
                prossimiEventiPoi: 'next events in this location',
                quando: 'When',
                raggioRicerca: 'Distance range',
                searchAllCat: 'Search in all categories',
                selezionaEvento: 'Select an event',
                serviziUtili: 'Useful services',
                specialitaCorrelate: 'Related products',
                tab: {
                    allegati: 'Attaches',
                    info: 'Info',
                    mappa: 'Map',
                },
                vetrina: 'showcase',
                warnTariffe: 'The price you see is referred to the basic fare, check it in the price list',
                when: {
                    '30days': {
                        long: 'Next 30 days',
                        short: '30 Days',
                    },
                    '7days': {
                        long: 'Next 7 days',
                        short: '7 days',
                    },
                    specifica: 'Specific day ',
                    today: {
                        long: 'Today',
                        short: 'Today',
                    },
                    tomorrow: {
                        long: 'Tomorrow',
                        short: 'Tomorrow',
                    },
                },
            },
            flussoPagamento: {
                acquistoAbbSosta: 'Your parking permit is available in "Parking and ZTL - Discounts"',
                acquistoBigliettoTrasporto: 'Your ticket is available in "Transport"',
                acquistoRicaricaBorsellino: 'Your credit has been updated',
                acquistoSatispayAbbSosta:
                    'As soon as Satispay will confirm the transaction, your parking permit will be available in the section "Parking and Ztl - Discounts"',
                acquistoSatispayBigliettoTrasporto:
                    'As soon as Satispay will confirm the transaction, your seasonal ticket will be available in the section "Transport"',
                acquistoSatispayRicaricaBorsellino:
                    'As soon as Satispay will confirm the transaction, your credit will be updated',
                attesaConfermaSatispay: 'Waiting for Satispay confirmation',
                attesaTransazioneSatispay: 'Some transactions may need more time than expected.',
                confermaPinCode: 'Confirm the PIN code',
                creditoMyCicero: 'myCicero Credit',
                creditoPrecedente: 'Previous credit',
                errorePagamento: 'An error occurred during the payment',
                importoAcquisto: 'Purchase Amount',
                messaggioTransazioneFallita: 'Something went wrong and the operation could not be completed.',
                pagamentoSanzioneEseguito:
                    'You will soon receive an e-mail with the payment receipt. You can verify the transaction by transaction list in your user profile.',
                pagamentoSkidataEseguito:
                    'Please go to the parking exit and insert the ticket into the parking meter to make the bar lift.',
                pinErrato: 'Wrong PIN Code',
                richiestaAcquistoSatispayAbbSosta:
                    'As soon as the purchase will be completed, your parking permit will be available in the section "Parking and Ztl - Discounts"',
                richiestaAcquistoSatispayBigliettoTrasporto:
                    'As soon as the purchase will be completed, your seasonal ticket will be available in the section "Transport"',
                richiestaAcquistoSatispayRicaricaBorsellino:
                    'As soon as the purchase will be completed, your credit will be updated',
                saldoAttuale: 'Current credit',
                scegliAltriMetodi: 'or choose',
                scegliCarta: 'Choose a card',
                scorriPerPagare: 'Scroll to pay',
                transazioneAnnullata: 'The transaction was cancelled by the customer.',
                transazioneEffettuata: 'Transaction completed.',
                transazioneFallita: 'Transaction failed.',
                usaAltraCarta: 'Pay with another card...',
                verificaTransazioneSatispay: 'Check the transaction',
            },
            flybus: {
                gtSearch: {
                    soluzioniDiViaggio: 'Travel</br>solutions',
                },
                homepage: {
                    elencoMovimenti: 'Transactions</br>list',
                    myTickets: 'My</br>tickets',
                    ricaricaCredito: 'Recharge</br>credit',
                    soluzioniDiViaggio: 'Travel</br>solutions',
                    subtitle:
                        '<span class="bold">Buy your bus</span><span style="font-weight: 200"></br>ticket</br>for the Dolomites</span>',
                },
            },
            geocode: {
                fail: 'Position not found',
                indirizziTrovati: 'Matching results',
                istruzioniChangePositionPageHtml:
                    'Enter an address, then click <div class="ui-icon-plus-submit" style="width:16px;height:15px;display:inline-block;"></div> to start searching',
                lookForPos: 'Acquiring position ...',
                noLocalitaTrovata: 'No address found',
                nodata: {
                    empty: 'no address found',
                },
                posNotAvailable: 'Positon unavailable.',
                slowGeocoder: 'The geocoder is taking too much time to respond',
            },
            gps: {
                abilitaGpsHtml:
                    "Your privacy settings prevent us from acquiring your position. To enable GPS positioning <a href='#position-page'>check your settings</a>",
                addressNotFound: 'Address not found',
                auto: 'GPS',
                buona: 'Good',
                cambiaIndirizzo: 'Change address',
                cambiaPosizione: 'Change position',
                discreta: 'Decent',
                eccellente: 'Excellent',
                enable: 'enable GPS location detection',
                errors: {
                    '0': 'Detection services not supported',
                    '1': 'Impossible to access detection services',
                    '2': 'Current position not detected',
                    '3': 'Current position not detected',
                    '4': 'Operation cancelled',
                    '410': 'Http error',
                    authorizationDenied: "You didn't authorize location services",
                    genericInObliteration:
                        ' Your position is not available, please verify that location service is active.',
                    hardwareDisabled: 'GPS location tracking disabled',
                    positionUnavailable: 'Current position not available',
                },
                info:
                    'In order to exclusively provide you with trusted and precise services, we need to know your current position. PluService is committed to protecting your privacy, therefore your location will never be detected without your explicit consent; moreover, we will never store your location in our servers.',
                infoAttivaGps:
                    'To provide you with an advanced service, the application needs to know your current position. Please, enable GPS in your device',
                infoAttivaGpsIphone:
                    'In order to guarantee a correct functioning, the application needs to know your current location. Please, enable GPS in your device',
                inserisciPosizione: 'enter address',
                manuale: 'manual',
                miaPosizione: 'My position',
                noGps:
                    'No GPS signal available. Your GPS may be disabled or your device may not be able to receive GPS signals being situated in a dead zone.',
                nuovoIndirizzo: 'New address',
                portamiQui: 'Bring me here',
                posAttuale: 'current position',
                posNonDisponibile: 'Current position unavailable',
                posRilevata: 'Your current position has been detected here',
                posizioneNonDefinita: 'Current position not defined',
                precisione: 'Precision',
                rilevaPosizione: 'detect position',
                rilevamentoPosInCorso: 'Detecting your position...',
                scarsa: 'Poor',
                searching: 'Localizing...',
                segnaleDebole: 'weak GPS signal',
                tuaPosizione: 'You are located',
            },
            home: {
                all: 'All',
                en: 'English',
                gps: 'from GPS',
                it: 'Italian',
                manual: 'address',
                manualdialog: {
                    header: 'address',
                    placeholder: 'enter address',
                },
                optionsdialog: {
                    header: 'options',
                },
                search: 'search nearby',
            },
            iccrea: {
                cambiaZona: 'Change area',
                homeTitle: 'BCC Club Card<br />welcomes you to <b>{0}</b>',
                hometitleNoPos: 'BCC Club Card<br />welcomes you',
                serviziTuttaItalia: 'Our services are active all around Italy',
                tutorial: {
                    subtitle1: 'All the most useful services to spare time and money in a click.',
                    subtitle2: "Pay only for the real parking minutes and you don't need parking metres.",
                    subtitle3: 'Discover discounts and coupons for you in the stores around you.',
                    subtitle4: 'Buy seasonal and other type of train and bus tickes by the app, with no more queues.',
                    subtitle5:
                        'You can directly access with BCC Card credentials, doing the login i the app MyCartaBCC.',
                    subtitle6:
                        'Charge the app wallet with BCC Card or Satispay and pay with a click all services on the territory!',
                    title1: 'BCC card is always at your side!',
                    title2: 'Cut cost of parking',
                    title3: 'Benefits and shopping with CartaBCC!',
                    title4: 'Take a train or a bus has never been so easy!',
                    title5: 'It not necessary to register!',
                    title6: 'Recharge your credit',
                },
            },
            inserimentoPin: {
                placeholder: '5 number-digits',
            },
            insiel: {
                centralinoUffici: 'Central Office Villa Chiozza tel',
                infoPrezziBiglietti: 'ticket price information ',
                luoghi: 'Places and Region',
                mobilitaRegione: 'Mobility in the region',
                progetto:
                    'Project co-financed by the European Union with the POR FESR 2007-2013 - activity 3.2.b "Development of advanced computer services for the tourism system"',
                scopriEventi: 'discover all the events',
            },
            isosta: {
                abb: {
                    abbonamenti: 'Discounts',
                    abbonamentiSubTitle: 'Daily and long-term parking permits',
                    abbonamento: 'Long-term parking permits',
                    acquista: 'Purchase',
                    acquistoAbbonamenti: 'Purchase',
                    attivi: 'Active',
                    cambioTargaFail: 'Change of Number Plate not occurred',
                    cambioTargaSuccess: 'Number Plate changed successfully',
                    campoNonValido: 'Red fields have a not valid value',
                    campoObbligatorio: 'Red fields are mandatory',
                    caricaAbbonamentiErroreTesto: 'Error: it is impossible to load the item!',
                    caricaAbbonamentiErroreTitolo: 'The item cannot be loaded',
                    categoriaAbbonamento: 'Category',
                    confermaAcquistoAbbSovrapposto: 'Do you want to proceed with the purchase anyway?',
                    dataFineValidita: 'To',
                    dataInizioValidita: 'Valid from',
                    datiAggiuntivi: 'Additional Data:',
                    datiIncompleti:
                        'Data missing or incomplete. Try to exit and log in again to this subscription or get in touch with our help desk for further assistance',
                    erroreCambioTargaListaAbb:
                        'Number Plate has successfully changed, but it is not possible to retrieve the subscriptions list in your phone. You will be redirected to the subscription home page',
                    failAcquistoAbb:
                        'Subscription purchase failed! Please, get in touch with our help desk for further assistance',
                    infoTipologiaNonAcquistabileDaUtente:
                        'Your account has not the required permits to purchase this type of subscription',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Once you have completed the purchasing process, it is possible to download the ticket by entering the page "Discounts" and updating the list',
                    noAbbInCorsoDiValidita: 'No valid seasonal ticket have been found',
                    noAbbNonAttivi: 'No seasonal ticket bught and not used have been found',
                    noAbbScaduti: 'No seasonal tickets expired have been found',
                    noAgevolazioni: 'You still have no long term parking permit',
                    noAgevolazioniZtl: 'You still have no ZTL permit',
                    noZtlInCorsoDiValidita: 'No valid permits found',
                    noZtlNonAttivi: 'No permits to be activated found',
                    noZtlScaduti: 'No expired permits found',
                    nonAcquistabile: 'Item not purchasable',
                    nonAncoraAttivi: 'Purchased - not active yet',
                    oraFineValidita: 'To:',
                    oraInizioValidita: 'From:',
                    ore: 'hours',
                    oreMeno: ' - hours ',
                    scaduti: 'Expired',
                    scegliComuneAreaSosta: 'Select the City where the parking area is located',
                    scegliTipoAbbonamento: 'Choose a subscription type...',
                    scegliTitolo: 'Select the Ticket',
                    scegliVeicolo: 'Choose a Number Plate',
                    successAcquistoAbb: 'Subscription purchased successfully!',
                    tipoAbbonamento: 'Type',
                    tipologiaNonAcquistabileDaUtente: 'The user is not entitled to purchase this type of subscription',
                    validitaAbbonamento: 'Validity',
                    warnAbbSovrapposto: 'You already have valid tickets in the indicated period ',
                },
                accettoCondizioniTerminiServizio: 'I agree with <action>the Terms and Conditions of use</action>',
                affinaRicerca: 'Try to enter a more precise address...',
                attivaServizio: 'activate the service ',
                attivaServizioTesto: 'To park, it is necessary to insert the vehicle data ',
                attivazioneAccediPreferenzeAziendaHtml:
                    'Please please sign in to your account via Pc on the website <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span>, personal data section, fill in the empty spaces to be registred as a company or freelance and to receive teh invoice.',
                attivazioneAccediPreferenzeAziendaTitle: 'Are you a company or freelance?',
                attivazioneAccediPreferenzeHtml:
                    'Please please sign in to your account via Pc on the websiite <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span> to set your options (payment methods, SMS notification alert, NoCall-SMS-IVR, etc.).',
                attivazioneAccediPreferenzeTitle: 'Manage your options',
                attivazioneCompletata: 'You have activated the "{0}" service',
                attivazioneCompletataInfo:
                    'Charge your credit, start parking and pay only for the real parking minutes.<br /><br />To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                attivazioneCompletataInfo1: '<i><b class="underline">Top up your credit</b></i>',
                attivazioneCompletataInfo2: '<i> and start parking by paying only the real parking minutes.</i>',
                attivazionePromemoriaHeader: "Don't forget to recharge your parking credit",
                attivazionePromemoriaText: 'It will be necessary to recharge your parking credit in order to park',
                autoricarica: {
                    erroreCaricamento: 'An error has occurred. Data could not be loaded, please try again later',
                    erroreSalvataggio: 'An error has occurred. The changes made were not saved, please try again later',
                    infoAutoricarica:
                        'With this option, your credit will be automatically topped up, when it is lower than the threashold amount you set.',
                    labelAttiva: 'Enable the automatic topup option',
                    labelCartaDiCreditoNecessaria: 'To use this payment modality, you should register a credit card',
                    labelDisattiva: 'Turn off the automatic topup option',
                    labelProcedi: 'Go-ahead',
                    labelSaldoInferioreA: 'When your credit is lower than',
                    labelTaglioRicarica: 'Top up your credit by',
                    titolo: 'Automatic topup ',
                },
                avvisoInizioSostaDomani:
                    'If you do not finish or extend your parking in advance, it will be automatically stopped <span class="bold">tomorrow</span> at <span class="bold">{0}</span>',
                avvisoInizioSostaIl:
                    'If you do not finish or extend your parking in advance, it will be automatically stopped the <span class="bold">{0}</span> at <span class="bold">{1}</span>',
                avvisoInizioSostaOggi:
                    'If you do not finish or extend your parking in advance, it will be automatically stopped <span class="bold">today</span> at <span class="bold">{0}</span>',
                calendar: {
                    aggiungiPromemoria: 'Add reminder',
                    askAggiungiPromemoria: 'Do you want to set an alarm 15 minutes before the parking expires?',
                    nonAggiungere: "Don't add it",
                    procedi: 'Next',
                    text:
                        'A reminder is going to be set in your calendar. An alarm will automatically warn you 15 minutes before your parking expires.',
                    title: 'Add reminder?',
                },
                caricaAltrePromozioni: 'Load other promotions',
                cercaLocalita: 'Search city',
                codiceStallo: 'Parking space code',
                codiceStalloPlaceholder: 'Insert parking space code',
                condizioniServizio: 'Service Terms and Conditions',
                countdownPagamento: 'You have {0} seconds to proceed with payment',
                daConfermareEntro: 'To be confirmed within',
                dettaglioPrenotazione: {
                    annulla: 'Cancel the booking',
                    cognome: 'Surname',
                    confermaAnnulla: 'Are you sure to cancel the reservation?',
                    cosaFare: 'What shall I do?',
                    datiAggiuntivi: 'Additional data',
                    email: 'E-mail',
                    erroreAnnulla: 'Impossible to cancel your reservation',
                    importo: 'Amount',
                    importoSosta: 'Parking amount',
                    importoTotale: 'Total amount paid',
                    indirizzo: 'Address',
                    intestazioneInfoPrenotazione: 'Booking info',
                    messaggioInformativoSostaAttiva:
                        'To stop parking, please go to the garage and ask for driving your car out. You will only be charged with the parking cost, calculated according to your entry time and the parking fees set.',
                    messaggioInformativoSostaPrenotata:
                        'To access the garage, show your booking to the parking operator. In case you enter before the time booked or go out after the time scheduled for more than 4 hours (four), the price will increase.',
                    modelloVeicolo: 'Vehicle model',
                    nome: 'Name',
                    nonSpecificato: 'Not specified',
                    numeroPasseggeri: 'Passengers',
                    numeroVolo: 'Flight number',
                    provenienzaVolo: 'Flight origin',
                    serviziAggiuntivi: 'Additional services:',
                    sitoWeb: 'Website',
                    targa: 'Car registration number',
                    telefono: 'Telephone',
                    titolo: 'Booking',
                },
                disambiguaDescrizione:
                    'We have found multiple parking zones near your positio. Select your zone by using vertical signs or the nearest parking meter.',
                disambiguaHeading: 'Multiple parking areas',
                disambiguaLabel: 'Choose where to park',
                disambiguaTitolo: 'Multiple parking zones',
                durataSosta: 'Duration:',
                elencoMovimenti: 'List of Transactions',
                elencoParcheggi: 'List of Parking Areas',
                findMyCar: {
                    aggiungiPosizione: 'Add',
                    cancellaPosizione: 'Delete this position',
                    cancellaPosizioneTesto:
                        'Do you want to remove this position? The operation cannot be undone and will not deactivate your active parking',
                    cancellaPosizioniTesto:
                        'Do you want to remove all saved positions in this category? The operation cannot be undone and will not deactivate your active parking',
                    clean: 'Clean',
                    erroreSalvataggio: 'An error occurred while storing this position. Please, try again',
                    header: 'Find My Car',
                    inserisciPosizione: 'Type an address...',
                    nessunaPosizioneSalvata: 'There are no parked vehicles',
                    oppureUsaMappa: 'Or tap somewhere on the map:',
                    posizione: 'Position',
                    posizioni: 'Positions',
                    posizioniRecenti: 'Recent',
                    posizioniSalvate: 'Saved Positions',
                    pulisci: 'Remove',
                    pulisciPosizioni: 'Remove positions',
                    pulisciQuestaPosizione: 'Remove position',
                    salvaPosizione: 'Save position',
                    targaOrDescrizione: 'Number plate or description',
                    whereIsMyCar: 'Where is my car?',
                },
                fineSosta: 'Parking expiry date',
                finoA: 'Until ',
                fraBrevePotraiRipetere: 'Soon you can repeat the operation…',
                gestioneCarte: {
                    aggiungiCarta: 'Add a card',
                    confermaEliminazione: 'Do you want to delete the card ending with',
                    scaduta: 'Expired',
                    titolo: 'Credit card',
                },
                importoSosta: 'Amount',
                importoSostaAttuale: 'Current Amount',
                importoSostaPrevisto: 'Expected Amount',
                indirizzoZona: 'Search by road or parking area',
                infoMemoComunePreferito:
                    'If you choose to save the selected city, this city will be suggested every time myCicero cannot retrieve your position.',
                infoStalloLabel: 'Where can I find the parking space number?',
                ingressoAlleOre: 'Entrance at:',
                inizioSosta: {
                    altreZoneDiSosta: 'Other parking areas',
                    askRegistraPosizione:
                        'With the GPS, I detected the exact position of your car. Do you want to save it and easily find your car again?',
                    avvisoDisattivazioneAutomaticaSosta: 'myCicero will automatically stop your parking session',
                    avvisoTermineSosta: 'Parking session will be stopped',
                    calcoloImporto: 'Amount calculation',
                    confermaInizioSosta: 'Start Parking Session',
                    finePrevistaMediaHide: 'Expected End:',
                    finoQuando: 'How long do yuo want to be parked?',
                    impossibileCalcolareImporto: 'Error: Unable to complete calculation of the amount',
                    infoCoupon: 'How does it work?',
                    infoCouponNoLogin: 'Have you got a coupon?Login to insert the code',
                    infoLimiteTariffario: 'In this area it is not allowed to park beyond:',
                    infoPrezzoTariffario: 'The tariff amount allows you to park anyway until:',
                    infoTariffeSu: 'Info and rates on',
                    iniziaSosta: 'Start Parking',
                    inizio: 'Start:',
                    noParcheggiRecenti: 'No recent parking sessions found',
                    noParkingsInAddress: 'No served areas were found for your search.',
                    noParkingsInCity: 'No parking areas found in the selected city',
                    noParkingsInCitySeason:
                        'In this city the parking has a seasonal pricing scheme. Currently there are no parking areas covered by the service.',
                    parcheggiRecenti: 'Recent Parking Areas',
                    placeholderCoupon: 'Insert your Coupon code',
                    promozioniIntornoATe: 'Promotions around you',
                    recenti: 'Recent',
                    registraPosizione: 'Saving position',
                    registraPosizioneAuto: 'Save car position',
                    salvaPosizionePrefix: 'Save detected GPS position',
                    salvaPosizioneShort: 'Save your car position for this parking',
                    salvaPosizioneSuffix: 'as the car position for this parking',
                    scegliParcheggio: 'Choose Parking Area',
                    scopriCoupon: 'Do you want to park for free? Discover how to do it!',
                    scopriCoupon1: 'Would you like to park for free?',
                    scopriCoupon2: 'Learn how to get it...',
                    success: 'Parking started successfully',
                },
                inizioSostaAutorimesse: {
                    avviaNavigatore: 'Start navigation',
                    cercaPerNomeIndirizzo: 'Search for address or name ',
                    chiudereSosta:
                        'To stop the parking session, go to the garage and ask for the exit.<br/>You will be only charged with the parking cost according to the real entry time and the applied price list.',
                    cittaNonSupportata:
                        'The city you are in is not covered by the service, we have chosen the closest city served',
                    creditoInsufficiente:
                        'Your credit is not enough to pay the parking. To start a parking session you have to recharge your parking credit.',
                    dataOraPerPreventivo: 'Your parking session is planned to last from now to:',
                    durataEccessiva: 'Cost estimated not computable for parking sessions over 7 days',
                    elencoStrutture: 'Facilities list',
                    emissioneFattura:
                        'If requested, will be the issued an invoice by MyCicero. The document does not include the amout remitted to the garage manger but only that paid through the platform.',
                    finePrevista: 'Park end expected:',
                    importoTotale: 'Total amount for this duration:',
                    infoTariffe:
                        'The rate applied in the garage cannot be subdivided according to the real parking minutes, only whole hours are considered.',
                    iniziaSostaEntroTrentaMin:
                        'Parking request will be automatically cancelled if you do not access to the parking lot within 30 minutes. No costs will be charged to the user',
                    inizioSosta: 'Park beginning:',
                    inizioSostaRichiesto: 'Park beginning request correctly forwarded.',
                    noResult: 'No results found',
                    parcheggioAlCompleto: 'Parking lot closed',
                    ricaricaIlBorsellino:
                        'Recharge your wallet if you want to pay the entire amount with MyCicero, or remit the gap to the garage operator.',
                    richiediInizioSosta: 'Request parking session beginning',
                    sostaSaraAttivata:
                        'The parking session will be activated when the garage manager will verify your entry. The planned time is not binding for the exit, indeed you can terminate your parking session in advance. You will be charged with the cost according to the real entry time and the applied rates.',
                    statoSosta: {
                        attiva: 'Parking session active',
                        conclusa: 'Parking session ended',
                        inAttesa: 'Deadline within:',
                    },
                },
                insertCode: {
                    confirmDescription:
                        'Scan with your smartphone the code printed in the ticket front side to see the amount to pay',
                    confirmTitle: 'Have you got a parking ticket from an indoor parking? ',
                    description: 'Please insert the code printed in the ticket front side to see the amount ti pay',
                    nonMostrarePiu: 'Do not show this message anymore',
                    okGoOn: 'Ok, go ahead',
                    placeholder: 'Insert the ticket code',
                    title: 'Have you got a parking ticket from an indoor parking? ',
                    verifica: 'Verify',
                },
                laMiaAuto: 'My car',
                map: {
                    areaNonServitaDaTitle: 'Area not served by {0}',
                    areaNonServitaDesc:
                        'Check if in this area the parking is subject to payment, by reading the closest vertical road sign or on the closest parking-meter.',
                    areaNonServitaHtml:
                        'For further information, please call the number <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> or <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">contact us via chat</a>',
                    areaNonServitaTitle: 'Area not served',
                    avviaNavigatore: 'Start navigator',
                    cambiaCitta: 'Change city',
                    caricamentoCompletato: 'Loading complete!',
                    caricamentoLento: 'Map loading is requiring more time than expected...',
                    caricamentoMappa: 'Loading map...',
                    cercaIndirizzo: 'Search by address',
                    disclaimerBtnText: 'I have understood',
                    disclaimerText: 'Please make sure that you provided the correct position of your car',
                    ingrandisciMappa: 'Zoom in to find the parking area',
                    localitaSconosciuta: 'Unknown area',
                    mappaSosta: 'Parking Map',
                    noIsostaLayer: 'Error while retrieving covered areas',
                    posizioneAmbiguaTemplateString:
                        'The current position corresponds to {0} possible parking areas. Choose the right one from the list:',
                    postiLiberi: 'Parking lots available',
                    postoLibero: 'Parking lot available',
                    ricercaHeaderTemplate: 'Look in {0}',
                    ricercaLocalitaInCorso: 'Currently looking for the area…',
                    ricercaPlaceholder: 'Address, places, points of interest',
                    scegliPosizione: 'Tap a parking area...',
                    staiVedendo: 'Currently showing:',
                    zonaImprecisa: 'Check on the vertical signs whether the suggested park area is correct',
                    zonaNonCoperta:
                        'In {0} there are currently no parking areas.<br/>In case of doubt, contact us at <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> or <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">via chat</a>',
                    zonaSenzaParcheggi: 'There are currently no parking areas here. Would you send us a feedback?',
                },
                memorizzaComunePreferito: 'Save as your usual parking city',
                minuti: 'minutes',
                minuto: 'minute',
                modalitaPagamento: {
                    attivaPagamentoContestuale: 'Activate usage-based payment',
                    erroreCaricamento: 'An error has occurred. Data could not be loaded, please try again later',
                    erroreNessunaCartaDiCredito: 'To enable the usage-based payment, please register a credit card',
                    erroreSalvataggio: 'An error has occurred. The changes made were not saved, please try again later',
                    infoCostiPagamentoContestuale:
                        'The amount of each parking session is directly charged to the registered credit card. This service has <b>a cost of € 0,08</b> for each transaction with a minimum transaction amount of € 0,20.',
                    infoCostiPagamentoContestualeActv:
                        'The amount of each parking session is directly charged to the registered credit card.',
                    infoCostiPagamentoContestualeRoger:
                        'Your credit, topping it up by Credit Card. Your credit can be used to buy travel tickets and all other available services too. Each single parking will be charged on the registered credit card.\r\r\r\r\r\r\r\r\r\r\r\r\r\n',
                    infoCredito:
                        'Top up myCicero credit by credit card, through Satispay, PayPal or in a SisalPay shop. <b>This payment option has NO extra costs.</b> myCicero Credit can also be used to buy tickets and to pay for all the other available services.',
                    infoCreditoACTV:
                        '<b>This method does NOT provide additional costs.</b> You can use your credit to purchase travel tickets and all other services available.',
                    infoCreditoRoger:
                        'Your credit, topping it up by Credit Card. Your credit can be used to buy travel tickets and all other available services too. Each single parking will be charged on the registered credit card.',
                    labelCartaDiCreditoNecessaria: 'To use this payment modality, you should register a credit card',
                    labelCredito: 'Credit',
                    labelModalita: 'Pay your parking with:',
                    labelNoCarteRegistrate: 'No registered cards found',
                    labelPagamentoContestuale: 'Usage-based payment',
                    labelProcedi: 'Go-ahead',
                    labelRegistraCarta: 'Register a card',
                    labelRicarica: 'Top-up',
                    labelSaldo: 'Credit',
                    labelScegliCartaDiCredito: 'Choose the credit card among the registered ones',
                    labelUtilizzaQuestaCarta: 'Use this registered credit card:',
                    titolo: 'How to pay',
                },
                mostraParcheggi: 'Show Parking Areas',
                numeroStallo: 'Parking space number',
                ongoingNotification: {
                    extendButtonLabel: 'Extend by 30 min.',
                    message: 'until {0}',
                    stopButtonLabel: 'Stop',
                    title: '{0} Active parking',
                },
                oopsAnnullaSosta: 'Oops! Cancel your park.',
                parcheggiGestiti: {
                    avvisoDurataPrenotazione:
                        'The reservation will be authomatically deleted at the expiry of selected period',
                    avvisoOrarioNonConsentito:
                        'The arrival time at the parking has to be included between {0} and {1} according to the regulation of selected facility.',
                    avvisoSostaNonDisponibile:
                        'For the selected dates, no parking can be booked, please try with different dates',
                    avvisoTermineSosta: 'Service ends at <span class="bold">{0}</span>.',
                    cantAddService:
                        'The following requested services could not be included: <ul><% _.forEach(articlesKo, function(article) { %> <li><%- article.descArticolo %></li> <% }); %></ul>',
                    cercaAeroportoLocalita: 'Search by name or place',
                    cercaAeroportoTitle: 'Choose a place',
                    cercaPlaceholder: 'Search by name or city',
                    condizioni: 'I have read the information notice and agree to the  <em>service conditions</em>',
                    confermaConPagamento: 'Book and pay now',
                    confermaSenzaPagamento: 'Book and pay when your parking ends',
                    dataInizioSostaNonConsentita: 'It is not possible to reserve the parking area before {0} at {1}',
                    erroreAggiornamentoPrezzi:
                        'The total amount for the selected days could be updated. Please try again later.',
                    erroreGenericoDisponibilita:
                        'The verify for car park availability with the parking managing authority failed. Please try later or contact our help desk.',
                    importoPagato: 'Amount payed',
                    importoTotaleDurata: 'Total amount for this duration',
                    info: {
                        mail: 'Mail',
                        orarioAp: 'Opening times',
                        servizi: 'Included services',
                        sitoWeb: 'Website',
                        social: 'Social',
                        telefono: 'Telephone',
                        tipo: 'Type',
                        tipoPosti: 'Places typology',
                    },
                    infoDesigna:
                        'Show the Qr code in the parking entrance column. Remember to take paper ticket issued by the column to exit from the parking or to pay the due amount at cashier in case that you exit later than the booked period.',
                    infoPrenotazioneEffettuata: 'The parking you booked is available in the section “Parking and ZTL”',
                    intestazionePrenotazione: '1 place reservation for the number plate',
                    istruzioniDownloadTitoli:
                        'After completing the purchase, you will find your booking in the app section "Parking and ZTL"',
                    menuTitle: 'Off-street parkings',
                    nessunParcheggioRecente: 'There are no recent parkings',
                    nessunRisultato: 'No results found for this search',
                    parkAvail: 'The parking place is available.',
                    parkNotAvail: 'For the days selected, no parking place is available ',
                    placeholderRicercaTestuale: 'Search by name ',
                    postiNonPrenotabili: '{0} available parking lots',
                    postiNonPrenotabiliEsauriti: 'No available parking lot ',
                    prenota: 'Book',
                    prenotaParcheggio: 'Book your parking place',
                    prenotazioneSosta: 'Book your parking',
                    richiediDisponibilita: 'Request availability',
                    scegliParcheggioTitle: 'Choose your parking place',
                    tabCondizioni: 'Conditions',
                    tabElenco: 'List',
                    tabInfo: 'Info',
                    tabMappa: 'Map',
                    tabRecenti: 'Recent',
                    tabTariffe: 'Fees',
                    titleConferma: 'Book your parking',
                    titleConfermata: 'Booking confirmed',
                    titleDettaglio: 'Details',
                    titlePrenota: 'Book your parking',
                    tutteLeAree: 'All the cities',
                    vaiAllaPrenotazione: 'Go to your booking',
                    verificaDisponibilita: 'Check the availability',
                    verificaDisponibilitaInCorso: 'We are contacting the parking managing authority',
                    visualizzaPrenotazione: 'Show the booking',
                },
                parcheggio: 'Parking ',
                posizioneNonDisponibile: 'Your position cannot be retrieved',
                preferenzeSosta: {
                    categorieAgevolate: 'Facilitated categories',
                    disclaimerCategorieSosta: 'The user is responsible of what declared, in accordance with the law ',
                    erroreSalvataggio: 'An error has occurred: the changes made could not be saved',
                    etichettaDurataDueOre: '120 minutes',
                    etichettaDurataFineGiornata: 'End of the day',
                    etichettaDurataQuattroOre: '240 minutes',
                    etichettaDurataUnOra: '60 minutes',
                    infoAreaNotifiche:
                        'Extend and stop the parking session with a click directly from your device notification centre.',
                    infoCategorieUtente:
                        'In some cities there are facilitated tarifs for special categories. If you are part of these categories, please activate the corresponding entry to use the tariffs reserved to you.',
                    infoCittaAbituale:
                        'This city will be automatically selected, in case no GPS position is available.',
                    infoDurataSosta:
                        'The minutes set will be used while activating the parking session to suggest the parking duration.<br/>Until the end of the parking day or as much as the pre-charged credit is available',
                    infoNotificheSms:
                        'The service cost is € 0,08 for every SMS received.<br/>If you start and stop the parking by SMS, an SMS notification for each operation is sent and cannot be deactivated.',
                    labelAreaNotifiche: 'Notification area integration',
                    labelAttiva: 'Activate',
                    labelCittaAbituale: 'Usual City:',
                    labelDurataSosta: 'Suggested parking duration:',
                    labelInLista: 'In the list',
                    labelInMappa: 'In the map',
                    labelNotificheSms: 'SMS notifications',
                    labelScegli: 'Choose',
                    labelSmsFineSosta: 'Parking end confirmation',
                    labelSmsInizioSosta: 'Parking start confirmation',
                    labelVisualizzazioneCercaParcheggio: 'While searching the parking area, please use the map',
                    mieCategorie: 'My categories',
                    titolo: 'Parking options',
                },
                prenotazioneDal: 'Booking from ',
                procedi: 'Go-ahead',
                prolunga: 'Extend',
                prolungaSosta: 'Extend Parking Duration',
                prolungaSostaFail: 'Parking extension failed!',
                prolungaSostaSuccess: 'Parking extended successfully',
                qrCode: {
                    accediEntroLeOre: 'Enter within',
                    accediPagaAllUscita: 'Do you want to access to tje parking now and pay at the exit?',
                    entraNelParcheggio: 'Enter into the parking',
                    erroreGenerazioneQrCode: 'An error occurred during QR Code issuing',
                    esciDalParcheggio: 'Exit from the parking',
                    esciDalParcheggioScansionaQrCode: 'Go to the parking exit and scan the QR Code on the bar ',
                    infoIngressoQrCode:
                        "<span class='bold'>Scan</span> the <span class='bold'>QR Code</span> at the parking entrance machine and take the ticket. Remember that you have<span class='bold'>15 minutes</span> to access in the parking.",
                    infoPagamentoClassico:
                        'Otherwise you can pay inserting the ticket in the automatic parking payment cash register.',
                    infoUscitaQrCode:
                        "<span class='bold'>Pay by the app</span> clicking on the panel of<span class='bold'>active parking</span>.</br><span class='bold'>Scan the QR Code</span> at the parking exit machine.",
                    ingressoEffettuatoAlleOre: 'Entrace done at:',
                    nuovoQrCode: 'New QR Code',
                    pagamentoClassico: 'Classic payment',
                    perEntrare: 'To access',
                    perUscire: 'To exit',
                    qrCodeScaduto: 'Your QR Code is expired, require a new one!',
                    tornaAllaSosta: 'Back to the parking',
                    visualizzaQrCode: 'Show the QR Code',
                },
                reminderUscita: 'Remember that you have 15 minutes available to exit from the parking after payment',
                ricaricaCredito: 'Top Up Credit',
                ricaricaCreditoAssociaCarta: 'Top up your credit or register a Credit Card...',
                rifSosta: 'Parking session ref. No.',
                salvaPosizione: 'Save position',
                scegliArea: 'Select a parking area',
                scegliCitta: 'Choose a city',
                selezionaComune: 'Select a city:',
                selezionaFineSosta: 'Select the desired parking expiry date.',
                servizioNonAttivo:
                    'You still haven\'t activated the service "Parking and ZTL". It will take only few minutes.',
                skidata: {
                    activateIn: 'You will have to activate the ticket within: ',
                    bsb: 'Short parking ticket',
                    cassaAutomatica: 'Ticket vending machine',
                    disambiguaStruttura: 'Select the park area',
                    emissioneFattura:
                        'If asked for, the invoice issued by MyCicero does not include the amount paid to the garage manager and refers exclusively to price paid though the online platform.',
                    expiredTicket: 'The generated ticket is expired.',
                    garage: 'Garage: ',
                    generationOk: 'Ticket correctly generated',
                    goToHome: 'Back to the home page',
                    infoStruttura:
                        'The parking session will be activated, when the QR code will be used to lift the park automatic barrier. You will be charged with the cost according to the real entry time and the applied rates.',
                    labelHour: 'hour',
                    labelHours: 'hours',
                    labelMinute: 'min',
                    labelMinutes: 'min',
                    labelSecond: 'sec',
                    labelSeconds: 'sec',
                    pagamentoOk: 'Payment successfully made',
                    pagamentoOkDescHtmlTemplate:
                        'The parking session payment <span class="bold">{0}</span> was successfully completed.',
                    parcheggiInStruttura: 'Covered park areas',
                    remainingTime: 'Remaining time:',
                    scansioneBiglietto: 'Ticket scan',
                    statusActive: 'Active Parking Session',
                    statusExpired: 'Expired tickets',
                    statusGenerated: 'Activate the parking session within:',
                    statusPaid: 'Exit the garage within:',
                    subscription: 'Long term parking permit',
                },
                sosta: 'Parking',
                sostaAPagamento: 'On-street parking',
                sostaAutorimesse: 'Garage',
                sostaFinoA: 'Park until',
                sostaValidaFinoA: 'Parking active until',
                sosteAttive: 'Active Parking Sessions',
                sosteParcheggi: 'Parking and ZTL',
                sostePrenotate: 'Bookings',
                stallo: 'Parking space number:',
                stalloMancante: 'Please enter the parking space number',
                stalloNonValido: 'Wrong parking space number',
                stalloTargaUsataDiRecente: 'You have recently paid the parking for this car',
                stalloUsatoDiRecente: '',
                stalloX: 'Parking space number {0}',
                talloncinoInviatoInfo: 'The logo for this car has been sent to your email address.',
                targhe: {
                    aggiungi: 'Add vehicle number plate',
                    attr: {
                        disponibile: 'Available',
                        occasionale: 'Free',
                        occupata: 'Used ',
                        principale: 'Main ',
                        secondaria: 'Secondary',
                    },
                    cambiaTarga: 'Change Car Number Plate',
                    conferma: 'Confirm',
                    confermaFormatoTarga:
                        'The car registration number you entered has a non-standard format, would you like to save it as well?',
                    confermaIvioTalloncino: 'Operation completed',
                    confermaRimozioneTarga: 'Would you like to delete this car?',
                    descrizioneBreve: 'Car descrption/name',
                    erroreComuniTalloncino: 'An error has occurred. The list of cities could be loaded.',
                    impossibileCambiareTarga: "You can't change Number Plate",
                    inUso: 'in use',
                    infoCancellazioneTargaPrincipale: 'The main car cannot be cancelled',
                    infoTalloncino: 'You will receive an email with the logo to show in ',
                    infoTalloncinoCitta: 'some cities.',
                    infoTalloncinoObbligatorioParte1: 'To the address',
                    infoTalloncinoObbligatorioParte2:
                        'you will receive an email with the logo which shall compulsory be shown in the following cities:',
                    infoTargaPrincipale1:
                        'The <span class="bold">main number plate</span> will be automatically suggested at each park beginning.',
                    infoTargaPrincipale2: 'Besides it is used for the SMS and NoCall.',
                    infoTargaPrincipaleInUso:
                        'The main plate is currently in use, so you cannot make an other plate the main one at the moment ',
                    infoTargaPrincipaleInUsoHeader: 'Main plate in use',
                    infoTargaPrincipaleOwn:
                        'This is the <span class="bold">main number plate</span>.<br/>It will be automatically suggested at each park beginning. Besides it is used for the SMS and NoCall.',
                    inserisciDatiTarga: 'In order to park is necessary enter data of a vehicle :',
                    inserisciTargaOccasionale: 'Enter the car reg. number to use for this parking session:',
                    inviaTalloncino: 'Send the Qrcode logo',
                    limiteRaggiunto: 'You reached the maximum amount of cars registered allowed',
                    memorizza: 'Save',
                    'memorizza e scegli': 'Save and select',
                    modificaTarga: 'Change your car number',
                    nessunaTargaRegistrata: 'No car registered',
                    noCallInfoTarga:
                        'The No Call/SMS" services will always activate the parking on this car number plate',
                    nuova: 'New car',
                    propostaDefault: 'suggested by default',
                    registraneUna: 'Register one',
                    registrazionePrimaTargaOk: 'You registered the car number',
                    registrazioneTargaKo: 'An error occurred while registering your car',
                    registrazioneTargaOk:
                        'Car registered successfully.<br/>The QrCode referred to this car has been sent to your email address<br/>{0}',
                    rendiTargaPrincipale: 'Change it into main car',
                    rendiTargaPrincipaleKo: 'It is impossible to make this as main number plate.',
                    rimozioneTargaKo: 'An error occurred while cancelling the number plate',
                    rimozioneTargaOk: 'Number plate correcly cancelled',
                    rimuovi: 'Cancel number plate',
                    rules: {
                        accettaCondizioni: 'You must agree with the Terms and Conditions of use',
                        troppoCorta: 'The car registration number shall include more than 3 types ',
                    },
                    salvaInviaTalloncino: 'Save and send the QrCode',
                    scegliTarga: 'Select one of the registered Number Plates to start the parking.',
                    scegliTargaShort: 'Personal',
                    targaNonValida: 'Car Number Plate not valid',
                    targaOccasionale: 'Occasional Car Number Plate',
                    targaPrincipale: 'Main Number Plate',
                    targaSecondaria: 'Secondary Car Number Plate',
                    targaVeicolo: 'car number plate',
                    targheRegistrate: 'Cars registered ',
                    targheSosta: 'Car registration numbers',
                    targheSostaRegistra: 'Register a car',
                    troppeTarghe: 'Sorry, no more then 2 car number plates can be registered!',
                },
                termina: 'Stop',
                terminaSosta: 'Stop parking session',
                terminaSostaPrefix: 'You are interrupting this parking',
                terminaSostaSuccess: 'Parking interrupted correctly',
                terminaSostaSuffix: 'minutes before the expected expiry date',
                termineBreve: 'The parking will end soon',
                termineSpecifico: 'Your parking will expire on {0} at {1}',
                trovaLaMiaAuto: 'Find my car',
                ultimi30MovFinoAlGiorno: 'Last 30 transactions until',
                usaMyCicero: 'Use myCicero',
                uscitaAlleOre: 'Exit at:',
                validaFinoA: 'Valid until',
                ztl: {
                    label: 'ZTL Permits',
                    subtitle: 'Restricted Access Areas',
                },
            },
            lardini: {
                aggiornamentoRisultatiInCorso: 'Results update',
                catalogoBuoni: 'Voucher catalog',
                classifica: 'Rank',
                infoGiornataCampionato: '{0}° Day - {1}',
                inizioAlle: 'Start at: {0}',
                livescore: 'Livescore',
                mondoLardiniFilottrano: 'The world of Lardini Filottrano',
                parcheggiaCon: 'Park with',
                partiteDel: 'Games of {0}',
                partiteLive: 'LIVE games',
                rilasciaPerAggiornare: 'Release to update the results',
                scopriNovita: 'Learn news',
                scorriVersoIlBassoPerAggiornare: 'Scroll to the bottom to update the results',
                sponsor: 'Sponsor',
                tableClassifica: {
                    labelSquadre: 'Teams',
                    partiteGiocate: 'Total matches',
                    partiteGiocateShort: 'T',
                    partitePerse: 'Lost matches',
                    partitePerseShort: 'L',
                    partiteVinte: 'Won matches',
                    partiteVinteShort: 'W',
                    punti: 'Points',
                    puntiShort: 'PT',
                    setPersi: 'Lost set',
                    setPersiShort: 'SL',
                    setVinti: 'Won set',
                    setVintiShort: 'SW',
                },
                viaggiaCon: 'Travel with',
                visualizzaParzialiSet: 'Show partial sets',
            },
            lecceclick: {
                bagniPubblici: 'Public toilets',
                colonnineAutoEnel: 'charging points for Enel cars',
                defibrillatori: 'Defibrillatori',
                esperienze: 'Experiences',
                fontanelleAcquaPotabile: 'Drinkable water',
                giochi: 'Games',
                gioco: '',
                infoProgettoEuropeo:
                    'Project funded by the European Union on P.O.R. Puglia 2014-2020, ERDF Fund, Action2.2',
                itinerari: 'Itineraries',
                parcheggiPubbliciPrivati: 'Private and public parking areas',
                runninCity: "Runnin'City",
                servizi: 'Services',
                wifiHotspot: 'Wifi hotspot',
            },
            media: {
                acquisisciImmagine: 'Take a photo',
                fotocamera: 'Camera ',
                gallery: 'Saved Images',
                importaGallery: 'Import a saved image ',
                scattaFoto: 'Take a photo',
                sceltaFotoGallery:
                    'Would you like to take a photo or do you prefer to import one of your saved images?',
            },
            mobilita: {
                acquistaDiNuovo: 'New purchase',
                acquistiRecenti: 'Recent purchases',
                biglietteria: 'Ticket office',
                cercaFermata: 'Search bus stop',
                cercaIndirizzo: 'Search by address',
                cercaLinea: 'Search line',
                cercaPerCodice: 'Search by code',
                cercaPerCodiceOrDescrizioneFermata: 'Search by code or description',
                cercaPerCodiceOrDescrizioneLinea: 'Search by code or description',
                cercaPerFermata: 'Search by code',
                cercaPerNumero: 'Search for number',
                cercaPerStazione: 'Search for station',
                cercaStazione: 'Search station',
                cercaTreno: 'Search train',
                cittaOrLocalita: 'City or place',
                codiceDescrizioneFermata: 'Stop code / description',
                codiceDescrizioneLinea: 'Line code / description',
                codiceFermata: 'Or stop code',
                codiceLinea: 'Or line code',
                codiceOrDescrizioneFermata: 'Stop code or description',
                codiceOrDescrizioneLinea: 'Line code or description',
                deleteAllConfirmMsg: 'If you confirm ALL expired "{0}"  tickets will be cancelled from your device.',
                deleteConfirmMsg: 'If you confirm, the ticket will be cancelled from your device.',
                dettaglioFermata: 'Stop details',
                fermate: 'Bus stops',
                fermateIntorno: 'Stops around',
                fermatePreferite: 'Favourite stops',
                header: 'Mobility',
                inserisciIDati: 'Insert data required to proceed',
                intornoA: 'Around',
                intornoAllIndirizzo: 'Near the address',
                linea: 'Line',
                linee: 'Line Timetable',
                lineePreferite: 'Favourite lines',
                lineeServite: 'Served lines',
                mieiTitoli: 'My tickets',
                navette: 'Shuttle buses',
                needToLogin: 'To visualize purchased tickets.',
                nessunRisultato: 'No results found',
                nessunaSoluzione: 'No solutions',
                noTitoliAttiviScaduti: 'There are no tickets to activate or which have already been used',
                numeroOrCodiceTreno: 'Train number or code',
                numeroTreno: 'Train number',
                ogniXminuti: 'Evry {0} minutes',
                orariAlleFermateLinee: 'Timetable at the bus-stops and lines',
                parlaConNoi: 'Speak with us',
                popolari: 'Most popular companies',
                reti: 'Nets',
                scegliPercorso: 'Choose a route',
                searchingTickets: "I'm searching purchased tickets",
                stazione: 'Station',
                stazioni: 'Stations',
                stazioniIntorno: 'Surrounding stations',
                stazioniPreferite: 'Favourites stations',
                tabelloneOrari: 'Scheduleboard',
                titoliAttivi: 'Active tickets',
                trattaXdiY: 'Route {0} of {1}',
                treni: 'Trenitalia',
                tuttiPassaggi: 'All passages',
            },
            momup: {
                AcquistaBiglietti: 'Buy tickets',
                CalcolaPercorso: 'Plan route',
                Eventi: 'Events',
                FermateOrari: 'Stops and schedules',
                Luoghi: 'Places',
                MieiTitoli: 'My tickets',
                abilitaNfc: 'Activate the NFC in device settings in order to read the NFC cards',
                letturaTessera: 'Card reading',
                letturaTitoli: 'Read ticket',
                navette: 'Treviso AirBus - Touristic tickets',
                nfc: {
                    arrival: 'Place',
                    article: 'Article',
                    contract: 'Agreent',
                    dataOraFineValidita: 'Date of end validity',
                    dataOraValidazione: 'Date and time of validation',
                    departure: 'Departure place',
                    endDate: 'Validity end date',
                    fermata: 'Stop',
                    linea: 'Line',
                    residuals: 'Remaining rides',
                    startDate: 'Validity start date',
                    vediValidazioni: 'See validations',
                },
                scansiona: 'Scan',
                scansioneFallita: 'Scan error',
                scopriAltreApp: 'Discover Mom world',
            },
            mp: {
                archeologia: 'Archeology',
                arteStoria: 'Art and history',
                bikeTrekking: 'Bike & Trekking',
                cominciaViaggio: 'The journey begins',
                contattaci: 'Contact us',
                culturaTradizione: 'Culture and traditions',
                eccellenze: 'Excellence',
                esperienze: 'Experience',
                eventi: 'Events',
                facebook: 'Follow us on FB',
                instagram: 'Instagram',
                itinerari: 'Itineraries',
                luoghi: 'Places',
                mail: 'Contacts',
                naturaScienza: 'Nature and science',
                ospitalita: 'Hospitality',
                prodotti: 'Products',
                scegliMuseo: 'Choose your museum',
                sosta: 'Parking',
                trasporto: 'Transport',
                youtube: 'YouTube',
            },
            mycicero: {
                biglietteria: {
                    header: 'Ticket office',
                },
                changePosition: {
                    header: 'Search city',
                    inputPlaceholder: 'Search city',
                    noResults: 'Choose city and discover all myCicero services',
                },
                home: {
                    descrizioneSosta: 'Blue lines, parking, ztl',
                    descrizioneViaggia: 'Train, bus, metro, ship',
                    highlightTitle: 'In evidence',
                    titoloSosta: 'Park',
                    titoloViaggia: 'Travel',
                },
                viaggia: {
                    abbonamenti: 'Passes',
                    abbonamentiExt: 'Passes',
                    acquistoOd: 'Buy from travel solution',
                    acquistoOdTessera: 'Search price',
                    acquistoSMS: 'Buy through SMS',
                    bigliettiSuPrenotazione: 'Tickets online',
                    header: 'Travel',
                    multiacquisto: 'Tourist services',
                    tariffaFissa: 'Fixed rate tickets',
                },
            },
            mytrasfer: {
                acquistaBiglietti: 'Buy tickets',
                calcolaPercorso: 'Calculate route',
                fermateOrari: 'Stops and schedules',
            },
            navette: {
                allResults: 'All results',
                anErrorOccurredRetry: 'An error occurred. <b>Try again</b>',
                busAndStops: 'Busses and stops',
                cercaPlaceHolder: 'Search by name',
                cosaVedere: 'What to see',
                detinazione: 'Destination',
                durata: 'Duration',
                emptyPoiList: 'No results',
                infoArrivoPrevistoNonDisponibili: 'Passage information not available',
                infoDirezioneNonDisponibili: 'Information about direction not available',
                infoNomeFermataNonDisponibile: 'Stop name not available',
                infoNonDisponibili: 'Further information are not available',
                informazioni: 'Information',
                kmTotali: 'Total Km',
                navettaDaEPer: 'Shuttles FROM and TO:',
                searchByNameOrLocation: 'Search by name or city',
                serviziTuristici: 'Tourist services',
                social: 'Social',
                tab: {
                    agenda: 'Agenda',
                    condizioni: 'Conditions',
                    dettagli: 'Details',
                    info: 'Info',
                    itinerario: 'Route',
                    mappa: 'Map',
                    orari: 'Timetable',
                    partenzeArrivi: 'Departures and arrivals',
                    tappe: 'Stages',
                },
                tappe: 'Stages',
                telefono: 'Phone',
                'title-elenco': 'Shuttle buses',
                titleMenu: 'Shuttle buses',
                updatingData: 'Shuttle buses',
                web: 'Web',
            },
            notification: {
                connectionErrorHeader: 'Internet connection unavailable',
                connectionErrorMessage:
                    'Error during connection with remote server: please verify your data connection and try again.',
                errorGeneric: 'An error occurred, unable to complete this operation.',
                noConnection: 'Internet connection unavailable.',
                offline: 'Offline',
                successGeneric: 'Update in progress…',
                successGenericHeader: 'Success',
                templateBorsellinoSosta: 'Credit: &euro; {0}',
                templateContactUs: 'Contact us...',
                templateCreditoNonDisponibile: 'An error occurred while calculating the credit',
                templateRicalcoloCredito: 'Calculating credit...',
            },
            notify: {
                header: 'Attention',
                questionAreaTariffabile: 'Do you believe this is part of a parking area?',
                segnalaAnomalie: 'Report malfunctions',
            },
            plusPayment: {
                cambiaMetodo: 'Other method',
                confermaInizioSosta: 'Confirm park beginning',
                effettuaLogin: 'Login',
                erroreAggiornamentoMetodiDiPagamento:
                    'Your payment modalities could not be updated. Please check the internet connection and retry.',
                erroreAggiornamentoSaldoBorsellino:
                    'Your credit could not be updated. Please check the internet connection and retry.',
                erroreAggiornamentoSaldoBorsellinoParent:
                    'Your credit {0} could not be updated. Please check the internet connection and retry.',
                ilTuoProfilo: 'Your profile',
                modalitaPagamentoNonSupportata: 'The selected modality cannot currently be used for the payment',
                nessunMetodoAlternativo: 'No alternative payment method available',
                paga: 'Pay',
                pagaConBorsellinoParent: 'Py with {0}',
                pagaConCartaDiCredito: 'Registered Card',
                profiloPagamento: 'Payment profile of </br>',
                ricaricaCreditoMyCicero: 'Top up your credit',
                usaCreditoMyCicero: 'Pay by using your credit',
                usaIlCredito: "Top up your myCicero credit. It's cheap!",
                usaIlCreditoBranded: 'Top up your credit',
            },
            poi: {
                apriMacrocategoria: 'Open a macrocategory ',
                categoria: 'Category',
                categorie: 'Categories',
                categorieSelezionate: 'Selected categories',
                contatti: {
                    email: 'Email',
                    fax: 'Fax',
                    header: 'Contacts',
                    tel: 'Tel',
                    url: 'Website',
                },
                deselezionaTutto: 'None',
                dettaglio: 'Place',
                elenco: 'List',
                espositori: 'Exhibitors',
                eventi: 'Events',
                eventiCorrelati: 'Related events',
                header: 'Landmarks ',
                info: 'Info & Contacts',
                infoContatti: {
                    cellulare: 'Mobile',
                    email: 'Email',
                    facebook: 'Facebook',
                    gestione: 'Management',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Phone',
                    vaiAlSito: 'Go to the website',
                },
                istruzioniNoCategorie: 'choose a category',
                itinerariCorrelati: 'Itineraries passing through here',
                loadMore: 'Look for other landmarks',
                luoghiCorrelati: 'Related places',
                macrocategorie: 'Macrocategories',
                mappa: 'Map',
                nessunPoiTrovato: 'no results have been found to match the search terms ',
                ospiti: 'Important guests',
                placeholderRicerca: 'Search...',
                posizioneNonCoperta: 'You are not in a served area',
                promozioni: {
                    promoPerTe: 'special offers for you',
                    promoPerTutti: 'available to all users',
                },
                ricercaInfoTerritorio: 'Which area are you looking for?',
                ricercaTutteCategorie: 'Search in all categories',
                scegliCategoria: 'Select',
                scegliPoi: 'Select a landmark',
                scegliTerritorio: 'List of the areas we serve. Choose the one you prefer',
                selezionaPoi: 'Select a POI',
                selezionaTutto: 'all',
                serviziInclusi: 'Select an event',
                serviziUtili: 'Useful services',
                specialitaCorrelate: 'Related products',
                staiCercandoAllCategories: 'In all the categories',
                tab: {
                    allegati: 'Attaches',
                    info: 'Info',
                    mappa: 'Map',
                },
                tutteLeCategorie: 'All the categories',
                vetrina: 'Showcase',
                virtualTour: {
                    info: 'The virtual tour will be opened in a browser window of the device',
                    intro: 'If you want to discover the best places of the region, take a virtual tour',
                    lancia: 'start the virtual tour',
                },
            },
            primoAvvio: {
                tutorial: {
                    biglietti: {
                        testo: 'Buy tickets and seasonal tickets in a click',
                        titolo: 'No more code',
                    },
                    borsellino: {
                        testo: 'And use it to pay for all the services offered',
                        titolo: 'Top up your credit',
                    },
                    buoniMotivi: {
                        testo: 'Good reasons to love myCicero',
                        titolo: 'A great app!',
                    },
                    dolomiti: {
                        scopriLeBellezze: {
                            testo: 'Discover with us Dolomites beauties',
                        },
                    },
                    masterpass: {
                        testo: 'With Masterpass of Mastercard is safe and you immedately receive the bonus',
                        titolo: 'Register your card',
                    },
                    seguiIlViaggio: {
                        testo: 'Train punctuality, next stops and arrival times',
                        titolo: 'Get updated when travelling by train',
                    },
                    soluzioniDiViaggio: {
                        testo: 'Integrated solutions with train, bus and metro',
                        titolo: 'Plan your travel',
                    },
                    sosta: {
                        testo: 'Pay only for the real parking minutes',
                        titolo: 'Save money when parking',
                    },
                },
            },
            profilazione: {
                accedi: 'Login',
                accediAccount: 'You are already registered',
                aci: {
                    registrazioneEseguiLogin:
                        'Please login to use the services made available by ACI in your myCicero account.',
                    registrazioneUtenteEsistenteConTessera:
                        'Your ACI member card has been successfully associated with your myCicero account (matching with your ACI account).',
                    registrazioneUtenteNuovoConTessera:
                        'Registration completed. You will find your login data in the email sent to the email address which is associated with your ACI account. Your ACI member card has been activated.',
                    registrazioneUtenteNuovoSenzaTessera:
                        'Registration completed. You will find your login data in the email sent to the email address which is associated with your ACI account. ',
                },
                activateServices: 'Activate services quickly',
                alreadySubscribed: 'Do you have already an account?',
                associaFoto: 'Attach a photo',
                azienda: 'Business',
                benvenuto: 'Welcome ',
                cambiaEmail: 'Email modify',
                cap: 'Zip code',
                cartaRegistrata: 'Registered Card',
                cell: 'Mobile Phone',
                cellFormatInvalid: 'Mobile phone number not valid.',
                cellulare: 'Mobile phone number',
                checkAccetto: 'I accept',
                checkComunicazioni: 'Receive communications and news',
                checkCondizioniPrivacy: 'I agree the ',
                checkCondizioniUtilizzo: 'I have read the',
                checkCondizioniUtilizzoAlternativelabel: 'I read',
                chiudi: 'Close',
                citta: 'City',
                cittaNascita: 'Municipality of birth',
                cittaResidenza: 'Municipality of residence',
                codTessera: 'Card number',
                codiceCliente: 'Client Code',
                codiceFiscale: 'Fiscal code',
                codiceUnivocoDestinatario: 'Recipient Unique Code',
                cognome: 'Surname',
                cohesion: {
                    erroreRegistrazione: 'Registratzion by Cohesion failed',
                    labelHtml: 'Registration by <b>Cohesion 2.0</b>:',
                },
                condizioniAltriFini: 'Consent form for promo shipping',
                condizioniCommerciali: 'Commercial Information',
                condizioniContrattuali: 'contractual conditions ',
                condizioniDiUtilizzo: 'terms of use',
                condizioniDiUtilizzoAlternativeLabel: 'Privacy policy',
                condizioniFiniCommerciali: 'Consent form for information material shipping',
                condizioniIscritti: 'Members report',
                condizioniPrivacy: 'privacy policy',
                condizioniUtilizzo: 'Terms of use',
                condizioniUtilizzoCredito: 'Credit terms of use',
                condizioniUtilizzoGenerali: 'General terms of use',
                condizioniUtilizzoPrivacy: 'Terms and conditions and privacy policy',
                condizioniUtilizzoSosta: 'Parking terms of use',
                condizioniUtilizzoTrasporto: 'Transport terms of use',
                confirmRollback: 'All entered data will be lost. Continue?',
                confirmation: 'Confirmation Code',
                contattaAssistenza: 'Contact our support',
                continuaSenzaRegistrazione: 'Continue without registration',
                continuaSenzaRegistrazioneAvvertimento:
                    'By continuing without registration it will not be possible making purchases',
                controllaCodice: 'Check code',
                controllaEmail: 'Check if your email account has been properly registered',
                creaUtente: 'Create your account',
                creaUtenteDesc: 'Create your user profile very quickly...',
                dataNascita: 'Birth Date',
                descrizionePromo: 'Have you a promotional code? Enter it here and activate the promotion',
                ebbeneSi: 'Yes, start again',
                email: 'E-mail address',
                emailConfirmed: 'Your e-mail address has been validated successfully',
                emailReminder:
                    'Remeber to confirm by clicking on the activation link we have sent to your e-mail address. You can also do it later',
                emailSent: 'E-mail sent to',
                erroreRegistrazioneCarta: 'The credit card registration failed',
                esclamaBenvenuto: 'Welcome!',
                fatturazioneElettronica: 'Digital invoice',
                fine: 'End',
                indirizzo: 'Address',
                indirizzoResidenza: 'Address of residence',
                infoMoficaDati:
                    'For any modification, before confirming, write to assistenza@mycicero.it o chiamar call 071 920 7000',
                infoNecessaria: 'Required fields',
                informativaFatturazione:
                    'Invoice for parking or travel tickets (local public transport) is not mandatory because it is outside the scope of VAT, according to Art. 74 DPR 633/72, point e), introducing single tax Vat. In case of request, the invoice will be issued and handled as an eInvoice with consequent costs for buyer, who will have to save it. Therefore we advise you, if possible, to save only the payment receipt. The payment receipt will be always issued at the same time of purchase for free. Otherwise, if you need the invoice, this will cost € 0,10 per month, equal to the cost beared to myCicero for eInvoice issuing and saving. The single invoice will be monthly sent by email only for the parking companies and for the services which provide invoice issuing.',
                informativaPrivacy: 'Privacy Information notice',
                inizia: 'Start',
                insertPinCode: 'Insert the activation code',
                intestatario: 'Card data',
                inviaSms: 'Send SMS',
                inviaSmsConferma: 'Yes, please, send it!',
                inviaSmsInfo: 'The activation code will be sent via sms. Are you sure?',
                iscrizione: 'You are registered with',
                iscrizioneNonCompletataPopupAnnullaEdElimina: 'Cancel and eliminate user',
                iscrizioneNonCompletataPopupCompletaIscrizione: 'For further information:',
                iscrizioneNonCompletataPopupMsg: 'Cancel and remove the user',
                iscrizioneNonCompletataPopupTitle: 'Registration not completed',
                iscrizioneServizi:
                    'If you already registered an account with autobus.it, you can use the same credentials',
                localitaProvenienza: 'Flight departing from',
                messaggioAssociaFoto:
                    'WARNING: This photo will be set in your season ticket and it will not be possible to change it',
                modelloVeicolo: 'Vehicle model type',
                modelloVeicoloObbligatorio: 'Vehicle model',
                modelloVeicoloOpzionale: 'Vehicle model (optional)',
                msgAssistenzaActv: 'app.support@avmspa.it',
                msgAssistenzaDefault: 'assistenza@mycicero.it and call center 071 920 7001',
                nazione: 'State',
                nazioneNascita: 'State of birth',
                nome: 'Name',
                nonHaiTessera: "Don't you have a transport card?",
                normativaPrivacy: 'Privacy Policy',
                numVolo: 'Return flight number',
                numeroTelefonoConfermato: 'Mobile phone number confirmed',
                numeroVerde: 'Toll free number',
                nuovoUtente: 'New user',
                partitaIva: 'Tax number',
                password: 'Password',
                passwordConfirm: 'Confirm Password',
                passwordNotMatch: 'Passwords do not match',
                pecEmail: 'PEC destinatario',
                perAssistenza: 'For our customer service send an email to the following address: ',
                perAssistenzaActv: 'In case you need support, please send an email to our help desk',
                perAssistenzaSito: 'For support, click the following',
                perAssistenzaTelefono: 'Or call the number:',
                perAssistenzaUlteriore: 'For problems with reception of tickets:',
                perInfo: 'For informations: ',
                perUlterioriInfo: 'For further information: ',
                perUlterioriInfoInfoActv: 'For further information: ',
                pinCode: 'Confirmation Code',
                pinCodeDesc: 'We have texted you the activation code.',
                privato: 'Private person',
                procedi: 'Continue',
                profiloPreferito: 'Main Profile',
                profiloPreferitoMessage: 'This profile will be used for the invoicing',
                promoCodePlaceholder: 'Insert a promotional code',
                promozioni: 'Promotions ',
                provincia: 'Province',
                ragioneSociale: 'Company name',
                recapiti: 'Contact',
                registraNuovoUtente: 'Register as a new user',
                registratiOra: 'Register now',
                registrationCompleted: 'Registration Completed',
                registrationFailed: 'Registration failed',
                registrazione1: 'Registration 1/2',
                registrazione2: 'Registration 2/2',
                reinviaSMS: 'Send SMS again',
                requiredFields: 'Please fill all required fields',
                resendBtn: 'Yes',
                resendOk: 'We have just texted you the activation code again. You should receive it shortly',
                resendText: 'We are going to text you the activation code again. Do you confirm?',
                resended: 'Code sent',
                rightNumber: 'Is that number correct?',
                rimuoviProfilo: 'Remove profile',
                salvaModifiche: 'Save the changes',
                sendSms: 'Sending confirmation SMS and e-mail...',
                sendingEmailDesc: 'We are sending an e-mail with the activation link to this e-mail address:',
                sendingSmsDesc: 'We are sending an SMS with the verification code to this number:',
                smsNotSent: 'SMS not sent to',
                smsSent: 'SMS sent to',
                splitPayment: 'Split Payment company',
                startAgain: 'Modify your number',
                targaObbligatoria: 'Vehicle reg. number',
                targaOpzionale: 'Vehicle reg. number (optional)',
                titoliAtac: 'ATAC Tickets',
                titoloPersonale: 'Insert and/or check your seasonal ticket card number before confirmation',
                titoloPesonale: 'Transport Card',
                usaCodice: 'Use the code',
                username: 'Username',
                vaiAllApp: 'Start using the app',
                vediPromo: 'Show active promotions',
                verificaCodiceSms: 'Verify the SMS code',
                wrongNumber: 'Wrong number?',
            },
            profiloUtente: {
                carte: 'Registered Credit Cards',
                impostazioniNotifiche: {
                    description:
                        'Extend and stop the parking with a click directly from the notification area of your smartphone',
                    header: 'Notification area integration',
                    title: 'Notification settings',
                    toggleActive: 'Disable',
                    toggleInactive: 'Enable',
                },
                mostraCod: 'Visualize User Code',
                nessunaCarta: 'No credit card',
                nessunaTessera: 'No linked card',
                pref: 'Personal settings',
                tessere: 'Cards and Contracts',
                title: 'User Profile',
            },
            promozione: {
                atmaBullet1: 'Scan the your user bar code by the scan reader on compactor machines',
                atmaBullet2: 'Insert only PET bottles from 0,5 to 2 litres and receive your ecobonus',
                atmaBullet3: 'Buy tickets using the collected bonus ',
                bullet1: 'Scan your user bar code through the scanner on compactors',
                bullet2:
                    'Please, 0,5 and 2 litres PET bottles only. You will receive your ecobonus. You can register maximum 30 a day.',
                bullet3: 'Buy tickets through the collected bonus',
                caricaNuovoBuono: 'Top up new voucher',
                caricaNuovoCredito: 'Top up new credit',
                compraAtac: 'Buy tickets B+ ',
                compraAtma: 'Buy ATMA tickets',
                dataOraMovimento: 'Date and Time',
                descrizione: 'You can use this amount to </br> buy tickets',
                descrizioneMovimento: 'Description',
                elencoPromozioniMobilita: {
                    nessunaPromozione: 'There are no promotions ',
                    title: 'Credits list ',
                },
                importoMovimento: 'Amount',
                invalidTxt: 'These data are not compliant to the given format',
                istruzioniPrincipaliHTML:
                    '<span class="bold">Recicle your plastic bottles and you\'ll be able to collect credit to buytickets and subscriptions <span class="bold atac-red">ATAC</span></span>',
                istruzioniPrincipaliHTMLATMA:
                    '<span class="bold">Recycle your plastic bottles and you can gather a credit to buy ATMA tickets</span>',
                labelProfilo: 'ATAC Roma, more reuse, more travels',
                labelProfiloAtma: 'ATMA Ancona Bottle Recycling',
                labelSaldo: 'Balance',
                movimenti: 'Transactions',
                noMovimenti: 'There are no transactions available',
                scadenza: 'Expiry date',
                titoliBAtac: 'B+ ATAC',
                titoliBAtma: 'ATMA',
                tuttiMovimenti: 'All transactions',
                txtInstructions:
                    'Insert required data and verify the voucher code to top up the prepaid credit concerning',
                ultimiMovimenti: 'Last transaction',
                usaCreditiMobilita: 'Use mobility credits',
                utilizzoEcobonus: 'Ecobonus use (€ {0})',
            },
            rockinroma: {
                atac: 'ATAC tickets',
                festival: 'Festival',
                lineUp: 'Lineup',
                location: 'Location',
                mieiTitoli: 'My tickets',
                tickets: 'Tickets',
                travel: 'Travel',
                treniDelRock: 'Post-concert trains',
            },
            rss: {
                dettaglioHeader: 'Detail',
                filterPlaceholder: 'Search...',
                latestNews: 'Latest News',
                news: 'News',
                newsFontiNotificheHeader: 'Feeds list',
                newsNotificheHeader: 'News e Notices',
                noResults: 'No results',
                scegliFeed: 'Choose a feed',
                updating: 'Checking news...',
            },
            rundetails: {
                nodata: {
                    empty: 'no details found',
                },
                realTime: {
                    arrivoPrevisto: 'estimated arrival',
                    arrivoReale: 'Actual',
                    arrivoStimato: 'Estimated',
                    binarioPrevisto: 'Scheduled rail',
                    binarioReale: 'Actual',
                    inAnticipo: 'in advance',
                    inOrario: 'on time',
                    inRitardo: 'delayed',
                    minuti: 'minutes',
                    minuto: 'minute',
                    partenzaPrevista: 'Scheduled departure',
                    partenzaReale: 'Actual',
                    ultimoRilevamento: 'Last survey: ',
                },
            },
            sanzioni: {
                cercaVerbale: 'Search record',
                codiceFiscale: 'Fiscal code',
                codiceInfrazione: 'Infraction code',
                cognome: 'Surename',
                cognomeSanzionato: 'Penalized surename',
                controllareDatiInseriti: 'Control inserted data.',
                data: 'Date',
                dataNascita: 'Date of birth',
                dataVerbale: 'Date of report',
                datiIncompleti: 'Incomplete data',
                datiSanzionato: 'Data of punished person',
                datiVerbale: 'Report data',
                descrizione: 'Description',
                dettaglioVerbale: 'Report detail',
                erroreIdSistema: 'IdSistem not specified',
                idVerbale: 'Report Id',
                importoBiglietto: 'Ticket amount',
                infoDatiVerbale: 'Insert necessary data for report research',
                noVettoriAbilitatiPagamentoSanzioni: 'No transport company enabled to penalties payment.',
                nome: 'Name',
                nomeSanzionato: 'Name of punished person',
                numero: 'Number',
                numeroVerbale: 'Report number',
                pagamentoSanzioni: 'Penalties payment',
                sanzionato: 'Punished',
                sanzione: 'Penalties',
                serialeVerbale: 'Report serial number',
                serie: 'Series',
                speseAmministrative: 'Administrative costs',
                totale: 'Total amount',
                verbale: 'Report',
                verbaleNonPagabile: '<b>Already paied report</b>',
                verbaleNonTrovato: '<b>Report not found</b><br>Check inserted data.',
            },
            selectPositionOnMap: {
                areaNonServitaHtml:
                    'For information please contact us at <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> or <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">via chat</a>',
                areaNonServitaLabel: 'Choose a point on the map.',
                areaNonServitaTitle: 'Not served area',
                disclaimerBtn: 'I see',
                disclaimerMsg: 'Be sure to indicate the right position',
                ricercaLocalitaInCorso: 'Searching locality…',
                scegli: 'Choose',
                warningAumentaZoom: 'Intensify the zoom',
                warningZoomInsufficiente: 'Intensify the zoom, to find your position',
            },
            selezionaModalitaDiPagamento: {
                comeVuoiPagare: 'How would you like to pay?',
                modalita: {
                    acipg: 'ACI Pay',
                    amonw: 'Payment cards',
                    bbol: '',
                    bill: 'Bill by SisalPay',
                    brsel: 'myCicero Credit',
                    cc: '',
                    ccric: 'Payment cards',
                    'ccs-2-s': '',
                    mpass: 'Masterpass™',
                    pbemo: 'BeMoov',
                    ppay: 'Postepay',
                    ppexp: 'PayPal',
                    ppric: 'PayPal',
                    sisal: 'SisalPay',
                    stpay: 'SatisPay®',
                },
            },
            serCom: {
                NessunServizioAzienda: 'No services available for the user with business profile',
                NessunServizioPrivato: 'No service available for the user with private profile',
                avvisiPagamento: {
                    header: 'Payment Alerts',
                    inScadenza: 'Expiring/to pay',
                },
                azienda: 'Company',
                certificazioneInfoHTML:
                    'In order to display payment notifications sent by public authorities, you have to be a certified user. To certify your account, go to authorized Municipality offices with valid ID card, or enter your certified system credentials (Cohesion) in your Private Online Area from a PC or Mac',
                comune: 'City',
                comuniRecenti: 'Recent cities',
                comuniSerCom: 'Towns providing Municipal Services',
                contattaAssistenza: 'Please, get in touch with our help desk',
                contatti: 'Contacts',
                costoServizio: 'Service Cost',
                dataInfrazione: 'Date of infraction',
                elencoMovimenti: {
                    header: 'Transactions List',
                    noResults: 'Transactions not found in the indicated period',
                    ricercaMovimenti: 'Search',
                },
                mainHeader: 'Municipal Services',
                nessunImportoDovuto: 'Total Amount due = 0, no payment is necessary!',
                news: {
                    header: 'News & Notices',
                },
                oraInfrazione: 'Time of infraction',
                pagamentiSpontanei: {
                    compilaTutto: 'Warning: fill all the required fields',
                    header: 'Voluntary Payments',
                    pagSpontaneo: 'Voluntary Payment',
                },
                pagamento: {
                    dataEmissione: 'Issue Date',
                    dataFine: 'Ending Date',
                    dataInizio: 'Starting Date',
                    dataSanzione: 'Sanction Date',
                    dataScadenza: 'Expiry Date',
                    descr: 'Description',
                    errorePagamento: 'An error occurred during payment transaction',
                    header: 'Payment',
                    importoDaPagare: 'Amount',
                    importoNonValido: 'Invalid amount',
                    pagamentoGuidato: 'Payment Wizard',
                    scegliData: 'Choose a date',
                    soggetto: 'Subject',
                    targa: 'Number Plate',
                    verbale: 'Report',
                },
                pagamentoEffettuato: 'Payment completed',
                pagamentoNonAbilitato: 'Payment not enabled',
                privato: 'Private',
                richiediCert: 'Request Certification',
                richiediCertInfoHTML:
                    'You will be redirected to your private account (accessible only by a <strong>traditional PC</strong>.',
                segnalazioni: {
                    cat: 'Category',
                    descr: 'Description',
                    header: 'Reports',
                    img: 'Picture',
                    indirizzo: 'Report Address',
                    inserite: 'Submitted Reports',
                    invia: 'Send Report',
                    noCategorie: 'There are no categories available for your current location',
                    nuova: {
                        abbandona: 'Discard current report and exit',
                        attendiCaricamentoImmagine: 'Loading image...',
                        caricamentoImmagineFallito: 'Loading image failed',
                        fail: 'Impossible to submit the current report!',
                        header: 'New Report',
                        inserisciQui: 'Insert Report Here',
                        success: 'Report submitted successfully!',
                        torna: 'Back to report',
                    },
                    subCat: 'Subcategory',
                    tue: 'Your Reports',
                    welcome: 'Welcome!',
                    welcomeIntroTemplate:
                        '<p>In this page you can send a report to {0}.</p><p>Choose one of the {1} availble categories:</p>',
                },
                serviziAbilitatiAzienda: 'Available services for user with business profile',
                serviziAbilitatiPrivato: 'Available services for user with private profile',
                tipoSoggetto: 'Type of Subject',
                tornaAiServizi: 'Back to Services',
                totale: 'Total',
                transazioneOK: 'Transaction completed successfully',
                utenteNonCertificato: 'User not certified',
            },
            siae: {
                acquistaBiglietti: 'Buy tickets',
                chooseSector: {
                    apriMappa: 'Open map',
                    headerScegliDaLista: 'Authomatic seat assignment',
                    headerScegliDaMappa: 'Seat selection',
                    noSettori: 'No area found',
                    scegliBiglietti: 'Choose tickets',
                },
                mieiBiglietti: 'My tickets',
                myTickets: {
                    mieiTitoli: 'My tickets',
                    passati: 'Gone by',
                    validi: 'Valid',
                },
                posto: 'Seat',
                seasonTicket: 'Seasonal ticket',
                settore: 'Area',
                ticketDetails: {
                    carta: 'Card',
                    cfOrganizzazione: 'CF Org.',
                    cfTitolo: 'CF Tit.',
                    data: 'Date',
                    idSistema: 'System ID',
                    progressiva: 'Progressiv',
                    sf: 'S.F.',
                    tipoEvento: 'Event',
                },
                ticketsSummary: {
                    commissioni: 'Service fees',
                    pagaConCarta: 'Pay by credit',
                    prevendita: 'Pre-sale',
                    removeTicketConfirm: 'Are you sure to cancel this item?',
                    staiPerAcquistare: 'You are buying',
                },
            },
            smartArea: {
                cambiaCitta: 'Change city...',
                confermaReset: 'All data stored locally in the Smart Area will be removed',
                defaultTitleHtml: 'The world of smart services',
                nonScegliNulla: 'No, thanks...',
                oppureAreaSmartHtml: 'Or choose a <i>smart</i> city:',
                reset: 'Clear local Smart Area data',
                resetDone: 'All data cleared. At next login to the home page, all data will be refreshed',
                scegli: 'Choose Smart City',
                seiQui: 'You are here',
                selezionaAreaSmart: 'Choose a Smart Area or City',
                servizioNonDisponibile: 'Service unavailable at the moment. Please, try later.',
            },
            solutions: {
                acquista: {
                    aPiedi: 'by foot',
                    arrivo: 'arrival',
                    articolo: 'article',
                    dilloAlVettore: 'Yes, I would like to purchase this travel solution',
                    dilloAlVettorePre: 'This ticket cannot be purchased yet. Would you like to point that out?',
                    dilloAlVettoreStatement: 'This ticket cannot be purchased yet.',
                    durata: 'lenght',
                    fromStop: 'from stop',
                    header: 'Buy travel solution',
                    importo: 'amount',
                    infoAddizionali: 'Additional info',
                    nonDisponibile: 'Not available',
                    partenza: 'departure',
                    toStop: 'to stop',
                    tratta: 'route',
                },
                dialog: {
                    partenzaArrivoUguali:
                        'Departure and arrival location correspond. There are no travel solutions available',
                },
                fav: {
                    header: 'Save Solution',
                    info: 'Save this travel solution as Bookmark',
                },
                form: {
                    cercasoluzioni: 'Search Travel Solutions',
                    elimina: 'Cancel',
                    itinerariPreferiti: 'Favourite itineraries',
                    nessunPreferito: 'No favourites',
                    preferiti: 'Favourites',
                    recenti: 'Recent',
                    searchbutton: 'Search',
                },
                list: {
                    arrivi: 'arrivals',
                    arrivo: 'arrival',
                    loadMore: 'Load further solutions',
                    ordinaPerDataArrivoAsc: 'By arrival time',
                    ordinaPerDataDiPartenzaAsc: 'By departure time',
                    ordinaPerDataDiPartenzaDesc: 'Departure time ↓',
                    ordinaPerDurataTragittoAsc: 'By duration',
                    ordinaPerDurataTragittoDesc: 'Travel duration ↓',
                    ordinaPerNumCambiAsc: 'By number of changes',
                    ordinaPerPrezzoAsc: 'Lowest price',
                    ordinaPerPrezzoDesc: 'Highest price',
                    ordinaRisultati: 'Order travel solution',
                    partenza: 'departure',
                    partenze: 'departures',
                },
                nodata: {
                    empty: 'No travel solution found.',
                },
                nome: 'Solution Name',
                type: {
                    auto: 'Car',
                    autobus: 'Bus only',
                    busTreni: 'Buses and trains',
                    pedonale: 'Pedestrian',
                    treno: 'Train only',
                },
            },
            stopdetails: {
                nodata: {
                    empty: 'non sono previsti arrivi/partenze',
                },
                settings: 'Stop settings',
            },
            stops: {
                arrivi: 'Arrivals at the stop',
                fav: {
                    conferma: 'Stop saved as a Bookmark',
                    header: 'Save Stop',
                    info: 'Save this stop as a Bookmark" in order to retrieve it quickly next time"',
                    nomePreferito: 'Favourite Name',
                },
                partenze: 'Departures at the stop',
            },
            summerjamboree: {
                alloggi: 'Where to stay',
                festival: 'Festival',
                foodAndBeverages: 'Food & Beverages',
                locations: 'Locations',
                mappa: 'Map',
                mercatino: "Rockin' Village - Market",
                navette: 'Special trains - shuttles',
                programma: 'Events',
            },
            sunsen: {
                cercaAlloggio: 'Search accommodation',
                elencoTornei: 'Tournaments list',
                home: {
                    classifica: 'Results and palcements',
                    eventi: 'Events',
                    informazioni: 'Information',
                    iscrizioni: 'Registrations',
                    partners: 'Partners',
                    sosta: 'Parking',
                    trasporto: 'Transport',
                },
            },
            taxi: {
                common: {
                    aggiornatoAlle: 'Updated at',
                    descrAnnullata: 'Booking cancelled',
                    descrArrivato: 'Arrived',
                    descrConfermata: 'Booking confirmed',
                    descrDaConfermare: 'Waiting for the confirmation',
                    descrInArrivo: 'Arriving in {0} minutes',
                    descrPagato: 'Paid (€ {0})',
                    ultimoAggiornamento: 'Latest update',
                },
                dettaglio: {
                    annullaPrenotazione: 'Cancel the booking',
                    dataAssegnazione: 'Date of acceptance',
                    pagaTaxi: 'Pay the taxi',
                    promptHeader: 'Cancel',
                    promptKo: 'No',
                    promptMessage: 'Are you sure you want to cancel this booking?',
                    promptOk: 'Yes',
                    title: 'Booking details',
                },
                home: {
                    aggiornamentoInCorso: 'Updating…',
                    miePrenotazioni: 'My bookings',
                    paga: 'Pay',
                    prenota: 'Request',
                    title: 'Search Taxi',
                },
                mappa: {
                    disclaimerBtn: 'I agree',
                    disclaimerMsg: 'Make sure you are providing your exact position',
                    procedi: 'Go-ahead',
                    title: 'Search a Taxi',
                    warningZoomInsufficiente: 'Zoom in to find your position',
                },
                pagamento: {
                    importoViaggio: 'Cost of the journey ',
                    numeroLicenza: 'License number',
                    pagamentoEffettuato: 'The journey has been successfully paid',
                    promptNumeroLicenza: 'Ask the taxi driver his license number',
                    scansiona: 'Scan',
                    scegliComePagare: 'Choose how to pay',
                    title: 'Pay the taxi',
                    totale: 'Total',
                },
                prenotazione: {
                    conferma: 'Confirm',
                    promptHeader: 'Look for a taxi',
                    promptMessage: 'We are waiting for the operation centre confirmation',
                    promptNote:
                        'You will receive a confirmation email after that Taxi is assigned. In case of pre-recording request, this will happen a few minutes before the specified time.',
                    title: 'Taxi request',
                },
            },
            tessere: {
                EliminaFail: 'An error occurred while attempting to delete the card',
                EliminaSuccess: 'The card has been deleted',
                EliminaTesseraConf: 'Do you want to delete this card?',
                aggiungiTesseraTrasporto: 'Add card...',
                apriControllo: 'Open control',
                attivaTessera: 'Activate the card',
                card: 'Card',
                cerca: 'Search Card',
                cercaAttiva: 'Search Card and activate...',
                cercaPlaceHolder: 'Card Name or Contract',
                chiudiControllo: 'Close control',
                codice: 'Card code',
                dettagliTessera: 'Card Details and Contract',
                haiTessera: 'Have you got a card?',
                identificativoTessera: 'Card identification number',
                inAttesaValidazione: 'Waiting for confirmation',
                inserisciCodice: 'Enter the card code',
                inserisciIdentificativoTessera: 'Insert your card identification number to buy the travel ticket.',
                noResultTessere: 'No card available',
                noResultTessereTrasporto: 'No card available',
                nomeTesseraContratto: 'Card Name or Contract',
                nonAttiva: 'Card not activated yet',
                rimuovi: 'Remove Card',
                scegliVettoreTessera: 'Choose your transport company',
                siHoTesseraVettore: 'Yes, I have a card',
                tessera: 'Card: ',
                tesseraRegistrata: 'Card successfully registered',
                toBeCertified: 'This card requires a manual certification by the administrator',
                tutte: 'All cards',
                valida: 'Valid card',
                validita: 'Validity',
                verifica: 'Check',
            },
            tir: {
                login: {
                    appName: 'TRANSPark',
                    appNonDisponibile: 'The application is currently not available for Windows Phone',
                    areeStazioni: 'Parking areas and fuel stations',
                    cerca: 'Search transactions',
                    cercaParcheggi: 'Search parking areas',
                    codice: 'User code',
                    scarica: 'Download',
                    targa: 'Vehicle number plate',
                    testo1:
                        'European Pilot Project (<a href="javascript:openLinkOnBrowser(\'http://www.cogistics.eu\')">www.cogistics.eu</a>) in Trieste for the promotion of truck parking service.',
                    testo2:
                        'Here, in the section Parking- Transactions, truck drivers can check the parking sessions activated in the parking area of the Trieste freight terminal or find parking areas and fuel stations through the link to the Transpark app of IRU.',
                    testo3: 'For truck drivers pareked in Trieste freight terminal only',
                    title: 'Truck Parking',
                    titoloApp: 'TransPark App',
                    titoloMovimenti: 'Show transactions list',
                },
                movimenti: {
                    nessuno: 'There are no transactions.',
                    title: 'Transactions',
                },
            },
            tours: {
                allCategories: 'All the categories',
                arrivi: 'Arrivals',
                cercaPrenota: 'look for a tour and book it',
                definisciRaggio: 'define a distance range around',
                dettaglio: 'Tour detail',
                elenco: 'list',
                inPartenzaEntro: 'Tour departing within',
                info: 'Information',
                itinerario: 'Itinerary',
                mappa: 'map',
                nomeTour: 'Tour name',
                partenze: 'Departures',
                raggioRicerca: 'distance range',
                vetrina: 'showcase',
                viaggioOrg: 'organized tours',
                warnTariffe: 'The price you see is referred to the basic fare, check it in the price list',
            },
            tplfvg: {
                AcquistaBiglietti: 'Buy tickets',
                CalcolaPercorso: 'Plan route',
                Eventi: 'Events',
                FermateOrari: 'Stops and schedules',
                Luoghi: 'Places',
                MieiTitoli: 'My tickets',
                ServiziTuristici: 'Tourist services',
                accediRegistrati: 'Login / Register',
                loginMessage: 'To use this app is necessary to access as a registered user <b>TPLFVG</b>.',
                newsEventi: 'News and events',
                rivendite: 'Ticket office',
            },
            trasportoGT: {
                accedi: {
                    header: 'Enter to Long-haul lines',
                },
                elencoMovimenti: {
                    header: 'Transaction Report',
                },
                header: 'Long-distance buses',
                mieiAbbonamenti: {
                    goToMyAbbonamenti: 'Go to My Subscriptions""',
                    header: 'My Subscriptions',
                    infoTitoliAcquistati:
                        'You will find the ticket in the "My Subscriptions" section of "Interregional Transport"',
                },
                mieiBiglietti: {
                    aggiornaElenco: 'Update List...',
                    elencoBigliettiDaObliterare: 'List of Purchased Tickets to be validated',
                    elencoBigliettiScaduti: 'List of Expired Tickets',
                    elencoBigliettiUsati: 'List of Used Tickets',
                    elencoBigliettiValidi: 'List of Valid Tickets',
                    goToMyTickets: 'Go to "My Tickets"',
                    header: 'My Tickets',
                    infoTitoliAcquistati:
                        'You will find the ticket in the "My Tickets" section of "Interregional Transport"',
                    nessunBigliettoTrovato: 'No ticket found',
                    obliterati: 'Validated tickets',
                    ore: 'time',
                    partenza: 'Departure',
                    scadenzaTime: 'valid until',
                    validoFinoAl: 'Valid until',
                },
                soluzioniViaggio: {
                    andata: 'Going',
                    arrivoA: 'Arrival',
                    avvisoDataDifferente:
                        'There are no travel solutions available for selected dates. Here follow the first solutions available.',
                    cercaFraLocalitaElencate: 'Filter by name',
                    cercaSoluzioni: 'Search Travel Solutions',
                    descrizioneViaggio: 'Route description',
                    dettaglio: 'Travel Solution Detail',
                    dettaglioAndata: 'Outward details',
                    dettaglioRitorno: 'Return details',
                    header: 'Travel Solutions',
                    infoCoperturaHTML:
                        '<b>The service</b> is reaching more areas. Check the cities reached by the interregional transport service...',
                    infoPasseggero: 'Passenger information',
                    localitaDestinazione: 'Place of arrival',
                    localitaPartenza: 'Place of departure',
                    maxUnCambio: 'max. 1 transfer',
                    mostraSoluzioni: 'Show Travel Solutions',
                    mostraTutteLeDestinazioni: 'Showing all available destinations from the chosen place of departure',
                    nessunCambio: 'No transfers',
                    nomeObbligatorio: 'Name required',
                    partenzaDa: 'Departure from',
                    riassuntoInfoAcquisto: 'Recap purchase information',
                    ritorno: 'Return',
                    scegliDataRitorno: 'Choose your return date',
                    scegliRitorno: 'Choose your return ',
                    scegliTariffa: 'Choose a rate',
                    selezionaDest: 'Choose a destination',
                    soluzioneSenzaPosti: 'The chosen solution is sold out/fully booked',
                    tariffa: 'Rate',
                    tratta: 'Route',
                    tutteLeSoluzioni: 'All solutions',
                    viaggioRitorno: 'Return ',
                    zoneCoperte: 'Zones covered by the service',
                },
            },
            trasportoRegionale: {
                acquistaBiglietti: 'Buy Tickets',
                acquistaSMS: {
                    acquistaAltroBiglietto: 'Purchase another ticket',
                    confermaAcquistoTitolo: 'The ticket has been purchased successfully',
                    elencoTitoliAcquistabili: 'List of tickets you can buy',
                    erroreAcquisto: 'An error occurred. Do you want to try again with the purchase?',
                    header: 'Purchase Tickets by SMS',
                    infoObliterazioneAuto: 'this ticket has been automatically validated',
                    infoObliterazioneBiglietti: 'every ticket must be validated before boarding the bus',
                    invioManualeSmsInfo:
                        'It is impossible to send the message. Please, send an sms to the number {0} with text {1}',
                    invioManualeSmsTitle: 'manual SMS sending ',
                    noArticoliVendibili: 'No purchasable article found',
                    riassuntoInfoBiglietto: 'Recap ticket information',
                    richiestaInoltrataInfo:
                        'Dear user, if your request has been succesfully completed you will receive soon the ticket bought by sms',
                    richiestaInoltrataTitle: 'Request forwarded',
                },
                acquistaScaffale: {
                    elencoTitoliAcquistabili: 'List of tickets you can buy',
                    elencoTitoliAcquistabiliActv: 'ACTV tickets that you can buy ',
                    elencoTitoliAcquistabiliMomup: 'List of tickets you can buy',
                    gotoTitoliGT: 'Buy tickets with a reservation',
                    gotoTitoliSMS: 'Buy by an SMS',
                    header: 'Buy Tickets',
                    headerActv: 'Buy tickets ACTV',
                    infoAcquistoSms:
                        "This ticket will be purchased through <span class='bold'> the phone credit </span> associated to the phone number that you are using.<br/> <br/>Tickets bought by SMS cannot have lower or different prices compared to those valid for complete routes from last stop to last stop. Therefore, no refunds are foreseen for shorter distance journeys.</br> </br>No tickets are refundable</br> </br>After the request sending, you are going to receive a confirmation SMS to be used as a ticket",
                    infoCoperturaATAC:
                        'Tickets can be used on all Metrebus surface transit: Atac busses, trams and trolleybusses, TPL and COTRAL means of transport in Rome.<br />In the underground it is possible to use the service on lines A, B, B1, railway Roma-Lido and at Flaminio station of railway Roma-Viterbo.<br /><br />The service will be shortly available on the entire route Roma-Viterbo and on line C.<br />',
                    infoCostiSms:
                        'In addition to the ticket price, it will be charged the SMS cost, that varies depending on your telephone company.',
                    infoObliterazioneAuto: 'this ticket has been automatically validated',
                    infoObliterazioneBiglietti: 'every ticket must be validated before boarding the bus',
                    infoObliterazioneContestuale: 'Activation is concurrent to the purchase.',
                    infoTrenitaliaATAC:
                        'As last Atac Spa directive, electronic tickets (Bit 100 and AIMOP) are not valid on Trenitalia means for the moment. For further information, please contac us per email assistenza@mycicero.it or at the phone number 0719207000.',
                    noArticoliVendibili: 'No purchasable articles found',
                    origineDestinazione: 'Buy a ticket from the travel solutions offered',
                    polimetrica: 'Extra-urban season tickets',
                    polimetrica2: 'Extra-urban season tickets',
                    riassuntoInfoBiglietto: 'Recap ticket information',
                    rinnovaAbbonamenti: 'Renew seasonal ticket',
                    scegliTitoliTessera: 'See card-bought tickets',
                    scegliTitoliTesseraActv: 'Tickets for Venezia Unica card holder',
                    smsDiAcquisto: 'Pone number: {0} <br/> Message: {1}',
                    titoliGT: 'Tickets with reservation',
                    titoliTessera: 'Tickets with season cards or discounts',
                    titoloSelezioneTessera: 'Buy tickets on card',
                },
                acquistoTitoli: {
                    acquistaGratis: 'Download for free',
                    scegliComePagare: 'Choose how to pay',
                    scegliComePagareFmt: 'Choose how to pay {0}',
                    scegliTipologia: 'Choose a typology',
                    tipiDiAttivazione: {
                        automatica: 'The ticket turns active after the purchase.',
                        multipla:
                            'The ticket shall be manually activated at the first use. You should also validate your ticket every time you board on a means of transport.',
                        normale: 'The ticket shall be manually activated at the first use.',
                        obbligatoria: 'The ticket shall be manually activated at the first use.',
                    },
                    tipoDiAttivazione: 'Activation type:',
                },
                alCompleto: 'Sold out',
                anticipo: 'Early arrival',
                arrivi: 'Arrivals',
                avvisoSD:
                    "Dear User, due to problems associated with the possible disappearance of E-Tickets (in case the app is installed on the SD card), starting from the next versions, the app will be automatically installed on your phone's internal storage; to avoid further problems, we kindly ask you to move the app from the sd card to the telephone inner storage. Sorry for any inconvenience. For further information,  please write at Assistenza@mycicero.it or phone at 071 920 7000",
                avvisoSDAVM:
                    "Dear User, due to problems associated with the possible disappearance of E-Tickets (in case the app is installed on the SD card), starting from the next versions, the app will be automatically installed on your phone's internal storage; to avoid further problems, we kindly ask you to move the app from the sd card to the telephone inner storage. Sorry for any inconvenience. For further information,  please write at app.support@avmspa.it",
                cercaFermate: {
                    cercoPassaggi: 'Search stop times...',
                    codDescriz: 'Code / Description',
                    comune: 'Select a city',
                    elencoFermate: 'Stop list',
                    elencoFermateTuaPosizione: 'Stops near your position',
                    header: 'Bus Stop Schedule',
                    headerActv: 'Search schedule and routes',
                    indirizzo: 'Address',
                    indirizzoFermata: 'Address/Stop',
                    inserisciIndirizzo: 'Type address',
                    intornoA: 'Show stops near:',
                    lineeServite: 'Served lines',
                    mostra: 'Show stops',
                    mostraFermate: 'Show bus stops ...',
                    msgNoFermatePreferite:
                        '<p>You haven\'t bookmarked any stop as favourites yet.</p><p>To bookmark this search push the Save" button in the details of every stop.</p>"',
                    nessunaFermata: 'No stop found',
                    nessunaLocalita: 'No location/address found',
                    noFermateVicine: 'There no stops near your current position',
                    noLineeServite: 'No lines are served',
                    noPassaggi: 'Thre are no rides',
                    oppure: 'Or...',
                    passaggiNonPrevisti: 'No arrivals/departures are expected for this date',
                    ricerca: 'Search stops',
                    ricercheRecenti: 'Recent searches',
                    stazioneIndirizzo: 'Station or address',
                    tramiteCodDescr: 'By code or description',
                    tuttiPassaggi: 'All rides to this bus stop',
                },
                cercaLinee: {
                    comune: 'Select a city',
                    header: 'Search lines',
                    indirizzo: 'Address...',
                    intornoA: 'Lines passing near',
                    mostra: 'Show lines',
                    nessunaLineaTrovata: 'No lines found',
                    oppure: 'Or...',
                    ricerchePreferite: 'Bookmarks',
                    ricercheRecenti: 'Recent',
                    tramiteCodDescr: 'By code or description',
                },
                cercaLocalita: 'Search city',
                cercaVettore: 'Search carrier',
                comuneAziendaEvento: 'City / Company / Event',
                daConvalidare: 'To be activated',
                daObliterare: 'Validation required',
                daValidare: 'To be activated',
                dettaglioCorsa: 'Route Details',
                dettaglioLinea: {
                    dettaglioLinea: 'Line detail',
                    dimentica: 'Forget',
                    disponibilitaFermate: 'Stops:',
                    nessunaCoincidenza: 'No connection available',
                    nessunaFermata: 'No stop found',
                    ricorda: 'Remember',
                },
                elencoFermate: 'List of Stops',
                elencoFermateA: 'Stops list at:',
                elencoLinee: {
                    descrizione: 'Description',
                    direzione: 'Direction',
                    elencoLinee: 'List of lines in the nearby',
                    elencoPercorsi: 'Line itinerary',
                    haiCercato: 'You searched:',
                    noPercorsi: 'There are non routes',
                    noSoluzioniVisibili: 'No line',
                    nonDisponibile: 'Non available',
                    passaggio: 'Passage expected',
                    passaggioAlle: 'Rides at',
                    passaggioOgni: 'Rides every',
                },
                elencoMovimenti: {
                    header: 'Transaction Report',
                },
                fermata: 'Stop',
                fermate: 'Stops',
                header: 'Regional Transport',
                linee: 'Line list',
                mieiAbbonamenti: {
                    abbonamentiNonTrovati: 'No valid Subscription found on this device.',
                    acquistaRinnova: 'Purchase/Renew',
                    articoliDisponibili: 'Available articles',
                    elencoAbbonamenti: 'List of Subscriptions',
                    elencoTessereAttive: 'Valid Cards',
                    extraUrbano: 'Extra-urban',
                    goToMyAbbonamenti: 'Go to "Subscriptions"',
                    header: 'Subscriptions',
                    infoAbbonamentiNonTrovati:
                        'No valid Subscription found on this device. Try to refresh the list by clicking the above button',
                    infoRequisitiAcquistoHTML:
                        'In order to purchase Subscriptions it is necessary to link a card to the chosen operator. You can add a Subscription Card to your account with a few click, by entering your private account on <a href=#" style="text-decoration: none;">www.mycicero.it</a> with a traditional PC."',
                    infoTitoliAcquistati:
                        'You will find the ticket in the "Subscriptions" section of "Regional Transport""',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Once you have completed the purchasing process, it is possible to download the ticket by entering the page "Subscriptions" and updating the list',
                    nessunaTesseraValida:
                        "You don't have any subscription linked to your Card. Renewal unavailable. Get in touch with the chosen operator to purchase a new subscription",
                    rinnovaAbbonamento: 'Renew Subscription',
                    scegliTessera: 'Choose Subscription Card',
                    scegliVettoreAbbonamento: 'Choose the operator you want to buy/renew a subscription from',
                    selezionaArticolo: 'Select an article',
                    soluzioniPossibili: 'Solutions found',
                    templateTratta: 'From {0} to {1}',
                    ultimaObliterazione: 'Last validation',
                    urbano: 'Urban',
                    validitaLinee: 'Valid for lines',
                },
                mieiBiglietti: {
                    acquista: 'Purchase Ticket',
                    attivi: 'Active',
                    daobliterare: 'To be activated',
                    elencoBigliettiDaObliterare: 'List of Purchased Tickets to be validated',
                    elencoBigliettiUsati: 'List of Used Tickets',
                    elencoBigliettiValidi: 'List of Valid Tickets',
                    finoAl: 'Until',
                    goToMyTickets: 'Go to "My Tickets"',
                    header: 'My Tickets',
                    infoTitoliAcquistati: 'You will find the ticket in the "My Tickets" section',
                    noTitoliAttivi: 'No valid tickets found',
                    noTitoliDaObliterare: 'No tickets to validate found',
                    noTitoliScaduti: 'No validated tickets found',
                    obliterati: 'Validated tickets',
                    scadenzaTime: 'valid until',
                    scaduti: 'Expired',
                    validita: 'Validity',
                    validoDal: 'Valid from',
                    validoFinoAl: 'Valid until',
                },
                mostraAltreFermate: 'Show other stops',
                mostraAltreLinee: 'Show other lines',
                mostraAltreStazioni: 'Show other stations',
                mostraAltriPassaggi: 'Show other stops',
                obliterazioneAutomatica: 'Automatic validation',
                partenze: 'Departures',
                passaggi: 'Passages',
                percorsi: 'Routes',
                prossimoTra: 'Next:',
                pulisci: 'Clean',
                ricaricaCredito: {
                    header: 'Top up Credit',
                    ricaricaActvWarning:
                        'The potential remaining credit as a result of not used recharges or purchases is in no case reimbursable.',
                },
                ritardo: 'Delay',
                scaduti: 'Expired',
                scegliVettore: 'Search by city, company or event:',
                scegliVettorePlaceholder: 'Company/Event',
                seiVicino: 'you are around this area',
                servizioNonAttivo: 'You haven\'t activated "Public Transport" yet. Just one minute.',
                soluzioniViaggio: {
                    cercaCollegamentiLocali: 'Search local connections',
                    cercaSoluzioni: 'Serch Travel Solutions',
                    elencoSoluzioni: 'List of Travel Solutions',
                    frequenzaOgni: 'Each',
                    header: 'Travel Solutions',
                    headerAndata: 'Outward solutions',
                    headerRitorno: 'Return solutions',
                    invertiDirezione: 'Swap direction',
                    mostra: 'Show:',
                    mostraSuMappa: 'Show on map',
                    nessunCollegamentoLocale: 'No local connection',
                    nessunaDestinazione: 'No destination found for these search criteria ',
                    nessunaSoluzione: 'No Travel Solution found',
                    noSoluzioniVisibili: 'No solution shown',
                    nonAcquistabile: 'Travel Solution not purchasable',
                    nonTuttiBigliettiAcquistabili: 'Not all tickets are purchasable',
                    ordinaPerOrarioArrivo: 'Sort by arrival time',
                    ordinaPerOrarioPartenza: 'Sort by departure time',
                    ordinaPerSoluzioniAcquistabili: 'Sort by purchasable solutions',
                    ordinaPerTempoTotale: 'Sort by travel time',
                    salvaRicercaPreferitaInfo:
                        'To bookmark this search push the Save" button among the results for the Travel Solutions search."',
                    scambia: 'Reverse',
                    tempoTotale: 'Total time',
                    tuttiBigliettiAcquistabili: 'All tickets are purchasable',
                },
                tipoServizio: 'Type of Service',
                trenitalia: {
                    altreInfo: 'Further information',
                    cartaFreccia: 'CartaFRECCIA',
                    condizioni:
                        'The electronic Regional ticket is issued as already validated. It is not possible to move up the departure or replace your ticket and refund it. The ticket is personal and associated to name and surname inserted during the online registration or in traveler data; the ticket online purchased for travels on regional trains must be displayed – on request of controllers - in the paper form (before leaving, print the PDF attached to the purchase mail) or by the screen using information technology (pc, tablet, smartphone) able to correctly visualize .pdf files, together with a valid identity document. ',
                    condizioniAcquistoTrenitalia:
                        'I agree to the <a href="#" onclick="javascript: openLinkOnBrowser(\'http://www.trenitalia.com/tcom/Informazioni/Condizioni-Generali-di-trasporto/Condizioni-Generali-di-trasporto\',true)">terms of transport</a> of the carrier and I have read the<a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/cms-file/html/trenitalia/Informativa_sulla_privacy.html\',true)">privacy information statement</a>.',
                    infoTariffa: 'Tariff info',
                    menu: 'Trenitalia',
                    modificaBigliettoHeader: 'Ticket Modification',
                    modificaBigliettoMessage:
                        "<div class='textAlignLeft'><p>In order to:<br /><ul><li>change your booking (departure date/time)</li><li>change your ticket (arrival or departure city; ticket typology; number of passengers etc.)</li><li>ask a ticket refound, in case the journey is cancelled</li></ul></p><p class='bold'>Go to the nearest train show this ticket.</p></div>",
                    percorsoFerroviario: 'Route',
                    popupDiniego: {
                        cancelLabel: "I don't want giving my contact data ",
                        confirmLabel: 'Insert contact data',
                        content:
                            'You have not stated contact data for all passengers. Trenitalia will not be able to contact them for this travel',
                        title: 'Attention please',
                    },
                    riepilogo: 'Recap',
                    stazioneArrivo: 'Arrival station',
                    stazioneNonValida: 'Not valid station',
                    stazionePartenza: 'Departure station',
                    tariffe: 'Fares',
                    viaggioAndata: 'Outward travel',
                    viaggioRitorno: 'Return travel',
                    vuoiModificareIlBiglietto: 'Do you want to change your ticket?',
                },
                tutteLeLocalita: 'All the cities',
                vaiAlleImpostazioni: 'Go to settings',
                validazioneAutomatica: 'Ticket automatically validated',
                zoneServite: {
                    header: 'Areas Covered by the service',
                },
            },
            travels: {
                details: {
                    header: 'details',
                },
            },
            treasureHunt: {
                abbandonaSquadra: 'Are you sure you want to leave the team?',
                aggiornaProcedi: 'Update and proceed',
                aggiungiGiocatore: 'Add player',
                cacciaAlTesoro: 'Treasure Hunt',
                checkVideoCaricato: 'Are you sure you have uploaded the video and want to continue?',
                codiceSquadra: 'Team Code',
                comeFunziona: 'How does it work?',
                compilaCampi: 'Fill in the fields',
                compitoCompletato: 'Completed task',
                completaPagamenti: 'Complete payments',
                countDownInizioGiocoAfter: 'The game has begun from {0}',
                countDownInizioGiocoBefore: 'At game beginning {0} are needed',
                countDownInizioGiocoSame: 'Here we are…',
                createTeam: 'I want to create a new team',
                erroreAggiungiGiocatore: 'The person can not be added to their team.',
                erroreCaricamentoGiochi: 'An error occurred during games loading. Please, try later.',
                erroreCaricamentoGioco: 'An error occurred during game loading. Please, try later.',
                erroreCheckLocation: 'Sorry. <br /> There was an error.',
                erroreInfoTeam: 'Team info could not be retrieved',
                erroreRimozioneGiocatoreQuotaPagata:
                    'The player can not be removed because he has already paid the registration fee.',
                erroreRimozioneGiocatoreQuotaSquadraPagata:
                    'The player could not be removed because he paid the team registration fee.',
                faseRisoltaDalTeam: 'Your group has already solved this phase.',
                garaFinita: 'The game is over.',
                giocaNoSmartphone:
                    'In this mode the player will participate in the game but can not use his smartphone',
                giocatori: 'players',
                gpsGenericError:
                    'Sorry. <br /> You have not provided permission to recover your GPS location. Sorry. <br /> There was an error.',
                gpsPermissionDenied: 'Sorry. <br /> You have not provided permission to recover your GPS location.',
                gpsPositionUnavailable: 'Sorry. <br /> The GPS position could not be recovered.',
                gpsTimeout:
                    'Sorry. <br/> There was an error with GPS. <br /> Check the status of the GPS antenna and permissions and restart the app.',
                graziePerLaRisposta: 'Thank you for the answer!',
                indizio: 'Clue',
                infoIscrizione:
                    'The enrollment of each player is valid only after payment. The team will be allowed to play only after that all amounts have been payed. ',
                invitaGiocatore:
                    'Send an invitation to a new player. You will receive a code through which you can directly access the group {0}.',
                invitaGiocatoreNoEmail: 'Does the player have no email or social contact? Add it directly to {0}.',
                iscrizioneSquadra: 'Team enrollment',
                iscrizioniChiuse: "We're sorry, but you can not sign up for this game.",
                itinerariSorpresa: 'Surprise tours',
                itinerarioSorpresa: 'Surprise tour',
                joinTeam: 'I have been invited and I have a code',
                luogo: 'Place',
                luogoGiusto: "Congratulations! <br /> It's the right place.",
                luogoSbagliato: 'Sorry. <br /> This is not the right place.',
                nessunGioco:
                    'You can find soon funny games to discover the beauties of Lecce!<br />Treasure hunts, quiz and unexpected itineraries will lead you into the most typical places, through history, art, food and wine of one of the most beautiful Italian cities.',
                nomeSquadra: 'Team name',
                nomeSquadraErrore: 'Maximum of 20 characters',
                pagaQuotaGiocatore: "Are you sure you want to pay for the player '{0}'",
                pagaQuotaSquadra: 'Are you sure you want to pay the registration fee for the team?',
                pagamentiNonCompletati: 'You have not completed payments yet',
                prossimoIndizioConPenalita: 'Next clue (but you lose {0} points)',
                quizzone: 'Quizzes',
                quotaGiocatoreNonPagata: 'One of the team members did not pay the fee. Remove it or pay its fee',
                quotaSquadraNonPagata: 'Remove it or pay its fee',
                raggiungiLuogo: 'Reach the place',
                rimuoviGiocatore: 'Are you sure you want to remove {0}?',
                rispostaEsatta: 'Correct answer',
                rispostaSbgliata: 'Wrong answer',
                scegliNomeSquadra: 'Choose a nice and easy name to remember.',
                shareEvent: 'Share the event with your friends',
                svelamiLuogo: 'Yes, reveal the place to me',
                svelamiLuogoConPenalita: 'Unveil the place (but I lose {0} points)',
                tornaAlGioco: 'Return to the game',
                tornaAllInizio: 'No, go back to the beginning',
                traguardo: 'Finish line',
                verificaLuogo: "Check to see if I've come to the right place",
                whoo: 'Whoo-hoo!',
            },
            tua: {
                AcquistaBiglietti: 'Buy<br/>tickets',
                AcquistaBigliettiHTML: 'Buy<br/>tickets',
                CalcolaPercorsoHTML: 'Calculate<br/>route',
                FermateOrariHTML: 'Stops<br/>and schedules',
                MieiTitoli: 'My<br/>tickets',
                MieiTitoliHTML: 'My<br/>tickets',
                SostaInAbruzzoHTML: 'Park in<br/>Abruzzo',
                UltimeNotizieHTML: 'Last<br/>news',
                bigliettiTariffaFissa: 'Fixed fare tickets',
                soluzioneNonAcquistabile:
                    'Unfortunately this ticket cannot be purchased now.<br/>Do you want to know when it will be possible?<br/><br/>Please contact us to the phone number <a href="tel:800762622">800762622</a> or send a mail to <a href="mailto:infotrasporto@mycicero.it">infotrasporto@mycicero.it</a>',
            },
            turismo: {
                buoniDisponibili: 'Available vouchers',
                buoniEsauriti: 'Finished vouchers',
                buoniUtilizzati: 'Used vouchers',
                caricaAltri: 'Show next 10',
                caricamentoInCorso: 'Loading',
                cerca: 'Search',
                cercaCoupon: 'Search Coupon',
                cercaCouponPlaceholder: 'Search a coupon',
                cercaEventi: 'Search Events',
                cercaEventiPlaceholder: 'Search an event',
                cercaIndirizzoPlaceholder: 'Address or location',
                cercaItinerariPlaceholder: 'Search one route',
                cercaItinerario: 'Search routes',
                cercaPoi: 'Search POI',
                cercaPoiPlaceholder: 'Search a place',
                cercaProdotti: 'Search products',
                cercaProdottiPlaceholder: 'Search a product',
                cercaServiziPlaceholder: 'Search a service',
                cercaServizio: 'Search services',
                concluso: 'Passed',
                condizioni: 'Conditions',
                costoDelBuono: 'Voucher cost:',
                costoInCrediti: 'Cost in credits:',
                couponCorrelati: 'Here you find also',
                couponGratuito:
                    'This voucher is free and you can have it without consuming credits: just click on "Obtain vouchers" to activate it.',
                creditiConvertiti: 'Converted credits:',
                creditiPerCouponsPresso: 'You still have {0} credits that can be changed in vouchers to spend in {1}',
                creditiPerCouponsTerminatiPresso: 'You have no enough credits to obtain vouchers at {0}',
                creditiResiduiTotali: 'Total remaining credits',
                creditiRimanenti: 'Remaining credits:',
                creditiTotali: 'Total credits:',
                creditoPerCouponsPresso: 'You still have {0} credits that can be changed in vouchers to spend in {1}',
                dataAlle: '{0} at {1}',
                dataCreazione: 'Date of creation:',
                dataDalleAlle: '{0} since {1} to {2}',
                dataInizioDalleDataFineAlle: 'Since {0} at {1} to {2} at {3}',
                dataInizioDataFine: 'Since {0} to {1}',
                dataOra: 'Date and time',
                detail: {
                    cellulare: 'Mobile phone number',
                    certificazioni: 'Certifications',
                    citta: 'City',
                    contatto: 'Contact',
                    costs: 'Entry',
                    couponCorrelati: 'Special offers',
                    email: 'E-mail',
                    eventiCorrelati: 'Related events',
                    facebook: 'Facebook',
                    fax: 'Fax',
                    gestione: 'Management',
                    giorno: 'Day {0}',
                    header: 'Contact us',
                    indirizzo: 'Address',
                    itinerariCorrelati: 'Related itineraries',
                    luoghiCorrelati: 'Related places',
                    navetteCorrelate: 'Shuttles to bring you here',
                    note: 'Note',
                    ospiti: 'Important guests',
                    promo: 'Promo',
                    propostoDa: 'Proposed by',
                    quando: 'When',
                    scaricaAllegati: 'Download attached documents',
                    serviziInclusi: 'Included services',
                    serviziUtili: 'Useful services',
                    sitoWeb: 'Web',
                    sitoWebOrganizzatore: 'Organizing web site',
                    social: 'Social',
                    specialitaCorrelate: 'Related products',
                    tappa: 'Leg {0}:',
                    tel: 'Tel',
                    telefono: 'Phone',
                    temi: 'Topics',
                    troviAnche: 'Related promos',
                    url: 'web',
                    vaiAlSito: 'Go to the website',
                    zoneProduzione: 'Production areas',
                },
                details: 'Details',
                dettagli: 'Details',
                diarioDiViaggio: 'Diary',
                downloads: 'Downloads',
                error: {
                    cantFilterAroundYou: 'Impossible to set the filter "Around you" if GPS position is not available.',
                    cantOrderByDistance:
                        'Impossible to set the system "Per distance" if GPS position is not available.',
                },
                erroreGenerazioneQrCode: 'An error occurred during QR Code issuing',
                esperienze: 'Experiences',
                estendiRaggioRicerca: 'Extend research range',
                eventi: 'Events',
                favorites: {
                    errorAddFavorites:
                        'An error occurred during favourite saving. Please, make sure to be connected to the internet and try again.',
                    errorDeleteFavorites:
                        'An error occurred during favourite cancellation. Please, make sure to be connected to the internet and try again.',
                    errorGetFavorites: 'An error occurred during favourites loading.',
                    errorUpdateFavorites:
                        'An error occurred during favourite change. Please, make sure to be connected to the internet and try again.',
                },
                filters: {
                    afternoon: 'Afternoon',
                    allDay: 'All day long',
                    aroundYou: 'Near you ',
                    cosa: 'What',
                    dataSpecifica: 'Choose a specific date',
                    everywhere: 'Wherever',
                    fasciaOraria: 'Time slot',
                    morning: 'Morning',
                    night: 'Evening',
                    oggi: 'Today',
                    perData: 'By date',
                    perDistanza: 'By distance',
                    perRilevanza: 'By importance',
                    perScadenza: 'By expiry date',
                    perSconto: 'By discount',
                    periodoSpecifico: 'Choose a specific period',
                    prossimi30Giorni: 'In the next 30 days',
                    prossimi7Giorni: 'In the next 7 days',
                    quando: 'When',
                },
                filtra: 'Filter',
                filtraEventi: 'Filter events',
                filtraItinerari: 'Filter routes',
                filtraLuoghi: 'Filter palces',
                filtraOrdina: 'Filter and organize',
                filtraProdotti: 'Filter products',
                filtraPromo: 'Filter promos',
                filtraServizi: 'Filter services',
                inserisciNota: 'Write a note...',
                itinerari: 'Itineraries',
                leggiCondizioni: 'Read conditions',
                luoghi: 'Places',
                mostraQrCodeAllaCassa: 'Show the QR to the cashier to use the voucher',
                neiParaggi: 'Nearby',
                nessunPreferitoSalvato: 'This section is empty for the moment.',
                noAvailableCoupons: 'You will find here the vouchers to use',
                noCreditsReport: 'Here you will find a summary of your credits',
                noResults: 'No results found',
                noUsedCoupons: 'You will find here the summary of used vouchers',
                note: 'Notes',
                numCrediti: '{0} credits',
                numOfRemainingCoupons: '{0} remaining</br>vouchers',
                offerteSpeciali: 'Special offers',
                oneRemainingCoupon: '1 remaining</br>voucher',
                ora: 'Time',
                ordina: 'Organize',
                ordinaEventi: 'Organize events',
                ordinaItinerari: 'Organize routes',
                ordinaLuoghi: 'Organize places',
                ordinaPromo: 'Organize promos',
                ordinaServizi: 'Organize services',
                ottieniBuoni: 'Obtain vouchers',
                pisteCiclabili: 'Bike lanes',
                preferiti: 'Favorites',
                preferitiDiarioViaggio: 'Favorites and travel diary',
                presso: 'In: {0}',
                prodotti: 'Products',
                prodottiTipici: 'Products',
                promo: 'Promo',
                quantiBuoniVuoi: 'How many vouchers do you want?',
                ricercaIncorso: 'Searching',
                rimuoviDataOra: 'Delete date and time',
                rimuoviOrario: 'Remove timetable',
                risultatiEntro: 'You searched by {0}',
                saldoRimanente: 'Remaining balance:',
                scansionaQrCode: 'Scan the QR Code',
                scansionaQrCodeAllaCassa: 'Scan the QR Code in the cashier',
                scaricaAllegati: 'Download the documents attached',
                scegliData: 'Pick a date',
                sconto: 'Sale',
                servizi: 'Services',
                serviziUtili: 'Useful services',
                shopping: 'Shopping',
                toccaPerIngrandire: 'Touch to expand',
                trasformaCreditoInBuoni: 'Change your credits into vouchers',
                trasformaTotCreditoInBuoni:
                    "You are going to use  <span class='secondary bold'>{0}</span> to obtain a <span class='secondary bold'>{1}€</span> discount voucher to spend in this sponsor.",
                tuoiCreditiBuoni: 'Your credits and vouchers',
                unCredito: '1 credit',
                utilizzaTuoiCrediti: 'Use your credits',
                utilizzatoIl: 'Used at:',
                validoFinoA: 'Valid until',
                valoreBuono: 'Voucher value:',
                valoreBuonoPressoSponsor: 'This sponsor makes available {0}€ vouchers. ',
                valoreCumulativoBuono: 'Cumulative voucher value:',
                valoreInEuro: 'Euro value:',
                withinRange: 'Until {0}',
            },
            unicoc: {
                acquistaTicket: 'Buy ticket',
                calcolaPercorso: 'Calculate route',
                mieiTitoli: 'My tickets',
                puntiVendita: 'Stores',
                trovaTariffa: 'Find the tarif',
            },
            ventis: {
                cambiaZona: 'Change area',
                effettuaLogin: 'Login',
                homeTitle: 'Ventis welcomes you to {0}',
                hometitleNoPos: 'Ventis welcomes you',
                infoCredito:
                    'Top up myCicero credit by credit card, through Satispay, MasterPass or in a SisalPay shop. <b>This payment option has NO extra costs.</b> myCicero Credit can also be used to buy tickets and to pay for all the other available services.',
                loginMessage: 'To use this app is necessary to access as <b>Ventis</b> registered user .',
                registrati: 'Register',
                requisitiAccesso: '',
                serviziTuttaItalia: 'Our services are active all around Italy',
                tutorial: {
                    subtitle1: 'Discover benefits for Ventis customers',
                    subtitle2: 'Pay only real parking minutes by Ventis Mobility',
                    subtitle3: 'Comfortably by a click on app Ventis Mobility',
                    subtitle4: 'You will find up to 70% discounts on major brands',
                    subtitle5: 'Convenience and benefits tailor-made for you',
                    subtitle6: '',
                    title1: 'Welcome in Ventis Mobility',
                    title2: 'Spare money on parking',
                    title3: 'Buy train, bus and subway tickets',
                    title4: 'Ventis.it the unmissable website',
                    title5: 'Everything in one app',
                    title6: '',
                },
            },
            visitRomagna: {
                dormi: 'Sleep',
                erroreCaricamentoDati: 'An error occurred during data loading.',
                fermati: 'Stop',
                mostraTuttiEventi: 'Show all the events',
                muoviti: 'Move',
            },
        },
    },
    de: {
        translation: {
            account: {
                accedi: 'Login',
                accountNonAttivo: 'Account nicht bestätigt',
                benvenuto: 'Willkommen!',
                cambiaPassword: 'Passwort ändern',
                cambioEmailInserisciPinPage: {
                    annullaModifiche: 'Abänderung annullieren',
                    errorePin: 'Error: der eingegebene Pin-Code ist nicht korrekt',
                    inserisciPin: 'Pin Kode',
                    istruzioniInserisciPIN: 'den Kode in der gesendete Mail einfügen ',
                    operazioneAvvenutaInfo: 'Operation erfolgreich abgeschlossen',
                    operazioneAvvenutaTitle: 'Ihre Email-Adresse wurde erfolgreich geändert',
                },
                cambioEmailPage: {
                    cambiaEmail: 'Mail ändern',
                    emailAttuale: 'Aktuelle Email',
                    eseguiCambioEmail: 'Fortfahren',
                    inserisciNuovaEmail: 'Eine neue Mail aus',
                    istruzioniPIN:
                        'Sie werden eine Überprüfungsmail, mit einen Pin bekommen. Fügen Sie den Pin Kode in der folgende Seite',
                    validazioneEmailInCorso: 'Überprüfen',
                },
                cambioPasswordPage: {
                    erroreCambioPassword:
                        'Beim Passwortwechsel ist ein Fehler aufgetreten. Bitte wenden Sie sich an die Servicezentrale.',
                    info:
                        'Das Passwort muss aus <span class="{0}">mindestens 8</span> bis <span class="{1}"> höchstens 26</span> Zeichen - darunter<span class="{2}">mindestens eine Zahl</span> - bestehen. <span class="{3}">Sonderzeichen sind nicht zugelassen</span>.<br/><span class="{4}">Das neue und das derzeitige Passwort müssen sich unterscheiden</span>.',
                    infoPassword:
                        'Das Passwort muss aus mindestens 8 Zeichen - darunter mindestens eine Zahl - bestehen. ',
                    inserisciNuovaPassword: 'Neues Passwort',
                    inserisciPassword: 'Derzeitiges Passwort',
                    inserisciVecchiaPassword:
                        'Wollen Sie Ihr Passwort ändern? Aus Sicherheitsgründen geben Sie bitte zunächst das derzeitige Passwort ein:',
                    mostraPassword: 'Passwort zeigen',
                    passwordDiverse: 'Die beiden Passwörter müssen übereinstimmen',
                    passwordUguali: 'Neues und altes Passwort müssen sich unterscheiden',
                    procedi: 'Fortfahren',
                    ripetiNuovaPassword: 'Neues Passwort bestätigen',
                    success:
                        'Ihr Passwort wurde geändert. Loggen Sie sich nun erneut mit Ihrem Benutzernamen und dem neuen Passwort ein.',
                },
                completaRegistrazione: 'Die Anmeldung beenden',
                completaRegistrazioneMsg: 'Zur Aktivierung des Accounts müssen Sie Ihre Anmeldung vervollständigen.',
                confermaLogout:
                    'Beim Fortfahren wird der aktuelle Benutzer ausgeloggt. Sie können sich erneut mit Benutzernamen und Passwort einloggen.',
                connessioneAssente: 'Login gescheitert: das Internet ist nicht erreichbar',
                dataIscrizione: 'Angemeldet am',
                datiErrati: 'Login gescheitert: Benutzer und/oder Passwort nicht korrekt',
                datiNonCorretti: 'Benutzername oder Passwort sind nicht richtig',
                effettuaLogout: 'Logout ',
                eliminazioneDati: {
                    eliminazioneLabel:
                        'Wenn Sie “mach weiter” klicken wird Ihre Account getrennt und Ihre Daten ausgestrichen gemäß EU-Verordnung 2016/679 (GDPR).Vermerk: nach dieser Operation können Sie die App nur mit Konsultation nutzen.',
                    eliminazioneTitle: 'BITTE AUFPASSEN: unumkehrbarere Aktion',
                    errorTitle: 'Ein Fehler ist aufgetreten',
                    successoTitle: 'Erfolgreiche Aktion',
                    successolabel: 'Ihre Daten weden innerhalb von 24 Arbeitsstunden geliefert.',
                },
                emailInesistente: 'Die angegebene e-mail Adresse ist mit keinem aktiven Account registriert',
                emailNonValida: 'Ungültige E-Mail-Adresse ',
                emailVuota: 'Fügen Sie Ihre e-mail Adresse ein',
                login: 'Login',
                loginPage: {
                    accedi: 'Login:',
                    effettuaAccesso: 'Login:',
                    iscrivitiAmyCicero: 'Anmeldung!',
                    mostraPassword: 'Passwort zeigen',
                    nessunAccount: 'Haben Sie noch kein Account?',
                    seHaiGiaUnAccount:
                        'Falls Sie bereits bei <span class="highlighted"> autobus.it</span> angemeldet sind, können Sie dieselben Zugangsdaten verwenden',
                },
                logout: 'Logout',
                logoutEffettuato: 'Logout erfolgreich gemacht',
                logoutUtente: 'Benutzer-Logout',
                passwordDimenticata: 'Passwort vergessen?',
                passwordDimenticataPage: {
                    email: 'Email-Adresse',
                    erroreResetPassword:
                        'Beim Reset des Passworts ist ein Fehler aufgetreten. Bitte wenden Sie sich an die Servicezentrale.',
                    impossibileResettarePassword:
                        'Das Passwort kann nicht zurückgesetzt werden. Bitte wenden Sie sich an die Servicezentrale.',
                    info:
                        'Geben Sie die Email-Adresse ein, die Sie bei der Registrierung gewählt haben. Sie werden ein temporäres Passwort bekommen.',
                    sendPasswordTemporanea: 'Provisorisches Passwort zuschicken',
                    success:
                        '<p>Ein temporäres Passwort  wurde Ihrer E-Mai-Adresse: gesendet </p><p class="textAlignCenter"><b>{0}</b></p><p>Haben Sie keine Bedienungsanleitung bekommen?<ul><li class="fontSizeTiny">Kontrollieren Sie doch Ihren Spam-Ordener</li><li class="fontSizeTiny">Kontrollieren Sie doch die eingegebene E-Mail-Adrresse</li><li class="fontSizeTiny">Bitte warten sie einige Minuten und versuchen sie es dann erneut</li><li class="fontSizeTiny">Vielleicht haben Sie eine verschiedene E-Mail-Adresse eingegeben</li></ul></p>',
                },
                passwordNonValida: 'Passwort ungültig',
                profilo: {
                    accedi: 'Profil aufrufen',
                    accediAccount: 'Login',
                    gestioneTarghe: 'Registrierte Fahrzeuge - Optionen',
                    gestisciCarteCredito: 'Kreditkartenoptionen einstellen',
                    header: 'Benutzerprofil',
                    impostazioniNotifica: 'Benachrichtigungseinstellungen',
                    preferenzeSosta: 'Parkplatzoptionen',
                    uploadImmagineProfiloFail:
                        'Das Benutzerbild kann nicht geändert werden. Bitte versuchen Sie es später.',
                    uploadImmagineProfiloRetry:
                        'Bei der Bildsendung ist ein Problem aufgetreten. Möchten Sie es wieder versuchen?',
                    uploadImmagineProfiloWait:
                        'Das Bild wurde gespeichert und wird jetzt bearbeitet, es kann nicht sofort sichtbar sein',
                    v2: {
                        apps: {
                            header: 'korrelate App',
                        },
                        associaTessera: 'Eine neue Verkehrskarte assoziieren',
                        cambiaFotoProfilo: 'Profilbild ändern',
                        chattaConAssistenza: 'Chatten Sie mit unserem Kundendienst',
                        condividi: 'Share…',
                        datiFatturazione: {
                            aggiungiProfiloFatturazione: 'Rechnungsdaten registrieren',
                            attivaFatturazione: 'Ich brauche die Rechnung',
                            confermaEliminazioneProfilo: 'Möchten Sie wirklich die Rechnungsdaten löschen?',
                            confermaModificaProfilo: 'Möchten Sie wirklich die Rechnungsdaten ändern?',
                            confermaRitornoAlProfilo: 'Möchten Sie zurück zu Ihrer Profil-Seite gehen?',
                            genericError: 'Füllen die Felde im Rot aus ',
                            header: 'Rechnungsdaten',
                            infoFatturazione:
                                'Bitte beachten Sie, dass die Rechnung/Quittung nur für die Dienste und Parkunternehmen per Email gesendet wird, die es vorsehen: in allen anderen Fällen, wird eine Bezahlungsbestätigung geschickt.',
                            label: 'Rechnungsdaten',
                            modificaProfiloFatturazione: 'Rechnungsdaten ändern',
                            modificheSalvate: 'Ihre Änderungen sind gespeichert worden',
                            profiloSalvato: 'Ihre Rechnungsdaten sind gespeichert worden',
                            rimuoviProfilo: 'Account löschen…',
                        },
                        datiPersonali: {
                            cambia: 'Ändern',
                            haiTesseraAssociata: 'Sie haben eine Verkehrskarte assoziiert',
                            header: 'Personenbezogene Daten',
                            label: 'Personenbezogene Daten',
                            nonPuoiModificareDati:
                                'Ihre Personenangaben sind schon aktualisiert worden und können nicht mehr geändert werden. Für jede Anfrage, bitte schreiben Sie uns an ',
                            perCancellareUtente: 'Bitte dazu eine E-Mail-Anfrage senden an',
                            vuoiCancellareUtente: 'Möchten Sie Ihr Account löschen?',
                        },
                        elencoMovimenti: 'Liste der Kontobewegungen',
                        eliminaDatiPersonali: 'Personenbezogene Daten löschen',
                        eliminazioneDatiPersonali: 'Personenbezogene Daten löschen/Account löschen',
                        eliminazioneDatiPersonaliModalContent:
                            'Sind Sie sicher Ihre Personenbezogene Daten zu löschen? <br> Erinnern: Die Aktion ist <b>unumkehrbarere</b>',
                        esci: 'Logout',
                        gestioneAffiliazioni: 'Aufnahmen',
                        gestioneCarte: 'Ihre Karten',
                        gestioneCreditiMobilita: 'Handeln der Guthaben der Mobilität',
                        ilTuoCredito: 'Ihr Guthaben ',
                        linguaApplicazione: 'Sprache der App',
                        notifichePush: 'Push-Meldungen',
                        preferenzeConsultazione: {
                            deselezionaTutto: 'alles anhaken',
                            erroreCaricamento:
                                'Ein Fehler ist beim Favoriten Laden aufgetreten. Bitte versuchen Sie es später noch einmal.',
                            erroreSalvataggio:
                                'Ein Fehler ist beim Favoriten Speichern aufgetreten. Bitte versuchen Sie es später noch einmal.',
                            header: 'Konsultation Favoriten',
                            infoGestione: 'Ihre Konsultation Favoriten betreiben und ändern',
                            label: 'Konsultation Favoriten',
                            nessunServizioInPreferenze:
                                'Sie haben in den Favoriten keine Dienst abgespeichert. Sie können Ihre Favoriten im Abschnitt "Favoriten nachschauen" des Profils betreiben. Klicken "Favoriten applizieren" um alle Dienste zu sehen und die Gehalte sichtlich zu machen.',
                            salvaModifiche: 'Umänderungen speichern',
                            selezionaTutto: 'alles selektionieren',
                        },
                        preferenzePush: {
                            header: 'Push-Meldungen',
                        },
                        ricaricaCredito: 'Guthaben aufladen',
                        sosta: {
                            comePagare: 'Wie bezahlen?',
                            gestioneTarghe: 'Ihre Autokennzeichen',
                            gestisciZsr: 'Betreiben den Abbonent Kode ',
                            header: 'Parken und ZTL',
                            preferenze: 'Vorzüge',
                        },
                        tesseraAssociataConSuccesso: 'Verkehrskarte {0} erfolgreich assoziiert!',
                        tiPiaceMyCicero: 'Gefällt Ihnen myCicero?',
                        trasporto: {
                            header: 'Verkehr',
                            notificheScadenzaTitolo: 'Fahrkarten- Ablaufnachrichten',
                            scadenzaTitoli: {
                                description: 'Fahrkarten- Ablaufnachrichten aktivieren',
                                header: 'Fahrkarten- Ablaufnachrichten',
                            },
                            tessere: 'Verkehrskarten',
                        },
                        vaiAlleTessere: 'Zu den Verkehrskarte',
                    },
                },
                registrati: 'Anmelden',
                settings: {
                    allFavConfermaDelete:
                        'Wird jetzt fortgefahren, werden alle bevorzugten Lösungen und Haltestellen vom Device entfernt. Dieser Vorgang kann nicht rückgängig gemacht werden.',
                    allFavRimossi: 'Bevorzugte Haltestellen und Lösungen wurden entfernt',
                    cardAssociate: 'Diesem Benutzer zugeordnete Card',
                    fermateFavConfermaDelete:
                        'Wird jetzt fortgefahren, werden alle gespeicherten bevorzugten Haltestellen vom Device entfernt. Dieser Vorgang kann nicht rückgängig gemacht werden.',
                    fermateFavRimosse: 'Die bevorzugten Haltstellen sind entfernt worden',
                    gestisciPosizione: 'Position verwalten',
                    pulisciDati: 'Daten vom Device löschen',
                    raggioRicerca: 'Suche im Umkreis um Position',
                    rimuoviFermateFav: 'Bevorzugte Haltestellen entfernen',
                    rimuoviSoluzioniFav: 'Bevorzugte Lösungen entfernen',
                    soluzioniFavConfermaDelete:
                        'Wird jetzt fortgefahren, werden alle gespeicherten bevorzugten Lösungen vom Device entfernt. Dieser Vorgang kann nicht rückgängig gemacht werden.',
                    soluzioniFavRimosse: 'Die bevorzugten Lösungen sind entfernt worden',
                    utenteAssociatoCard: 'Dieser Benutzer ist folgender Card zugeordnet',
                },
                utente: 'Benutzer',
                zsr: {
                    associaZSRDescriptionHTML:
                        '<span>Benutzerprofil (an dem das Fahrzeug Kennzeichen assoziert ist) mit dem blaue Streife Abonnement verbunden</span>',
                    associaZSRHeading: 'Abonnent Kode assozieren',
                    associazioneFail: 'Kode nicht erkannt',
                    associazioneSuccess: 'assoziert Kode',
                    codiceIdZSR: 'Abonnent Kode',
                    comeOttengo: 'Wie bewirke ich das?',
                    dataDiNascita: 'Geburtsdatum',
                    failureHeading: 'Kode nicht erkannt',
                    idZSR: 'idZSR: ',
                    riprovaAssociazione: 'Probieren wieder die Kombination',
                    successHeading: 'assozierte Kode',
                },
            },
            affiliazioni: {
                common: {
                    budgetMensile: 'Monatsbudget: <span class="bold secondary">{0}</span>',
                    confermaFineSostaChild: 'Zahlung mit Gutschrift von <span class="bold secondary">{0}</span>:',
                    descrizioneTarga: 'Kurze Name',
                    numeroTarga: 'Kennzeichen',
                    rimuoviAffiliazione: 'Aufnahme entfernen',
                    serviziAbilitati: 'Zugelassene Service',
                    sosta: 'Parken',
                    sostaTargheLimitate: 'Parken nur mit Kennzeichnen',
                    spesaMensile: 'Monatliche Ausgaben: <span class="bold secondary">{0}</span>',
                    targaGiaInserita: '{0} ist schon registriert in der Liste der erlaubten Kennzeichen',
                    trasporto: 'Transport',
                },
                creaModificaAffiliazione: {
                    aggiorna: 'Aktualisieren',
                    alias: 'Alias',
                    aliasEsempio: 'z.B. Mario Rossi',
                    emailInfoPlaceholder: 'z.B. mario.rossi@gmail.com, luca.verdi@gmail.com',
                    erroreValidazioneEmail: "Das Format der Mailadresse '{0}' ist nicht richtig",
                    erroreValidazioneImportoSpesaMassimaMensile: 'Bitte, wählen Sie die monatliche Ausgabengrenze',
                    headerSezione: {
                        durataLimite: 'Monatliche Dauer und Grenze',
                        sosta: 'Parken und Ztl',
                        trasporto: 'Transport',
                    },
                    infoEmail:
                        'Bitte, fügen Sie die Mailadressen der Benutzer ein, die durch Ihres Guthaben einkaufen können.',
                    inviaRichiesta: 'Antrag schicken',
                    limitaDurata: 'Dauergrenze',
                    limitaSpesa: 'Monatliche Ausgabegrenze (€)',
                    messaggioRichiestaAffiliazione: 'Aufnahme-Antrag gesendet',
                    messaggioRimozioneAffiliazione: 'Die Aufnahme wurde entfernt',
                    messaggioUpdateAffiliazione: 'Die Aufnahme wurde aktualisiert',
                    modificaAffiliazione: 'Aufnahme verändern',
                    nuovaAffiliazione: 'Neue Aufnahme',
                    permettiPagamento: 'Bezahlung erlauben ',
                    qualsiasiTarga: 'jedes Kennzeichen',
                    spesaAttuale: 'Gegenwärtige monatliche Ausgabe',
                    targheAbilitate: '{0} registrierte Kennzeichen',
                    targheSpecifiche: 'Mit bestimmten Kennzeichen',
                },
                dettaglioAffiliazione: {
                    limiteSpesaMensile: 'Monatliche Ausgabegrenze',
                    seiAbilitato: 'Sie sind erlaubt',
                    spesaAttuale: 'gegenwärtige Ausgabegrenze',
                },
                elencoMovimenti: {
                    delegatoA: 'Bezahlung delegiert zum',
                    pagatoPer: 'Bezahlung ausgeführt von',
                },
                gestioneAffiliazioni: {
                    cercaNomeEmail: 'Name oder Mail suchen',
                    creaNuova: 'Suchen neue',
                    funzionalita: 'Funktionalitäten',
                    gestioneTargheRicorrenti: 'Wiedekehrende Kennzeichen',
                    infoAffiliazioneChild:
                        'Hier können Sie kontrollieren die Liste der<br/> Benutzer, die ihre<br/>Guthabens mit Ihnen geteilt haben.',
                    infoAffiliazioneParent:
                        'Sie können einigen Benutzer gestatten<br/>Ihr Guthaben zu nutzen<br/>. Sie können die Nutzung einigen Dienste begrenzen<br/>. Außerdem können Sie bestimmen<br/>eine Liste der Kennzeichen, die nutzbare für parken sind.',
                    richiesteInAttesa: 'Anfragen in Erwartung',
                    tabs: {
                        childView: 'Bezahlen durch',
                        parentView: 'Erlaubt Bezahlungen ',
                    },
                    title: 'Aufnahmen führen',
                },
                gestioneTargheAutorizzate: {
                    aggiungiRiccorrenti: 'Wiedekehrenden Kennzeichen anfügen',
                    elencoAutorizzate: 'Liste der berechtigten Kennzeichen',
                    gestisciRiccorrenti: 'Wiedekehrende Kennzeichen',
                    importaRicorrenti: 'Aus wiedekehrenden Kennzeichen importieren',
                    infoTargheRicorrenti: 'Sie können diese Kennzeichen zu anderen Erlaubnisse zugeben ohne jedes Mal',
                    inserisciTargaConRicorrenti: 'Oder fügen Sie ein neues Kennzeichen ein',
                    inserisciTargaSenzaRicorrenti: 'Ein neues Kennzeichen einfügen',
                    targaInRicorrenti:
                        "{0} ist registriert in der Liste der wiedekehrenden Kennzeichen. Sie können ein oder mehrere Kennzeichen aus dem Menü 'Importieren aus wiedekehrende Kennzeichen' importieren",
                    targheAutorizzate: 'Autorisiert von {0}',
                    title: 'Erlaubte wiedekehrende Kennzeichen',
                },
                gestioneTargheRicorrenti: {
                    aggiungiTarga: 'Ein wiedekehrenden Kennzeichen anfügen',
                    elencoRicorrenti: 'Liste der wiedekehrenden Kennzeichen',
                    title: 'Wiedekehrende Kennzeichen',
                },
                importaTargheRicorrenti: {
                    descInfoTargheRicorrenti:
                        'Beim "alle Kennzeichen" amgewiesen, erlauben Sie die Nutzung deren, die schon registrierten sind und auch der zukünftigen. Andernfalls können Sie nur jene, die Sie verfügbar erbringen wollen.',
                    title: 'Andere wiedekehrende Kennzeichen importieren',
                    titleInfoTargheRicorrenti: 'Wählen die Kennzeichen, die an der Benutzer assoziert sein müssen',
                    tutte: 'Alle Kennzeichen',
                },
                richiestaAffiliazione: {
                    durataModalita: 'Dauer und Modalitäten',
                    info: 'möchte gern sein/ihr Guthaben mit Ihr teilen',
                    messaggioAffiliazioneAccettata: 'Aufnahme akzeptiert',
                    messaggioAffiliazioneRifiutata: 'Aufnahme abgelehnt',
                    spesaMassimaMensile: 'Größte monatliche Ausgabe',
                    title: 'Aufnahme-Antrag',
                },
            },
            amt: {
                homepage: {
                    benvenutiCatania: '<span>Wilkommen in</span><span class="bold">Catania</span>',
                    biglietteriaTitle: 'Fahrkartenausgaben und Verkaufstellen',
                    carSharingTitle: 'Carsharing',
                    parcheggiTitle: 'Parken',
                    trasportoAcquisti: 'Einkäufe',
                    trasportoAcquisto: 'Einkauf',
                    trasportoSubtitle: 'Info & Fahrkarten',
                    trasportoTitle: 'Transport',
                },
            },
            amtab: {
                homepage: {
                    autobus: 'bus',
                    sosta: 'parken',
                },
            },
            app: {
                appBloccata: 'App gesperrt',
                cambioDispositivo: 'Handy-Änderung',
                description: 'Willkommen bei $t(app.name)!',
                dontAskAnymore: 'Nicht erneut fragen',
                exitMessage: 'Wollen Sie diese Anwendung wirklich beenden?',
                exitTitle: 'Logout bestätigen',
                fineSupportoIOS6Messaggio:
                    'Sehr geehter Benutzer, Ihre Betriebssystemversion ist niedriger als 7. Die laufende Version erlaubt uns nicht Schritt mit jüngsten technologischen Entwicklungen zu halten. Die nächste Version von myCicero wird nicht weiter mit dieser Betriebssystemversion kompatibel sein. Um unsere Dienste weiterhin benutzen zu können, aktualisieren Sie bitte Ihr Mobil-Betriebssystem auf iOS 7 oder höher.',
                grazieMyCiceroTemplate:
                    'Dank für die Nutzung von unserem Service. Wenn Sie es als nützlich finden, bitte schreiben Sie eine Beurteilung auf {0}?',
                iOSNotCompatible:
                    'Um ATAC Fahrscheine einzukaufen, sollte Ihr Handy zumindest auf Version 8 aktualisiert werden. Für weitere Informationen, rufen Sie die Nummer 071 920 7000 an oder senden Sie eine Email an assistenza@mycicero.it ',
                msgCambioDispositivo:
                    '{0} hat Fahrscheine schon mit einem anderen Handy gekauft. Falls Sie bestätigen, werden die schon eingekauften Fahrscheine nicht mehr auf dem alten Handy verfügbar sein. Für weitere Informationen, rufen Sie 071 920 7000 oder schreiben Sie an assistenza@mycicero.it',
                msgTelefonoImpegnatoAltroAccount:
                    'Dieses Handy wurde von einem anderen Benutzer verwendet, um Fahrscheine einzukaufen. Für weitere Informationen, rufen Sie 071 920 7000 oder schreiben Sie an assistenza@mycicero.it',
                name: 'Wepps',
                no: 'Nein',
                pubblicaRecensione: 'Rezension veröffentlichen',
                recensisciMyCicero: 'Eine Rezension über die App erstellen',
                ricordaDopo: 'Bitte später daran erinnern',
                supportoIOS6: 'Systemsfortbildung',
                updateAppMessage: 'Die App auf die letzte Version aktualisieren',
                waitdetail: 'Anfrage wird bearbeitet',
                waitmessage: 'Bitte warten',
                wpNonCompatibile:
                    'Um ATAC Fahrkarten zu kaufen, brauchen Sie ein Smartphone mit iOS oder Android. Für weitere Auskünfte, rufen Sie die 071 920 7000 an oder senden sie eine Mail an assistenza@mycicero.it ',
                yes: 'Ja',
            },
            arriva: {
                homepage: {
                    navette: 'Sonderdienste',
                },
            },
            aspo: {
                fatturazioneDisclaimer:
                    'Bitte aufpassen: die Quittung wird monatlich per Mail und nur für Parkendienst gesendet. Für alle wird auf jeden Fall eine Zahlbestätigung per Mail gesendet.',
                qrCodeFermata: 'Qr Kodex der Haltestelle',
                qrCodeFermataSubtitle: 'Haltestelle Auskünfte',
                rivendite: 'Fahrkartenschalter und Wiederverkäufe',
            },
            atc: {
                homepage: {
                    benvenutiLaSpezia: 'Wilkommen in La Spezia',
                },
                trasporto: {
                    acquistaBiglietti: ' Fahrkarten kaufen',
                    calcolaPercorso: ' Fahrstrecke planen',
                    fermateOrari: 'Haltstellen und Zeitpläne',
                    mieiTitoli: ' Meine Fahrkarten',
                },
            },
            atcgo: {
                acquistaBigliettiHTML: 'Fahrkarten<br/>kaufen',
                calcolaPercorsoHTML: 'Fahrstrecke<br/>bestimmen',
                fermateOrariHTML: 'Haltstellen<br/>und Zeitpläne',
                luoghi: 'Orte',
                mieiTitoliHTML: 'Meine<br/>Fahrkarten',
            },
            autoguidovie: {
                AcquistaBiglietti: 'Fahrkarten<br/>kaufen',
                CalcolaPercorso: 'Fahrstrecke planen',
                CalcolaPercorsoHTML: 'Fahrstrecke<br/>planen',
                ElencoMovimenti: 'Kontobewegungen</br>',
                FermateOrari: 'Haltestelle und Fahrpläne',
                FermateOrariHTML: 'Haltestelle und<br/>Fahrpläne',
                MieiTitoli: 'Meine<br/>Fahrkarten',
                ServiziTuristici: 'Touristische<br />Einrichtungen',
            },
            autoricarica: {
                labelToggleAttiva: 'Aktivieren',
                title: 'automatische Guthabensaufladung',
            },
            avm: {
                addAnagraficaDisclaimer:
                    'Um die Rechnung für den öffentlichen Nahverkehr Dienste oder die integrierte Mobilität (blaue Zone Parken) von AVM/Actv anzufordern, füllen Sie das Formular durch diesen Link aus: a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.veneziaunica.it/it/content/richiesta-fattura\',true)">http://www.veneziaunica.it/it/content/richiesta-fattura</a>. <br /> Nach der Formularausfüllung, bekommen Sie den “Kundencode”. Danach können Sie die Berechnung der Fahrkarten des öffentlichen Nahverkehrs, gekauft durch AVM Venezia Official App, erfordern. Bitte, füllen Sie das folgende Formular:',
                addAnagraficaDisclaimer2:
                    'Achtung: die Rechnung/Quittung wird monatlich per Email von AVM gesendet nur nach der Kunde Code Eingabe. Alle Benutzer werden immer und überall eine Zahlungsbestätigung bekommen.',
                addAnagraficaError1: 'Sie sollen die Felde des formulars ausfüllen',
                addAnagraficaError2:
                    "Sie sollen nur ein Feld zwischen 'Steuernemmer' und 'Identifikationsnummer' ausfüllen",
                addAnagraficaError3:
                    "Mindestens ein Feld zwischen 'Steuernemmer' und 'Identifikationsnummer' spezifizieren",
                addAnagraficaError4: "Es ist not ein 'Kundencode' spezifizieren",
                addAnagraficaErrorANV: 'Account nicht gültig',
                addAnagraficaErrorBLK: 'Account blockiert',
                addAnagraficaErrorECF: 'Identifikationsnummer oder Steuernemmer entsprechen nicht dem Account',
                addAnagraficaErrorERR: 'Ein Fehler ist aufgetreten',
                addAnagraficaErrorINV: 'Input nicht gültig',
                addAnagraficaErrorNFD: 'Kunde Id nicht gefunden',
                areaNonServitaHtml:
                    'Für weitere Auskünfte, mailen Sie bitte <a href="mailto:info@avmspa.it">info@avmspa.it</a> von Montag bis Freitag von 8:00 bis 16:00.',
                benvenutiVenezia: '<span>Willkommen in </span><span class="bold">Venedig</span>',
                calcolaPercorso: 'Strecke berechnen',
                caricaIlTuoVoucher: 'Ihres Voucher einziehen',
                caricaVoucher: 'Voucher einziehen',
                caricaVoucherDescription: 'Den Venezia Unica PNR Kode Ihres einziehen.',
                caricaVoucherPlaceholder: 'Ihre voucher einziehen',
                caricoCliente: 'Bevor reisen, ist auf des Kundens Rechnung die Restgültigkeit der Fahrkarte evaluiren.',
                condizioniContent:
                    "<div> <h2><strong>TERMS AND CONDITIONS OF USE</strong></h2> <h3><strong>1. Field of application</strong></h3> <p>These Terms and Conditions of Use govern the relationship between the User and Azienda Veneziana per la Mobilità (hereafter referred to as AVM) regarding the purchase of local public transport tickets through the use of AVM Venezia official APP<br/> Terms, conditions and regulations governing operations and methods of access and use of public transport, obligations and responsibilities of the transport company and passenger can be found in General Transport Conditions published on site.<br/> The APP can only be downloaded and used on smartphones.</p><h3><strong>2. Meaning of terms and conditions of use</strong></h3> <p>When the user registers and downloads the APP, compatible with his/her smartphone's operating system, he (the user) completely accepts, and is subject to all the associated store's terms and conditions of use, without exception.<br/> AVM reserves the right to unilaterally modify in any moment, these present terms and conditions of use. Each time the user accesses the APP, it is his responsibility to verify any possible modifications; the APP's use implies total acceptance of the terms and conditions.</p><h3><strong>3. Instructions for use</strong></h3> <p>The purchase of a travel ticket through the APP is at the User's exclusive risk. For this purpose the user must protect his mobile device from unauthorized use. In order to minimize possible damages, the User undertakes to immediately advise AVM regarding any suspect of unauthorized use of the smartphone, his account or the APP.<br/> When using the APP (i.e. purchasing a ticket) for the first time, the User must follow the registration instructions and insert the information required by the APP. For any further purchases, the User need only log in by inserting his e-mail address and password.<br/> Once registered, the User is the only person responsible for all activities conducted through his personal account. AVM declines any responsibility relating to errors committed by the User during the registration.<br/> For correct service, when the user downloads the APP onto his smartphone, he must give AVM his personal information, e-mail address and the smartphone device phone number. It is the User's responsibility to verify the correct registration of his personal information.<br/> The User is the only person responsible for the secrecy of his password: should the User suspect of such secrecy being violated, he must immediately modify his password.</p><h3><strong>4. Method of use</strong></h3> <p>Tickets must be purchased before accessing transport means. The User is permitted to purchase tickets for anyone travelling with him.<br/> Payment can only be made with a credit card, including prepaid ones adhering to the Visa/Mastercard circuit The User's credit card information must be inserted after registration or when buying. Once the transaction has been concluded, a receipt of payment will be sent to the User's e-mail address.<br/> Ticket purchased through an APP, must always be validated before the journey begins.<br/> At public transport access areas equipped with turnstiles and QR code readers, the user must visualize the pertinent QR Code and insert the smartphone into the slot. The validity period of the ticket begins, at the moment of scanning.<br/> If the turnstile does not have a QR code reader, or even in the case of a turnstile not being present (e.g. for bus services) validation can be carried out by clicking on the specific icon on the smartphone screen. In this case, validation will be postponed by three minutes.<br/> It is the User's responsibility to guarantee the good functioning of his mobile phone device for the whole length of his journey, should a ticket controller consider it necessary to visualize the validated ticket. Failure to do so, because of bad or incorrect functioning of the mobile device involves the same penalties, as those foreseen and approved for ticket irregularities in General Transport Conditions.</p><h3><strong>Complaints and responsibility</strong></h3> <p>It is not possible to refund or change tickets purchased through the APP.<br/> It is not possible to transfer tickets to other mobile devices. They can be only used in conjunction with the device from which the transaction was done. Any malfunction causing the loss of a ticket or any travel document is solely and exclusively the user's responsibility, and in no case will AVM provide a refund for lost/irrecoverable tickets.<br/> AVM will only refund in the case of a wrong debit determined as an error in the system of payment.</p><h3><strong>Right of Withdrawal</strong></h3> <p>The User can uninstall the APP in any moment and without giving any notice.<br/> Any tickets that have already been purchased and not used, will not be refunded.<br/> <h3><strong>Norms on Privacy</strong></h3> <p>When the User installs the App, he declares and accepts AVM to access, keep and process his personal information and any contents associated with the APP's use, if required by law or if such activities are necessary for the APP's use, i.e. services provided through the APP, in respect of Legislative Decree 196/2003 “Regulations regarding management of personal information”.<br/> The User acknowledges and accepts the use of the APP as a means of electronically transmitting information in communication networks.<br/> More details about how AVM manages personal information is available from site.<br/> Ownership information: Azienda Veneziana della Mobilità spa, Isola Nova del Tronchetto 33, Venice.</p><h3><strong>Intellectual Property</strong></h3> <p>By downloading the APP, the User accepts and acknowledges that it is protected by legislation regarding intellectual property, and other applicable regulations, including, but not limited to, copyrights. The User accepts to use such information covered by monopoly and material exclusively for the use of the service offered, while respecting regulations in the present Terms and Conditions of Use. No part of the APP nor products offered, can be reproduced in any form, nor with any means, excepting that permitted in the present conditions. The User accepts not to modify, rent, hire, lend, sell, distribute, or create anything based on this present APP, in any way, and may not exploit the APP or the products purchased in an unauthorized way.<br/> All copyrights related to the APP are AVM property and/or its licensees. The use of any APP component, except for use permitted under these Terms and Conditions, is strictly prohibited; it violates third party intellectual property rights and may subject the User to civil and penal fines, including possible monetary damage, for violation of copyrights.<br/> AVM, the AVM logo and other AVM Group trademarks/brands, graphic symbols and logos used in connection with the APP represent brands or registered brands of the AVM group. The User has no right or authorization to use, or make reference to any brand mentioned.</p></div>",
                condizioniHeader: 'TERMS AND CONDITIONS',
                condizioniVeneziaUnica: 'Venezia Unica Nutzbedingungen',
                infoMobilita: 'Läufe Zeitplänen aus/nach schulischen Einrichtungen',
                messageCondizioniBorsellino:
                    "Ich habe die <a class='condizioni-borsellino'>Nutzungsbedingungen</a> der Guthaben gelesen und verstanden.",
                messaggioInformativoSosta:
                    'Bitte, kontrolliren Sie, bei der Beschielderung, wenn das ist ein Zahlungsgebiet',
                ricercaOrari: 'Fahrplan an den Haltestellen ',
                sezioneVoucher: 'In Abschnitt "meine Voucher"finden Sie die  Fahrkarten',
                sostaItem: 'aktiv/e',
                sostaSubTitle: 'Info & Fahrkarten',
                sostaTitle: 'Parken',
                trasportoItem: 'Einkäufe',
                trasportoSubTitle: 'Info & Fahrkarten',
                trasportoTitle: 'Transport',
                vaiAiVoucher: 'Zu meinen Voucher',
                verificaAcquisto:
                    'Kontrollieren im Schnitt "Actv Fahrkarten kaufen", wenn hinsichtlich Ihres Reisenbedarfes günstigeren Reiselösungen  (Fahrscheine durch Karte kaufen oder Rechtzeitigfahrkarten) es gibt',
                viaggia: {
                    abbonamenti: 'Kaufen Fahrkarten durch Venezia Unica',
                    acquistoOd: 'Kaufen außerstädtische Fahrkarten',
                    acquistoOdTessera: 'Kaufen außerstädtische Fahrkarten durch Venezia Unica',
                    header: 'Reisen',
                    tariffaFissa: 'Kaufen rechtzeitige Fahrkarten',
                },
                voucherItem: 'Voucher',
                voucherSubTitle: 'Voucher',
                voucherTitle: 'Ihre…aufladen',
            },
            biglietto: {
                acquistatoIl: 'Gekauft am',
                atac: {
                    aimop: {
                        descrizioneAggiuntiva:
                            'Beim Einkauf sind die Fahrkartenlaufzeit- und Ablauf bestimmt, deswegen ist die Fahrkarte schon im Betrieb. Wenn die Abonnements, bis zum 24. jedes Monats gekauft werden, sind sie gültig vom Einkauf bis zum Ende des laufenden Monats. Diese, die später gekauft werden, sind gültig vom ersten Tages des folgenden Monats.',
                        note:
                            'Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin oder, wenn Sie eine Android Vorrichtung mit NFC haben, nähern Sie es dem NFC Terminal auf dem Drehkreuzen.',
                        tipoValidazione: 'Automatisch aktiviert',
                    },
                    bit100: {
                        descrizioneAggiuntiva:
                            'Nach der ersten Aktivierung, ist diese Fahrkarte 100 Minuten gültig für alle Oberflächen-Verkehrsmitteln (Busse, Straßenbahnen und O-Busse). Für die U-Bahn ist die Fahrkarte gültig nur für eine Fahrt auch in mehreren Linien ohne die Drehkreuzen zu überschreiten.',
                        note:
                            "<p class='bold'>Gültigkeit:</p><p>100 Minute Gültigkeit von der erste Aktivierung für Bus, Obertleitungsbus, Straßenbahn, und die Metro C. 1 Fahrt für die Metro A, B, B1 auch auf mehreren Linien ohne die Drehkreuzen zu überschreiten. 1 Fahrt für Zuge.</p><p class='bold'> Einsatzbereich:</p><p> Es ist gültig für alle Metrebus Oberflächen-Verkehrsmitteln: Bus, Straßenbahn, Obertleitungsbus und Metro ATAC, RomaTPL und Cotral Verkehrsmitteln, Ferrovia Roma-Lido und Ferrovia Roma – Viterbo</p><p class='bold'> Wie nutzt man die</p><p>Die Fahrkarte ist gültig nur wenn aktiviert. Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin oder, wenn Sie eine Android Vorrichtung mit NFC haben, nähern Sie es dem NFC Terminal auf dem Drehkreuzen. Wenn Sie die Aktivierung für Metro A, B und B1  bestätigen, haben Sie 2 Minuten zur Verfügung, um in die Metro einzutreten.</p> ",
                        tipoValidazione: 'Hinweise zu den Erstbetrieb, vor der Verkehrsmittelnutzung',
                    },
                    brm24: {
                        descrizioneAggiuntiva: '24 Stunden gültig nach der Aktivierung',
                        note:
                            'Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin oder, wenn Sie eine Android Vorrichtung mit NFC haben, nähern Sie es dem NFC Terminal auf dem Drehkreuzen.',
                        tipoValidazione: 'Hinweise zu den Erstbetrieb, vor der Verkehrsmittelnutzung',
                    },
                    brm48: {
                        descrizioneAggiuntiva: '48 Stunden gültig nach der Aktivierung',
                        note:
                            'Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin oder, wenn Sie eine Android Vorrichtung mit NFC haben, nähern Sie es dem NFC Terminal auf dem Drehkreuzen.',
                        tipoValidazione: 'Hinweise zu den Erstbetrieb, vor der Verkehrsmittelnutzung',
                    },
                    brm72: {
                        descrizioneAggiuntiva: '72 Stunden gültig nach der Aktivierung',
                        note:
                            'Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin oder, wenn Sie eine Android Vorrichtung mit NFC haben, nähern Sie es dem NFC Terminal auf dem Drehkreuzen.',
                        tipoValidazione: 'Hinweise zu den Erstbetrieb, vor der Verkehrsmittelnutzung',
                    },
                    hai2Minuti: 'Sie haben 2 Minuten zur Verfügung, um in die Metro einzutreten.',
                    vuoiAttivareTitolo: 'Möchten Sie die Fahrkarte aktivieren?',
                    vuoiAttivareTitoloBus:
                        '<div class="secondary textAlignCenter fontSizeHuge">Möchten Sie auf dem Bus aufsteigen oder in der Metro C eintreten?</div><div class=\'marginTop\'>Die Berechnung der Gültigkeitsdauer des Fahrschein wird angefangen.<br />Um mit der U-Bahn reisen, stellen Sie das Qr Code auf dem Drehkreuzes Scannern hin.</div>',
                    vuoiEntrareMetro:
                        '<div class="secondary textAlignCenter fontSizeHuge">Möchten Sie in die Metro A, B, B1 eintreten?</div><div class=\'marginTop\'>Um mit der U-Bahn reisen, stellen Sie in zwei Minuten das Qr Code auf dem Drehkreuzes Scannern hin.<br />Der Fahrschein ist für eine U-Bahnfahrt gültig.</div>',
                    vuoiSalireTreno:
                        '<div class="secondary textAlignCenter fontSizeHuge">Möchten Sie in den Zug einsteigen?</div><div class=\'marginTop\'>Der Fahrschein ist für eine Zugfahrt gültig.<br/>Wählen den Bahnhof aus:</div>',
                },
                attiva: 'Aktivieren',
                attivaESaliBus: 'Aktivieren Sie den Fahrschein, um den zu benutzen:',
                attivaEdEntraMetro: 'Aktivieren und eintreten in:',
                attivaMsg: 'Aktivieren Sie den Fahrschein, um den zu benutzen:',
                attivaPer: 'Aktivieren für',
                attivato: 'Aktiviert',
                attivatoIl: 'Entwertet am',
                attivatoMetro: 'U-Bahn Validierung:',
                attivatoPer: 'Aktiviert für',
                attivatoTreno: 'Zug Validierung:',
                attivazioneBus: 'Aktivierung für Bus, Metro C',
                attivazioneMetro: 'Aktivierung für Metro A, B, B1',
                attivazioneNFC: 'NFC Aktivierung',
                attivazioneTitolo: 'Fahrkartenaktivierung',
                attivazioneTreno: 'Zugaktivierung',
                avvisoTitoliLocali:
                    'Die Fahrscheine werden nur im Smartphone gespeichert. Für weitere Informationen, klicken Sie {0}hier{1} ',
                avvisoTitoliLocaliMail:
                    'Die Karten werden in dem Samrtphone gespeichert. Für weiteren Informationen kontaktieren Sie {0}',
                avvisoTitoliLocaliNoLink: 'Die Fahrscheine werden nur im Smartphone gespeichert.',
                cercaTitolo: 'Ticket Suchen',
                chiediCodice: 'Fragen Sie den Fahrer nach Auskünfte, um die Titeln zu aktivieren',
                codiceNonValido: 'Kode nicht gültig',
                confermaAttivazione:
                    'Wenn Sie bestätigen, wird der Fahrschein aktiviert und die Berechnung der Gültigkeitsdauer angefangen',
                confermaMetro: 'Wenn Sie bestätigen, haben Sie 2 Minuten zur Verfügung, um in die Metro einzutreten.',
                confermaMetroAttivazione:
                    'Wenn Sie bestätigen, wird der Fahrschein aktiviert und die Berechnung der Gültigkeitsdauer angefangen und Sie werden 2 Minuten zur Verfügung haben, um in die Metro einzutreten.',
                costoTitolo: 'Fahrkartenkosten',
                daAttivare: 'Zum Aktivieren',
                dataEmissione: 'Ausstellungsdatum',
                dataScadenza: 'Ablaufdatum',
                entraInMetro: 'Metro',
                entraMetro: 'Eintreten:',
                error: {
                    corseEsaurite: 'Keine Bus-Lösung verfügbar',
                    datiNonCongrui: 'Unrichtige Angabe',
                    erroreAntiPassback: 'Anti-passback Kontrollesfehler',
                    erroreApplicativo: 'Anwendungsfehler',
                    erroreValidazioneMultipla: 'Vielfach Entwertung unter demselben Account Fehler',
                    impossibileValidare: 'Die Fahrkarte kann nicht aktiviert werden',
                    titoloNonValido: 'Die Fahrkarte ist nicht gültig',
                },
                fermataSalita: 'Einstiegshaltestelle',
                finoA: 'Bis',
                header: 'Ticket',
                identificativo: 'Kennung',
                inFaseDiAttivazione: 'Dienstleistung in der Aktivierungsphase',
                infoAcquistoAnnullato: 'Die Transaktion wurde vom Käufer annulliert',
                infoAcquistoEffettuato: 'Der gekaufte Fahrschein ist unter "meine Titel" verfügbar.',
                infoAcquistoFallito: 'Es war nicht möglich die Transaktion zu beenden.',
                infoAcquistoFallitoVix:
                    'Es war nicht möglich die Transaktion zu beenden. Bitte probieren Sie es wieder.',
                infoAcquistoSiaeEffettuato: 'Der gekaufte Fahrschein ist unter "Ereignisse" verfügbar.',
                infoCodiceManuale: 'Falls mangelndes Code Lesen, wenden sich dem Fahrer',
                inserisciQualcosaPartenza: 'Straße, Viertel oder Abfahrtshaltestelle eingeben',
                istruzioniAttivazione: 'Drücken "Entwerten" um die Fahrkarte zu enwerten',
                istruzioniDownloadTitoliAsincroni:
                    'Sobald Sie den Einkauf abgeschlossen haben, können Sie Ihren Fahrschein in dem Abschnitt "Meine Tickets" herunterladen',
                istruzioniDownloadTitoliAsincroniTrasporto:
                    'Sobald Sie den Einkauf abgeschlossen haben, können Sie Ihren Fahrschein in dem Abschnitt "Nahverkehr" herunterladen',
                istruzioniObliterazione: 'Drücken "Entwerten" um die Fahrkarte zu enwerten',
                localita: 'Ort',
                multicorsa: {
                    MultiCorsa: 'Carnet',
                    attivaAltro: 'Fahrten entwerten',
                    attivaDefault: 'Aktivieren',
                    attivaPrimo: 'Fahrten entwerten',
                    attivaUltimo: 'Fahrt entwerten',
                    attivoFinoA: 'Fahrt etwertet bis:',
                    confermaRivalidazione: 'Die benutzen Karten werden zusammen mit den abgelaufenen archivieren.',
                    corseAttive: 'Aktive Fährte',
                    corseDaAttivare: 'Fahrten zu benutzen',
                    corseRimaste: 'Fährte:',
                    daAttivare: 'Fahrt nicht etwertete',
                    info: 'Um die Fahrten zu entwerten, stellen Sie das Qr Code {0} Mals auf dem Drehkreuz hin.',
                    quantiAttivare: 'Wie viele Fahrten zu Aktivierten?',
                    scaduto: 'Abgelaufene',
                    tickets: 'Fahrten',
                    tutteCorseScadute: 'Alle Fährte sind ungültig worden',
                    validoDa: 'Fahrt etwertet von:',
                },
                nfcNotSupported:
                    'NFC ist für Ihr Smartphone verfügbar. Trotzdem, mit dieser Android Version, kann myCicero diese Funktion nicht benutzen.',
                nfcOFF:
                    'Mit Ihrem Smartphone können Sie die NFC Aktivierung benutzen. Troztdem ist diese Funktion nicht aktiv. Möchten Sie es aktivieren?',
                nfcON:
                    'Sehr gut! Mit Ihrem Smartphone können Sie diesen Fahrschein aktivieren, in dem das Handy nahe an ein NFC Terminal gehalten wird, wenn es verfügbar ist. ',
                noPosPartenzaRilevata: 'Abfahrtsposition kann nicht erfasst werden',
                nonAcquistabileContrattiInsufficienti:
                    'Sie können diese Fahrkarte nicht kaufen, weil die Karte nicht genügend Verträge hat',
                nonAncoraUtilizzabile: 'Noch nicht nutzbar',
                nonAttivato: 'Fahrkarte nicth aktiviert',
                nonEffettuata: 'Nicht vorgenommen',
                nonObliterato: 'Fahrschein nicht abgestempelt',
                nonValidato: 'Fahrkarte nicht entwertete',
                notificaMessaggio: '{0} wird um {1} abgelaufen',
                notificaTitolo: 'Die Fahrkarte wird gültig in:',
                nuovaAttivazione: 'Neue Aktivierung',
                nuovaValidazione: 'Neue Validierung',
                oblitera: 'Aktivieren',
                obliteratoIl: 'Abgestempelt am ',
                piuCorse: 'Mehr Fahrte',
                precedente: 'Zurück zum vorigen Ticket',
                premiAttiva: 'Wenn die Fahrkarte nicht aktiviert ist, kann eine Strafe mit sich bringen',
                premiValida:
                    'Drücken "Entwerten" bevor auf dem Mittel aufzusteigen. Falls die Fahrkarte nicht entwertet worden ist, eine Geldstrafe fällig wird.',
                primaAttivazione: 'Aktiviert',
                qrCodeScaduto: 'abgelaufener Kodex',
                saliInBus: 'Bus',
                saliSulTreno: 'Zug',
                saraValidoTra: 'Die Fahrkarte wird gültig in:',
                scaduto: 'Abgelaufen',
                scadutoIl: 'Abgelaufen am',
                selezionaFermataSalita: 'Falls bekannt, die Einstiegshaltestelle wählen',
                selezionaStazioneSalita: 'Bahnhof auswählen:',
                singolaCorsa: '1 Fahrt',
                stazioneSalita: 'Bahnhof:',
                successivo: 'Weiter zum nächsten Ticket',
                tempoRestante: 'Verbleibende Laufzeit',
                termsConditions:
                    "<span>Ich habe die </span><a href='#'> Nutzungsbedingungen </a><span> gelesen und stimme ihnen zu</span>",
                tipologiaBiglietto: 'Typologie der Fahrkarte',
                titoliImpersonali: 'Unpersönliche Fahrscheine',
                titoloAttivo: 'Aktive Karte',
                titoloAttivoFinoAl: 'Fahrkarte aktive bis',
                titoloDiViaggio: 'Fahrschein ',
                titoloLocale: 'Diese Fahrscheine ist nur im Ihnen Smartphone gespeichert',
                titoloNonAttivo: 'Fahrkarte nicht aktive',
                titoloScaduto: 'Die Fahrkartre ist abgelaufen',
                titoloScadutoAlle: 'Fahrkarte ge aktive',
                treno: 'Zug',
                ultimaValidazione: 'Letze Aktivierung',
                utilizzabileDalAl: 'Nutzbar vom {0} bis {1}',
                utilizzabileFinoA: 'Nutzbar bis {0}',
                utilizzabileIl: 'Nutzbar am {0}',
                utilizzabileIlGiorno: 'Nutzbar am Tag:',
                utilizzabileOggi: 'Nutzbar heute',
                vaiAlBiglietto: 'Zum Fahrschein',
                valida: 'Neue Fahrkarte entwerten',
                validaMsg: 'Entwerten Sie die Fahrkarte, um es zu benutzen',
                validatoIl: 'Entwertete am:',
                valido: 'Gültig',
                validoFinoAl: 'Gültig bis',
                warningAccessoMetro: 'Durchziehen  den U-Bahn Übergang </br>  binnen',
            },
            bikeSharing: {
                aggiungiBici: 'Ein anderes Fahrrad hinzufügen',
                alertPrenotazioneAccorciata:
                    'Die Verleihperiode wurde reduziert nach der Regelung an der gewählten Stelle',
                alertPrenotazioneAllungata:
                    'Die Verleihperiode wurde erhöht nach der Regelung an der gewählten Stelle. Es gibt keine Extra-Kosten.',
                alertPrenotazioneAnnullata: 'Die Buchung ist annulliert worden',
                altreFunzionalita: 'Andere Funktionalitäten ',
                annullaPrenotazione: 'Buchung annullieren',
                bici: 'Fahrrad',
                biciPrenotataPerHtmlTemplate: 'Das Fahrrad wird für {0} gebucht ',
                bicicletta: 'Fahrrad:',
                biciclette: 'Fahrrad:',
                bikePoint: 'Bike Point:',
                bikePointChiuso: 'Bike point geschlossen',
                bikePointChiusoInfo: 'Während die Schlusszeit des Bike-points ist es nicht möglich zu buchen',
                bikePointPrelievo: 'Entnahme:',
                bikePointRiconsegna: 'Rückgabe:',
                btnPrenota: 'Ein Fahrrad buchen',
                cantBook: 'Sie können nicht buchen',
                cercaBikePoint: 'Bike Point suchen',
                cercaPerNomeIndirizzo: 'Nach Name oder Adresse suchen',
                confermaBici: 'Fahrrad abholen',
                consegnaInRitardo: 'Sie sollten es bis... zurückerstatten:',
                contattaci: 'Kontaktieren Sie uns ',
                dettaglioCorsa: 'Fahrtdetails',
                elencoPrenotazioniRecenti: 'Liste der jüngeren Operationen...',
                elencoStrutture: 'Bike Point',
                emptyPoint: 'Bike Point leer',
                haiPrenotazione: 'Sie haben eine Buchung für {0} Fahrräd(er)',
                haiRiconsegnatoInRitardo: 'Vervollständigt (mit Verspätung)',
                importoMyCicero: 'Durch myCicero bezahlt:',
                importoOra: 'Wenn Sie es jetzt zurückerstatten :',
                importoTotale: 'Gesamtbetrag:',
                infoPoint: 'Bike Point Informationen',
                infoPrelievo: 'Das Fahrrad wird für die eingegebene Periode gebucht',
                infoPrenotazione0: 'Verischerung, Gebühren und eine Karte von Rom inklusive im Verleihpreis.',
                infoPrenotazione1:
                    'Sie haben 30 Minuten um das/die Rad/Räde abzuholen, anders wird Ihren Antrag automatisch gelöscht (keine Kosten werden belasten) ',
                infoPrenotazione2:
                    'Die Buchung wird automatisch aktiviert, wenn der Arbeiter des Bike-Points die Räde Ihn angibt.',
                infoPrenotazione3:
                    'Die asugewähltete Zeit ist zur Rückgabe der Fahrzeuge nicht verbindlich und es wird möglich sein die Vermietung im voraus beenden. Die Kosten werden auf Grund der tatsächlichen Abholungszeit und nach geltenden Tariff belasten.',
                infoRitardo:
                    'Die fehlende Rücklieferung wurde von MyCicero eingetragen. Bitte bringen Sie das Fahrrad zurück so bald wie möglich',
                inserisciCodiceBici: 'Fahrradkode eingeben',
                inserisciNumeroBici: 'Fahrradnummer einziehen',
                istruzioni: {
                    bloccoSbloccoSaldo:
                        'Um die Fahrräder absperren oder entsperren, das Guthabenrest hoher oder egal der Verleihenkost sein soll.',
                    buonaPedalata: 'Gute Tour!',
                    cosaDevoFare: 'Was sollte Ich machen?',
                    inserisciCodice: 'Eingeben oder scannen Ihren Buchungskode aller Fahrräder ',
                    mostraCodice: 'den Kode zeigen',
                    mostraIlCodice: '2) Zeigen Sie dem Station-Betreiber den Buchung-Kode.',
                    mostraSuMappa: 'auf der Karte zeigen',
                    raggiungiIlBikePoint: '1) Erreichen Sie, bis {0}, den Bike Point "{1}"',
                    ricordatiDiRiconsegnare:
                        '4) Vergessen Sie nicht, die Fahrräder bis {0} in einem der unseren Bike Pointes zurückzugeben.',
                    semplice: 'Einfach',
                    termineNoleggioSelfService:
                        'Vor dem Verleihende, überzeugen Sie sich dass alle geliehene Fahrräder in der Bikepoint angehängt worden ist.',
                },
                leMiePrenotazioni: 'Meine Buchungen',
                limitePrenotazioni: 'Sie haben die maximale Buchungsanzahl erreicht.',
                mezzoPrenotatoPeriodoSelezionato: 'Der Artikel wird für die gewählte Periode gebucht.',
                mostaCodicePrenotazione: 'Den Buchung-Kode zeigen',
                nessunRecente: 'Nichts zu zeigen',
                noBikes: 'Kein Fahrrad momentan verfügbar',
                noBikesInPoint: 'Kein Artikel verfügbar in dieser Station',
                noResult: 'Keine Ergebnisse für diese Suche gefunden',
                noleggi: 'Aktive Vermietung',
                operazioneNonAutorizzata: 'Diese Aktion ist nicht erlaubt',
                orario: 'Dienstzeit ',
                orarioApertura: 'Öffnungszeit:',
                prelevaEntro: 'Abholen bis :',
                prelievo: 'Sie können das Fahrrad abholen binnen:',
                prelievoEffettuato: 'Abholung durchgeführt',
                prelievoEntro: 'Abholung binnen:',
                prenota: 'Buchen',
                prenotazioni: 'Buchungen',
                preventivoPrenotazione: 'Buchungskostenvoranschlag',
                problemi: 'Für jedes Problem oder Fehlfunktion',
                recenti: 'Jüngere',
                ricalcoloPreventivoInCorso: 'Der geschätzte Betrag wird gerade neuberechnet...',
                ricaricaBorsellino: 'Laden Sie Ihre Guthaben auf, um zu buchen.',
                ricaricaBorsellino2:
                    'Laden Sie Ihre Guthaben auf, wenn Sie den ganzen Betrag durch MyCicero bezahlen möchten, anders zahlen Sie die Differenz am Arbeiter des Bike-Points.',
                riconsegna: 'Sie müssen es bis .. zurückerstatten: ',
                riconsegnaEffettuata: 'Rückkehr getätigt:',
                riconsegnaEntro: 'Rückgabe binnen:',
                sblocca: 'Entsperren',
                scegliTipologia: 'Typologie wählen',
                seiInRitardo: 'Verspätete Rückkehr',
                templateMessaggioPreventivo:
                    'Wenn Sie jetz die gebuchte Mittels abholen und am ausgewählt Uhr rückgeben, geben Sie aus: {0}',
                terminaNoleggio: 'Vermietung beenden',
                titles: {
                    bikeSharing: 'Bike',
                    conferma: 'Bestätigen',
                    dettaglioCorsa: 'Fahrtdetails',
                    prenotaBici: 'Ein Fahrrad buchen',
                    scegliBikePoint: 'Ein Bike Point wählen',
                },
                visualizzaRecenti: 'Kontobewegungen',
            },
            busitaliaveneto: {
                acquistaBiglietti: 'Fahrkarten kaufen',
                calcolaPercorso: 'Reiseroute bestimmen',
                fermateOrari: 'Haltstellen und Zeitpläne',
            },
            carPoolingTaxiCondiviso: {
                bacheca: {
                    cercaConducenti: 'Fahrer suchen',
                    cercaOfferteRichieste: 'Suchen Angebote und Anfrage der Benutzers',
                    cercaPasseggeri: 'Passagiere suchen',
                },
                common: {
                    annullaRichiesta: 'Anfrage ablehnen',
                    annullaRichiestaError: 'Es is unmöglich die Anfrage ablehnen. Keine Buchung gefunden. ',
                    annullaRichiestaMessage: 'Wollen Sie die Anfrage endgültig ablehnen? ',
                    bacheca: 'Pinnwand',
                    carInfo: 'Fahrzeugauskünfte',
                    chiamaTaxi: 'Taxi anrufen',
                    commento: 'Ausspruch',
                    confermaPrenotazioneTaxi: 'Bestätigen Taxi Buchung',
                    confermaPrenotazioneTaxiMessage:
                        "Wenn Sie die Buchung für geteilt Taxi bestätigen, werden andere Benutzer eine Nachricht über Taxi Buchung bekommen .<br/><br/>Finden Sie die Anfragen im Abschnitt <b class='primary'>MEINE REISEN</b>",
                    confermaRichiesta: 'Bestätigen Ihre Anfrage',
                    confermaRichiestaMessage: 'Sind Sie sicher die Anfrage zu bestätigen?',
                    confermaValutazione: 'Bestätigen die Abschätzung',
                    corsaEliminata: 'Abgesagter Lauf',
                    corsaEliminataMessage: 'Dieser Lauf endgültig gelöscht wurde ',
                    dettaglio: 'Detail',
                    elencoPasseggeri: 'Passagiere Liste',
                    eliminaCorsa: 'Lauf absagen',
                    eliminaCorsaMessage: 'Möchten Sie den Lauf definitiv absagen?',
                    ferryInfo: 'Fährschiffauskünfte:',
                    filtra: 'Filtern',
                    filtraOfferte: 'Filtern Angebote',
                    filtraRichieste: 'Filtern Anfragen',
                    filtraStoricoViaggi: 'Filtern Reisenbewegung',
                    filtriAttiviNum: '{0} aktive Filter',
                    filtroAttivoNum: '{0} aktive Filter',
                    iMieiViaggi: 'Meine Reisen',
                    inserisciRichiesta: 'Anfrage einfügen',
                    inviaOfferta: 'Angebot senden',
                    inviaRichiesta: 'Anfrage senden',
                    iscrizione: 'Anmeldung',
                    mappa: 'Karte',
                    minimoPasseggeri: 'Mindeste Passagieren',
                    nessunRisultato: 'Kein Ergebnis',
                    numeroPostiDisponibili: 'Anzahl der verfügbaren Sitzen',
                    numeroPostiRichiesti: 'Anzahl der erforderliche Sitzen ',
                    offertaPassaggio: 'Durchreise anbieten',
                    offriCorsaPerViaggioCercato: 'Bieten eine Durchreise für die gesuchten Reise',
                    offriUnPassaggio: 'Eine Durchreise anbieten',
                    partecipaTaxiCondiviso: 'Nehmen doch teil an mitgetragenes Taxi',
                    passeggeriAccompagnati: 'Begleitete Passagiere',
                    postiConfermatiNum: '{0} Bestätigte Sitze',
                    postoConfermatoNum: '{0} Bestätigter Sitz',
                    prenotazioneTaxiConfermata: 'Taxi ',
                    procediRichiesta: 'Weiter mit Ihrer Antrag',
                    pubblicaRichiesta: 'Ihre Anfrage bekanntmachen',
                    pubblicaValutazione: 'Ihre Abschätzung bekannt machen',
                    pubblicaValutazioneMessage:
                        'Durch die Publikation Ihrer Abschätzung können alle Benutzer Ihre Rezension sehen',
                    rendiDisponibileAuto: 'Tun Ihres Auto verfügbar',
                    ricercaNoRisultati: 'die Suche hat keine Ergebnisse ergeben',
                    richiestaAnnullata: 'Abgesagte Anfrage',
                    richiestaPassaggioInviata: 'Durchreise Anfrage gesendet',
                    richiestaPubblicata:
                        "Ihre Anfrage wurde publiziert.<br/><br/>Ihre Anfrrage ist verfügbar im Abschnitt  <b class='primary'>Meine Reisen</b>",
                    richiestaRifiutata: 'Abgelehnte Anfrage',
                    richiestaTaxiCondiviso: 'Geteiltes Taxi Anfrage',
                    richiestaTaxiCondivisoNum: '{0} Anfrage für geteiltes Taxi',
                    richiesteTaxiCondivisoNum: '{0} Anfragen für geteiltes Taxi',
                    riepilogoOfferta: 'Angebot Zusammenfassung',
                    riepilogoRichiesta: 'Anfrage Zusammenfassung',
                    rifiutaRichiesta: 'Anfrage ablehnen',
                    rifiutaRichiestaError: 'Es is unmöglich die Anfrage ablehnen. Keine Buchung gefunden. ',
                    rifiutaRichiestaMessage: 'Möchten Sie endgültig die Anfrage abzusagen? ',
                    storicoViaggi: 'Reiseliste',
                    taxiCondiviso: 'GeteiltesTaxi',
                    tornaOfferta: 'Zurück zum Angebot',
                    valutaConducente: 'Den Fahrer evaluiren',
                    valutaPasseggeri: 'Die Passagiere evaluieren',
                    valutaPasseggero: 'Den Passagier evaluieren',
                    valutaUtente: 'Den Benutzer evaluieren',
                    valutazione: 'Abschätzung',
                    viaggiAttivi: 'Aktive Reisen',
                    viaggiCompletati: 'Ergänzte Reise',
                    viaggiConTaxiCondiviso: 'Reise mit geteilten Taxi',
                    viaggiDaConducente: 'Fahrers Reisen',
                    viaggiDaPasseggero: 'Passegiere Reisen',
                },
                offriPassaggio: {
                    partenzaArrivoModificate:
                        'Wenn Sie die Abfahrt und die Bestimmung ändern, können die Reiselösungen nicht mehr vereinbar mit der Anfrage des Passagieres',
                },
                pubblicaRichiesta: {
                    infoRichiestaCarPooling:
                        'Durch diese Anfrage machen Sie bekannt im Schaukasten zwei verschiedene Anfragen. Eine Anfrage für Car Pooling und eine andere für Sammeltaxis. Sie werden durch Mail die Abwesenheitsnotizen bekommen, wenn andere Benutzer werden Reisenangebote oder Anfrage für Sammeltaxis hinzufügen, die mit Ihrem Bedarf vereinbar sind.',
                    infoRichiestaCarPoolingTaxiCondiviso:
                        'Durch diese Anfrage machen Sie bekannt im Schaukasten zwei verschiedene Anfragen. Eine Anfrage für Car Pooling und eine andere für Sammeltaxis. Sie werden durch Mail die Abwesenheitsnotizen bekommen, wenn andere Benutzer werden Reisenangebote oder Anfrage für Taxi Condiviso hinzufügen, die mit Ihrem Bedarf vereinbar sind.',
                    infoRichiestaNoAmbito:
                        'Bitte wählen Sie mindestens zwischen Car Pooling und Taxi Sharing einen Bereich aus, für denen eine Anfrage im Schaukasten bekanntmachen. ',
                    infoRichiestaTaxiCondiviso:
                        'Bitte wählen Sie mindestens zwischen Car Pooling und Sammeltaxis einen Bereich aus, für denen eine Anfrage im Schaukasten bekanntmachen. ',
                    pubblicaRichiestaCarPooling: 'Die Teilungsanfrage für Car Pooling bekanntmachen ',
                    pubblicaRichiestaTaxiCondiviso: 'Die Teilungsanfrage für Taxi bekanntmachen ',
                },
                riepilogoOfferta: {
                    informazioniOffertaPassaggioPubblicata:
                        "Bitte warten, dass andere Benutzer Sie per Email kontaktieren oder suchen Passagiere für Ihre Reise die Anfrage mit Ihrem Bedarf vereinbar sind. <br/><br/>Sie werden Ihre Anfrage i, Abschnitt <b class='primary'>MEINE REISE</b> finden",
                    informazioniVeicolo: 'Fahrzeugauskünfte',
                    informazioniVeicoloPlaceholder: 'Kennzeichen, Marke, Modell',
                    offertaPassaggioPubblicata: 'Durchreiseanfrage bekanntgemacht',
                    selezionaMezzoDiTrasporto: 'Wählen Sie den Verkehrsmittel aus',
                    selezionaTraghettoElba: "Wählen Sie die Fährschiff aus, mit der nach Isola d'Elba ankommen",
                },
                riepilogoRichiesta: {
                    richiestaInoltrataConducente:
                        "Ihre Anfrage ist dem Fahrer gesendet worden<b class='primary'>{0}</b>.<br/><br/>Bitte warten Sie, dass der Fahrer Ihre Anfrage bestätigt  oder rufen Sie sie/hin für Aufschübe an.<br/><br/>Ihre Anfrage ist im Abschnitt<b class='primary'>MEINE FAHRKARTEN</b>",
                    richiestaInoltrataConducenti:
                        "Ihre Anfrage ist den Fahrern gesendet worden<b class='primary'>{0}</b>.<br/><br/>Bitte warten Sie, dass die Fahrer Ihre Anfrage bestätigen  oder rufen Sie sie für Aufschübe an.<br/><br/>Ihre Anfrage ist im Abschnitt<b class='primary'>MEINE REISEN</b>",
                    richiestaInoltrataTaxiCondiviso:
                        "Sie haben Ihre Beteiligung an den geteilt Taxi gesendet.<br/><br/>Bitte,  rufen Sie die andere Teilnehmer an, für Aufschübe über Taxi Buchungen .<br/><br/>Ihre Anfrage ist im Abschnitt<b class='primary'>MEINE REISEN</b>",
                    richiesteInoltrate:
                        "Ihre Afrage ist gesendet worden.<br/><br/>Sie ist im Abschnitt <b class='primary'>MEINE REISEN</b>",
                    richiesteInoltrateTaxiCondiviso:
                        "Sie haben Ihre Beteiligung an den geteilt Taxis gesendet.<br/><br/>Bitte,  rufen Sie die andere Teilnehmer an, für Aufschübe über Taxi Buchungen.<br/><br/>Ihre Anfrage ist im Abschnitt<b class='primary'>MEINE REISEN</b>",
                    richiesteInviate: 'Gesendete Anfragen',
                    richiestePassaggioInviate: 'Durchreise Anfragen gesendet',
                },
                soluzioniDiViaggio: {
                    posizioniNonValide: 'Abfahrt- und Ankunftposition nicht gültig',
                },
            },
            cercaOd: {
                destinazione: 'Zielort',
                header: 'Suche nach Strecke ',
                nessunTitoloTrovato: 'Keine Ergebnisse für diese Suche gefunden',
                origine: 'Abfahrt',
                voglioArrivareA: 'Ich möchte bis diesem Punkt ankommen',
                voglioPartireDa: 'Ich möchte aus diesem Punkt abfahren',
            },
            common: {
                Targa: 'Kennzeichenen',
                aPartireDa: 'Vom',
                aPiedi: 'Zu Fuß',
                accedi: 'Eiloggen',
                accetta: 'Zustimmen',
                acquista: 'Kaufen',
                acquistaCon: 'Bezahlung mit',
                acquistabile: 'Erwerbbar',
                acquisto: 'Kauf',
                acquistoABuonFine: 'Kauf erfolgreich abgeschlossen',
                acquistoEffettuato: 'Kauf vorgenommen',
                adesso: 'Jetzt',
                agevolazioni: 'Ermäßigungen',
                aggiungi: 'Hinzufügen',
                al: 'Bis',
                alAlle: 'Am {0} um {1}',
                andataRitorno: 'Hin- und Rückfahrt',
                anni: 'Jahren',
                annulla: 'Abbrechen',
                annullaOperazione: 'Vorgang abbrechen',
                annullata: 'Gelöscht',
                applicaPreferenze: 'Favoriten ',
                apriQrCode: 'Qr-Code öffnen',
                arrivo: 'Ankunft',
                associaCarta: 'Eine Kreditkarte registrieren ',
                attendere: 'Warten',
                attenzione: 'Achtung',
                attiva: 'Aktivieren',
                attivaBorsellino: 'öffentliche Verkehrsmittel - Guthaben Aktivieren',
                attivaNuovoTitolo: 'Neue Karte aktivieren',
                attivato: 'Aktiviert',
                auto: 'Auto',
                autocompleteTypes: {
                    EVENTI: 'Ereignisse',
                    FERMATE: 'Haltstellen',
                    INDIRIZZO: 'Adressen',
                    LINEE: 'Linien',
                    LOCALITA: 'Stellen',
                    POI: 'Dann',
                },
                avanti: 'Weiter',
                backHome: 'Zurück zu Home',
                benvenuto: 'Willkommen',
                benvenutoNelMondoMyCicero: 'Wilkommen auf myCicero',
                benvenutoNelMondoVettore: 'Wilkommen auf {0}.',
                calcolaPercorso: 'Berechnen die Reiseroute',
                cambiCorsa: 'Wechsel',
                cambia: 'Wechseln',
                cambiaCitta: 'Stadt wechseln',
                cambiaImmagine: 'Wechseln',
                cambioCorsa: 'Wechsel',
                cancella: 'Löschen',
                cancellata: 'Gelöscht',
                caratteri: 'Zeichen',
                carica: 'Laden',
                caricaFile: 'Laden',
                caricamento: 'Uploaden...',
                carriers: 'Beförderungsunternehmen',
                carrozza: 'Wage',
                centro: 'Stadtmitte',
                cerca: 'Suchen...',
                chiudi: 'Schließen',
                chiuso: 'Geschloßen',
                cities: 'Städte',
                clickPerMaggioriInfo: 'Klicken Sie hier für weitere Informationen...',
                codiceTransazione: 'Transaktionskode',
                cognome: 'Familienname',
                comune: 'Stadt ',
                comuneArrivo: 'Ankunftsstadt',
                comuneNonValido: 'Stadt ungültig oder nicht vom Service bedient.',
                comunePartenza: 'Abfahrtsstadt',
                con: 'mit',
                condividiViaggio: 'Die Reise teilen',
                condizioniUtilizzoHtml: 'Ich akzeptiere die <a href="#" class="lnkCondizioni">Nutzungsbedingungen</a> ',
                conducente: 'Fahrer',
                conferma: 'bestätigen',
                confermaAcquisto: 'Kauf bestätigen',
                confermaContinua: 'Möchten Sie weitergehen?',
                confermaEChiudi: 'bestätigen und Schließen',
                confermaNonChiedere: 'Das nicht mehr zeigen',
                confermaSelezione: 'Auswahl bestätigen',
                confermaUscitaApp: 'Wollen Sie die Anwendung wirklich beenden?',
                contattaAssistenza: 'Bitte wenden Sie sich an die Servicezentrale',
                contattaIlGestore: 'Kontaktieren Sie den Betrieber',
                contattiEdEntiCoinvolti: 'Kontakte und übereingekommene Einrichtungen ',
                continua: 'Fortfahren',
                copertura: 'Gebietsdeckung',
                corse: 'Fahrten',
                creaTessera: 'Fahrkarte erschaffen',
                crediti: 'Guthaben',
                dal: 'Von',
                dalAlle: 'Vom {0} um {1}',
                dalleAlle: 'Von {0} bis {1}',
                data: 'Datum',
                dataSvolgimento: 'Datum',
                datiSalvati: 'Angaben gespeichert',
                descrizione: 'Beschreibung',
                dettaglio: 'Detail',
                domani: 'Morgen',
                durata: 'Dauer',
                e: 'und',
                elencoMovimenti: {
                    tipo: {
                        abbSosta: 'Ein Park-Abonnement kaufen ',
                        ricarica: 'Guthaben aufladen',
                        sosta: 'Parken',
                        utilizzoCredito: 'Nutzung des Guthabens',
                    },
                },
                elimina: 'löschen',
                emesso: 'Ausgestellt',
                emptyList: 'keine Ergebnisse gefunden',
                errore: 'Achtung',
                erroreCaricamento:
                    'Ein Fehler ist aufgetreten: die Daten konnten nicht geladen werden. Bitte versuchen Sie es erneut später.',
                erroreComunicazioneServer: 'Verbindung Server Fehler',
                erroreConnessione:
                    'Ein Fehler ist aufgetreten. Bitte prüfen Sie die Internet Verbindung und versuchen Sie wieder.',
                erroreConnessioneServer: 'Keine Verbindung zum Server',
                erroreDownloadTitoli:
                    'Beim Fahrscheineherunterladung ist ein Fehler aufgetreten. Bitte versuchen Sie es wieder später.',
                erroreFormatoQrCode: 'Falsches QR-Code-Format',
                errorePagamento: 'Bei der Bezahlung, ist ein Fehler aufgetreten. Bitte versuchen sie es später erneut.',
                erroreSalvataggio:
                    'Ein Fehler ist aufgetreten: die Änderungen wurden nicht gespeichert. Bitte versuchen Sie es erneut später.',
                erroreScansioneQrCode: 'Ein Fehler ist aufgetreten während dem Qr Scannen.',
                erroreSconosciuto: 'Es ist ein Fehler aufgetreten',
                eventi: 'Ereignisse',
                evviva: 'Juchhu',
                fa: 'vor {0}',
                filters: 'Filtern ',
                filtra: 'Filtern ',
                filtri: 'Filtern ',
                filtro: 'Filter',
                finoA: 'Zum',
                finoATuttoIl: 'Bis das ganze',
                finoAl: 'bis',
                giorni: 'Tage',
                giornoAlle: '{0} um {1}',
                googlePlay: {
                    legal: 'Google Play und das Google Play-Logo sind Marken von Google LLC.',
                },
                home: 'Home',
                ieri: 'Gestern',
                ilDalleAlle: 'Am {0} vom {1} bis {2}',
                illimitato: 'Unbegrenzt',
                importo: 'Betrag',
                importoTotale: 'Gesamtbetrag',
                impossibileEseguireOperazione: 'Es ist unmöglich den Operation durchzuführen',
                impossibileVisualizzareQrCode: 'Es ist unmöglich den Qr-Code anzuzeigen',
                impostazioni: 'Einstellungen',
                indietro: 'Zurück',
                indirizzo: 'Adresse',
                indirizzoArrivo: 'Ankunftsadresse',
                indirizzoPartenza: 'Abfahrtsadresse',
                inevidenza: 'Höhepunkte',
                info: 'Informationen',
                infoAbbreviato: 'Auskünfte',
                infoBiglietto: '',
                infoNonDisponibili: 'Weitere Auskünfte sind nicht verfügbar',
                infoTraghetto: 'Fährschiffauskünfte:',
                infoVeicolo: 'Fahrzeugauskünfte:',
                ingrandisci: 'Zoom',
                inizia: 'Beginn',
                inizio: 'Anfang',
                inserisciCodicePromo: 'Geben Sie den Code',
                intornoA: 'Rings',
                inviaRisposta: 'Antwort senden',
                io: 'Ich',
                itinerario: 'Fahrweg',
                leggi: 'Lesen',
                leggiTutto: 'Alles lesen..',
                liberi: 'freien',
                libero: 'frei',
                lingua: 'Sprache',
                link: 'Link',
                loadMore: 'Mehr laden...',
                longTermParkingPanel: {
                    finoA: 'bis',
                    prenotazioneDal: 'Buchung von',
                },
                luoghi: 'Orte',
                mappa: 'Straßenkarte',
                mesi: 'Monaten ',
                mezzo: 'Fahrzeug',
                mieiTitoli: 'Meine Fahrkarten',
                minuti: 'Minuten',
                minutiLower: 'Minuten',
                minutiShort: 'min.',
                mobilita: 'Mobilität',
                modalita: 'Modalität',
                modifica: 'Ändern',
                mostraTutti: 'Zeige alles',
                mostraTutto: 'Alles zeigen',
                movimenti: 'Kontobewegungen',
                msgAtacLockedOutUntil:
                    'Aus Gründen der Sicherheit, die mit der letzten Migration verbunden sind, sind ATAC Karten derzeit nicht erhältlich; werden sie wieder sichtbar um {1} Uhr sein',
                nascondi: 'Verstecken...',
                nessun: 'Kein',
                nessunDettaglioTrovato: 'Kein Detail gefunden',
                nessuno: 'Kein',
                newsNotifiche: 'News und Anmeldungen',
                newsNotificheUnread: '{0} Ungelesene News',
                nfcSpentoDesc: 'Bitte, aktivieren das NFC in Ihrer Smartphone Einstellungen',
                nfcSpentoWarning: 'NFC ist in Ihrem Gerät deaktiviert',
                no: 'Nein',
                noCameraPermission: 'Sie haben kein Erlaubnisse um in die Kamera einzutreten',
                noRicerchePreferite: 'Keine bevorzugten Suchen vorhanden',
                noRicercheRecenti: 'Keine jüngsten Suchen gefunden',
                noRisultati: 'Keine Ergebnisse für diese Suche gefunden',
                noRisultatiRicerca: 'Es wurden keine Ergebnisse gefunden.',
                noRisultatiVisibili: 'Keine sichtbaren Ergebnisse',
                nome: 'Vorname',
                nomeCompleto: 'Name und Familienname',
                nonAcquistabile: 'Nicht erwerbbar',
                nonAttiva: 'Nicht aktiv',
                nonConfermata: 'Nicht bestätigen',
                nonOra: 'Nicht jetzt',
                notifica: 'Benachrichtigung',
                numCartafreccia: 'Cartafreccia-Nummer',
                nuova: 'Neue',
                nuovaAttivazione: 'Neue Aktivation ',
                obbligatorio: '(obligatorisch)',
                oggi: 'Heute',
                ok: 'Ok',
                operazioneEseguita: 'Vorgang durchGefährt',
                operazioneFallita: 'fehlgeschlagene Aktion',
                opzioni: 'Optionen',
                ora: 'Stunde',
                oraDelGiorno: "<span class='bold'>{0}</span> von {1}",
                orariEfermate: 'Fahrpläne und Haltestellen',
                orario: 'Uhrzeit',
                ore: 'Stunden',
                ottimo: 'Sehr gut ',
                paga: 'Bezahlen',
                parcheggiNavette: 'Parkplätze mit Pendelfahrzeuge',
                parcheggia: 'Parken',
                partenza: 'Abfahrt',
                partners: 'Partners',
                passeggeri: 'Passagiere',
                passeggero: 'Passagier',
                plusAutoricarica: {
                    labelCartaDiCreditoNecessaria: 'Bitte eine Kreditkarte regstrieren',
                    labelMemorizza: 'Speichern',
                    labelRicaricaAutomatica: 'Die automatische Guthabensaufladung einstellen',
                    labelRicaricaAutomaticaAttiva: 'Automatische Guthabensaufladung aktiv',
                    labelRicaricaAutomaticaNonDisponibile: 'Automatische Guthabensaufladung nicht möglich',
                },
                plusCartaDiCredito: {
                    labelElimina: 'Entfernen',
                    labelProprietario: 'BESITZER',
                    labelValidita: 'VALID<br/>THRU',
                },
                posti: 'Sitze',
                posto: 'Sitz',
                preferite: 'Bevorzugte',
                preferiti: 'Bevorzugte',
                prefissoData: 'Am',
                prezzo: 'Preis',
                primaAttivazione: 'Erste Validierung:',
                procedi: 'Fortfahren',
                prodotti: 'Produkte',
                promoOK: 'Promotion gestellt',
                prosegui: 'Weitergehen',
                qrCodeFermata: 'Haltestelle - QR Code ',
                quando: 'Wann',
                quantita: 'Menge',
                raggiungici: 'Erreichen uns',
                realtaAumentata: 'Erweiterte Realität ',
                recenti: 'Jüngst',
                refresh: 'Updaten',
                reset: 'Reset',
                results: 'Ergebnisse',
                ricarica: 'Guthaben aufladen',
                ricerca: 'Suchen',
                riceviAssistenza: 'Zur Kundenbetreuun, klicken auf:',
                rifiuta: 'Ablehnen',
                rifiutata: 'Abgelehnt',
                rimuoviFiltri: 'Filtern löschen',
                riprova: 'Bitte versuchen Sie es erneut',
                risultatiPer: 'Ergebnisse für',
                rivendite: 'Ticketschalter und Ticketsverkaufstellen',
                salta: 'Auslassen',
                salva: 'Speichern',
                salvaNeiPreferiti: 'Unter Bevorzugten speichern',
                salvaProcedi: 'speichern und weitergehen',
                salve: 'Hallo',
                scadenza: 'Ablaufdatum: ',
                scanQrCode: 'QR-Code scannen',
                scegliRitorno: 'Rückreise auswählen',
                scegliTipologia: 'Wählen Sie eine Kategorie zu filtern',
                secureCode: 'Mobile Secure Code',
                secureCodeMyCicero: 'myCicero Secure Code',
                secureCodeRecover:
                    'Falls der Secure Code verloren gegangen ist, sollen Sie die Daten der Kreditkarte löschen und die neu eintragen.',
                seiSicuro: 'Sind Sie sicher?',
                seleziona: 'Auswählen',
                selezionaMemorizza: 'Markieren und speichern',
                selezionaPosizioneMappa: 'In der Karte auswählen',
                sempre: 'immer',
                servizi: 'Service',
                serviziAggiuntivi: 'Zusätzlichen Dienstleistungen',
                share: 'Share',
                sharing: {
                    header: 'Gefällt Ihnen myCicero?',
                    provaMyCicero: 'Probieren Sie myCicero aus!',
                    sharingMessage:
                        'Benutzen Sie die öffentlichen Verkehrsmittel oder brauchen Sie ein intelligentes, schnelles und günstiges System zur Parkbezahlung über eine App? Dann sollten Sie unbedingt myCicero ausprobieren! myCicero ist die einzige App, die Ihnen sowohl das Parken als auch die Nutzung der öffentlichen Verkehrsmittel erlaubt, die App wird Ihnen bei jeder Phase Ihrer Reise unterstützen. Eine einzelne App für viele Dienstleistungen. - Damit können Sie nur die echten Parkminuten bezahlen und ZTL-Zugangserlaubnisse kaufen. - Reiselösungen integriert mit lokalen Verbindungen und Tickets. - Lokale und nationale Linien mit Tickets und Abonnements zu verkaufen. - Fahrplan und Tickets in einem Klick, halten Sie das Smartphone nahe an der automatischen Ticket Tor und einfach eintreten. ',
                    shortText: 'Teilen Sie die App mit Ihren Freunden!',
                    text: 'Gefällt Ihnen myCicero? Share it!',
                },
                socialMedia: 'Social media',
                soloAndata: 'Einfache Fahrt',
                sosta: 'Parken',
                spese: 'Ausgaben',
                sulista: 'Liste',
                sumappa: 'Karte',
                targa: 'Kennzeichen',
                tariffa: 'Tarif',
                telefono: 'Telefon ',
                tempoScaduto: 'Abgelaufene Zeit',
                terminaApp: 'App schließen',
                termsCondition: 'Ich habe die Nutzungsbedienungen gelesen',
                timeoutPagamentoBigliettoTrasportoMessage:
                    "Die Verarbeitung braucht länger als vorgesehen. Bevor zu wieder probieren, warten Sie einigen Sekunden und überprüfen Sie wenn die Fahrkarte im Abschnitt 'Meine Fahrkarten' sind oder wenn die Kaufbestätingung Email bekommen.",
                timeoutPagamentoMessage:
                    'Die Verarbeitung braucht länger als vorgesehen. Bevor zu wieder probieren, warten Sie einigen Sekunden und uberprüfen Sie wenn die Kaufbestätingung Email bekommen.',
                timeoutPagamentoTitle: 'Verbindung timeout',
                tipo: 'Typologie:',
                tipologia: 'Typologie ',
                tornaAllaHome: 'Zurück zur Homepage',
                tornaIndietro: 'Zurück',
                totale: 'Gesamt',
                tours: 'Tour',
                tra: 'in {0}',
                trasporto: 'Transport',
                tuttaLaSettimana: 'Ganze Woche',
                tutteTipologie: 'Alle Typologien',
                tutti: 'alle',
                utente: 'Benutzer',
                utenti: 'Benutzern',
                utilizzabileIl: 'Nutzbar am:',
                utilizzoTitoliAtac: 'ATAC-Fahrscheine Verwaltung',
                vaiAlTitolo: 'Zum Fahrschein',
                vaiAllaPagina: 'Zur Seite',
                valida: 'GüLTIG',
                validoDal: 'Gültig ab',
                validoFinoAl: 'Gültig bis',
                validoFinoAlle: 'Gültig bis',
                validoIlGiorno: 'Gültig am',
                validoTra: 'Gültig in',
                verifico: 'Überprüfen...',
                verifying: 'überprüfung läuft...',
                version: 'Version',
                vettore: 'Verkehrsunternehmen',
                viaggi: 'Reisen',
                viaggio: 'Reise',
                visitaIlSito: 'Webseite besuchen',
                yes: 'Ja',
                zonaNonCoperta: 'Diese Stadt ist vom Service nicht bedient. ',
            },
            credito: {
                aci: {
                    descrRedirect:
                        'Beim Klicken auf die Schaltfläche werden Sie auf die Bezahlungsseite von Aci umgeleitet.',
                    descrizione: 'Mit ACI pay bezahlen',
                },
                acquistoConBorsellino: 'Kaufen mit Ihrem Guthaben ',
                acquistoConBorsellinoMyCicero: 'Kaufen mit Ihrem Guthaben myCicero',
                acquistoConBorsellinoTrasporto: 'Kaufen mit Ihrem Transport-Guthaben ',
                acquistoSisalAbbSosta: 'Nach dem Einkauf, wird Ihr Abonnement unter "Ermäßigungen" verfügbar sein.',
                acquistoSisalRicaricaBorsellino: 'Nach dem Einkauf, wird Ihr Guthaben aktualisiert sein.',
                alertConnessioneCadutaAcquistoAbb:
                    'Die Verbindung wurde unterbrochen, weshalb nicht sicher ist, ob der Vorgang abgeschlossen werden konnte. Kontrollieren Sie, ob das eben erworbene Abonnement im Bereich "Meine Abonnements" verzeichnet ist, andernfalls den Kaufvorgang wiederholen.',
                attivaBorsellinoTrasportoPubblico: 'Öffentliche Verkehrsmittel - Guthaben aktivieren',
                bemoov: {
                    descrRedirect:
                        'Sie werden auf eine externe Seite weitergeleitet, und Sie werden aufgefordert, den Code und die OTP CV2 der verknüpften Kreditkarte einzugeben',
                    descrUsoNumeroTelefono:
                        'Ein OTP-Code wird per SMS an die angegebene Nummer zur Bestätigung geschickt werden',
                    inserisciNumeroTelefono: 'Bitte die mit Ihrem Account assoziierte Telefonnummer eingeben',
                },
                clearCodice: 'Code löschen',
                controllaCodice: 'Code prüfen',
                credito: 'Guthaben ',
                creditoBorsellinoInsufficiente: 'Das Restguthaben ist nicht ausreichend für diesen Kauf.',
                creditoInsufficiente: 'Guthaben nicht ausreichend',
                creditoResiduo: 'Restguthaben',
                creditoSosta: 'Prkguthaben',
                datiPagamento: 'Zahlungsdaten',
                dettaglioAcquisto: 'Einkaufdetails',
                dettaglioAttivitaRicarica: 'Detaillierte Transaktionsübersicht ',
                effettuaPagamento: 'Zahlung vornehmen',
                effettuaPagamentoPer: 'Zahlung vornehmen für',
                erroreCaricamento:
                    'Ein Fehler ist aufgetreten: die Daten konnten nicht geladen werden. Bitte versuchen Sie es erneut später.',
                erroreSalvataggio:
                    'Ein Fehler ist aufgetreten: die Änderungen wurden nicht gespeichert. Bitte versuchen Sie es erneut später.',
                gestionePagamento: 'Zahlungsverwaltung',
                importoAcquisto: 'Kaufbetrag',
                infoAcquistiSmartphoneHTML:
                    'Zum Kaufen über Smartphone registrieren Sie bitte eine Kreditkarte, über die völlig sicher Abonnements erworben und das Parkguthaben aufgeladen werden kann. <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Registrieren Sie Ihre Karte mit wenigen Klicks</a>.',
                infoAttivaBorsellinoHTML:
                    'Sie können Ihr Guthaben verwenden. Zur Aktivierung einfach auf den <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Geschätzten Bereich</a> zugreifen.',
                infoConfermaPagamento:
                    'Durch Betätigen dieser Schaltfläche wird das Geschäft abgewickelt, indem der Betrag von der angegebenen Kreditkarte abgehoben wird.',
                infoConfermaPagamentoBorsellino:
                    'Durch betätigen dieser Schaltfläche wird das Geschäft abgewickelt, indem der Betrag vom Guthaben abgehoben wird',
                infoConfermaPagamentoBorsellinoMyCicero:
                    'Durch betätigen dieser Schaltfläche wird das Geschäft abgewickelt, indem der Betrag vom Guthaben abgehoben wird',
                infoConfermaPagamentoBorsellinoTemplate:
                    'Durch betätigen dieser Schaltfläche wird das Geschäft abgewickelt, indem der Betrag vom Guthaben abgehoben wird {0} ',
                infoConfermaPagamentoRedirect: 'Sie werden auf eine externe Weseite weitergeleitet',
                infoRicaricaBorsellinoHTML:
                    'Das Guthaben kann direkt vom Telefon aufgeladen werden (<a data-bind="tap: gotoRicarica">hier klicken</a>) oder, indem über einen PC auf den<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Geschätzten Bereich </a> zugegriffen wird.',
                infoRicaricaBorsellinoShortHTML:
                    'Das Guthaben kann aufgeladen werden, indem über einen PC auf den <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Geschätzten Bereich </a> zugegriffen wird.',
                inserisciCodiceCouponRicarica: 'Coupon Kode einfügen',
                inserisciDatiCarta: 'Bitte die Kreditkarten-Details eingeben',
                inserisciSecureCode: 'Den Secure Code Mobile eingeben',
                inserisciSecureCodeMyCicero: 'Den Secure Code myCicero eingeben',
                metodoPagamento: 'Zahlungsmethode',
                noCreditCard: 'Mit Kreditkarte kaufen',
                nonRicordi: 'Kode vergessen?',
                pagaCon: 'Zahlen mit ',
                payCreditOneShot: 'Zahlung mit Kreditkarte vornehmen, ohne diese zu registrieren',
                paypal: {
                    info1: 'Automatisch mit dem PayPal Account bezahlen.',
                    info2: 'Wenn Sie darauf clicken, werden Sie sofort durch PayPal bezahlen.',
                    titolo: 'PayPal<sup>TM</sup>',
                },
                paypalexp: {
                    descrRedirect: 'Wenn Sie auf diese Taste klicken, werden Sie zur PayPal Bezahlung umadressiert.',
                    descrizione: 'Paypal express checkout Bezahlung',
                },
                paypalric: {
                    descrRedirect: 'Falls Sie auf "Ja" klicken, wird die Bezahlung durch Paypal erfolgen.',
                    descrizione: 'Mit Paypal bezahlen',
                },
                prenotazioneSisal: 'Sie haben eine Vormerkung<br/>von &euro;&nbsp;{0}',
                prenotazioneSisalAbb: 'Sie haben eine Vormerkung<br/>von &euro;&nbsp;{0}',
                prenotazioneSisalRic: 'Sie haben eine Vormerkung für <br/>das Aufladen von &euro;&nbsp;{0}',
                promoTitoli: 'Promotion',
                redirectToCCInfo:
                    'Sie werden an eine externe Seite weitergeleitet, auf der Sie zur Eingabe der Daten Ihrer Kreditkarte aufgefordert werden.',
                registraCartaCredito: 'Neue Kreditkarte...',
                ricarica: 'Aufladen',
                ricaricaBorsellino: 'Guthaben aufladen',
                ricaricaCoupon: 'Haben Sie ein Coupon?',
                ricaricaCouponNonValido: 'Das Kode ist nicht gültig oder abgelaufen',
                ricaricaCouponUsaCodice: 'Suchen...',
                ricaricaCouponVerificaCodiceBtn: 'Kode prüfen',
                ricaricaCredito: 'Guthaben aufladen',
                ricaricaSuccess: 'Aufladevorgang erfolgreich abgeschlossen',
                richiediPagamento: 'Bezahlung anfordern',
                richiediPagamentoPer: 'Bezahlung anfordern für',
                saldo: 'Guthaben',
                saldoAttuale: 'Saldo Aktuelles Guthaben',
                saldoFuturo: 'Saldo Zukünftiges Guthaben',
                satispay: {
                    bonus:
                        '&euro; 5,00 Bonus bei <u onclick="openLinkOnBrowser(\'https://www.satispay.com/promo/mycicero\')">Anmeldung </u> zum Service!',
                    completaPagamento:
                        'Die Bezahlung in der App <span style="font-weight: bold">SatisPay</span> vervollständigen',
                    confermaCompletato:
                        'Sobald wir die Transaktionbestätigung bekommen, wird den Einkauf fertiggestellt ',
                    inserisciNumero: 'Bitte die Telefonnummer eingeben, die mit dem Satispay-Account assoziiert ist',
                    risultatoAcquisto: 'Nach dem Einkaufen wird der Fahrschein unter "Nahverkehr" verfügbar sein',
                    titolo: 'Satispay',
                    verraiRediretto: 'Sie können die Bezahlung in der App <strong>Satispay</strong> vervollständigen',
                },
                scegliCartaCredito: 'Eine der zugeordneten Kreditkarten Wählen',
                scegliImporto: 'Den Betrag für das Aufladen des Guthabens Wählen',
                scegliMetodoPagamento: 'Zahlungsmethode Wählen',
                screenSaved: 'Ferner wurde gerade ein Bild in Ihrer Fotogalerie registriert.',
                secureCodeErrato: 'Secure Code falsch',
                secureCodeReminder:
                    'Mobile Secure Code ist Ihre persönliche 5- Stellige Nummer die Sie bei der Anmeldung Ihrer Kreditkarte eingegeben haben.',
                secureCodeReminderMyCicero:
                    'myCicero Secure Code ist Ihre persönliche 5- Stellige Nummer die Sie bei der Anmeldung Ihrer Kreditkarte eingegeben haben.',
                sisalCommissioni1: 'Neben den Operationskosten, sind auch ',
                sisalCommissioni2: 'SisalPay Gebühren zu bezahlen',
                sisalCommissioni3: 'die dem bezahlten Betrag entsprechend sind',
                sisalGeneraCod: 'Code generieren für',
                sisalInfoAcquisto:
                    'Zum Kaufen von weiterem Guthaben begeben Sie sich an eine <u> SisalPay-Annahmestelle</u> und geben Sie folgende Parameter an…',
                sisalInfoAcquisto2:
                    'Sie können jetzt in jedem SisalPay Schalter mit Ihrem PNR Kode aufzahlen. Die Anzahlung erfolgt durch dem Portal Autobus.it - MyCicero',
                sisalInfoAcquisto3:
                    'Eine SisalPay-Verkaufsstelle erreichen und die Bezahlung auf autobus.it - myCicero tätigen. Dazu kommunizieren Sie bitte den PNR-Code, den Sie bekommen haben.',
                sisalInfoMaggiorazioneHtml:
                    'Wenn Sie durch SisalPay anzahlen, sind die Transaktionkosten verhältnismäßig dem Anzahlungsbetrag.',
                sisalInviatoPerEmail: 'Dieser Code wurde Ihnen per E-Mail an folgende Adresse geschickt',
                sisalMostraRivendite: 'Verzeichnis der SisalPay-Annahmestellen anzeigen',
                sisalPay: 'SisalPay',
                sisalPayDescription:
                    'Nach dem Klick wird ein PNR-Code generiert, den Sie bei der SisalPay-Annahmestelle angeben müssen, damit die Zahlung vorgenommen werden kann.',
                sisalPuntiVendita: 'SisalPay Verkaufsstelle',
                sisalRaggiungi:
                    'Sie können jetzt in jedem SisalPay Schalter mit Ihrem PNR Kode aufzahlen. Die Bezahlung erfolgt durch dem Portal Autobus.it - MyCicero.',
                sisalbill: {
                    completaPagamento: 'Vervollständige die Zahlung mit Bill',
                    completaPagamentoFallita: 'Transaktion versagene',
                    confermaCompletato: 'Sobald wir die Bestätigung bekommen, wird den Einkauf beendet ',
                    confermaCompletatoAbbonamentoSosta:
                        'Nachdem Sie den Kauf beendet haben, klicken Sie im Teil "Erleichterungen", um die Erlaubnis herunterladen',
                    confermaCompletatoBorsellino: 'Das Guthabenkredit war abgemeldet',
                    confermaCompletatoFallita: 'Ein Fehler ist während der Bezahlung aufgetreten',
                    confermaCompletatoTitoli: 'Sie können die Fahrkarte im Teil meine Fahrkarten finden',
                    risultatoAcquisto:
                        'Sobald wir die Bestätigung aus Sisal&nbsp;Bill bekommen, wird den Einkauf beendet ',
                    risultatoAcquistoBorsellino:
                        'Sobald wir die Bestätigung aus Sisal&nbsp;Bill bekommen, wird den Einkauf beendet ',
                },
                staiAcquistando: 'Sie kaufen gerade:',
                staiPagando: 'Sie sind bereit, zu zahlen:',
                staiPrenotando: 'Die folgende Zahlung wird gebucht',
                stpay: {
                    descr: '<p>Satispay ist ein Zahlungssystem, das nicht mit Debit-/Kreditkarten verbunden ist.</p>',
                    iscrivitiSubito: 'Melden Sie sich an, um das Service zu benutzen, Sie werden 5€ Bonus bekommen',
                },
                usaIlCredito: {
                    info1: 'Laden Sie Ihr Guthaben auf und benutzen Sie es zur Bezahlung von myCicero Dienstleistungen',
                    info1Branded: 'Laden Sie Ihre Guthaben auf, um die Service su bezahlen.',
                    info2:
                        'So müssen Sie nicht jedesmal alle Kreditkarte-Daten erneut eingeben! Keine Extra-Kosten. Verschiedene Zahlungsmöglichkeiten verfügbar.',
                    info2Branded:
                        'So müssen Sie nicht jedesmal alle Kreditkarte-Daten erneut eingeben! Keine Extra-Kosten.',
                    ricaricaCredito: 'Guthaben aufladen',
                    titolo: 'Es ist günstig!',
                },
            },
            dettaglioSinteticoFermata: {
                direzione: '{0}',
                distanzaDaTe: '{0} von Ihnen',
            },
            dettaglioSisnteticoBus: {
                direzione: 'Richtung: {0}',
                distanzaDaTe: 'Haltestelle {0} von Ihnen entfernt',
            },
            difonzo: {
                acquistaTitoli: 'Fahrkarten kaufen',
                fermateEdOrari: 'Haltestellen und Zeitpläne',
                mieiTitoli: 'Meine Fahrkarten',
                soluzioniDiViaggio: 'Reiselösungen',
            },
            dolomiti: {
                AcquistaBiglietti: 'Fahrkarten kaufen',
                CalcolaPercorso: 'Fahrstrecke planen',
                Eventi: 'Ereignisse',
                FermateOrari: 'Haltestelle und Fahrpläne',
                Luoghi: 'Orte',
                MieiTitoli: 'Meine Fahrkarten',
                ServiziTuristici: 'Fremdenverkehrseinrichtungen',
            },
            eav: {
                AcquistaBiglietti: 'Fahrkarten<br/>kaufen',
                CalcolaPercorsoHTML: 'Fahrstrecke<br/>planen',
                CampaniaExpress: 'Campania Express',
                CampaniaExpressHTML: 'Campania<br/>Express',
                CumaExpress: 'Cuma Express',
                CumaExpressHTML: 'Cuma<br/>Express',
                FermateOrari: 'Haltstelle und ',
                FermateOrariHTML: 'Haltestelle und<br/>Fahrpläne',
                MieiTitoli: 'Meine<br/>Fahrkarten',
                bigliettiBus: 'Busfahrkarten',
                bigliettiFunivia: 'Seilbahnfahrkarten',
                bigliettiTreno: 'Zugfahrkarten',
                fermate: 'Haltestelle und Zeiten',
            },
            elbasharing: {
                bachecaTab: {
                    conducenti: 'Fahrer',
                    passeggeri: 'Passagiere',
                    taxi: 'Taxis',
                },
                common: {
                    cercaUnPassaggio: 'Eine Durchreise buchen',
                    filtraLabel: 'Filtern',
                    filtriAttivi: 'Filter aktive',
                    filtroAttivo: 'Filter aktiver',
                    infomobilita: 'Infomobilität',
                    nuovaRicerca: 'Neue Suche',
                    trovaSoluzioneViaggio: 'Eine Reiselösung finden',
                },
                homepage: {
                    bacheca: 'Schaukasten',
                    consultaOfferteRichieste: 'Aktive Angebote und Anfragen nachschauen',
                    controllaViaggi: 'Ihre Reise kontrollieren',
                    iMieiViaggi: 'Meine Reisen',
                    offriUnPassaggio: 'Eine Durchreise bieten',
                    partecipaOpinione: 'Nehmen Sie teil durch Ihrer Meinung',
                    questionari: 'Fragebogen',
                    rendiDisponibileAuto: 'Tun Ihres Auto verfügbar',
                    servizi: 'Dienste',
                    viviIlTerritorio: 'Erfahren das Gebiet ',
                },
                review: {
                    reviewLabel: 'Besprechungen von anderen Reisenden:',
                },
                soluzioniDiViaggio: {
                    posizioniNonValideOffriPassaggio:
                        "Es ist möglich eine Durchreise nur mit Abfahrt und Ankunft in der Isola d'Elba zu bieten",
                    posizioniNonValideRichiediPassaggio:
                        "Es ist möglich eine Durchreise nur mit Abfahrt und Ankunft in der Isola d'Elba zu erfordern.",
                },
                tabelloneOrari: {
                    intornoAllIndirizzo: 'Neben der Adresse',
                },
                taxiCondivisoStatus: {
                    taxiStatus: 'Bestätigt',
                },
                vetrinaVettori: {
                    description:
                        'Für weitere Auskünfte über offizielle Fahrpläne und Einkauf der Fahrkarten, können Sie die Webseiten der Nahverkehrsbetriebe CTT Nord und Tiemme konsultieren ',
                },
            },
            event: {
                allCategories: 'Alle Kategorien',
                arrivi: 'Ankünfte',
                caricaAltriEventi: 'andere Ereignisse hinzufügen',
                definisciRaggio: 'Suchumkreis bestimmen:',
                dettaglio: 'Ereignis-Details',
                elenco: 'Liste',
                entroIl: 'Ereignisse binnen',
                eventi: 'Ereignisse',
                eventiCorrelati: 'Korrelate Ereignisse',
                finePrevista: 'vorausgesehene Ende',
                inPartenzaEntro: 'Touren, die binnen.. Anfangen',
                info: 'Information',
                infoContatti: {
                    cellulare: 'Handy',
                    email: 'Email',
                    facebook: 'Facebook',
                    organizzatoDa: 'Organizierte von',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Telefon ',
                    vaiAlSito: 'Zu der Webseite',
                },
                ingresso: 'Eingang',
                inizio: 'Beginn',
                itinerariCorrelati: 'Reiseroute, die hier durchgehen',
                itinerario: 'Route',
                mappa: 'Karte',
                noEventi: 'kein Ereigniss geplant',
                nomeEvent: 'Ereignisname',
                ospiti: 'Bedeutende Gäste',
                partenze: 'Abfahrten',
                prossimiEventi: 'Nächste Ereignisse',
                prossimiEventiPoi: 'Nächste Ereignisse in diesem Gebiet',
                quando: 'Wann',
                raggioRicerca: 'Suchumkreis ',
                searchAllCat: 'In allen Kategorien suchen',
                selezionaEvento: 'Ein Ereingis auswählen',
                serviziUtili: 'Notwendige Dienste',
                specialitaCorrelate: 'korrelate Produkte',
                tab: {
                    allegati: 'Anlagen',
                    info: 'Auskünfte',
                    mappa: 'Karte',
                },
                vetrina: 'Schaufenster',
                warnTariffe: 'Dieser Preis bezieht sich auf Grundpreise. Bitte überprufen Sie es in de Preisliste',
                when: {
                    '30days': {
                        long: 'Nächste 30 Tage',
                        short: '30 Tage',
                    },
                    '7days': {
                        long: 'Nächste7 Tage',
                        short: '7 Tage',
                    },
                    specifica: 'Ein bestimmter Tag',
                    today: {
                        long: 'Heute',
                        short: 'Heute',
                    },
                    tomorrow: {
                        long: 'Morgen',
                        short: 'Morgen',
                    },
                },
            },
            flussoPagamento: {
                acquistoAbbSosta: 'Ihr Park-Abonnement ist unter "Parken und ZTL - Ermäßigungen" verfügbar.',
                acquistoBigliettoTrasporto: 'Ihre Fahrkarte ist unter "Nahverkehr" verfügbar',
                acquistoRicaricaBorsellino: 'Ihr Guthaben wurde aktualisiert',
                acquistoSatispayAbbSosta:
                    'Sobald die Transaktion von Satispay bestätigt wird, wird Ihr Park-Abonnement unter "Parken und ZTL - Ermäßigungen" verfügbar sein',
                acquistoSatispayBigliettoTrasporto:
                    'Sobald die Transaktion von Satispay bestätigt wird, wird Ihr Abonnement unter "Nahverkehr" verfügbar sein',
                acquistoSatispayRicaricaBorsellino:
                    'Sobald die Transaktion von Satispay bestätigt wird, wird Ihr Guthaben aktualisiert',
                attesaConfermaSatispay: 'In Erwartung von Satispay-Bestätigung',
                attesaTransazioneSatispay: 'Einige Transaktionen benötigen mehr Zeit als vorgesehen',
                confermaPinCode: 'Den Pin-Code bestätigen',
                creditoMyCicero: 'myCicero Guthaben',
                creditoPrecedente: 'Voriges Guthaben',
                errorePagamento: 'Ein Fehler ist währen Bezahlung aufgetreten. ',
                importoAcquisto: 'Betrag',
                messaggioTransazioneFallita:
                    'Es ist ein Fehler aufgetreten. Die Transaktion konnte nicht abgeschlossen werden',
                pagamentoSanzioneEseguito:
                    'Sie werden eine Email bekommen, mit dem Zahlungsbeleg. Sie können die Transaktion in Ihrem Benutzerkonto Liste kontrollieren.',
                pagamentoSkidataEseguito:
                    'Um das Parken zu beenden, bitte lassen die Parkzettel in den Parkometer ein, um die Schranke hochzulassen.',
                pinErrato: 'Falscher Pin-Code',
                richiestaAcquistoSatispayAbbSosta:
                    'Sobald der Einkauf abgeschlossen wird, wird Ihr Park-Abonnement unter "Parken und ZTL - Ermäßigungen" verfügbar sein',
                richiestaAcquistoSatispayBigliettoTrasporto:
                    'Sobald der Einkauf abgeschlossen wird, wird Ihr Abonnement unter "Nahverkehr" verfügbar sein',
                richiestaAcquistoSatispayRicaricaBorsellino:
                    'Sobald der Einkauf abgeschlossen wird, wird Ihr Guthaben aktualisiert',
                saldoAttuale: 'Gegenwärtiges Guthaben',
                scegliAltriMetodi: 'oder wählen',
                scegliCarta: 'Eine Karte wählen',
                scorriPerPagare: 'Zur Bezahlung bitte hinunterrollen',
                transazioneAnnullata: 'Die Transaktion wurde vom Käufer annulliert.',
                transazioneEffettuata: 'Transaktion erfolgreich abgeschlossen ',
                transazioneFallita: 'Transaktion gescheitert',
                usaAltraCarta: 'Mit einer anderen Karte bezahlen…',
                verificaTransazioneSatispay: 'Die Transaktion überprüfen',
            },
            flybus: {
                gtSearch: {
                    soluzioniDiViaggio: 'Reiselösungen</br>',
                },
                homepage: {
                    elencoMovimenti: 'Kontobewegungen</br>',
                    myTickets: 'Meine</br>tickets',
                    ricaricaCredito: 'Guthaben</br>aufladen',
                    soluzioniDiViaggio: 'Reiselösungen</br>',
                    subtitle:
                        '<span class="bold">Kaufen Ihre Reise</span><span style="font-weight: 200"></br>mit dem Bus</br>nach den Dolomiten</span>',
                },
            },
            geocode: {
                fail: 'Erfassen der Position misslungen',
                indirizziTrovati: 'Gefundene Adressen',
                istruzioniChangePositionPageHtml:
                    'Geben Sie eine Adresse, und drücken Sie dann <div class="ui-icon-plus-submit" style="width:16px;height:15px;display:inline-block;"></div>, um Ihre Suche zu beginnen',
                lookForPos: 'Erfassen der Position läuft...',
                noLocalitaTrovata: 'Kein Ort erkannt',
                nodata: {
                    empty: 'kein Ort erkannt',
                },
                posNotAvailable: 'Position nicht verfügbar',
                slowGeocoder: 'Geocoder benötigt zu lange für die Antwort',
            },
            gps: {
                abilitaGpsHtml:
                    'Die Datenschutzeinstellungen verhindern den Zugriff auf die aktuelle Position: Sie können die Einstellungen jederzeit über das Panel</br><a href="#position-page">Optionen> Positionsmanagement</a> ändern',
                addressNotFound: 'Adresse nicht gefunden',
                auto: 'GPS',
                buona: 'Gut',
                cambiaIndirizzo: 'Adresse ändern',
                cambiaPosizione: 'Position ändern',
                discreta: 'Ausreichend',
                eccellente: 'Exzellent',
                enable: 'GPS-Erfassung der Position freigeben',
                errors: {
                    '0': 'Lokalisierungsservice nicht unterstützt',
                    '1': 'Kein Zugriff auf Lokalisierungsservice möglich',
                    '2': 'Momentane Position nicht erfasst',
                    '3': 'Momentane Position nicht erfasst',
                    '4': 'Vorgang abgebrochen',
                    '410': 'http-Fehler',
                    authorizationDenied: 'Die Standortdienste sind nicht zugelassen worden',
                    genericInObliteration:
                        'Ihre Position ist nicht verfügbar, bitte prüfen Sie wenn die Lokalisierung aktiv ist.',
                    hardwareDisabled: 'GPS-Ortung ausgeschlatet',
                    positionUnavailable: 'aktueller Standort nicht vorhanden',
                },
                info:
                    'Die Informationen zur Position werden ausschließlich für die Erbringung präziser und zuverlässiger Dienste verwendet: Der Schutz Ihrer Privatsphäre ist ausgesprochen wichtig für PluService, daher wird Ihre Position niemals ohne Ihre Zustimmung verwendet. Ferner speichert PluService Ihre Position in keiner Form auf den eigenen Servern.',
                infoAttivaGps:
                    'Für die optimale Funktionstüchtigkeit der Anwendung müssen GPS und Positionserfassung übers Netz aktiv sein',
                infoAttivaGpsIphone:
                    'Für die optimale Funktionstüchtigkeit von myCicero sollte die GPS-Erfassung aktiv sein',
                inserisciPosizione: 'Adresse eingeben',
                manuale: 'manuell',
                miaPosizione: 'Meine Position',
                noGps:
                    'Das GPS könnte abgeschaltet oder gesperrt sein oder sich in einer nicht vom Signal abgedeckten Gegend befinden.',
                nuovoIndirizzo: 'Neue Adresse',
                portamiQui: 'Bringen Sie mich hier',
                posAttuale: 'Momentane Position ',
                posNonDisponibile: 'Position nicht verfügbar',
                posRilevata: 'Ihre erfasste Position ist',
                posizioneNonDefinita: 'Momentane Position nicht definiert',
                precisione: 'Präzision',
                rilevaPosizione: 'Position erfassen',
                rilevamentoPosInCorso: 'Positionserfassung...',
                scarsa: 'Mangelhaft',
                searching: 'Anpeilen...',
                segnaleDebole: 'schwaches GPS Signal',
                tuaPosizione: 'Sie befinden sich hier',
            },
            home: {
                all: 'Alle',
                en: 'Englisch',
                gps: 'von GPS',
                it: 'Italienisch',
                manual: 'Adresse',
                manualdialog: {
                    header: 'Adresse',
                    placeholder: 'Adresse eingeben',
                },
                optionsdialog: {
                    header: 'Optionen',
                },
                search: 'In der Nähe suchen',
            },
            iccrea: {
                cambiaZona: 'Zone wechseln',
                homeTitle: 'BCC Club Karte<br />begrüßt Sie in<b>{0}</b>',
                hometitleNoPos: 'BCC Club Karte<br />begrüßt Sie',
                serviziTuttaItalia: 'Unsere Service sind aktive im ganzen Italien',
                tutorial: {
                    subtitle1: 'Die nütztlichste Service um Zeit und Geld zu sparen',
                    subtitle2: 'Nur die echten Parkminuten bezahlen ohne Parkzeituhr',
                    subtitle3: 'Entdecken alle Rabatte und Coupons, die in die Geschäfte um Ihr nutzen können.',
                    subtitle4: 'Kaufen Zug- und Busabonnements und -Fahrkarten durche die app, one Reihen mehr.',
                    subtitle5:
                        'Sie können mit Ihren CartaBCC Akkreditive eintreten, durch den Login in der app MyCartaBCC.',
                    subtitle6:
                        'Der App Geldbeutel mit der CartaBCC oder Satispay aufladen und mit einem Click bezahlen!',
                    title1: 'BCC Karte ist immer an Ihrer Seite!',
                    title2: 'Parkenkosten sparen',
                    title3: 'Günstigkeit des Shoppings mit CartaBCC',
                    title4: 'Es hat nie so einfach gewesen einen Zug oder ein Flugzeug zu nehmen!',
                    title5: 'Die Registrierung ist nicht nötig!',
                    title6: 'Ihre Guthaben aufladen',
                },
            },
            inserimentoPin: {
                placeholder: '5 Zahlen',
            },
            insiel: {
                centralinoUffici: 'Vermittlungsamt Villa Chiozza tel',
                infoPrezziBiglietti: 'Information über den Fahrkartepreis',
                luoghi: 'Orte und Gebiet',
                mobilitaRegione: 'Mobilität in der Region ',
                progetto:
                    'Von der Europäischen Union mit dem POR EFRE 2007-2013 mitfinanziertes Projekt – Aktivität 3.2.b) "Entwicklung fortschrittlicher IT-Dienste für das Tourismussystem"',
                scopriEventi: 'Alle Ereignisse entdecken',
            },
            isosta: {
                abb: {
                    abbonamenti: 'Ermäßigungen',
                    abbonamentiSubTitle: 'Tageskarten und Abonnements',
                    abbonamento: 'Ermäßigung / Abonnement',
                    acquista: 'Kaufen',
                    acquistoAbbonamenti: 'Kauf',
                    attivi: 'Aktive',
                    cambioTargaFail: 'Kennzeichenänderung nicht vorgenommen',
                    cambioTargaSuccess: 'Kennzeichenänderung erfolgreich vorgenommen',
                    campoNonValido: 'Die rot-markierte Felder haben einen ungültigen Wert',
                    campoObbligatorio: 'Die rot-markierte Felder sind obligatorisch',
                    caricaAbbonamentiErroreTesto: 'Error: der Artikel kann nicht geladen werden',
                    caricaAbbonamentiErroreTitolo: 'Der Artikel kann nicht geladen werden ',
                    categoriaAbbonamento: 'Category',
                    confermaAcquistoAbbSovrapposto: 'Möchten Sie jedenfalls den Kauf fertigstellen?',
                    dataFineValidita: 'Bis:',
                    dataInizioValidita: 'Gültig bis:',
                    datiAggiuntivi: 'zusätzliche Daten:',
                    datiIncompleti:
                        'Abonnementdaten unvollständig. Versuchen Sie, das Abonnement erneut aufzurufen. Falls das Problem weiter bestehet, wenden Sie sich bitte an die Servicezentrale.',
                    erroreCambioTargaListaAbb:
                        'Kennzeichenänderung vorgenommen, es ist jedoch nicht möglich, die Abonnements lokal wiederherzustellen. Sie werden zur Hauptseite der Abonnements weitergeleitet.',
                    failAcquistoAbb: 'Abonnementkauf gescheitert! Bitte wenden Sie sich an die Servicezentrale',
                    infoTipologiaNonAcquistabileDaUtente:
                        'Ihr Benutzer verfügt nicht über die erforderlichen Berechtigungen zum Kauf dieser Art von Abonnement.',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Sobald Sie den Einkauf abgeschlossen haben, klicken Sie im Abschnitt " Ermässigungen" und aktualisieren Sie bitte Ihre Liste',
                    noAbbInCorsoDiValidita: 'Keine gültige Abonnements gefunden',
                    noAbbNonAttivi: 'Keine gekauften Abonnements, noch nicht aktiv, gefunden',
                    noAbbScaduti: 'Keine abgelaufenen Abonnements gefunden',
                    noAgevolazioni: 'Sie haben noch keine Abonnemnets',
                    noAgevolazioniZtl: 'Sie haben noch keinen ZTL- Zugangsschein',
                    noZtlInCorsoDiValidita: 'Keine gültige Erlaubnisse gefunden ',
                    noZtlNonAttivi: 'Keine zu aktivierenden Erlaubnisse gefunden',
                    noZtlScaduti: 'Keine abgelaufenen Erlaubnisse gefunden',
                    nonAcquistabile: 'Abonnement nicht erwerbbar',
                    nonAncoraAttivi: 'Erworben aber noch nicht aktiv',
                    oraFineValidita: 'Bis Uhrzeit:',
                    oraInizioValidita: 'Ab Uhrzeit:',
                    ore: 'Uhr',
                    oreMeno: ' - Uhr ',
                    scaduti: 'Abgelaufene',
                    scegliComuneAreaSosta: 'Wählen Sie die Stadt, in der sich die Parkzone befindet',
                    scegliTipoAbbonamento: 'Wählen Sie den Typ...',
                    scegliTitolo: 'Wählen Sie das Ticket',
                    scegliVeicolo: 'Wählen Sie das Fahrzeug',
                    successAcquistoAbb: 'Kauf erfolgreich abgeschlossen!',
                    tipoAbbonamento: 'Typ',
                    tipologiaNonAcquistabileDaUtente:
                        'Dieser Abonnementtyp kann von diesem Benutzer nicht erworben werden.',
                    validitaAbbonamento: 'Gültigkeit',
                    warnAbbSovrapposto: 'Sie haben schon gültige Fharkarten im angegebenen Zeitraum',
                },
                accettoCondizioniTerminiServizio: 'I bin mit <action>den Nutzungsbedingungen einverstanden</action>',
                affinaRicerca: 'Versuchen Sie, eine genauere Adresse einzugeben...',
                attivaServizio: 'Service aktivieren',
                attivaServizioTesto: 'Um zu parken, ist es nöt Fahrzeugdaten einfügen',
                attivazioneAccediPreferenzeAziendaHtml:
                    'Bitte loggen Sie sich in Ihrem Account durch Pc auf der Webseite <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span>, Teil Personenangaben, geben Sie hier die notwendigen Angaben ein, um als Firma oder Freiberufler registriert zu werden und die Rechnung zu bekommen',
                attivazioneAccediPreferenzeAziendaTitle: 'Sind Sie eine Firma oder Freiberufler?',
                attivazioneAccediPreferenzeHtml:
                    'Bitte loggen Sie sich in Ihrem Account durch Pc auf der Webseite <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span> um die Optionen einzustellen (Zahlungsmethode, MeldeSMS , NoCall-SMS-IVR, etc.).',
                attivazioneAccediPreferenzeTitle: 'Optionen einstellen',
                attivazioneCompletata: 'Sie haben das "{0}" aktiviert',
                attivazioneCompletataInfo:
                    'Laden Sie Ihr Guthaben auf, parken Sie Ihr Auto und bezahlen Sie nur die tatsächlichen Parkminuten.<br /><br />Um in den Städten von {0} parken zu können, müssen Sie myCicero Schein ausstellen, den Sie per Email bekommen.',
                attivazioneCompletataInfo1: '<i><b class="underline">Guthaben aufladen</b></i>',
                attivazioneCompletataInfo2: '<i> parken und bezahlen Sie nur die tatsächlichen Parkminuten.</i>',
                attivazionePromemoriaHeader: 'Vergessen nicht den Guthaben aufladen, um zu parken',
                attivazionePromemoriaText: 'Es ist nöt den Guthaben aufladen, um zu parken',
                autoricarica: {
                    erroreCaricamento:
                        'Ein Fehler ist aufgetreten: die Daten konnten nicht geladen werden. Bitte versuchen Sie es erneut später.',
                    erroreSalvataggio:
                        'Ein Fehler ist aufgetreten: die Änderungen wurden nicht gespeichert. Bitte versuchen Sie es erneut später.',
                    infoAutoricarica:
                        'Mit dieser Modalität wird Ihr Guthaben automatisch aufgeladen, wenn es unter den eingestellten Grenze fällt.',
                    labelAttiva: 'Die automatische Aufladung aktivieren',
                    labelCartaDiCreditoNecessaria:
                        'Um diese Bezahlungsmodalität zu benutzen, bitte registrieren Sie eine Kreditkarte',
                    labelDisattiva: 'Die automatische Aufladung deaktivieren',
                    labelProcedi: 'Fortfahren',
                    labelSaldoInferioreA: 'Wenn Ihr Guthaben unter .. Ist',
                    labelTaglioRicarica: 'Aufladen',
                    titolo: 'Automatische Aufladung',
                },
                avvisoInizioSostaDomani:
                    'Wenn Sie Ihre Halt nicht früher anschließen oder verlängern, hört er Morgen um <span class="bold">{0}</span> automatisch auf',
                avvisoInizioSostaIl:
                    'Wenn Sie Ihre Halt nicht früher anschließen oder verlängern, hört er am <span class="bold">{0}</span> um <span class="bold">{1}</span> automatisch auf',
                avvisoInizioSostaOggi:
                    'Wenn Sie Ihre Halt nicht früher anschließen oder verlängern, hört er Heute um <span class="bold">{0}</span> automatisch auf',
                calendar: {
                    aggiungiPromemoria: 'Erinnerungshilfe hinzufügen',
                    askAggiungiPromemoria:
                        'Soll Ihr Smartphone Sie 15 Minuten im Voraus an den Ablauf der Parkzeit erinnern?',
                    nonAggiungere: 'Nicht hinzufügen',
                    procedi: 'Fortfahren',
                    text:
                        'Eine Erinnerungshilfe wird zu Ihrem Terminkalender hinzugefügt. Sie werden 15 Minuten vorher an das Ablaufen der Parkzeit erinnert.',
                    title: 'Erinnerungshilfe hinzufügen?',
                },
                caricaAltrePromozioni: 'Weitere Promotionen laden',
                cercaLocalita: 'Ort suchen',
                codiceStallo: 'Parkplatzkode',
                codiceStalloPlaceholder: 'Parkplatzkode einfügen',
                condizioniServizio: 'Nutzungsbedingungen',
                countdownPagamento: 'Sie haben {0} Sekunden zu bezahlen',
                daConfermareEntro: 'Zu bestätigen nicht später als',
                dettaglioPrenotazione: {
                    annulla: 'Buchung annullieren',
                    cognome: 'Familienname',
                    confermaAnnulla: 'Sind sie sicher die Reservierung abzulöschen?',
                    cosaFare: 'Was sollte Ich machen?',
                    datiAggiuntivi: 'Zusätzliche Angaben',
                    email: 'E-mail',
                    erroreAnnulla: 'Es ist nicht möglich die Reservierung abzulöschen',
                    importo: 'Betrag',
                    importoSosta: 'Parken-Betrag',
                    importoTotale: 'Gesamtsumme bezahlt',
                    indirizzo: 'Adresse',
                    intestazioneInfoPrenotazione: 'Buchungsinformationen',
                    messaggioInformativoSostaAttiva:
                        'Um das Parken zu beenden, bitte gehen Sie in die Garage und fragen Sie danach, Ihr Fahrzeug daraus zu fahren. Sie werden nur die Parkkosten bezahlen, die nach Ihre Eingangszeit und den Parkgebühren berechnet werden.',
                    messaggioInformativoSostaPrenotata:
                        'Um in die Garage einzutreten, bitte die Buchung am Parkbetreiber zeigen. Falls Sie frühr als geplant eintreten oder später für über 4 Stunden (vier), wird der Preis erhöht.',
                    modelloVeicolo: 'Wagenmodell',
                    nome: 'Name',
                    nonSpecificato: 'Nicht spezifiziert',
                    numeroPasseggeri: 'Passagieren',
                    numeroVolo: 'Flugnummer',
                    provenienzaVolo: 'Flug Herkunft',
                    serviziAggiuntivi: 'Zusätzlichen Dienstleistungen',
                    sitoWeb: 'Webseite',
                    targa: 'Autokennzeichen ',
                    telefono: 'Telefonnummer',
                    titolo: 'Buchung',
                },
                disambiguaDescrizione:
                    'Wir haben verschiedene Parkzonen herum Ihre Position gefunden. Bitte wählen Sie die Gegend aus, nach dem Sie die nächste Beschilderung oder Parkometer nachgeschaut haben. ',
                disambiguaHeading: 'Etagenparkent gebiet',
                disambiguaLabel: 'Wählen Sie wo zu parken',
                disambiguaTitolo: 'Etagenparkent gebiet',
                durataSosta: 'Parkdauer:',
                elencoMovimenti: 'Liste Kontobewegungen',
                elencoParcheggi: 'Liste der Parkplätze',
                findMyCar: {
                    aggiungiPosizione: 'Hinzufügen',
                    cancellaPosizione: 'Diese Position löschen',
                    cancellaPosizioneTesto:
                        'Soll diese Position gelöscht werden? Dieser Vorgang kann nicht rückgängig gemacht werden und führt nicht zur Deaktivierung aktiver Parkvorgänge.',
                    cancellaPosizioniTesto:
                        'Sollen die gespeicherten Positionen gelöscht werden? Dieser Vorgang kann nicht rückgängig gemacht werden und führt nicht zur Deaktivierung aktiver Parkvorgänge.',
                    clean: 'Löschen',
                    erroreSalvataggio:
                        'Beim Speichern der Position ist ein Fehler aufgetreten. Versuchen Sie es bitte erneut.',
                    header: 'Meinen Wagen auffinden',
                    inserisciPosizione: 'Adresse eingeben...',
                    nessunaPosizioneSalvata: 'Es sind keine Fahrzeuge geparkt',
                    oppureUsaMappa: 'Oder auf der Karte drücken:',
                    posizione: 'Position',
                    posizioni: 'Positionen',
                    posizioniRecenti: 'Kürzlich',
                    posizioniSalvate: 'Gespeichert Positionen',
                    pulisci: 'Löschen',
                    pulisciPosizioni: 'Positionen löschen',
                    pulisciQuestaPosizione: 'Diese Position löschen',
                    salvaPosizione: 'bestätigen',
                    targaOrDescrizione: 'Kennzeichen oder Beschreibung',
                    whereIsMyCar: 'Wo ist mein Auto?',
                },
                fineSosta: 'Ende Parkzeit ',
                finoA: 'Bis',
                fraBrevePotraiRipetere: 'Sie können in Kürze die Handlung wiederholen...',
                gestioneCarte: {
                    aggiungiCarta: 'Eine Karte hinzufügen',
                    confermaEliminazione: 'Möchten Sie die Kreditkarte, die mit … endet, entfernen?',
                    scaduta: 'fällig',
                    titolo: 'Kreditkarte',
                },
                importoSosta: 'Parkgebühr',
                importoSostaAttuale: 'Derzeitiger Stand Parkgebühr',
                importoSostaPrevisto: 'Voraussichtliche Parkgebühr',
                indirizzoZona: 'Suchen nach dem Weg oder der Parkzone',
                infoMemoComunePreferito:
                    'Falls Sie die markierte Stadt speichern, wird Ihnen diese Stadt empfohlen jedes Mal dass Ihre Position nicht verfügbar ist.',
                infoStalloLabel: 'Wo finde Ich die Stellplatz-Nummer?',
                ingressoAlleOre: 'Eintritt um:',
                inizioSosta: {
                    altreZoneDiSosta: 'Andere Park-Zonen',
                    askRegistraPosizione:
                        'Mithilfe des GPS konnte die genaue Position Ihres Wagens ermittelt werden. Soll sie gespeichert werden, um das Auffinden zu erleichtern?',
                    avvisoDisattivazioneAutomaticaSosta: 'Der Parkvorgang wird automatisch deaktiviert',
                    avvisoTermineSosta: 'das Parken wird enden ',
                    calcoloImporto: 'Betrag berechnen',
                    confermaInizioSosta: 'Parkbeginn bestätigen',
                    finePrevistaMediaHide: 'Voraussichtliches Ende:',
                    finoQuando: 'Wie lange möchten Sie parken?',
                    impossibileCalcolareImporto: 'Fehler: Berechnung des Betrags nicht möglich',
                    infoCoupon: 'Wie funktionert es?',
                    infoCouponNoLogin: 'Haben Sie ein Coupon? Führen Sie das Login durch, um den Kode einzufügen',
                    infoLimiteTariffario: 'In diesem Parkzone darf man nicht über... Uhr parken:',
                    infoPrezzoTariffario: 'Der Tarifbetrag erlaubt jedenfalls zu parken bis:',
                    infoTariffeSu: 'Info und Tarife auf',
                    iniziaSosta: 'Parkbeginn ',
                    inizio: 'Beginn:',
                    noParcheggiRecenti: 'Es sind keine jüngeren Parkvorgänge vorhanden',
                    noParkingsInAddress: 'Für diese Suche sind keine bediente Zone gefunden worden',
                    noParkingsInCity: 'In der selektierten Stadt sind keine Parkzonen vorhanden',
                    noParkingsInCitySeason:
                        'In dieser Stadt sind die Parkgebühren saisonal. Jetzt sind keine Park-zonen vom Service bedient.',
                    parcheggiRecenti: 'Jüngere Parkvorgänge',
                    placeholderCoupon: 'Fügen Sie Ihren Couponkode ein',
                    promozioniIntornoATe: 'Promotionen um Sie',
                    recenti: 'Jüngere',
                    registraPosizione: 'Speicherung der Position',
                    registraPosizioneAuto: 'Speicherung PKW-Position',
                    salvaPosizionePrefix: 'Momentan erfasste GPS-Position speichern',
                    salvaPosizioneShort: 'PKW-Position für diesen Parkvorgang speichern',
                    salvaPosizioneSuffix: 'Als PKW-Position für diesen Parkvorgang',
                    scegliParcheggio: 'Parkplatz Auswählen',
                    scopriCoupon: 'Wollen Sie kostenlos parken? Entdecken Sie wie!',
                    scopriCoupon1: 'Möchten Sie kostenlos parken?',
                    scopriCoupon2: 'Entdecken Sie wie...',
                    success: 'Parkbeginn korrekt registriert',
                },
                inizioSostaAutorimesse: {
                    avviaNavigatore: 'Navigation anfangen',
                    cercaPerNomeIndirizzo: 'Suchen per Adresse oder Name',
                    chiudereSosta:
                        'Um das Parkverfahren zu beenden, einmal im garage, den Ausgang anfordern.<br/>Sie werden nur die Park-Kosten nach der tatsächlichen Eingangszeit und angewandten Gebühren bezahlen.',
                    cittaNonSupportata:
                        'Diese Stadt ist vom Service nicht bedient. Wir haben die nächstgelegene Stadt gewählt.',
                    creditoInsufficiente:
                        'Das Guthaben ist ungenügend. Um den Parkplatz zu aktivieren, laden Sie Ihres Guthaben auf.',
                    dataOraPerPreventivo: 'Die geplante Dauer Ihres Parkverfahrens geht von jetzt bis:',
                    durataEccessiva: 'Betragsvorchlang nich verfügbar für Parkplätze länger als 7 Tage',
                    elencoStrutture: 'Einrichtungenliste',
                    emissioneFattura:
                        'Wenn angefragt, wird die Rechnung von MyCicero ausgestellt. Das Dokument schließt nicht den Betrag dem Autogaragearbeiter gezahlt ein.',
                    finePrevista: 'Park-Ende vorgeschlagt:',
                    importoTotale: 'Gesamtbetrag für diese Dauer:',
                    infoTariffe:
                        'Die im Garage angewandte Gebühr kann nicht nach den tatsächlichen Park-Minuten aufgeteilt werden, nur Vollstunden sind akzeptiert.',
                    iniziaSostaEntroTrentaMin:
                        'Parkplatzbeginnanfrage wird automatisch gelöscht, wenn Sie binnen 30 Minuten in Parkplatz nicht einfahren. Kein Betrag wird belastet. ',
                    inizioSosta: 'Park-Beginn:',
                    inizioSostaRichiesto: 'Parkplatzbeginn richtig angefragt.',
                    noResult: 'Keine Ergebnisse gefunden',
                    parcheggioAlCompleto: 'Parkplatz geschlossen',
                    ricaricaIlBorsellino:
                        'Laden Sie das Guthaben, ob Sie den ganzen Betrag mit MyCicero bezahlen möchten, anders können Sie die Preisdifferenz dem Autogarage Arbeiter zahlen.',
                    richiediInizioSosta: 'Parkplatz-Beginn anfragen',
                    sostaSaraAttivata:
                        'Das Parkverfahren wird aktiviert, wenn der Garage-Betreiber Ihren Eingang überprüfen wird. Die geplannte Dauer ist für den Ausgang nicht verbindlich, Sie können Ihr Parkverfahren früher beenden. Sie werden nur die Park-Kosten nach der tatsächlichen Eingangszeit und angewandten Gebühren bezahlen.',
                    statoSosta: {
                        attiva: 'Parkplatz aktiv',
                        conclusa: 'Parkplatz beendet',
                        inAttesa: 'Termin binnen:',
                    },
                },
                insertCode: {
                    confirmDescription:
                        'Bitte, scannen den Kodex auf der Vorderseite des Zettels durch Ihren Smartphone, um den gebührenden Betrag anzuzeigen',
                    confirmTitle: 'Haben Sie einen Parkzettel von einen Parkaus abgeholt?',
                    description:
                        'Bitte fügen Sie ein den Kodex, der auf der Vorderseite des Zettels, um den gebührenden Betrag zu zahlen',
                    nonMostrarePiu: 'Diese Nachricht nicht mehr anzeigen ',
                    okGoOn: 'Ok, weiter',
                    placeholder: 'Den Zettels Kodex einfügen',
                    title: 'Haben Sie einen Parkzettel von einen Parkaus abgeholt?',
                    verifica: 'Überprüfen',
                },
                laMiaAuto: 'Mein Auto',
                map: {
                    areaNonServitaDaTitle: 'Zone nicht bedient von {0}',
                    areaNonServitaDesc:
                        'Bitte überprüfen Sie auf den vertikalen Straßenbeschilderungen oder auf dem Parkometer, ob die vorgeschlagene Park-Zone gebührenpflichtig ist',
                    areaNonServitaHtml:
                        'Für weitere Informationen, kontaktieren Sie uns bitte unter der Nummer <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> oder <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">über chat</a>',
                    areaNonServitaTitle: 'Zone nicht vom Service bedient',
                    avviaNavigatore: 'Navigator zuleiten',
                    cambiaCitta: 'Stadt wechseln',
                    caricamentoCompletato: 'Ladevorgang beendet!',
                    caricamentoLento: 'Der Ladevorgang dauert lünger als vorhergesehen...',
                    caricamentoMappa: 'Laden der Straßenkarte... ',
                    cercaIndirizzo: 'Suche nach Adresse',
                    disclaimerBtnText: 'Ich habe verstanden',
                    disclaimerText:
                        'Bitte stellen Sie sicher, dass Sie die Position Ihres Auto korrekt angegeben haben',
                    ingrandisciMappa: 'Um den Parkplatz zu finden, bitte das Bild vergrößern',
                    localitaSconosciuta: 'unbekannter Ort ',
                    mappaSosta: 'Parkkarte',
                    noIsostaLayer: 'Die freigegebenen Zonen können nicht wieder hergestellt werden',
                    posizioneAmbiguaTemplateString:
                        'Die momentane Position befindet sich an der überschneidung mehrerer {0} Parkzonen. Wählen Sie die tatsächliche:',
                    postiLiberi: 'Freie Plätze',
                    postoLibero: 'Frei Platz',
                    ricercaHeaderTemplate: 'Suchen in  {0}',
                    ricercaLocalitaInCorso: 'Ort suchen…',
                    ricercaPlaceholder: 'Adresse, Orte, Anziehungspunkte…',
                    scegliPosizione: 'Eine Parkzone berühren...',
                    staiVedendo: 'Derzeit gezeigt:',
                    zonaImprecisa:
                        'Bitte überprüfen Sie auf den vertikalen Straßenbeschilderungen, ob die vorgeschlagene Park-Zone korrekt ist',
                    zonaNonCoperta:
                        'In {0} sind keine Parkzonen vorhanden.<br/>Bei Zweifeln, kontaktieren Sie uns bitte an <a href="tel:+39&nbsp;071&nbsp;9207000">+390719207000</a> oder <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">per Chat</a>',
                    zonaSenzaParcheggi:
                        'Hier sind jetzt keine gebührenpflichtigen Zonen vorhanden. Haben Sie andere Informationen?',
                },
                memorizzaComunePreferito: 'Als übliche Parkstadt markieren',
                minuti: 'Minuten',
                minuto: 'Minute',
                modalitaPagamento: {
                    attivaPagamentoContestuale: 'Aktivieren die Bezahlung nach Konsum ',
                    erroreCaricamento:
                        'Ein Fehler ist aufgetreten: die Daten konnten nicht geladen werden. Bitte versuchen Sie es erneut später.',
                    erroreNessunaCartaDiCredito:
                        'Um die Bezahlung nach Konsum benutzen zu können, bitte eine Kreditkarte registrieren',
                    erroreSalvataggio:
                        'Ein Fehler ist aufgetreten: die Änderungen wurden nicht gespeichert. Bitte versuchen Sie es erneut später.',
                    infoCostiPagamentoContestuale:
                        'Der Parkbetrag wird von der registrierten Kreditkarte abgebucht. Bei dieser Bezahlungsoption, <b>werden € 0,08</b> für jede Transaktion nachberechnet, mit einem Mindestbetrag von € 0,20.',
                    infoCostiPagamentoContestualeActv:
                        'Der Parkbetrag wird von der registrierten Kreditkarte abgebucht.',
                    infoCostiPagamentoContestualeRoger:
                        'Ihres Guthaben, aufladen durch Kredit Karte.. Sie können durch das Guthaben auch die Fahrkarten und alle andere verfügbare Dienste lösen. Die Berechnung des Parkens wird die Karte belasten.',
                    infoCredito:
                        'myCicero-Guthaben mit Kreditkarte oder Satispay, PayPal oder auch in einem SisalPay Geschäft aufladen. <b>Mit dieser Bezahlungsoption haben Sie keine Zusatzkosten.</b> myCicero-Guthaben kann auch benutzt werden, um Fahrschiene/Tickets zu kaufen oder die anderen verfügbaren Dienste zu bezahlen.',
                    infoCreditoACTV:
                        '<b>Diese Zahlungsmethode hat KEINE  Extra-Kosten.</b> Man kann das Guthaben nutzet, um Fahrkarten und andere verfügbare Dienstleistungen zu kaufen.',
                    infoCreditoRoger:
                        'Ihres Guthaben, aufladen durch Kredit Karte. Sie können durch das Guthaben auch die Fahrkarten und alle andere verfügbare Dienste lösen. Die Berechnung des Parkens wird die Karte belasten.',
                    labelCartaDiCreditoNecessaria:
                        'Um diese Bezahlungsmodalität zu benutzen, bitte registrieren Sie eine Kreditkarte',
                    labelCredito: 'Guthaben',
                    labelModalita: 'Um das Parken zu bezahlen, bitte eine der zwei folgenden Optionen wählen:',
                    labelNoCarteRegistrate: 'Keine registrierte Karte gefunden',
                    labelPagamentoContestuale: 'Bezahlung nach Konsum',
                    labelProcedi: 'Fortfahren',
                    labelRegistraCarta: 'Eine Karte registrieren',
                    labelRicarica: 'Aufladen',
                    labelSaldo: 'Guthaben ',
                    labelScegliCartaDiCredito: 'Bitte eine Kreditkarte wählen',
                    labelUtilizzaQuestaCarta: 'Diese registrierte Kreditkarte benutzen:',
                    titolo: 'Wie bezahlen?',
                },
                mostraParcheggi: 'Parkplätze zeigen',
                numeroStallo: 'Parkplatznummer',
                ongoingNotification: {
                    extendButtonLabel: 'Um 30 Minuten verlängern',
                    message: 'bis {0}',
                    stopButtonLabel: 'Beenden',
                    title: '{0} Aktive Parkverfahren ',
                },
                oopsAnnullaSosta: 'Oops! Annullieren Sie Ihren Park.',
                parcheggiGestiti: {
                    avvisoDurataPrenotazione:
                        'Die Buchung wird automatisch gelöscht am Ablauf des ausgewählteten Zeitraumes',
                    avvisoOrarioNonConsentito:
                        'Die Ankunftszeit zum Parkplatz soll zwischen {0} und {1} Uhr, nach den Regelungen der ausgewählten Struktur, eingeschlossen werden.',
                    avvisoSostaNonDisponibile:
                        'Für die gewählten Tagen kann das Parken nicht gebucht werden, bitte versuchen Sie mit anderen Tagen',
                    avvisoTermineSosta: 'Das Service beendet um <span class="bold">{0}</span>.',
                    cantAddService:
                        'Die folgenden gefragten Dienstleistungen konnte nicht einbezogen werden: <ul><% _.forEach(articlesKo, function(article) { %> <li><%- article.descArticolo %></li> <% }); %></ul>',
                    cercaAeroportoLocalita: 'Nach Name oder Stadt suchen',
                    cercaAeroportoTitle: 'Stadt wählen',
                    cercaPlaceholder: 'Nach Name oder Stadt suchen',
                    condizioni:
                        'Ich habe die Datenschutzhinweise gelesen und stimme  <em>mit den Bediengungen zu </em>',
                    confermaConPagamento: 'Buchen und bezahlen Sie jetzt',
                    confermaSenzaPagamento: 'Buchen und bezahlen Sie, wenn Ihre Parkplatz beendet wird',
                    dataInizioSostaNonConsentita: 'Es ist nicht möglich vor dem {0} um {1} das Parken zu reservieren',
                    erroreAggiornamentoPrezzi:
                        'Die Gesamtsumme für die gewählte Tage konnte nicht aktualisiert werden. Bitte versuchen Sie erneut später.',
                    erroreGenericoDisponibilita:
                        'Die Überprüfung zur Parkplatzverfügbarkeit mit dem Parkplatzleiter schlug fehl. Versuchen Sie bitte später oder kontktieren Sie unsere Servicezentrale.',
                    importoPagato: 'Gebühr bezahlt',
                    importoTotaleDurata: 'Gesamtsgebühr für diese Dauer',
                    info: {
                        mail: 'Mail',
                        orarioAp: 'Öffnungszeiten',
                        servizi: 'Einbezogene Dienstleistungen',
                        sitoWeb: 'Webseite',
                        social: 'Social',
                        telefono: 'Telefon',
                        tipo: 'Typologie',
                        tipoPosti: 'Typologie der Plätzen',
                    },
                    infoDesigna:
                        'Zeingen Sie den QR Kodex an der Einfahrtvollautomat auf. Bitte, holen Sie ab den Papierzettel vom Ausfahrtvollautomat. Falls Sie später der gebuchte Periode herauskommen, ist den Papierzettel unentbehrlich um die eventuelle Unterschied auszugeben.  ',
                    infoPrenotazioneEffettuata: 'Das gebuchte Parken ist unter “Parken und ZTL” verfügbar',
                    intestazionePrenotazione: '1 Parkplatz reserviert für das Kennzeichnen',
                    istruzioniDownloadTitoli:
                        'Nach Abschluss Ihres Einkaufes, wird die Buchung im App-bereich "Parken und ZTL" sichtbar sein',
                    menuTitle: 'Parkhäuser',
                    nessunParcheggioRecente: 'Keine jüngsten Parken gefunden.',
                    nessunRisultato: 'Keine Ergebnisse für diese Suche gefunden',
                    parkAvail: 'Der Parkplatz ist frei.',
                    parkNotAvail: 'Für den gewählte Tagen ist der Parkplatz voll.',
                    placeholderRicercaTestuale: 'Nach Name suchen',
                    postiNonPrenotabili: '{0} abkömmliche Parkplätze',
                    postiNonPrenotabiliEsauriti: 'Keine abkömmlichen Parkplätze ',
                    prenota: 'Buchen',
                    prenotaParcheggio: 'Buchen Sie Ihren Parkplatz',
                    prenotazioneSosta: 'Buchen Ihren Parkplatz',
                    richiediDisponibilita: 'Verfügbarkeitsanfrage',
                    scegliParcheggioTitle: 'Parkplatz wählen',
                    tabCondizioni: 'Bediengungen',
                    tabElenco: 'Liste',
                    tabInfo: 'Info',
                    tabMappa: 'Karte',
                    tabRecenti: 'Jüngste',
                    tabTariffe: 'Gebühren',
                    titleConferma: 'Das Parken buchen',
                    titleConfermata: 'Buchung bestätigt',
                    titleDettaglio: 'Details',
                    titlePrenota: 'Das Parken buchen',
                    tutteLeAree: 'Alle Städte',
                    vaiAllaPrenotazione: 'Zu Ihrer Buchung',
                    verificaDisponibilita: 'Die Verfügbarkeit überprüfen',
                    verificaDisponibilitaInCorso: 'Wir kontaktieren den Parkplatzleiter',
                    visualizzaPrenotazione: 'Buchung anschauen',
                },
                parcheggio: 'Parken ',
                posizioneNonDisponibile: 'Ihre Position kann nicht festgestellt werden',
                preferenzeSosta: {
                    categorieAgevolate: 'erleichterte Gattungen',
                    disclaimerCategorieSosta:
                        'Der Benutzer die Verantwortung der Erklärung übernimmt, aufgrund der Rechtsvortschriften.',
                    erroreSalvataggio:
                        'Ein Fehler ist aufgetreten: die Änderungen wurden nicht gespeichert. Bitte versuchen Sie es erneut später.',
                    etichettaDurataDueOre: '120 Minuten',
                    etichettaDurataFineGiornata: 'Ende des Tages',
                    etichettaDurataQuattroOre: '240 Minuten',
                    etichettaDurataUnOra: '60 Minuten',
                    infoAreaNotifiche: 'Mit einem Klick im Benachrichtigungsbereich das Park verlängern oder enden ',
                    infoCategorieUtente:
                        'In einigen Städten gibt es erleichterte Tarife für besonderen Gattungen. Falls Sie zu einer dieser Gattungen gehören, bitte aktivieren die entsprechende Menüoption um Ihren Gebührensatz zu genießen.',
                    infoCittaAbituale:
                        'Diese Stadt wird automatisch ausgewählt, wenn Ihre Position durch GPS nich verfügbar ist',
                    infoDurataSosta:
                        'Die aufgegebene Minuten werden am Parkaktivierung benutzt um die vorgesehene Dauer vorzuschlagen.<br/>Bis Tagsende oder Guthabenserschöpfung falls nicht möglich ist bis zum Tagsende bezahlen.',
                    infoNotificheSms:
                        'Die Servicekosten für jede SMS betragen € 0,08 <br/>. Wenn der Parkplatz durch SMS begonnen und beendet wird, werden SMS-Benachrichtigungen immer gesendet und können nicht deaktiviert werden ',
                    labelAreaNotifiche: 'Benachrichtigungsbereich Integration',
                    labelAttiva: 'Aktivieren',
                    labelCittaAbituale: 'übliche Stadt',
                    labelDurataSosta: 'vorgeschlagene Parkdauer:',
                    labelInLista: 'In der Liste',
                    labelInMappa: 'Auf der Karte ',
                    labelNotificheSms: 'Benachrichtigungs dsurch SMS',
                    labelScegli: 'Wählen',
                    labelSmsFineSosta: 'Parkbeginn bestätigen',
                    labelSmsInizioSosta: 'Parkende bestätigen',
                    labelVisualizzazioneCercaParcheggio: 'Während Parksuche veranschauen lieber',
                    mieCategorie: 'Meine Gattungen',
                    titolo: 'Parkplatzoptionen',
                },
                prenotazioneDal: 'Buchung von',
                procedi: 'Fortfahren',
                prolunga: 'verlängern',
                prolungaSosta: 'Parkzeit verlängern',
                prolungaSostaFail: 'Parkzeit kann nicht verlängert werden',
                prolungaSostaSuccess: 'Parkzeitverlängerung korrekt registriert',
                qrCode: {
                    accediEntroLeOre: 'Treten Sie ein binnen',
                    accediPagaAllUscita: 'Wollen Sie jetzt im Parken eintreten und an der Ausfahrt bezahlen?',
                    entraNelParcheggio: 'Im Parken eintreten',
                    erroreGenerazioneQrCode: 'Ein Fehler ist durch die Generierung des Qr Codes aufgetreten',
                    esciDalParcheggio: 'Aus dem Parken aus treten',
                    esciDalParcheggioScansionaQrCode:
                        'Fahren Sie nach der Ausfahrt des Parkens und den QR Code auf der Schranke scannen  ',
                    infoIngressoQrCode:
                        "<span class='bold'>Scannen</span> den <span class='bold'>QR Code</span> durch die Einfahrt Automat und holen das Ticket ab. Erinnern Sie sich, dass Sie<span class='bold'>15 Minuten</span> haben um in den Parken einzufahren.",
                    infoPagamentoClassico:
                        'Als Alternative können Sie bezahlen mit dem Ticket in der Automatladenkasse des Parkens.',
                    infoUscitaQrCode:
                        "<span class='bold'>Bezahlen Sie durch die App</span> beim klicken <span class='bold'>Parken aktiv</span>.</br><span class='bold'>Scannen den  QR Code</span> durch den Automat.",
                    ingressoEffettuatoAlleOre: 'Einfahrt um:',
                    nuovoQrCode: 'Neuer Qr Code',
                    pagamentoClassico: 'klassiche Zahlung',
                    perEntrare: 'Um einzufahren',
                    perUscire: 'Um auszufahren',
                    qrCodeScaduto: 'Ihrer QR Code ist abgelaufen, fragen Sie eine neuen an!',
                    tornaAllaSosta: 'Zurück zum Parken',
                    visualizzaQrCode: 'Den QR Code anzeigen',
                },
                reminderUscita:
                    'Erinnern Sie sich, das Sie 15 Minuten nach der Zahlung haben, um aus den Parken auszufahren.',
                ricaricaCredito: 'Guthaben aufladen',
                ricaricaCreditoAssociaCarta: 'Guthaben aufladen oder Karte zuordnen...',
                rifSosta: 'Park-Verfahren-Bezugsnummer',
                salvaPosizione: 'Position speichern',
                scegliArea: 'Parkzone auswählen',
                scegliCitta: 'Eine Stadt wählen',
                selezionaComune: 'Gemeinde auswählen',
                selezionaFineSosta: 'Voraussichtliches Ende der Parkzeit Wählen',
                servizioNonAttivo:
                    'Sie haben noch nicht das Service "Parken und ZTL" aktiviert. Sie brauchen nur einige Minuten.',
                skidata: {
                    activateIn: 'Sie müssen den Fahrschein bis .. aktivieren: ',
                    bsb: 'Kurz-parken Fahrschein ',
                    cassaAutomatica: 'Automatische Kasse',
                    disambiguaStruttura: 'Die Park-Zone auswählen',
                    emissioneFattura:
                        'Wenn gefragt, enthält die Rechnung, die von MyCicero erstellt wird, nicht den Betrag, der dem Garage-Betreiber bezahlt wird. Die Rechnung bezieht sich nur auf den Betrag, der durch myCicero bezahlt wird.',
                    expiredTicket: 'Der generierte Fahrschein ist abgelaufen.',
                    garage: 'Garage: ',
                    generationOk: 'Fahrschein korrekt generiert',
                    goToHome: 'Zurück zur Homepage',
                    infoStruttura:
                        'Das Parkverfahren wird aktiviert, wenn der QR Kode wird benutzt, um die automatische Schrankenanlage aufzuheben. Sie werden nur die Park-Kosten nach der tatsächlichen Eingangszeit und angewandten Gebühren bezahlen.',
                    labelHour: 'Stunde',
                    labelHours: 'Stunden',
                    labelMinute: 'Min',
                    labelMinutes: 'Min',
                    labelSecond: 'sek',
                    labelSeconds: 'sek',
                    pagamentoOk: 'Bezahlung erfolgreich getätigt',
                    pagamentoOkDescHtmlTemplate:
                        'Die Bezahlung des Parkverfahrens <span class="bold">{0}</span> wurde erfolgreich vervollständigt.',
                    parcheggiInStruttura: 'überdachte Parkzone ',
                    remainingTime: 'Verbleibende Zeit:',
                    scansioneBiglietto: 'Scannen der Eintrittskarte',
                    statusActive: 'Aktiver Parkvorgang',
                    statusExpired: 'Abgelaufene Fahrscheine ',
                    statusGenerated: 'Das Parkvefahren bis... aktivieren:',
                    statusPaid: 'Aus der Garage bis.. Ausgehen:',
                    subscription: 'Abonnements',
                },
                sosta: 'Parken',
                sostaAPagamento: 'Parken in der blauen Zone',
                sostaAutorimesse: 'Garage',
                sostaFinoA: 'Parken bis ',
                sostaValidaFinoA: 'Parken aktiv bis',
                sosteAttive: 'Aktive Parkvorgänge',
                sosteParcheggi: 'Parken und ZTL',
                sostePrenotate: 'Buchungen',
                stallo: 'Stellplatznummer:',
                stalloMancante: 'Bitte die Stellplatz-Nummer eingeben',
                stalloNonValido: 'Falsche Stellplatz-Nummer',
                stalloTargaUsataDiRecente: 'Kürzlich haben Sie das Parken für dieses Auto bezahlen ',
                stalloUsatoDiRecente: '',
                stalloX: 'Stellplatznummer {0} ',
                talloncinoInviatoInfo: 'Das Logo für dieses Auto wurde an Ihrer Email-Adresse gesendet.',
                targhe: {
                    aggiungi: 'Kennzeichen einfügen',
                    attr: {
                        disponibile: 'Verfügbar',
                        occasionale: 'Frei',
                        occupata: 'Benutzt',
                        principale: 'Haupt',
                        secondaria: 'Sekundäres',
                    },
                    cambiaTarga: 'Kennzeichen ändern',
                    conferma: 'Bestätigen',
                    confermaFormatoTarga:
                        'Das eingegebene Autokennzeichen hat ein nicht-standard Format. Möchten Sie au jeden Fall weitergehen?',
                    confermaIvioTalloncino: 'Operation vervollständigt',
                    confermaRimozioneTarga: 'Möchten Sie dieses Fahrzeugkennzeichen entfernen?',
                    descrizioneBreve: 'Autobeschreibung/ -Name ',
                    erroreComuniTalloncino: 'Ein Fehler ist aufgetreten. Die Stadtliste konnte nicht gezeigt werden.',
                    impossibileCambiareTarga: 'Kennzeichenänderung nicht möglich',
                    inUso: 'wird gerade verwendet',
                    infoCancellazioneTargaPrincipale: 'Das Hauptkennzeichen kann nicht entfernt werden',
                    infoTalloncino: 'Sie werden eine Email bekommen, wo das Logo ist, das in … zu zeigen ist',
                    infoTalloncinoCitta: 'einige Städte.',
                    infoTalloncinoObbligatorioParte1: 'An der Adresse',
                    infoTalloncinoObbligatorioParte2:
                        'wird eine Email mit dem Logo gesendet, das in den folgenden Städten obligatorisch zu zeigen ist:',
                    infoTargaPrincipale1:
                        'Das <span class="bold">Hauptkennzeichnen</span>wird für jeden Parkbeginn automatisch vorgeschlagt.',
                    infoTargaPrincipale2: 'Außerdem wird es benutzt zum SMS- und NoCallservice.',
                    infoTargaPrincipaleInUso:
                        'Das gegenwärtige Hauptkennzeichnen ist jetzt angewandt, deswegen können Sie nicht ein anderes Kennzeichnen als hauptsächlich bringen',
                    infoTargaPrincipaleInUsoHeader: 'Hauptkennzeichnen angewandt',
                    infoTargaPrincipaleOwn:
                        'Das ist das <span class="bold">Hauptkennseichnen</span>.<br/>das wird für jeden Parkbeginn automatisch vorgeschlagt. Außerdem wird es benutzt zum SMS- und NoCallservice.',
                    inserisciDatiTarga: 'Um zu parken ist es not die Anlage eines Fahrzeuges einzufügen:',
                    inserisciTargaOccasionale: 'Bitte geben Sie das Kennzeichen für diesen Parkvorgang ein:',
                    inviaTalloncino: 'Das QrCode Logo schicken ',
                    limiteRaggiunto: 'Die maximale erlaubte Anzahl von registrierten Autos ist erreicht worden',
                    memorizza: 'Speichern',
                    'memorizza e scegli': 'Speichern und wählen',
                    modificaTarga: 'Autokennzeichen ändern',
                    nessunaTargaRegistrata: 'Kein Fahrzeug registriert',
                    noCallInfoTarga: 'Für den Service "No Call/SMS" wird immer dieses Kennzeichen verwendet.',
                    nuova: 'Neues Auto',
                    propostaDefault: 'Standardangebot',
                    registraneUna: 'Eines registrieren',
                    registrazionePrimaTargaOk: 'Sie haben ein Autokennzeichen registriert',
                    registrazioneTargaKo: 'Bei der Fahrzeugsregistrierung ist ein Fehler aufgetreten',
                    registrazioneTargaOk:
                        'Auto erfolgreich registriert.<br/>Der QrCode für dieses Auto wurde an Ihre E-Mail-Adresse gesandt<br/>{0}',
                    rendiTargaPrincipale: 'Als Hauptkennzeichnen machen',
                    rendiTargaPrincipaleKo: 'Es ist nicht möglich dieses als Hauptkennzeichnen zu machen.',
                    rimozioneTargaKo: 'Fehler während Löschung des Kennzeichenens',
                    rimozioneTargaOk: 'Kennzeichnen richtig gelöscht',
                    rimuovi: 'Kennzeichenen löschen',
                    rules: {
                        accettaCondizioni: 'Sie müssen den Nutzungsbedingungen zustimmen ',
                        troppoCorta: 'Das Kennzeichen sollte von mehr als 3 Schriftzeichen bestehen',
                    },
                    salvaInviaTalloncino: 'Speichern und QrCode schicken',
                    scegliTarga: 'Eines der zugeordneten Kennzeichen Wählen, um den Parkvorgang zu beginnen.',
                    scegliTargaShort: 'Persönlich',
                    targaNonValida: 'Ungültige Kennzeichen',
                    targaOccasionale: 'Gelegentlich verwendetes Kennzeichen',
                    targaPrincipale: 'Hauptkennzeichen',
                    targaSecondaria: 'Zweitkennzeichen',
                    targaVeicolo: 'Nummernschild',
                    targheRegistrate: 'Registrierte Fahrzeuge',
                    targheSosta: 'Kennzeichen der Fahrzeugen',
                    targheSostaRegistra: 'Ein Autokennzeichen registrieren',
                    troppeTarghe: 'Achtung! Es können nicht mehr als 2 Kennzeichen verwaltet werden!',
                },
                termina: 'Ende ',
                terminaSosta: 'Ende Parkvorgang',
                terminaSostaPrefix: 'Der Parkvorgang wird gerade beendet',
                terminaSostaSuccess: 'Ende Parkvorgang korrekt registriert',
                terminaSostaSuffix: 'Minuten vor dem voraussichtlichen Ende',
                termineBreve: 'Das Parken wird bald enden',
                termineSpecifico: 'Ihr Park wird am {0} um {1} beenden',
                trovaLaMiaAuto: 'Mein Auto finden',
                ultimi30MovFinoAlGiorno: 'Letzte 30 Kontobewegungen bis zum Datum',
                usaMyCicero: 'MyCicero benutzen',
                uscitaAlleOre: 'Ausfahrt um:',
                validaFinoA: 'Gültig bis',
                ztl: {
                    label: 'Zufahrtserlaubnis für gesperrte Stadtgebiete (ZTL)',
                    subtitle: 'Verkehrsbeschränkte Zonen (ZTL)',
                },
            },
            lardini: {
                aggiornamentoRisultatiInCorso: 'Ergebnis update',
                catalogoBuoni: 'Gutscheinekatalog',
                classifica: 'Rankliste',
                infoGiornataCampionato: '{0}° Tag - {1}',
                inizioAlle: 'Beginn um: {0}',
                livescore: 'Livescore',
                mondoLardiniFilottrano: 'Die Welt von Lardini Filottrano',
                parcheggiaCon: 'Parken mit',
                partiteDel: 'Spielen am {0}',
                partiteLive: 'LIVE Spiele',
                rilasciaPerAggiornare: 'Loslassen um die Ergebnisse zu aktualisieren',
                scopriNovita: 'Erfahren Sie Neuigkeiten',
                scorriVersoIlBassoPerAggiornare: 'Scrollen bis',
                sponsor: 'Sponsor',
                tableClassifica: {
                    labelSquadre: 'Mannschaften',
                    partiteGiocate: 'Totale Spielrunde',
                    partiteGiocateShort: 'TS',
                    partitePerse: 'Verspielte Spielrunde',
                    partitePerseShort: 'VS',
                    partiteVinte: 'Gewonnene Spielrunde',
                    partiteVinteShort: 'GS',
                    punti: 'Punkte',
                    puntiShort: 'PT',
                    setPersi: 'Verspielte Sets',
                    setPersiShort: 'VS',
                    setVinti: 'Gewonnene Sets',
                    setVintiShort: 'GS',
                },
                viaggiaCon: 'Reisen mit',
                visualizzaParzialiSet: 'Bedingte Sets anzeigen',
            },
            lecceclick: {
                bagniPubblici: 'öffentliche Toiletten',
                colonnineAutoEnel: 'Enel Aufladestellen für Elektroautos',
                defibrillatori: 'Defibrillator',
                esperienze: 'Erfahrungen',
                fontanelleAcquaPotabile: 'trinkbares Wasser',
                giochi: 'Spiele',
                gioco: '',
                infoProgettoEuropeo:
                    'Projekt finanziert von der Europäische Union auf P.O.R. Puglia 2014-2020, EFRE Fond, Maßnahme 2.2',
                itinerari: 'Reiserouten',
                parcheggiPubbliciPrivati: 'Öffentliche und private Parkplätze',
                runninCity: "Runnin'City",
                servizi: 'Service',
                wifiHotspot: 'Wifi hotspot',
            },
            media: {
                acquisisciImmagine: 'Ein Foto machen',
                fotocamera: 'Kamera ',
                gallery: 'Gespeicherte Bilder',
                importaGallery: 'Ein gespeichertes Bild importieren',
                scattaFoto: 'Ein Foto machen',
                sceltaFotoGallery: 'Möchten Sie ein Foto machen oder aus Ihren gespeicherten Bilder importieren?',
            },
            mobilita: {
                acquistaDiNuovo: 'Erneut kaufen',
                acquistiRecenti: 'jüngste Einkäufe',
                biglietteria: 'Fahrkartenschalter',
                cercaFermata: 'Haltestelle suchen',
                cercaIndirizzo: 'Nach Adresse suchen ',
                cercaLinea: 'Linie suchen',
                cercaPerCodice: 'Suchen per Kode',
                cercaPerCodiceOrDescrizioneFermata: 'Suchen per Kode oder Beschreibung',
                cercaPerCodiceOrDescrizioneLinea: 'Suchen per Kode oder Beschreibung',
                cercaPerFermata: 'Suchen per Kode',
                cercaPerNumero: 'Suchen per Nummer',
                cercaPerStazione: 'Suchen per Bahnhof',
                cercaStazione: 'Station suchen',
                cercaTreno: 'Zug suchen',
                cittaOrLocalita: 'Stadt oder Örtlichkeit',
                codiceDescrizioneFermata: 'Haltenskode / -Beschreibung ',
                codiceDescrizioneLinea: 'Linienkode / -Beschreibung ',
                codiceFermata: 'Oder Haltestellenkode',
                codiceLinea: 'Oder Linienkode',
                codiceOrDescrizioneFermata: 'Haltestellekode oder Beschreibung',
                codiceOrDescrizioneLinea: 'Linienkode oder Beschreibung',
                deleteAllConfirmMsg:
                    'Wenn Sie bestätigen, ALLE abgelaufen "{0}" Fahrkarten werden von Ihrem Apparat gelöscht.',
                deleteConfirmMsg: 'Wenn Sie bestätigen, die Fahrkarte wird von Ihrem Apparat gelöscht.',
                dettaglioFermata: 'Haltestellen Detailen',
                fermate: 'Haltestelle',
                fermateIntorno: 'Haltestellen ringsherum',
                fermatePreferite: 'Lieblienshaltestellen',
                header: 'Mobilität',
                inserisciIDati: 'Fügen Sie die gefordert Datein ein, um weiterzugehen',
                intornoA: 'Ringsherum',
                intornoAllIndirizzo: 'Bei dem Adresse',
                linea: 'Linie',
                linee: 'Linien',
                lineePreferite: 'Lieblienslinien',
                lineeServite: 'Gediente Linien',
                mieiTitoli: 'Meine Fahrkarten',
                navette: 'Pendelfahrzeuge',
                needToLogin: 'umm eingekauften Karte zu zeigen',
                nessunRisultato: 'Keine Ergebnisse für diese Suche gefunden',
                nessunaSoluzione: 'Keine Lösungen',
                noTitoliAttiviScaduti: 'Es gibt keine Tickets zu aktivieren oder die schon benutzt worden sind',
                numeroOrCodiceTreno: 'Augnummer oder -Kode',
                numeroTreno: 'Zugnummer',
                ogniXminuti: 'Jede {0} Minuten',
                orariAlleFermateLinee: 'Fahrplan an den Haltestellen und Linien ',
                parlaConNoi: 'Mit uns sprechen',
                popolari: 'Die Beliebtesten',
                reti: 'Netze',
                scegliPercorso: 'Route wählen',
                searchingTickets: 'Ich suche gekaufte Karte',
                stazione: 'Station',
                stazioni: 'Stationen',
                stazioniIntorno: 'Bahnhöfe im Umkreis',
                stazioniPreferite: 'Liebliensstationen',
                tabelloneOrari: 'Stundenplantafel',
                titoliAttivi: 'Aktive Karten',
                trattaXdiY: 'Strecke {0} von {1}',
                treni: 'Züge',
                tuttiPassaggi: 'Alle Durchgänge',
            },
            momup: {
                AcquistaBiglietti: 'Fahrkarten kaufen',
                CalcolaPercorso: 'Fahrstrecke planen',
                Eventi: 'Ereignisse',
                FermateOrari: 'Haltestelle und Fahrpläne',
                Luoghi: 'Orte',
                MieiTitoli: 'Meine Fahrkarten',
                abilitaNfc: 'Aktivieren Sie die NFC in der Einstellung des Smatphone, um die NFC card zu lesen',
                letturaTessera: 'Karte lesen',
                letturaTitoli: 'Fahrkarten lesen',
                navette: 'Treviso AirBus - Touristische Tickets',
                nfc: {
                    arrival: 'Ort',
                    article: 'Artikel',
                    contract: 'Vertrag',
                    dataOraFineValidita: 'Endgültigkeit Datum',
                    dataOraValidazione: 'Validierung Uhrzeit und Datum',
                    departure: 'Abfahrtsort',
                    endDate: 'Gültigkeitsende',
                    fermata: 'Haltestelle',
                    linea: 'Linie',
                    residuals: 'Verbleibende Fahrten',
                    startDate: 'Gültigkeitsbeginn',
                    vediValidazioni: 'Validierungen schauen',
                },
                scansiona: 'Scannen',
                scansioneFallita: 'Scannen Fehler',
                scopriAltreApp: 'Entdecken Mom welt',
            },
            mp: {
                archeologia: 'Archelogie',
                arteStoria: 'Kunst & Geschichte',
                bikeTrekking: 'Bike & Trekking',
                cominciaViaggio: 'Die Reise beginnt…',
                contattaci: 'Kontaktieren uns',
                culturaTradizione: 'Kultur & Tradition',
                eccellenze: 'Exzellenzen',
                esperienze: 'Erfahrung ',
                eventi: 'Ereingnisse',
                facebook: 'Folgen uns an FB',
                instagram: 'Instagram',
                itinerari: 'Reiseroute',
                luoghi: 'Orte',
                mail: 'Kontakte',
                naturaScienza: 'Natur & Wissenschaft',
                ospitalita: 'Gastfreundschaft',
                prodotti: 'Produkte',
                scegliMuseo: 'Wählen Ihre Museum…',
                sosta: 'Parken',
                trasporto: 'Transport',
                youtube: 'YouTube',
            },
            mycicero: {
                biglietteria: {
                    header: 'Fahrkartenausgabe',
                },
                changePosition: {
                    header: 'Stadt suchen',
                    inputPlaceholder: 'Stadt suchen',
                    noResults: 'Suchen die Stadt und entdecken alle myCicero Dienste',
                },
                home: {
                    descrizioneSosta: 'Blaue streife, Parkplätze, ztl',
                    descrizioneViaggia: 'Züge, Busse, U-Bahn, Schiff',
                    highlightTitle: 'in Evidenz',
                    titoloSosta: 'Parken',
                    titoloViaggia: 'Reisen',
                },
                viaggia: {
                    abbonamenti: 'Abonnements',
                    abbonamentiExt: 'Abonnements',
                    acquistoOd: 'Kaufen von Reiselösungen',
                    acquistoOdTessera: 'Tarif suchen',
                    acquistoSMS: 'Kaufen durch SMS',
                    bigliettiSuPrenotazione: 'Fahrkarten mit Reservierung',
                    header: 'Reisen',
                    multiacquisto: 'Reisedienst',
                    tariffaFissa: 'Fahrkarten mit fester Tarif',
                },
            },
            mytrasfer: {
                acquistaBiglietti: 'Fahrkarten kaufen',
                calcolaPercorso: 'Reiseroute rechnen',
                fermateOrari: 'Haltestellen und Zeitpläne',
            },
            navette: {
                allResults: 'Alle Ergebnisse',
                anErrorOccurredRetry: 'Ein Fehler ist aufgetreten. <b>versuchen Sie wieder</b>',
                busAndStops: 'Busse und Haltestelle',
                cercaPlaceHolder: 'Per Name Suchen',
                cosaVedere: 'Was zu sehen',
                detinazione: 'Richtung',
                durata: 'Dauer',
                emptyPoiList: 'Keine Ergebnisse',
                infoArrivoPrevistoNonDisponibili: 'Keine Vorbeifahrenauskünfte verfügbar',
                infoDirezioneNonDisponibili: 'Keine Richtungsauskünfte verfügbar',
                infoNomeFermataNonDisponibile: 'Keine Haltestellename verfügbar',
                infoNonDisponibili: 'Weitere Auskünfte sind nicht verfügbar',
                informazioni: 'Auskünfte',
                kmTotali: 'Gesamtkilometern',
                navettaDaEPer: 'Pendelfahrzeugen AUS und NACH:',
                searchByNameOrLocation: 'Suchen per Name oder Ort',
                serviziTuristici: 'Touristische Einrichtungen',
                social: 'Social',
                tab: {
                    agenda: 'Agenda',
                    condizioni: 'Bedingungen',
                    dettagli: 'Details',
                    info: 'Auskünfte',
                    itinerario: 'Fahrweg',
                    mappa: 'Karte',
                    orari: 'Uhrzeite',
                    partenzeArrivi: 'Abfahrt und Ankünfte',
                    tappe: 'Etappen',
                },
                tappe: 'Etappen',
                telefono: 'Telefon',
                'title-elenco': 'Pendelfahrzeuge',
                titleMenu: 'Pendelfahrzeuge',
                updatingData: 'Pendelfahrzeuge',
                web: 'Web',
            },
            notification: {
                connectionErrorHeader: 'Verbindung nicht verfügbar',
                connectionErrorMessage:
                    'Keine Verbindung zum Server: bitte prüfen Sie die Daten Verbindung und versuchen Sie wieder.',
                errorGeneric: 'Der Vorgang konnte nicht abgeschlossen werden. Es ist ein Fehler aufgetreten.',
                noConnection: 'Verbindung nicht verfügbar.',
                offline: 'Offline',
                successGeneric: 'Aktualisierung',
                successGenericHeader: 'Erfolg',
                templateBorsellinoSosta: 'Guthaben: &euro; {0}',
                templateContactUs: 'Kontaktieren Sie uns...',
                templateCreditoNonDisponibile: 'Fehler bei der Neuberechnung des Guthabens',
                templateRicalcoloCredito: 'Neuberechnung des Guthabens läuft ...',
            },
            notify: {
                header: 'Achtung',
                questionAreaTariffabile:
                    'Sind Sie der Ansicht, dass diese Zone zu einem gebührenpflichtigen Gebiet gehört?',
                segnalaAnomalie: 'Störung signalisieren',
            },
            plusPayment: {
                cambiaMetodo: 'Andere Methoden',
                confermaInizioSosta: 'Parkbeginn bestätigen',
                effettuaLogin: 'Eiloggen',
                erroreAggiornamentoMetodiDiPagamento:
                    'Ihre Bezahlungsmodalitäten wurden nicht aktualisiert. Bitte überprüfen Sie die Internetverbindung und versuchen es erneut.',
                erroreAggiornamentoSaldoBorsellino:
                    'Ihr Guthaben wurde nicht aktualisiert. Bitte überprüfen Sie die Internetverbindung und versuchen es erneut.',
                erroreAggiornamentoSaldoBorsellinoParent:
                    'Ihr {0} Guthaben wurde nicht aktualisiert. Bitte überprüfen Sie die Internetverbindung und versuchen es erneut.',
                ilTuoProfilo: 'Ihres Benutzerkonto',
                modalitaPagamentoNonSupportata: 'Diese Modalität kann für diese Bezahlung nicht benutzt werden.',
                nessunMetodoAlternativo: 'Keine alternative Bezahlungsmodalität verfügbar',
                paga: 'Bazahlen',
                pagaConBorsellinoParent: 'Bezahlen mit {0}',
                pagaConCartaDiCredito: 'Registrierte Karte',
                profiloPagamento: 'Zahlungsprofil von </br>',
                ricaricaCreditoMyCicero: 'Das Guthaben aufladen',
                usaCreditoMyCicero: 'Mit dem Guthaben bezahlen',
                usaIlCredito: 'myCicero Guthaben aufladen, es ist günstiger!',
                usaIlCreditoBranded: 'myCicero Guthaben aufladen',
            },
            poi: {
                apriMacrocategoria: 'Eine Makrokategorie benutzen',
                categoria: 'Kategorie',
                categorie: 'Kategorien',
                categorieSelezionate: 'markierte Kategorien',
                contatti: {
                    email: 'Email',
                    fax: 'Fax',
                    header: 'Kontakte',
                    tel: 'Tel',
                    url: 'Webseite',
                },
                deselezionaTutto: 'Keine',
                dettaglio: 'Ort',
                elenco: 'Liste',
                espositori: 'Aussteller',
                eventi: 'Ereignisse',
                eventiCorrelati: 'Korrelate Ereignisse',
                header: 'Anziehungspunkte',
                info: 'Informationen und Kontakte',
                infoContatti: {
                    cellulare: 'Handynummer',
                    email: 'Email',
                    facebook: 'Facebook',
                    gestione: 'Führung',
                    sitoWeb: 'Web',
                    social: 'Social',
                    telefono: 'Telefon',
                    vaiAlSito: 'Zu der Webseite',
                },
                istruzioniNoCategorie: 'eine Kategorie wählen',
                itinerariCorrelati: 'Reiseroute, die hier durchgehen',
                loadMore: 'andere Anziehungspunkte suchen',
                luoghiCorrelati: 'Korrelate Orte',
                macrocategorie: 'Makrokategorien',
                mappa: 'Karte',
                nessunPoiTrovato: 'Für deinen Suchbegriff wurden keine Ergebnisse gefunden',
                ospiti: 'Bedeutende Gäste',
                placeholderRicerca: 'Suchen...',
                posizioneNonCoperta: 'Ihre Lage ist vom Service nicht bedient',
                promozioni: {
                    promoPerTe: 'Besondere Angebote für Sie',
                    promoPerTutti: 'Für alle Benutzer verfügbar ',
                },
                ricercaInfoTerritorio: 'Für welches Gebiet suchen Informationen?',
                ricercaTutteCategorie: 'In allen Kategorien suchen',
                scegliCategoria: 'Markieren',
                scegliPoi: 'Einen Anziehungspunkt markieren',
                scegliTerritorio: 'Liste der bedekten Fläche. Was wählen Sie?',
                selezionaPoi: 'Ein POI auswählen',
                selezionaTutto: 'Alle',
                serviziInclusi: 'Ein Ereingis auswählen',
                serviziUtili: 'Notwendige Dienste',
                specialitaCorrelate: 'korrelate Produkte',
                staiCercandoAllCategories: 'In allen Kategorien',
                tab: {
                    allegati: 'Anlagen',
                    info: 'Auskünfte',
                    mappa: 'Karte',
                },
                tutteLeCategorie: 'Alle Kategorien',
                vetrina: 'Schaufenster',
                virtualTour: {
                    info: 'Die virtuelle Besichtigung wird in einem Browser Fenster dieser Vorrichtung geöffnet',
                    intro: 'Surfen durch der virtuelle Besichtigung, um die Wunder dieses Orts zu entdecken ',
                    lancia: 'Virtual Tour starten',
                },
            },
            primoAvvio: {
                tutorial: {
                    biglietti: {
                        testo: 'Fahrkarten und Abonnements in einem Klick kaufen',
                        titolo: 'Kein Code mehr!',
                    },
                    borsellino: {
                        testo: 'und benutzen Sie es, um die angebotenen Dienstleistungen zu bezalen',
                        titolo: 'Laden Sie Ihr Guthaben auf',
                    },
                    buoniMotivi: {
                        testo: 'Warum mycCicero Super ist',
                        titolo: 'eine Super-App!',
                    },
                    dolomiti: {
                        scopriLeBellezze: {
                            testo: 'Entdecken mit uns die Schönheiten der Dolomiten',
                        },
                    },
                    masterpass: {
                        testo: 'Mit Masterpass von Mastercard ist sicher und Sie sofort einen Bonus bekommen',
                        titolo: 'Registrieren Ihre Karte',
                    },
                    seguiIlViaggio: {
                        testo: 'Zug-Pünktlichkeit, nächste Halte des Zuges, Ankunftszeiten',
                        titolo: 'Aktuelle Infos über Ihre Zug-Reise bekommen',
                    },
                    soluzioniDiViaggio: {
                        testo: 'Lösungen integriert mit Zug, Bus und Metro',
                        titolo: 'Planen Sie Ihre Reise!',
                    },
                    sosta: {
                        testo: 'Nur die echten Parkminuten bezahlen',
                        titolo: 'Geld sparen beim Parken',
                    },
                },
            },
            profilazione: {
                accedi: 'Login',
                accediAccount: 'Sie sind schon registriert',
                aci: {
                    registrazioneEseguiLogin:
                        'Bitte melden Sie sich an, um die von ACI in Ihrem myCicero Account zur Verfügung gestellten Dienstleistungen zu benutzen.',
                    registrazioneUtenteEsistenteConTessera:
                        'Ihre ACI Mitgliedskarte ist erfolgreich mit Ihrem myCicero Account verbund worden (das Gleiche von Ihrem ACI Account).',
                    registrazioneUtenteNuovoConTessera:
                        'Ihre Anmeldung wurde erfolgreich abgeschlossen. Ihre Zugangsdaten sind an die Email-Adresse gesendet worden, die mit dem Aci-Account verbunden ist. Ihre ACI Mitgliedskarte ist aktiviert worden',
                    registrazioneUtenteNuovoSenzaTessera:
                        'Ihre Anmeldung wurde erfolgreich abgeschlossen. Ihre Zugangsdaten sind an die Email-Adresse gesendet worden, die mit dem Aci-Account verbunden ist. ',
                },
                activateServices: 'Serviceaktivierung in einer Minute',
                alreadySubscribed: 'Sie haben bereits ein Account?',
                associaFoto: 'Foto anlagen',
                azienda: 'Unternehmen',
                benvenuto: 'Willkommen ',
                cambiaEmail: 'Email verändern',
                cap: 'PLZ',
                cartaRegistrata: 'Registrierte Karte',
                cell: 'Handynummer',
                cellFormatInvalid: 'Handynummer nicht gültig',
                cellulare: 'Handynummer',
                checkAccetto: 'Ich akzeptiere',
                checkComunicazioni: 'SMS und Nachrichten bekommen',
                checkCondizioniPrivacy: 'Ich akzeptiere ',
                checkCondizioniUtilizzo: 'Ich habe gelesen',
                checkCondizioniUtilizzoAlternativelabel: 'Ich habe gelesen',
                chiudi: 'Schließen',
                citta: 'Stadt',
                cittaNascita: 'Geburtstadt',
                cittaResidenza: 'Wohngemeinde',
                codTessera: 'Kartenummer',
                codiceCliente: 'Kundencode',
                codiceFiscale: 'Steuernummer',
                codiceUnivocoDestinatario: 'Einheitlicher Code ',
                cognome: 'Nachname',
                cohesion: {
                    erroreRegistrazione: 'Registrierung durch Cohesion gescheitert:',
                    labelHtml: 'Registrierung durch <b>Cohesion 2.0</b>:',
                },
                condizioniAltriFini: 'Befreiung für Einsendung der Sonderaktionen',
                condizioniCommerciali: 'Wirtschaftsinformatik',
                condizioniContrattuali: 'Vertragsbedingungen',
                condizioniDiUtilizzo: 'nutzungsbedingungen',
                condizioniDiUtilizzoAlternativeLabel: 'Datenschutzerklärung',
                condizioniFiniCommerciali: 'Befreiung für Einsendung des Informationsmaterials',
                condizioniIscritti: 'Informationsschreiben für ',
                condizioniPrivacy: 'Datenschutzbedingungen',
                condizioniUtilizzo: 'Nutzungsbedingungen',
                condizioniUtilizzoCredito: 'Guthaben Nutzungsbedingungen',
                condizioniUtilizzoGenerali: 'Allgemenine Nutzungsbedingungen',
                condizioniUtilizzoPrivacy: 'Nutzungsbedingungen und Datenschutz',
                condizioniUtilizzoSosta: 'Parken Nutzungsbedingungen',
                condizioniUtilizzoTrasporto: 'Transport Nutzungsbedingungen',
                confirmRollback: 'Hiermit werden die bisher eingegebenen Angaben gelöscht. Fortfahren?',
                confirmation: 'Code bestätigen',
                contattaAssistenza: 'Kontaktieren Sie unseren Kundendienst',
                continuaSenzaRegistrazione: 'Ohne Registrierung fortsetzen',
                continuaSenzaRegistrazioneAvvertimento:
                    'Das Verfahren ohne Registrierung ist nicht gestattet, Einkäufe zu tätigen',
                controllaCodice: 'Checken Sie das Kode',
                controllaEmail: 'Überprüfen Sie, ob die registrierte Emailaccount korrekt ist',
                creaUtente: 'Ihren Benutzer erstellen',
                creaUtenteDesc: 'Benutzererstellung in einer Minute...',
                dataNascita: 'Geburtsdatum',
                descrizionePromo: 'Habe Sie ein Promotionskode? Fügen Sie das hier ein und aktivieren die Promotion',
                ebbeneSi: 'Ja, neu anfangen',
                email: 'E-Mail-Adresse',
                emailConfirmed: 'E-Mail-Account erfolgreich bestütigt',
                emailReminder:
                    'Vergessen Sie nicht, Ihre E-Mail-Adresse über den zugesandten Link zu bestätigen. Dies kann auch später erfolgen.',
                emailSent: 'E-Mail gesandt an',
                erroreRegistrazioneCarta: 'Die Registrierung der Kreditkarte ist gescheitert',
                esclamaBenvenuto: 'Wilkommen!',
                fatturazioneElettronica: 'elektronische Rechnung',
                fine: 'Ende',
                indirizzo: 'Adresse',
                indirizzoResidenza: 'Wohngadresse',
                infoMoficaDati:
                    'Für jede Abänderung, vor der Bestätigung, schreiben Sie an assistenza@mycicero.it oderrufen Sie die Nummer 071 920 7000 an',
                infoNecessaria: 'Obligatorische Angabe.',
                informativaFatturazione:
                    'Die Rechnungsausstellung für Parken oder Fahrtkarten (Nahverkehr) ist nicht obligatorisch, weil es außerhalb des Anwendungsbereiches der Steuer ist. Wie es in Artikel 74 633/72, Buchstabe e) festgelegt ist. Falls der Rechnungsantrag, wird diese als elektronische Rechnung ausgestellt und betrieben, danach wird den Rechnungsempfänger die elektronische Rechnung zu verwahren und die Kosten zu ertragen. Daher raten wir, wenn möglich ist, nur die Auszahlungsquittung zu verwahren. Die Auszahlungsquittung wird gleichzeitig mit jedem Einkauf kostenlos erstellt. Statt die Rechnung notwendig ist, die wird € 0,10 pro Monat kosten. Bitte beachten Sie, dass die Rechnung monatlich nur für die Dienste und Parkunternehmen per Email gesendet wird.',
                informativaPrivacy: 'Datenschutzhinweise',
                inizia: 'Starten',
                insertPinCode: 'Fügen Sie den Aktivationkode hinzu ',
                intestatario: 'Karteangaben',
                inviaSms: 'SMS senden',
                inviaSmsConferma: 'Ja, bitte, den Code senden',
                inviaSmsInfo: 'Der Aktivierungscode wird per SMS gesendet. Möchten Sie weitergehen?',
                iscrizione: 'Sie sind registriert mit',
                iscrizioneNonCompletataPopupAnnullaEdElimina: 'Löschen und entfernen den Benutzer',
                iscrizioneNonCompletataPopupCompletaIscrizione: 'Weitere Informationen:',
                iscrizioneNonCompletataPopupMsg: 'Löschen und enfernen den Benutzer',
                iscrizioneNonCompletataPopupTitle: 'Registrierung nicht ergänzt',
                iscrizioneServizi:
                    'Falls Sie bereits bei autobus.it angemeldet sind, können Sie dieselben Zugangsdaten verwenden',
                localitaProvenienza: 'der Flug fliegt von ….ab',
                messaggioAssociaFoto:
                    'ACHTUNG: Dieses Bild wird auf Ihrem Abonnement aufgezeigt und es wird nicht möglich sein es zu ändern',
                modelloVeicolo: 'Flugzeugmodell',
                modelloVeicoloObbligatorio: 'Fahrzeugmodell ',
                modelloVeicoloOpzionale: 'Fahrzeugmodell (optional)',
                msgAssistenzaActv: 'app.support@avmspa.it',
                msgAssistenzaDefault: 'assistenza@mycicero.it und call center 071 920 7000',
                nazione: 'Staat',
                nazioneNascita: 'Geburtsstaat',
                nome: 'Name',
                nonHaiTessera: 'Haben sie keine Verkehrskarte?',
                normativaPrivacy: 'Datenschutz',
                numVolo: 'Rückflugzeugsnummer',
                numeroTelefonoConfermato: 'Telefonnummer bestütigt',
                numeroVerde: 'kostenfrei Servicetelefonnummer',
                nuovoUtente: 'Neuer Benutzer',
                partitaIva: 'Umsatzsteuer-Identifikationsnummer',
                password: 'Passwort',
                passwordConfirm: 'Passwort erneut eingeben',
                passwordNotMatch: 'Die Passwörter stimmen nicht überein.',
                pecEmail: 'PEC destinatario',
                perAssistenza: 'Zur Kundenbetreuung senden Sie ein Email folgender Adresse:',
                perAssistenzaActv: 'Falls Sie Hilfe brauchen, senden Sie bitte eine mail an der Servicezentrale',
                perAssistenzaSito: 'Für Hilfe, klicken auf',
                perAssistenzaTelefono: 'Oder die Nummer anrufen:',
                perAssistenzaUlteriore: 'Falls haben sie Probleme die Eintrittskarten zu bekommen:',
                perInfo: 'Für Informationen: ',
                perUlterioriInfo: 'Weitere Informationen: ',
                perUlterioriInfoInfoActv: 'Für weiteren Informationen: ',
                pinCode: 'Code bestätigen',
                pinCodeDesc: 'Der Aktivierungscode wurde per SMS gesendet.',
                privato: 'Privat',
                procedi: 'Fortfahren',
                profiloPreferito: 'Hauptprofil',
                profiloPreferitoMessage: 'Dieses Profil wird für die Rechnung benutzt',
                promoCodePlaceholder: 'Fügen einem Promotionskode ein ',
                promozioni: 'Promotion',
                provincia: 'Provinz',
                ragioneSociale: 'Firmenbezeichnung',
                recapiti: 'Kontaktdaten ',
                registraNuovoUtente: 'Als ein neuer Benutzer anmelden',
                registratiOra: 'Registrieren Sie sich jetzt',
                registrationCompleted: 'Registrierung beendet.',
                registrationFailed: 'Verfehlte Anmeldung  ',
                registrazione1: 'Anmeldung 1/2',
                registrazione2: 'Anmeldung 2/2',
                reinviaSMS: 'SMS erneut senden',
                requiredFields: 'Alle obligatorischen Felder ausfüllen.',
                resendBtn: 'Ja, bitte senden.',
                resendOk:
                    'Der Aktivierungscode wurde gerade erneut per SMS gesendet. Sie sollten ihn in Kürze erhalten.',
                resendText: 'Der Aktivierungscode wird gerade erneut per SMS gesendet. Sind Sie sicher?',
                resended: 'Code gesendet',
                rightNumber: 'Ist es das Nummer richtig?',
                rimuoviProfilo: 'Profil löschen',
                salvaModifiche: 'Änderungen speichern',
                sendSms: 'SMS und E-Mail zur Bestütigung senden...',
                sendingEmailDesc: 'Ferner wird eine E-Mail mit dem Aktivierungslink an folgende Adresse geschickt:',
                sendingSmsDesc: 'Der Bestütigungscode wird per SMS an folgende Nummer geschickt:',
                smsNotSent: 'Kein SMS versenden',
                smsSent: 'SMS geschickt an ',
                splitPayment: 'Split Payment Firma',
                startAgain: 'Telfonnummer verändern',
                targaObbligatoria: 'Fahrzeugskennzeichen',
                targaOpzionale: 'Fahrzeugskennzeichen (optional)',
                titoliAtac: 'ATAC Fahrscheine ',
                titoloPersonale: 'Vor der Zusage, die Daten Ihrer Abonnementskarte eingeben und/oder kontrollieren',
                titoloPesonale: 'Transport Karte',
                usaCodice: 'Benutzen den Kode',
                username: 'Username',
                vaiAllApp: 'Benutzen Sie die App',
                vediPromo: 'Zeigen die aktive Promotione ',
                verificaCodiceSms: 'Den SMS-Code überprüfen',
                wrongNumber: 'Falsche Nummer?',
            },
            profiloUtente: {
                carte: 'Registrierte Kreditkarten',
                impostazioniNotifiche: {
                    description:
                        'Das Parken mit einem Klick direkt im Benachrichtigungsbereich Ihres Smartphones verlängern und deaktivieren',
                    header: 'Benachrichtigungsbereich-Integration',
                    title: 'Benachrichtigungseinstellungen',
                    toggleActive: 'Aktivieren',
                    toggleInactive: 'Deaktivieren',
                },
                mostraCod: 'User Code anzeigen',
                nessunaCarta: 'Keine Kreditkarte',
                nessunaTessera: 'Keine Karte verbunden',
                pref: 'Persönliche Einstellungen',
                tessere: 'Karten und Verträge',
                title: 'Benutzerprofil',
            },
            promozione: {
                atmaBullet1: 'Scannen Ihre Barcode durch den Scanner der Kompaktiermaschinen',
                atmaBullet2: 'Nur PET Flaschen vom 0,5 zum 2 Litern einlassen, um den Ecobonus zu bekommen',
                atmaBullet3: 'Die Fahrkarten durch den angesammelten Bonus kaufen',
                bullet1: 'Scannen Sie durch das Lesegerät der Öko-Kompaktoren den Barcode Ihren Benutzer ID',
                bullet2:
                    'Fügen Sie Nur 0,5 und 2 Litern PET Flaschen ein und bekommen Ihres Bonus. Sie können maximal 30 pro Tag einzufügen.',
                bullet3: 'Kaufen Sie Fahrkarten durch angehäuften Bonus',
                caricaNuovoBuono: 'Neue Voucher aufladen',
                caricaNuovoCredito: 'Neues Guthaben aufladen',
                compraAtac: 'B + kaufen',
                compraAtma: 'ATMA Fahrkarten kaufen',
                dataOraMovimento: 'Datum und Uhrzeit',
                descrizione: 'Sie könnnen den Betrag genießenn um,</br> Fahrkarten zu kaufen',
                descrizioneMovimento: 'Beschreibung',
                elencoPromozioniMobilita: {
                    nessunaPromozione: 'Keine Promotion',
                    title: 'Guthabenliste',
                },
                importoMovimento: 'Betarg',
                invalidTxt: 'Diese Angabe befolgt nicht das gegeben Format',
                istruzioniPrincipaliHTML:
                    '<span class="bold">Verwerten Sie Ihren Plastikflaschen wieder und Sie können Guthaben ansammeln, um Fahrkarten und Abonnements zu erkaufen<span class="bold atac-red">ATAC</span></span>',
                istruzioniPrincipaliHTMLATMA:
                    '<span class="bold">Verwerten Ihre Plastikflaschen wieder und Sie können das Guthaben sammeln, um ATMA Fahrkarten zu kaufen</span>',
                labelProfilo: 'ATAC Roma, je mehr Sie verwerten wieder, desto meherere Sie fahren',
                labelProfiloAtma: 'Flaschen Wiederverwendung ATMA',
                labelSaldo: 'Kontostand',
                movimenti: 'Kontobewegungen',
                noMovimenti: 'Keine Kontobewegungen',
                scadenza: 'Frist',
                titoliBAtac: 'B+ ATAC',
                titoliBAtma: 'ATMA',
                tuttiMovimenti: 'Alle Kontobewegungen',
                txtInstructions:
                    'Fügen die erforderte Angaben ein und verifizieren den Voucher Kode, um das Guthaben einzuladen',
                ultimiMovimenti: 'Letze Kontobewegungen',
                usaCreditiMobilita: 'Die Mobilitätsguthaben nutzen',
                utilizzoEcobonus: 'Ecobonus Nutzung(€ {0})',
            },
            rockinroma: {
                atac: 'ATAC Fahrkarten',
                festival: 'Festival',
                lineUp: 'Lineup',
                location: 'Location',
                mieiTitoli: 'Meine Fahrkarten',
                tickets: 'Tickets',
                travel: 'Travel',
                treniDelRock: 'Post-Konzert Züge',
            },
            rss: {
                dettaglioHeader: 'Detail',
                filterPlaceholder: 'Suchen...',
                latestNews: 'Aktuelle Iformationen',
                news: ' Neuigkeiten',
                newsFontiNotificheHeader: 'Feed Liste',
                newsNotificheHeader: ' Neuigkeiten und Mitteilungen',
                noResults: 'Keine Ergebnisse',
                scegliFeed: 'Wählen ein Feed',
                updating: 'News-Überprüfung',
            },
            rundetails: {
                nodata: {
                    empty: 'kein Detail gefunden',
                },
                realTime: {
                    arrivoPrevisto: 'voraussichtliche Ankunftszeit',
                    arrivoReale: 'echte',
                    arrivoStimato: 'voraussichtlich',
                    binarioPrevisto: 'geplantes Gleis',
                    binarioReale: 'echte',
                    inAnticipo: 'im Voraus',
                    inOrario: 'nach Zeitplan',
                    inRitardo: 'mit Verspätung',
                    minuti: 'Minuten',
                    minuto: 'Minute',
                    partenzaPrevista: 'geplante Ankunftszeit',
                    partenzaReale: 'echte',
                    ultimoRilevamento: 'Letzte Erfassung: ',
                },
            },
            sanzioni: {
                cercaVerbale: 'Protokoll suchen',
                codiceFiscale: 'Steuernummer',
                codiceInfrazione: 'Vergehen Kodex',
                cognome: 'Familienname',
                cognomeSanzionato: 'sanktionierte Familienname',
                controllareDatiInseriti: 'kontrollieren die eingefügte Daten',
                data: 'Datum',
                dataNascita: 'Geburtsdatum',
                dataVerbale: 'Protokoll Datum',
                datiIncompleti: 'unvollständige Daten',
                datiSanzionato: 'Daten des sanktionierten Menschen',
                datiVerbale: 'Protololl Daten',
                descrizione: 'Beschreibung',
                dettaglioVerbale: 'Protololl Detail',
                erroreIdSistema: 'IdSystem nicht spezifiziert',
                idVerbale: 'Id Protokoll',
                importoBiglietto: 'Betrag der Fahrkarte',
                infoDatiVerbale: 'Tragen die nutzliche Daten für die Protokollsuche ein ',
                noVettoriAbilitatiPagamentoSanzioni: 'Kein Verkehrsbetrieb für Strafzahlung',
                nome: 'Name',
                nomeSanzionato: 'Name des Sanktionierten',
                numero: 'Nummer',
                numeroVerbale: 'Protokollnummer',
                pagamentoSanzioni: 'Strafzahlung',
                sanzionato: 'Bestrafte ',
                sanzione: 'Sanktion',
                serialeVerbale: 'Protokollrehie',
                serie: 'Rehie',
                speseAmministrative: 'Verwaltungsausgaben',
                totale: 'Gesamtsumme',
                verbale: 'Protokoll',
                verbaleNonPagabile: '<b>Protokoll schon bezahlt</b>',
                verbaleNonTrovato: '<b>Protokoll nicht gefunden</b><br>Bitte kontrollieren die eingefügten Daten.',
            },
            selectPositionOnMap: {
                areaNonServitaHtml:
                    'Für Auskünfte kontaktieren uns bei <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> oder <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">per chat</a>',
                areaNonServitaLabel: 'Einen Punkt in der Karte auswählen.',
                areaNonServitaTitle: 'Nicht bedientes Gebiet',
                disclaimerBtn: 'Ich verstehe',
                disclaimerMsg: 'Versichern Sie sich, dass Ihre Position richtig ist',
                ricercaLocalitaInCorso: 'Ortschaft suchen',
                scegli: 'Wählen',
                warningAumentaZoom: 'Das Zoom vergrößern',
                warningZoomInsufficiente: 'Das Zoom verkleinern',
            },
            selezionaModalitaDiPagamento: {
                comeVuoiPagare: 'Wie möchten Sie bezahlen?',
                modalita: {
                    acipg: 'ACI Pay',
                    amonw: 'Zahlungskarten',
                    bbol: '',
                    bill: 'Bill von SisalPay',
                    brsel: 'myCicero Guthaben',
                    cc: '',
                    ccric: 'Zahlungskarten',
                    'ccs-2-s': '',
                    mpass: 'Masterpass™',
                    pbemo: 'BeMoov',
                    ppay: 'Postepay',
                    ppexp: 'PayPal',
                    ppric: 'PayPal',
                    sisal: 'SisalPay',
                    stpay: 'SatisPay®',
                },
            },
            serCom: {
                NessunServizioAzienda: 'Für Benutzer mit Firmenprofil sind keine Dienste freigegeben',
                NessunServizioPrivato: 'Für private Benutzer sind keine Dienste freigegeben',
                avvisiPagamento: {
                    header: 'Zahlungsbescheide',
                    inScadenza: 'Fällige Zahlungen',
                },
                azienda: 'Firma',
                certificazioneInfoHTML:
                    'Um ZahlungsMeldungen von Behörden geschickt anzuzeigen, müssen Sie eine zertifizierte Benutzer sein. Um zertifiziert zu werden, begeben Sie sich in eines autorisierten Gemeinde-Büro mit gültigem Ausweis. Andernfalls können Sie Ihre login-Daten der zertifizierten System (Cohesion) verwenden, um auf Ihrem reservierten Online-Bereich von Ihrem PC oder Mac zugreifen.',
                comune: 'Stadt',
                comuniRecenti: 'Kürzlich angezeigte Städte',
                comuniSerCom: 'Städte, die Städtische Dienste anbieten',
                contattaAssistenza: 'Bitte wenden Sie sich an die Servicezentrale',
                contatti: 'Kontakte',
                costoServizio: 'Kosten der Dienstleistung',
                dataInfrazione: 'Datum des Vergehens',
                elencoMovimenti: {
                    header: 'Liste der Kontobewegungen',
                    noResults: 'Es sind keine Bewegungen im angegebenen Zeitraum',
                    ricercaMovimenti: 'Suche',
                },
                mainHeader: 'Städtische Dienste',
                nessunImportoDovuto: 'Der geschuldete Betrag ist gleich 0, keine Zahlung erforderlich!',
                news: {
                    header: 'News und Mitteilungen',
                },
                oraInfrazione: 'Uhrzeit des Vergehens',
                pagamentiSpontanei: {
                    compilaTutto: 'Achtung: alle verlangten Felder ausfüllen',
                    header: 'Spontane Zahlungen',
                    pagSpontaneo: 'Spontane Zahlung',
                },
                pagamento: {
                    dataEmissione: 'Ausstellungsdatum',
                    dataFine: 'Enddatum',
                    dataInizio: 'Anfangsdatum',
                    dataSanzione: 'Datum der Strafe',
                    dataScadenza: 'Fälligkeitsdatum',
                    descr: 'Beschreibung',
                    errorePagamento: 'Während der Zahlungsabwicklung ist ein Fehler aufgetreten.ü',
                    header: 'Zahlung ',
                    importoDaPagare: 'Zahlbetrag',
                    importoNonValido: 'Betrag ungültig',
                    pagamentoGuidato: 'Gefährter Zahlungsvorgang',
                    scegliData: 'Datum Wählen',
                    soggetto: 'Person',
                    targa: 'Kennzeichen',
                    verbale: 'Protokoll',
                },
                pagamentoEffettuato: 'Zahlung getütigt',
                pagamentoNonAbilitato: 'Zahlung nicht freigegeben',
                privato: 'Privat',
                richiediCert: 'Zertifizierung anfordern',
                richiediCertInfoHTML:
                    'Sie werden zu Ihrem<strong>über herkömmlichen PC </strong>zugänglichen Geschätzten Web-Bereich weitergeleitet.',
                segnalazioni: {
                    cat: 'Kategorie',
                    descr: 'Beschreibung',
                    header: 'Signalisierungen',
                    img: 'Bild',
                    indirizzo: 'Adresse Signalisierung',
                    inserite: 'Eingegebene Signalisierungen',
                    invia: 'Signalisierung senden',
                    noCategorie: 'Es sind keine Kategorien für Ihre Position verfügbar.',
                    nuova: {
                        abbandona: 'Signalisierung aufgeben und Bereich verlassen',
                        attendiCaricamentoImmagine: 'Warten Sie laden das Foto...',
                        caricamentoImmagineFallito: 'Fotos werden geladen gescheitert',
                        fail: 'Signalisierung kann nicht gespeichert werden!',
                        header: 'Neue Signalisierung',
                        inserisciQui: 'Signalisierung hier eingeben',
                        success: 'Signalisierung erfolgreich gespeichert',
                        torna: 'Zurück zur Signalisierung',
                    },
                    subCat: 'Unterkategorie',
                    tue: 'Ihre Signalisierungen',
                    welcome: 'Willkommen!',
                    welcomeIntroTemplate:
                        '<p>Auf dieser Seite kann eine Signalisierung an {0} gesendet werden.</p><p>Zunüchst eine der verfügbaren Kategorien {1} Auswählen:</p>',
                },
                serviziAbilitatiAzienda: 'Für Benutzer mit Firmenprofil freigegebene Dienstleistungen',
                serviziAbilitatiPrivato: 'Für Privatbenutzer freigegebene Dienstleistungen',
                tipoSoggetto: 'Personenart',
                tornaAiServizi: 'Zurück zu Dienstleistungen',
                totale: 'Gesamt',
                transazioneOK: 'Transaktion erfolgreich beendet',
                utenteNonCertificato: 'Nicht zertifizierter Benutzer',
            },
            siae: {
                acquistaBiglietti: 'Fahrkarten lösen',
                chooseSector: {
                    apriMappa: 'Sitzplan öffnen',
                    headerScegliDaLista: 'Automatisch Auswahl der Sitzen',
                    headerScegliDaMappa: 'Sitz auswählen',
                    noSettori: 'Keine Sektor verfügbar',
                    scegliBiglietti: 'Eintrittskarten auswählen',
                },
                mieiBiglietti: 'Meine Eintrittskarte',
                myTickets: {
                    mieiTitoli: 'Meine Fahrkarten',
                    passati: 'Vergangene',
                    validi: 'Gültige',
                },
                posto: 'Sitz',
                seasonTicket: 'Abonnement',
                settore: 'Sektor',
                ticketDetails: {
                    carta: 'Karte',
                    cfOrganizzazione: 'CF Org.',
                    cfTitolo: 'CF Tit.',
                    data: 'Datum',
                    idSistema: 'ID System ',
                    progressiva: 'Fortlaufend',
                    sf: 'S.F.',
                    tipoEvento: 'Ereignis',
                },
                ticketsSummary: {
                    commissioni: 'Gebühren',
                    pagaConCarta: 'Durch Guthaben bezahlen',
                    prevendita: 'Vorverkauf',
                    removeTicketConfirm: 'Sind Sie sicher diese Artikel zu löschen?',
                    staiPerAcquistare: 'Sie werden kaufen',
                },
            },
            smartArea: {
                cambiaCitta: 'Stadt wechseln...',
                confermaReset: 'Alle lokal gespeicherten Daten der Smart Area werden gelöscht.',
                defaultTitleHtml: 'Die Welt der Smart Services',
                nonScegliNulla: 'Keine Wahl tütigen ...',
                oppureAreaSmartHtml: 'Oder ein <i>Smart</i>Gebiet Wählen:',
                reset: 'Die lokalen Daten der Smart Area löschen',
                resetDone: 'Daten gelöscht. Beim nächsten Aufrufen der Home Page werden die Daten frisch geladen.',
                scegli: 'Smart-Stadt Wählen',
                seiQui: 'Sie befinden sich hier',
                selezionaAreaSmart: 'Ein Smart-Gebiet oder eine Smart-Stadt Wählen',
                servizioNonDisponibile: 'Dienstleistung momentan nicht verfügbar.',
            },
            solutions: {
                acquista: {
                    aPiedi: 'zu Fuß',
                    arrivo: 'Ankunft',
                    articolo: 'Stück',
                    dilloAlVettore: 'Ja, ich würde diese Reiselösung gerne erwerben',
                    dilloAlVettorePre:
                        'Dieser Fahrschein kann noch nicht gekauft werden. Möchten Sie es signalisieren?',
                    dilloAlVettoreStatement: 'Dieser Fahrschein kann noch nicht gekauft werden.',
                    durata: 'Dauer',
                    fromStop: 'ab Haltestelle',
                    header: 'Lösung kaufen',
                    importo: 'Betrag ',
                    infoAddizionali: 'Zusatz-Info',
                    nonDisponibile: 'Nicht verfügbar',
                    partenza: 'Abfahrt',
                    toStop: 'bis Haltestelle',
                    tratta: 'Strecke',
                },
                dialog: {
                    partenzaArrivoUguali: 'Abfahrt und Zielort stimmen überein. Keine Reiselösung vorhanden.',
                },
                fav: {
                    header: 'Lösung speichern',
                    info:
                        'Diese Reiselösung unter den "Bevorzugten" speichern, damit sie in Zukunft rasch abgerufen werden kann.',
                },
                form: {
                    cercasoluzioni: 'Reiselösungen suchen',
                    elimina: 'Löschen',
                    itinerariPreferiti: 'Liebliengsrouten',
                    nessunPreferito: 'Keine Liebliengsrouten',
                    preferiti: 'Lieblingselemente',
                    recenti: 'Jüngsten',
                    searchbutton: 'Suchen',
                },
                list: {
                    arrivi: 'Ankünfte',
                    arrivo: 'Ankunft',
                    loadMore: 'Weitere Lösungen hochladen',
                    ordinaPerDataArrivoAsc: 'Nach Ankunftszeit',
                    ordinaPerDataDiPartenzaAsc: 'Nach Abfahrtszeit',
                    ordinaPerDataDiPartenzaDesc: 'Abfahrtzeit ↓',
                    ordinaPerDurataTragittoAsc: 'Nach Dauer',
                    ordinaPerDurataTragittoDesc: 'Reisedauer ↓',
                    ordinaPerNumCambiAsc: 'Wechselnnummer',
                    ordinaPerPrezzoAsc: 'Niedrigsten Preis',
                    ordinaPerPrezzoDesc: 'Hochsten Preis',
                    ordinaRisultati: 'Reiselösungen ordnen',
                    partenza: 'Abfhart',
                    partenze: 'Abfährte',
                },
                nodata: {
                    empty: 'Keine Reiselösung gefunden',
                },
                nome: 'Name der Lösung',
                type: {
                    auto: 'Auto',
                    autobus: 'Nur Bus',
                    busTreni: 'Züge und Busse',
                    pedonale: 'Fußgänger',
                    treno: 'Nur Züge',
                },
            },
            stopdetails: {
                nodata: {
                    empty: 'no details found',
                },
                settings: 'Einstellungen Haltestelle',
            },
            stops: {
                arrivi: 'Ankünfte an der Haltestelle',
                fav: {
                    conferma: 'Die Haltestelle wurde zu Ihren bevorzugten Haltestellen hinzugefügt',
                    header: 'Haltestelle speichern',
                    info:
                        'Diese Haltestelle unter den "Bevorzugten" speichern, damit sie in Zukunft rasch abgerufen werden kann',
                    nomePreferito: 'Name Bevorzugte/r',
                },
                partenze: 'Abfahrten an der Haltestelle',
            },
            summerjamboree: {
                alloggi: 'Wo wohnen',
                festival: 'Festival',
                foodAndBeverages: 'Food & Beverages',
                locations: 'Locations',
                mappa: 'Karte',
                mercatino: "Rockin' Village - Market",
                navette: 'Sonderzuge und -Pendelfahrzeuge',
                programma: 'Ereignisse',
            },
            sunsen: {
                cercaAlloggio: 'Herberge suchen',
                elencoTornei: 'Tourniere Liste',
                home: {
                    classifica: 'Ergebnisse und Endstände',
                    eventi: 'Ereignisse',
                    informazioni: 'Auskünfte',
                    iscrizioni: 'Anmeldungen',
                    partners: 'Partners',
                    sosta: 'Parken',
                    trasporto: 'Transport',
                },
            },
            taxi: {
                common: {
                    aggiornatoAlle: 'Aktualisiert um',
                    descrAnnullata: 'Buchung annulliert',
                    descrArrivato: 'Angekommen',
                    descrConfermata: 'Buchung bestätigt',
                    descrDaConfermare: 'Bitte auf die Bestätigung warten',
                    descrInArrivo: 'Kommt in {0} Minuten an',
                    descrPagato: 'Bezahlt (€ {0})',
                    ultimoAggiornamento: 'Letztes Update',
                },
                dettaglio: {
                    annullaPrenotazione: 'Die Buchung annullieren',
                    dataAssegnazione: 'Tag der Annahme',
                    pagaTaxi: 'Das Taxi bezahlen',
                    promptHeader: 'Annullieren',
                    promptKo: 'Nein',
                    promptMessage: 'Möchten Sie diese Buchung wirklich annullieren?',
                    promptOk: 'Ja',
                    title: 'Buchungsdetails',
                },
                home: {
                    aggiornamentoInCorso: 'Die Angaben werden gerade aktualisiert',
                    miePrenotazioni: 'Meine Buchungen',
                    paga: 'Bezahlen',
                    prenota: 'Erfordern',
                    title: 'Taxi suchen',
                },
                mappa: {
                    disclaimerBtn: 'I have vestanden',
                    disclaimerMsg: 'Bitte stellen Sie sicher, dass Ihre genaue Position kommuniziert wird',
                    procedi: 'Fortfahren',
                    title: 'Taxi suchen',
                    warningZoomInsufficiente: 'Bittein der Karte zoomen, um Ihre Position zu finden',
                },
                pagamento: {
                    importoViaggio: 'Reisekosten',
                    numeroLicenza: 'Genehmigungsnummer',
                    pagamentoEffettuato: 'Die Reise ist erfolgreich bezahlt worden',
                    promptNumeroLicenza: 'Den Taxifahrer um die Genehmigungsnummer bitten',
                    scansiona: 'Scannen',
                    scegliComePagare: 'Bitte eine Bezahlungsmethode wählen',
                    title: 'Taxi bezahlen',
                    totale: 'Gesamtsumme',
                },
                prenotazione: {
                    conferma: 'Bestätigen',
                    promptHeader: 'Auf ein Taxi suchen',
                    promptMessage: 'Bitte auf die Bestätigung aus dem Operationszentrums warten',
                    promptNote:
                        'Bei der Reservierungsannahme und Taxivergabe, wurden Sie eine Bestätigungsmail bekommen. Falls zeitversetzterer Forderung, wird die Mail kurz von der angegebenen Zeit bekommen.',
                    title: 'Taxi Forderung',
                },
            },
            tessere: {
                EliminaFail: 'Beim Versuch, die Karte zu löschen ist ein Fehler aufgetreten',
                EliminaSuccess: 'Die Karte wurde gelöscht',
                EliminaTesseraConf: 'Wollen Sie diese Karte löschen?',
                aggiungiTesseraTrasporto: 'Karte hinzufügen...',
                apriControllo: 'Prüfung öffnen',
                attivaTessera: 'Aktivieren Sie die Karte',
                card: 'Karte',
                cerca: 'Suche nach Karte',
                cercaAttiva: 'Suche nach Karte und aktivieren...',
                cercaPlaceHolder: 'Kartenname oder Vertrags',
                chiudiControllo: 'Prüfung schließen',
                codice: 'Kartencode',
                dettagliTessera: 'Kartendetails und Vertrags',
                haiTessera: 'Haben Sie eine Karte?',
                identificativoTessera: 'Kartenidentifikationsnummer',
                inAttesaValidazione: 'Warten auf Bestätigung',
                inserisciCodice: 'Geben Sie den Kartenkode ein',
                inserisciIdentificativoTessera:
                    'Fügen Sie die Identifikationsnummer der Karte ein, um die Fahrkarte zu kaufen.',
                noResultTessere: 'Keine Karte verfügbar',
                noResultTessereTrasporto: 'Keine Karte verfügbar',
                nomeTesseraContratto: 'Karte- oder Vertragsname',
                nonAttiva: 'Karte noch nicht aktiviert',
                rimuovi: 'Karte entfernen',
                scegliVettoreTessera: 'Ihr Transportunternehmen wählen',
                siHoTesseraVettore: 'Ja, ich habe eine Karte',
                tessera: 'Karte: ',
                tesseraRegistrata: 'Karte erfolgreich registriert',
                toBeCertified: 'Diese Karte erfordert eine manuelle Zertifizierung durch den Administrator',
                tutte: 'Alle Karten',
                valida: 'Gültig Karte',
                validita: 'Gültigkeit',
                verifica: 'überprüfen',
            },
            tir: {
                login: {
                    appName: 'TRANSPark',
                    appNonDisponibile: 'Die App ist derzeit für Windows Phones nicht verfügbar',
                    areeStazioni: 'Parkplätze und Tankstellen',
                    cerca: 'Kontobewegungen suchen',
                    cercaParcheggi: 'Parkplätze suchen',
                    codice: 'Benutzercode',
                    scarica: 'Herunterladen',
                    targa: 'Kennzeichen',
                    testo1:
                        'Europäisches Pilotprojekt  (<a href="javascript:openLinkOnBrowser(\'http://www.cogistics.eu\')">www.cogistics.eu</a>) in Triest zur Förderung vom LKW Park-Service.',
                    testo2:
                        'Hier, unter Park-Kontobewegungen, können Lkw-Fahrer die Parkverfahren überprüfen, die im Triest-Güterverkehrszentrum aktiviert worden sind, oder Park-Zonen und Tankstellen über den Link zur Transpark App von IRU nachsuchen.',
                    testo3: 'Nur für Lkw-Fahrer im Triest-Güterverkehrszentrum geparkt',
                    title: 'LKW Parken',
                    titoloApp: 'TransPark App',
                    titoloMovimenti: 'Kontobewegungen zeigen',
                },
                movimenti: {
                    nessuno: 'Keine Kontobewegungen',
                    title: 'Kontobewegungen',
                },
            },
            tours: {
                allCategories: 'Alle Kategorien',
                arrivi: 'Ankunfte',
                cercaPrenota: 'Ein Tour suchen und buchen',
                definisciRaggio: 'bestimmen Suche Umkereis um:',
                dettaglio: 'Tour Details',
                elenco: 'Liste',
                inPartenzaEntro: 'Unterwegs Tour binnen',
                info: 'Information',
                itinerario: 'Route',
                mappa: 'Karte',
                nomeTour: 'Routename',
                partenze: 'Abfahrten',
                raggioRicerca: 'Suche Umkreis:',
                vetrina: 'Auslage',
                viaggioOrg: 'organisierte Reisen',
                warnTariffe: 'Gezeichneten Preis ist dem Grundtarif. Kontrollieren Sie bitte innen Preisliste.',
            },
            tplfvg: {
                AcquistaBiglietti: 'Fahrkarten kaufen',
                CalcolaPercorso: 'Fahrstrecke planen',
                Eventi: 'Ereignisse',
                FermateOrari: 'Haltestelle und Fahrpläne',
                Luoghi: 'Orte',
                MieiTitoli: 'Meine Fahrkarten',
                ServiziTuristici: 'Fremdenverkehrseinrichtungen',
                accediRegistrati: 'Einloggen / Registrieren',
                loginMessage:
                    'Um diese App nutzen zu können, müssen Sie als angemeldeten Benutzer betreten <b>TPLFVG</b>.',
                newsEventi: 'News und Ereignisse',
                rivendite: 'Fahrkartenausgabe',
            },
            trasportoGT: {
                accedi: {
                    header: 'Zugriff auf Fernverkehr',
                },
                elencoMovimenti: {
                    header: 'Liste der Kontobewegungen',
                },
                header: 'Fernbusse',
                mieiAbbonamenti: {
                    goToMyAbbonamenti: 'Meine Abonnements aufrufen',
                    header: 'Meine Abonnements',
                    infoTitoliAcquistati:
                        'Sie können den Fahrschein im Abschnitt "Meine Abonnements" im "Fernverkehr" finden',
                },
                mieiBiglietti: {
                    aggiornaElenco: 'Liste aktualisieren...',
                    elencoBigliettiDaObliterare: 'Liste gekaufter Fahrscheine zum Abstempeln',
                    elencoBigliettiScaduti: 'Liste abgelaufener Fahrscheine ',
                    elencoBigliettiUsati: 'Liste verwendeter Fahrscheine ',
                    elencoBigliettiValidi: 'Liste gültiger Fahrscheine ',
                    goToMyTickets: '"Meine Tickets" aufrufen',
                    header: 'Meine Tickets',
                    infoTitoliAcquistati:
                        'Sie können den Fahrschein im Abschnitt "Meine Tickets" im "Fernverkehr" finden',
                    nessunBigliettoTrovato: 'Keine Fahrscheine gefunden',
                    obliterati: 'Gestempelt und gültig',
                    ore: 'Stunden',
                    partenza: 'Abfahrt',
                    scadenzaTime: 'gültig bis',
                    validoFinoAl: 'Gültig bis',
                },
                soluzioniViaggio: {
                    andata: 'Anreise',
                    arrivoA: 'Ankunft in',
                    avvisoDataDifferente:
                        'Keine verfügbare Reiselösungen für die gewählte Daten. Hinzu fügen die erste vorhandene Lösungen',
                    cercaFraLocalitaElencate: 'Unter den aufgelisteten Orten suchen',
                    cercaSoluzioni: 'Reiselösungen suchen',
                    descrizioneViaggio: 'Beschreibung der Reise',
                    dettaglio: 'Detail der Lösung',
                    dettaglioAndata: 'Hinreisedetailen',
                    dettaglioRitorno: 'Rückreisedetailen',
                    header: 'Reiselösungen',
                    infoCoperturaHTML:
                        '<b>Das System</b> erfasst das gesamte Staatsgebiet. Kontrollieren Sie, welche Städte in Ihrer Umgebung vom Fernverkehr erreicht werden...',
                    infoPasseggero: 'Angaben zum Fahrgast',
                    localitaDestinazione: 'Zielort',
                    localitaPartenza: 'Abfahrtsort',
                    maxUnCambio: 'Höchstens einmal Umsteigen',
                    mostraSoluzioni: 'Lösungen zeigen',
                    mostraTutteLeDestinazioni: 'Es werden alle vom Abfahrtsort erreichbaren Zielorte angezeigt',
                    nessunCambio: 'Ohne Umsteigen',
                    nomeObbligatorio: 'Namensangabe obligatorisch',
                    partenzaDa: 'Abfahrt von ',
                    riassuntoInfoAcquisto: 'Zusammenfassung Kaufinformationen',
                    ritorno: 'Rückkehr',
                    scegliDataRitorno: 'Ihren Rückkehr-Tag wählen',
                    scegliRitorno: 'Ihre Rückkehr wählen',
                    scegliTariffa: 'Tarif Wählen',
                    selezionaDest: 'Zielort Wählen',
                    soluzioneSenzaPosti: 'Für die gewühlte Lösung sind keine Plütze frei',
                    tariffa: 'Tarif ',
                    tratta: 'Strecke',
                    tutteLeSoluzioni: 'Alle Lösungen',
                    viaggioRitorno: 'Rückkehr',
                    zoneCoperte: 'Vom Service erreichte Gebiete',
                },
            },
            trasportoRegionale: {
                acquistaBiglietti: 'Ticket kaufen',
                acquistaSMS: {
                    acquistaAltroBiglietto: 'Ein weiteres Ticket erwerben',
                    confermaAcquistoTitolo: 'Der Fahrschein wurde erworben',
                    elencoTitoliAcquistabili: 'Liste der erhältlichen Fahrkarten ',
                    erroreAcquisto: 'Ein Fehler ist aufgetreten. Möchten Sie den Kauf wieder probieren?',
                    header: 'Per SMS kaufen',
                    infoObliterazioneAuto: 'Das soeben gekaufte Ticket wurde automatisch gestempelt',
                    infoObliterazioneBiglietti: 'Jedes gekaufte Ticket muss vor der Verwendung abgestempelt werden',
                    invioManualeSmsInfo: 'Es ist nicht möglich die SMS schicken',
                    invioManualeSmsTitle: 'Handsendung der SMS',
                    noArticoliVendibili: 'Es sind keine verkaufbaren Artikel vorhanden',
                    riassuntoInfoBiglietto: 'Zusammenfassung Ticket-Info ',
                    richiestaInoltrataInfo:
                        'Sehr geehter Benutzer, wenn Ihre Forderung zum einen guten Abschluss gebracht war, bekommen Sie bald die Fahrkarte per SMS',
                    richiestaInoltrataTitle: 'Forderung eingereicht',
                },
                acquistaScaffale: {
                    elencoTitoliAcquistabili: 'Liste der erhältlichen Fahrkarten ',
                    elencoTitoliAcquistabiliActv: 'Liste der erhältlichen ACTV Fahrkarten',
                    elencoTitoliAcquistabiliMomup: 'Liste der erhältlichen Fahrkarten ',
                    gotoTitoliGT: 'Kaufen Sie Fahrkarten durch Buchung',
                    gotoTitoliSMS: 'Kaufen durch eine SMS',
                    header: 'Vom Regal kaufen',
                    headerActv: 'ACTV Fahrkarte aktivieren',
                    infoAcquistoSms:
                        "Diese Fahrkarte wird durch das <span class='bold'>Telefonguthaben</span> gekauft, dass  an der benutzt Telefonnumer assoziiert ist .<br/> <br/>Durch SMS ist es nicht möglich Fahrkarten, die niedrige oder andere Preise als diesen kompletten Fahrt, von einer Endstation zu einer anderen, kaufen.</br></br>Daher sind Rückzahlungen für Fahrten mit niedriger Strecke nicht eingeplant.</br></br>Keine Fahrkarten sind rückzahlbare</br></br>Nach dem Forderungsendung, bekommen Sie eine Bestätigungs-SMS, die als Fahrkarte genutzt werden kann.",
                    infoCoperturaATAC:
                        'Die Fahrkarten sind gültig auf allen Metrebus Landverkehrsmittels: Busse, Straßenbahnen und Oberleitungbussiystem Atac, Verkehrsmittels TPL  und COTRAL in Rome.<br />Auf U-Bahn ist das Service brauchbar auf Linien A, B, B1, Eisenbahn Roma-Lido und im Bahnof Flaminio der Eisenbahn Roma-Viterbo.<br /><br />In Kürze wird das Service für ganze Strecke Roma-Viterbo und auf Linie C im Betrieb werden.<br />',
                    infoCostiSms:
                        'Zu den Fahrkartenpreis wird die Kosten der Forderungs-SMS dazugerechnet. Die Kosten variieren gemäß Ireem telefonischen Operator.',
                    infoObliterazioneAuto: 'Das eben gekaufte Ticket wurde automatisch gestempelt',
                    infoObliterazioneBiglietti: 'Jedes gekaufte Ticket muss vor der Verwendung abgestempelt werden',
                    infoObliterazioneContestuale: 'Die Aktivierung ist gleichzeitig des Kaufes',
                    infoTrenitaliaATAC:
                        'Nach der Richtlinie von Atac Spa, die elektronische Fahrkarte (Bit 100 und AIMOP) sind vorübergehend nicht gültig für die Trenitalia Verkehrsmittel. Für weitere Auskünfte kontaktieren Sie uns bitte per Email an assistenza@mycicero.it oder per Telfon an 0719207000.',
                    noArticoliVendibili: 'Es sind keine verkaufbaren Artikel vorhanden',
                    origineDestinazione: 'Ticket aus den Reiselösungen kaufen ',
                    polimetrica: 'Außerstädtische Dauerkarten',
                    polimetrica2: 'Außerstädtische Dauerkarten',
                    riassuntoInfoBiglietto: 'Zusammenfassung Ticket-Info ',
                    rinnovaAbbonamenti: 'Abonnements erneuern',
                    scegliTitoliTessera: 'Durch Karte eingekaufte Fahrscheine',
                    scegliTitoliTesseraActv: 'Durch Karte eingekaufte Fahrscheine',
                    smsDiAcquisto: 'Telefonnummer: {0} <br/> SMS: {1}',
                    titoliGT: 'Fahrkarten mit bestätigten Plätzen',
                    titoliTessera: 'Fahrscheine auf Karte oder mit Ermäβigung',
                    titoloSelezioneTessera: 'Kaufen Sie Fahrkarten durch der Ausweis ',
                },
                acquistoTitoli: {
                    acquistaGratis: 'Kostenlos herunterladen',
                    scegliComePagare: 'Wählen Sie eine Bezahlungsmodalität:',
                    scegliComePagareFmt: 'Wählen Sie eine Bezahlungsmodalität: {0}',
                    scegliTipologia: 'Typologie auswählen',
                    tipiDiAttivazione: {
                        automatica: 'Der Fahrschein wird aktiv nach dem Einkauf',
                        multipla:
                            'Der Fahrschein muss manuell bei ersten Gebrauch aktiviert werden. Hinzu müssen Sie den Fahrschein jedes Mal abstempeln, dass Sie an Board gehen.',
                        normale: 'Der Fahrschein muss manuell bei ersten Gebrauch aktiviert werden ',
                        obbligatoria: 'Der Fahrschein muss manuell bei ersten Gebrauch aktiviert werden ',
                    },
                    tipoDiAttivazione: 'Aktivierungsart:',
                },
                alCompleto: 'Ausverkauft',
                anticipo: 'Verfrühung',
                arrivi: 'Ankünfte',
                avvisoSD:
                    'Lieber Benutzer, wegen Problemen verbunden mit vermissten E-Tickets (wenn die App auf die SD-Speicherkarte installiert ist), wird die App ab den nächsten Versionen nur auf Ihrem Gerät installiert; um Missstände zu vermeiden, bitten wir Ihnen, die App ab sofort auf das Gerät zu verschieben. Wir bitten um Verständnis. Für  weitere Informationen,  senden Sie uns eine E-Mail an Assistenza@mycicero.it oder erreichen Sie uns telefonisch unter 071 920 7000',
                avvisoSDAVM:
                    'Lieber Benutzer, wegen Problemen verbunden mit vermissten E-Tickets (wenn die App auf die SD-Speicherkarte installiert ist), wird die App ab den nächsten Versionen nur auf Ihrem Gerät installiert; um Missstände zu vermeiden, bitten wir Ihnen, die App ab sofort auf das Gerät zu verschieben. Wir bitten um Verständnis. Für  weitere Informationen,  senden Sie uns eine E-Mail an app.support@avmspa.it',
                cercaFermate: {
                    cercoPassaggi: 'Haltestelle-Zeiten ',
                    codDescriz: 'Code/Beschreibung',
                    comune: 'Eine Stadt wählen',
                    elencoFermate: 'Liste der Haltestelle ',
                    elencoFermateTuaPosizione: 'Liste der Haltestellen in der Umgebung',
                    header: 'Fahrplan an Haltestelle',
                    headerActv: 'Zeiten und Fahrwege suchen',
                    indirizzo: 'Adresse',
                    indirizzoFermata: 'Adresse/Haltestelle',
                    inserisciIndirizzo: 'Adresse eingeben',
                    intornoA: 'Haltestelle in der Nähe von.. zeigen:',
                    lineeServite: 'Bedienten Linien',
                    mostra: 'Haltestelle zeigen',
                    mostraFermate: 'Haltestellen zeigen...',
                    msgNoFermatePreferite:
                        '<p>Es sind keine bevorzugten Haltestellen gespeichert.</p><p>Um eine Haltestelle hinzuzufügen, die Taste "Speichern" im Detail der einzelnen Haltestelle drücken.</p>"',
                    nessunaFermata: 'Keine Haltestelle gefunden.',
                    nessunaLocalita: 'Kein Ort gefunden',
                    noFermateVicine: 'Keine Haltestelle in der Nähe von Ihrer Position verfügbar',
                    noLineeServite: 'Keine gediente Linie',
                    noPassaggi: 'Keinen Vorbeifahren verfügbar',
                    oppure: 'Oder...',
                    passaggiNonPrevisti: 'Keine Ankünfte/Abfahrten vorgesehen',
                    ricerca: 'Suche Haltestellen',
                    ricercheRecenti: 'Jüngste Suchen',
                    stazioneIndirizzo: 'Bahnhof oder Adresse',
                    tramiteCodDescr: 'Durch Kode oder Beschreibung',
                    tuttiPassaggi: 'Allen Vorbeifahren dieser Haltestelle',
                },
                cercaLinee: {
                    comune: 'Eine Stadt wählen',
                    header: 'Linien Suchen',
                    indirizzo: 'Adresse...',
                    intornoA: 'Linien die in der Nähe von .. Fahren',
                    mostra: 'Linien zeigen',
                    nessunaLineaTrovata: 'Keine Linien gefunden',
                    oppure: 'Oder...',
                    ricerchePreferite: 'Favoriten',
                    ricercheRecenti: 'Jüngsten ',
                    tramiteCodDescr: 'Durch Kode oder Beschreibung',
                },
                cercaLocalita: 'Ort suchen',
                cercaVettore: 'Verkehrsunternehmer suchen',
                comuneAziendaEvento: 'Stadt / Unternehmen / Event',
                daConvalidare: 'Zum Aktivieren',
                daObliterare: 'Zum Abstempeln',
                daValidare: 'Zum Aktivieren',
                dettaglioCorsa: 'Detailangaben Fahrt',
                dettaglioLinea: {
                    dettaglioLinea: 'Linien-Details',
                    dimentica: 'Vergessen',
                    disponibilitaFermate: 'Haltestelle:',
                    nessunaCoincidenza: 'Keine Verbindung',
                    nessunaFermata: 'Keine Haltestelle',
                    ricorda: 'Erinnern',
                },
                elencoFermate: 'Liste Haltestellen',
                elencoFermateA: 'Haltestellenliste in:',
                elencoLinee: {
                    descrizione: 'Beschreibung',
                    direzione: 'Richtung ',
                    elencoLinee: 'Linienliste in der Nähe',
                    elencoPercorsi: 'Linienführung',
                    haiCercato: 'Sie haben gesucht:',
                    noPercorsi: 'Keine Fahrt',
                    noSoluzioniVisibili: 'Keine Linie',
                    nonDisponibile: 'Nicht verfügbar',
                    passaggio: 'Durchreise um',
                    passaggioAlle: 'Vorbeifahren um',
                    passaggioOgni: 'Vorbeifahren jeder',
                },
                elencoMovimenti: {
                    header: 'Liste Kontobewegungen',
                },
                fermata: 'Haltestelle',
                fermate: 'Haltestellen',
                header: 'Regionalverkehr',
                linee: 'Linienliste',
                mieiAbbonamenti: {
                    abbonamentiNonTrovati: 'Auf diesem Device sind keine gültigen Abonnements vorhanden.',
                    acquistaRinnova: 'Kaufen/verlängern',
                    articoliDisponibili: 'Verfügbare Artikel',
                    elencoAbbonamenti: 'Liste Abonnements',
                    elencoTessereAttive: 'Aktiver Ausweise',
                    extraUrbano: 'AußerStädtisch',
                    goToMyAbbonamenti: '"Abonnements" aufrufen',
                    header: 'Abonnements',
                    infoAbbonamentiNonTrovati:
                        'Auf diesem Device sind keine gültigen Abonnements vorhanden. Versuchen Sie, bereits vorhandene Abonnements durch betätigen der oben stehenden Schaltfläche zu laden.',
                    infoRequisitiAcquistoHTML:
                        'Zur Tütigung des Kaufs muss ein Ausweis des gewühlten Verkehrsunternehmens zugeordnet werden. Sie können mit wenigen Mausklicks neue hinzufügen, indem Sie mithilfe eines herkömmlichen PC Ihren Geschätzten Bereich auf <a href="#" style="text-decoration: none;">www.mycicero.it</a> aufrufen. In Kürze wird dieser Vorgang auch über mobile Geräte verfügbar sein.',
                    infoTitoliAcquistati:
                        'Sie können den Fahrschein im Bereich "Abonnements" unter "Regionalverkehr" finden',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Sobald Sie den Einkauf abgeschlossen haben, klicken Sie im Abschnitt "Abonnements" und aktualisieren Sie bitte Ihre Liste',
                    nessunaTesseraValida:
                        'Ihren Ausweisen sind keine Abonnements zugeordnet. Eine Verlüngerung ist nicht möglich. Zum Kauf eines neuen Abonnements wenden Sie sich an Ihr Verkehrsunternehmen.',
                    rinnovaAbbonamento: 'Abonnement verlängern',
                    scegliTessera: 'Ausweis wählen',
                    scegliVettoreAbbonamento:
                        'Verkehrsunternehmen Wählen, dessen Abonnement gekauft oder verlängert werden soll.',
                    selezionaArticolo: 'Artikel wählen',
                    soluzioniPossibili: 'Mögliche Lösungen',
                    templateTratta: 'Von {0} bis {1}',
                    ultimaObliterazione: 'Letzte Abstempelung ',
                    urbano: 'Städtisch',
                    validitaLinee: 'Gültig fuer die folgende Linien ',
                },
                mieiBiglietti: {
                    acquista: 'Ticket kaufen',
                    attivi: 'Aktive',
                    daobliterare: 'Zu aktivieren',
                    elencoBigliettiDaObliterare: 'Liste gekaufter Fahrscheine zum Abstempeln',
                    elencoBigliettiUsati: 'Liste verwendeter Fahrscheine ',
                    elencoBigliettiValidi: 'Liste gültiger Fahrscheine ',
                    finoAl: 'Bis',
                    goToMyTickets: '"Meine Ticket" aufrufen',
                    header: 'Meine Tickets',
                    infoTitoliAcquistati: 'Sie können den Fahrschein im Abschnitt "Meine Tickets"',
                    noTitoliAttivi: 'Keine gültigen Tickets gefunden',
                    noTitoliDaObliterare: 'Keine Tickets gefunden zu validieren',
                    noTitoliScaduti: 'Keine gültigen Tickets gefunden',
                    obliterati: 'Gestempelt und gültig',
                    scadenzaTime: 'gültig bis',
                    scaduti: 'Abgelaufen',
                    validita: 'Gültigkeit',
                    validoDal: 'Gültig ab',
                    validoFinoAl: 'Gültig bis',
                },
                mostraAltreFermate: 'Andere Haltestellen zeigen',
                mostraAltreLinee: 'Andere Linien zeigen',
                mostraAltreStazioni: 'Andere Bahnhof-Haltestellen zeigen',
                mostraAltriPassaggi: 'Fahrplan an dieser Haltestelle zeigen ',
                obliterazioneAutomatica: 'Automatische Abstempelung nach dem Kauf',
                partenze: 'Abfahrten',
                passaggi: 'Vorbeifahrten',
                percorsi: 'Fahrwege',
                prossimoTra: 'Die nächste um',
                pulisci: 'Löschen',
                ricaricaCredito: {
                    header: 'Guthaben aufladen',
                    ricaricaActvWarning:
                        'Die Restbetrag, dass allenfalls nach Einkäufe und Landungen noch verfügbar ist, es ist keinesfalls rückerstattbar ',
                },
                ritardo: 'Verspätung',
                scaduti: 'Abgelaufen',
                scegliVettore: 'Nach Stadt, Unternehmen oder Event suchen',
                scegliVettorePlaceholder: 'Unternehmen/Event',
                seiVicino: 'Sie befinden sich hier in der Nähe',
                servizioNonAttivo:
                    'Sie haben den Service "Regional-/Fernverkehr" noch nicht aktiviert. Es dauert nur einen Moment.',
                soluzioniViaggio: {
                    cercaCollegamentiLocali: 'Lokalen Verbindungen suchen',
                    cercaSoluzioni: 'Lösungen suchen',
                    elencoSoluzioni: 'Lösungsverzeichnis',
                    frequenzaOgni: 'Jede',
                    header: 'Reiselösungen',
                    headerAndata: 'Hinreiselösungen',
                    headerRitorno: 'Rückreiselösungen',
                    invertiDirezione: 'Richtung umkehren',
                    mostra: 'Zeigen:',
                    mostraSuMappa: 'Fahrweg auf Karte',
                    nessunCollegamentoLocale: 'Keine lokale Verbindungen',
                    nessunaDestinazione: 'Keine Bestimmungsorten für diese Suchkriterien gefunden',
                    nessunaSoluzione: 'Keine Reiselösung gefunden',
                    noSoluzioniVisibili: 'Keine Ergebnisse gezeigt',
                    nonAcquistabile: 'Lösung kann nicht gekauft werden',
                    nonTuttiBigliettiAcquistabili: 'Nicht alle Tickets können gekauft werden',
                    ordinaPerOrarioArrivo: 'Nach Ankunftsuhrzeit ordnen',
                    ordinaPerOrarioPartenza: 'Nach Abfahrtsuhrzeit ordnen',
                    ordinaPerSoluzioniAcquistabili: 'Nach küuflichen Lösungen ordnen',
                    ordinaPerTempoTotale: 'Nach Gesamtzeit ordnen',
                    salvaRicercaPreferitaInfo:
                        'Zum Hinzufügen die Taste "Speichern" auf der Seite mit den Ergebnissen der Suche nach der Reiselösung drücken.',
                    scambia: 'Umkehren',
                    tempoTotale: 'Gesamtzeit',
                    tuttiBigliettiAcquistabili: 'Alle Tickets können erworben werden',
                },
                tipoServizio: 'Serviceart',
                trenitalia: {
                    altreInfo: 'Weitere Auskünfte',
                    cartaFreccia: 'CartaFRECCIA',
                    condizioni:
                        'Die elektronische Regionale Karte wird ausgestoßen als schon entwertet. Es ist nicht möglich den Abfahrt vorwegnehmen und die Karte ist nicht rückzahlbar. Die Karte ist namentlich und an Vorname und Name vereinigt, die bei der Anmeldung oder im Reisendenangaben eingefügt wurden; die online gekaufte Karte für regionalen Züge müssen – nach Kontrolleuranfrage – in Papierform (vor dem Abfahrt, drücken Sie den .pdf, der beigelegten an der Einkaufsmail ist) oder durch den Schirm eines elektronisches Apparates (pc, tablet, smartphone) zusammen mit einem gültigen Ausweisdokument vorzeigt werden.',
                    condizioniAcquistoTrenitalia:
                        'Ich akzeptiere <a href="#" onclick="javascript: openLinkOnBrowser(\'http://www.trenitalia.com/tcom/Informazioni/Condizioni-Generali-di-trasporto/Condizioni-Generali-di-trasporto\',true)"> die Beförderungsbedingungen</a>  des Transport-Unternehmens und habe<a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/cms-file/html/trenitalia/Informativa_sulla_privacy.html\',true)">die Datenschutzerklärung gelesen</a>.',
                    infoTariffa: 'Tarifauskunft',
                    menu: 'Trenitalia',
                    modificaBigliettoHeader: 'Ticket-Änderung',
                    modificaBigliettoMessage:
                        "<div class='textAlignLeft'><p>Bei den folgenden Änderungsbedarfen:<br /><ul><li>Buchungsänderung (Abfahrtsdatum/Zeit)</li><li>Ticketsänderung (Abreise-/Zielort; Ticketsart; Passagierenanzahl usw)</li><li>Anfrage nach Ticket-Erstattung, bei Reiserücktritt</li></ul></p><p class='bold'>Bitte erreichen Sie den nächstgelegensten Bahnhof und zeigen Sie dieses Ticket.</p></div>",
                    percorsoFerroviario: 'Route',
                    popupDiniego: {
                        cancelLabel: 'Ich will keine Kontaktdaten zurücklassen',
                        confirmLabel: 'Kontaktdaten einziehen',
                        content:
                            'Sie haben nicht die Kontaktsdaten für alle Passagiere zurückgelassen. Trenitalia kann sie nicht über diese Reise kontaktieren',
                        title: 'Aufpassen',
                    },
                    riepilogo: 'Resümee',
                    stazioneArrivo: 'Ankunftsstation',
                    stazioneNonValida: 'Station nicht gültig',
                    stazionePartenza: 'Abfahrtsstation',
                    tariffe: 'Gebühren',
                    viaggioAndata: 'Hinreise',
                    viaggioRitorno: 'Rückreise',
                    vuoiModificareIlBiglietto: 'Möchten Sie Ihre Fahrkarte ändern?',
                },
                tutteLeLocalita: 'Alle Orte ',
                vaiAlleImpostazioni: 'Zur Einstellungen',
                validazioneAutomatica: 'Diese Fahrkarte wird automatisch entwerten',
                zoneServite: {
                    header: 'Vom Service erreichte Gebiete',
                },
            },
            travels: {
                details: {
                    header: 'Details',
                },
            },
            treasureHunt: {
                abbandonaSquadra: 'Sind Sie sicher diese Mannschaft abzugeben?',
                aggiornaProcedi: 'Aktualisieren und machen Sie weiter',
                aggiungiGiocatore: 'Spieler ',
                cacciaAlTesoro: 'Schnitzeljagd',
                checkVideoCaricato:
                    'Sind Sie sicher, dass Sie das Video verladen haben und dass Sie fortsetxen wollen?',
                codiceSquadra: 'Mannschaft Kode',
                comeFunziona: 'Wie funktioniert es?',
                compilaCampi: 'kompilieren die Felder',
                compitoCompletato: 'Aufgabe ergänzt',
                completaPagamenti: 'ergäzen die  Bezahlungen',
                countDownInizioGiocoAfter: 'das Spiel is von {0} angefangen',
                countDownInizioGiocoBefore: 'Noch {0} bis Spielbeginn',
                countDownInizioGiocoSame: 'Wir sind dort…',
                createTeam: 'Ich will eine neue Mannschaft suchen',
                erroreAggiungiGiocatore: 'Es ist unmöglich einen Menschen eigenem Mannschaft anzufügen',
                erroreCaricamentoGiochi:
                    'Ein Fehler beim Laden des Spiels ist aufgetreten. Bitte versuchen Sie es wieder später',
                erroreCaricamentoGioco:
                    'Ein Fehler beim Laden des Spiels ist aufgetreten. Bitte versuchen Sie es wieder später',
                erroreCheckLocation: 'Es tut uns leid.<br />Ein Fehler ist augetreten.',
                erroreInfoTeam: 'Es ist nicht möglich die informationen uber das Team wiederherstellen',
                erroreRimozioneGiocatoreQuotaPagata:
                    'Es ist unmöglich den Spieler beseitigen, weil er den Mitgliedbeitrag bezahlt hat.',
                erroreRimozioneGiocatoreQuotaSquadraPagata:
                    'Es ist unmöglich den Spieler beseitigen, weil er den Mitgliedbeitrag des Mannshaftes bezahlt hat.',
                faseRisoltaDalTeam: 'Ihre Gruppe hat diese Phase schon beheben',
                garaFinita: 'Der Wettstreit ist beendet',
                giocaNoSmartphone:
                    'Bei disem Modus wird der Spieler and der Schnitzeljagd teilnehmen aber kann nicht seines/ihres Smartphone nutzen.',
                giocatori: 'Spieler',
                gpsGenericError:
                    'Es tut uns leid.<br />Sie haben keine Erlaubnis ergeben, um die  GPS Position nachzuholen. Es tut uns leid.<br /> Ein Fehler ist aufgetreten.',
                gpsPermissionDenied:
                    'Es tut uns leid.<br />Sie haben keine Erlaubnis ergeben, um die  GPS Position nachzuholen.',
                gpsPositionUnavailable: 'Es tut uns leid.<br />Es war nicht möglich die GPS Position nachzuholen. ',
                gpsTimeout:
                    'Es tut uns leid.<br />Ein Fehler mit den GPS ist augetreten. <br />Bitte kontrollieren Sie die GPS Antenne und die Erlaubnisse, dann starten Sie die App neu.',
                graziePerLaRisposta: 'Danke für die Antwort!',
                indizio: 'Anzeichen',
                infoIscrizione:
                    'Die Anmeldung ist gültig nach der Bezahlung. Die Mannschaft kann spielen nach dem alle Anteile gezahlt werden.',
                invitaGiocatore:
                    'Senden eine Einladung einem neuen Spieler. Sie/Er wird den Kode mit dem direkt das Spiel zu betreten. ',
                invitaGiocatoreNoEmail: 'Hat den Spieler keine Email oder social Kontakt? Fügen Sie sie/ihn hinzu {0}.',
                iscrizioneSquadra: 'Mannschaft Anmeldung',
                iscrizioniChiuse: 'Es tut uns leid, Sie können diesen Wettstreit nicht anmelden.',
                itinerariSorpresa: 'Überraschung Reiserouten',
                itinerarioSorpresa: 'Überraschung Reiseroute',
                joinTeam: 'Ich werde eingeladen und habe ein Kode',
                luogo: 'Ort',
                luogoGiusto: 'Kompliment!<br />Das ist den richtigen Ort.',
                luogoSbagliato: 'Ers tut uns leid.<br />Das ist nicht den richtigen Ort.',
                nessunGioco:
                    'Sie können früh lustige Spiele finden, um die Schönheit von lece zu entdecken!<br />Schnitzeljagd, quiz und Überraschung Reiserouten werden dich nach den am bezeichnendesten Orte, durch Geschichte, Kunst und Önogastronomie von einer der am schönsten Italienische Städte einweisen.',
                nomeSquadra: 'Mannschaft Name',
                nomeSquadraErrore: '20 Buchstaben am meinsten',
                pagaQuotaGiocatore: "Sind Sie sicher, dass Sie für diesen Spieler bezahlen wollen '{0}'",
                pagaQuotaSquadra: 'Sind Sie sicher, dass Sie den Einschreibungsanteil des Mannschafts bezahlen wollen?',
                pagamentiNonCompletati: 'Sie haben die Bezahlungen noch nicht ergänzt',
                prossimoIndizioConPenalita: 'Nächste Anzeichen (aber verlieren Sie {0} Punkte)',
                quizzone: 'Quiz',
                quotaGiocatoreNonPagata:
                    'Einer des Mannschaftsmitglieder hat den Anteil nicht bezahlt. Streichen Sie sie/ihn auf oder zhalen ihren/seine Anteil.',
                quotaSquadraNonPagata: 'Um weiterzugehen ist es nötig  den Anteil der Mannschaft zu zahlen',
                raggiungiLuogo: 'Den Ort erreichen',
                rimuoviGiocatore: 'Sind Sie sicher {0} zu beseitigen?',
                rispostaEsatta: 'Richtige Antwort',
                rispostaSbgliata: 'Falsche Anwort',
                scegliNomeSquadra: 'Wählen Sie eine nette Nachricht, das ist einfach zu erinnern',
                shareEvent: 'Tragen das Ereignis mit Ihre Freunde mit',
                svelamiLuogo: 'Ja, verrate mich den Ort ',
                svelamiLuogoConPenalita: 'Verrate mich den Ort (aber ich verliere {0} Punkte)',
                tornaAlGioco: 'Zurück zum Spiel',
                tornaAllInizio: 'Nein, zurück zum Beginn',
                traguardo: 'Ziel',
                verificaLuogo: 'Kontrollieren wenn ich in den richtigen Orte angekommen bin',
                whoo: 'Whoo-hoo!',
            },
            tua: {
                AcquistaBiglietti: 'Fahrkarten<br/>kaufen',
                AcquistaBigliettiHTML: 'Fahrkarten<br/>kaufen',
                CalcolaPercorsoHTML: 'Reise<br/>calculieren',
                FermateOrariHTML: 'Haltestelle und<br/>Fahrpläne',
                MieiTitoli: 'Meine<br/>Fahrkarten',
                MieiTitoliHTML: 'Meine<br/>Fahrkarten',
                SostaInAbruzzoHTML: 'In Abruzzo<br/>parken',
                UltimeNotizieHTML: 'Letzte<br/>Nachrichten',
                bigliettiTariffaFissa: 'Fahrkarten mit fixen Preis',
                soluzioneNonAcquistabile:
                    'Leider können Sie diese Fahrkarte jetzt nicht kaufen.<br/>Wollen Sie wissen wenn wird sie noch verfügbar sein?<br/><br/>Bitte, kontaktieren Sie uns zu Telefonnummer<a href="tel:800762622">800762622</a> oder senden eine Mail zu <a href="mailto:infotrasporto@mycicero.it">infotrasporto@mycicero.it</a>',
            },
            turismo: {
                buoniDisponibili: 'verfügbare Gutscheine',
                buoniEsauriti: 'ausgegangene Gutscheine',
                buoniUtilizzati: 'gebrauchte Gutscheine',
                caricaAltri: 'Nächste 10',
                caricamentoInCorso: 'Laden',
                cerca: 'Suchen',
                cercaCoupon: 'Coupon suchen',
                cercaCouponPlaceholder: 'Einen Coupon suchen',
                cercaEventi: 'Ereignisse suchen',
                cercaEventiPlaceholder: 'Ein Ereignis suchen',
                cercaIndirizzoPlaceholder: 'Adresse oder Örtlichkeit',
                cercaItinerariPlaceholder: 'Eine Route suchen',
                cercaItinerario: 'Reiserouten suchen',
                cercaPoi: 'POI suchen',
                cercaPoiPlaceholder: 'Einen Ort suchen',
                cercaProdotti: 'Produkte suchen',
                cercaProdottiPlaceholder: 'Ein Produkt suchen',
                cercaServiziPlaceholder: 'Einen Dienst suchen',
                cercaServizio: 'Dienste suchen',
                concluso: 'Abgeschlossen',
                condizioni: 'Bedingungen',
                costoDelBuono: 'Gutscheine Preis:',
                costoInCrediti: 'Guthaben Preis:',
                couponCorrelati: 'Hier finden Sie auch',
                couponGratuito:
                    'Dieses Gutschein ist frei und Sie können es haben ohne Ihre Guthaben zu verschliessen: Sie sollen nur auf "Gutschein bekommen" um es zu aktivieren. ',
                creditiConvertiti: 'Verwandelte Guthaben:',
                creditiPerCouponsPresso:
                    'Sie haben noch {0} Guthaben, die Sie zu Gutscheinen weiterverarbeiten können. Sie können diese Guthaben bei {1} anwenden.',
                creditiPerCouponsTerminatiPresso: 'Sie haben nicht genüg Guthaben, um Gutscheine bei {0} zu gewinnen.',
                creditiResiduiTotali: 'Verbleibende Gesamtguthaben',
                creditiRimanenti: 'Verbleibende Guthaben:',
                creditiTotali: 'Gänzliche Guthaben:',
                creditoPerCouponsPresso:
                    'Sie haben noch {0} Guthaben, die Sie zu Gutscheinen weiterverarbeiten können. Sie können diese Guthaben bei {1} anwenden.',
                dataAlle: '{0} um {1}',
                dataCreazione: 'Erschaffungsdatum:',
                dataDalleAlle: '{0} von {1} bis {2}',
                dataInizioDalleDataFineAlle: 'Von {0} um {1} zum {2} am {3}',
                dataInizioDataFine: 'Von {0} zu am {1}',
                dataOra: 'Datum und Uhrzeit',
                detail: {
                    cellulare: 'Handynummer',
                    certificazioni: 'Zertifizierungen',
                    citta: 'Stadt',
                    contatto: 'Kontakt',
                    costs: 'Einganga',
                    couponCorrelati: 'Sonderangeboten',
                    email: 'E-mail',
                    eventiCorrelati: 'Korrelative Ereignisse',
                    facebook: 'Facebook',
                    fax: 'Fax',
                    gestione: 'Organisation',
                    giorno: 'Tag {0}',
                    header: 'Kontakte',
                    indirizzo: 'Adresse',
                    itinerariCorrelati: 'Korrelative Reiseroute',
                    luoghiCorrelati: 'Korrelative Orte',
                    navetteCorrelate: 'Pendelfahrzeuge, die hierher fahren',
                    note: 'Aufzeichnungen',
                    ospiti: 'Wichtige Gäste',
                    promo: 'Promo',
                    propostoDa: 'Vorgeschlagen von',
                    quando: 'Wann',
                    scaricaAllegati: 'Die  beigelegte Dokumente herunterladen',
                    serviziInclusi: 'Einbezogene Dienste',
                    serviziUtili: 'Nützliche Dienste',
                    sitoWeb: 'Web',
                    sitoWebOrganizzatore: 'Webseite des Veranstalters',
                    social: 'Social',
                    specialitaCorrelate: 'Korrelate Produkte',
                    tappa: 'Etappe{0}:',
                    tel: 'Tel',
                    telefono: 'Telefon',
                    temi: 'Themen',
                    troviAnche: 'Korrelate Promotione',
                    url: 'web',
                    vaiAlSito: 'Zu der Webseite',
                    zoneProduzione: 'Herstellungsgebiet',
                },
                details: 'Details',
                dettagli: 'Details',
                diarioDiViaggio: 'Tagbuch',
                downloads: 'Downloads',
                error: {
                    cantFilterAroundYou:
                        'Es ist nicht möglich das Filter "um dich herum" einstellen, wenn die GPS-Stellung nicht verfügbar ist.',
                    cantOrderByDistance:
                        'Es ist nicht möglich die Sortierung "nach der Entfernung" einstellen, wenn die GPS-Stellung nicht verfügbar ist.',
                },
                erroreGenerazioneQrCode: 'Während die Qr Code Erschaffung is es ein Fehler aufgetreten',
                esperienze: 'Erfahrungen',
                estendiRaggioRicerca: 'Den Sucheumkreis strecken',
                eventi: 'Ereignisse',
                favorites: {
                    errorAddFavorites:
                        'Ein Fehler ist währen des Favorit Speichern aufgetreten. Bitte, überzeugen Sie,dass Sie mit dem Internet verbunden sind und versuchen Sie es noch einmal.',
                    errorDeleteFavorites:
                        'Ein Fehler ist währen des Favorit Löschens aufgetreten. Bitte, überzeugen Sie, dass Sie mit dem Internet verbunden sind und versuchen Sie es noch einmal.',
                    errorGetFavorites: 'Ein Fehler ist währen des Favoriten Ladens aufgetreten.',
                    errorUpdateFavorites:
                        'Ein Fehler ist währen der Favorit Änderung aufgetreten. Bitte, überzeugen Sie, dass Sie mit dem Internet verbunden sind und versuchen Sie es noch einmal.',
                },
                filters: {
                    afternoon: 'Nachmittag',
                    allDay: 'der ganze Tag',
                    aroundYou: 'Um Sie herum',
                    cosa: 'Was',
                    dataSpecifica: 'Bestimmten Datum auswählen',
                    everywhere: 'Überall',
                    fasciaOraria: 'Zeitabschnitt',
                    morning: 'Morgen',
                    night: 'Abend',
                    oggi: 'Heute',
                    perData: 'Per Datum',
                    perDistanza: 'Per Entfernung',
                    perRilevanza: 'Per Relevanz',
                    perScadenza: 'Fällig',
                    perSconto: 'Per Rabatt',
                    periodoSpecifico: 'Eine bestimmte Periode auswählen',
                    prossimi30Giorni: 'In der nächsten 30 Tagen',
                    prossimi7Giorni: 'In der nächsten 7 Tagen',
                    quando: 'Wann',
                },
                filtra: 'Filtern',
                filtraEventi: 'Ereignisse filtern',
                filtraItinerari: 'Reiserouten filtern',
                filtraLuoghi: 'Orte filtern',
                filtraOrdina: 'Filtern und arrangieren',
                filtraProdotti: 'Produkte filtern',
                filtraPromo: 'Promotionen filtern',
                filtraServizi: 'Dienste filtern',
                inserisciNota: 'Eine Nachricht einsetzen',
                itinerari: 'Reiserouten',
                leggiCondizioni: 'Bedingungen lesen',
                luoghi: 'Orte',
                mostraQrCodeAllaCassa: 'Zeigen den Qr Code zur Kasse, um den Gutschein zu nutzen',
                neiParaggi: 'In der Nähe',
                nessunPreferitoSalvato: 'Im Moment ist dieser Abschnitt leer',
                noAvailableCoupons: 'Sie finden hier die Gutscheine',
                noCreditsReport: 'Sie finden hier Ihre Guthaben - Zusammenfassung',
                noResults: 'Keine Ergebniss gefunden',
                noUsedCoupons: 'Sie finden hier die Zusammenfassung der benutzten Gutscheine',
                note: 'Nachrichte',
                numCrediti: '{0} Guthaben',
                numOfRemainingCoupons: '{0}  Gutschein</br>verbleibende',
                offerteSpeciali: 'Sonderangeboten',
                oneRemainingCoupon: '1 Gutschein</br>verbleibende',
                ora: 'Uhr',
                ordina: 'Ordnen',
                ordinaEventi: 'Ereignisse ordnen',
                ordinaItinerari: 'Reiserouten ordnen',
                ordinaLuoghi: 'Orte ordnen',
                ordinaPromo: 'Promotionen ordnen',
                ordinaServizi: 'Dienste ordnen',
                ottieniBuoni: 'Bekommen Guthscheine',
                pisteCiclabili: 'Radwege',
                preferiti: 'Favoriten',
                preferitiDiarioViaggio: 'Favoriten und Reisetagebuch',
                presso: 'Bei: {0}',
                prodotti: 'Produkte',
                prodottiTipici: 'Typische Produkte',
                promo: 'Sonderaktion',
                quantiBuoniVuoi: 'Wie viele Guthscheine wollen Sie?',
                ricercaIncorso: 'Suchen',
                rimuoviDataOra: 'Datum und Uhrzeit beseitigen',
                rimuoviOrario: 'Uhrzeit beseitigen',
                risultatiEntro: ' Sie haben binnen {0} gesucht',
                saldoRimanente: 'Rest:',
                scansionaQrCode: 'Scannen den QR Code',
                scansionaQrCodeAllaCassa: 'Scannen den QR Code in der Kasse',
                scaricaAllegati: 'Die beigelegten Dokumente',
                scegliData: 'Datum wählen',
                sconto: 'Rabatt',
                servizi: 'Diensten',
                serviziUtili: 'nutzliche Dienste',
                shopping: 'Shopping',
                toccaPerIngrandire: 'Tippen zum Vergrößen',
                trasformaCreditoInBuoni: 'Verarbeiten Sie Ihres Guthaben zu Gutscheinen weiter',
                trasformaTotCreditoInBuoni:
                    "Sie werden <span class='secondary bold'>{0}</span> nutzen um einen <span class='secondary bold'>{1}€</span> Rabattschein zu bekommen. Sie können diese Rqabattschein bei diesem Sponsor zu verwenden.",
                tuoiCreditiBuoni: 'Ihre Guthaben und Gutscheine',
                unCredito: '1 Guthaben',
                utilizzaTuoiCrediti: 'Nutzen Ihre Guthaben',
                utilizzatoIl: 'Benutzt am:',
                validoFinoA: 'Gültig bis',
                valoreBuono: 'Guthaben Wert:',
                valoreBuonoPressoSponsor: 'Diese Sponsor stellt zur Verfügung {0}€ Gutscheine. ',
                valoreCumulativoBuono: 'Kumulativer Gutscheinwert:',
                valoreInEuro: 'Wert in Euro',
                withinRange: 'Bis zum {0}',
            },
            unicoc: {
                acquistaTicket: 'Kaufen Fahrkarten',
                calcolaPercorso: 'Die Fahrstrecke errechnen',
                mieiTitoli: 'Meine Fahrkarten',
                puntiVendita: 'Verkaufstsellen',
                trovaTariffa: 'Finden den Tarif',
            },
            ventis: {
                cambiaZona: 'Zone wechseln',
                effettuaLogin: 'Einloggen',
                homeTitle: 'Ventis begrüßt Sie in {0}',
                hometitleNoPos: 'Ventis begrüßt Sie',
                infoCredito:
                    'myCicero-Guthaben mit Kreditkarte oder Satispay, MasterPass oder auch in einem SisalPay Geschäft aufladen. <b>Mit dieser Bezahlungsoption haben Sie keine Zusatzkosten.</b> myCicero-Guthaben kann auch benutzt werden, um Fahrschiene/Tickets zu kaufen oder die anderen verfügbaren Dienste zu bezahlen.',
                loginMessage: 'Um diese App nutzen, braucht man als angemeldete <b>Ventis</b> Benutzer einloggen.',
                registrati: 'Anmelden',
                requisitiAccesso: '',
                serviziTuttaItalia: 'Unsere Service sind aktive im ganzen Italien',
                tutorial: {
                    subtitle1: 'Entdecken die Sonderangeboten für Ventis Kunden',
                    subtitle2: 'Bezahlen nur die echten Parkminuten durch Ventis Mobility',
                    subtitle3: 'Bequem mit einem Klick durch die app Ventis Mobility',
                    subtitle4: 'Sie finden bis zu 70% Rabatt für alle großen Marken',
                    subtitle5: 'Bequemlichkeit und Einsparung maßgeschneiderte für Sie',
                    subtitle6: '',
                    title1: 'Willkommen in Ventis Mobility',
                    title2: 'Parkenkosten sparen',
                    title3: 'Kaufen Zug-, Bus- und U-Bahn Fahrkarten',
                    title4: 'Die Webseite Ventis.it nicht zu versäumen',
                    title5: 'Alle in einer App',
                    title6: '',
                },
            },
            visitRomagna: {
                dormi: 'Schlafen',
                erroreCaricamentoDati: 'Ein Fehler ist währen Datenladen aufgetreten. ',
                fermati: 'Halten Sie',
                mostraTuttiEventi: 'Alle Ereignisse aufzeigen',
                muoviti: 'Bewegen Sie ',
            },
        },
    },
    bg: {
        translation: {
            account: {
                accedi: 'Вход',
                accountNonAttivo: 'Профилът не е потвърден',
                benvenuto: 'Добре дошли!',
                cambiaPassword: 'Смяна на парола',
                cambioEmailInserisciPinPage: {
                    annullaModifiche: 'Отмяна на промените',
                    errorePin: 'Грешка: въведеният от Вас PIN не е правилен',
                    inserisciPin: 'PIN',
                    istruzioniInserisciPIN:
                        'Моля, въведете ПИН код за потвърждение, който ще намерите в имейла, изпратен до',
                    operazioneAvvenutaInfo: 'Операцията е завършена успешно',
                    operazioneAvvenutaTitle: 'Имейлът Ви бе променен успешно',
                },
                cambioEmailPage: {
                    cambiaEmail: 'Променете имейл адреса',
                    emailAttuale: 'Текущ имейл',
                    eseguiCambioEmail: 'Напред',
                    inserisciNuovaEmail: 'Изберете нов имейл',
                    istruzioniPIN: 'Ще получите имейл с код за проверка, който трябва да се въведе на  следния екран.',
                    validazioneEmailInCorso: 'Проверка',
                },
                cambioPasswordPage: {
                    erroreCambioPassword:
                        'Възникна грешка при смяна на паролата. Моля, свържете се с нашия отдел Поддръжка.',
                    info:
                        'Новата парола трябва да се състои от минимум <span class = {0} "> 8 </span> до максимум <span class =" {1} "> 26 </span> знака и да <span class =" {2} "> съдържа поне число </span>. <Span class =" {3} "> Не са позволени специални знаци </span>. <br/> <span class =" {4} "> Новата парола трябва да се различава от предишната парола </span>. ',
                    infoPassword:
                        'Паролата трябва да съдържа най-малко 8 знака, от които поне един трябва да бъде число.',
                    inserisciNuovaPassword: 'Нова парола',
                    inserisciPassword: 'Текуща парола',
                    inserisciVecchiaPassword:
                        'Искате ли да промените паролата? От съображения за безопасност, моля, въведете текущата си парола:',
                    mostraPassword: 'Показване на парола',
                    passwordDiverse: 'Двете пароли трябва да си съответстват',
                    passwordUguali: 'Новата парола трябва да съответства на старата',
                    procedi: 'Напред',
                    ripetiNuovaPassword: 'Потвърждение на новата парола',
                    success:
                        'Паролата бе променена успешно. Моля, влезте отново с Вашето потребителско име и нова парола.',
                },
                completaRegistrazione: 'Завършете регистрацията',
                completaRegistrazioneMsg:
                    'За да продължите с този профил е необходимо регистрацията да бъде завършена.',
                confermaLogout:
                    'В случай, че продължите, текущият потребител ще бъде изключен. Ще може да влезете отново, след като въведете потребителското си име и парола.',
                connessioneAssente: 'Неуспешно влизане: Не е достъпна Интернет връзка',
                dataIscrizione: 'Регистриран на',
                datiErrati: 'Неуспешно влизане: неправилно потребителско име или парола',
                datiNonCorretti: 'Грешно потребителско име или парола',
                effettuaLogout: 'Изход',
                eliminazioneDati: {
                    eliminazioneLabel: '',
                    eliminazioneTitle: '',
                    errorTitle: '',
                    successoTitle: '',
                    successolabel: '',
                },
                emailInesistente: 'Предоставеният имейл адрес не е свързан с нито един активен профил',
                emailNonValida: 'Грешен имейл',
                emailVuota: 'Въведете Вашия имейл',
                login: 'Вход',
                loginPage: {
                    accedi: 'Влезте в профила си:',
                    effettuaAccesso: 'Вход',
                    iscrivitiAmyCicero: 'Регистрирай се!',
                    mostraPassword: 'Показване на парола',
                    nessunAccount: 'Нямате ли профил?',
                    seHaiGiaUnAccount:
                        'В случай, че вече сте регистрирали профил с <span class = "highlighted"> autobus.it </span>, може да използвате същите идентификационни данни',
                },
                logout: 'Изход',
                logoutEffettuato: 'Потребителят е изключен',
                logoutUtente: 'Изход на потребителя',
                passwordDimenticata: 'Забравена парола?',
                passwordDimenticataPage: {
                    email: 'Имейл адрес',
                    erroreResetPassword:
                        'Възникна грешка при нулирането на паролата Ви. Моля, свържете се с нашия отдел Поддръжка за съдействие',
                    impossibileResettarePassword:
                        'В момента системата не може да нулира паролата Ви. Моля, опитайте отново по-късно или се свържете с нашия отдел Поддръжка, за да получите допълнителна помощ',
                    info: 'Напишете имейл адреса, който сте използвали за регистрацията. Ще получите временна парола.',
                    sendPasswordTemporanea: 'Изпратете ми временна парола',
                    success:
                        '<p> Временната парола бе изпратена на имейл адреса: </p> <p class = "textAlignCenter"> <b> {0} </b> </p> <p> Нямате получена инструкция? <ul> < li class = "fontSizeTiny"> Проверете в спама на пощата си </li> <li class = "fontSizeTiny"> Проверете предоставения имейл адрес </li> <li class = "fontSizeTiny"> Опитайте отново след няколко минути </li> < li class = "fontSizeTiny"> Може да сте използвали различен имейл адрес за Вашата регистрация </li> </ul> </p>',
                },
                passwordNonValida: 'Невалидна парола',
                profilo: {
                    accedi: 'Влезте в профила си',
                    accediAccount: 'Вход',
                    gestioneTarghe: 'Управлявайте Вашите регистрирани автомобили',
                    gestisciCarteCredito: 'Управление на кредитни карти',
                    header: 'Потребителски профил',
                    impostazioniNotifica: 'Настройки на известията',
                    preferenzeSosta: 'Опции за паркиране',
                    uploadImmagineProfiloFail:
                        'В момента не е възможно да промените снимката на профила си. Моля, опитайте по-късно',
                    uploadImmagineProfiloRetry:
                        'Възникна проблем при изпращането на снимката на сървъра. Искате ли да опитате отново?',
                    uploadImmagineProfiloWait:
                        'Изображението е запазено и сега се обработва, така че не може да се види веднага',
                    v2: {
                        apps: {
                            header: 'Свързано приложение',
                        },
                        associaTessera: 'Свържете нова карта за пътуване',
                        cambiaFotoProfilo: 'Променете изображението на потребителския си профил',
                        chattaConAssistenza: 'Свържете се с нашия отдел за Поддръжка',
                        condividi: 'Споделяне…',
                        datiFatturazione: {
                            aggiungiProfiloFatturazione: 'Добавете данни за фактурирането',
                            attivaFatturazione: 'Имам нужда от фактурата',
                            confermaEliminazioneProfilo:
                                'Сигурни ли сте, че искате да изтриете данните за фактуриране?',
                            confermaModificaProfilo: 'Сигурни ли сте, че искате да промените данните за фактуриране?',
                            confermaRitornoAlProfilo:
                                'Искате ли все пак да се върнете на страницата на потребителския си профил?',
                            genericError: '',
                            header: 'Данни за фактуриране',
                            infoFatturazione:
                                'Моля, обърнете внимание, че фактурата/касова бележка ще бъде изпратена на имейл само за паркинг компаниите и за услугите, които осигуряват издаването на фактура /касова бележка. Във всички останали случаи ще бъде изпратено потвърждение за плащане.',
                            label: 'Данни за фактуриране',
                            modificaProfiloFatturazione: 'Промяна на данните за фактуриране',
                            modificheSalvate: 'Вашите промени са запазени',
                            profiloSalvato: 'Данните Ви за фактуриране бяха запазени',
                            rimuoviProfilo: 'Изтриване на профила…',
                        },
                        datiPersonali: {
                            cambia: 'Промяна',
                            haiTesseraAssociata: 'Имате свързана карта',
                            header: 'Лични данни',
                            label: 'Лични данни',
                            nonPuoiModificareDati:
                                'Вашите лични данни вече са актуализирани и не могат да бъдат променяни допълнително. За всякакви искания, моля, изпратете имейл до',
                            perCancellareUtente: 'Моля, изпратете заявка до',
                            vuoiCancellareUtente: 'Искате ли да изтриете профила си?',
                        },
                        elencoMovimenti: 'Отчет на транзакциите',
                        eliminaDatiPersonali: '',
                        eliminazioneDatiPersonali: '',
                        eliminazioneDatiPersonaliModalContent: '',
                        esci: 'Изход',
                        gestioneAffiliazioni: 'Управление на партньорства',
                        gestioneCarte: 'Управлявайте картите си',
                        gestioneCreditiMobilita: '',
                        ilTuoCredito: 'Вашият кредит',
                        linguaApplicazione: 'Език на приложението',
                        notifichePush: 'Push известия',
                        preferenzeConsultazione: {
                            deselezionaTutto: 'Премахване на всичко от избора',
                            erroreCaricamento:
                                'Възникна грешка при зареждането на предпочитани. Моля, опитайте по-късно.',
                            erroreSalvataggio:
                                'Възникна грешка при записването на предпочитани. Моля, опитайте по-късно.',
                            header: 'Предпочитания за сърфиране',
                            infoGestione: 'Управлявайте и редактирайте предпочитанията си за сърфиране в съдържанието',
                            label: 'Предпочитания за сърфиране',
                            nessunServizioInPreferenze:
                                'Не сте запазили услуги в предпочитанията си. Може да управлявате предпочитанията си в „Предпочитания за консултации“, достъпни от потребителския Ви профил. Ако предпочитате да виждате всички услуги, отново кликнете върху „Прилагане на предпочитанията“, за да премахнете филтъра от видимостта на съдържанието.',
                            salvaModifiche: 'Премахване на всичко от избора',
                            selezionaTutto: 'Избери всички',
                        },
                        preferenzePush: {
                            header: 'Push известия',
                        },
                        ricaricaCredito: 'Заредете допълнително кредита си',
                        sosta: {
                            comePagare: 'Как да платя',
                            gestioneTarghe: 'Управлявайте автомобилите си',
                            gestisciZsr: 'Управление на сезонен код за билети',
                            header: 'Паркинг и Зона с ограничен трафик',
                            preferenze: 'Предпочитания',
                        },
                        tesseraAssociataConSuccesso: 'Карта {0} е успешно свързана!',
                        tiPiaceMyCicero: 'Харесва ли ви myCicero?',
                        trasporto: {
                            header: 'Tранспорт',
                            notificheScadenzaTitolo: 'Забележка за срока на валидност на билетите',
                            scadenzaTitoli: {
                                description: 'Включете известие за предстоящата дата на изтичане на билетите',
                                header: 'Забележка за срока на валидност на билетите',
                            },
                            tessere: 'Карти за пътуване',
                        },
                        vaiAlleTessere: 'Отиди до картите си',
                    },
                },
                registrati: 'Регистрация',
                settings: {
                    allFavConfermaDelete:
                        'Ако продължите, всички запаметени спирки и резултати ще бъдат премахнати. Тази операция не може да бъде отменена.',
                    allFavRimossi: 'Премахнати са предпочитаните спирки и резултати',
                    cardAssociate: 'Карти, свързани с този потребител',
                    fermateFavConfermaDelete:
                        'В случай, че продължите, всички запаметени спирки ще бъдат премахнати. Тази операция не може да бъде отменена.',
                    fermateFavRimosse: 'Предпочитаните спирки са премахнати',
                    gestisciPosizione: 'Управление на локализация',
                    pulisciDati: 'Премахване на лични данни от устройството',
                    raggioRicerca: 'Диапазон на търсене около Вашата позиция',
                    rimuoviFermateFav: 'Премахване на предпочитаните спирки',
                    rimuoviSoluzioniFav: 'Премахване на предпочитаните резултати',
                    soluzioniFavConfermaDelete:
                        'В случай, че продължите, всички запазени решения ще бъдат премахнати. Тази операция не може да бъде отменена.',
                    soluzioniFavRimosse: 'Премахнати са предпочитаните резултати',
                    utenteAssociatoCard: 'Този потребител е свързан с картата',
                },
                utente: 'Потребител',
                zsr: {
                    associaZSRDescriptionHTML: '',
                    associaZSRHeading: 'Комбинирайте членски код',
                    associazioneFail: 'Кодът не е разпознат',
                    associazioneSuccess: 'Код на партньор',
                    codiceIdZSR: 'Код на абонат',
                    comeOttengo: 'Как мога да го получа?',
                    dataDiNascita: 'Дата на раждане',
                    failureHeading: 'Кодът не е разпознат',
                    idZSR: 'ZSRid:',
                    riprovaAssociazione: 'Опитайте с връзката отново',
                    successHeading: 'Код на партньор',
                },
            },
            affiliazioni: {
                common: {
                    budgetMensile: '',
                    confermaFineSostaChild: '',
                    descrizioneTarga: 'Кратко име',
                    numeroTarga: 'Регистрационен номер',
                    rimuoviAffiliazione: 'Премахване на партньорства',
                    serviziAbilitati: 'Активирани услуги',
                    sosta: 'Паркинг',
                    sostaTargheLimitate: 'Паркирайте само с регистрационни номера',
                    spesaMensile: '',
                    targaGiaInserita: '{0} вече е регистриран в списъка с разрешени регистрационни номера',
                    trasporto: 'Tранспорт',
                },
                creaModificaAffiliazione: {
                    aggiorna: 'Обновяване',
                    alias: 'Псевдоним',
                    aliasEsempio: 'напр. Иван Иванов',
                    emailInfoPlaceholder: 'напр. Ivan.ivanov@gmail.com, maria.dimitrova@gmail.com',
                    erroreValidazioneEmail: 'Форматът на имейл адреса „{0}“ не е правилен',
                    erroreValidazioneImportoSpesaMassimaMensile: '',
                    headerSezione: {
                        durataLimite: 'Месечна продължителност и лимит',
                        sosta: 'Паркинг и Зона с ограничен трафик',
                        trasporto: 'Tранспорт',
                    },
                    infoEmail:
                        'Моля, въведете имейл адресите на потребителите, които могат да купуват с помощта на Вашия портфейл. Моля, отделете всеки адрес със запетайка.',
                    inviaRichiesta: 'Изпрати заявка',
                    limitaDurata: 'Лимит за времетраене',
                    limitaSpesa: 'Месечен лимит на разходите (€)',
                    messaggioRichiestaAffiliazione: 'Заявката за партньорство е изпратена',
                    messaggioRimozioneAffiliazione: 'Партньорството е премахнато',
                    messaggioUpdateAffiliazione: 'Партньорството е обновено',
                    modificaAffiliazione: 'Промяна на партньорството',
                    nuovaAffiliazione: 'Нова партньорство',
                    permettiPagamento: 'Разрешаване на плащане',
                    qualsiasiTarga: 'Всеки регистрационен номер',
                    spesaAttuale: '',
                    targheAbilitate: '{0} регистрирани регистрационни номера',
                    targheSpecifiche: 'Със специфични регистрационни номера',
                },
                dettaglioAffiliazione: {
                    limiteSpesaMensile: 'Месечен лимит на разходите',
                    seiAbilitato: 'Можете да използвате кредит от',
                    spesaAttuale: 'Текущ разход',
                },
                elencoMovimenti: {
                    delegatoA: 'Плащане разрешено за',
                    pagatoPer: 'Плащането е изпълнено от',
                },
                gestioneAffiliazioni: {
                    cercaNomeEmail: 'Търсене на име или поща',
                    creaNuova: 'Ново търсене',
                    funzionalita: 'Функции',
                    gestioneTargheRicorrenti: '',
                    infoAffiliazioneChild:
                        'На това място може да проверите списъка с <br/> потребители, които са споделили  <br/> портфейлите си с Вас.',
                    infoAffiliazioneParent: '',
                    richiesteInAttesa: 'Чакащи заявки',
                    tabs: {
                        childView: 'Плати чрез',
                        parentView: 'Разрешаване на плащания към',
                    },
                    title: 'Управление на партньорства',
                },
                gestioneTargheAutorizzate: {
                    aggiungiRiccorrenti: '',
                    elencoAutorizzate: 'Списък на разрешени регистрационни номера',
                    gestisciRiccorrenti: '',
                    importaRicorrenti: '',
                    infoTargheRicorrenti:
                        'Може да зададете този регистрационен номер с други права, без да го добавяте отново всеки път',
                    inserisciTargaConRicorrenti: 'Или добавете нов регистрационен номер',
                    inserisciTargaSenzaRicorrenti: 'Добавете нов регистрационен номер',
                    targaInRicorrenti: '',
                    targheAutorizzate: '',
                    title: 'Управление на регистрирани регистрационни номера',
                },
                gestioneTargheRicorrenti: {
                    aggiungiTarga: '',
                    elencoRicorrenti: '',
                    title: '',
                },
                importaTargheRicorrenti: {
                    descInfoTargheRicorrenti: '',
                    title: '',
                    titleInfoTargheRicorrenti: '',
                    tutte: '',
                },
                richiestaAffiliazione: {
                    durataModalita: 'Продължителност и условия',
                    info: 'би искал да сподели с Вас портфейла си',
                    messaggioAffiliazioneAccettata: 'Партньорството е прието',
                    messaggioAffiliazioneRifiutata: 'Партньорството е отказано',
                    spesaMassimaMensile: 'Най-големите месечни разходи',
                    title: 'Искане за партньорство',
                },
            },
            amt: {
                homepage: {
                    benvenutiCatania: '',
                    biglietteriaTitle: '',
                    carSharingTitle: '',
                    parcheggiTitle: '',
                    trasportoAcquisti: '',
                    trasportoAcquisto: '',
                    trasportoSubtitle: '',
                    trasportoTitle: '',
                },
            },
            amtab: {
                homepage: {
                    autobus: '',
                    sosta: 'Паркинг',
                },
            },
            app: {
                appBloccata: 'Приложението е заключено',
                cambioDispositivo: 'Смяна на устройството',
                description: 'Добре дошли в $ t (app.name)!',
                dontAskAnymore: 'Не ме питай повече',
                exitMessage: 'Наистина ли желаете да излезете от профила си?',
                exitTitle: 'Изход',
                fineSupportoIOS6Messaggio:
                    'Уважаеми потребители, версията на Вашата операционна система е по-ниска от тази на тази версия. Следващата версия на myCicero няма да бъде съвместима с Вашата операционна система. За да може да използвате нашите услуги, актуализирайте iOS до версия 7 или  по-нова.',
                grazieMyCiceroTemplate:
                    'Благодарим Ви, че използвате нашите услуги. Ако смятате, че са полезни, защо не оставите коментар за {0}?',
                iOSNotCompatible:
                    'За да закупите ATAC билети, Вашият мобилен телефон трябва да бъде актуализиран поне до версия 8. За повече информация, обадете се на 071 920 7000 или изпратете имейл на assistenza@mycicero.it',
                msgCambioDispositivo:
                    '{0} вече е закупил билети с друг мобилен телефон. Ако потвърдите, вече закупените билети няма да са налични в старото устройство. За повече информация, обадете се на 071 920 7000 или напишете имейл на assistenza@mycicero.it',
                msgTelefonoImpegnatoAltroAccount:
                    'Това устройство вече е било използвано от друг потребител за закупуване на билети. За повече информация, обадете се на 071 9207000 или напишете имейл на assistenza@mycicero.it',
                name: 'Wepps',
                no: 'Не',
                pubblicaRecensione: 'Публикуване на коментар',
                recensisciMyCicero: 'Оценете приложението',
                ricordaDopo: 'Напомни ми по-късно',
                supportoIOS6: 'Надстройка на системата',
                updateAppMessage: 'Моля, актуализирайте приложението с последната версия',
                waitdetail: 'Заявката е в процес',
                waitmessage: 'Изчакване',
                wpNonCompatibile:
                    'За да закупите ATAC билети е необходимо да имате смартфон на iOS или Android. За допълнителна информация, моля, обадете се на (+39) 071 920 7000 или изпратете имейл на assistenza@mycicero.it',
                yes: 'Да',
            },
            arriva: {
                homepage: {
                    navette: 'Специални услуги',
                },
            },
            aspo: {
                fatturazioneDisclaimer: '',
                qrCodeFermata: 'QR код на автобус',
                qrCodeFermataSubtitle: '',
                rivendite: 'Кабини и магазини за билети',
            },
            atc: {
                homepage: {
                    benvenutiLaSpezia: '',
                },
                trasporto: {
                    acquistaBiglietti: '',
                    calcolaPercorso: '',
                    fermateOrari: '',
                    mieiTitoli: '',
                },
            },
            atcgo: {
                acquistaBigliettiHTML: 'Купете <br/> билети',
                calcolaPercorsoHTML: 'Планиране на <br/> маршрут',
                fermateOrariHTML: '',
                luoghi: 'Места',
                mieiTitoliHTML: 'Моите <br/> билети',
            },
            autoguidovie: {
                AcquistaBiglietti: 'Купете <br/> билети',
                CalcolaPercorso: 'Изчисляване на маршрут',
                CalcolaPercorsoHTML: 'Планиране на <br/> маршрут',
                ElencoMovimenti: 'Транзакции </ BR> списък',
                FermateOrari: 'Спирки и разписания',
                FermateOrariHTML: 'Спирки и <br/> разписания',
                MieiTitoli: 'Моите <br/> билети',
                ServiziTuristici: '',
            },
            autoricarica: {
                labelToggleAttiva: 'Активиране',
                title: 'Автоматично презареждане',
            },
            avm: {
                addAnagraficaDisclaimer:
                    'За да изисквате фактури за местни обществени транспортни услуги или интегрирана мобилност (паркинг на улицата), управлявана от AVM / Actv, моля попълнете формата в тази връзка: <a href = "#" onclick = "javascript: openLinkOnBrowser (\'http: / /bit.ly/request-an-invoice\',true)">http://bit.ly/request-an-invoice </a>. <br /> След като попълните формуляра, ще получите „клиентския код“ и ще може да изисквате фактури за местните билети за обществен транспорт, закупени от официалното приложение на AVM Venezia, като попълните следния формуляр:',
                addAnagraficaDisclaimer2:
                    'Внимане: фактурата/касовата бележка ще бъде изпращана месечно от AVM само след предоставяне на клиентски код. На всички наши клиенти винаги ще се изпраща потвърждение за плащане.',
                addAnagraficaError1: 'Трябва да попълните този формуляр',
                addAnagraficaError2: 'Може да попълните само полето за категория „Номер по ДДС“ или „Фискален код“.',
                addAnagraficaError3: 'Трябва да се попълни поне едно поле между „номер по ДДС“ и „фискален код“.',
                addAnagraficaError4: 'Трябва да посочите „Клиентски код“',
                addAnagraficaErrorANV: 'Невалиден профил',
                addAnagraficaErrorBLK: 'Заключен профил',
                addAnagraficaErrorECF: 'Номер по ДДС или „Фискален код“ не съответства на сметката.',
                addAnagraficaErrorERR: 'Възникна грешка',
                addAnagraficaErrorINV: 'Невалидно въвеждане',
                addAnagraficaErrorNFD: 'Клиентът не е намерен',
                areaNonServitaHtml: '',
                benvenutiVenezia: '<span> Добре дошли във </span> <span class = "bold"> Венеция </span>',
                calcolaPercorso: 'Изчисляване на маршрут',
                caricaIlTuoVoucher: 'Заредете Вашия ваучер',
                caricaVoucher: 'Заредете ваучер',
                caricaVoucherDescription: 'Поставете PNR кода на Venezia Unica на Вашия ваучер',
                caricaVoucherPlaceholder: 'Поставете Вашия ваучер',
                caricoCliente:
                    'Клиентът трябва да прецени валидността на оставащото време преди началото на пътуването.',
                condizioniContent:
                    '<div> <h2> <strong> ПРАВИЛА И УСЛОВИЯ ЗА ПОЛЗВАНЕ </strong> </h2> <h3> <strong> 1. Област на приложение </strong> </h3> <p> Тези Условия за ползване уреждат взаимоотношенията между Потребителя и Azienda Veneziana per la Mobilità (наричани по-долу "AVM") по отношение на закупуването на билети за местен обществен транспорт чрез използване от официалното мобилно приложение на AVM Venezia <br/> Условията и правилата, регулиращи операциите и методите за достъп и използване на обществения транспорт, задълженията и отговорностите на транспортната компания и пътника могат да бъдат намерени в Общите транспортни условия, публикувани на място. <br/> Мобилното приложение може да се изтегля и използва само на смартфони. </p> <h3> <strong> 2. Значение на правилата и условията за използване </strong> </h3> <p> Когато потребителят се регистрира и изтегли приложението, съвместимо с операционната система на неговия / нейния смартфон, той (потребителят) напълно приема и подлежи на всички Условията за ползване на съответния магазин, без изключение. <br/> AVM си запазва правото да променя едностранно във всеки един момент настоящите правила и условия за ползване. Всеки път, когато потребителят осъществи достъп до приложението, негова отговорност е да провери всички възможни изменения; Използването на приложението означава пълно приемане на Общите условия. </p> <h3> <strong> 3. Инструкции за употреба </strong> </h3> <p> Покупката на билет за пътуване през мобилното приложение е на изключителния риск на потребителя. За тази цел потребителят трябва да защити мобилното си устройство от неразрешена употреба. За да сведе до минимум възможните щети, Потребителят се задължава незабавно да уведоми АВМ относно всякакви подозрения за неоторизирано използване на смартфона, неговата сметка или приложението. <br/> Когато за първи път използвате приложението (т.е. закупуване на билет), Потребителят трябва да спазва инструкциите за регистрация и да вмъква информацията, изисквана от приложението. За по-нататъшни покупки, Потребителят трябва само да влезе, като впише имейл адреса и паролата си. <br/> Веднъж регистриран, Потребителят е единственият човек, отговорен за всички дейности, извършвани през неговата лична сметка. AVM не поема никаква отговорност, свързана с грешки, извършени от Потребителя по време на регистрацията. <br/> За правилното обслужване, когато потребителят изтегли приложението на своя смартфон, той трябва да предостави на AVM неговата лична информация, имейл адрес и телефон на смартфон. номер. Отговорност на потребителя е да провери правилната регистрация на личната си информация. <br/> Потребителят е единственият човек, отговорен за секретността на паролата си: ако потребителят подозира, че такава поверителност е нарушена, той трябва незабавно да промени паролата си. </ P> <h3> <силен> 4. Начин на употреба </strong> </h3> <p> Билетите трябва да бъдат закупени преди достъп до транспортни средства. Потребителят има право да закупи билети за всеки, който пътува с него. <br/> Плащането може да се извърши само с кредитна карта, включително предплатените, които се придържат към схемата Visa / Mastercard. , След приключване на транзакцията, на електронния адрес на потребителя ще бъде изпратена разписка за плащане. <br/> Билетът, закупен чрез приложението, трябва винаги да бъде валидиран преди започването на пътуването. <br/> В зоните за обществен транспорт оборудван с турникети и четци за QR код, потребителят трябва да визуализира съответния QR код и да постави смартфона в слота.\r\r\r\r\r\r\r\r\r\nПериодът на валидност на билета започва в момента на сканиране. <br/> Ако турникетът няма четец на QR код или дори в случай на присъствие на турникет (напр. За автобусни услуги), може да се извърши валидиране. като натиснете съответната икона на екрана на смартфона. В този случай валидирането ще бъде отложено с три минути. <br/> Отговорността на потребителя е да гарантира доброто функциониране на мобилното си устройство за цялото време на пътуването си, ако билетният контролер счете за необходимо да визуализира валидираните билет. Неспазването на това, поради лошо или неправилно функциониране на мобилното устройство, включва същите санкции, като предвидените и одобрени за нередности в общите транспортни условия. </p> <h3> <strong> Жалби и отговорност </strong> </h3> <p> Не е възможно да се възстановят или променят билети, закупени чрез приложението. <br/> Не е възможно да се прехвърлят билети към други мобилни устройства. Те могат да се използват само заедно с устройството, от което е извършена транзакцията. Всяка неизправност, причиняваща загуба на билет или документ за пътуване, е единствено и единствено отговорност на потребителя и в никакъв случай AVM няма да предостави възстановяване на загубени / невъзстановими билети. <br/> AVM ще възстановява само в случай на грешен дебит. определено като грешка в системата за плащане. </p> <h3> <strong> Право на изтегляне </strong> </h3> <p> Потребителят може да деинсталира приложението във всеки един момент и без да уведомява. Всички билети, които вече са закупени и не са използвани, няма да бъдат възстановени. <br/> <h3> <strong> Норми за поверителност </strong> </h3> <p> Когато потребителят инсталира приложението, той декларира и приема AVM за достъп, съхраняване и обработка на неговата лична информация и всякакво съдържание, свързано с използването на приложението, ако това се изисква от закона или ако такива дейности са необходими за използването на APP, т.е. услуги, предоставяни чрез APP, по отношение на Законодателен декрет. 196/2003 „Правилник за управление на личната информация“. <br/> Потребителят признава и приема използването на АП P като средство за електронно предаване на информация в комуникационни мрежи. <br/> Повече информация за това как AVM управлява личната информация е достъпна от сайта. <br/> Информация за собствеността: Azienda Veneziana della Mobilità spa, Isola Nova del Tronchetto 33, Венеция. </p><h3> <strong> Интелектуална собственост </strong> </h3> <p> С изтеглянето на приложението, потребителят приема и потвърждава, че е защитен от законодателството относно интелектуалната собственост и други приложими разпоредби, включително, но не само авторски права. Потребителят се съгласява да използва такава информация, обхваната от монопол и материал изключително за използването на предлаганата услуга, като спазва разпоредбите в настоящите Общи условия. Никоя част от приложението, нито предлаганите продукти, не могат да бъдат възпроизвеждани под каквато и да е форма, нито с каквито и да е средства, с изключение на разрешеното в настоящите условия. Потребителят се съгласява да не променя, отдава под наем, наема, дава, продава, разпространява или създава каквото и да е въз основа на настоящото приложение, и по никакъв начин не може да използва приложението или продуктите, закупени по неоторизиран начин. авторските права, свързани с приложението, са собственост на AVM и / или нейните лицензополучатели. Използването на всеки компонент на мобилното приложение, с изключение на използването, разрешено съгласно настоящите Общи условия, е строго забранено; нарушава правата на интелектуална собственост на трети страни и може да подчини Потребителя на граждански и наказателни глоби, включително възможни парични щети, за нарушаване на авторски права. <br/> AVM, логото на AVM и други търговски марки / марки на AVM Group във връзка с приложението представляват марки или регистрирани марки на групата AVM. Потребителят няма право или разрешение да използва или да прави препратка към спомената марка. </p> </div>',
                condizioniHeader: 'ПРАВИЛА И УСЛОВИЯ',
                condizioniVeneziaUnica: 'Условия за ползване на Venezia Unica',
                infoMobilita: '',
                messageCondizioniBorsellino:
                    "Прочетох и разбрах <a class='condizioni-borsellino'> Общите условия </a> за използване на кредити.",
                messaggioInformativoSosta: '',
                ricercaOrari: 'Търсене на разписания на спирки',
                sezioneVoucher: 'Билети може да намерите в раздел "Моите ваучери"',
                sostaItem: 'активен',
                sostaSubTitle: 'Информация & Билети',
                sostaTitle: 'Паркинг',
                trasportoItem: 'Покупки',
                trasportoSubTitle: 'Информация & Билети',
                trasportoTitle: 'Tранспорт',
                vaiAiVoucher: 'Отиди до Моите ваучери',
                verificaAcquisto:
                    'Проверете секцията "Купи билети", в случай, че има по-евтини тарифни резултати в сравнение с Вашите нужди за пътуване (карти за билети или дневни билети)',
                viaggia: {
                    abbonamenti: '',
                    acquistoOd: '',
                    acquistoOdTessera: '',
                    header: '',
                    tariffaFissa: '',
                },
                voucherItem: 'Ваучер',
                voucherSubTitle: 'Ваучер',
                voucherTitle: 'Заредете своя',
            },
            biglietto: {
                acquistatoIl: 'Закупен в',
                atac: {
                    aimop: {
                        descrizioneAggiuntiva:
                            'Билетите се издават със срок на валидност, което означава, че вече са активни. Сезонните билети, закупени в рамките на 24-то число на всеки месец, също са вече активни, т.к. са валидни за текущия месец. Сезонните билети, закупени след 24-ти, автоматично важат от следващия месец.',
                        note:
                            'За да пътувате с влаковете на метрото покажете QRCode на скенера на бариерите за билети, или, ако имате Android устройство с NFC, поставете го близо до четеца на NFC на бариерите.',
                        tipoValidazione: 'Автоматично активиран',
                    },
                    bit100: {
                        descrizioneAggiuntiva: '',
                        note:
                            "<p class = 'bold'> Валидност: </p> <p> 100 минути валидност от първото активиране на автобус, тролейбус, трамвай и метро.",
                        tipoValidazione: '0',
                    },
                    brm24: {
                        descrizioneAggiuntiva:
                            '1 пътуване само за метро A, B, B1 и за повече линии, без да е необходимо да пресичате бариерите.',
                        note: '0',
                        tipoValidazione:
                            "1 пътуване само за влакове. </p> <p class = 'bold'> Област на използване: </p> <p> Може да се използва за всички транспортни услуги на Metrebus: автобус, тролейбус, трамвай и метро C, RomaTPL и Cotral транспортно средство, Ferrovia Roma-Lido e Ferrovia Roma - Viterbo </p> <p class = 'bold'> Как можете да го използвате </p> <p> Билетът е валиден само ако е активиран.",
                    },
                    brm48: {
                        descrizioneAggiuntiva: '0',
                        note:
                            'За да пътувате в метрото, покажете QR кода на скенера на бариерата. В случай, че имате устройство с NFC технология, отворете билета на екрана и го поставете в контакт с четеца на NFC на бариерата.',
                        tipoValidazione: '0',
                    },
                    brm72: {
                        descrizioneAggiuntiva:
                            'След активиране на билет за Метро А, Б и В1, ще имате 2 минути, за да пресечете бариерите. </p> ',
                        note:
                            'За да пътувате с влаковете на метрото покажете QRCode на скенера на бариерите за билети, или, ако имате Android устройство с NFC, поставете го близо до четеца на NFC на бариерите.',
                        tipoValidazione: 'Инструкции за първо използване, преди въвеждане на метод',
                    },
                    hai2Minuti: 'Имате 2 минути да прекосите бариерите',
                    vuoiAttivareTitolo: 'Искате ли да активирате билета?',
                    vuoiAttivareTitoloBus:
                        '<div class = "secondary textAlignCenter fontSizeHuge"> Искате ли да се качите в автобуса или да влезете в метрото C? </div> <div class = \'marginTop\'> Броячът на валидност ще започне. <br/> За достъп до метрото, покажете QrCode на скенера на бариерите за билети. </div>',
                    vuoiEntrareMetro:
                        '<div class = "secondary textAlignCenter fontSizeHuge"> Искате ли да влезете в Метро A, B, B1? </div> <div class = \'marginTop\'> За да влезнете в метрото, покажете в рамките на две минути QrCode на скенера на билети за билети. <br/> Билетът е валиден за едно пътуване с влак в метрото. </div>',
                    vuoiSalireTreno:
                        '<div class = "secondary textAlignCenter fontSizeHuge"> Искате ли да се качите във влака? </div> <div class = \'marginTop\'> Билетът е валиден за едно пътуване с влак. <br /> Изберете станция на заминаване: </ DIV>',
                },
                attiva: 'Активиране',
                attivaESaliBus: 'Активирайте билета си, за да го използвате:',
                attivaEdEntraMetro: 'Активирайте и въведете:',
                attivaMsg: 'Активирайте билета, за да го използвате',
                attivaPer: 'Активен за',
                attivato: 'Активен',
                attivatoIl: 'Активиран на',
                attivatoMetro: 'Валидиране на метро:',
                attivatoPer: 'Активирано за',
                attivatoTreno: 'Валидиране на влака:',
                attivazioneBus: 'Активиране на Автобус, Metro C',
                attivazioneMetro: 'Активиране на Metro A, B, B1',
                attivazioneNFC: 'NFC активация',
                attivazioneTitolo: 'Активиране на билет',
                attivazioneTreno: 'Активиране на влак',
                avvisoTitoliLocali:
                    'Билетите се запазват само на смартфон. За допълнителна информация кликнете върху {0} тук {1}',
                avvisoTitoliLocaliMail:
                    'Билетите са запазени на Вашия смартфон. За повече информация се свържете с {0}',
                avvisoTitoliLocaliNoLink: 'Билетите се запазват само на смартфон.',
                cercaTitolo: 'Търсене на билет',
                chiediCodice: 'Попитайте информацията за драйвера за активиране на заглавието',
                codiceNonValido: 'Кодът е невалиден',
                confermaAttivazione:
                    'Ако потвърдите, билетът ще бъде активиран и броенето на времето за валидност ще започне',
                confermaMetro: 'Ако потвърдите, имате 2 минути време за достъп до метрото.',
                confermaMetroAttivazione:
                    'Ако потвърдите, билетът ще бъде активиран, броенето на времето за валидност ще започне и ще имате 2 минути време за достъп до метрото.',
                costoTitolo: 'Разходи за билети',
                daAttivare: 'Да се ​​активира',
                dataEmissione: 'Дата на издаване',
                dataScadenza: 'Дата на изтичане',
                entraInMetro: 'Метро',
                entraMetro: 'Въведете в:',
                error: {
                    corseEsaurite: 'Няма повече налични резултати за автобуси',
                    datiNonCongrui: 'Некоректни данни',
                    erroreAntiPassback: 'Грешка при управлението на Anti-passback',
                    erroreApplicativo: 'Грешка в приложението',
                    erroreValidazioneMultipla: 'Многократно валидиране при една и съща грешка в профила',
                    impossibileValidare: 'Не е възможно да активирате билета',
                    titoloNonValido: 'Билетът не е валиден',
                },
                fermataSalita: 'Борд спирка',
                finoA: 'До',
                header: 'Билет',
                identificativo: 'Идентификация',
                inFaseDiAttivazione: 'Услугата се активира',
                infoAcquistoAnnullato: 'Сделката е анулирана от клиента',
                infoAcquistoEffettuato: 'Закупеният билет се предлага в секцията "Моите билети".',
                infoAcquistoFallito: 'Не успяхме да завършим транзакцията Ви.',
                infoAcquistoFallitoVix: 'Не успяхме да завършим транзакцията Ви. Моля, опитайте отново.',
                infoAcquistoSiaeEffettuato: 'Закупеният билет се предлага в секция "Събития".',
                infoCodiceManuale: 'В случай на неуспешно разчитане на кода, обърнете се към водача',
                inserisciQualcosaPartenza: 'Поставете адрес, зона или спирка на заминаване',
                istruzioniAttivazione: 'Натиснете "Проверка", за да потвърдите билета',
                istruzioniDownloadTitoliAsincroni:
                    'След като завършите процеса на закупуване ще е възможно да изтеглите билета, като изберете страницата "Моите билети" на приложението',
                istruzioniDownloadTitoliAsincroniTrasporto:
                    'След като завършите процеса на закупуване, ще е възможно да изтеглите билета, като изберете страницата "Транспорт" на приложението',
                istruzioniObliterazione: 'Натиснете "Проверка", за да потвърдите билета',
                localita: 'Места',
                multicorsa: {
                    MultiCorsa: 'ТИР',
                    attivaAltro: 'Проверката се изпълнява',
                    attivaDefault: 'Активиране',
                    attivaPrimo: 'Проверката се изпълнява',
                    attivaUltimo: 'Потвърждение на маршрт',
                    attivoFinoA: 'Маршрутът е валиден до:',
                    confermaRivalidazione: '',
                    corseAttive: 'Активни маршрути:',
                    corseDaAttivare: 'Оставащи пътувания',
                    corseRimaste: 'Маршрути:',
                    daAttivare: 'Маршрутът не е потвърден',
                    info: 'За валидиране на маршрута, разтрийте Qr кода през четеца на турникета {0}.',
                    quantiAttivare: '',
                    scaduto: 'Изтекъл',
                    tickets: 'Изпълнява',
                    tutteCorseScadute: 'Всички маршрути са с изтекъл срок',
                    validoDa: 'Маршрутът е валиден от:',
                },
                nfcNotSupported:
                    'NFC услугата е достъпна за Вашия смартфон. Въпреки това, с тази версия на Android myCicero няма достъп до тази функция.',
                nfcOFF:
                    'С Вашия смартфон може да използвате активирането на NFC. Тази функция обаче не е активна. Желаете ли да я активирате?',
                nfcON:
                    'Поздравления! С Вашия смартфон може да активирате този билет, като просто приближите телефона близо до четеца на NFC, в случай, че има такъв.',
                noPosPartenzaRilevata: 'Невъзможно е да се открие Вашата позиция за заминаване.',
                nonAcquistabileContrattiInsufficienti: '',
                nonAncoraUtilizzabile: 'Не се използва сега',
                nonAttivato: 'Билетът не е активиран',
                nonEffettuata: 'Не е готов',
                nonObliterato: 'Билетът не е потвърден',
                nonValidato: 'Билетът не е потвърден',
                notificaMessaggio: '{0} ще изтече на {1}',
                notificaTitolo: 'Билетът скоро ще изтече',
                nuovaAttivazione: 'Нова активация',
                nuovaValidazione: 'Нова проверка',
                oblitera: 'Активиране',
                obliteratoIl: 'Валидиран на',
                piuCorse: ' Още пътувания',
                precedente: 'Отидете на предишния билет',
                premiAttiva: 'Неизпълнението на валидността на билета води до наказание',
                premiValida:
                    'Натиснете "Валидиране" преди да се качите в автомобила. Неизпълнението на валидността на билета води до наказание.',
                primaAttivazione: 'Активен',
                qrCodeScaduto: '',
                saliInBus: 'Автобус',
                saliSulTreno: 'Влак',
                saraValidoTra: 'Билетът ще бъде валиден в',
                scaduto: 'Изтекъл',
                scadutoIl: 'Изтекъл на',
                selezionaFermataSalita: 'Ако я знаете, моля, изберете спирката за качване на автобус',
                selezionaStazioneSalita: 'Изберете станция/гара:',
                singolaCorsa: '1 пътуване',
                stazioneSalita: 'Гара:',
                successivo: 'Към следващия билет',
                tempoRestante: '',
                termsConditions: " <span> Прочетох и приемам </span> <a href='#'> Общите условия </a>",
                tipologiaBiglietto: 'Тип на билетите',
                titoliImpersonali: 'Безличен билет',
                titoloAttivo: 'Активен билет',
                titoloAttivoFinoAl: 'Билетът е активен до',
                titoloDiViaggio: 'Билет',
                titoloLocale: 'Може да намерите този билет само на Вашия смартфон',
                titoloNonAttivo: 'Билетът не е активен',
                titoloScaduto: 'Билетът е изтекъл',
                titoloScadutoAlle: 'Билетът ще изтече на',
                treno: 'Влак',
                ultimaValidazione: 'Последна валидация',
                utilizzabileDalAl: 'Може да се използва от {0} до {1}',
                utilizzabileFinoA: 'Използваем до {0}',
                utilizzabileIl: 'Може да се използва на {0}',
                utilizzabileIlGiorno: 'Може да се използва на адрес:',
                utilizzabileOggi: 'Използва се днес',
                vaiAlBiglietto: 'Към билета',
                valida: 'Нова активация',
                validaMsg: 'Потвърдете билета, за да може да го използвате',
                validatoIl: 'Валидиран на:',
                valido: 'Валиден',
                validoFinoAl: 'Валиден до',
                warningAccessoMetro: 'Преминете през бариерата за влизане в метрото </br> от',
            },
            bikeSharing: {
                aggiungiBici: 'Добавете още един велосипед',
                alertPrenotazioneAccorciata:
                    'Периодът на наема е намален в съответствие с наредбата, прилагана в избраната структура.',
                alertPrenotazioneAllungata:
                    'Периодът на наема е увеличен в съответствие с наредбата, прилагана в избраната структура. Това не води до допълнителни разходи.',
                alertPrenotazioneAnnullata: 'Резервацията е анулирана',
                altreFunzionalita: 'Други функционалности',
                annullaPrenotazione: 'Отменете резервацията',
                bici: 'Велосипед',
                biciPrenotataPerHtmlTemplate: 'Велосипедът ще бъде резервиран за {0}',
                bicicletta: 'Велосипед:',
                biciclette: 'Велосипед:',
                bikePoint: 'Велосипедна точка:',
                bikePointChiuso: 'Велосипедна точка е затворена',
                bikePointChiusoInfo:
                    'По време на затваряне на велосипедната точка не е възможно да се направи резервация',
                bikePointPrelievo: 'Взимане:',
                bikePointRiconsegna: 'Обратното предаване:',
                btnPrenota: 'Резервирайте велосипед',
                cantBook: 'Не може да резервирате',
                cercaBikePoint: 'Търсене на велосипедна точка',
                cercaPerNomeIndirizzo: 'Търсене по адрес или име',
                confermaBici: 'Вземете велосипеда',
                consegnaInRitardo: 'Трябваше да го върнете в:',
                contattaci: 'Свържете се с нас',
                dettaglioCorsa: 'Подробности за маршрута',
                elencoPrenotazioniRecenti: 'Списък на скорошни операции...',
                elencoStrutture: 'Велосипедна точка',
                emptyPoint: 'Велосипедна точка е празна',
                haiPrenotazione: 'Имате резервация за {0} велосипед (и)',
                haiRiconsegnatoInRitardo: 'Завършено (при забавяне)',
                importoMyCicero: 'Платени чрез myCicero:',
                importoOra: 'Ако го върнете сега:',
                importoTotale: 'Обща сума:',
                infoPoint: 'Информация за велосипедна точка',
                infoPrelievo: 'Велосипедът ще бъде резервиран за избрания период',
                infoPrenotazione0: 'Наемът включва застрахователно покритие, данъци и карта на Рим',
                infoPrenotazione1:
                    '30 минути, за да вземете мотора / ите, в противен случай заявката Ви ще бъде автоматично изтрита (няма да бъдат таксувани)',
                infoPrenotazione2:
                    'Резервацията ще бъде активна, когато операторът на велосипедната точка Ви даде велосипедите.',
                infoPrenotazione3:
                    'Планираното време не е задължително за връщане на автомобила, а също така е възможно да се спре предварително времето за наемане. Разходите се таксуват в зависимост от необходимото време и от съществуващата тарифа.',
                infoRitardo: 'Mycicero отбеляза липсващата доставка. Моля, върнете велосипеда възможно най-скоро',
                inserisciCodiceBici: 'Поставете кода на велосипеда',
                inserisciNumeroBici: 'Поставете номера на велосипеда',
                istruzioni: {
                    bloccoSbloccoSaldo:
                        'За да блокирате и отключите велосипедите, балансът на портфейла Ви трябва да е по-висок или същият като цената на наема',
                    buonaPedalata: 'Приятно пътуване!',
                    cosaDevoFare: 'Какво да правя?',
                    inserisciCodice: 'Поставете или сканирайте кодовете на всичките си резервации за велосипеди',
                    mostraCodice: 'покажете кода',
                    mostraIlCodice: '2) Покажете кода за резервация на търговеца на станцията.',
                    mostraSuMappa: 'покажете на картата',
                    raggiungiIlBikePoint: '1) Достигнете в рамките на {0} до точката за велосипед "{1}"',
                    ricordatiDiRiconsegnare:
                        '4) Не забравяйте да върнете велосипедите в {0} в някой от нашите велосипедни точки',
                    semplice: 'Лесно',
                    termineNoleggioSelfService:
                        'Преди края на наемането се уверете, че сте закачили всички велосипеди под наем до велосипедната точка',
                },
                leMiePrenotazioni: 'Моите резервации',
                limitePrenotazioni: 'Достигнахте максималната сума за резервации',
                mezzoPrenotatoPeriodoSelezionato: 'Продуктът ще бъде резервиран за избрания период',
                mostaCodicePrenotazione: 'покажете кода за резервация',
                nessunRecente: 'Нищо за показване',
                noBikes: 'В момента няма велосипед',
                noBikesInPoint: 'Няма наличен продукт в избраната станция',
                noResult: 'Няма налични резултати за това търсене',
                noleggi: 'Активни наеми',
                operazioneNonAutorizzata: 'Непозволена операция',
                orario: ' часове за обслужване',
                orarioApertura: 'Работно време',
                prelevaEntro: 'Вземане в рамките на:',
                prelievo: 'Може да вземете велосипеда в рамките на:',
                prelievoEffettuato: 'Вземането е направено:',
                prelievoEntro: 'Вземане в рамките на:',
                prenota: 'Резервирайте',
                prenotazioni: 'Резервации',
                preventivoPrenotazione: 'Пресмятане на резервацията:',
                problemi: 'За всеки проблем или неизправност',
                recenti: 'Най-скорошен',
                ricalcoloPreventivoInCorso: 'Прогнозна сума, преизчислена в момента.',
                ricaricaBorsellino: 'Презаредете портфейла, за да направите резервация.',
                ricaricaBorsellino2:
                    'Презаредете портфейла, ако искате да платите цялата сума от MyCicero, в противен случай ще платите разликата на оператора на велосипедната точка.',
                riconsegna: 'Трябва да го върнете в:',
                riconsegnaEffettuata: 'Връщане:',
                riconsegnaEntro: 'Връщане в рамките на:',
                sblocca: 'Отключване',
                scegliTipologia: 'Изберете тип',
                seiInRitardo: 'Закъснявате с връщането на продукта',
                templateMessaggioPreventivo:
                    'Ако сега изтеглите резервирани суми и ги добавите обратно в определеното време, ще похарчите: {0}',
                terminaNoleggio: 'Край под наем',
                titles: {
                    bikeSharing: 'Велосипед',
                    conferma: 'Запазване на местоположението',
                    dettaglioCorsa: 'Подробности за маршрута',
                    prenotaBici: 'Резервирайте велосипед',
                    scegliBikePoint: 'Изберете велосипедна точка',
                },
                visualizzaRecenti: 'Отчет на транзакциите',
            },
            busitaliaveneto: {
                acquistaBiglietti: 'Купи билети',
                calcolaPercorso: 'Изчисляване на маршрут',
                fermateOrari: 'Спирки и разписания',
            },
            carPoolingTaxiCondiviso: {
                bacheca: {
                    cercaConducenti: '',
                    cercaOfferteRichieste: '',
                    cercaPasseggeri: '',
                },
                common: {
                    annullaRichiesta: '',
                    annullaRichiestaError: '',
                    annullaRichiestaMessage: '',
                    bacheca: '',
                    carInfo: '',
                    chiamaTaxi: '',
                    commento: '',
                    confermaPrenotazioneTaxi: '',
                    confermaPrenotazioneTaxiMessage: '',
                    confermaRichiesta: '',
                    confermaRichiestaMessage: '',
                    confermaValutazione: '',
                    corsaEliminata: '',
                    corsaEliminataMessage: '',
                    dettaglio: 'Детайли',
                    elencoPasseggeri: '',
                    eliminaCorsa: '',
                    eliminaCorsaMessage: '',
                    ferryInfo: '',
                    filtra: '',
                    filtraOfferte: '',
                    filtraRichieste: '',
                    filtraStoricoViaggi: '',
                    filtriAttiviNum: '',
                    filtroAttivoNum: '',
                    iMieiViaggi: '',
                    inserisciRichiesta: '',
                    inviaOfferta: '',
                    inviaRichiesta: 'Изпрати заявка',
                    iscrizione: '',
                    mappa: 'Карта',
                    minimoPasseggeri: '',
                    nessunRisultato: 'Няма резултати',
                    numeroPostiDisponibili: '',
                    numeroPostiRichiesti: '',
                    offertaPassaggio: '',
                    offriCorsaPerViaggioCercato: '',
                    offriUnPassaggio: '',
                    partecipaTaxiCondiviso: '',
                    passeggeriAccompagnati: '',
                    postiConfermatiNum: '',
                    postoConfermatoNum: '',
                    prenotazioneTaxiConfermata: '',
                    procediRichiesta: '',
                    pubblicaRichiesta: '',
                    pubblicaValutazione: '',
                    pubblicaValutazioneMessage: '',
                    rendiDisponibileAuto: '',
                    ricercaNoRisultati: 'Няма намерени резултати',
                    richiestaAnnullata: '',
                    richiestaPassaggioInviata: '',
                    richiestaPubblicata: '',
                    richiestaRifiutata: '',
                    richiestaTaxiCondiviso: '',
                    richiestaTaxiCondivisoNum: '',
                    richiesteTaxiCondivisoNum: '',
                    riepilogoOfferta: '',
                    riepilogoRichiesta: '',
                    rifiutaRichiesta: '',
                    rifiutaRichiestaError: '',
                    rifiutaRichiestaMessage: '',
                    storicoViaggi: '',
                    taxiCondiviso: '',
                    tornaOfferta: '',
                    valutaConducente: '',
                    valutaPasseggeri: '',
                    valutaPasseggero: '',
                    valutaUtente: '',
                    valutazione: '',
                    viaggiAttivi: '',
                    viaggiCompletati: '',
                    viaggiConTaxiCondiviso: '',
                    viaggiDaConducente: '',
                    viaggiDaPasseggero: '',
                },
                offriPassaggio: {
                    partenzaArrivoModificate: '',
                },
                pubblicaRichiesta: {
                    infoRichiestaCarPooling: '',
                    infoRichiestaCarPoolingTaxiCondiviso: '',
                    infoRichiestaNoAmbito: '',
                    infoRichiestaTaxiCondiviso: '',
                    pubblicaRichiestaCarPooling: '',
                    pubblicaRichiestaTaxiCondiviso: '',
                },
                riepilogoOfferta: {
                    informazioniOffertaPassaggioPubblicata: '',
                    informazioniVeicolo: '',
                    informazioniVeicoloPlaceholder: '',
                    offertaPassaggioPubblicata: '',
                    selezionaMezzoDiTrasporto: '',
                    selezionaTraghettoElba: '',
                },
                riepilogoRichiesta: {
                    richiestaInoltrataConducente: '',
                    richiestaInoltrataConducenti: '',
                    richiestaInoltrataTaxiCondiviso: '',
                    richiesteInoltrate: '',
                    richiesteInoltrateTaxiCondiviso: '',
                    richiesteInviate: '',
                    richiestePassaggioInviate: '',
                },
                soluzioniDiViaggio: {
                    posizioniNonValide: '',
                },
            },
            cercaOd: {
                destinazione: 'Дестинация',
                header: 'Търсене по маршрут',
                nessunTitoloTrovato: 'Не са намерени резултати по въведените критерии',
                origine: 'Начало',
                voglioArrivareA: 'Бих искал да отида до',
                voglioPartireDa: 'Искам да тръгна от',
            },
            common: {
                Targa: 'Регистрационен номер',
                aPartireDa: '',
                aPiedi: 'С ходене',
                accedi: 'Вход',
                accetta: 'Съгласен',
                acquista: 'Покупка',
                acquistaCon: 'Покупка с',
                acquistabile: 'Може да се купи',
                acquisto: 'Покупка',
                acquistoABuonFine: 'Покупката е завършена успешно',
                acquistoEffettuato: 'Покупката е завършена',
                adesso: 'Сега',
                agevolazioni: 'Ползи',
                aggiungi: 'Добавяне',
                al: 'До',
                alAlle: '{0} в {1}',
                andataRitorno: 'Отиване и връщане',
                anni: 'години',
                annulla: 'Отказ',
                annullaOperazione: 'Отказ',
                annullata: '',
                applicaPreferenze: 'Прилагане на предпочитанията',
                apriQrCode: '',
                arrivo: 'Пристигане',
                associaCarta: 'Регистрирайте кредитна карта',
                attendere: 'Изчакване',
                attenzione: 'Внимание',
                attiva: 'Активиране',
                attivaBorsellino: 'Активирайте електронния портфейл на обществения транспорт',
                attivaNuovoTitolo: '',
                attivato: 'Активиран',
                auto: 'Кола',
                autocompleteTypes: {
                    EVENTI: 'Събития',
                    FERMATE: 'Спирки',
                    INDIRIZZO: 'Адреси',
                    LINEE: 'Линии',
                    LOCALITA: 'Места',
                    POI: 'Тогава',
                },
                avanti: 'Напред',
                backHome: 'Обратно',
                benvenuto: 'Добре дошли',
                benvenutoNelMondoMyCicero: 'Добре дошли в myCicero.',
                benvenutoNelMondoVettore: 'Добре дошли в {0}.',
                calcolaPercorso: 'Изчисляване на маршрут',
                cambiCorsa: 'Връзки',
                cambia: 'Промяна',
                cambiaCitta: 'Промяна на града',
                cambiaImmagine: 'Промяна',
                cambioCorsa: 'Връзка',
                cancella: 'Изтриване',
                cancellata: '',
                caratteri: 'Писмен знак',
                carica: 'Качване',
                caricaFile: 'Качване',
                caricamento: 'Зареждане...',
                carriers: 'Превозвачи',
                carrozza: 'Треньор',
                centro: 'Център на града',
                cerca: 'Търсене...',
                chiudi: 'Затвори',
                chiuso: 'Затворено',
                cities: 'Град',
                clickPerMaggioriInfo: 'Натиснете тук за повече информация...',
                codiceTransazione: 'Код на транзакция',
                cognome: 'Фамилия',
                comune: 'Град',
                comuneArrivo: 'Град на пристигане',
                comuneNonValido: 'Град, който не е покрит от услугата.',
                comunePartenza: 'Град на отпътуване',
                con: 'с',
                condividiViaggio: 'Споделете Вашето пътуване',
                condizioniUtilizzoHtml: 'Приемам <a href="#" class="lnkCondizioni"> Общите условия </a>',
                conducente: '',
                conferma: 'Запазване на местоположението',
                confermaAcquisto: 'Потвърждение на покупката',
                confermaContinua: 'Сигурни ли сте, че желаете да продължите?',
                confermaEChiudi: 'Запазване и продължаване',
                confermaNonChiedere: 'Да не се показва това отново',
                confermaSelezione: 'Потвърдете избора',
                confermaUscitaApp: 'Наистина ли желаете да излезете от приложението?',
                contattaAssistenza: 'Моля, свържете се с нашия отдел Поддръжка',
                contattaIlGestore: 'Свържете се с управителя',
                contattiEdEntiCoinvolti: 'Контакти и органи по споразумения',
                continua: 'Продължи',
                copertura: 'Покрити райони',
                corse: 'Изпълнява',
                creaTessera: '',
                crediti: '',
                dal: 'От',
                dalAlle: 'От {0} в {1}',
                dalleAlle: 'От {0} до {1}',
                data: 'Дата',
                dataSvolgimento: 'Дата',
                datiSalvati: 'Данните са запазени',
                descrizione: 'Кратко име',
                dettaglio: 'Детайли',
                domani: 'Утре',
                durata: 'Продължителност',
                e: 'и',
                elencoMovimenti: {
                    tipo: {
                        abbSosta: 'Купете дългосрочно разрешение за паркиране',
                        ricarica: 'Заредете допълнително кредита си',
                        sosta: 'Паркинг',
                        utilizzoCredito: 'Използване на кредити',
                    },
                },
                elimina: 'Изтриване',
                emesso: 'Издаден',
                emptyList: 'Няма намерен елемент',
                errore: 'Внимание',
                erroreCaricamento: 'Възникна грешка. Данните не успяха да се заредят. Моля, опитайте отново по-късно',
                erroreComunicazioneServer: 'Грешка в сървъра за комуникация',
                erroreConnessione: 'Възникна грешка. Моля, потвърдете връзката си с интернет и опитайте отново.',
                erroreConnessioneServer: 'Грешка при свързване с отдалечен сървър',
                erroreDownloadTitoli: 'По време на зареждането на билета възникна грешка. Моля, опитайте по-късно.',
                erroreFormatoQrCode: 'Неправилен формат на QR кода',
                errorePagamento: 'Възникна грешка при опита за плащане. Моля, опитайте отново.',
                erroreSalvataggio:
                    'Възникна грешка. Направените промени не бяха запазени. Моля, опитайте отново по-късно',
                erroreScansioneQrCode: 'Възникна грешка при сканирането на QR код.',
                erroreSconosciuto: 'Възникна неизвестна грешка',
                eventi: 'Събития',
                evviva: '',
                fa: ' преди {0}',
                filters: 'Филтри',
                filtra: 'Филтър',
                filtri: 'Филтри',
                filtro: 'филтър',
                finoA: 'До',
                finoATuttoIl: 'До края',
                finoAl: 'до',
                giorni: 'дни',
                giornoAlle: '',
                googlePlay: {
                    legal: 'Google Play и логото на Google Play са запазени марки на Google LLC.',
                },
                home: '',
                ieri: 'Вчера',
                ilDalleAlle: '{0} от {1} до {2}',
                illimitato: 'Неограничен',
                importo: 'Сума',
                importoTotale: 'Обща сума',
                impossibileEseguireOperazione: 'Операцията не може да се извърши',
                impossibileVisualizzareQrCode: '',
                impostazioni: 'Настройки',
                indietro: 'Назад',
                indirizzo: 'Адрес',
                indirizzoArrivo: 'Адрес на пристигане',
                indirizzoPartenza: 'Адрес на заминаване',
                inevidenza: 'Акценти',
                info: 'Информация',
                infoAbbreviato: 'Информация',
                infoBiglietto:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                infoNonDisponibili: 'Няма допълнителна информация',
                infoTraghetto: '',
                infoVeicolo: '',
                ingrandisci: 'Zoom',
                inizia: 'Начало',
                inizio: 'Начало',
                inserisciCodicePromo: 'Добавяне на код',
                intornoA: 'Около',
                inviaRisposta: '',
                io: '',
                itinerario: 'Маршрут',
                leggi: 'Прочети',
                leggiTutto: 'Прочетете всички ..',
                liberi: '',
                libero: '',
                lingua: 'Език',
                link: 'връзка',
                loadMore: 'Зареди още...',
                longTermParkingPanel: {
                    finoA: 'До',
                    prenotazioneDal: 'Резервация от',
                },
                luoghi: 'Места',
                mappa: 'Карта',
                mesi: 'месеца',
                mezzo: 'Автомобил',
                mieiTitoli: 'Моите билети',
                minuti: 'минути',
                minutiLower: 'минути',
                minutiShort: 'мин.',
                mobilita: 'Подвижност',
                modalita: '',
                modifica: 'Промяна',
                mostraTutti: 'Покажи всички',
                mostraTutto: 'Покажи всички',
                movimenti: 'Транзакции',
                msgAtacLockedOutUntil:
                    'От съображения за сигурност, свързани с неотдавнашната миграция, ATAC билетите временно не са налични; те ще бъдат достъпни отново в {1}',
                nascondi: 'Скриване...',
                nessun: 'Не',
                nessunDettaglioTrovato: 'Не са открити детайли',
                nessuno: '',
                newsNotifiche: 'Новини и известия',
                newsNotificheUnread: '{0} непрочетени новини',
                nfcSpentoDesc: '',
                nfcSpentoWarning: '',
                no: 'Не',
                noCameraPermission: 'Нямате лиценз за достъп до камерата',
                noRicerchePreferite: 'Не са намерени предпочитани търсения',
                noRicercheRecenti: 'Няма налични скорошни търсения',
                noRisultati: 'Няма налични резултати за това търсене',
                noRisultatiRicerca: 'Няма намерени резултати.',
                noRisultatiVisibili: 'Няма налични резултати',
                nome: 'Име',
                nomeCompleto: 'Име и фамилия',
                nonAcquistabile: 'Не може да се закупи',
                nonAttiva: 'Неактивен',
                nonConfermata: '',
                nonOra: 'Не сега',
                notifica: 'Уведомление',
                numCartafreccia: 'Номер на Cartafreccia',
                nuova: 'Нов',
                nuovaAttivazione: 'Нова активация',
                obbligatorio: '(Задължително)',
                oggi: 'Днес',
                ok: 'Добре',
                operazioneEseguita: 'Задачата е завършена',
                operazioneFallita: 'Операцията се провали',
                opzioni: 'опции',
                ora: 'Време',
                oraDelGiorno: '',
                orariEfermate: 'Спирки и разписания',
                orario: 'Време',
                ore: 'време',
                ottimo: 'Страхотно',
                paga: 'Плащане',
                parcheggiNavette: 'Паркиране & Каране (трансфери)',
                parcheggia: 'Паркинг',
                partenza: 'тръгване',
                partners: '',
                passeggeri: 'Пътници',
                passeggero: 'Пътник',
                plusAutoricarica: {
                    labelCartaDiCreditoNecessaria: 'Трябва да се регистрира кредитна карта',
                    labelMemorizza: 'Запазване',
                    labelRicaricaAutomatica: 'Задаване на автоматично презареждане',
                    labelRicaricaAutomaticaAttiva: 'Опцията за автоматично включване е включена',
                    labelRicaricaAutomaticaNonDisponibile: 'Автоматичното презареждане не е налице',
                },
                plusCartaDiCredito: {
                    labelElimina: 'Изтриване',
                    labelProprietario: 'СОБСТВЕНИК',
                    labelValidita: 'ВАЛИДНИ <br/> THRU',
                },
                posti: 'Места',
                posto: 'Място',
                preferite: 'Фаворити',
                preferiti: 'Любими',
                prefissoData: 'за',
                prezzo: 'Цена',
                primaAttivazione: 'Първо валидиране:',
                procedi: 'Напред',
                prodotti: 'Продукти',
                promoOK: 'Промоцията е използвана',
                prosegui: 'Продължавай',
                qrCodeFermata: 'QR код на автобус',
                quando: 'Кога',
                quantita: 'Количество',
                raggiungici: 'Стигнете до нас',
                realtaAumentata: 'Увеличена реалност',
                recenti: 'Най-скорошен',
                refresh: 'Обновяване',
                reset:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                results: 'Резултати',
                ricarica: 'Заредете допълнително кредита си',
                ricerca: 'Търсене',
                riceviAssistenza: 'Получаване на помощ',
                rifiuta: 'Отказ',
                rifiutata: '',
                rimuoviFiltri: 'Премахване на филтрите',
                riprova: 'Опитайте пак',
                risultatiPer: 'Резултати за',
                rivendite: 'Кабини и магазини за билети',
                salta: 'Пропускане',
                salva: 'Запазване',
                salvaNeiPreferiti: 'Запазване като отметки',
                salvaProcedi: 'Запазване и продължаване...',
                salve: 'Здравейте',
                scadenza: '',
                scanQrCode: '',
                scegliRitorno: 'Изберете връщане',
                scegliTipologia: 'Изберете категория за филтриране',
                secureCode: 'Мобилен защитен код',
                secureCodeMyCicero: 'myCicero защитен код',
                secureCodeRecover:
                    'Тъй като не може да бъде извлечено, ако сте го загубили, трябва да изтриете и отново да регистрирате кредитната си карта.',
                seiSicuro: 'Сигурни ли сте?',
                seleziona: 'Изберете',
                selezionaMemorizza: 'Избор и запазване',
                selezionaPosizioneMappa: '',
                sempre: 'винаги',
                servizi: 'Услуги',
                serviziAggiuntivi: 'Допълнителни услуги:',
                share: 'Споделяне',
                sharing: {
                    header: 'Харесва ли ви myCicero?',
                    provaMyCicero: 'Опитайте myCicero!',
                    sharingMessage:
                        'Ако използвате обществени транспортни средства или ако търсите интелигентна, бърза и евтина система за заплащане на паркинг от приложение, определено трябва да опитате myCicero!\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\nmyCicero е единственото приложение, което Ви позволява да паркирате колата си и да пътувате с помощта на обществени транспортни средства. Приложението ще Ви подкрепя във всяка стъпка от пътуването Ви. Едно приложение за много услуги.\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n- Може да платите само реалните минути за паркиране и закупуване на разрешени зони с ограничен трафик.\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n- Интегрирани туристически решения с местни връзки и билети.\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n- Местни и национални линии с билети и билети за продажба.\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n- График и билети с едно кликване, затворете Вашия смартфон до портата за билети и влезте.',
                    shortText: 'Споделете приложението с приятелите си!',
                    text: 'Харесва ли ви myCicero? Споделете го!',
                },
                socialMedia: '',
                soloAndata: 'Еднопосочен',
                sosta: 'Паркинг',
                spese: 'Разходи',
                sulista: 'Списък',
                sumappa: 'Карта',
                targa: 'Регистрационен номер',
                tariffa: 'Тарифа',
                telefono: 'Телефон',
                tempoScaduto: '',
                terminaApp: 'Затворете приложението',
                termsCondition: 'Прочетох и приемам Общите условия',
                timeoutPagamentoBigliettoTrasportoMessage: '',
                timeoutPagamentoMessage: '',
                timeoutPagamentoTitle: '',
                tipo: 'Тип:',
                tipologia: 'Тип',
                tornaAllaHome: 'Обратно',
                tornaIndietro: 'Назад',
                totale: 'Обща сума',
                tours: 'Обиколка',
                tra: 'в {0}',
                trasporto: 'Tранспорт',
                tuttaLaSettimana: 'Цялата седмица',
                tutteTipologie: 'Всички типове',
                tutti: 'всички',
                utente: 'Потребител',
                utenti: '',
                utilizzabileIl: 'Може да се използва на адрес:',
                utilizzoTitoliAtac: 'Управление на билети ATAC',
                vaiAlTitolo: 'Към билета',
                vaiAllaPagina: 'Към страница',
                valida: 'Активиране',
                validoDal: 'Активен от',
                validoFinoAl: 'Валиден до',
                validoFinoAlle: 'Валиден до',
                validoIlGiorno: 'Валидно на',
                validoTra: 'Важи в',
                verifico: 'Проверка...',
                verifying: 'Проверка...',
                version: 'Версия',
                vettore: 'Оператор',
                viaggi: '',
                viaggio: '',
                visitaIlSito: 'Посетете уебсайта',
                yes: 'Да',
                zonaNonCoperta: 'Градът, в който се намирате, не се покрива от услугата',
            },
            credito: {
                aci: {
                    descrRedirect: 'С натискане на бутона, Вие ще бъдете пренасочени към страницата за плащане на ACI.',
                    descrizione: 'Направете плащането с ACI pay',
                },
                acquistoConBorsellino: 'Купете чрез Вашия кредит',
                acquistoConBorsellinoMyCicero: 'Купете чрез Вашия myCicero кредит',
                acquistoConBorsellinoTrasporto: 'Купете чрез Вашия кредит за градски транспорт',
                acquistoSisalAbbSosta:
                    'Веднага след завършване на покупката, разрешението за паркиране ще бъде налично в раздел "Паркинг и Зона с ограничен трафик - Отстъпки"',
                acquistoSisalRicaricaBorsellino:
                    'Веднага щом покупката бъде завършена, кредитът Ви ще бъде актуализиран',
                alertConnessioneCadutaAcquistoAbb:
                    'Връзката е загубена по време на транзакцията. Възможно е операцията да не бъде успешно завършена. Моля, проверете дали новият абонамент е правилно показан в списъка Ви с абонаменти. Ако не, опитайте да го закупите отново',
                attivaBorsellinoTrasportoPubblico: 'Активирайте електронния си портфейл за обществен транспорт',
                bemoov: {
                    descrRedirect:
                        'Ще бъдете пренасочени към външна страница и ще бъдете помолени да въведете OTP кода и CV2 на свързаната Ви кредитна карта',
                    descrUsoNumeroTelefono: 'OTP код ще бъде изпратен чрез SMS до посочения номер за потвърждение',
                    inserisciNumeroTelefono: 'Моля, въведете телефонния номер, свързан с профила Ви',
                },
                clearCodice: 'Изтриване на кода',
                controllaCodice: 'Проверете кода',
                credito: 'Кредит',
                creditoBorsellinoInsufficiente: 'Недостатъчен кредит за тази покупка в електронния портфейл',
                creditoInsufficiente: 'Недостатъчен кредит',
                creditoResiduo: 'Оставащ кредит',
                creditoSosta: 'Кредит за паркиране',
                datiPagamento: 'Данни за плащане',
                dettaglioAcquisto: 'Подробности за покупката',
                dettaglioAttivitaRicarica: 'Подробности за обработените кредитни зареждания',
                effettuaPagamento: 'Купуване',
                effettuaPagamentoPer: 'Плащане',
                erroreCaricamento: 'Възникна грешка. Данните не успяха да се заредят. Моля, опитайте отново по-късно',
                erroreSalvataggio:
                    'Възникна грешка. Направените промени не бяха запазени. Моля, опитайте отново по-късно',
                gestionePagamento: 'Обработка на плащане',
                importoAcquisto: 'Сума на покупка',
                infoAcquistiSmartphoneHTML:
                    'Регистрирайки кредитна карта, Вие ще може да закупувате абонаменти и да зареждате целия си кредит за паркиране директно на Вашия смартфон. <a href="#" onclick="javascript:openLinkOnBrowser(getLinkRegistraCarta(),true)"> Регистрирайте картата сега </a>! "',
                infoAttivaBorsellinoHTML:
                    'Възможно е да се плати чрез предварително таксувания кредит от  електронен портфейл. За да я активирате, посетете <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)"> частния акаунт </a> (от компютър). "',
                infoConfermaPagamento:
                    'С натискането на този бутон избраната сума ще бъде начислена на избраната Кредитна карта',
                infoConfermaPagamentoBorsellino:
                    'С натискането на този бутон избраната сума ще бъде таксувана от вашия електронен портфейл',
                infoConfermaPagamentoBorsellinoMyCicero:
                    'С натискането на този бутон избраната сума ще бъде таксувана от вашия електронен портфейл',
                infoConfermaPagamentoBorsellinoTemplate:
                    'С натискането на този бутон, избраната сума ще бъде таксувана на Вашия {0} мобилен портфейл',
                infoConfermaPagamentoRedirect: 'Ще бъдете пренасочени към външна уеб страница',
                infoRicaricaBorsellinoHTML:
                    'Може да зареждате електронния си портфейл директно от телефона си (<a data-bind=tap: gotoRicarica"> кликнете тук </a>) или от компютър, който влиза в <a href = "#" onclick = "javascript: openLinkOnBrowser (getLinkProfilo (), true) "> частен акаунт </a>."',
                infoRicaricaBorsellinoShortHTML:
                    'Може да заредите електронния си портфейл от компютър в <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)"> частния акаунт </a>. "',
                inserisciCodiceCouponRicarica: 'Вмъкване на код за ваучер',
                inserisciDatiCarta: 'Въведете данните за кредитната карта',
                inserisciSecureCode: 'Поставете мобилния си защитен код',
                inserisciSecureCodeMyCicero: 'Поставете Вашия защитен код myCicero',
                metodoPagamento: 'Начин на плащане',
                noCreditCard: 'Направете покупка с кредитна карта',
                nonRicordi: 'Забравихте кода си?',
                pagaCon: 'Плати с',
                payCreditOneShot: 'Платете сумата, без да регистрирате кредитна карта',
                paypal: {
                    info1: 'Плащайте автоматично с Вашата PayPal сметка.',
                    info2: 'С натискане на бутона, ще платите веднага чрез PayPal.',
                    titolo: 'PayPal <SUP> TM </ SUP>',
                },
                paypalexp: {
                    descrRedirect: 'С натискане на този бутон ще бъдете пренасочени към PayPal плащане.',
                    descrizione: 'Paypal express плащане на касата',
                },
                paypalric: {
                    descrRedirect: 'С натискане на бутона "Да", Вие ще платите чрез PayPal.',
                    descrizione: 'Платете с PayPal сметката си',
                },
                prenotazioneSisal: 'Имате резервация <br/> от & euro; & nbsp; {0}',
                prenotazioneSisalAbb: 'Имате резервация <br/> от & euro; & nbsp; {0}',
                prenotazioneSisalRic: 'Имате резервация за <br/> начислена в кредита от & euro; & nbsp; {0}',
                promoTitoli: 'Промоция',
                redirectToCCInfo:
                    'Ще бъдете пренасочени към външна защитена уеб страница и ще бъдете помолени да предоставите данните за кредитната си карта',
                registraCartaCredito: 'Нова кредитна карта...',
                ricarica: 'Заредете допълнително кредита си',
                ricaricaBorsellino: 'Заредете кредита си',
                ricaricaCoupon: 'Имате ли ваучер?',
                ricaricaCouponNonValido: 'Кодът е невалиден или изтекъл',
                ricaricaCouponUsaCodice: 'Търсене...',
                ricaricaCouponVerificaCodiceBtn: 'Потвърдете кода',
                ricaricaCredito: 'Заредете допълнително кредита си',
                ricaricaSuccess: 'Операцията е завършена успешно',
                richiediPagamento: 'Заявка за плащане',
                richiediPagamentoPer: 'Заявете плащане за',
                saldo: 'Баланс',
                saldoAttuale: 'Баланс по текущия кредит',
                saldoFuturo: 'Кредит',
                satispay: {
                    bonus:
                        '& Евро; 5,00 бонус, ако се<u onclick = "openLinkOnBrowser (" https://www.satispay.com/promo/mycicero ")"> регистрирайте </u> към услугата!',
                    completaPagamento:
                        'Завършете плащането в приложението <span style = "font-weight: bold"> SatisPay </span>',
                    confermaCompletato: 'Веднага след като получим потвърждение, покупката ще бъде завършена',
                    inserisciNumero: 'Моля, въведете телефонния номер, свързан с профила ви в Satispay',
                    risultatoAcquisto: 'След приключване на покупката, билетът ще бъде достъпен в раздел "Транспорт"',
                    titolo: 'Satispay',
                    verraiRediretto: 'Може да завършите плащането в приложението <strong> Satispay </strong>',
                },
                scegliCartaCredito: 'Изберете една от Вашите регистрирани кредитни карти',
                scegliImporto: 'Изберете сумата за презареждане на Вашия кредит',
                scegliMetodoPagamento: 'Избор наметод за плащане',
                screenSaved: 'Снимка на този код е запазена в галерията на телефона Ви',
                secureCodeErrato: 'Грешен защитен код',
                secureCodeReminder:
                    'Mobile Secure Code е таен 5-цифрен номер, който сте въвели при регистрацията на кредитната карта.',
                secureCodeReminderMyCicero:
                    'myCicero Secure Code е таен 5-цифрен номер, който сте въвели при регистрацията на кредитната карта.',
                sisalCommissioni1: 'Освен цената на операцията, ще трябва да платите също',
                sisalCommissioni2: 'такса SisalPay',
                sisalCommissioni3: 'която е пропорционална на платената сума',
                sisalGeneraCod: 'Създайте код за',
                sisalInfoAcquisto:
                    'За да заплатите такса за кредита, отидете на един от оторизираните <u> SisalPay точки за продажба </u> и представете следните параметри...',
                sisalInfoAcquisto2:
                    'Моля, отидете на <span class = "underline primary"> SisalPay място на продажба </span> и помолете търговеца да плати на bus.it - ​​myCicero и да съобщи следния PNR код.',
                sisalInfoAcquisto3:
                    'Отидете на търговски обект на SisalPay и помолете търговеца да плати на bus.it - ​​myCicero и да съобщи свързания PNR код.',
                sisalInfoMaggiorazioneHtml:
                    'Към разход за сделката ще се добави и допълнителната такса, прилагана от SisalPay, пропорционално на сумата, която трябва да бъде платена. За повече информация, моля, посетете <span class = "underline primary"> тази връзка </span>.',
                sisalInviatoPerEmail: 'Този код е изпратен на Вашия имейл адрес',
                sisalMostraRivendite: 'Покажете списъка с SisalPay агенции',
                sisalPay: 'SisalPay',
                sisalPayDescription:
                    'След кликване ще се генерира PNR код, който ще бъде предоставен  на SisalPay агенцията, за да се пристъпи към плащане',
                sisalPuntiVendita: 'SisalPay търговски обекти',
                sisalRaggiungi:
                    'За да извършите плащане, моля, отидете на SisalPay точка за продажба и помолете търговеца да плати на bus.it - ​​myCicero и да Ви  съобщи PNR кода, който ще бъде генериран',
                sisalbill: {
                    completaPagamento: '',
                    completaPagamentoFallita: '',
                    confermaCompletato: '',
                    confermaCompletatoAbbonamentoSosta: '',
                    confermaCompletatoBorsellino: '',
                    confermaCompletatoFallita: '',
                    confermaCompletatoTitoli: '',
                    risultatoAcquisto: '',
                    risultatoAcquistoBorsellino: '',
                },
                staiAcquistando: 'На път сте да закупите:',
                staiPagando: 'На път сте да платите:',
                staiPrenotando: 'На път сте да резервирате плащането на:',
                stpay: {
                    descr:
                        '<p> Satispay е платежна система, независима от традиционните методи като дебитните и кредитни карти. </p>',
                    iscrivitiSubito: 'Присъединете се сега, за да получите своя 5 € бонус за добре дошли',
                },
                usaIlCredito: {
                    info1: 'Заредете кредита си и го използвайте за плащане на услугите на myCicero.',
                    info1Branded: 'Заредете отново кредита си и го използвайте за плащане на всички услуги',
                    info2:
                        'Така че, не е нужно да въвеждате данните за кредитната си карта всеки път! Без допълнително заплащане. Налице е широк набор от методи за плащане',
                    info2Branded:
                        'Така че, не е нужно да въвеждате данните за кредитната си карта всеки път! Без допълнително заплащане.',
                    ricaricaCredito: 'Заредете допълнително кредита си',
                    titolo: 'Защото е удобно',
                },
            },
            dettaglioSinteticoFermata: {
                direzione: '{0}',
                distanzaDaTe: '{0} от Вас',
            },
            dettaglioSisnteticoBus: {
                direzione: 'Направление: {0}',
                distanzaDaTe: 'Спирка на {0} от вас',
            },
            difonzo: {
                acquistaTitoli: '',
                fermateEdOrari: '',
                mieiTitoli: '',
                soluzioniDiViaggio: '',
            },
            dolomiti: {
                AcquistaBiglietti: 'Купи билети',
                CalcolaPercorso: 'Изчисляване на маршрут',
                Eventi: 'Събития',
                FermateOrari: 'Спирки и разписания',
                Luoghi: 'Места',
                MieiTitoli: 'Моите билети',
                ServiziTuristici: 'Туристически услуги',
            },
            eav: {
                AcquistaBiglietti:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                CalcolaPercorsoHTML:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                CampaniaExpress: '',
                CampaniaExpressHTML:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                CumaExpress: '',
                CumaExpressHTML:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                FermateOrari: '',
                FermateOrariHTML:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                MieiTitoli: 'Моите билети',
                bigliettiBus: '',
                bigliettiFunivia: '',
                bigliettiTreno: '',
                fermate: 'Спирки',
            },
            elbasharing: {
                bachecaTab: {
                    conducenti: '',
                    passeggeri: '',
                    taxi: '',
                },
                common: {
                    cercaUnPassaggio: '',
                    filtraLabel: '',
                    filtriAttivi: '',
                    filtroAttivo: '',
                    infomobilita: '',
                    nuovaRicerca: '',
                    trovaSoluzioneViaggio: '',
                },
                homepage: {
                    bacheca: '',
                    consultaOfferteRichieste: '',
                    controllaViaggi: '',
                    iMieiViaggi: '',
                    offriUnPassaggio: '',
                    partecipaOpinione: '',
                    questionari: '',
                    rendiDisponibileAuto: '',
                    servizi: 'Услуги',
                    viviIlTerritorio: '',
                },
                review: {
                    reviewLabel: '',
                },
                soluzioniDiViaggio: {
                    posizioniNonValideOffriPassaggio: '',
                    posizioniNonValideRichiediPassaggio: '',
                },
                tabelloneOrari: {
                    intornoAllIndirizzo: '',
                },
                taxiCondivisoStatus: {
                    taxiStatus: '',
                },
                vetrinaVettori: {
                    description: '',
                },
            },
            event: {
                allCategories: 'Всички категории',
                arrivi: 'Пристигания',
                caricaAltriEventi: 'добавяне на други събития',
                definisciRaggio: 'дефиниране на обхват на разстояние:',
                dettaglio: 'Подробности за събитие',
                elenco: 'Списък',
                entroIl: 'Събития в рамките на',
                eventi: 'Събития',
                eventiCorrelati: 'Свързани събития',
                finePrevista: 'очакван край',
                inPartenzaEntro: 'Тръгване на обиколка в рамките на',
                info: 'Информация',
                infoContatti: {
                    cellulare: 'Мобилен телефон',
                    email: 'Email',
                    facebook: 'Facebook',
                    organizzatoDa: 'Организиран от',
                    sitoWeb: 'Web',
                    social: 'Социални мрежи',
                    telefono: 'Телефон',
                    vaiAlSito: 'Отидете на уебсайта',
                },
                ingresso: 'Вход',
                inizio: 'Начало',
                itinerariCorrelati: 'Маршрути, които минават оттук',
                itinerario: 'Маршрут',
                mappa: 'Карта',
                noEventi: 'Няма планирано събитие',
                nomeEvent: 'Име на събитие',
                ospiti: 'Важни гости',
                partenze: 'Заминаване',
                prossimiEventi: 'Следващи събития',
                prossimiEventiPoi: 'следващите събития на това местоположение',
                quando: 'Кога',
                raggioRicerca: 'Обхват на разстоянието',
                searchAllCat: 'Търсене във всички категории',
                selezionaEvento: 'Изберете събитие',
                serviziUtili: 'Полезни услуги',
                specialitaCorrelate: 'Свързани продукти',
                tab: {
                    allegati: 'Прикачен',
                    info: 'Информация',
                    mappa: 'Карта',
                },
                vetrina: 'Афиш',
                warnTariffe: 'Цената, която виждате, се отнася до основната тарифа, проверете я в ценовата листа',
                when: {
                    '30days': {
                        long: 'Следващите 30 дни',
                        short: '30 дни',
                    },
                    '7days': {
                        long: 'Следващите 7 дни',
                        short: '7 дни',
                    },
                    specifica: 'Определен ден',
                    today: {
                        long: 'Днес',
                        short: 'Днес',
                    },
                    tomorrow: {
                        long: 'Утре',
                        short: 'Утре',
                    },
                },
            },
            flussoPagamento: {
                acquistoAbbSosta:
                    'Вашео разрешение за паркиране се намира в "Паркинг и Зона с ограничен трафик - Отстъпки"',
                acquistoBigliettoTrasporto: 'Вашият билет е наличен в "Транспорт"',
                acquistoRicaricaBorsellino: 'Кредитът Ви бе актуализиран',
                acquistoSatispayAbbSosta:
                    'В момента, в който Satispay потвърди транзакцията, разрешението Ви за паркиране ще бъде налично в раздел "Паркинг и Зона с ограничен трафик - Отстъпки"',
                acquistoSatispayBigliettoTrasporto:
                    'В момента, в който Satispay потвърди транзакцията, Вашият сезонен билет ще бъде наличен в раздел "Транспорт".',
                acquistoSatispayRicaricaBorsellino:
                    'В момента, в който Satispay потвърди транзакцията, кредитът Ви ще бъде актуализиран',
                attesaConfermaSatispay: 'Изчаква се потвърждение от Satispay',
                attesaTransazioneSatispay: 'Някои транзакции може да се нуждаят от повече време от очакваното.',
                confermaPinCode: 'Потвърдете PIN кода',
                creditoMyCicero: 'myCicero Кредит',
                creditoPrecedente: 'Предишен кредит',
                errorePagamento: 'По време на плащането възникна грешка',
                importoAcquisto: 'Сума на покупка',
                messaggioTransazioneFallita: 'Нещо се обърка и операцията не можа да бъде завършена.',
                pagamentoSanzioneEseguito:
                    'Скоро ще получите имейл с касовата бележка. Може да проверите транзакцията от списъка с транзакции във Вашия потребителски профил.',
                pagamentoSkidataEseguito:
                    'Моля, отидете на изхода за паркиране и поставете билета в идентификатора на паркинга, за да вдигнете бариерата.',
                pinErrato: 'Грешен PIN код',
                richiestaAcquistoSatispayAbbSosta:
                    'Веднага след завършване на покупката, разрешението за паркиране ще бъде налично в раздел "Паркинг и Зона с ограничен трафик - Отстъпки"',
                richiestaAcquistoSatispayBigliettoTrasporto:
                    'Веднага щом покупката бъде завършена, Вашият сезонен билет ще бъде наличен в раздел "Транспорт".',
                richiestaAcquistoSatispayRicaricaBorsellino:
                    'Веднага щом покупката бъде завършена, кредитът Ви ще бъде актуализиран',
                saldoAttuale: 'Текущ кредит',
                scegliAltriMetodi: 'или изберете',
                scegliCarta: 'Изберете карта',
                scorriPerPagare: 'Превъртете, за да платите',
                transazioneAnnullata: 'Сделката е анулирана от клиента.',
                transazioneEffettuata: 'Транзакцията приключи.',
                transazioneFallita: 'Транзакцията бе неуспешна.',
                usaAltraCarta: 'Плащане с друга карта...',
                verificaTransazioneSatispay: 'Проверете транзакцията',
            },
            flybus: {
                gtSearch: {
                    soluzioniDiViaggio: 'Резултати за </ BR> пътувания',
                },
                homepage: {
                    elencoMovimenti: 'Транзакции </ BR> списък',
                    myTickets: 'Моите </ BR> билети',
                    ricaricaCredito: 'Презареждане </ BR> кредит',
                    soluzioniDiViaggio: 'Резултати за </ BR> пътувания',
                    subtitle:
                        '<span class = "bold"> Купете си билет </span> <span style = "font-weight: 200"> </br> за автобус </br> за Доломитите </span>',
                },
            },
            geocode: {
                fail: 'Позицията не е намерена',
                indirizziTrovati: 'Съответстващи резултати',
                istruzioniChangePositionPageHtml:
                    'Въведете адрес, след което кликнете върху <div class = "ui-icon-plus-submit" стил = "ширина: 16px; височина: 15px; дисплей: inline-block;"> </div>, за да започнете търсенето',
                lookForPos: 'Получаване на позиция...',
                noLocalitaTrovata: 'Няма намерен адрес',
                nodata: {
                    empty: 'Няма намерен адрес',
                },
                posNotAvailable: 'Позицията не е налице.',
                slowGeocoder: 'Геокодерът отнема твърде много време, за да отговори',
            },
            gps: {
                abilitaGpsHtml:
                    "Вашите настройки за поверителност ни пречат да разберем Вашата позиция. За да активирате позиционирането по GPS, <a href='#position-page'> проверете настройките си </a>",
                addressNotFound: 'Адресът не е намерен',
                auto: 'GPS',
                buona: 'Добре',
                cambiaIndirizzo: 'Смяна на адрес',
                cambiaPosizione: 'Промяна на позицията',
                discreta: 'Дискретен',
                eccellente: 'Отличен',
                enable: 'разрешете откриването на GPS местоположение',
                errors: {
                    '0': 'Откритите услуги не се поддържат',
                    '1': 'Не е възможно достъп до откритите услуги',
                    '2': 'Текущата позиция не е открита',
                    '3': 'Текущата позиция не е открита',
                    '4': 'Операцията е анулирана',
                    '410': 'Http грешка',
                    authorizationDenied: 'Не сте упълномощили услуги за местоположение',
                    genericInObliteration:
                        ' Позицията Ви не е налице. Моля, проверете дали услугата за местоположение Ви е активна.',
                    hardwareDisabled: 'Проследяването на местоположението на GPS е деактивирано',
                    positionUnavailable: 'Текущата позиция не е налична',
                },
                info:
                    'За да Ви предоставим изключително надеждни и прецизни услуги е необходимо да знаем Вашата текуща позиция. PluService се ангажира да защитава Вашата поверителност, поради което местоположението Ви никога няма да бъде открито без изричното Ви съгласие; освен това никога няма да съхраняваме Вашето местоположение в нашите сървъри.',
                infoAttivaGps:
                    'За да Ви предостави разширена услуга, приложението трябва да знае текущата Ви позиция. Моля, активирайте GPS в устройството си',
                infoAttivaGpsIphone:
                    'За да се гарантира правилното функциониране, приложението трябва да знае текущото Ви местоположение. Моля, активирайте GPS в устройството си',
                inserisciPosizione: 'Въведете адрес',
                manuale: 'наръчник',
                miaPosizione: 'Моята позиция',
                noGps:
                    'Няма наличен GPS сигнал. Вашият GPS може да е деактивиран или устройството Ви да не може да приема GPS сигнали, т.к. се намира в мъртва зона.',
                nuovoIndirizzo: 'Нов адрес',
                portamiQui: 'Доведи ме тук',
                posAttuale: 'текуща позиция',
                posNonDisponibile: 'Текущата позиция не е налице',
                posRilevata: 'Тук е открита текущата Ви позиция',
                posizioneNonDefinita: 'Текуща позиция не е определена',
                precisione: 'Прецизност',
                rilevaPosizione: 'откриване на позиция',
                rilevamentoPosInCorso: 'Откриване на позицията Ви...',
                scarsa: 'Слаб',
                searching: 'Локализиране...',
                segnaleDebole: 'слаб GPS сигнал',
                tuaPosizione: 'Вие се намирате',
            },
            home: {
                all: 'Всички',
                en: 'Английски',
                gps: 'от GPS',
                it: 'Италиански',
                manual: 'Адрес',
                manualdialog: {
                    header: 'Адрес',
                    placeholder: 'Въведете адрес',
                },
                optionsdialog: {
                    header: 'опции',
                },
                search: 'търсене наблизо',
            },
            iccrea: {
                cambiaZona: 'Промяна на областта',
                homeTitle: 'BCC Club Card Ви приветства в <b> {0} </b>',
                hometitleNoPos: 'BCC Club Card Ви приветства',
                serviziTuttaItalia: 'Нашите услуги са активни в цяла Италия',
                tutorial: {
                    subtitle1: 'Всички най-полезни услуги за свободно време и пари с едно натискане.',
                    subtitle2: 'Плащайте само за реалните минути за паркиране и нямате нужда от паркоместа.',
                    subtitle3: 'Открийте отстъпки и ваучери за Вас в магазините около Вас.',
                    subtitle4:
                        'Купете сезонни и други видове билети за влакове и автобуси от приложението, без повече опашки.',
                    subtitle5:
                        'Може да имате пряк достъп с идентификационните данни на BCC картата, като изберете Вход в приложението MyCartaBCC.',
                    subtitle6:
                        'Заредете портфейла на приложението с BCC Card или Satispay и платете с едно кликване всички услуги на територията!',
                    title1: 'BCC картата е винаги на Ваша страна!',
                    title2: 'Намалете разходите за паркиране',
                    title3: 'Ползи и пазаруване с CartaBCC!',
                    title4: 'Да се качите на влак или автобус никога не е било толкова лесно!',
                    title5: 'Не е необходимо да се регистрирате!',
                    title6: 'Заредете допълнително кредита си',
                },
            },
            inserimentoPin: {
                placeholder: '5 номера-цифри',
            },
            insiel: {
                centralinoUffici: 'Телефон Централен офис Villa Chiozza',
                infoPrezziBiglietti: 'информация за цената на билет',
                luoghi: 'Места и регион',
                mobilitaRegione: 'Мобилност в региона',
                progetto:
                    'Проект съфинансиран от Европейския съюз с POR FESR 2007-2013 - дейност 3.2.b "Разработване на съвременни компютърни услуги за туристическата система"',
                scopriEventi: 'открийте всички събития',
            },
            isosta: {
                abb: {
                    abbonamenti: 'Отстъпки',
                    abbonamentiSubTitle: 'Дневни и дългосрочни разрешителни за паркиране',
                    abbonamento: 'Дългосрочни разрешителни за паркиране',
                    acquista: 'Покупка',
                    acquistoAbbonamenti: 'Покупка',
                    attivi: 'Активен',
                    cambioTargaFail: 'Промяната на регистрационния номер не бе извършена',
                    cambioTargaSuccess: 'Регистрационния номер е сменен успешно',
                    campoNonValido: '',
                    campoObbligatorio: '',
                    caricaAbbonamentiErroreTesto: 'Грешка: не е възможно да се зареди артикула!',
                    caricaAbbonamentiErroreTitolo: 'Артикулът не може да се зареди',
                    categoriaAbbonamento: 'Категория',
                    confermaAcquistoAbbSovrapposto: 'Желаете ли да продължите с покупката?',
                    dataFineValidita: 'До',
                    dataInizioValidita: 'Активен от',
                    datiAggiuntivi: '',
                    datiIncompleti:
                        'Данните липсват или са непълни. Опитайте се да излезете и да влезете отново в този абонамент или да се свържете с нашия отдел Поддръжка за допълнително съдействие',
                    erroreCambioTargaListaAbb:
                        'Регистрационния номер е сменен успешно, но не е възможно да изтеглите списъка с абонаменти в телефона си. Ще бъдете пренасочени към началната страница на абонамента',
                    failAcquistoAbb:
                        'Неуспешно закупуване на абонамент! Моля, свържете се с нашия отдел Поддръжка за допълнително съдействие',
                    infoTipologiaNonAcquistabileDaUtente:
                        'Вашият профил не разполага с необходимите разрешителни за закупуване на този тип абонамент',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'След като завършите процеса на закупуване, е възможно да изтеглите билета, като въведетеизберете страницата "Отстъпки" и актуализирате списъка',
                    noAbbInCorsoDiValidita: 'Не е намерен валиден сезонен билет',
                    noAbbNonAttivi: 'Не са открити закупени сезонни и неизползвани билети',
                    noAbbScaduti: 'Не са открити изтекли сезонни билети',
                    noAgevolazioni: 'Все още нямате дългосрочно разрешение за паркиране',
                    noAgevolazioniZtl: 'Все още нямате разрешение за Зона с ограничен трафик',
                    noZtlInCorsoDiValidita: 'Не са намерени валидни разрешения',
                    noZtlNonAttivi: 'Няма намерени разрешения',
                    noZtlScaduti: 'Не са намерени изтекли разрешителни',
                    nonAcquistabile: 'Артикулът не може да се закупи',
                    nonAncoraAttivi: 'Закупен - все още не е активен',
                    oraFineValidita: 'До:',
                    oraInizioValidita: 'От:',
                    ore: '',
                    oreMeno: '',
                    scaduti: 'Изтекъл',
                    scegliComuneAreaSosta: 'Изберете града, в който се намира зоната за паркиране',
                    scegliTipoAbbonamento: 'Изберете тип абонамент...',
                    scegliTitolo: 'Изберете билета',
                    scegliVeicolo: 'Изберете номер на табела',
                    successAcquistoAbb: 'Абонаментът е закупен успешно!',
                    tipoAbbonamento: 'Тип',
                    tipologiaNonAcquistabileDaUtente: 'Потребителят няма право да закупи този вид абонамент',
                    validitaAbbonamento: 'Валидност',
                    warnAbbSovrapposto: 'Вече имате валидни билети за посочения период',
                },
                accettoCondizioniTerminiServizio: 'Съгласен съм с <action> Общите условия за използване </action>',
                affinaRicerca: 'Опитайте се да въведете по-точен адрес...',
                attivaServizio: 'Активиране на услугата',
                attivaServizioTesto: 'За паркиране е необходимо да се въведат данните за автомобила',
                attivazioneAccediPreferenzeAziendaHtml:
                    'Моля, влезте в профила си на уебсайта чрез компютър  <span class = "underline" onclick = "openLinkOnBrowser (" http://www.mycicero.it ")"> www.mycicero.it </span>, раздел Лични данни, попълнете празните полета, за да се регистрирате като фирма или на свободна практика, за да получите фактурата.',
                attivazioneAccediPreferenzeAziendaTitle: 'Вие сте фирма или на свободна практика?',
                attivazioneAccediPreferenzeHtml:
                    'Моля, влезте в профила си чрез компютър в уеб сайта <span class = "underline" onclick = "openLinkOnBrowser (" http://www.mycicero.it ")"> www.mycicero.it </span>, за да зададете опции (начини на плащане, SMS известяване, NoCall-SMS-IVR и др.).',
                attivazioneAccediPreferenzeTitle: 'Управлявайте опциите си',
                attivazioneCompletata: 'Активирахте "{0}" услугата ',
                attivazioneCompletataInfo:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                attivazioneCompletataInfo1: '<i> <b class = "underline"> Заредете допълнително кредита си </b> </i>',
                attivazioneCompletataInfo2:
                    '<i> и започнете да паркирате, като заплатите само истинските минути за паркиране. </i>',
                attivazionePromemoriaHeader: 'Не забравяйте да презаредите кредита си за паркиране',
                attivazionePromemoriaText: 'Ще бъде необходимо да презаредите кредита си за паркиране, за да паркирате',
                autoricarica: {
                    erroreCaricamento:
                        'Възникна грешка. Данните не успяха да се заредят. Моля, опитайте отново по-късно',
                    erroreSalvataggio:
                        'Възникна грешка. Направените промени не бяха запазени. Моля, опитайте отново по-късно',
                    infoAutoricarica:
                        'С тази опция кредитът Ви ще бъде автоматично увеличен, в случай че е по-нисък от определената от Вас сума.',
                    labelAttiva: 'Активирайте опцията за автоматично набиране',
                    labelCartaDiCreditoNecessaria:
                        'За да използвате този начин на плащане, трябва да регистрирате кредитна карта',
                    labelDisattiva: 'Изключете опцията за автоматично зареждане',
                    labelProcedi: 'Напред',
                    labelSaldoInferioreA: 'В случай, че кредитът Ви е по-нисък от',
                    labelTaglioRicarica: 'Заредете допълнително кредита си до',
                    titolo: 'Автоматично презареждане',
                },
                avvisoInizioSostaDomani:
                    'Ако не приключите или не удължите паркирането си предварително, то автоматично ще бъде спряно <span class = "bold"> утре </span> в <span class = "bold"> {0} </span>',
                avvisoInizioSostaIl:
                    'Ако не приключите или не удължите паркирането си предварително, то автоматично ще спре <span class = "bold"> {0} </span> в <span class = "bold"> {1} </span>',
                avvisoInizioSostaOggi:
                    'Ако не завършите или удължите паркирането си предварително, то ще бъде спряно автоматично <span class = "bold"> днес </span> в <span class = "bold"> {0} </span>',
                calendar: {
                    aggiungiPromemoria: 'Добавяне на напомняне',
                    askAggiungiPromemoria: 'Искате ли да зададете аларма 15 минути преди изтичането на паркирането?',
                    nonAggiungere: 'Не го добавяйте',
                    procedi: 'Напред',
                    text:
                        'В календара Ви ще бъде зададено напомняне. Алармата автоматично ще ви предупреди 15 минути преди изтичането на паркинга.',
                    title: 'Добавяне на напомняне?',
                },
                caricaAltrePromozioni: 'Заредете други промоции',
                cercaLocalita: 'Търсене на град',
                codiceStallo: 'Код за паркомясто',
                codiceStalloPlaceholder: 'Въведете кода за място за паркиране',
                condizioniServizio: 'Условия за ползване на услугата',
                countdownPagamento: '',
                daConfermareEntro: 'Да бъде потвърдено в рамките на',
                dettaglioPrenotazione: {
                    annulla: 'Отменете резервацията',
                    cognome: 'Фамилия',
                    confermaAnnulla: 'Наистина ли искате да отмените резервацията?',
                    cosaFare: 'Какво да правя?',
                    datiAggiuntivi: '',
                    email: 'E-mail',
                    erroreAnnulla: 'Невъзможно е да анулирате резервацията си',
                    importo: 'Сума',
                    importoSosta: 'Сума',
                    importoTotale: 'Обща изплатена сума',
                    indirizzo: 'Адрес',
                    intestazioneInfoPrenotazione: 'Информация за резервацията',
                    messaggioInformativoSostaAttiva:
                        'За да спрете паркирането, моля, отидете до гаража и попитайте за излизане от колата. Ще бъдете таксувани само с цената за паркиране, изчислена според вашето време за влизане и определените такси за паркиране.',
                    messaggioInformativoSostaPrenotata:
                        'За достъп до гаража, покажете Вашата резервация на оператора на паркинга. В случай, че влезете преди записаното време или излезете след определеното за повече от 4 часа (четири) часа, цената ще се увеличи.',
                    modelloVeicolo: 'Модел на автомобил',
                    nome: 'Име',
                    nonSpecificato: '',
                    numeroPasseggeri: 'Пътници',
                    numeroVolo: 'Номер на полета',
                    provenienzaVolo: 'Произход на полета',
                    serviziAggiuntivi: 'Допълнителни услуги:',
                    sitoWeb: 'Web',
                    targa: 'Регистрационен номер',
                    telefono: 'Телефон',
                    titolo: 'Резервация',
                },
                disambiguaDescrizione: '',
                disambiguaHeading: '',
                disambiguaLabel: '',
                disambiguaTitolo: '',
                durataSosta: 'Продължителност:',
                elencoMovimenti: 'Отчет на транзакциите',
                elencoParcheggi: 'Списък на зоните за паркиране',
                findMyCar: {
                    aggiungiPosizione: 'Добавяне',
                    cancellaPosizione: 'Изтрийте тази позиция',
                    cancellaPosizioneTesto:
                        'Искате ли да премахнете тази позиция? Операцията не може да бъде отменена и няма да деактивира Вашия активен паркинг',
                    cancellaPosizioniTesto:
                        'Искате ли да премахнете всички запазени позиции в тази категория? Операцията не може да бъде отменена и няма да деактивира Вашето  активно паркиране',
                    clean: 'Изчисти',
                    erroreSalvataggio: 'Възникна грешка при съхранението на тази позиция. Моля, опитайте отново',
                    header: 'Намерете колата ми',
                    inserisciPosizione: 'Въведете адрес...',
                    nessunaPosizioneSalvata: 'Няма паркирани автомобили',
                    oppureUsaMappa: 'Или докоснете някъде на картата:',
                    posizione: 'Позиция',
                    posizioni: 'Позиции',
                    posizioniRecenti: 'Най-скорошен',
                    posizioniSalvate: 'Запазени позиции',
                    pulisci: 'Изчисти',
                    pulisciPosizioni: 'Премахване на позиции',
                    pulisciQuestaPosizione: 'Отстранете позицията',
                    salvaPosizione: 'Запазване на местоположението',
                    targaOrDescrizione: 'Номер на регистрационния номер или описание',
                    whereIsMyCar: 'Къде е моята кола?',
                },
                fineSosta: 'Дата на изтичане на паркирането',
                finoA: 'До',
                fraBrevePotraiRipetere: '',
                gestioneCarte: {
                    aggiungiCarta: 'Добавете карта',
                    confermaEliminazione: 'Искате ли да изтриете картата, завършваща с',
                    scaduta: 'Изтекъл',
                    titolo: 'Кредитна карта',
                },
                importoSosta: 'Сума',
                importoSostaAttuale: 'Текуща сума',
                importoSostaPrevisto: 'Очаквана сума',
                indirizzoZona: 'Търсене по шосе или зона за паркиране',
                infoMemoComunePreferito:
                    'Ако изберете да запазите избрания град, всеки път този град ще бъде предлаган, когато myCicero не може да намери Вашата локация.',
                infoStalloLabel: 'Къде мога да намеря номера на мястото за паркиране?',
                ingressoAlleOre: '',
                inizioSosta: {
                    altreZoneDiSosta: 'Други зони за паркиране',
                    askRegistraPosizione:
                        'С GPS открих точната позиция на колата Ви. Искате ли да го запазите и лесно да намерите колата си отново?',
                    avvisoDisattivazioneAutomaticaSosta: 'myCicero автоматично ще спре сесията Ви за паркиране',
                    avvisoTermineSosta: 'Паркинг сесията ще бъде спряна',
                    calcoloImporto: 'Изчисляване на сума',
                    confermaInizioSosta: 'Потвърдете началото на парка',
                    finePrevistaMediaHide: 'Очакван край:',
                    finoQuando: 'Колко дълго желаете да паркирате?',
                    impossibileCalcolareImporto: 'Грешка: Изчисляването на сумата не успя да завърши',
                    infoCoupon: 'Как работи?',
                    infoCouponNoLogin: 'Имате ли ваучер? Влезте, за да въведете кода',
                    infoLimiteTariffario: 'В този район не е позволено да се паркира извън:',
                    infoPrezzoTariffario: 'Сумата на тарифата Ви позволява да паркирате така или иначе, до:',
                    infoTariffeSu: 'Информация и цени',
                    iniziaSosta: 'Старт на паркиране',
                    inizio: 'Начало:',
                    noParcheggiRecenti: 'Няма скорошни места за паркинг',
                    noParkingsInAddress: 'Не бяха намерени райони за показване на търсенето Ви.',
                    noParkingsInCity: 'Не са намерени зони за паркиране за избрания град',
                    noParkingsInCitySeason:
                        'В този град паркингът има сезонна схема на ценообразуване. Понастоящем няма зони за паркиране, покрити от услугата.',
                    parcheggiRecenti: 'Скорошни зони за паркиране',
                    placeholderCoupon: 'Добавете кода на ваучера си',
                    promozioniIntornoATe: 'Промоции около Вас',
                    recenti: 'Най-скорошен',
                    registraPosizione: 'Запазване на позиция',
                    registraPosizioneAuto: 'Запазване на позицията на автомобила',
                    salvaPosizionePrefix: 'Запазване на установената GPS позиция',
                    salvaPosizioneShort: 'Запазете позицията си на автомобила за този паркинг',
                    salvaPosizioneSuffix: 'като място за автомобила за този паркинг',
                    scegliParcheggio: 'Изберете Вашето място за паркиране',
                    scopriCoupon: 'Искате ли да паркирате безплатно? Открийте как да го направите!',
                    scopriCoupon1: 'Искате ли да паркирате безплатно?',
                    scopriCoupon2: 'Научете как да го получите...',
                    success: 'Паркирането стартира успешно',
                },
                inizioSostaAutorimesse: {
                    avviaNavigatore: 'Стартирайте навигатор',
                    cercaPerNomeIndirizzo: 'Търсене по адрес или име',
                    chiudereSosta:
                        'За да спрете сесията за паркиране, отидете в гаража и попитайте за изхода. <br/> Ще бъдете таксувани само с разходите за паркиране според реалното време за влизане и ценовата листа.',
                    cittaNonSupportata:
                        'Градът, в който се намирате, не е покрит от услугата, ние избрахме най-близкия град, който се обслужва',
                    creditoInsufficiente:
                        'Вашият кредит не е достатъчен, за да се плати паркинга. За да стартирате нов период, трябва да презаредите кредита си за паркиране.',
                    dataOraPerPreventivo: 'Вашата сесия за паркиране се планира да продължи от сега до:',
                    durataEccessiva: 'Не може да се изчисли прогнозна цена за паркиране над 7 дни',
                    elencoStrutture: 'Списък с удобства',
                    emissioneFattura:
                        'При поискване, ще бъде издадена фактура от MyCicero. Документът не включва сумата, преведена на управителя на гаража, а само сумата, която е платена чрез платформата.',
                    finePrevista: 'Очакван край:',
                    importoTotale: 'Обща сума за този период:',
                    infoTariffe:
                        'Прилаганата в гаража ставка не може да бъде разделена според реалните минути за паркиране,  тук се отчитат само цели часове.',
                    iniziaSostaEntroTrentaMin:
                        'Заявката за паркиране ще бъде автоматично анулирана, ако не стигнете до паркинга в рамките на 30 минути. Потребителят няма да заплати никакви разходи',
                    inizioSosta: 'Старт на паркиране:',
                    inizioSostaRichiesto: 'Заявката за начало на паркиране е изпратена правилно.',
                    noResult: 'Няма намерени резултати',
                    parcheggioAlCompleto: 'Паркингът е затворен',
                    ricaricaIlBorsellino:
                        'Заредете портфейла си, ако искате да платите цялата сума с MyCicero, или платете разликата на служителя на гаража.',
                    richiediInizioSosta: 'Заявка за начало на паркинране',
                    sostaSaraAttivata:
                        'Сесията за паркиране ще бъде активирана, когато служителят на гаража потвърди влизането Ви. Планираното време не е задължително за изхода, наистина можете да прекратите предварително паркирането си. Ще бъдете таксувани с цената според реалното време за влизане и прилаганите цени.',
                    statoSosta: {
                        attiva: 'Сесията за паркиране е активна',
                        conclusa: 'Сесията за паркиране приключи',
                        inAttesa: 'Краен срок:',
                    },
                },
                insertCode: {
                    confirmDescription: '',
                    confirmTitle: '',
                    description: '',
                    nonMostrarePiu: '',
                    okGoOn: '',
                    placeholder: '',
                    title: '',
                    verifica: 'Проверка',
                },
                laMiaAuto: 'Моята кола',
                map: {
                    areaNonServitaDaTitle: 'Районът не се обслужва от {0}',
                    areaNonServitaDesc:
                        'Проверете дали в тази зона паркингът подлежи на плащане, като прочетете най-близката вертикална пътна табела или най-близкия паркинг-автомат.',
                    areaNonServitaHtml:
                        'За повече информация, моля, обадете се на номера <a href="tel:+390719207000"> + 39 & nbsp; 9207000 </a> или <a href = "#" onclick = "javascript: openLinkOnBrowser (\'http: // www .mycicero.it / chat / \', true) "> свържете се с нас чрез чата </a>',
                    areaNonServitaTitle: 'Районът не се обслужва',
                    avviaNavigatore: 'Стартирайте навигатор',
                    cambiaCitta: 'Промяна на града',
                    caricamentoCompletato: 'Зареждането е завършено!',
                    caricamentoLento: 'Зареждането на карта изисква повече време, отколкото се очакваше...',
                    caricamentoMappa: 'Картата се зарежда...',
                    cercaIndirizzo: 'Търсене по адрес',
                    disclaimerBtnText: 'Разбрах',
                    disclaimerText: 'Моля, уверете се, че сте отбелязали правилната позиция на Вашия автомобил',
                    ingrandisciMappa: 'Увеличете мащаба, за да намерите зоната за паркиране',
                    localitaSconosciuta: 'Неизвестен район',
                    mappaSosta: 'Карта за паркиране',
                    noIsostaLayer: 'Грешка при извличане на покритите райони',
                    posizioneAmbiguaTemplateString:
                        'Текущата позиция съответства на {0} възможни зони за паркиране. Изберете правилния от списъка:',
                    postiLiberi: 'Има на разположение паркоместа',
                    postoLibero: 'Има на разположение паркомясто',
                    ricercaHeaderTemplate: 'Погледнете в {0}',
                    ricercaLocalitaInCorso: 'В момента търсим за района ...',
                    ricercaPlaceholder: 'Адрес, места, забележителности',
                    scegliPosizione: 'Докоснете зона за паркиране...',
                    staiVedendo: 'В момента се показва:',
                    zonaImprecisa: 'Проверете вертикалните знаци дали предложената паркова зона е правилна',
                    zonaNonCoperta:
                        'В {0} момента няма зони за паркиране. <br/> В случай на съмнение се свържете с нас на адрес <a href="tel:+390719207000"> + 39 & nbsp; 9207000 </a> или <a href = " # "onclick =" javascript: openLinkOnBrowser ("http://www.mycicero.it/chat/\',true)"> чрез чат </a>',
                    zonaSenzaParcheggi: 'В момента тук няма места за паркиране. Бихте ли ни изпратили обратна връзка?',
                },
                memorizzaComunePreferito: 'Запазете като Ваш често използван град за паркиране',
                minuti: 'минути',
                minuto: 'минута',
                modalitaPagamento: {
                    attivaPagamentoContestuale: 'Активирайте плащане на база на използването',
                    erroreCaricamento:
                        'Възникна грешка. Данните не успяха да се заредят. Моля, опитайте отново по-късно',
                    erroreNessunaCartaDiCredito:
                        'За да активирате плащане на база на използването. Моля, регистрирайте кредитна карта',
                    erroreSalvataggio:
                        'Възникна грешка. Направените промени не бяха запазени. Моля, опитайте отново по-късно',
                    infoCostiPagamentoContestuale:
                        'Размерът на всяка сесия за паркиране се таксува директно от регистрираната кредитна карта. Тази услуга има <b> цена от 0,08 евро </b> за всяка транзакция с минимална сума на транзакцията от 0,20 евро.',
                    infoCostiPagamentoContestualeActv:
                        'Размерът на всяка сесия за паркиране се таксува директно от регистрираната кредитна карта.',
                    infoCostiPagamentoContestualeRoger: '',
                    infoCredito:
                        'Допълнете myCicero кредита с кредитна карта, чрез Satispay, MasterPass или в магазин на SisalPay. <b> Тази опция за плащане няма допълнителни разходи. </b> myCicero Credit може да се използва и за закупуване на билети и за заплащане на всички други налични услуги.',
                    infoCreditoACTV:
                        '<b> Този метод НЕ осигурява допълнителни разходи. </b> Може да използвате кредита си за закупуване на пътни билети и всички други налични услуги.',
                    infoCreditoRoger: '',
                    labelCartaDiCreditoNecessaria:
                        'За да използвате този начин на плащане, трябва да регистрирате кредитна карта',
                    labelCredito: 'Кредит',
                    labelModalita: 'Платете паркинга си с:',
                    labelNoCarteRegistrate: 'Не са намерени регистрирани карти',
                    labelPagamentoContestuale: 'Плащане на база на използване',
                    labelProcedi: 'Напред',
                    labelRegistraCarta: 'Регистрирайте карта',
                    labelRicarica: 'Заредете допълнително кредита си',
                    labelSaldo: 'Кредит',
                    labelScegliCartaDiCredito: 'Изберете кредитната карта сред регистрираните',
                    labelUtilizzaQuestaCarta: 'Използвайте тази регистрирана кредитна карта:',
                    titolo: 'Как да платя',
                },
                mostraParcheggi: 'Показване на зони за паркиране',
                numeroStallo: 'Номер на място за паркиране',
                ongoingNotification: {
                    extendButtonLabel: 'Удължете с 30 минути.',
                    message: 'до {0}',
                    stopButtonLabel: 'Спирка',
                    title: '{0} Активен паркинг',
                },
                oopsAnnullaSosta: 'Опаа! Отменете паркирането си.',
                parcheggiGestiti: {
                    avvisoDurataPrenotazione: 'Резервацията ще се изтрие автоматично след изтичане на избрания период',
                    avvisoOrarioNonConsentito:
                        'Времето за пристигане на паркинга трябва да бъде включено между {0} и {1} в съответствие с регулирането на избраното съоръжение.',
                    avvisoSostaNonDisponibile:
                        'За избраните дати не може да се резервира паркинг. Моля опитайте с различни дати',
                    avvisoTermineSosta: 'Услугата завършва с <span class = "bold"> {0} </span>.',
                    cantAddService:
                        'Не бяха включени следните заявени услуги: <ul> <% _.forEach (articlesKo, function (article) {%> <li> <% - article.descArticolo%> </li> <%}); %> </ Ул>',
                    cercaAeroportoLocalita: 'Търсене по име или град',
                    cercaAeroportoTitle: 'Изберете място',
                    cercaPlaceholder: 'Търсене по име или град',
                    condizioni: 'Прочетох информационното известие и приемам <em> условията за обслужване </em>',
                    confermaConPagamento: 'Резервирайте и платете сега',
                    confermaSenzaPagamento: 'Резервирайте и платете, след като Ви приключи паркирането',
                    dataInizioSostaNonConsentita: 'Не е възможно да запазите зоната за паркиране преди {0} в {1}',
                    erroreAggiornamentoPrezzi:
                        'Общата сума за избраните дни може да бъде актуализирана. Моля, опитайте отново по-късно.',
                    erroreGenericoDisponibilita:
                        'Проверката за наличие на паркинг с управляващия орган за паркиране е неуспешна. Моля, опитайте по-късно или се свържете с нашия отдел Поддръжка.',
                    importoPagato: 'Сумата е платена',
                    importoTotaleDurata: 'Обща сума за този период',
                    info: {
                        mail: 'Email',
                        orarioAp: 'Работно време',
                        servizi: 'Включени услуги',
                        sitoWeb: 'Web',
                        social: 'Социални мрежи',
                        telefono: 'Телефон',
                        tipo: 'Тип',
                        tipoPosti: 'Тип на местата',
                    },
                    infoDesigna: '',
                    infoPrenotazioneEffettuata:
                        'Паркингът, който сте резервирали, е на разположение в раздел „Паркинг и Зона с ограничен трафик“',
                    intestazionePrenotazione: '1 място с резервация за регистрационния номер',
                    istruzioniDownloadTitoli:
                        'След приключване на покупката ще намерите резервацията си в приложението в раздел "Паркинг и Зона с ограничен трафик".',
                    menuTitle: '',
                    nessunParcheggioRecente: 'Няма скорошни места за паркинг',
                    nessunRisultato: 'Няма налични резултати за това търсене',
                    parkAvail: 'Мястото за паркинг е на разположение.',
                    parkNotAvail: 'За избраните дни няма място за паркиране',
                    placeholderRicercaTestuale: 'Търсене по име',
                    postiNonPrenotabili: '',
                    postiNonPrenotabiliEsauriti: '',
                    prenota: 'Резервирайте',
                    prenotaParcheggio: 'Резервирайте Вашето място за паркиране',
                    prenotazioneSosta: 'Резервирайте паркинга си',
                    richiediDisponibilita: 'Заявка за наличност',
                    scegliParcheggioTitle: 'Изберете Вашето място за паркиране',
                    tabCondizioni: 'Условия',
                    tabElenco: 'Списък',
                    tabInfo: 'Информация',
                    tabMappa: 'Карта',
                    tabRecenti: 'Най-скорошен',
                    tabTariffe: 'Такси',
                    titleConferma: 'Резервирайте паркинга си',
                    titleConfermata: 'Резервацията е потвърдена',
                    titleDettaglio: 'Детайли',
                    titlePrenota: 'Резервирайте паркинга си',
                    tutteLeAree: 'Всички градове',
                    vaiAllaPrenotazione: 'Отидете на резервацията си',
                    verificaDisponibilita: 'Проверете наличността',
                    verificaDisponibilitaInCorso: 'Свързваме се с управляващия орган на паркинга',
                    visualizzaPrenotazione: 'Покажете резервацията',
                },
                parcheggio: 'Паркинг',
                posizioneNonDisponibile: 'Вашата позиция не може да бъде установена',
                preferenzeSosta: {
                    categorieAgevolate: '',
                    disclaimerCategorieSosta: '',
                    erroreSalvataggio:
                        'Възникна грешка. Направените промени не бяха запазени. Моля, опитайте отново по-късно',
                    etichettaDurataDueOre: '120 минути',
                    etichettaDurataFineGiornata: 'Края на деня',
                    etichettaDurataQuattroOre: '240 минути',
                    etichettaDurataUnOra: '60 минути',
                    infoAreaNotifiche:
                        'Разширете и спрете сесията за паркиране с едно щракване директно от центъра за известия за устройството.',
                    infoCategorieUtente: '',
                    infoCittaAbituale: 'Този град ще бъде избран автоматично, в случай че няма налична GPS позиция.',
                    infoDurataSosta:
                        'Зададените минути ще се използват при активиране на сесията за паркиране, за да се предложи продължителността на паркинга. <br/> До края на деня за паркиране или дотогава, доколкото е налице предварително таксувания кредит',
                    infoNotificheSms:
                        'Стойността на услугата е € 0,08 за всеки получен SMS. <br/> Ако стартирате и спрете паркирането чрез SMS, се изпраща SMS известие за всяка операция и не може да бъде деактивирано.',
                    labelAreaNotifiche: 'Интеграция на мястото за уведомяване',
                    labelAttiva: 'Активиране',
                    labelCittaAbituale: 'Обичаен град:',
                    labelDurataSosta: 'Предложена продължителност на паркирането:',
                    labelInLista: 'В списъка',
                    labelInMappa: 'В картата',
                    labelNotificheSms: 'SMS известия',
                    labelScegli: 'Избирам',
                    labelSmsFineSosta: 'Потвърждение при приключване на паркирането',
                    labelSmsInizioSosta: 'Потвърдете началото на парка',
                    labelVisualizzazioneCercaParcheggio:
                        'Когато търсите в зоната за паркиране, моля, използвайте картата',
                    mieCategorie: '',
                    titolo: 'Опции за паркиране',
                },
                prenotazioneDal: 'Резервация от',
                procedi: 'Напред',
                prolunga: 'Разширен',
                prolungaSosta: 'Уддължаване на продължителността на паркирането',
                prolungaSostaFail: 'Удължаването за паркиране не е успешно!',
                prolungaSostaSuccess: 'Паркирането е удължено успешно',
                qrCode: {
                    accediEntroLeOre: '',
                    accediPagaAllUscita: '',
                    entraNelParcheggio: '',
                    erroreGenerazioneQrCode: '',
                    esciDalParcheggio: '',
                    esciDalParcheggioScansionaQrCode: '',
                    infoIngressoQrCode: '',
                    infoPagamentoClassico: '',
                    infoUscitaQrCode: '',
                    ingressoEffettuatoAlleOre: '',
                    nuovoQrCode: '',
                    pagamentoClassico: '',
                    perEntrare: '',
                    perUscire: '',
                    qrCodeScaduto: '',
                    tornaAllaSosta: '',
                    visualizzaQrCode: '',
                },
                reminderUscita: '',
                ricaricaCredito: 'Заредете допълнително кредита си',
                ricaricaCreditoAssociaCarta: 'Презаредете кредита си или регистрирайте кредитна карта...',
                rifSosta: 'Паркинг сесия реф. No',
                salvaPosizione: 'Запазване на местоположението',
                scegliArea: 'Изберете зона за паркиране',
                scegliCitta: 'Изберете град',
                selezionaComune: 'Изберете град:',
                selezionaFineSosta: 'Изберете желана дата за изтичане на паркирането.',
                servizioNonAttivo:
                    'Все още не сте активирали услугата "Паркиране и Зона с ограничен трафик". Ще Ви отнеме само няколко минути.',
                skidata: {
                    activateIn: 'Ще трябва да активирате билета в рамките на:',
                    bsb: 'Кратък билет за паркиране',
                    cassaAutomatica: 'Автоматично теглене на пари',
                    disambiguaStruttura: 'Изберете зоната за паркиране',
                    emissioneFattura:
                        'При поискване, ще бъде издадена фактура от MyCicero. Документът не включва сумата, преведена на управителя на гаража, а само сумата, която е платена чрез платформата.',
                    expiredTicket: 'Генерираният билет е изтекъл.',
                    garage: 'Гараж:',
                    generationOk: 'Билетът е правилно генериран',
                    goToHome: 'Обратно',
                    infoStruttura:
                        'Сесията за паркиране ще бъде активирана, когато QR кодът се използва за повдигане на автоматичната бариера на паркинга. Ще бъдете таксувани с цената според реалното време за влизане и прилаганите цени.',
                    labelHour: 'Час',
                    labelHours: 'часа',
                    labelMinute: 'мин.',
                    labelMinutes: 'мин.',
                    labelSecond: ' сек.',
                    labelSeconds: ' сек.',
                    pagamentoOk: 'Плащането е успешно направено',
                    pagamentoOkDescHtmlTemplate:
                        'Плащането на сесията за паркиране <span class = "bold"> {0} </span> бе успешно завършена.',
                    parcheggiInStruttura: 'Покрити зони за паркиране',
                    remainingTime: 'Оставащо време:',
                    scansioneBiglietto: 'Сканиране на билет',
                    statusActive: 'Сесията за паркиране е активна',
                    statusExpired: 'Изтекли билети',
                    statusGenerated: 'Активирайте сесията за паркиране в рамките на:',
                    statusPaid: 'Излезте от гаража в:',
                    subscription: 'Сезонен билет',
                },
                sosta: 'Паркинг',
                sostaAPagamento: 'Паркиране на улицата',
                sostaAutorimesse: 'Гараж',
                sostaFinoA: 'Паркирайте до',
                sostaValidaFinoA: 'Паркирането е активно до',
                sosteAttive: 'активен',
                sosteParcheggi: 'Паркинг и Зона с ограничен трафик',
                sostePrenotate: 'Резервации',
                stallo: 'Номер на мястото за паркиране:',
                stalloMancante: 'Моля, въведете номера на мястото за паркиране',
                stalloNonValido: 'Грешен номер на място за паркиране',
                stalloTargaUsataDiRecente: 'Наскоро сте платили паркинга за тази кола',
                stalloUsatoDiRecente:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                stalloX: 'Брой места за паркиране {0}',
                talloncinoInviatoInfo: 'Логото за тази кола е изпратено на Вашия имейл адрес.',
                targhe: {
                    aggiungi: 'Добавете регистрационния номер на автомобил',
                    attr: {
                        disponibile: 'Наличен',
                        occasionale: 'Безплатно',
                        occupata: 'Използван',
                        principale: 'Главен',
                        secondaria: 'Втори',
                    },
                    cambiaTarga: 'Промяна на регистрационен номер на автомобил',
                    conferma: 'Запазване на местоположението',
                    confermaFormatoTarga:
                        'Регистрационният номер на автомобила, който сте въвели, има нестандартен формат, желаете ли все пак да го запазите?',
                    confermaIvioTalloncino: 'Операцията е завършена',
                    confermaRimozioneTarga: 'Желаете ли да изтриете този автомобил?',
                    descrizioneBreve: 'Описание/име на автомобил',
                    erroreComuniTalloncino: 'Възникна грешка. Може да се зареди списъкът на градовете.',
                    impossibileCambiareTarga: 'Не може да промените регистрационния номер',
                    inUso: 'в употреба',
                    infoCancellazioneTargaPrincipale: 'Главния автомобил не може да бъде отменен',
                    infoTalloncino: 'Ще получите имейл с логото, което ще се покаже',
                    infoTalloncinoCitta: 'някои градове.',
                    infoTalloncinoObbligatorioParte1: 'Към адреса',
                    infoTalloncinoObbligatorioParte2:
                        'ще получите имейл с логото, което е задължително да се показва в следните градове:',
                    infoTargaPrincipale1:
                        '<Span class = "bold"> Главният регистрационен номер  </span> ще бъде автоматично предложен за всяко начало на паркиране.',
                    infoTargaPrincipale2: 'Освен това се използва за SMS и NoCall.',
                    infoTargaPrincipaleInUso:
                        'Главният регистрационен номер се използва в момента, така че в сега  не може да направите друг номер главен',
                    infoTargaPrincipaleInUsoHeader: 'Използва се главният регистрационен номер',
                    infoTargaPrincipaleOwn:
                        'Това е <span class = "bold"> главния регистрационен номер </span>. <br/> Той ще бъде автоматично предлаган при всяко начало на паркиране. Освен това се използва за SMS и NoCall.',
                    inserisciDatiTarga: 'За да паркирате е необходимо да въведете данни за автомобила:',
                    inserisciTargaOccasionale:
                        'Въведете регистрационния номер на автомобила, който ще  използвате за тази сесия за паркиране:',
                    inviaTalloncino: 'Изпратете логото на Qrcode',
                    limiteRaggiunto: 'Достигнахте максималния брой на разрешени регистрирани автомобила',
                    memorizza: 'Запазване',
                    'memorizza e scegli': 'Запазване и избор',
                    modificaTarga: 'Променете номера на автомобила си',
                    nessunaTargaRegistrata: 'Не е регистриран автомобил',
                    noCallInfoTarga:
                        'Услугата Без повикване/SMS винаги ще активира паркирането на този автомобилен номер',
                    nuova: 'Добавете регистрационния номер на автомобил',
                    propostaDefault: 'Предложен по подразбиране',
                    registraneUna: 'Регистрирайте един',
                    registrazionePrimaTargaOk: 'Регистрирахте номера на автомобила',
                    registrazioneTargaKo: 'Възникна грешка  по време на регистрация на автомобила Ви',
                    registrazioneTargaOk:
                        'Автомобилът е регистриран успешно. <br/> QrCode, свързан с този автомобил е изпратен на Вашия имейл адрес <br/> {0}',
                    rendiTargaPrincipale: 'Сменете го на главен автомобил',
                    rendiTargaPrincipaleKo: 'Невъзможно е да се направи като главен регистрационен номер.',
                    rimozioneTargaKo: 'Възникна грешка при анулирането на регистрационния номер',
                    rimozioneTargaOk: 'Табелата с номера е отменена',
                    rimuovi: 'Отменете регистрационния номер',
                    rules: {
                        accettaCondizioni: 'Необходимо е да се съгласите с Общите условия за ползване',
                        troppoCorta: 'Регистрационният номер на автомобила трябва да съдържа повече от 3 символа',
                    },
                    salvaInviaTalloncino: 'Запазете и изпратете QR кода',
                    scegliTarga: 'Изберете един от регистрационните номера за стартиране на  паркирането.',
                    scegliTargaShort: '',
                    targaNonValida: 'Номерът на автомобила не е валиден',
                    targaOccasionale: 'Случайни автомобилни номера',
                    targaPrincipale: 'Сменете го на главен автомобил',
                    targaSecondaria: 'Втори регистрационен номер на  автомобил',
                    targaVeicolo: 'Регистрационен номер на автомобил',
                    targheRegistrate: 'Автомобилите са регистрирани',
                    targheSosta: 'Управлявайте автомобилите си',
                    targheSostaRegistra: 'Регистрирайте кола',
                    troppeTarghe: 'За съжаление, не повече от 2 автомобилни номера могат да бъдат регистрирани!',
                },
                termina: 'Спирка',
                terminaSosta: 'Спиране на сесия на паркиране',
                terminaSostaPrefix: 'Вие прекъсвате това паркиране',
                terminaSostaSuccess: 'Паркирането е прекъснато правилно',
                terminaSostaSuffix: 'минути преди очакваната дата на изтичане',
                termineBreve: 'Паркирането скоро ще приключи',
                termineSpecifico: 'Паркирането Ви ще изтече на {0} в {1}',
                trovaLaMiaAuto: 'Намерете колата ми',
                ultimi30MovFinoAlGiorno: 'Последните 30 транзакции до',
                usaMyCicero: 'Използвайте myCicero',
                uscitaAlleOre: '',
                validaFinoA: 'Валиден до',
                ztl: {
                    label: 'Позволени зона с ограничен трафик',
                    subtitle: 'Зони с ограничен достъп',
                },
            },
            lardini: {
                aggiornamentoRisultatiInCorso: '',
                catalogoBuoni: '',
                classifica: '',
                infoGiornataCampionato: '',
                inizioAlle: '',
                livescore: '',
                mondoLardiniFilottrano: '',
                parcheggiaCon: '',
                partiteDel: '',
                partiteLive: '',
                rilasciaPerAggiornare: '',
                scopriNovita: '',
                scorriVersoIlBassoPerAggiornare: '',
                sponsor: '',
                tableClassifica: {
                    labelSquadre: '',
                    partiteGiocate: '',
                    partiteGiocateShort: '',
                    partitePerse: '',
                    partitePerseShort: '',
                    partiteVinte: '',
                    partiteVinteShort: '',
                    punti: '',
                    puntiShort: '',
                    setPersi: '',
                    setPersiShort: '',
                    setVinti: '',
                    setVintiShort: '',
                },
                viaggiaCon: '',
                visualizzaParzialiSet: '',
            },
            lecceclick: {
                bagniPubblici: 'Обществени тоалетни',
                colonnineAutoEnel: 'точки за зареждане на автомобили Enel',
                defibrillatori: '',
                esperienze: 'Преживявания',
                fontanelleAcquaPotabile: 'Питейна вода',
                giochi: 'Игри',
                gioco:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                infoProgettoEuropeo:
                    'Проект, финансиран от Европейския съюз по Р.О.Р. Пулия 2014-2020 г., Фонд ЕФРР, Дейност2.2',
                itinerari: 'Маршрут',
                parcheggiPubbliciPrivati: 'Частни и обществени зони за паркинг',
                runninCity: '',
                servizi: 'Услуги',
                wifiHotspot: 'Wifi hotspot',
            },
            media: {
                acquisisciImmagine: 'Направете снимка',
                fotocamera: 'Камера',
                gallery: 'Запазени изображения',
                importaGallery: 'Импортиране на запазено изображение',
                scattaFoto: 'Направете снимка',
                sceltaFotoGallery:
                    'Желаете ли да направите снимка или предпочитате да импортирате едно от запазените си изображения?',
            },
            mobilita: {
                acquistaDiNuovo: 'Нова покупка',
                acquistiRecenti: 'Скорошни покупки',
                biglietteria: 'Бюро за продажба на билети',
                cercaFermata: ' Търсене на автобусна спирка',
                cercaIndirizzo: 'Търсене по адрес',
                cercaLinea: 'Търсене на линия',
                cercaPerCodice: 'Търсене по код',
                cercaPerCodiceOrDescrizioneFermata: 'Търсене по код или описание',
                cercaPerCodiceOrDescrizioneLinea: 'Търсене по код или описание',
                cercaPerFermata: 'Търсене по код',
                cercaPerNumero: 'Търсене на номер',
                cercaPerStazione: 'Търсене на станция',
                cercaStazione: 'Търсене на станция',
                cercaTreno: 'Търсене на влак',
                cittaOrLocalita: 'Град или място',
                codiceDescrizioneFermata: 'Стоп код / ​​описание',
                codiceDescrizioneLinea: 'Код на линия / описание',
                codiceFermata: 'Или стоп за спиране',
                codiceLinea: 'Или код на линия',
                codiceOrDescrizioneFermata: 'Търсене по код или описание',
                codiceOrDescrizioneLinea: 'Код на линия или описание',
                deleteAllConfirmMsg:
                    'В случай, че потвърдите Всички изтекли "{0}" билети ще бъдат отменени от Вашето устройство.',
                deleteConfirmMsg: 'Ако потвърдите, билетът ще бъде отменен от Вашето устройство.',
                dettaglioFermata: 'Подробности за спирка',
                fermate: '',
                fermateIntorno: 'Спирки наоколо',
                fermatePreferite: 'Предпочитани спирки',
                header: 'Tранспорт',
                inserisciIDati: 'Въведете данните, необходими за продължаване',
                intornoA: 'Около',
                intornoAllIndirizzo: 'Близо до адреса',
                linea: 'Линия',
                linee: '',
                lineePreferite: 'Предпочитани линии',
                lineeServite: 'Обслужвани линии',
                mieiTitoli: 'Моите билети',
                navette: 'Автобуси',
                needToLogin: 'линия',
                nessunRisultato: 'Няма намерени резултати',
                nessunaSoluzione: 'Няма резултати',
                noTitoliAttiviScaduti: 'Няма билети за активиране или които вече са били използвани',
                numeroOrCodiceTreno: 'Номер или код на влак',
                numeroTreno: 'Номер на влак',
                ogniXminuti: 'Всеки {0} мин.',
                orariAlleFermateLinee: 'График на автобусните спирки и линии',
                parlaConNoi: 'Говорете с нас',
                popolari: 'Най-популярни компании',
                reti: 'Мрежи',
                scegliPercorso: 'Избер на маршрут',
                searchingTickets: 'Търся закупени билети',
                stazione: 'Станция',
                stazioni: 'Станции',
                stazioniIntorno: 'Заобикалящи станции',
                stazioniPreferite: 'Предпочитани станции',
                tabelloneOrari: 'Разписание на борда',
                titoliAttivi: 'Активни билети',
                trattaXdiY: 'Маршрут {0} от {1}',
                treni: 'Trenitalia',
                tuttiPassaggi: 'Всички пътници',
            },
            momup: {
                AcquistaBiglietti: 'Купи билети',
                CalcolaPercorso: 'Изчисляване на маршрут',
                Eventi: 'Събития',
                FermateOrari: 'Спирки и разписания',
                Luoghi: 'Места',
                MieiTitoli: 'Моите билети',
                abilitaNfc: '',
                letturaTessera: '',
                letturaTitoli: '',
                navette: '',
                nfc: {
                    arrival: '',
                    article: 'артикул',
                    contract: '',
                    dataOraFineValidita: '',
                    dataOraValidazione: '',
                    departure: '',
                    endDate: '',
                    fermata: 'Спирка',
                    linea: 'Линия',
                    residuals: 'Оставащи пътувания',
                    startDate: '',
                    vediValidazioni: '',
                },
                scansiona: 'Сканиране',
                scansioneFallita: '',
                scopriAltreApp: 'Открийте света на мама',
            },
            mp: {
                archeologia: '',
                arteStoria: '',
                bikeTrekking: '',
                cominciaViaggio: '',
                contattaci: '',
                culturaTradizione: '',
                eccellenze: '',
                esperienze: 'Преживявания',
                eventi: 'Събития',
                facebook: '',
                instagram: '',
                itinerari: 'Маршрут',
                luoghi: 'Места',
                mail: '',
                naturaScienza: '',
                ospitalita: '',
                prodotti: 'Продукти',
                scegliMuseo: '',
                sosta: 'Паркинг',
                trasporto: 'Tранспорт',
                youtube: '',
            },
            mycicero: {
                biglietteria: {
                    header: 'Бюро за продажба на билети',
                },
                changePosition: {
                    header: '',
                    inputPlaceholder: '',
                    noResults: '',
                },
                home: {
                    descrizioneSosta: '',
                    descrizioneViaggia: '',
                    highlightTitle: 'Акценти',
                    titoloSosta: 'Паркинг',
                    titoloViaggia: '',
                },
                viaggia: {
                    abbonamenti: 'Абонаменти',
                    abbonamentiExt: 'Абонаменти',
                    acquistoOd: '',
                    acquistoOdTessera: '',
                    acquistoSMS: '',
                    bigliettiSuPrenotazione: '',
                    header: '',
                    multiacquisto: '',
                    tariffaFissa: '',
                },
            },
            mytrasfer: {
                acquistaBiglietti: 'Купи билети',
                calcolaPercorso: 'Изчисляване на маршрут',
                fermateOrari: 'Спирки и разписания',
            },
            navette: {
                allResults: 'Всички резултати',
                anErrorOccurredRetry: 'Възникна грешка. <b> Опитайте отново </b>',
                busAndStops: 'Автобуси и спирки',
                cercaPlaceHolder: 'Търсене по име',
                cosaVedere: 'Какво да видя',
                detinazione: 'Дестинация',
                durata: 'Продължителност',
                emptyPoiList: 'Няма резултати',
                infoArrivoPrevistoNonDisponibili: 'Няма информация за преминаването',
                infoDirezioneNonDisponibili: 'Информация за посоката не е налична',
                infoNomeFermataNonDisponibile: 'Името на спирката не е налице',
                infoNonDisponibili: 'Няма допълнителна информация',
                informazioni: 'Информация',
                kmTotali: 'Общо km',
                navettaDaEPer: '',
                searchByNameOrLocation: 'Търсене по име или град',
                serviziTuristici: 'Туристически услуги',
                social: 'Социални мрежи',
                tab: {
                    agenda: 'Програма',
                    condizioni: 'Условия',
                    dettagli: 'Детайли',
                    info: 'Информация',
                    itinerario: 'Маршрут',
                    mappa: 'Карта',
                    orari: 'Разписание',
                    partenzeArrivi: 'Разписание',
                    tappe: 'Етапи',
                },
                tappe: 'Етапи',
                telefono: 'Телефон',
                'title-elenco': 'Автобуси',
                titleMenu: 'Автобуси',
                updatingData: 'Автобуси',
                web: 'Web',
            },
            notification: {
                connectionErrorHeader: 'Няма връзка с интернет',
                connectionErrorMessage:
                    'Грешка при свързване с отдалечен сървър: проверете връзката си за данни и опитайте отново.',
                errorGeneric: 'Възникна грешка, която не може да завърши тази операция.',
                noConnection: 'Няма връзка с Интернет.',
                offline: 'Извън линия',
                successGeneric: 'Актуализация в процес ...',
                successGenericHeader: 'Успешно',
                templateBorsellinoSosta: 'Кредит: & euro; {0}',
                templateContactUs: 'Свържете се с нас...',
                templateCreditoNonDisponibile: 'При изчисляването на кредита възникна грешка',
                templateRicalcoloCredito: 'Изчисляване на кредит...',
            },
            notify: {
                header: 'Внимание',
                questionAreaTariffabile: 'Смятате ли, че това е част от зоната за паркиране?',
                segnalaAnomalie: 'Подаване на сигнал за неизправности',
            },
            plusPayment: {
                cambiaMetodo: 'Друг метод',
                confermaInizioSosta: 'Потвърдете началото на парка',
                effettuaLogin: 'Вход',
                erroreAggiornamentoMetodiDiPagamento:
                    'Начините Ви на плащане не успяха да се актуализират. Моля, проверете връзката с интернет и опитайте отново.',
                erroreAggiornamentoSaldoBorsellino:
                    'Кредитът Ви не успя да се актуализира. Моля, проверете връзката с интернет и опитайте отново.',
                erroreAggiornamentoSaldoBorsellinoParent:
                    'Кредитът Ви {0} не успя да се актуализира. Моля, проверете връзката с интернет и опитайте отново.',
                ilTuoProfilo: 'Твоят профил',
                modalitaPagamentoNonSupportata: 'В момента избраният начин не може да се използва за плащането',
                nessunMetodoAlternativo: 'Няма алтернативен метод на плащане',
                paga: 'Плащане',
                pagaConBorsellinoParent: 'Py с {0}',
                pagaConCartaDiCredito: 'Регистрирана карта',
                profiloPagamento: 'Профил на плащане на </br>',
                ricaricaCreditoMyCicero: 'Заредете допълнително кредита си',
                usaCreditoMyCicero: 'Платете с кредита си',
                usaIlCredito: 'Заредете кредит myCicero. Евтино е!',
                usaIlCreditoBranded: 'Заредете допълнително кредита си',
            },
            poi: {
                apriMacrocategoria: 'Отворете макрокатегория',
                categoria: 'Категория',
                categorie: 'Категории',
                categorieSelezionate: 'Избрани категории',
                contatti: {
                    email: 'Email',
                    fax: 'Факс',
                    header: 'Контакти',
                    tel: 'Тел.',
                    url: 'Web',
                },
                deselezionaTutto: 'Нито един',
                dettaglio: 'Място',
                elenco: 'Списък',
                espositori: 'Изложители',
                eventi: 'Събития',
                eventiCorrelati: 'Свързани събития',
                header: 'Природни забележителности',
                info: 'Информация & Контакти',
                infoContatti: {
                    cellulare: 'Мобилен телефон',
                    email: 'Email',
                    facebook: 'Facebook',
                    gestione: 'Управление',
                    sitoWeb: 'Web',
                    social: 'Социални мрежи',
                    telefono: 'Телефон',
                    vaiAlSito: 'Отидете на уебсайта',
                },
                istruzioniNoCategorie: 'Избер на категория',
                itinerariCorrelati: 'Маршрути, които минават оттук',
                loadMore: 'Потърсете други забележителности',
                luoghiCorrelati: 'Свързани места',
                macrocategorie: 'Макро Категории',
                mappa: 'Карта',
                nessunPoiTrovato: 'Няма намерени резултати, които да съответстват на думите за търсене',
                ospiti: 'Важни гости',
                placeholderRicerca: 'Търсене...',
                posizioneNonCoperta: 'Вие не сте в обслужваната зона',
                promozioni: {
                    promoPerTe: 'специални оферти за Вас',
                    promoPerTutti: 'достъпни за всички потребители',
                },
                ricercaInfoTerritorio: 'В коя зона търсите?',
                ricercaTutteCategorie: 'Търсене във всички категории',
                scegliCategoria: 'Изберете',
                scegliPoi: 'Изберете POI',
                scegliTerritorio: 'Списък на областите, които обслужваме. Изберете този, който предпочитате',
                selezionaPoi: 'Изберете POI',
                selezionaTutto: 'Всички',
                serviziInclusi: 'Включени услуги',
                serviziUtili: 'Полезни услуги',
                specialitaCorrelate: 'Свързани продукти',
                staiCercandoAllCategories: 'Във всички категории',
                tab: {
                    allegati: 'Прикачен',
                    info: 'Информация',
                    mappa: 'Карта',
                },
                tutteLeCategorie: 'Всички категории',
                vetrina: 'Афиш',
                virtualTour: {
                    info: 'Виртуалната обиколка ще се отвори в прозореца на браузъра на устройството',
                    intro: 'Ако желаете да откриете най-добрите места в региона, направете виртуална разходка',
                    lancia: 'започнете виртуалната обиколка',
                },
            },
            primoAvvio: {
                tutorial: {
                    biglietti: {
                        testo: 'Купете билети и сезонни билети с едно натискане',
                        titolo: 'Няма повече код',
                    },
                    borsellino: {
                        testo: 'Използвайте го, за да платите всички предлагани услуги',
                        titolo: 'Заредете допълнително кредита си',
                    },
                    buoniMotivi: {
                        testo: 'Добри причини да обичаш myCicero',
                        titolo: 'Чудесно приложение!',
                    },
                    dolomiti: {
                        scopriLeBellezze: {
                            testo: 'Открийте с нас красотите на Доломитите',
                        },
                    },
                    masterpass: {
                        testo: 'С Masterpass на Mastercard е безопасно и Вие веднага получавате бонуса',
                        titolo: 'Регистрирайте картата си',
                    },
                    seguiIlViaggio: {
                        testo: 'Точност на влака, следващи престои и времена на пристигане',
                        titolo: 'Бъдете актуализирани, когато пътувате с влак',
                    },
                    soluzioniDiViaggio: {
                        testo: 'Интегрирани резултати с влак, автобус и метро',
                        titolo: 'Планирайте пътуването си',
                    },
                    sosta: {
                        testo: 'Плащайте само за реалните минути на паркиране',
                        titolo: 'Намалете разходите за паркиране',
                    },
                },
            },
            profilazione: {
                accedi: 'Вход',
                accediAccount: 'Вече сте регистриран',
                aci: {
                    registrazioneEseguiLogin:
                        'Моля, влезте за да използвате услугите, предоставени от ACI във Вашия myCicero акаунт.',
                    registrazioneUtenteEsistenteConTessera:
                        'Вашата ACI карта е успешно свързана с Вашия myCicero акаунт (съвпадение с Вашия ACI акаунт).',
                    registrazioneUtenteNuovoConTessera:
                        'Регистрацията е завършена. Ще намерите данните си за вход в имейла, изпратен на имейл адреса, който е свързан с профила ви в ACI. Вашата ACI карта е активирана.',
                    registrazioneUtenteNuovoSenzaTessera:
                        'Регистрацията е завършена. Ще намерите данните си за вход в имейла, изпратен на имейл адреса, който е свързан с профила ви в ACI.',
                },
                activateServices: 'Активирайте услугите бързо',
                alreadySubscribed: 'Имате ли вече профил?',
                associaFoto: 'Прикачване на снимка',
                azienda: 'Бизнес',
                benvenuto: 'Добре дошли',
                cambiaEmail: 'Променете имейл адреса',
                cap: 'Пощенски код',
                cartaRegistrata: 'Регистрирана карта',
                cell: 'Мобилен телефон',
                cellFormatInvalid: 'Мобилния номер не е валиден.',
                cellulare: 'Номер на мобилен телефон',
                checkAccetto: 'Приемам',
                checkComunicazioni: 'Получавайте съобщения и новини',
                checkCondizioniPrivacy: 'Съгласен съм с ',
                checkCondizioniUtilizzo: 'Прочетох',
                checkCondizioniUtilizzoAlternativelabel: '',
                chiudi: 'Затвори',
                citta: 'Град',
                cittaNascita: 'Община на раждане',
                cittaResidenza: 'Община на пребиваване',
                codTessera: 'Номер на карта',
                codiceCliente: 'Клиентски код',
                codiceFiscale: 'Фискален код',
                codiceUnivocoDestinatario: '',
                cognome: 'Фамилия',
                cohesion: {
                    erroreRegistrazione: 'Регистрацията чрез Cohesion се провали',
                    labelHtml: 'Регистрация от <b> Кохезия 2.0 </b>:',
                },
                condizioniAltriFini: 'Формуляр за одобрение за промо доставка',
                condizioniCommerciali: 'Търговска информация',
                condizioniContrattuali: 'договорни условия',
                condizioniDiUtilizzo: 'Условия за ползване',
                condizioniDiUtilizzoAlternativeLabel: '',
                condizioniFiniCommerciali: 'Формуляр за съгласие за доставка на информационни материали',
                condizioniIscritti: 'Доклад на членовете',
                condizioniPrivacy: 'Декларация за поверителност',
                condizioniUtilizzo: 'Условия за ползване',
                condizioniUtilizzoCredito: 'Условия за ползване',
                condizioniUtilizzoGenerali: 'Общи условия за ползване',
                condizioniUtilizzoPrivacy: 'Условия и Правила за поверителност',
                condizioniUtilizzoSosta: 'Условия за паркиране',
                condizioniUtilizzoTrasporto: 'Условия за използване на транспорта',
                confirmRollback: 'Всички въведени данни ще бъдат загубени. Продължаване?',
                confirmation: 'Код за потвърждение',
                contattaAssistenza: 'Свържете се с нашия отдел за Поддръжка',
                continuaSenzaRegistrazione: 'Продължете без регистрация',
                continuaSenzaRegistrazioneAvvertimento:
                    'Чрез продължаване без регистрация няма да е възможно да се правят покупки',
                controllaCodice: 'Проверете кода',
                controllaEmail: 'Проверете дали Вашият имейл акаунт е регистриран правилно',
                creaUtente: 'Създайте Ваш профил',
                creaUtenteDesc: 'Създайте Вашия потребителски профил много бързо...',
                dataNascita: 'Дата на раждане',
                descrizionePromo: 'Имате ли промоционален код? Въведете го тук и активирайте промоцията',
                ebbeneSi: 'Да, започнете отново',
                email: 'Имейл адрес',
                emailConfirmed: 'Вашият имейл адрес е потвърден успешно',
                emailReminder:
                    'Моля, потвърдете с кликване линка за активиране, който сме изпратили на Вашия e-mail адрес. Може да го направите и по-късно',
                emailSent: 'Имейлът, изпратен до',
                erroreRegistrazioneCarta: 'Регистрацията на кредитната карта не бе успешна',
                esclamaBenvenuto: 'Добре дошли!',
                fatturazioneElettronica: '',
                fine: 'Край',
                indirizzo: 'Адрес',
                indirizzoResidenza: 'Адрес на пребиваване',
                infoMoficaDati:
                    'За всяка промяна, преди да потвърдите, пишете на assistenza@mycicero.it o chiamar, обадете се на 071 920 7000',
                infoNecessaria: 'Задължителни полета',
                informativaFatturazione: '',
                informativaPrivacy: 'Уведомление за поверителност',
                inizia: 'Начало',
                insertPinCode: 'Поставете кодът за активация',
                intestatario: 'Данни за карта',
                inviaSms: 'Изпратете SMS',
                inviaSmsConferma: 'Да, моля, изпратете го!',
                inviaSmsInfo: 'Кодът за активиране ще бъде изпратен чрез SMS. Сигурни ли сте?',
                iscrizione: 'Вие сте регистриран с',
                iscrizioneNonCompletataPopupAnnullaEdElimina: 'Откажете и премахнете потребителя',
                iscrizioneNonCompletataPopupCompletaIscrizione: 'За повече информация:',
                iscrizioneNonCompletataPopupMsg: 'Отказ и премахване на потребителя',
                iscrizioneNonCompletataPopupTitle: 'Регистрацията не е завършена',
                iscrizioneServizi:
                    'В случай, че вече сте регистрирали акаунт в autobus.it, може да използвате същите идентификационни данни',
                localitaProvenienza: 'Излитане от',
                messaggioAssociaFoto:
                    'ПРЕДУПРЕЖДЕНИЕ: Тази снимка ще бъде поставена във Вашия сезонен билет и няма да е възможно да я промените',
                modelloVeicolo: 'Модел на автомобил',
                modelloVeicoloObbligatorio: 'Модел на автомобил',
                modelloVeicoloOpzionale: 'Модел на автомобил (по избор)',
                msgAssistenzaActv: 'app.support@avmspa.it',
                msgAssistenzaDefault: 'assistenza@mycicero.it и кол център 071 920 7001',
                nazione: 'Държава',
                nazioneNascita: 'Държава на раждане',
                nome: 'Име',
                nonHaiTessera: '',
                normativaPrivacy: 'Декларация за поверителност',
                numVolo: 'Номер на полет за връщане',
                numeroTelefonoConfermato: 'Мобилния номер е потвърден',
                numeroVerde: 'Безплатен номер',
                nuovoUtente: 'Нов потребител',
                partitaIva: 'Данъчен номер',
                password: 'Парола',
                passwordConfirm: 'Потвърждение на парола',
                passwordNotMatch: 'Паролите не съвпадат',
                pecEmail: '',
                perAssistenza: 'За нашето обслужване на клиенти изпратете имейл на следния адрес:',
                perAssistenzaActv: 'За нашето обслужване на клиенти изпратете имейл на следния адрес:',
                perAssistenzaSito: 'За свързване с отдел Поддръжка натиснете следното',
                perAssistenzaTelefono: 'Или се обадете на номер:',
                perAssistenzaUlteriore: 'За проблеми с приемането на билети:',
                perInfo: 'За информация:',
                perUlterioriInfo: 'За повече информация:',
                perUlterioriInfoInfoActv: 'За повече информация:',
                pinCode: 'Код за потвърждение',
                pinCodeDesc: 'Изпратихме Ви кода за активиране.',
                privato: 'Частно лице',
                procedi: 'Напред',
                profiloPreferito: 'Основен профил',
                profiloPreferitoMessage: 'Този профил ще се използва за фактуриране',
                promoCodePlaceholder: 'Вмъкнете промоционален код',
                promozioni: 'Промо',
                provincia: 'Провинция',
                ragioneSociale: 'Име на фирма',
                recapiti: '',
                registraNuovoUtente: 'Регистрирайте се като нов потребител',
                registratiOra: 'Регистрирайте се сега',
                registrationCompleted: 'Регистрацията е завършена',
                registrationFailed: 'Регистрацията се провали',
                registrazione1: 'Регистрация 1/2',
                registrazione2: 'Регистрация 2/2',
                reinviaSMS: 'Изпратете отново SMS',
                requiredFields: 'Моля, попълнете всички задължителни полета',
                resendBtn: 'Да',
                resendOk: 'Току-що Ви изпратихме отново кода за активация. Трябва да го получите скоро',
                resendText: 'Кодът за активиране ще бъде изпратен чрез SMS. Сигурни ли сте?',
                resended: 'Кодът е изпратен',
                rightNumber: 'Правилен ли е номерът?',
                rimuoviProfilo: 'Премахване на потребителския профил',
                salvaModifiche: 'Запазване на промените',
                sendSms: 'Изпращане на потвърдителен SMS и имейл...',
                sendingEmailDesc: 'Изпращаме имейл с линк за активация на този имейл адрес:',
                sendingSmsDesc: 'Изпращаме SMS с кода за потвърждение на този номер:',
                smsNotSent: 'SMS не е изпратен до',
                smsSent: 'SMS е изпратен до',
                splitPayment: '',
                startAgain: 'Променете номера си',
                targaObbligatoria: 'Регистрационен номер на автомобил',
                targaOpzionale: 'Рег. номер (по избор)',
                titoliAtac: 'ATAC билети',
                titoloPersonale:
                    'Поставете и / или проверете номера на Вашата сезонна карта за билети преди потвърждението',
                titoloPesonale: 'Транспортна карта',
                usaCodice: 'Използвайте кода',
                username: 'Потребител',
                vaiAllApp: 'Започнете да използвате приложението',
                vediPromo: 'Показване на активните промоции',
                verificaCodiceSms: 'Проверете кода за SMS',
                wrongNumber: 'Грешен номер?',
            },
            profiloUtente: {
                carte: 'Регистрирани кредитни карти',
                impostazioniNotifiche: {
                    description:
                        'Разширете и спрете паркирането с едно щракване директно от опцията  за уведомяване на Вашия смартфон',
                    header: 'Интеграция на мястото за уведомяване',
                    title: 'Настройки на известията',
                    toggleActive: 'Деактивиране',
                    toggleInactive: 'Активиране',
                },
                mostraCod: 'Визуализирайте потребителския код',
                nessunaCarta: 'Няма кредитна карта',
                nessunaTessera: 'Няма свързана карта',
                pref: 'Предпочитания',
                tessere: 'Карти и договори',
                title: 'Потребителски профил',
            },
            promozione: {
                atmaBullet1: '',
                atmaBullet2: '',
                atmaBullet3: '',
                bullet1: '',
                bullet2: '',
                bullet3: '',
                caricaNuovoBuono: '',
                caricaNuovoCredito: '',
                compraAtac: '',
                compraAtma: '',
                dataOraMovimento: 'Дата и час',
                descrizione: '',
                descrizioneMovimento: 'Описание',
                elencoPromozioniMobilita: {
                    nessunaPromozione: '',
                    title: '',
                },
                importoMovimento: 'Сума',
                invalidTxt: '',
                istruzioniPrincipaliHTML: '',
                istruzioniPrincipaliHTMLATMA: '',
                labelProfilo: '',
                labelProfiloAtma: '',
                labelSaldo: 'Баланс',
                movimenti: 'Транзакции',
                noMovimenti: '',
                scadenza: '',
                titoliBAtac: '',
                titoliBAtma: '',
                tuttiMovimenti: '',
                txtInstructions: '',
                ultimiMovimenti: '',
                usaCreditiMobilita: '',
                utilizzoEcobonus: '',
            },
            rockinroma: {
                atac: 'ATAC билети',
                festival: 'Фестивал',
                lineUp: 'Редица',
                location: 'Локация',
                mieiTitoli: 'Моите билети',
                tickets: 'Билети',
                travel: 'Пътувания',
                treniDelRock: 'Post-concert влакове',
            },
            rss: {
                dettaglioHeader: 'Детайли',
                filterPlaceholder: 'Търсене...',
                latestNews: 'Последни новини',
                news: 'Новини',
                newsFontiNotificheHeader: 'Списък с канали',
                newsNotificheHeader: 'Новини и известия',
                noResults: 'Няма резултати',
                scegliFeed: 'Избор на канал',
                updating: 'Проверка на новини...',
            },
            rundetails: {
                nodata: {
                    empty: 'Не са открити детайли',
                },
                realTime: {
                    arrivoPrevisto: 'Очаквано пристигане',
                    arrivoReale: 'Актуално',
                    arrivoStimato: 'Очаквано',
                    binarioPrevisto: 'Планирана железопътна линия',
                    binarioReale: 'Актуално',
                    inAnticipo: 'предварително',
                    inOrario: 'на време',
                    inRitardo: 'отложен',
                    minuti: 'минути',
                    minuto: 'минута',
                    partenzaPrevista: 'Планирано заминаване',
                    partenzaReale: 'Актуално',
                    ultimoRilevamento: 'Последно проучване:',
                },
            },
            sanzioni: {
                cercaVerbale: 'Търсене на запис',
                codiceFiscale: 'Фискален код',
                codiceInfrazione: 'Код за нарушение',
                cognome: 'Фамилия',
                cognomeSanzionato: 'Санкционирана фамилия',
                controllareDatiInseriti: 'Контролира въведените данни.',
                data: 'Дата',
                dataNascita: 'Дата на раждане',
                dataVerbale: 'Дата на справка',
                datiIncompleti: 'Непълни данни',
                datiSanzionato: 'Данни на наказаното лице',
                datiVerbale: 'Данни за справка',
                descrizione: 'Описание',
                dettaglioVerbale: 'Детайли за справка',
                erroreIdSistema: 'IdSistem не е посочен',
                idVerbale: 'Номер на справка',
                importoBiglietto: 'Сума на билета',
                infoDatiVerbale: 'Въведете необходимите данни за изследвана справка',
                noVettoriAbilitatiPagamentoSanzioni:
                    'Нито една транспортна компания не е разрешила плащането на неустойки.',
                nome: 'Име',
                nomeSanzionato: 'Име на санкционираното лице',
                numero: 'Номер',
                numeroVerbale: 'Номер на справка',
                pagamentoSanzioni: 'Плащане на санкции',
                sanzionato: 'Наказан',
                sanzione: 'Санкции',
                serialeVerbale: 'Сериен номер на справка',
                serie: 'Серии',
                speseAmministrative: 'Административни разходи',
                totale: 'Обща сума',
                verbale: 'Справка',
                verbaleNonPagabile: '<b> Вече платен отчет </b>',
                verbaleNonTrovato: '<b>Справката не е открита </b> <br> Проверете въведените данни.',
            },
            selectPositionOnMap: {
                areaNonServitaHtml:
                    'За повече информация, моля, обадете се на номера <a href="tel:+390719207000"> + 39 & nbsp; 9207000 </a> или <a href = "#" onclick = "javascript: openLinkOnBrowser (\'http: // www .mycicero.it / chat / \', true) "> свържете се с нас чрез чата </a>',
                areaNonServitaLabel: '',
                areaNonServitaTitle: 'Районът не се обслужва',
                disclaimerBtn: 'Разбрах',
                disclaimerMsg: '',
                ricercaLocalitaInCorso: 'В момента търсим за района ...',
                scegli: 'Избирам',
                warningAumentaZoom: '',
                warningZoomInsufficiente: 'Увеличете мащаба, за да намерите позицията си',
            },
            selezionaModalitaDiPagamento: {
                comeVuoiPagare: 'Как бихте желали да платите?',
                modalita: {
                    acipg: 'ACI Pay',
                    amonw: 'Платежни карти',
                    bbol:
                        'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                    bill: 'SisalBill',
                    brsel: 'myCicero Кредит',
                    cc:
                        'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                    ccric: 'Платежни карти',
                    'ccs-2-s':
                        'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                    mpass: 'Masterpass ™',
                    pbemo: 'BeMoov',
                    ppay: 'Postepay',
                    ppexp: 'PayPal',
                    ppric: 'PayPal',
                    sisal: 'SisalPay',
                    stpay: 'SatisPay®',
                },
            },
            serCom: {
                NessunServizioAzienda: 'Няма налични услуги за потребителя с бизнес профил',
                NessunServizioPrivato: 'Няма налична услуга за потребителя с личен профил',
                avvisiPagamento: {
                    header: 'Нотификации за плащане',
                    inScadenza: 'Изтичащ/Да се плати',
                },
                azienda: 'Бизнес',
                certificazioneInfoHTML:
                    'За да се показват известия за плащане, изпратени от публични органи, трябва да сте сертифициран потребител. За да удостоверите профила си, отидете в оторизираните общински офиси с валидна лична карта или въведете Вашите сертифицирани удостоверения за системата (Сближаване) в частната Ви онлайн зона от компютър или Mac',
                comune: 'Град',
                comuniRecenti: 'Последни градове',
                comuniSerCom: 'Градове, предоставящи общински услуги',
                contattaAssistenza: 'Моля, свържете се с нашия отдел Поддръжка',
                contatti: 'Контакти',
                costoServizio: 'Разходи за услугата',
                dataInfrazione: 'Дата на нарушение',
                elencoMovimenti: {
                    header: 'Отчет на транзакциите',
                    noResults: 'Транзакции, които не са намерени в посочения период',
                    ricercaMovimenti: 'Търсене',
                },
                mainHeader: 'Общински услуги',
                nessunImportoDovuto: 'Общо дължима сума = 0, не е необходимо плащане!',
                news: {
                    header: 'Новини & известия',
                },
                oraInfrazione: 'Време на нарушение',
                pagamentiSpontanei: {
                    compilaTutto: 'Предупреждение: попълнете всички задължителни полета',
                    header: 'Доброволни плащания',
                    pagSpontaneo: 'Доброволно плащане',
                },
                pagamento: {
                    dataEmissione: 'Дата на издаване',
                    dataFine: 'Крайна дата',
                    dataInizio: 'Начална дата',
                    dataSanzione: 'Дата на санкция',
                    dataScadenza: 'Дата на изтичане',
                    descr: 'Описание',
                    errorePagamento: 'По време на плащането възникна грешка',
                    header: 'Плащане',
                    importoDaPagare: 'Сума',
                    importoNonValido: 'Невалидна сума',
                    pagamentoGuidato: 'Помощник при плащане',
                    scegliData: 'Избер на дата',
                    soggetto: 'Предмет',
                    targa: 'Регистрационен номер',
                    verbale: 'Справка',
                },
                pagamentoEffettuato: 'Плащането е завършено',
                pagamentoNonAbilitato: 'Плащането не е активирано',
                privato: 'Частно лице',
                richiediCert: 'Заявка за сертифициране',
                richiediCertInfoHTML:
                    'Ще бъдете пренасочени към личния Ви профил (достъпен само от <strong> компютър </strong>.',
                segnalazioni: {
                    cat: 'Категория',
                    descr: 'Описание',
                    header: 'Справки',
                    img: 'Снимка',
                    indirizzo: 'Адрес на справка',
                    inserite: 'Подадени справки',
                    invia: 'Изпращане на справка',
                    noCategorie: 'Не са открити категории на текущото Ви местоположение',
                    nuova: {
                        abbandona: 'Отхвърлете текущата справка и излезте',
                        attendiCaricamentoImmagine: 'Зареждане на снимка...',
                        caricamentoImmagineFallito: 'Неуспешно зареждане на снимка',
                        fail: 'Невъзможно е да изпратите текущата справка!',
                        header: 'Нова справка',
                        inserisciQui: 'Добавете справката тук',
                        success: 'Справката бе изпратена успешно!',
                        torna: 'Назад към справката',
                    },
                    subCat: 'Подкатегория',
                    tue: 'Вашите справки',
                    welcome: 'Добре дошли!',
                    welcomeIntroTemplate:
                        '<p> На тази страница може да изпратите справка до {0}. </p> <p> Изберете една от {1} наличните категории: </p>',
                },
                serviziAbilitatiAzienda: 'Налични услуги за потребител с бизнес профил',
                serviziAbilitatiPrivato: 'Налични услуги за потребител с частен профил',
                tipoSoggetto: 'Вид на предмета',
                tornaAiServizi: 'Обратно към Услуги',
                totale: 'Обща сума',
                transazioneOK: 'Транзакцията приключи успешно',
                utenteNonCertificato: 'Потребителят не е сертифициран',
            },
            siae: {
                acquistaBiglietti: 'Купи билети',
                chooseSector: {
                    apriMappa: 'Отворяне на карта',
                    headerScegliDaLista: 'Автоматично определяне на седалката',
                    headerScegliDaMappa: 'Избор на седалка',
                    noSettori: 'Няма намерена област',
                    scegliBiglietti: 'Изберете билети',
                },
                mieiBiglietti: 'Моите билети',
                myTickets: {
                    mieiTitoli: 'Моите билети',
                    passati: 'Преминава през',
                    validi: 'Валиден',
                },
                posto: 'Място',
                seasonTicket: 'Сезонен билет',
                settore: 'Район',
                ticketDetails: {
                    carta: 'Карта',
                    cfOrganizzazione: 'CF Org.',
                    cfTitolo: 'CF Tit.',
                    data: 'Дата',
                    idSistema: 'Номер на системата',
                    progressiva: 'Progressiv',
                    sf: 'S.F.',
                    tipoEvento: 'Събитие',
                },
                ticketsSummary: {
                    commissioni: 'Такси за услуги',
                    pagaConCarta: 'Плащане с кредит',
                    prevendita: 'Предварителна продажба',
                    removeTicketConfirm: 'Наистина ли желаете да отмените този артикул?',
                    staiPerAcquistare: 'Вие купувате',
                },
            },
            smartArea: {
                cambiaCitta: 'Промяна на града...',
                confermaReset: 'Всички данни, съхранявани локално в Интелигентната зона, ще бъдат премахнати',
                defaultTitleHtml: 'Светът на интелигентните услуги',
                nonScegliNulla: 'Не, благодаря...',
                oppureAreaSmartHtml: 'Или изберете <i> интелигентен </i> град:',
                reset: 'Изчистване на местните Интелигентни данни',
                resetDone:
                    'Всички данни са изчистени. При следващо влизане в началната страница всички данни ще бъдат обновени',
                scegli: 'Избер на Интелигентен град',
                seiQui: 'Намирате се тук',
                selezionaAreaSmart: 'Избер на Интелигентна зона или град',
                servizioNonDisponibile: 'Услугата е недостъпна в момента. Моля, опитайте по-късно.',
            },
            solutions: {
                acquista: {
                    aPiedi: 'С ходене',
                    arrivo: 'Пристигане',
                    articolo: 'артикул',
                    dilloAlVettore: 'Да, бих желал да закупя този избор за пътуване',
                    dilloAlVettorePre: 'Този билет все още не може да бъде закупен. Желаете ли да си го отбележите?',
                    dilloAlVettoreStatement: 'Този билет все още не може да бъде закупен.',
                    durata: 'Продължителност',
                    fromStop: 'от спирка',
                    header: 'Купете резултатът за пътуване',
                    importo: 'Сума',
                    infoAddizionali: 'Допълнителна информация',
                    nonDisponibile: 'Не е налице',
                    partenza: 'тръгване',
                    toStop: 'до спирка',
                    tratta: 'маршрут',
                },
                dialog: {
                    partenzaArrivoUguali:
                        'Мястото на заминаване и пристигане съответстват. Няма налични резултати за пътуване',
                },
                fav: {
                    header: 'Запазване на резултат',
                    info: 'Запазване на този резултат за пътуване като отметка',
                },
                form: {
                    cercasoluzioni: 'Търсене на резултати за пътуване',
                    elimina: 'Изтриване',
                    itinerariPreferiti: 'Предпочитани маршрути',
                    nessunPreferito: 'Няма предпочитани',
                    preferiti: 'Любими',
                    recenti: 'Най-скорошен',
                    searchbutton: 'Търсене',
                },
                list: {
                    arrivi: 'Пристигания',
                    arrivo: 'Пристигане',
                    loadMore: 'Заредете допълнителни резултати',
                    ordinaPerDataArrivoAsc: 'По време на пристигане',
                    ordinaPerDataDiPartenzaAsc: 'По време на заминаване',
                    ordinaPerDataDiPartenzaDesc: 'Време на отпътуване',
                    ordinaPerDurataTragittoAsc: 'По продължителност',
                    ordinaPerDurataTragittoDesc: 'Продължителност на пътуването ↓',
                    ordinaPerNumCambiAsc: 'По брой промени',
                    ordinaPerPrezzoAsc: 'Най-ниска цена',
                    ordinaPerPrezzoDesc: 'Най-висока цена',
                    ordinaRisultati: 'Резултати за пътуване',
                    partenza: 'тръгване',
                    partenze: 'Заминаване',
                },
                nodata: {
                    empty: 'Не е намерен резултат за пътуване',
                },
                nome: 'Име на резултат',
                type: {
                    auto: 'Кола',
                    autobus: 'Само автобус',
                    busTreni: 'Автобуси и влакове',
                    pedonale: 'Пешеходец',
                    treno: 'Само влак',
                },
            },
            stopdetails: {
                nodata: {
                    empty: '',
                },
                settings: 'Настройки на спирки',
            },
            stops: {
                arrivi: 'Пристигане на спирката',
                fav: {
                    conferma: 'Спирката е записана като отметка',
                    header: 'Запазване на спирка',
                    info: 'Запазване на тази спирка като "Bookmark", за да я изтеглите бързо следващия път"',
                    nomePreferito: 'Предпочитано име',
                },
                partenze: 'Отпътуване от спирката',
            },
            summerjamboree: {
                alloggi: 'Къде да остана',
                festival: 'Фестивал',
                foodAndBeverages: 'Храни & Напитки',
                locations: 'Места',
                mappa: 'Карта',
                mercatino: "Rockin 'Village - пазар",
                navette: 'Специални влакове - совалки',
                programma: 'Събития',
            },
            sunsen: {
                cercaAlloggio: '',
                elencoTornei: '',
                home: {
                    classifica: '',
                    eventi: 'Събития',
                    informazioni: 'Информация',
                    iscrizioni: '',
                    partners: '',
                    sosta: 'Паркинг',
                    trasporto: 'Tранспорт',
                },
            },
            taxi: {
                common: {
                    aggiornatoAlle: 'Актуализирано на',
                    descrAnnullata: 'Резервацията е анулирана',
                    descrArrivato: 'Пристигна',
                    descrConfermata: 'Резервацията е потвърдена',
                    descrDaConfermare: 'Изчаква потвърждението',
                    descrInArrivo: 'Пристигане след {0} минути',
                    descrPagato: 'Платени (€ {0})',
                    ultimoAggiornamento: 'Последна актуализация',
                },
                dettaglio: {
                    annullaPrenotazione: 'Отменете резервацията',
                    dataAssegnazione: 'Дата на приемане',
                    pagaTaxi: 'Плащане на таксито',
                    promptHeader: 'Отказ',
                    promptKo: 'Не',
                    promptMessage: 'Сигурни ли сте, че искате да отмените тази резервация?',
                    promptOk: 'Да',
                    title: 'Подробности за резервацията',
                },
                home: {
                    aggiornamentoInCorso: 'Актуализира се ...',
                    miePrenotazioni: 'Моите резервации',
                    paga: 'Плащане',
                    prenota: 'Заявка',
                    title: 'Потърсете такси',
                },
                mappa: {
                    disclaimerBtn: 'Разбрах',
                    disclaimerMsg: 'Уверете се, че предоставяте точната си позиция',
                    procedi: 'Напред',
                    title: 'Потърсете такси',
                    warningZoomInsufficiente: 'Увеличете мащаба, за да намерите позицията си',
                },
                pagamento: {
                    importoViaggio: 'Разходи за пътуването',
                    numeroLicenza: 'Номер на лиценз',
                    pagamentoEffettuato: 'Пътуването е успешно платено',
                    promptNumeroLicenza: 'Попитайте таксиметровия шофьор за лицензния му номер',
                    scansiona: 'Сканиране',
                    scegliComePagare: 'Изберете как да плащате',
                    title: 'Плащане на таксито',
                    totale: 'Обща сума',
                },
                prenotazione: {
                    conferma: 'Запазване на местоположението',
                    promptHeader: 'Потърсете такси',
                    promptMessage: 'Очакваме потвърждение от операционния център',
                    promptNote:
                        'Ще получите имейл за потвърждение, след като Ви е назначено такси. В случай на заявка за предварително поръчка на такси, мейлът ще се изпрати няколко минути преди определеното време.',
                    title: 'Заявка за такси',
                },
            },
            tessere: {
                EliminaFail: 'Възникна грешка при опит за изтриване на картата',
                EliminaSuccess: 'Картата е изтрита',
                EliminaTesseraConf: 'Желаете ли да изтриете тази карта?',
                aggiungiTesseraTrasporto: 'Добавяне на карта...',
                apriControllo: '',
                attivaTessera: 'Активиране на картата',
                card: 'Карта',
                cerca: 'Търсене на карта',
                cercaAttiva: 'Търсене на карта и активация...',
                cercaPlaceHolder: 'Име на карта или договор',
                chiudiControllo: '',
                codice: 'Код на карта',
                dettagliTessera: 'Данни за картата и договор',
                haiTessera: 'Имате ли карта?',
                identificativoTessera: 'Идентификационен номер на картата',
                inAttesaValidazione: 'Изчаква потвърждение',
                inserisciCodice: 'Въведете код на картата',
                inserisciIdentificativoTessera: 'Поставете идентификационния си номер, за да си купите билета.',
                noResultTessere: 'Няма налична карта',
                noResultTessereTrasporto: 'Няма налична карта',
                nomeTesseraContratto: 'Име на карта или договор',
                nonAttiva: 'Картата все още не е активирана',
                rimuovi: 'Премахване на картата',
                scegliVettoreTessera: 'Изберете Вашата транспортна компания',
                siHoTesseraVettore: 'Да, имам карта',
                tessera: 'Карта',
                tesseraRegistrata: 'Картата е успешно регистрирана',
                toBeCertified: 'Тази карта изисква ръчно сертифициране от администратора',
                tutte: 'Всички карти',
                valida: 'Валидна карта',
                validita: 'Валидност',
                verifica: 'Проверка',
            },
            tir: {
                login: {
                    appName: 'TRANSPark',
                    appNonDisponibile: 'Понастоящем приложението не е достъпно за Windows телефон',
                    areeStazioni: 'Паркинг места и бензиностанции',
                    cerca: 'Търсене на транзакции',
                    cercaParcheggi: 'Търсене на зони за паркиране',
                    codice: 'Потребителски код',
                    scarica: 'Изтегляне',
                    targa: 'Регистрационен номер на автомобил',
                    testo1:
                        'Европейски пилотен проект (<a href="javascript:openLinkOnBrowser(\'http://www.cogistics.eu\')"> www.cogistics.eu </a>) в Триест за популяризиране на услугата за паркиране на камиони.',
                    testo2:
                        'Тук, в частта „Паркинги-транзакции”, шофьорите на камиони могат да проверят активираните паркирания на паркинга на товарния терминал в Триест или да намерят паркинги и бензиностанции чрез връзката с приложението на Транспарк на IRU.',
                    testo3: 'Само за шофьори на камиони, паркирани на товарния терминал на Триест',
                    title: 'Паркиране на камиони',
                    titoloApp: 'TransPark приложение',
                    titoloMovimenti: 'Показване на списък с транзакции',
                },
                movimenti: {
                    nessuno: 'Няма транзакции.',
                    title: 'Отчет на транзакциите',
                },
            },
            tours: {
                allCategories: 'Всички категории',
                arrivi: 'Пристигания',
                cercaPrenota: 'потърсете обиколка и я резервирайте',
                definisciRaggio: 'дефиниране на обхват на разстояние:',
                dettaglio: 'Детайли на обиколка',
                elenco: 'Списък',
                inPartenzaEntro: 'Тръгване на обиколка в рамките на',
                info: 'Информация',
                itinerario: 'Маршрут',
                mappa: 'Карта',
                nomeTour: 'Име на обиколка',
                partenze: 'Заминаване',
                raggioRicerca: 'Обхват на разстоянието',
                vetrina: 'Афиш',
                viaggioOrg: 'организирани екскурзии',
                warnTariffe: 'Цената, която виждате, се отнася до основната тарифа, проверете я в ценовата листа',
            },
            tplfvg: {
                AcquistaBiglietti: 'Купи билети',
                CalcolaPercorso: 'Изчисляване на маршрут',
                Eventi: 'Събития',
                FermateOrari: 'Спирки и разписания',
                Luoghi: 'Места',
                MieiTitoli: 'Моите билети',
                ServiziTuristici: 'Туристически услуги',
                accediRegistrati: '',
                loginMessage: '',
                newsEventi: '',
                rivendite: '',
            },
            trasportoGT: {
                accedi: {
                    header: 'Влезте в Линии на дълги разстояния',
                },
                elencoMovimenti: {
                    header: 'Отчет на транзакциите',
                },
                header: 'Автобуси на дълги разстояния',
                mieiAbbonamenti: {
                    goToMyAbbonamenti: 'Към "Моите абонаменти"',
                    header: 'Моите абонаменти',
                    infoTitoliAcquistati:
                        'Билетът ще намерите в секция "Моите абонаменти" на "Междурегионален транспорт"',
                },
                mieiBiglietti: {
                    aggiornaElenco: 'Актуализация на списъка...',
                    elencoBigliettiDaObliterare: 'Списък на закупените билети за валидиране',
                    elencoBigliettiScaduti: 'Списък на изтеклите билети',
                    elencoBigliettiUsati: 'Списък на използваните билети',
                    elencoBigliettiValidi: 'Списък на валидни билети',
                    goToMyTickets: 'Към „Моите билети“',
                    header: 'Моите билети',
                    infoTitoliAcquistati: 'Билетът ще намерите в секция "Моите билети" на "Междурегионален транспорт"',
                    nessunBigliettoTrovato: 'Няма намерен билет',
                    obliterati: 'Валидни билети',
                    ore: 'време',
                    partenza: 'тръгване',
                    scadenzaTime: 'Валиден до',
                    validoFinoAl: 'Валиден до',
                },
                soluzioniViaggio: {
                    andata: 'Отивате',
                    arrivoA: 'Пристигане',
                    avvisoDataDifferente:
                        'Няма налични резултати за пътуване за избраните дати. Следвайте  тук първите налични резултати.',
                    cercaFraLocalitaElencate: 'Филтриране по име',
                    cercaSoluzioni: 'Резултати за пътуване',
                    descrizioneViaggio: 'Описание на маршрут',
                    dettaglio: 'Подробности за резултата за пътуване',
                    dettaglioAndata: 'Външни детайли',
                    dettaglioRitorno: 'Детайли за връщане',
                    header: 'Резултати за пътуване',
                    infoCoperturaHTML:
                        '<b> Услугата </b> обхваща повече области. Проверете градовете, до които достига междурегионалната транспортна услуга...',
                    infoPasseggero: 'Информация за пътниците',
                    localitaDestinazione: 'Място на пристигане',
                    localitaPartenza: 'Място на заминаване',
                    maxUnCambio: 'макс. 1 прехвърляне',
                    mostraSoluzioni: 'Покажи резултати за пътуване',
                    mostraTutteLeDestinazioni:
                        'Показване на всички налични дестинации от избраното място за заминаване',
                    nessunCambio: 'Няма прехвърляния',
                    nomeObbligatorio: 'Изисква се име',
                    partenzaDa: 'Отпътуване от',
                    riassuntoInfoAcquisto: 'Повторете информацията за покупката',
                    ritorno: 'Връщане',
                    scegliDataRitorno: 'Изберете Вашата дата на връщане',
                    scegliRitorno: 'Изберете Вашето връщане',
                    scegliTariffa: 'Изберете курс',
                    selezionaDest: 'Изберете дестинация',
                    soluzioneSenzaPosti: 'Избраният резултат е продаден/напълно резервиран',
                    tariffa: 'Тарифа',
                    tratta: 'маршрут',
                    tutteLeSoluzioni: 'Всички резултати',
                    viaggioRitorno: 'Връщане на пътуване',
                    zoneCoperte: 'Зони, покрити от услугата',
                },
            },
            trasportoRegionale: {
                acquistaBiglietti: 'Купи билети',
                acquistaSMS: {
                    acquistaAltroBiglietto: 'Закупете друг билет',
                    confermaAcquistoTitolo: 'Билетът е закупен успешно',
                    elencoTitoliAcquistabili: 'Списък на билетите, които може да закупите',
                    erroreAcquisto: 'Възникна грешка. Искате ли да опитате отново с покупката?',
                    header: 'Купете с SMS',
                    infoObliterazioneAuto: 'този билет е автоматично потвърден',
                    infoObliterazioneBiglietti: 'Всеки билет трябва да бъде валидиран преди да се качите на автобуса',
                    invioManualeSmsInfo:
                        'Невъзможно е да се изпрати съобщението. Моля, изпратете SMS до номера {0} с текст {1}',
                    invioManualeSmsTitle: 'ръчно изпращане на SMS',
                    noArticoliVendibili: 'Не са намерени закупени артикули',
                    riassuntoInfoBiglietto: 'Събрана информация за билета',
                    richiestaInoltrataInfo:
                        'Уважаеми потребители, в случай че заявката Ви е била завършена успешно, ще получите скоро закупения билет на SMS',
                    richiestaInoltrataTitle: 'Заявката е препратена',
                },
                acquistaScaffale: {
                    elencoTitoliAcquistabili: 'Списък на билетите, които може да закупите',
                    elencoTitoliAcquistabiliActv: 'ACTV Билети, които може да закупите',
                    elencoTitoliAcquistabiliMomup: 'Списък на билетите, които може да закупите',
                    gotoTitoliGT: 'Купете билети с резервация',
                    gotoTitoliSMS: 'Купете с SMS',
                    header: 'Купи билети',
                    headerActv: 'Купи билети ACTV',
                    infoAcquistoSms:
                        "Този билет ще бъде закупен чрез <span class = 'bold'> телефонния кредит </span>, свързан с телефонния номер, който използвате. <br/> <br/> Билетите, закупени чрез SMS, не могат да имат по-ниски или различни цени до тези, валидни за пълни маршрути от последната спирка до последната спирка. Следователно, не се предвиждат възстановявания за по-кратки пътувания от разстояние. </br> </br> Няма билети за връщане </br> </br> След изпращане на заявката ще получите SMS за потвърждение, който ще се използва като билет",
                    infoCoperturaATAC:
                        'Билети могат да се използват на всички наземни транзити на Metrebus: автобуси Atac, трамваи и тролейбуси, транспортни средства TPL и COTRAL в Рим. <br /> В подземното метро е възможно да се ползва услугата по линии А, В, В1, железопътна линия Рома -Lido и на гара Flaminio на жп-гара Roma-Viterbo. <br /> <br /> Услугата ще бъде достъпна за целия маршрут Roma-Viterbo и на линия C. <br />',
                    infoCostiSms:
                        'В допълнение към цената на билета, Вие ще бъдете таксуван и с цената на SMS, която варира в зависимост от Вашата телефонна компания.',
                    infoObliterazioneAuto: 'този билет е автоматично потвърден',
                    infoObliterazioneBiglietti: 'Всеки билет трябва да бъде валидиран преди да се качите на автобуса',
                    infoObliterazioneContestuale: 'Активирането е едновременно с покупката.',
                    infoTrenitaliaATAC:
                        'Както миналата ATAC Спа директива, електронните билети (Bit 100 и AIMOP) за момента не са валидни за Trenitalia. За повече информация, моля свържете се с нас на имейл assistenza@mycicero.it или на телефон 0719207000.',
                    noArticoliVendibili: 'Не са намерени закупени артикули',
                    origineDestinazione: 'Купете билет от предлаганите туристически резултати',
                    polimetrica: 'Извънградски сезонни билети',
                    polimetrica2: 'Извънградски сезонни билети',
                    riassuntoInfoBiglietto: 'Събрана информация за билета',
                    rinnovaAbbonamenti: 'Подновяване на сезонен билет',
                    scegliTitoliTessera: 'Билети за притежатели на карти на Venezia Unica',
                    scegliTitoliTesseraActv: 'Билети за притежатели на карти на Venezia Unica',
                    smsDiAcquisto: 'Номер на Pone: {0} <br/> Съобщение: {1}',
                    titoliGT: 'Билети с резервация',
                    titoliTessera: 'Билети със сезонни карти или отстъпки',
                    titoloSelezioneTessera: 'Купете билети на карта',
                },
                acquistoTitoli: {
                    acquistaGratis: 'Свали безплатно',
                    scegliComePagare: 'Изберете как да плащате',
                    scegliComePagareFmt: 'Изберете как да плащате {0}',
                    scegliTipologia: 'Изберете тип',
                    tipiDiAttivazione: {
                        automatica: 'Билетът става активен след покупката.',
                        multipla:
                            'Билетът се активира ръчно при първата му използване. Трябва също така да потвърдите своя билет всеки път, когато се качите на транспортно средство.',
                        normale: 'Билетът се активира ръчно при първото използване.',
                        obbligatoria: 'Билетът се активира ръчно при първото използване.',
                    },
                    tipoDiAttivazione: 'Тип на активиране:',
                },
                alCompleto: 'Продадено',
                anticipo: 'Ранно пристигане',
                arrivi: 'Пристигания',
                avvisoSD:
                    'Уважаеми потребители, поради проблеми, свързани с възможното изчезване на E-Tickets (в случай, че приложението е инсталирано на SD картата), като се започне от следващите версии, приложението ще бъде автоматично инсталирано на вътрешната памет на телефона Ви; за да избегнете допълнителни проблеми, любезно Ви молим да преместите приложението от sd картата към вътрешната телефонна памет. Съжаляваме за неудобството.',
                avvisoSDAVM:
                    'Уважаеми потребители, поради проблеми, свързани с евентуалното изчезване на E-Tickets (в случай, че приложението е инсталирано на SD картата), като се започне от следващите версии, приложението ще бъде автоматично инсталирано на вътрешната памет на телефона Ви, за да се избегне по-нататъшни проблеми, любезно Ви молим да преместите приложението от sd картата към вътрешната памет на телефона.\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\n\r\r\r\r\r\r\r\r\r\nЗа повече информация, моля пишете на app.support@avmspa.it ',
                cercaFermate: {
                    cercoPassaggi: 'Време за спиране на търсенето...',
                    codDescriz: 'Код / Описание',
                    comune: 'Изберете град',
                    elencoFermate: 'Списък на спирки',
                    elencoFermateTuaPosizione: 'Спирки близо до позицията Ви',
                    header: 'График на автобусна спирка',
                    headerActv: '0',
                    indirizzo: 'Адрес',
                    indirizzoFermata: '0',
                    inserisciIndirizzo: 'Въведете адрес',
                    intornoA: 'Показване на спирки в близост до:',
                    lineeServite: 'Обслужвани линии',
                    mostra: 'Показване на спирки',
                    mostraFermate: 'Показване на автобусни спирки...',
                    msgNoFermatePreferite:
                        '<p> Все още не сте отбелязали някоя спирка като предпочитана. </p> <p> За да запазите това търсене, натиснете бутон „Запазване“ в детайлите на всяка спирка. </p> "',
                    nessunaFermata: 'Не е открита спирка',
                    nessunaLocalita: 'Няма намерена локация/адрес',
                    noFermateVicine: 'Няма спирки близо до текущата Ви позиция',
                    noLineeServite: 'Не се обслужват линии',
                    noPassaggi: 'Няма пътувания',
                    oppure: 'Или...',
                    passaggiNonPrevisti: 'За тази дата не се очакват пристигания и заминавания',
                    ricerca: 'Търсене на спирки',
                    ricercheRecenti: 'Последни търсения',
                    stazioneIndirizzo: 'Станция или адрес',
                    tramiteCodDescr: 'По код или описание',
                    tuttiPassaggi: 'Всички пътувания до тази автобусна спирка',
                },
                cercaLinee: {
                    comune: 'Изберете град',
                    header: 'Търсене на линии',
                    indirizzo: 'Адрес...',
                    intornoA: 'Наблизо минават линии',
                    mostra: 'Показване на линии',
                    nessunaLineaTrovata: 'Няма намерени линии',
                    oppure: 'Или...',
                    ricerchePreferite: 'Любими',
                    ricercheRecenti: 'Най-скорошен',
                    tramiteCodDescr: 'По код или описание',
                },
                cercaLocalita: '0',
                cercaVettore: '0',
                comuneAziendaEvento: '0',
                daConvalidare: '0',
                daObliterare: 'Необходимо е валидиране',
                daValidare: 'Да се ​​активира',
                dettaglioCorsa: 'Подробности за маршрута',
                dettaglioLinea: {
                    dettaglioLinea: 'Детайл на линията',
                    dimentica: 'Забрави',
                    disponibilitaFermate: 'Спирка:',
                    nessunaCoincidenza: 'Няма налична връзка',
                    nessunaFermata: 'Не е открита спирка',
                    ricorda: 'Запомни',
                },
                elencoFermate: 'Спирки',
                elencoFermateA: 'Списък на спирки на:',
                elencoLinee: {
                    descrizione: 'Описание',
                    direzione: 'Посока',
                    elencoLinee: 'Списък на линиите в близкия',
                    elencoPercorsi: 'Маршрут на линията',
                    haiCercato: 'Търсили сте:',
                    noPercorsi: 'Няма маршрути',
                    noSoluzioniVisibili: 'Няма линия',
                    nonDisponibile: 'Не е налице',
                    passaggio: 'Очаква се преминаване',
                    passaggioAlle: 'Пътува в',
                    passaggioOgni: 'Пътува всеки',
                },
                elencoMovimenti: {
                    header: 'Отчет на транзакциите',
                },
                fermata: 'Спирка',
                fermate: 'Спирки',
                header: 'Регионален транспорт',
                linee: 'Списък с линии',
                mieiAbbonamenti: {
                    abbonamentiNonTrovati: 'Не е намерен валиден абонамент на това устройство.',
                    acquistaRinnova: 'Покупка/Подновяване',
                    articoliDisponibili: 'Налични статии',
                    elencoAbbonamenti: 'Списък на абонаменти',
                    elencoTessereAttive: 'Валидни карти',
                    extraUrbano: 'Извънградско',
                    goToMyAbbonamenti: 'Към „Абонаменти“',
                    header: 'Абонаменти',
                    infoAbbonamentiNonTrovati:
                        'Не е намерен валиден абонамент на това устройство. Опитайте се да обновите списъка, като натиснете върху бутона по-горе',
                    infoRequisitiAcquistoHTML:
                        'За да закупите абонамент, е необходимо да свържете карта с избрания оператор. Може да добавите абонаментна карта към профила си с няколко кликвания, като въведете частния си профил в <a href=#" style="text-decoration: none;"> www.mycicero.it </a> с  компютър . "',
                    infoTitoliAcquistati: 'Билетът ще намерите в раздел "Абонаменти" на "Регионален транспорт" "',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'След като завършите процеса на закупуване е възможно да изтеглите билета, като въведете страницата "Абонаменти" и актуализирате списъка',
                    nessunaTesseraValida:
                        'Нямате абонамент, свързан с Вашата карта. Не е налице подновяване. Свържете се с избрания оператор, за да закупите нов абонамент',
                    rinnovaAbbonamento: 'Подновяване на абонамент',
                    scegliTessera: 'Изберете карта за абонамент',
                    scegliVettoreAbbonamento: 'Изберете оператора, от който желаете да закупите/подновите абонамент',
                    selezionaArticolo: 'Изберете статия',
                    soluzioniPossibili: 'Намерени са резултати',
                    templateTratta: 'От {0} до {1}',
                    ultimaObliterazione: 'Последна валидация',
                    urbano: 'Градски',
                    validitaLinee: 'Валиден за линии',
                },
                mieiBiglietti: {
                    acquista: 'Покупка на билет',
                    attivi: 'Активен',
                    daobliterare: 'Да се ​​активира',
                    elencoBigliettiDaObliterare: 'Списък на закупените билети за валидиране',
                    elencoBigliettiUsati: 'Списък на използваните билети',
                    elencoBigliettiValidi: 'Списък на валидни билети',
                    finoAl: 'до',
                    goToMyTickets: 'Към „Моите билети“',
                    header: 'Моите билети',
                    infoTitoliAcquistati: 'Билетът ще намерите в секция "Моите билети"',
                    noTitoliAttivi: 'Не са намерени валидни билети',
                    noTitoliDaObliterare: 'Не са намерени билети за валидиране',
                    noTitoliScaduti: 'Не са намерени валидирани билети',
                    obliterati: 'Валидни билети',
                    scadenzaTime: 'Валиден до',
                    scaduti: 'Изтекъл',
                    validita: 'Валидност',
                    validoDal: 'Активен от',
                    validoFinoAl: 'Валиден до',
                },
                mostraAltreFermate: 'Показване на други спирки',
                mostraAltreLinee: 'Показване на други линии',
                mostraAltreStazioni: 'Показване на други станции',
                mostraAltriPassaggi: 'Показване на други спирки',
                obliterazioneAutomatica: 'Автоматично валидиране',
                partenze: 'Заминаване',
                passaggi: 'Пасажи',
                percorsi: 'Маршрути',
                prossimoTra: 'Следваща:',
                pulisci: 'Изчисти',
                ricaricaCredito: {
                    header: 'Заредете допълнително кредита си',
                    ricaricaActvWarning: '0',
                },
                ritardo: 'Закъснение',
                scaduti: 'Изтекъл',
                scegliVettore: 'Търсене по град, фирма или събитие:',
                scegliVettorePlaceholder: '0',
                seiVicino: 'Вие сте около този район',
                servizioNonAttivo: 'Все още не сте активирали "Обществен транспорт". Само една минута.',
                soluzioniViaggio: {
                    cercaCollegamentiLocali: 'Търсене на локални връзки',
                    cercaSoluzioni: 'Търсене на резултати за пътуване',
                    elencoSoluzioni: 'Списък с резултати за пътуване',
                    frequenzaOgni: 'Всеки',
                    header: 'Резултати за пътуване',
                    headerAndata: 'Външни резултати',
                    headerRitorno: 'Резултати за връщане',
                    invertiDirezione: 'Смяна на посоката',
                    mostra: 'Показване:',
                    mostraSuMappa: 'Покажи на картата',
                    nessunCollegamentoLocale: 'Няма локална връзка',
                    nessunaDestinazione: 'Няма намерена дестинация за тези критерии за търсене',
                    nessunaSoluzione: 'Не е намерен резултат за пътуване',
                    noSoluzioniVisibili: 'Няма показан резултат',
                    nonAcquistabile: 'Резултатът за пътуване не може да се закупи',
                    nonTuttiBigliettiAcquistabili: 'Не всички билети може да се закупят',
                    ordinaPerOrarioArrivo: 'Сортиране по време на пристигане',
                    ordinaPerOrarioPartenza: 'Сортиране по време на заминаване',
                    ordinaPerSoluzioniAcquistabili: 'Сортиране по резултати за продажби',
                    ordinaPerTempoTotale: 'Сортиране по време за пътуване',
                    salvaRicercaPreferitaInfo:
                        'За да добавите отметка за това търсене, натиснете бутон „Запазване“ на страницата с резултатите от търсенето на резултати за пътуване.',
                    scambia: 'Обратно',
                    tempoTotale: 'Общо време',
                    tuttiBigliettiAcquistabili: 'Всички билети може да се закупят',
                },
                tipoServizio: 'Вид услуга',
                trenitalia: {
                    altreInfo:
                        'За повече информация, моля пишете на Assistenza@mycicero.it или на телефон 071 920 7000',
                    cartaFreccia: 'CartaFRECCIA',
                    condizioni:
                        'Електронният регионален билет вече се издава като валидиран. Не е възможно да се премести за заминаване или да се замени билета и да се възстанови. Билетът е личен и е свързан с името и фамилията, въведени в онлайн регистрацията или в данните за пътниците. Онлайн билетът, закупен за пътувания с регионални влакове, трябва да бъде показан (по искане на контрольорите) на хартиен носител  (да отпечатате PDF прикачения към пощенската кутия) или на екрана, използвайки информационна технология (компютър, таблет, смартфон) с правилно визуализиране на .pdf файла, заедно с валиден документ за самоличност.',
                    condizioniAcquistoTrenitalia:
                        'Съгласен съм с <a href = "#" onclick = "javascript: openLinkOnBrowser (" http://www.trenitalia.com/tcom/Informazioni/Condizioni-Generali-di-trasporto/Condizioni-Generali-di-trasporto ", true) "> Условията за транспорт </a> на превозвача и прочетох <a href =" # "onclick =" javascript: openLinkOnBrowser ("http://www.trenitalia.com/cms-file/html/ trenitalia / Informativa_sulla_privacy.html \', true) "> Декларация за поверителност </a>.',
                    infoTariffa: 'Тарифна информация',
                    menu: 'Trenitalia',
                    modificaBigliettoHeader: 'Модификация на билети',
                    modificaBigliettoMessage:
                        "<div class = 'textAlignLeft'> <p> За да: <br /> <ul> <li> промените резервацията си (дата / час на заминаване) </li> <li> променете билета си (град на пристигане или заминаване); тип на билета; брой пътници и т.н.) </li> <li> Поискайте отмяна на билета, в случай че пътуването е отменено </li> </ul> </p> <p class = 'bold'> Отидете до най-близкия влак и  покажете този билет. </p> </div>",
                    percorsoFerroviario: 'Маршрут',
                    popupDiniego: {
                        cancelLabel: '',
                        confirmLabel: '',
                        content: '',
                        title: '',
                    },
                    riepilogo: 'Кратък преглед',
                    stazioneArrivo: 'Станция за пристигане',
                    stazioneNonValida: 'Невалидна станция',
                    stazionePartenza: 'Заминаваща станция',
                    tariffe: 'Такси',
                    viaggioAndata: 'Външно пътуване',
                    viaggioRitorno: 'Връщане на пътуване',
                    vuoiModificareIlBiglietto: 'Желаете ли да промените билета си?',
                },
                tutteLeLocalita: 'Всички градове',
                vaiAlleImpostazioni: 'Отидете в Настройки',
                validazioneAutomatica: 'Билетът автоматично е валидиран',
                zoneServite: {
                    header: 'Зони, покрити от услугата',
                },
            },
            travels: {
                details: {
                    header: 'детайли',
                },
            },
            treasureHunt: {
                abbandonaSquadra: '',
                aggiornaProcedi: '',
                aggiungiGiocatore: 'Добавяне на играч',
                cacciaAlTesoro: 'Лов на съкровища',
                checkVideoCaricato: '',
                codiceSquadra: '',
                comeFunziona: 'Как работи?',
                compilaCampi: '',
                compitoCompletato: '',
                completaPagamenti: 'Завършете плащанията',
                countDownInizioGiocoAfter: 'Играта започна от {0}',
                countDownInizioGiocoBefore: 'В началото на играта са нужни {0}',
                countDownInizioGiocoSame: 'Тук сме…',
                createTeam: '',
                erroreAggiungiGiocatore: '',
                erroreCaricamentoGiochi: 'При зареждане на игрите възникна грешка. Моля, опитайте по-късно.',
                erroreCaricamentoGioco: 'При зареждане на играта възникна грешка. Моля, опитайте по-късно.',
                erroreCheckLocation: '',
                erroreInfoTeam: '',
                erroreRimozioneGiocatoreQuotaPagata: '',
                erroreRimozioneGiocatoreQuotaSquadraPagata: '',
                faseRisoltaDalTeam: '',
                garaFinita: '',
                giocaNoSmartphone: '',
                giocatori: 'играчи',
                gpsGenericError: '',
                gpsPermissionDenied: '',
                gpsPositionUnavailable: '',
                gpsTimeout: '',
                graziePerLaRisposta: '',
                indizio: '',
                infoIscrizione:
                    'Записването на всеки играч е валидно само след плащане. На отбора ще бъде разрешено да играе само след като всички суми са платени.',
                invitaGiocatore: '',
                invitaGiocatoreNoEmail: '',
                iscrizioneSquadra: 'Регистриране на екип',
                iscrizioniChiuse: '',
                itinerariSorpresa: 'Екскурзии с изненада',
                itinerarioSorpresa: 'Екскурзия с изненада',
                joinTeam: '',
                luogo: '',
                luogoGiusto: '',
                luogoSbagliato: '',
                nessunGioco: '',
                nomeSquadra: '',
                nomeSquadraErrore: '',
                pagaQuotaGiocatore: '',
                pagaQuotaSquadra: '',
                pagamentiNonCompletati: 'Все още не сте извършили плащания',
                prossimoIndizioConPenalita: '',
                quizzone: 'Викторини',
                quotaGiocatoreNonPagata: '',
                quotaSquadraNonPagata: '',
                raggiungiLuogo: '',
                rimuoviGiocatore: '',
                rispostaEsatta: '',
                rispostaSbgliata: '',
                scegliNomeSquadra: 'Изберете хубаво и лесно име, което да запомните.',
                shareEvent: '',
                svelamiLuogo: '',
                svelamiLuogoConPenalita: '',
                tornaAlGioco: '',
                tornaAllInizio: '',
                traguardo: '',
                verificaLuogo: '',
                whoo: '',
            },
            tua: {
                AcquistaBiglietti:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                AcquistaBigliettiHTML: '',
                CalcolaPercorsoHTML: 'Планиране на <br/> маршрут',
                FermateOrariHTML: 'Спирки <br/> и разписания',
                MieiTitoli:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                MieiTitoliHTML: 'Моите <br/> билети',
                SostaInAbruzzoHTML: '',
                UltimeNotizieHTML: 'Последни <br/> новини',
                bigliettiTariffaFissa: '',
                soluzioneNonAcquistabile: '',
            },
            turismo: {
                buoniDisponibili: '',
                buoniEsauriti: '',
                buoniUtilizzati: '',
                caricaAltri: 'Показване на следващите 10',
                caricamentoInCorso: 'Качване',
                cerca: 'Търсене',
                cercaCoupon: 'Търсене на ваучер',
                cercaCouponPlaceholder: 'Търсене на ваучер',
                cercaEventi: 'Търсене на събития',
                cercaEventiPlaceholder: 'Търсене на събитие',
                cercaIndirizzoPlaceholder: 'Адрес или местоположение',
                cercaItinerariPlaceholder: 'Търсене на един маршрут',
                cercaItinerario: 'Търсене на маршрути',
                cercaPoi: 'Търсене на POI',
                cercaPoiPlaceholder: 'Търсене на място',
                cercaProdotti: 'Търсене на продукти',
                cercaProdottiPlaceholder: 'Търсете на продукт',
                cercaServiziPlaceholder: 'Търсене на услуга',
                cercaServizio: 'Търсене на услуги',
                concluso: '',
                condizioni: 'Условия',
                costoDelBuono: '',
                costoInCrediti: '',
                couponCorrelati: 'Специални оферти',
                couponGratuito: '',
                creditiConvertiti: '',
                creditiPerCouponsPresso: '',
                creditiPerCouponsTerminatiPresso: '',
                creditiResiduiTotali: '',
                creditiRimanenti: '',
                creditiTotali: '',
                creditoPerCouponsPresso: '',
                dataAlle: '{0} в {1}',
                dataCreazione: '',
                dataDalleAlle: '{0} от {1} до {2}',
                dataInizioDalleDataFineAlle: 'От {0} в {1} до {2} в {3}',
                dataInizioDataFine: 'От {0} до {1}',
                dataOra: 'Дата и час',
                detail: {
                    cellulare: 'Мобилен телефон',
                    certificazioni: 'Сертификати',
                    citta: 'Град',
                    contatto: 'Контакт',
                    costs: 'Вход',
                    couponCorrelati: 'Специални оферти',
                    email: 'E-mail',
                    eventiCorrelati: 'Свързани събития',
                    facebook: 'Facebook',
                    fax: 'Факс',
                    gestione: 'Управление',
                    giorno: 'Ден {0}',
                    header: 'Контакти',
                    indirizzo: 'Адрес',
                    itinerariCorrelati: 'Свързани маршрути',
                    luoghiCorrelati: 'Свързани места',
                    navetteCorrelate: 'Трансфер до Вас',
                    note: 'Бележки',
                    ospiti: 'Важни гости',
                    promo: 'Промо',
                    propostoDa: 'Предложено от',
                    quando: 'Кога',
                    scaricaAllegati: 'Изтеглете приложените документи',
                    serviziInclusi: 'Включени услуги',
                    serviziUtili: 'Полезни услуги',
                    sitoWeb: 'Web',
                    sitoWebOrganizzatore: 'Организиране на уеб сайт',
                    social: 'Социални мрежи',
                    specialitaCorrelate: 'Свързани продукти',
                    tappa: '',
                    tel: 'Тел.',
                    telefono: 'Телефон',
                    temi: 'Теми',
                    troviAnche: 'Свързани промоции',
                    url: 'Web',
                    vaiAlSito: 'Отидете на уебсайта',
                    zoneProduzione: 'Производствени зони',
                },
                details: 'Детайли',
                dettagli: 'Детайли',
                diarioDiViaggio: 'Дневник',
                downloads: 'Изтегляния',
                error: {
                    cantFilterAroundYou:
                        'Невъзможно е да се зададе филтър "Около Вас", ако GPS позицията не е налична.',
                    cantOrderByDistance:
                        'Невъзможно е да се настрои системата "На разстояние", ако GPS позицията не е налична.',
                },
                erroreGenerazioneQrCode: '',
                esperienze: 'Преживявания',
                estendiRaggioRicerca: 'Разширете обхвата на търсене',
                eventi: 'Събития',
                favorites: {
                    errorAddFavorites:
                        'Възникна грешка при запазването на предпочитани. Моля, уверете се, че сте свързани към интернет и опитайте отново.',
                    errorDeleteFavorites:
                        'Възникна грешка по време на анулирането на предпочитани. Моля, уверете се, че сте свързани към интернет и опитайте отново.',
                    errorGetFavorites: 'Възникна грешка при зареждането на предпочитани.',
                    errorUpdateFavorites:
                        'Възникна грешка по време на промяната на предпочитани. Моля, уверете се, че сте свързани към интернет и опитайте отново.',
                },
                filters: {
                    afternoon: 'След обяд',
                    allDay: 'Цял ден',
                    aroundYou: 'Близо до вас',
                    cosa: 'Какво',
                    dataSpecifica: 'Изберете конкретна дата',
                    everywhere: 'Където и',
                    fasciaOraria: 'Времеви слот',
                    morning: 'Сутрин',
                    night: 'Вечер',
                    oggi: 'Днес',
                    perData: 'По дата',
                    perDistanza: 'По разстояние',
                    perRilevanza: 'По важност',
                    perScadenza: 'По срок на годност',
                    perSconto: 'По отстъпка',
                    periodoSpecifico: 'Изберете конкретен период',
                    prossimi30Giorni: 'През следващите 30 дни',
                    prossimi7Giorni: 'В следващите 7 дни',
                    quando: 'Кога',
                },
                filtra: 'Филтър',
                filtraEventi: '',
                filtraItinerari: '',
                filtraLuoghi: '',
                filtraOrdina: 'Филтрирайте и организирайте',
                filtraProdotti: 'Филтър на продукти',
                filtraPromo: '',
                filtraServizi: '',
                inserisciNota: 'Напишете бележка...',
                itinerari: 'Маршрут',
                leggiCondizioni: 'Прочетете условията',
                luoghi: 'Места',
                mostraQrCodeAllaCassa: '',
                neiParaggi: 'Близо до',
                nessunPreferitoSalvato: 'Този раздел е празен в момента.',
                noAvailableCoupons: '',
                noCreditsReport: '',
                noResults: 'Няма намерени резултати',
                noUsedCoupons: '',
                note: 'Бележки',
                numCrediti: '',
                numOfRemainingCoupons: '',
                offerteSpeciali: 'Специални оферти',
                oneRemainingCoupon: '',
                ora: 'Време',
                ordina: '',
                ordinaEventi: '',
                ordinaItinerari: '',
                ordinaLuoghi: '',
                ordinaPromo: '',
                ordinaServizi: '',
                ottieniBuoni: '',
                pisteCiclabili: '',
                preferiti: 'Любими',
                preferitiDiarioViaggio: 'Любими и Дневник за пътуване',
                presso: 'В: {0}',
                prodotti: 'Продукти',
                prodottiTipici: 'Продукти',
                promo: 'Промо',
                quantiBuoniVuoi: '',
                ricercaIncorso: 'Търсене',
                rimuoviDataOra: 'Изтриване на дата и час',
                rimuoviOrario: 'Премахване на разписание',
                risultatiEntro: 'Вие търсихте по {0}',
                saldoRimanente: '',
                scansionaQrCode: '',
                scansionaQrCodeAllaCassa: '',
                scaricaAllegati:
                    'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                scegliData: 'Избер на дата',
                sconto: 'Продажба',
                servizi: 'Услуги',
                serviziUtili: 'Полезни услуги',
                shopping: 'Пазаруване',
                toccaPerIngrandire: '',
                trasformaCreditoInBuoni: '',
                trasformaTotCreditoInBuoni: '',
                tuoiCreditiBuoni: '',
                unCredito: '',
                utilizzaTuoiCrediti: '',
                utilizzatoIl: '',
                validoFinoA: 'Валиден до',
                valoreBuono: '',
                valoreBuonoPressoSponsor: '',
                valoreCumulativoBuono: '',
                valoreInEuro: '',
                withinRange: 'До {0}',
            },
            unicoc: {
                acquistaTicket: '',
                calcolaPercorso: '',
                mieiTitoli: '',
                puntiVendita: '',
                trovaTariffa: '',
            },
            ventis: {
                cambiaZona: 'Промяна на областта',
                effettuaLogin: 'Вход',
                homeTitle: 'Ventis Ви приветства с {0}',
                hometitleNoPos: 'Ventis Ви приветства',
                infoCredito:
                    'Допълнете myCicero кредита с кредитна карта, чрез Satispay, MasterPass или в магазин на SisalPay. <b> Тази опция за плащане няма допълнителни разходи. </b> myCicero Credit може да се използва и за закупуване на билети и за заплащане на всички други налични услуги.',
                loginMessage: '',
                registrati: 'Регистрация',
                requisitiAccesso:
                    'За да използвате това приложение е необходимо да имате достъп до <b> Ventis </b> регистриран потребител.',
                serviziTuttaItalia: 'Нашите услуги са активни в цяла Италия',
                tutorial: {
                    subtitle1: 'Открийте ползите за клиентите на Ventis',
                    subtitle2: 'Плащайте само реални минути за паркиране от Ventis Mobility',
                    subtitle3: 'Удобно с едно кликване върху приложението Ventis Mobility',
                    subtitle4: '',
                    subtitle5: 'Удобства и ползи, направени специално за Вас',
                    subtitle6:
                        'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                    title1: 'Добре дошли във Ventis Mobility',
                    title2: 'Намалете разходите за паркиране',
                    title3: 'Купете билети за влак, автобус и метро',
                    title4: 'Ventis',
                    title5: 'Всичко в едно приложение',
                    title6:
                        'Заредете кредита си, започнете да паркирате и плащате само за реалните минути за паркиране. <br /> <br /> To park in the cities of {0} you must exhibit the myCicero stub which you will receive by email.',
                },
            },
            visitRomagna: {
                dormi: 'Сън',
                erroreCaricamentoDati: 'Възникна грешка при зареждането на данни.',
                fermati: 'Спирка',
                mostraTuttiEventi: 'Покажете всички събития',
                muoviti: 'Напред',
            },
        },
    },
    fr: {
        translation: {
            account: {
                accedi: 'Accédez',
                accountNonAttivo: 'Compte pas confirmé',
                benvenuto: 'Bienvenue !',
                cambiaPassword: 'Changer le mot de passe',
                cambioEmailInserisciPinPage: {
                    annullaModifiche: 'Annuler les modifications',
                    errorePin: 'Erreur : le code PIN saisi n’est pas correct',
                    inserisciPin: 'Code PIN',
                    istruzioniInserisciPIN: 'Saisissez le code PIN contenu dans l’e-mail envoyé à',
                    operazioneAvvenutaInfo: 'Opération effectuée avec succès',
                    operazioneAvvenutaTitle: 'E-mail modifié avec succès',
                },
                cambioEmailPage: {
                    cambiaEmail: 'Changer l’e-mail',
                    emailAttuale: 'E-mail actuel',
                    eseguiCambioEmail: 'Continuer',
                    inserisciNuovaEmail: 'Choisissez un nouvel e-mail',
                    istruzioniPIN:
                        'Vous recevrez un e-mail de vérification avec un code PIN que vous devrez saisir sur la page-écran suivante.',
                    validazioneEmailInCorso: 'Vérification en cours',
                },
                cambioPasswordPage: {
                    erroreCambioPassword:
                        'Une erreur s’est produite pendant le changement du mot de passe. Veuillez contacter l’assistance.',
                    info:
                        'Le mot de passe doit être composé d’<span class="{0}">un minimum de 8</span> à <span class="{1}">un maximum de 26</span> caractères dont <span class="{2}">au moins un numéro</span>. <span class="{3}">Les caractères spéciaux ne sont pas autorisés</span>.<br/><span class="{4}">Le nouveau mot de passe et celui actuel doivent être différents</span>.',
                    infoPassword:
                        'Le mot de passe doit avoir une longueur minimale de 8 caractères et doit inclure au moins un numéro.',
                    inserisciNuovaPassword: 'Choisissez un nouveau mot de passe',
                    inserisciPassword: 'Mot de passe actuel',
                    inserisciVecchiaPassword:
                        'Vous souhaitez changer le mot de passe ? Pour des raisons de sécurité, vous devez saisir le mot de passe actuel :',
                    mostraPassword: 'Montrer le mot de passe',
                    passwordDiverse: 'Les deux mots de passe doivent correspondre',
                    passwordUguali: 'Le nouveau mot de passe et l’ancien mot de passe doivent être différents',
                    procedi: 'Continuer',
                    ripetiNuovaPassword: 'Répétez le nouveau mot de passe',
                    success:
                        'Votre mot de passe a été modifié correctement. Effectuez de nouveau l’identification avec votre nom d’utilisateur et votre nouveau mot de passe.',
                },
                completaRegistrazione: 'Terminer l’enregistrement',
                completaRegistrazioneMsg: 'Pour continuer avec ce compte, vous devez terminer l’enregistrement.',
                confermaLogout:
                    'En continuant, l’utilisateur actuel sera déconnecté. Vous pourrez accéder de nouveau en saisissant le nom d’utilisateur et le mot de passe.',
                connessioneAssente: 'Identification utilisateur échouée : connexion Internet absente',
                dataIscrizione: 'Enregistré le',
                datiErrati: 'Identification utilisateur échouée : utilisateur et/ou mot de passe erronés',
                datiNonCorretti: 'Nom d’utilisateur ou mot de passe erronés',
                effettuaLogout: 'Effectuez la déconnexion',
                eliminazioneDati: {
                    eliminazioneLabel:
                        'En cliquant sur « Continuer », votre compte sera déconnecté et vos données seront éliminées conformément au Règlement UE 2016/679 (RGPD) N.B. : après cette opération, vous ne pourrez utiliser l’application qu’en mode consultation.',
                    eliminazioneTitle: 'ATTENTION : opération irréversible.',
                    errorTitle: 'Une erreur s’est produite',
                    successoTitle: 'Opération effectuée avec succès',
                    successolabel: 'Vos données seront supprimées dans un délai d’un jour ouvrable',
                },
                emailInesistente: 'L’adresse que vous avez fournie n’est associée à aucun compte actif',
                emailNonValida: 'E-mail pas valide',
                emailVuota: 'Saisissez votre adresse e-mail',
                login: 'Identification',
                loginPage: {
                    accedi: 'Accédez avec votre compte :',
                    effettuaAccesso: "Effectuez l'accès",
                    iscrivitiAmyCicero: 'Enregistrez-vous !',
                    mostraPassword: 'montrer le mot de passe',
                    nessunAccount: 'Vous ne possédez pas de compte ?',
                    seHaiGiaUnAccount:
                        'Si vous avez déjà un compte avec <span class="highlighted">autobus.it</span> vous pouvez utiliser les mêmes données d’identification',
                },
                logout: 'Déconnexion',
                logoutEffettuato: 'Déconnexion effectuée avec succès',
                logoutUtente: 'Déconnexion utilisateur',
                passwordDimenticata: 'Mot de passe oublié',
                passwordDimenticataPage: {
                    email: 'Adresse e-mail',
                    erroreResetPassword:
                        'Une erreur s’est produite pendant la réinitialisation du mot de passe. Veuillez contacter l’assistance.',
                    impossibileResettarePassword:
                        'Impossible de réinitialiser le mot de passe. Veuillez contacter l’assistance.',
                    info:
                        'Saisissez l’adresse e-mail choisie pendant la phase d’enregistrement. Vous recevrez un mot de passe d’accès temporaire.',
                    sendPasswordTemporanea: 'Envoi mot de passe',
                    success:
                        '<p>Vous avez reçu un mot de passe temporaire à l\'adresse : </p><p class="textAlignCenter"><b>{0}</b></p><p>Vous n\'avez pas reçu les instructions ?<ul><li class="fontSizeTiny">Contrôlez le dossier du courrier indésirable</li><li class="fontSizeTiny">Contrôlez l\'adresse e-mail saisie</li><li class="fontSizeTiny">Réessayez dans quelques minutes</li><li class="fontSizeTiny">Vous pourriez ne pas avoir utilisé l\'adresse saisie pour votre enregistrement au service</li></ul></p>',
                },
                passwordNonValida: 'Mot de passe pas valable',
                profilo: {
                    accedi: 'Accédez à votre profil',
                    accediAccount: 'Identification',
                    gestioneTarghe: 'Gestion des plaques d’immatriculation stationnement',
                    gestisciCarteCredito: 'Gérer les cartes de crédit',
                    header: 'Profil utilisateur',
                    impostazioniNotifica: 'Configurations notifications',
                    preferenzeSosta: 'Préférences de stationnement',
                    uploadImmagineProfiloFail:
                        'Impossible de modifier l’image du profil. Veuillez réessayer plus tard.',
                    uploadImmagineProfiloRetry:
                        "Un problème s’est produit pendant l'envoi de l’image au serveur. Vous voulez réessayer ?",
                    uploadImmagineProfiloWait:
                        'L’image a été sauvegardée et est en phase d’élaboration, par conséquent elle pourrait ne pas être visible immédiatement.',
                    v2: {
                        apps: {
                            header: 'Applications associées',
                        },
                        associaTessera: 'Associer une nouvelle carte',
                        cambiaFotoProfilo: 'Changer la photo de profil',
                        chattaConAssistenza: 'Chattez avec nous',
                        condividi: 'Partagez...',
                        datiFatturazione: {
                            aggiungiProfiloFatturazione: 'Ajoutez profil de facturation',
                            attivaFatturazione: 'Je suis intéressé par la facture...',
                            confermaEliminazioneProfilo:
                                'Êtes-vous certain de vouloir éliminer le profil de facturation ?',
                            confermaModificaProfilo: 'Êtes-vous certain de vouloir modifier le profil de facturation ?',
                            confermaRitornoAlProfilo: 'Vous souhaitez retourner quand-même à la page de profil ?',
                            genericError: 'Remplissez correctement les champs obligatoire mis en évidence en rouge',
                            header: 'Données de facturation',
                            infoFatturazione:
                                'Attention : la facture/le reçu ne sera envoyé mensuellement par e-mail que pour les services et les gestionnaires qui le prévoient.</br>Pour tous, la confirmation de paiement effectué sera quoi qu’il en soit toujours envoyée',
                            label: 'Données de facturation',
                            modificaProfiloFatturazione: 'Modifier profil de facturation',
                            modificheSalvate: 'Les modifications effectuées ont été sauvegardées avec succès',
                            profiloSalvato: 'Les données du profil de facturation ont été sauvegardées avec succès',
                            rimuoviProfilo: 'Éliminer profil...',
                        },
                        datiPersonali: {
                            cambia: 'Changer',
                            haiTesseraAssociata: 'Vous avez une carte associée',
                            header: 'Données personnelles',
                            label: 'Données personnelles',
                            nonPuoiModificareDati:
                                "Les données personnelles ont déjà été certifiées, il n'est donc pas possible d'effectuer de modifications. Pour tout besoin, envoyez-nous un e-mail à ",
                            perCancellareUtente: 'Pour le faire, il est nécessaire de nous envoyer une demande à',
                            vuoiCancellareUtente: 'Vous souhaitez éliminer votre profil ?',
                        },
                        elencoMovimenti: 'Liste des mouvements',
                        eliminaDatiPersonali: 'Éliminer les données personnelles',
                        eliminazioneDatiPersonali: 'Élimination des données personnelles/élimination du compte',
                        eliminazioneDatiPersonaliModalContent:
                            "Souhaitez-vous vraiment supprimer vos données ? <br> Rappelez-vous : L'opération est <b>irréversible</b>",
                        esci: 'Sortir',
                        gestioneAffiliazioni: 'Gestion adhésions',
                        gestioneCarte: 'Gestion cartes',
                        gestioneCreditiMobilita: 'Gestion crédits de mobilité',
                        ilTuoCredito: 'Votre crédit',
                        linguaApplicazione: 'Langue application',
                        notifichePush: 'Notifications push',
                        preferenzeConsultazione: {
                            deselezionaTutto: 'Désélectionner tout',
                            erroreCaricamento:
                                'Une erreur s’est produite pendant le chargement des préférences. Veuillez réessayer plus tard.',
                            erroreSalvataggio:
                                'Une erreur s’est produite pendant la sauvegarde des préférences. Veuillez réessayer plus tard.',
                            header: 'Préférences de consultation',
                            infoGestione: 'Gérez et modifiez vos préférences de consultation des contenus',
                            label: 'Préférences de consultation',
                            nessunServizioInPreferenze:
                                "Vous n'avez mémorisé aucun service parmi vos préférences. Vous pouvez gérer vos préférences dans la section 'Préférences de consultation' accessible directement depuis votre profil. Si vous souhaitez visualiser tous les services, cliquez de nouveau sur 'Appliquer préférences' pour éliminer le filtre sur la visibilité des contenus.",
                            salvaModifiche: 'Sauvegarder les modifications',
                            selezionaTutto: 'Sélectionner tout',
                        },
                        preferenzePush: {
                            header: 'Notifications push',
                        },
                        ricaricaCredito: 'Recharger le crédit',
                        sosta: {
                            comePagare: 'Comment payer',
                            gestioneTarghe: 'Gestion des plaques d’immatriculation',
                            gestisciZsr: 'Gérer le code abonné',
                            header: 'Stationnement et ZTL',
                            preferenze: 'Préférences',
                        },
                        tesseraAssociataConSuccesso: 'Carte {0} associée avec succès !',
                        tiPiaceMyCicero: 'myCicero vous plaît-il ?',
                        trasporto: {
                            header: 'Transport',
                            notificheScadenzaTitolo: 'Notifications expiration titres',
                            scadenzaTitoli: {
                                description:
                                    "Activez les notifications pour l'avertissement concernant l'expiration imminente des titres de voyage",
                                header: 'Notifications expiration titres',
                            },
                            tessere: 'Cartes',
                        },
                        vaiAlleTessere: 'Aller aux cartes',
                    },
                },
                registrati: 'Enregistrez-vous',
                settings: {
                    allFavConfermaDelete:
                        'En continuant, toutes les solutions et les arrêts favoris mémorisés seront éliminés du dispositif. Cette activité ne peut pas être annulée.',
                    allFavRimossi: 'Les arrêts et les solutions favoris ont été éliminés',
                    cardAssociate: 'Cartes associées à cet utilisateur',
                    fermateFavConfermaDelete:
                        'En continuant, tous les arrêts favoris mémorisés seront éliminés du dispositif. Cette activité ne peut pas être annulée.',
                    fermateFavRimosse: 'Les arrêts favoris ont été éliminés',
                    gestisciPosizione: 'Gérer position',
                    pulisciDati: 'Nettoyer les données sur le dispositif',
                    raggioRicerca: 'Rayon de recherche autour de la position',
                    rimuoviFermateFav: 'Éliminer les arrêts favoris',
                    rimuoviSoluzioniFav: 'Éliminer les solutions favorites',
                    soluzioniFavConfermaDelete:
                        'En continuant, toutes les solutions favorites mémorisées seront éliminées du dispositif. Cette activité ne peut pas être annulée.',
                    soluzioniFavRimosse: 'Les solutions favorites ont été éliminées',
                    utenteAssociatoCard: 'Cet utilisateur est associé à la carte',
                },
                utente: 'Utilisateur',
                zsr: {
                    associaZSRDescriptionHTML:
                        "<span>Connectez votre profil utilisateur (auquel la plaque d’immatriculation de la voiture est associée) à l'abonnement pour le stationnement sur les places de parking à lignes bleues</span>",
                    associaZSRHeading: 'Associer code abonné',
                    associazioneFail: 'Code pas reconnu',
                    associazioneSuccess: 'Code associé',
                    codiceIdZSR: 'Code abonné',
                    comeOttengo: 'Comment puis-je l’obtenir ?',
                    dataDiNascita: 'Date de naissance',
                    failureHeading: 'Code pas reconnu',
                    idZSR: 'idZSR : ',
                    riprovaAssociazione: 'Réessayer l’association',
                    successHeading: 'Code associé',
                },
            },
            affiliazioni: {
                common: {
                    budgetMensile: 'Budget mensuel : <span class="bold secondary">{0}</span>',
                    confermaFineSostaChild:
                        'Paiement effectué avec crédit de <span class="bold secondary">{0}</span> :',
                    descrizioneTarga: 'Nom court',
                    numeroTarga: "Numéro de plaque d'immatriculation",
                    rimuoviAffiliazione: 'Éliminer l’adhésion',
                    serviziAbilitati: 'Services activés',
                    sosta: 'Stationnement',
                    sostaTargheLimitate: 'Stationnement seulement avec plaques d’immatriculation',
                    spesaMensile: 'Frais mensuels : <span class="bold secondary">{0}</span>',
                    targaGiaInserita: '{0} est déjà présent dans la liste des plaques d’immatriculation autorisées',
                    trasporto: 'Transport',
                },
                creaModificaAffiliazione: {
                    aggiorna: 'Mettre à jour',
                    alias: 'Alias',
                    aliasEsempio: 'par ex. Mario Rossi',
                    emailInfoPlaceholder: 'par ex. mario.rossi@gmail.com, luca.verdi@gmail.com',
                    erroreValidazioneEmail: "Le format de l’adresse e-mail '{0}' n'est pas correct",
                    erroreValidazioneImportoSpesaMassimaMensile: 'Choisissez la limite de frais mensuels',
                    headerSezione: {
                        durataLimite: 'Durée et limite mensuelle',
                        sosta: 'Stationnement et ztl',
                        trasporto: 'Transport',
                    },
                    infoEmail:
                        'Saisissez les e-mails des utilisateurs qui peuvent effectuer des achats avec votre crédit, séparés par une virgule.',
                    inviaRichiesta: 'Envoi demande',
                    limitaDurata: 'Limite durée',
                    limitaSpesa: 'Limite frais mensuels (€)',
                    messaggioRichiestaAffiliazione: 'La demande d’adhésion a été envoyée',
                    messaggioRimozioneAffiliazione: 'L’adhésion a été éliminée',
                    messaggioUpdateAffiliazione: 'L’adhésion a été mise à jour',
                    modificaAffiliazione: 'Modifier adhésion',
                    nuovaAffiliazione: 'Nouvelle adhésion',
                    permettiPagamento: 'Permettre paiement',
                    qualsiasiTarga: 'N’importe quelle plaque d’immatriculation',
                    spesaAttuale: 'Frais mensuels actuels : ',
                    targheAbilitate: '{0} plaques d’immatriculation configurées',
                    targheSpecifiche: 'Avec des plaques d’immatriculation spécifiques',
                },
                dettaglioAffiliazione: {
                    limiteSpesaMensile: 'Limite frais mensuels',
                    seiAbilitato: 'Vous êtes autorisé à utiliser le crédit de',
                    spesaAttuale: 'Frais actuels',
                },
                elencoMovimenti: {
                    delegatoA: 'Paiement délégué à',
                    pagatoPer: 'Paiement effectué par',
                },
                gestioneAffiliazioni: {
                    cercaNomeEmail: 'Chercher nom ou e-mail',
                    creaNuova: 'Chercher nouvelle',
                    funzionalita: 'Fonction',
                    gestioneTargheRicorrenti: 'Gestion plaques d’immatriculation partagées',
                    infoAffiliazioneChild:
                        'Ceci est le lieu où vous pourrez vérifier la liste des<br/>utilisateurs qui vous ont autorisé à utiliser <br/>leur porte-monnaie électronique pour effectuer vos achats et vos paiements.',
                    infoAffiliazioneParent:
                        'Vous pouvez permettre aux autres utilisateurs d’utiliser votre crédit <br/> pour effectuer leurs achats. Vous pouvez choisir si en limiter l’utilisation à une période de temps déterminée ou à des plaques d’immatriculation spécifiques.',
                    richiesteInAttesa: 'Demandes en attente',
                    tabs: {
                        childView: 'Payer avec',
                        parentView: 'Permettre paiements à',
                    },
                    title: 'Gestion adhésions',
                },
                gestioneTargheAutorizzate: {
                    aggiungiRiccorrenti: 'Ajouter aux plaques d’immatriculation partagées',
                    elencoAutorizzate: 'Liste des plaques d’immatriculation autorisées',
                    gestisciRiccorrenti: 'Gérer les plaques d’immatriculation partagées',
                    importaRicorrenti: 'Importer des plaques partagées',
                    infoTargheRicorrenti:
                        'Vous pourrez attribuer cette plaque d’immatriculation à d’autres autorisations sans devoir la saisir chaque fois.',
                    inserisciTargaConRicorrenti: 'Ou insérez une nouvelle plaque d’immatriculation',
                    inserisciTargaSenzaRicorrenti: 'Insérer une nouvelle plaque d’immatriculation',
                    targaInRicorrenti:
                        "{0} est présente dans la liste des plaques d’immatriculation partagées. Vous pouvez importer une ou plusieurs plaques partagées à partir de la section appropriée 'Importer des plaques partagées'",
                    targheAutorizzate: 'Autorisées par {0}',
                    title: 'Gestion plaques d’immatriculation autorisées',
                },
                gestioneTargheRicorrenti: {
                    aggiungiTarga: 'Ajoutez une plaque d’immatriculation partagée',
                    elencoRicorrenti: 'Liste des plaques d’immatriculation partagées',
                    title: 'Plaques d’immatriculation partagées',
                },
                importaTargheRicorrenti: {
                    descInfoTargheRicorrenti:
                        "En choisissant d’attribuer « Toutes les plaques d’immatriculation », vous permettrez l’utilisation de celles déjà enregistrées et aussi de celles que vous ajouterez à l'avenir. Sinon, vous pouvez ne sélectionner que celles que vous souhaitez rendre disponibles.",
                    title: 'Importer des plaques partagées',
                    titleInfoTargheRicorrenti: 'Choisissez les plaques d’immatriculation à associer à l’utilisateur',
                    tutte: 'Toutes les plaques d’immatriculation',
                },
                richiestaAffiliazione: {
                    durataModalita: 'Durée et mode',
                    info: 'Voudrait vous permettre d’utiliser son crédit pour effectuer vos paiements',
                    messaggioAffiliazioneAccettata: 'L’adhésion a été acceptée',
                    messaggioAffiliazioneRifiutata: 'L’adhésion a été refusée',
                    spesaMassimaMensile: 'Frais mensuels maximaux',
                    title: "Demande d'adhésion",
                },
            },
            amt: {
                homepage: {
                    benvenutiCatania: '<span>Bienvenue à </span><span class="bold">Catane</span>',
                    biglietteriaTitle: 'Revendeurs et billetteries',
                    carSharingTitle: 'Covoiturage',
                    parcheggiTitle: 'Parkings',
                    trasportoAcquisti: 'Achats',
                    trasportoAcquisto: 'Achat',
                    trasportoSubtitle: 'Infos et tickets',
                    trasportoTitle: 'Transport',
                },
            },
            amtab: {
                homepage: {
                    autobus: 'autobus',
                    sosta: 'stationnement',
                },
            },
            app: {
                appBloccata: 'Application bloquée',
                cambioDispositivo: 'Changement Dispositif',
                description: 'Bienvenue sur $t(app.name) !',
                dontAskAnymore: 'Ne plus le demander',
                exitMessage: 'Êtes-vous sûr de vouloir sortir de l’application ?',
                exitTitle: 'Confirmer sortie',
                fineSupportoIOS6Messaggio:
                    "Cher utilisateur, la version de votre système d'exploitation est inférieure à la 7. Cette version du système d'exploitation ne nous permet pas de suivre les derniers développements technologiques. La prochaine version de myCicero ne sera donc plus compatible avec votre système d'exploitation. Pour continuer à utiliser nos services, mettez iOS à jour à la version 7 ou suivante.",
                grazieMyCiceroTemplate:
                    "Merci d'avoir utilisé nos services. Si vous les avez trouvé utiles, pourquoi ne pas nous laisser un commentaire sur {0} ?",
                iOSNotCompatible:
                    'Pour acheter les titres ATAC, il faut mettre votre dispositif à jour à la version 8 ou supérieure. Pour de plus amples informations, veuillez contacter le 071 920 7000 ou envoyer un e-mail à assistenza@mycicero.it',
                msgCambioDispositivo:
                    '{0} a déjà acheté des titres avec un autre téléphone. Si vous confirmez, les titres déjà achetés ne seront plus disponibles dans le téléphone précédent. Pour de plus amples informations, veuillez contacter le 071 920 7000 ou assistenza@mycicero.it',
                msgTelefonoImpegnatoAltroAccount:
                    'Ce téléphone a déjà été utilisé pour acheter des titres par un autre utilisateur. Pour de plus amples informations, veuillez contacter le 071 920 7000 ou assistenza@mycicero.it',
                name: 'Wepps',
                no: 'Non',
                pubblicaRecensione: 'Publier avis',
                recensisciMyCicero: 'Donnez votre avis sur l’application',
                ricordaDopo: 'Me le rappeler plus tard',
                supportoIOS6: 'Mise à jour du système',
                updateAppMessage: 'Veuillez mettre l’application à jour à la dernière version disponible',
                waitdetail: 'Demande en cours',
                waitmessage: 'Veuillez attendre',
                wpNonCompatibile:
                    'Pour acheter les titres ATAC, un smartphone iOS ou Android est nécessaire. Pour de plus amples informations, veuillez contacter le 071 920 7000 ou envoyer un e-mail à assistenza@mycicero.it',
                yes: 'Oui',
            },
            arriva: {
                homepage: {
                    navette: 'Services spéciaux',
                },
            },
            aspo: {
                fatturazioneDisclaimer:
                    "Attention : le reçu sera envoyé mensuellement par e-mail uniquement pour les services de stationnement. Pour tous, la confirmation de paiement effectué sera quoi qu'il en soit envoyée par e-mail.",
                qrCodeFermata: 'Code QR arrêt',
                qrCodeFermataSubtitle: 'infos arrêt',
                rivendite: 'Revendeurs et billetteries',
            },
            atc: {
                homepage: {
                    benvenutiLaSpezia: '<span class="bold">Bienvenue à </span><span class="bold">La Spezia</span>',
                },
                trasporto: {
                    acquistaBiglietti: 'Acheter des tickets',
                    calcolaPercorso: 'Calcul du parcours',
                    fermateOrari: 'Arrêts et horaires',
                    mieiTitoli: 'Mes titres',
                },
            },
            atcgo: {
                acquistaBigliettiHTML: 'Acheter<br/>des tickets',
                calcolaPercorsoHTML: 'Calculer<br/>le parcours',
                fermateOrariHTML: 'Arrêts<br/>et horaires',
                luoghi: 'Lieux',
                mieiTitoliHTML: 'Mes<br/>titres',
            },
            autoguidovie: {
                AcquistaBiglietti: 'Acheter<br/>des tickets',
                CalcolaPercorso: 'Calcul du parcours',
                CalcolaPercorsoHTML: 'Calculer<br/>le parcours',
                ElencoMovimenti: 'Liste<br/>des mouvements',
                FermateOrari: 'Horaires et arrêts',
                FermateOrariHTML: 'Horaires et<br/>arrêts',
                MieiTitoli: 'Mes<br/>titres',
                ServiziTuristici: 'Services<br />touristiques',
            },
            autoricarica: {
                labelToggleAttiva: 'Activer',
                title: 'Recharge automatique',
            },
            avm: {
                addAnagraficaDisclaimer:
                    'Pour demander l\'émission de factures relatives aux services de transport public local ou à la mobilité intégrée (parking lignes bleues) gérés par AVM/Actv, veuillez remplir le formulaire au lien suivant : <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/richiesta-fattura\',true)">http://bit.ly/richiesta-fattura</a>.<br />Une fois le formulaire rempli, vous recevrez le « code client » et vous pourrez demander l’émission de factures relatives aux titres de voyage du transport public local achetés par le biais d’AVM Venezia Official App en remplissant le module suivant :',
                addAnagraficaDisclaimer2:
                    "Attention : la facture/le reçu ne sera envoyé mensuellement par e-mail de la part d’AVM qu’après la saisie du Code Client. Pour tous, la confirmation de paiement effectué sera quoi qu'il en soit envoyée.",
                addAnagraficaError1: 'Vous devez remplir les champs du formulaire.',
                addAnagraficaError2: "Seul un champ entre 'Numéro de TVA' et 'Numéro fiscal' peut être rempli.",
                addAnagraficaError3: "Au moins un champ entre 'Numéro fiscal' et 'Numéro de TVA' doit être précisé.",
                addAnagraficaError4: "Il est nécessaire de préciser un 'Code Client'.",
                addAnagraficaErrorANV: 'Compte pas valide',
                addAnagraficaErrorBLK: 'Compte bloqué',
                addAnagraficaErrorECF: 'Numéro fiscal ou Numéro de TVA ne correspondant pas au compte',
                addAnagraficaErrorERR: 'Une erreur s’est produite.',
                addAnagraficaErrorINV: 'Entrée pas valide',
                addAnagraficaErrorNFD: 'ID Client pas trouvé',
                areaNonServitaHtml:
                    'Vérifiez sur les panneaux verticaux si la zone est payante.</br> Assurez-vous que le pointeur se trouve sur la chaussée et choisissez éventuellement la rue dans laquelle vous vous stationnez dans le menu « LISTE ». </br> En cas de problèmes techniques, remplissez le formulaire Internet <a href="#" onclick="javascript:openLinkOnBrowser(\'http://bit.ly/AssistenzaAppAVM\',true)">http://bit.ly/AssistenzaAppAVM</a>',
                benvenutiVenezia: '<span>Bienvenue à </span><span class="bold">Venise</span>',
                calcolaPercorso: 'Calculer le parcours',
                caricaIlTuoVoucher: 'Chargez votre bon',
                caricaVoucher: 'Charger bon',
                caricaVoucherDescription: 'Saisissez le code PNR Venezia Unica de votre bon.',
                caricaVoucherPlaceholder: 'Insérez votre bon',
                caricoCliente:
                    'Il est à la charge du client d’évaluer la validité de temps résiduel avant d’effectuer le voyage.',
                condizioniContent:
                    "<div> <h2><strong>CONDITIONS D’UTILISATION AVM VENEZIA OFFICIAL APP</strong></h2> <h3><strong>1. Domaine d'application</strong></h3><p>Les présentes conditions d'utilisation régissent la relation entre l’utilisateur et l’Azienda Veneziana per la Mobilità spa (ci-après pour abréger AVM) en ce qui concerne l’achat de tickets de voyage pour le transport public local par le biais de l’utilisation d’AVM Venezia official APP<br/> Les conditions et les exigences qui régissent les opérations et les modes d'accès et d'utilisation du transport public et qui établissent les obligations et les responsabilités du transporteur et du transporté sont contenues dans les Conditions Générales de Transport publiées sur le site www.avmspa.it.<br/> L'application ne peut être téléchargée et utilisée que sur les smartphones, il n'est donc pas possible de l'utiliser sur des dispositifs tels que les tablettes et/ou similaires</p><h3><strong>2. Valeur des conditions d'utilisation</strong></h3> <p> En téléchargeant l'application depuis la boutique associée au système d'exploitation et en s'enregistrant à l'application, l'utilisateur accepte pleinement toutes les présentes conditions d'utilisation, aucune exclue.<br/> AVM se réserve le droit de modifier unilatéralement ces conditions d'utilisation à tout moment. Il est de la seule responsabilité de l'utilisateur de vérifier, à chaque accès à l'application, si des modifications ont été apportées ; l'utilisation de l'application implique l'acceptation pleine et entière de celles-ci.</p><h3><strong>3. Conditions d'utilisation</strong></h3> <p>L'achat d'un ticket de voyage via l’application se fait aux seuls risques de l'utilisateur. L'utilisateur doit prendre des mesures pour protéger son dispositif mobile contre tout accès non autorisé. Afin de minimiser les éventuels dommages, l'utilisateur s'engage à signaler sans délai à AVM tout soupçon d'utilisation non autorisée ou de mode non autorisé de son compte utilisé pour accéder à l'application.<br/> Pour procéder au premier achat de titres de voyage, il est nécessaire que l'utilisateur effectue l'opération d'enregistrement, en saisissant les données demandées par l'application. Pour tous les achats ultérieurs, il suffira que l'utilisateur se connecte en saisissant son adresse e-mail et son mot de passe.<br/>Après l'enregistrement, l'utilisateur deviendra seul responsable de toutes les activités effectuées via son compte. AVM décline toute responsabilité pour les erreurs commises par l'utilisateur lors de son inscription.<br/> Aux fins de l'utilisation du service, le client devra fournir à AVM ses données personnelles, son adresse e-mail et son numéro de téléphone portable associé au smartphone sur lequel l'application est téléchargée. Il appartient à l'utilisateur de vérifier le bon enregistrement de ses données.<br/> L'utilisateur est le seul responsable exclusif de la confidentialité de son mot de passe. S’il a des raisons de croire que des tiers ont accédé au mot de passe ou en ont eu connaissance, l'utilisateur doit immédiatement changer son mot de passe.</p><h3><strong>4. Mode de fonctionnement</strong></h3><p>Le ticket de voyage doit être acheté avant d'accéder aux moyens de transport. Pour chaque dispositif mobile, il est permis d'acheter plusieurs tickets de voyage pour les passagers voyageant ensemble.<br/> Les paiements ne peuvent être effectués que par carte de crédit, y compris les cartes prépayées appartenant aux circuits Visa et Mastercard dont les données doivent être saisies à la suite de l’enregistrement ou lors de l'achat. Une fois la transaction effectuée, un reçu de paiement sera envoyé à l'adresse e-mail de l'utilisateur.<br/> Les titres de voyage achetés via l’application doivent toujours être validés avant le début du voyage.<br/> Sur les passages d'accès aux moyens de transport équipés d'un tourniquet et de lecteur du code QR, l’utilisateur doit visualiser le code QR associé au titre de voyage et le scanner sur le lecteur placé sur le passage. À partir du moment où le code QR est scanné, la validité du titre de voyage commencera.<br/> Dans tous les cas où le tourniquet n'est pas équipé d'un lecteur de code QR ou s'il n'y a pas de tourniquet (par ex. dans les véhicules automobiles), la validation devra être effectuée en cliquant sur une icône appropriée sur le dispositif mobile. Dans ces cas, l'expiration de la durée de validité sera reportée de 3 (trois) minutes.<br/> Il est de la responsabilité de l'utilisateur de garantir le bon fonctionnement du dispositif mobile pendant toute la durée du voyage, afin de pouvoir présenter le ticket électronique validé en le visualisant sur le dispositif mobile, à la demande du personnel de contrôle. La non-présentation du titre de voyage en raison d'un dysfonctionnement du dispositif mobile entraîne les mêmes conséquences prévues et sanctionnées pour les irrégularités des titres de voyage dans les Conditions Générales de Transport.</p><h3><strong>Réclamations et responsabilités</strong></h3> <p> Toute opération volontaire ou involontaire effectuée par l'utilisateur entraînant la perte de titres de voyage reste de la responsabilité exclusive de celui-ci, y compris, par exemple, les cas de désinstallation de l'application, de dysfonctionnement et de formatage du dispositif, ainsi que la perte de celui-ci.<br/> Les titres de voyage achetés sont mémorisés exclusivement sur le dispositif avec lequel l'achat a été effectué, ils ne sont donc pas transférables sur d'autres dispositifs mobiles.<br/> AVM ne remboursera le titre de voyage que si des frais sont survenus en raison d'un traitement incorrect de la transaction imputable au système de paiement.</p><h3><strong>Rétractation</strong></h3> <p> Sauf indication contraire au point précédent, l'utilisateur peut désinstaller l'application de son dispositif mobile à tout moment et sans préavis et peut également demander la suppression de son compte par e-mail avec une demande explicite au service clients de l'application.</p><h3><strong>Règles de confidentialité</strong></h3> <p> En installant l'application, l'utilisateur déclare et accepte qu'AVM puisse accéder, stocker et traiter ses données personnelles et tout contenu associé à l’utilisation de l'application, si la loi l'exige ou si de telles activités sont nécessaires à l'utilisation de l'application ou des services fournis via l'application, en pleine conformité avec le décret législatif italien 196/2003 « Code en matière de protection des données personnelles ».<br/> L'utilisateur reconnaît et accepte que l'utilisation de l'application puisse permettre la transmission de données via des réseaux de communication électronique.<br/> Des informations plus détaillées sur l'utilisation des données personnelles par AVM sont disponibles sur le site www.avmspa.it. Le titulaire du traitement est l’Azienda Veneziana della Mobilità spa dont le siège se trouve à Venise, Isola Nova del Tronchetto 33.</p><h3><strong>Propriété intellectuelle</strong></h3> <p>En téléchargeant l’application, l'utilisateur accepte et reconnaît que celui-ci est protégé par les règlementations en matière de propriété intellectuelle et par les autres dispositions applicables, y compris, par exemple, les droits d'auteur. L'utilisateur s'engage à n'utiliser ces informations couvertes par les droits de propriété et matériels que pour l'utilisation du service proposé dans le respect des dispositions des présentes conditions générales d’utilisation. Aucune partie de l’application et des produits proposés ne peuvent être reproduits sous quelque forme ou par quelque moyen que ce soit, sauf autorisation expresse dans les présentes conditions. L'utilisateur s'engage à ne pas modifier, louer, prêter, vendre, distribuer ou créer des ouvrages dérivés ou basés sur la présente application, de quelque manière que ce soit, et ne pourra pas exploiter l'application ou les produits achetés de manière non autorisée.<br/> Tous les droits d'auteur relatifs à l’application sont la propriété d'AVM et/ou de ses concédants de licence. L'utilisation de chaque composant de l'application, à l'exception de l'utilisation autorisée par les présentes conditions générales, est strictement interdite et viole les droits de propriété intellectuelle de tiers et peut exposer l'utilisateur à des sanctions civiles et pénales, y compris d'éventuels dommages pécuniaires, pour violation des droits d'auteur.<br/> AVM, le logo AVM et les autres marques du groupe AVM, les signes graphiques et les logos utilisés en relation avec l'application constituent des marques de commerce ou des marques déposées du groupe AVM. L'utilisateur n'a aucun droit ni licence d'utilisation en ce qui concerne les marques mentionnées et l'utilisation de celles-ci.</p></div>",
                condizioniHeader: 'CONDITIONS GÉNÉRALES',
                condizioniVeneziaUnica: 'Conditions Venezia Unica',
                infoMobilita: 'Horaires des voyages depuis/vers les instituts scolaires',
                messageCondizioniBorsellino:
                    "J’ai lu les <a class='condizioni-borsellino'>conditions d’utilisation</a> du crédit.",
                messaggioInformativoSosta: 'Vérifiez sur les panneaux verticaux si la zone est payante.',
                ricercaOrari: 'Recherche horaires aux arrêts',
                sezioneVoucher: 'Trouvez les titres dans la section « Mes bons »',
                sostaItem: 'active(s)',
                sostaSubTitle: 'Infos et tickets',
                sostaTitle: 'Stationnement',
                trasportoItem: 'achats',
                trasportoSubTitle: 'Infos et tickets',
                trasportoTitle: 'Transport',
                vaiAiVoucher: 'Aller à mes bons',
                verificaAcquisto:
                    'Vérifiez dans la section « Achetez un titre Actv » s’il existe des solutions tarifaires plus avantageuses par rapport à vos exigences de voyage (titres avec carte ou tickets à durée limitée)',
                viaggia: {
                    abbonamenti: 'Acheter des titres sur Venezia Unica',
                    acquistoOd: 'Acheter des titres extra-urbains',
                    acquistoOdTessera: 'Acheter des titres extra-urbains sur Venezia Unica',
                    header: 'Voyagez',
                    tariffaFissa: 'Acheter des titres à durée limitée',
                },
                voucherItem: 'Bon',
                voucherSubTitle: 'Bon',
                voucherTitle: 'Charger votre',
            },
            biglietto: {
                acquistatoIl: 'Acheté le',
                atac: {
                    aimop: {
                        descrizioneAggiuntiva:
                            'Le titre est émis avec les dates de commencement et d’expiration prédéfinies, donc il est acheté déjà actif. Les abonnements achetés avant le 24 de chaque mois sont activés au moment de l’achat car valables pendant le mois en cours. Ceux achetés ensuite seront activés automatiquement le 1er jour du mois suivant.',
                        note:
                            'Pour voyager en métro, montrez le code QR au lecteur optique du tourniquet ou, si vous disposez d’un dispositif Android doté de la technologie NFC, approchez le smartphone au lecteur NFC présent sur le tourniquet.',
                        tipoValidazione: 'Activé automatiquement',
                    },
                    bit100: {
                        descrizioneAggiuntiva:
                            'Valable 100 minutes à partir de la première activation sur tous les moyens de transport de surface (bus, tram et trolleybus). Pour le métro, le titre sera valable pour un seul voyage, même sur plusieurs lignes, sans passer par les tourniquets',
                        note:
                            "<p class='bold'>Validité :</p><p>100 minutes à compter de la première activation sur bus, trolleybus, tram et métro C. 1 aller simple pour le métro A, B, B1, même sur plusieurs lignes sans passer par les tourniquets. 1 aller simple en train</p><p class='bold'>Domaine d’utilisation :</p><p>Il peut être utilisé sur tous les services de transport de surface et dans les métros du circuit Metrebus : Bus, tram, trolleybus et métro ATAC, moyens de transport RomaTPL et Cotral, Gare Rome-Lido et Gare Rome-Viterbe.</p><p class='bold'>Comment l’utiliser :</p><p>Le titre n'est valable que si on l'active. Pour voyager en métro, montrez le code QR au lecteur optique du tourniquet ou, si vous disposez d’un dispositif doté de la technologie NFC, ouvrez le titre et approchez le smartphone au lecteur NFC présent sur le tourniquet. Au moment de l'activation, pour les métros A, B et B1, un compteur démarrera, vous aurez donc 2 minutes pour accéder aux tourniquets.</p>",
                        tipoValidazione:
                            'Manuelle à la première utilisation, avant de monter sur les moyens de transport',
                    },
                    brm24: {
                        descrizioneAggiuntiva: 'Valable 24 heures à compter de la première activation',
                        note:
                            'Pour voyager en métro, montrez le code QR au lecteur optique du tourniquet ou, si vous disposez d’un dispositif Android doté de la technologie NFC, approchez le smartphone au lecteur NFC présent sur le tourniquet.',
                        tipoValidazione:
                            'Manuelle à la première utilisation, avant de monter sur les moyens de transport',
                    },
                    brm48: {
                        descrizioneAggiuntiva: 'Valable 48 heures à compter de la première activation',
                        note:
                            'Pour voyager en métro, montrez le code QR au lecteur optique du tourniquet ou, si vous disposez d’un dispositif Android doté de la technologie NFC, approchez le smartphone au lecteur NFC présent sur le tourniquet.',
                        tipoValidazione:
                            'Manuelle à la première utilisation, avant de monter sur les moyens de transport',
                    },
                    brm72: {
                        descrizioneAggiuntiva: 'Valable 72 heures à compter de la première activation',
                        note:
                            'Pour voyager en métro, montrez le code QR au lecteur optique du tourniquet ou, si vous disposez d’un dispositif Android doté de la technologie NFC, approchez le smartphone au lecteur NFC présent sur le tourniquet',
                        tipoValidazione:
                            'Manuelle à la première utilisation, avant de monter sur les moyens de transport',
                    },
                    hai2Minuti: 'Vous avez 2 minutes pour accéder aux tourniquets',
                    vuoiAttivareTitolo: 'Vous souhaitez activer le titre ?',
                    vuoiAttivareTitoloBus:
                        '<div class="secondary textAlignCenter fontSizeHuge">Vous souhaitez monter dans le bus ou dans le métro C ?</div><div class=\'marginTop\'>Le compteur du temps de validité démarrera.<br />Pour entrer dans le métro, montrez le code QR aux lecteurs optiques du tourniquet.</div>',
                    vuoiEntrareMetro:
                        "<div class=\"secondary textAlignCenter fontSizeHuge\">Vous souhaitez entrer dans le métro A, B, B1 ?</div><div class='marginTop'>Pour entrer, vous avez 2 minutes pour montrer le code QR aux lecteurs optiques du tourniquet.<br/>Le titre n'est valable que pour un seul voyage en métro.</div>",
                    vuoiSalireTreno:
                        "<div class=\"secondary textAlignCenter fontSizeHuge\">Vous souhaitez monter dans le train ?</div><div class='marginTop'>Le titre n'est valable que pour un seul voyage en train.<br />Choisissez la gare de départ :</div>",
                },
                attiva: 'Activer',
                attivaESaliBus: 'Activez et montez sur le :',
                attivaEdEntraMetro: 'Activez et entrez dans :',
                attivaMsg: 'Activez le ticket pour pouvoir l’utiliser',
                attivaPer: 'Activez pour',
                attivato: 'Activé',
                attivatoIl: 'Activé le',
                attivatoMetro: 'Validation métro :',
                attivatoPer: 'Activé pour',
                attivatoTreno: 'Validation train :',
                attivazioneBus: 'Activation Bus, Métro C',
                attivazioneMetro: 'Activation Métro A, B, B1',
                attivazioneNFC: 'Activation par le biais de NFC',
                attivazioneTitolo: 'Activation titre',
                attivazioneTreno: 'Activation Train',
                avvisoTitoliLocali:
                    '<span>Les titres ne sont mémorisés que sur le smartphone. Pour de plus amples informations, cliquez {0}ici{1}</span>',
                avvisoTitoliLocaliMail:
                    'Les titres sont mémorisés sur le smartphone. Pour de plus amples informations contactez {0}',
                avvisoTitoliLocaliNoLink: 'Les titres ne sont mémorisés que sur le smartphone.',
                cercaTitolo: 'Chercher titre de voyage',
                chiediCodice: 'Demandez au conducteur les informations pour activer le titre',
                codiceNonValido: 'Code pas valable',
                confermaAttivazione:
                    'Si vous confirmez, le titre sera activé et le comptage du temps de validité démarrera',
                confermaMetro: 'Si vous confirmez, vous avez deux minutes pour entrer dans le métro.',
                confermaMetroAttivazione:
                    'Si vous confirmez, le titre sera activé, le comptage du temps de validité démarrera et vous aurez ensuite deux minutes pour entrer dans le métro.',
                costoTitolo: 'Coût du titre',
                daAttivare: 'À activer',
                dataEmissione: "Date d'émission",
                dataScadenza: "Date d'échéance",
                entraInMetro: 'Métro',
                entraMetro: 'Entrez dans :',
                error: {
                    corseEsaurite: 'Voyages terminés',
                    datiNonCongrui: 'Dates pas cohérentes',
                    erroreAntiPassback: 'Erreur contrôle anti-passback',
                    erroreApplicativo: 'Erreur dans l’application',
                    erroreValidazioneMultipla: 'Erreur validation multiple même compte',
                    impossibileValidare: 'Impossible de valider le ticket',
                    titoloNonValido: "Le titre n'est pas valable",
                },
                fermataSalita: 'Arrêt de montée',
                finoA: "Jusqu'à",
                header: 'Ticket',
                identificativo: 'Identifiant',
                inFaseDiAttivazione: "Service en phase d'activation",
                infoAcquistoAnnullato: 'Transaction annulée par l’utilisateur',
                infoAcquistoEffettuato: 'Vous pouvez trouver le ticket acheté dans la section « Mes titres ».',
                infoAcquistoFallito: 'Impossible d’effectuer la transaction.',
                infoAcquistoFallitoVix:
                    "Il n’est pas possible d’effectuer la transaction. Effectuez de nouveau la procédure d'achat.",
                infoAcquistoSiaeEffettuato: 'Vous pouvez trouver le ticket acheté dans la section « Événements ».',
                infoCodiceManuale: 'En cas de non-lecture du code, adressez-vous au conducteur',
                inserisciQualcosaPartenza: 'Saisissez la rue, la zone ou l’arrêt de départ',
                istruzioniAttivazione: 'Appuyez sur « Valider » pour valider le titre de voyage',
                istruzioniDownloadTitoliAsincroni:
                    'Une fois l’achat terminé, pour télécharger le titre entrez dans la section « Mes titres » de l’application',
                istruzioniDownloadTitoliAsincroniTrasporto:
                    'Une fois l’achat terminé, pour télécharger le titre entrez dans la section « Transport » de l’application',
                istruzioniObliterazione: 'Appuyez sur « Valider » pour valider le titre de voyage',
                localita: 'Localité',
                multicorsa: {
                    MultiCorsa: 'Carnet',
                    attivaAltro: 'Validation voyages',
                    attivaDefault: 'Activer',
                    attivaPrimo: 'Validation voyages',
                    attivaUltimo: 'Validation voyage',
                    attivoFinoA: 'Voyage valable jusqu’à :',
                    confermaRivalidazione: 'Les voyages actifs en ce moment seront archivés comme étant expirés.',
                    corseAttive: 'Voyages actifs : ',
                    corseDaAttivare: 'voyages résiduels',
                    corseRimaste: 'Voyages : ',
                    daAttivare: 'Voyage pas validé',
                    info: 'Pour valider les voyages, passez {0} fois le code QR devant le tourniquet.',
                    quantiAttivare: 'Combien de voyages souhaitez-vous activer ?',
                    scaduto: 'Expiré',
                    tickets: 'Voyages',
                    tutteCorseScadute: 'Tous les voyages sont expirés',
                    validoDa: 'Voyage valable à partir de :',
                },
                nfcNotSupported:
                    'Votre smartphone est autorisé au service NFC. Cependant, cette version d’Android ne permet pas à myCicero d’accéder à cette fonction.',
                nfcOFF:
                    'Avec votre smartphone vous pouvez utiliser la validation par NFC. Cette fonction résulte cependant désactivée. Vous souhaitez l’activer ?',
                nfcON:
                    'Félicitations ! Votre smartphone vous permet de valider ce titre de voyage en approchant simplement le dispositif au lecteur NFC si présent.',
                noPosPartenzaRilevata: 'Impossible de trouver la position de départ.',
                nonAcquistabileContrattiInsufficienti:
                    'Le titre ne peut pas être acheté car la carte n’a pas de contrats suffisants',
                nonAncoraUtilizzabile: 'Pas encore utilisable',
                nonAttivato: 'Titre pas activé',
                nonEffettuata: 'Pas effectuée',
                nonObliterato: 'Titre pas validé',
                nonValidato: 'Titre pas validé',
                notificaMessaggio: '{0} expirera à {1}',
                notificaTitolo: 'Le titre expirera sous peu',
                nuovaAttivazione: 'Nouvelle activation',
                nuovaValidazione: 'Nouvelle validation',
                oblitera: 'Activer',
                obliteratoIl: 'Oblitéré le',
                piuCorse: 'Plusieurs voyages',
                precedente: 'Aller au ticket précédent',
                premiAttiva: 'La non-activation comporte une sanction.',
                premiValida:
                    'Appuyez sur « Nouvelle validation » avant de monter sur le moyen de transport. La non-activation comporte une sanction.',
                primaAttivazione: 'Activé',
                qrCodeScaduto: 'Code QR expiré',
                saliInBus: 'Bus',
                saliSulTreno: 'Activer titre',
                saraValidoTra: 'Le titre sera valable dans ',
                scaduto: 'Expiré',
                scadutoIl: 'Expiré le',
                selezionaFermataSalita: 'Si vous le connaissez, sélectionnez l’arrêt de montée',
                selezionaStazioneSalita: 'Sélectionnez gare de départ :',
                singolaCorsa: '1 seul voyage',
                stazioneSalita: 'Gare de montée :',
                successivo: 'Aller au ticket suivant',
                tempoRestante: 'Temps résiduel',
                termsConditions: "<span>J’ai lu et j’accepte les </span><a href='#'>conditions d’utilisation</a>",
                tipologiaBiglietto: 'Type de ticket',
                titoliImpersonali: 'Titres de voyage impersonnels',
                titoloAttivo: 'Titre de voyage actif',
                titoloAttivoFinoAl: 'Titre actif jusqu’au',
                titoloDiViaggio: 'Titre de voyage',
                titoloLocale: 'Ce titre se trouve uniquement sur votre smartphone.',
                titoloNonAttivo: 'Titre pas activé',
                titoloScaduto: 'Le titre a expiré',
                titoloScadutoAlle: 'Titre expiré à',
                treno: 'Train',
                ultimaValidazione: 'Dernière validation',
                utilizzabileDalAl: 'Utilisable du {0} au {1}',
                utilizzabileFinoA: 'Utilisable jusqu’au {0}',
                utilizzabileIl: 'Utilisable le {0}',
                utilizzabileIlGiorno: 'Utilisable le :',
                utilizzabileOggi: 'Utilisable aujourd’hui',
                vaiAlBiglietto: 'Aller au ticket',
                valida: 'Nouvelle activation',
                validaMsg: 'Validez le ticket pour pouvoir l’utiliser',
                validatoIl: 'Validée le :',
                valido: 'Valide',
                validoFinoAl: 'Valable jusqu’à',
                warningAccessoMetro: "Traversez le passage d'accès </br> au métro avant",
            },
            bikeSharing: {
                aggiungiBici: 'Ajoutez une autre bicyclette.',
                alertPrenotazioneAccorciata:
                    'La durée de la location a été réduite en fonction du règlement appliqué dans la structure sélectionnée.',
                alertPrenotazioneAllungata:
                    'La durée de la location a été augmentée en fonction du règlement appliqué dans la structure sélectionnée. Ceci ne comporte aucun frais supplémentaire pour vous.',
                alertPrenotazioneAnnullata: 'La réservation a été annulée.',
                altreFunzionalita: 'Autres fonctions',
                annullaPrenotazione: 'Annuler la réservation',
                bici: 'Bicyclette',
                biciPrenotataPerHtmlTemplate: 'La bicyclette restera réservée pendant {0}',
                bicicletta: 'Bicyclette :',
                biciclette: 'Bicyclettes :',
                bikePoint: 'Bike Point :',
                bikePointChiuso: 'Bike point fermé',
                bikePointChiusoInfo: "Pendant l’horaire de fermeture du bike point il n'est pas possible de réserver",
                bikePointPrelievo: 'Prélèvement :',
                bikePointRiconsegna: 'Retour :',
                btnPrenota: 'Réservez une bicyclette',
                cantBook: 'Vous ne pouvez pas réserver',
                cercaBikePoint: 'Chercher Bike Point',
                cercaPerNomeIndirizzo: 'Chercher par adresse ou nom',
                confermaBici: 'Prélever la bicyclette',
                consegnaInRitardo: 'Vous auriez dû la retourner avant :',
                contattaci: 'Contactez-nous',
                dettaglioCorsa: 'Détail voyage',
                elencoPrenotazioniRecenti: 'Liste des opérations récentes...',
                elencoStrutture: 'Bike Point',
                emptyPoint: 'Bike Point vide',
                haiPrenotazione: 'Vous avez une réservation de {0} bicyclettes',
                haiRiconsegnatoInRitardo: 'Terminé (en retard)',
                importoMyCicero: 'Payé avec myCicero :',
                importoOra: 'Si vous retournez maintenant :',
                importoTotale: 'Montant total :',
                infoPoint: 'Infos Bike Point',
                infoPrelievo: 'Le moyen de transport sera réservé pendant la période sélectionnée.',
                infoPrenotazione0: "La location comprend l'assurance, les taxes et la carte de Rome",
                infoPrenotazione1:
                    'Vous avez 30 minutes pour prélever la/les bicyclette(s), dans le cas contraire la demande sera annulée automatiquement',
                infoPrenotazione2:
                    'La réservation sera automatiquement activée quand vous prélèverez la/les bicyclette(s).',
                infoPrenotazione3:
                    "L’horaire configuré n'est pas contraignant pour le retour des véhicules et il sera quoi qu'il en soit possible de terminer la location à l'avance. Le coût sera débité en fonction de l’horaire de prélèvement effectif selon le tarif en vigueur.",
                infoRitardo: 'Le non-retour a été noté par myCicero. Retournez la bicyclette dès que possible.',
                inserisciCodiceBici: 'Saisissez le code bicyclette',
                inserisciNumeroBici: 'Saisissez le numéro bicyclette',
                istruzioni: {
                    bloccoSbloccoSaldo:
                        'Pour pouvoir bloquer ou débloquer les bicyclettes, vous devez avoir un solde porte-monnaie électronique supérieur ou égal au coût de la location',
                    buonaPedalata: '3) Bonne promenade !',
                    cosaDevoFare: 'Que dois-je faire ?',
                    inserisciCodice: 'Insérez ou scannez le code de toutes les bicyclettes de votre réservation',
                    mostraCodice: 'montrer le code',
                    mostraIlCodice: '2) Une fois sur place, montrez le code de réservation au gestionnaire.',
                    mostraSuMappa: 'montrer sur la carte',
                    raggiungiIlBikePoint: '1) Rejoignez le Bike Point « {1} » avant {0}',
                    ricordatiDiRiconsegnare:
                        '4) Rappelez-vous de retourner les bicyclettes avant {0} dans un des Bike Point adhérant au service',
                    semplice: 'Simple',
                    termineNoleggioSelfService:
                        'Avant de terminer la location, assurez-vous d’avoir raccroché toutes les bicyclettes louées au bike point.',
                },
                leMiePrenotazioni: 'Mes réservations',
                limitePrenotazioni: 'Vous avez atteint le nombre maximal de réservations',
                mezzoPrenotatoPeriodoSelezionato: 'Le moyen de transport sera réservé pendant la période sélectionnée',
                mostaCodicePrenotazione: 'Montrer le code de réservation',
                nessunRecente: 'Rien à visualiser',
                noBikes: 'Aucune bicyclette disponible en ce moment.',
                noBikesInPoint: 'Aucun véhicule disponible dans la structure sélectionnée',
                noResult: "La recherche n'a donné aucun résultat",
                noleggi: 'Locations actives',
                operazioneNonAutorizzata: 'Opération pas autorisée',
                orario: 'Heure d’utilisation',
                orarioApertura: 'Heure d’ouverture',
                prelevaEntro: 'Prélevez avant :',
                prelievo: 'Vous pouvez prélever la bicyclette avant : ',
                prelievoEffettuato: 'Prélèvement effectué : ',
                prelievoEntro: 'Prélèvement avant : ',
                prenota: 'Réserver',
                prenotazioni: 'Réservations',
                preventivoPrenotazione: 'Devis réservation :',
                problemi: 'Pour tout problème ou mauvais service',
                recenti: 'Récents',
                ricalcoloPreventivoInCorso: 'Nouveau calcul devis en cours...',
                ricaricaBorsellino: 'Recharger le porte-monnaie électronique pour effectuer la réservation.',
                ricaricaBorsellino2:
                    'Rechargez le porte-monnaie électronique si vous souhaitez payer le montant total avec MyCicero, dans le cas contraire vous paierez la différence à l’opérateur du bike point.',
                riconsegna: 'Vous devez la retourner avant : ',
                riconsegnaEffettuata: 'Retour effectué :',
                riconsegnaEntro: 'Retour avant :',
                sblocca: 'Débloquer',
                scegliTipologia: 'choisissez le type',
                seiInRitardo: 'Vous êtes en retard pour le retour',
                templateMessaggioPreventivo:
                    'Si vous prélevez les moyens de transport réservés maintenant et vous les retournez à l’heure sélectionnée, vous dépenserez : {0}',
                terminaNoleggio: 'Terminer la location',
                titles: {
                    bikeSharing: 'Bike',
                    conferma: 'Confirmer',
                    dettaglioCorsa: 'Détail voyage',
                    prenotaBici: 'Réserver bicyclette',
                    scegliBikePoint: 'Choisissez un Bike Point',
                },
                visualizzaRecenti: 'Liste des mouvements',
            },
            busitaliaveneto: {
                acquistaBiglietti: 'Acheter des tickets',
                calcolaPercorso: 'Calcul du parcours',
                fermateOrari: 'Arrêts et horaires',
            },
            carPoolingTaxiCondiviso: {
                bacheca: {
                    cercaConducenti: 'Chercher des conducteurs',
                    cercaOfferteRichieste: 'Chercher des offres et des demandes des utilisateurs',
                    cercaPasseggeri: 'Chercher des passagers',
                },
                common: {
                    annullaRichiesta: 'Annuler la demande',
                    annullaRichiestaError: 'Impossible d’annuler la demande. Réservation pas trouvée.',
                    annullaRichiestaMessage: 'Annuler la demande définitivement ?',
                    bacheca: "Panneau d'affichage",
                    carInfo: 'Infos véhicule :',
                    chiamaTaxi: 'Appeler un taxi',
                    commento: 'Commentaire',
                    confermaPrenotazioneTaxi: 'Confirmer la réservation du taxi',
                    confermaPrenotazioneTaxiMessage:
                        "En confirmant la réservation du taxi partagé, les autres utilisateurs recevront une notification de la confirmation du taxi.<br/><br/>Vous trouverez vos demandes dans la section <b class='primary'>MES VOYAGES</b>",
                    confermaRichiesta: 'Confirmer la demande',
                    confermaRichiestaMessage: 'Êtes-vous certain de vouloir confirmer la demande ?',
                    confermaValutazione: 'Confirmer l’avis',
                    corsaEliminata: 'Voyage éliminé',
                    corsaEliminataMessage: 'Le voyage a été éliminé définitivement.',
                    dettaglio: 'Détail',
                    elencoPasseggeri: 'Liste des passagers',
                    eliminaCorsa: 'Éliminer le voyage',
                    eliminaCorsaMessage: 'Éliminer le voyage définitivement ?',
                    ferryInfo: 'Infos ferry :',
                    filtra: 'Filtrer',
                    filtraOfferte: 'Filtrer les offres',
                    filtraRichieste: 'Filtrer les demandes',
                    filtraStoricoViaggi: 'Filtrer l’historique des voyages',
                    filtriAttiviNum: '{0} filtres actifs',
                    filtroAttivoNum: '{0} filtre actif',
                    iMieiViaggi: 'Mes voyages',
                    inserisciRichiesta: 'Insérer la demande',
                    inviaOfferta: 'Envoyer l’offre',
                    inviaRichiesta: 'Envoi demande',
                    iscrizione: 'Enregistrement',
                    mappa: 'Carte',
                    minimoPasseggeri: 'Passagers minimums',
                    nessunRisultato: 'Aucun résultat',
                    numeroPostiDisponibili: 'Nombre de places disponibles',
                    numeroPostiRichiesti: 'Nombre de places demandées',
                    offertaPassaggio: 'Offre d’accompagnement',
                    offriCorsaPerViaggioCercato: 'Offrez un voyage pour le voyage cherché',
                    offriUnPassaggio: 'Offrez un accompagnement',
                    partecipaTaxiCondiviso: 'Participez au taxi partagé',
                    passeggeriAccompagnati: 'Passagers accompagnés',
                    postiConfermatiNum: '{0} places confirmées',
                    postoConfermatoNum: '{0} place confirmée',
                    prenotazioneTaxiConfermata: 'Réservation taxi confirmée',
                    procediRichiesta: 'Continuer la demande',
                    pubblicaRichiesta: 'Publiez votre demande',
                    pubblicaValutazione: 'Publier l’avis',
                    pubblicaValutazioneMessage:
                        'En publiant l’avis tous les utilisateurs pourront visualiser votre avis',
                    rendiDisponibileAuto: 'Rendez votre voiture disponible',
                    ricercaNoRisultati: "La recherche n'a pas donné de résultat",
                    richiestaAnnullata: 'Demande annulée',
                    richiestaPassaggioInviata: 'Demande d’accompagnement envoyée',
                    richiestaPubblicata:
                        "Votre demande a été publiée.<br/><br/>Vous trouverez votre demande dans la section <b class='primary'>Mes voyages</b>",
                    richiestaRifiutata: 'Demande refusée',
                    richiestaTaxiCondiviso: 'Demande taxi partagé',
                    richiestaTaxiCondivisoNum: '{0} utilisateur participe au taxi partagé',
                    richiesteTaxiCondivisoNum: '{0} utilisateurs participent au taxi partagé',
                    riepilogoOfferta: 'Récapitulatif offre',
                    riepilogoRichiesta: 'Récapitulatif demande',
                    rifiutaRichiesta: 'Refuser la demande',
                    rifiutaRichiestaError: 'Impossible de refuser la demande. Réservation pas trouvée.',
                    rifiutaRichiestaMessage: 'Annuler la demande définitivement ?',
                    storicoViaggi: 'Historique des voyages',
                    taxiCondiviso: 'Taxi partagé',
                    tornaOfferta: 'Retour à l’offre',
                    valutaConducente: 'Donner un avis sur le conducteur',
                    valutaPasseggeri: 'Donner un avis sur les passagers',
                    valutaPasseggero: 'Donner un avis sur le passager',
                    valutaUtente: 'Donner un avis sur l’utilisateur',
                    valutazione: 'Avis',
                    viaggiAttivi: 'Voyages actifs',
                    viaggiCompletati: 'Voyages terminés',
                    viaggiConTaxiCondiviso: 'Voyages avec taxi partagé',
                    viaggiDaConducente: 'Voyages en tant que conducteur',
                    viaggiDaPasseggero: 'Voyages en tant que passager',
                },
                offriPassaggio: {
                    partenzaArrivoModificate:
                        'En modifiant le départ ou la destination par rapport à celles de départ, les solutions pourraient être plus compatibles avec la demande du passager.',
                },
                pubblicaRichiesta: {
                    infoRichiestaCarPooling:
                        "En soumettant la demande, vous publierez deux requêtes distinctes dans la section Tableau d'affichage, une pour le covoiturage et une pour le taxi partagé.Vous recevrez des notifications par e-mail lorsque d'autres utilisateurs introduirontt des offres de voyage ou des demandes de taxi partagé compatibles avec vos exigences de voyage.",
                    infoRichiestaCarPoolingTaxiCondiviso:
                        "En envoyant la demande, vous publierez dans la section Panneau d'affichage deux demandes séparées, une pour le covoiturage et une pour le taxi partagé. Vous recevrez des notifications par e-mail quand d’autres utilisateurs inséreront des offres de voyage ou des demandes de taxi partagé compatibles avec vos exigences de voyage.",
                    infoRichiestaNoAmbito:
                        'Sélectionnez au moins un secteur, entre le covoiturage et le taxi partagé, pour lequel saisir une demande dans la section Panneau d’affichage.',
                    infoRichiestaTaxiCondiviso:
                        "En envoyant la demande, vous publierez dans la section Panneau d'affichage une demande pour Taxi partagé. Vous recevrez des notifications par e-mail quand d’autres utilisateurs inséreront des demandes de taxi partagé compatibles avec vos exigences de voyage.",
                    pubblicaRichiestaCarPooling: 'Publiez une demande de partage voyage Covoiturage',
                    pubblicaRichiestaTaxiCondiviso: 'Publiez une demande de partage voyage en taxi',
                },
                riepilogoOfferta: {
                    informazioniOffertaPassaggioPubblicata:
                        "Attendez que d’autres utilisateurs vous contactent par e-mail ou cherchez immédiatement les passagers pour votre voyage parmi les demandes compatibles avec l’offre publiée. <br/><br/>Vous trouverez votre demande dans la section <b class='primary'>MES VOYAGES</b>",
                    informazioniVeicolo: 'Informations véhicule',
                    informazioniVeicoloPlaceholder: 'Plaque d’immatriculation, marque, modèle',
                    offertaPassaggioPubblicata: 'Offre d’accompagnement publiée',
                    selezionaMezzoDiTrasporto: 'Choisissez le moyen de transport avec lequel vous arriverez',
                    selezionaTraghettoElba: "Choisissez le ferry avec lequel vous arriverez à l’île d'Elbe",
                },
                riepilogoRichiesta: {
                    richiestaInoltrataConducente:
                        "Votre demande a été envoyée au conducteur <b class='primary'>{0}</b>.<br/><br/>Attendez que le conducteur confirme votre demande ou appelez-le pour avoir des nouvelles.<br/><br/>Vous trouverez votre demande dans la section <b class='primary'>MES VOYAGES</b>",
                    richiestaInoltrataConducenti:
                        "Votre demande a été envoyée aux conducteurs <b class='primary'>{0}</b>.<br/><br/>Attendez que les conducteurs confirment votre demande ou appelez-les pour avoir des nouvelles.<br/><br/>Vous trouverez vos demandes dans la section <b class='primary'>MES VOYAGES</b>",
                    richiestaInoltrataTaxiCondiviso:
                        "Vous avez envoyé votre participation au taxi partagé<br/><br/>Appelez les autres participants pour avoir des nouvelles sur la réservation du taxi.<br/><br/>Vous trouverez votre demande dans la section <b class='primary'>MES VOYAGES</b>",
                    richiesteInoltrate:
                        "Vos demandes ont été envoyées.<br/><br/>Vous les trouverez dans la section <b class='primary'>MES VOYAGES</b>",
                    richiesteInoltrateTaxiCondiviso:
                        "Vous avez envoyé votre participation aux taxis partagés.<br/><br/>Appelez les autres participants pour avoir des nouvelles sur la réservation des taxis.<br/><br/>Vous trouverez vos demandes dans la section <b class='primary'>MES VOYAGES</b>",
                    richiesteInviate: 'Demandes envoyées',
                    richiestePassaggioInviate: 'Demandes d’accompagnement envoyées',
                },
                soluzioniDiViaggio: {
                    posizioniNonValide: 'Positions de départ et d’arrivée pas valables.',
                },
            },
            cercaOd: {
                destinazione: 'Destination',
                header: 'Chercher sur trajet',
                nessunTitoloTrovato: 'Il n’y a pas de solutions pour les critères saisis',
                origine: 'Origine',
                voglioArrivareA: 'Je veux arriver à',
                voglioPartireDa: 'Je veux partir de',
            },
            common: {
                Targa: "Plaque d'immatriculation",
                aPartireDa: 'À partir de',
                aPiedi: 'À pied',
                accedi: 'Accédez',
                accetta: 'Accepter',
                acquista: 'Acheter',
                acquistaCon: 'Acheter avec',
                acquistabile: 'Disponible',
                acquisto: 'Achat',
                acquistoABuonFine: "L'achat a réussi",
                acquistoEffettuato: 'Achat effectué',
                adesso: 'Maintenant',
                agevolazioni: 'Avantages',
                aggiungi: 'Ajouter',
                al: 'À',
                alAlle: 'Au {0} à {1}',
                andataRitorno: 'Aller / Retour',
                anni: 'ans',
                annulla: 'Annuler',
                annullaOperazione: 'Annuler opération',
                annullata: 'Annulé',
                applicaPreferenze: 'Appliquer préférences',
                apriQrCode: 'Ouvrir le code QR',
                arrivo: 'Arrivée',
                associaCarta: 'Enregistrer carte',
                attendere: 'Veuillez attendre',
                attenzione: 'Attention',
                attiva: 'Valider',
                attivaBorsellino: 'Activez le porte-monnaie électronique transport public',
                attivaNuovoTitolo: 'Activer de nouveaux voyages',
                attivato: 'Validé',
                auto: 'Voiture',
                autocompleteTypes: {
                    EVENTI: 'Événements',
                    FERMATE: 'Arrêts',
                    INDIRIZZO: 'Adresses',
                    LINEE: 'Lignes',
                    LOCALITA: 'Localité',
                    POI: 'Ensuite',
                },
                avanti: 'Continuer',
                backHome: "Retour à la page d'accueil",
                benvenuto: 'Bienvenue',
                benvenutoNelMondoMyCicero: 'Bienvenue dans le monde myCicero.',
                benvenutoNelMondoVettore: 'Bienvenue dans le monde {0}.',
                calcolaPercorso: 'Calcul du parcours',
                cambiCorsa: 'changements',
                cambia: 'Changer',
                cambiaCitta: 'Changer de ville',
                cambiaImmagine: 'Changer',
                cambioCorsa: 'changement',
                cancella: 'Éliminer',
                cancellata: 'Éliminé',
                caratteri: 'caractères',
                carica: 'Charger',
                caricaFile: 'Charger',
                caricamento: 'Chargement...',
                carriers: 'Transporteurs',
                carrozza: 'Wagon',
                centro: 'Zone centre',
                cerca: 'Chercher...',
                chiudi: 'Fermer',
                chiuso: 'Fermé',
                cities: 'Ville',
                clickPerMaggioriInfo: 'Cliquez ici pour de plus amples informations...',
                codiceTransazione: 'Code transaction',
                cognome: 'Nom',
                comune: 'Municipalité',
                comuneArrivo: "Municipalité d'arrivée",
                comuneNonValido: 'Municipalité pas valable ou pas couverte par le service.',
                comunePartenza: 'Municipalité de départ',
                con: 'avec',
                condividiViaggio: 'Partagez le voyage',
                condizioniUtilizzoHtml: 'J\'accepte les <a href="#" class="lnkCondizioni">conditions d’utilisation</a>',
                conducente: 'Conducteur',
                conferma: 'Confirmer',
                confermaAcquisto: 'Confirmer achat',
                confermaContinua: 'Êtes-vous certain de vouloir continuer ?',
                confermaEChiudi: 'Confirmer et fermer',
                confermaNonChiedere: 'Ne plus me le rappeler.',
                confermaSelezione: 'Confirmer sélection',
                confermaUscitaApp: 'Êtes-vous sûr de vouloir sortir de l’application ?',
                contattaAssistenza: 'Veuillez contacter l’assistance',
                contattaIlGestore: 'Contacter le gestionnaire',
                contattiEdEntiCoinvolti: 'Contacts et organismes impliqués',
                continua: 'Continuer',
                copertura: 'Couverture zones',
                corse: 'Voyages',
                creaTessera: 'Créer carte',
                crediti: 'Crédits',
                dal: 'Du',
                dalAlle: 'Du {0} à {1}',
                dalleAlle: 'De {0} à {1}',
                data: 'Date',
                dataSvolgimento: 'Date d’exécution',
                datiSalvati: 'Données sauvegardées',
                descrizione: 'Nom court',
                dettaglio: 'Détail',
                domani: 'Demain',
                durata: 'Durée',
                e: 'et',
                elencoMovimenti: {
                    tipo: {
                        abbSosta: 'Achat abonnement',
                        ricarica: 'Recharger',
                        sosta: 'Stationnement',
                        utilizzoCredito: 'Utilisation crédit',
                    },
                },
                elimina: 'éliminer',
                emesso: 'Émis',
                emptyList: 'Aucun élément présent',
                errore: 'Attention',
                erroreCaricamento:
                    'Une erreur s’est produite. Impossible de charger les données, veuillez réessayer plus tard',
                erroreComunicazioneServer: 'Erreur de communication avec le serveur',
                erroreConnessione: 'Une erreur s’est produite. Vérifiez la connexion réseau et réessayez',
                erroreConnessioneServer: 'Impossible de se connecter au serveur',
                erroreDownloadTitoli:
                    'Une erreur s’est produite pendant le téléchargement des titres. Veuillez réessayer plus tard.',
                erroreFormatoQrCode: 'Format code QR erroné',
                errorePagamento:
                    "Une erreur s'est produite pendant le paiement. Veuillez effectuer de nouveau l'achat.",
                erroreSalvataggio:
                    'Une erreur s’est produite. Impossible de sauvegarder les modifications, veuillez réessayer plus tard.',
                erroreScansioneQrCode: 'Une erreur s’est produite pendant le scannage du code QR.',
                erroreSconosciuto: 'Une erreur s’est produite',
                eventi: 'Événements',
                evviva: 'Youpi !',
                fa: 'il y a {0}',
                filters: 'Filtres',
                filtra: 'Filtrer',
                filtri: 'filtres',
                filtro: 'filtre',
                finoA: "Jusqu'à",
                finoATuttoIl: 'Jusqu’à l’entièreté du',
                finoAl: "jusqu'au",
                giorni: 'jours',
                giornoAlle: '{0} à {1}',
                googlePlay: {
                    legal: 'Google Play et le logo de Google Play sont des marques de Google LLC.',
                },
                home: 'Accueil',
                ieri: 'Hier',
                ilDalleAlle: 'Le {0} de {1} à {2}',
                illimitato: 'Illimité',
                importo: 'Montant',
                importoTotale: 'Montant total',
                impossibileEseguireOperazione: 'Impossible d’effectuer l’opération',
                impossibileVisualizzareQrCode: 'Impossible d’afficher le code QR',
                impostazioni: 'Configurations',
                indietro: 'Retour',
                indirizzo: 'Adresse',
                indirizzoArrivo: "Adresse d'arrivée",
                indirizzoPartenza: 'Adresse de départ',
                inevidenza: 'En évidence',
                info: 'Informations',
                infoAbbreviato: 'Infos',
                infoBiglietto: '',
                infoNonDisponibili: 'De plus amples informations ne sont pas disponibles',
                infoTraghetto: 'Infos ferry :',
                infoVeicolo: 'Infos véhicule :',
                ingrandisci: 'Agrandir',
                inizia: 'Commencer',
                inizio: 'Début',
                inserisciCodicePromo: 'Saisissez le code',
                intornoA: 'Aux alentours de',
                inviaRisposta: 'Envoyer la réponse',
                io: 'Moi',
                itinerario: 'Itinéraire',
                leggi: 'Lire',
                leggiTutto: 'Lire tout...',
                liberi: 'Libres',
                libero: 'Libre',
                lingua: 'Langue',
                link: 'lien',
                loadMore: 'Charger autres...',
                longTermParkingPanel: {
                    finoA: "Jusqu'à",
                    prenotazioneDal: 'Réservation à partir de',
                },
                luoghi: 'Lieux',
                mappa: 'Carte',
                mesi: 'mois',
                mezzo: 'Moyen de transport',
                mieiTitoli: 'Mes titres',
                minuti: 'Minutes',
                minutiLower: 'minutes',
                minutiShort: 'min',
                mobilita: 'Mobilité',
                modalita: 'Modes',
                modifica: 'Modifier',
                mostraTutti: 'Tout montrer',
                mostraTutto: 'Tout montrer',
                movimenti: 'Mouvements',
                msgAtacLockedOutUntil:
                    'Pour des raisons de sécurité liées à la migration récente, la gestion de vos titres ATAC est momentanément suspendue ; vous pourrez retourner et utiliser les titres à {1}',
                nascondi: 'Cacher...',
                nessun: 'Aucun',
                nessunDettaglioTrovato: 'Aucun détail trouvé',
                nessuno: 'Aucun',
                newsNotifiche: 'Nouveautés et notifications',
                newsNotificheUnread: '{0} Nouveautés et notifications',
                nfcSpentoDesc: 'Activez-le à partir des configurations du téléphone pour valider le titre de voyage',
                nfcSpentoWarning: 'NFC désactivé sur votre dispositif.',
                no: 'Non',
                noCameraPermission: "Vous n'avez pas les autorisations pour accéder à la caméra.",
                noRicerchePreferite: 'Il n’y a pas de recherche favorite',
                noRicercheRecenti: 'Il n’y a pas de recherche récente',
                noRisultati: 'Il n’y a pas de résultat pour cette recherche.',
                noRisultatiRicerca: 'Il n’y a pas de résultat pour la recherche.',
                noRisultatiVisibili: 'Il n’y a pas de résultats visibles.',
                nome: 'Prénom',
                nomeCompleto: 'Prénom et nom',
                nonAcquistabile: 'Pas disponible',
                nonAttiva: 'Pas active',
                nonConfermata: 'Pas confirmé',
                nonOra: 'Pas maintenant',
                notifica: 'Notification',
                numCartafreccia: 'N° Cartafreccia',
                nuova: 'Nouvelle',
                nuovaAttivazione: 'Nouvelle activation',
                obbligatorio: '(obligatoire)',
                oggi: 'Aujourd’hui',
                ok: 'Ok',
                operazioneEseguita: 'Opération effectuée',
                operazioneFallita: 'Opération échouée',
                opzioni: 'options',
                ora: 'Maintenant',
                oraDelGiorno: "<span class='bold'>{0}</span> du {1}",
                orariEfermate: 'Horaires et arrêts',
                orario: 'Maintenant',
                ore: 'heures',
                ottimo: 'Parfait',
                paga: 'Payer',
                parcheggiNavette: 'Parkings avec navettes',
                parcheggia: 'Stationnez',
                partenza: 'Départ',
                partners: 'Partenaires',
                passeggeri: 'Passagers',
                passeggero: 'Passager',
                plusAutoricarica: {
                    labelCartaDiCreditoNecessaria: 'Il faut une carte de crédit mémorisée',
                    labelMemorizza: 'Mémoriser',
                    labelRicaricaAutomatica: 'Configurer recharge automatique',
                    labelRicaricaAutomaticaAttiva: 'Recharge automatique active',
                    labelRicaricaAutomaticaNonDisponibile: 'Recharge automatique pas disponible',
                },
                plusCartaDiCredito: {
                    labelElimina: 'Éliminer',
                    labelProprietario: 'PROPRIÉTAIRE',
                    labelValidita: 'VALID<br/>THRU',
                },
                posti: 'Places',
                posto: 'Place',
                preferite: 'Favorites',
                preferiti: 'Favoris',
                prefissoData: 'le',
                prezzo: 'Prix',
                primaAttivazione: 'Première validation',
                procedi: 'Continuer',
                prodotti: 'Produits',
                promoOK: 'Promotion attribuée',
                prosegui: 'Continuer',
                qrCodeFermata: 'Code QR arrêt',
                quando: 'Quand',
                quantita: 'Quantité',
                raggiungici: 'Rejoignez-nous',
                realtaAumentata: 'Réalité augmentée',
                recenti: 'Récents',
                refresh: 'Mettre à jour',
                reset: '',
                results: 'Résultats',
                ricarica: 'Recharger',
                ricerca: 'Recherche',
                riceviAssistenza: "Pour de l'assistance, visitez la page :",
                rifiuta: 'Refuser',
                rifiutata: 'Refusé',
                rimuoviFiltri: 'Éliminer les filtres',
                riprova: 'Réessayez',
                risultatiPer: 'Résultats pour ',
                rivendite: 'Revendeurs et billetteries',
                salta: 'Sauter le passage',
                salva: 'Sauvegarder',
                salvaNeiPreferiti: 'Sauvegarder dans les favoris',
                salvaProcedi: 'Sauvegarder et continuer...',
                salve: 'Bonjour',
                scadenza: 'Expiration : ',
                scanQrCode: 'Scanner le code QR',
                scegliRitorno: 'Choisissez le retour',
                scegliTipologia: 'Choisissez un type pour filtrer',
                secureCode: 'Secure Code Mobile',
                secureCodeMyCicero: 'myCicero Secure Code',
                secureCodeRecover:
                    "N’étant pas récupérable, si vous l'avez perdu, vous devez éliminer et enregistrer de nouveau votre carte de crédit.",
                seiSicuro: 'En êtes-vous sûr ?',
                seleziona: 'Sélectionner',
                selezionaMemorizza: 'Sélectionnez et mémorisez le choix',
                selezionaPosizioneMappa: 'Sélectionner sur la carte',
                sempre: 'Toujours',
                servizi: 'Services',
                serviziAggiuntivi: 'Services supplémentaires :',
                share: 'Partagez',
                sharing: {
                    header: 'myCicero vous plaît-il ?',
                    provaMyCicero: 'Essayez myCicero !',
                    sharingMessage:
                        'Si vous utilisez les moyens de transport publics ou si vous souhaitez un système intelligent, rapide et économique pour payer le stationnement de façon pratique à partir de l’application, vous devriez essayer myCicero ! myCicero est la seule application qui vous permet de laisser la voiture et de vous déplacer avec les moyens de transport publics, en vous accompagnant lors de chaque phase du voyage. Une application pour de nombreux services.  - Ne payez que les minutes de stationnement effectives et achetez les autorisations pour les ZTL.  - Solutions de voyage intégrées aux liaisons locales et aux tickets.  - Lignes locales et nationales avec achat de tickets et d’abonnements.  - Horaires et tickets en un clic, approchez le smartphone aux tourniquets et entrez. ',
                    shortText: 'Partagez l’application avec vos amis !',
                    text: 'myCicero vous plaît-il ? Partagez',
                },
                socialMedia: 'Média social',
                soloAndata: 'Aller simple',
                sosta: 'Stationnement',
                spese: 'Frais',
                sulista: 'Liste',
                sumappa: 'Carte',
                targa: "Numéro de plaque d'immatriculation",
                tariffa: 'Tarif',
                telefono: 'Numéro de téléphone',
                tempoScaduto: 'Durée expirée',
                terminaApp: 'Fermer l’application',
                termsCondition: 'J’ai lu les conditions d’utilisation',
                timeoutPagamentoBigliettoTrasportoMessage:
                    "L’élaboration prend plus de temps que prévu. Avant de réessayer, attendez quelques secondes et vérifiez si le titre est téléchargé dans la section 'Mes titres' ou si vous recevez la confirmation d’achat par e-mail.",
                timeoutPagamentoMessage:
                    'L’élaboration prend plus de temps que prévu. Avant de réessayer, attendez quelques secondes et vérifiez si vous recevez la confirmation d’achat par e-mail.',
                timeoutPagamentoTitle: 'La connexion a expiré',
                tipo: 'Type :',
                tipologia: 'Type',
                tornaAllaHome: "Retour à la page d'accueil",
                tornaIndietro: 'Retour',
                totale: 'Total',
                tours: 'Tour',
                tra: 'dans {0}',
                trasporto: 'Transport',
                tuttaLaSettimana: 'Toute la semaine',
                tutteTipologie: 'Tous les types',
                tutti: 'Tous',
                utente: 'Utilisateur',
                utenti: 'Utilisateurs',
                utilizzabileIl: 'Utilisable le :',
                utilizzoTitoliAtac: 'J’utilise des titres ATAC',
                vaiAlTitolo: 'Aller au titre',
                vaiAllaPagina: 'Aller à la page',
                valida: 'VALIDER',
                validoDal: 'Valable à partir de',
                validoFinoAl: 'Valable jusqu’à',
                validoFinoAlle: 'Valable jusqu’à',
                validoIlGiorno: 'Valable la journée',
                validoTra: 'Valable dans',
                verifico: 'Je vérifie...',
                verifying: 'Je suis en train de vérifier ...',
                version: 'Version',
                vettore: 'Transporteur',
                viaggi: 'Voyages',
                viaggio: 'Voyage',
                visitaIlSito: 'visitez le site',
                yes: 'Oui',
                zonaNonCoperta: 'Vous vous trouvez dans une zone pas couverte par le service.',
            },
            credito: {
                aci: {
                    descrRedirect: 'En cliquant sur le bouton vous serez redirigé sur la page de paiement ACI.',
                    descrizione: 'Payez avec ACI pay',
                },
                acquistoConBorsellino: 'Achetez en utilisant le crédit',
                acquistoConBorsellinoMyCicero: 'Achetez en utilisant le crédit myCicero',
                acquistoConBorsellinoTrasporto: 'Achetez en utilisant le crédit Transport public',
                acquistoSisalAbbSosta:
                    "Dès que vous aurez complété l'achat vous trouverez l'abonnement dans la section « Stationnement et ZTL - Avantages/ Abonnements ».",
                acquistoSisalRicaricaBorsellino:
                    'Dès que vous aurez complété l’achat, le crédit du porte-monnaie électronique sera mis à jour.',
                alertConnessioneCadutaAcquistoAbb:
                    "Une déconnexion s’est produite et rien ne garantit que l'opération d'achat ait réussi. Vérifiez si l'abonnement que vous venez d’acheter se trouve dans la section « Mes abonnements », dans le cas contraire effectuez de nouveau l’achat.",
                attivaBorsellinoTrasportoPubblico: 'Activez le porte-monnaie électronique Transport public',
                bemoov: {
                    descrRedirect:
                        'Vous serez redirigé à une page externe où vous devrez saisir le code OTP et le CV2 de la carte de crédit associée.',
                    descrUsoNumeroTelefono: 'Vous recevez un code OTP de confirmation par SMS au numéro précisé',
                    inserisciNumeroTelefono: 'Saisissez le numéro de téléphone associé au compte',
                },
                clearCodice: 'Éliminer le code',
                controllaCodice: 'Contrôler le code',
                credito: 'Crédit',
                creditoBorsellinoInsufficiente:
                    'Le crédit résiduel sur le porte-monnaie électronique n’est pas suffisant pour effectuer cet achat.',
                creditoInsufficiente: 'Crédit insuffisant',
                creditoResiduo: 'Crédit résiduel',
                creditoSosta: 'Crédit stationnement',
                datiPagamento: 'Données de paiement',
                dettaglioAcquisto: "Détail des activités d'achat",
                dettaglioAttivitaRicarica: 'Détail des activités de recharge de crédit',
                effettuaPagamento: 'Effectuer le paiement',
                effettuaPagamentoPer: 'Effectuer le paiement pour',
                erroreCaricamento:
                    'Une erreur s’est produite. Impossible de charger les données, veuillez réessayer plus tard',
                erroreSalvataggio:
                    'Une erreur s’est produite. Impossible de sauvegarder les modifications, veuillez réessayer plus tard',
                gestionePagamento: 'Gestion du paiement',
                importoAcquisto: "Montant de l'achat",
                infoAcquistiSmartphoneHTML:
                    'Pour les achats à partir d’un smartphone, enregistrez une carte de crédit par le biais de laquelle vous pourrez, en toute sécurité, acheter des abonnements et recharger votre crédit de stationnement. <a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">Enregistrez-en une en quelques clics</a>.',
                infoAttivaBorsellinoHTML:
                    'Il est possible d’utiliser le crédit pré-chargé sur un porte-monnaie électronique virtuel. Pour l\'activer il suffit d’accéder à l’<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">espace réservé</a>.',
                infoConfermaPagamento:
                    'En appuyant sur le bouton, vous effectuerez la transaction en prélevant le montant de la carte de crédit spécifiée.',
                infoConfermaPagamentoBorsellino:
                    'En appuyant sur le bouton, vous effectuerez la transaction en prélevant le montant du crédit',
                infoConfermaPagamentoBorsellinoMyCicero:
                    'En appuyant sur le bouton, vous effectuerez la transaction en prélevant le montant du crédit myCicero',
                infoConfermaPagamentoBorsellinoTemplate:
                    'En appuyant sur le bouton, vous effectuerez la transaction en prélevant le montant du porte-monnaie électronique {0} ',
                infoConfermaPagamentoRedirect: 'Vous serez redirigé à une page externe',
                infoRicaricaBorsellinoHTML:
                    'Vous pouvez recharger le porte-monnaie électronique directement depuis votre téléphone (<a data-bind="tap: gotoRicarica">cliquez ici</a>) ou vous pouvez accéder, par l’intermédiaire d’un PC, à l’<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">espace réservé</a>.',
                infoRicaricaBorsellinoShortHTML:
                    'Vous pouvez recharger le porte-monnaie électronique, par l’intermédiaire d’un PC, dans l’<a href="#" onclick="javascript:openLinkOnBrowser(getLinkProfilo(),true)">espace réservé</a>.',
                inserisciCodiceCouponRicarica: 'Saisissez le code coupon',
                inserisciDatiCarta: 'Saisissez les détails de la carte de crédit',
                inserisciSecureCode: 'Saisissez le Secure Code Mobile',
                inserisciSecureCodeMyCicero: 'Saisissez le myCicero Secure Code',
                metodoPagamento: 'Moyen de paiement',
                noCreditCard: 'Acheter en utilisant une carte de crédit',
                nonRicordi: 'Vous ne vous en souvenez pas ?',
                pagaCon: 'Payer avec ',
                payCreditOneShot: 'Effectuez le paiement en utilisant une carte de crédit sans l’enregistrer',
                paypal: {
                    info1: 'Payez automatiquement par l’intermédiaire de votre compte PayPal.',
                    info2:
                        'En cliquant sur le bouton, vous effectuerez immédiatement le paiement par l’intermédiaire de PayPal.',
                    titolo: 'PayPal<sup>TM</sup>',
                },
                paypalexp: {
                    descrRedirect: 'En cliquant sur le bouton vous serez redirigé sur la page de paiement PayPal.',
                    descrizione: 'Paiement paypal express checkout',
                },
                paypalric: {
                    descrRedirect: 'En cliquant sur le bouton, vous effectuerez immédiatement le paiement par PayPal.',
                    descrizione: 'Payez avec votre compte paypal',
                },
                prenotazioneSisal: 'Vous avez une réservation pour <br/> &euro;&nbsp;{0}',
                prenotazioneSisalAbb: 'Vous avez une réservation pour <br/> un abonnement de &euro;&nbsp;{0}',
                prenotazioneSisalRic: 'Vous avez une réservation pour <br/> une recharge de &euro;&nbsp;{0}',
                promoTitoli: 'Promotion titres',
                redirectToCCInfo:
                    'Vous serez redirigé vers une page externe sur laquelle vous devrez saisir les données de la carte de crédit.',
                registraCartaCredito: 'Nouvelle carte de crédit...',
                ricarica: 'Recharger',
                ricaricaBorsellino: 'Recharger le porte-monnaie électronique',
                ricaricaCoupon: 'Vous possédez un coupon ?',
                ricaricaCouponNonValido: "Le code n'est pas valable ou est expiré.",
                ricaricaCouponUsaCodice: 'Effectuer la recharge...',
                ricaricaCouponVerificaCodiceBtn: 'Vérifier le code',
                ricaricaCredito: 'Recharger le crédit',
                ricaricaSuccess: 'Recharge effectuée correctement',
                richiediPagamento: 'Demander paiement',
                richiediPagamentoPer: 'Demander paiement pour ',
                saldo: 'Solde',
                saldoAttuale: 'Solde crédit actuel',
                saldoFuturo: 'Solde crédit',
                satispay: {
                    bonus:
                        '5,00 &euro; de bonus si vous vous <u onclick="openLinkOnBrowser(\'https://www.satispay.com/promo/mycicero\')">enregistrez</u> au service !',
                    completaPagamento: "Terminer le paiement sur l'application Satispay",
                    confermaCompletato: 'Dès que nous recevrons la confirmation, l’achat sera terminé',
                    inserisciNumero: 'Saisissez le numéro de téléphone associé au compte Satispay',
                    risultatoAcquisto: 'Dès que nous recevrons la confirmation de Satispay, l’achat sera terminé.',
                    titolo: 'Satispay',
                    verraiRediretto: 'Vous pourrez terminer le paiement dans l’application <strong>Satispay</strong>',
                },
                scegliCartaCredito: 'Choisissez une carte de crédit parmi celles associées',
                scegliImporto: 'Choisissez le montant avec lequel recharger votre crédit',
                scegliMetodoPagamento: 'Choisissez une méthode de paiement',
                screenSaved: 'En outre, je viens d’enregistrer une image dans votre galerie photo.',
                secureCodeErrato: 'Secure Code erroné',
                secureCodeReminder:
                    'Le Secure Code Mobile est votre code personnel de 5 caractères numériques que vous avez saisis au moment de l’enregistrement de la carte de crédit.',
                secureCodeReminderMyCicero:
                    'Le myCicero Secure Code est votre code personnel de 5 caractères numériques que vous avez saisis au moment de l’enregistrement de la carte de crédit.',
                sisalCommissioni1: 'Le coût de l’opération sera augmenté d’une',
                sisalCommissioni2: 'commission SisalPay',
                sisalCommissioni3: 'qui dépend du montant du paiement.',
                sisalGeneraCod: 'Créer code pour ',
                sisalInfoAcquisto:
                    'Pour acheter la recharge, rendez-vous dans un des <u>Points SisalPay</u> autorisés et communiquez les paramètres suivants...',
                sisalInfoAcquisto2:
                    'Rejoignez un <span class="underline primary">Point SisalPay</span>, demandez ensuite au commerçant d’effectuer un paiement sur autobus.it - myCicero et communiquez le code PNR de réservation suivant.',
                sisalInfoAcquisto3:
                    'Rejoignez un point SisalPay et demandez d’effectuer un paiement sur « Autobus.it/myCicero » en communiquant le code PNR que vous trouvez ci-dessus.',
                sisalInfoMaggiorazioneHtml:
                    'le coût de l’opération sera augmenté de la commission appliquée par SisalPay, proportionnelle à la valeur de paiement. Pour de plus amples informations, suivez <span class="underline primary">ce lien</span>.',
                sisalInviatoPerEmail: 'Ce code vous a été envoyé par e-mail à l’adresse ',
                sisalMostraRivendite: 'Montrer liste Points SisalPay',
                sisalPay: 'SisalPay',
                sisalPayDescription:
                    'Après le clic, le PNR à communiquer au Point de vente SisalPay sera créé, par le biais de celui-ci vous pourrez effectuer le paiement.',
                sisalPuntiVendita: 'Points SisalPay',
                sisalRaggiungi:
                    'Pour effectuer le paiement, rejoignez un Point de vente SisalPay, demandez ensuite au commerçant d’effectuer un paiement sur autobus.it - myCicero et communiquez le code PNR qui sera créé',
                sisalbill: {
                    completaPagamento: 'Transaction effectuée',
                    completaPagamentoFallita: 'Transaction échouée',
                    confermaCompletato: '',
                    confermaCompletatoAbbonamentoSosta:
                        'Une fois l’achat terminé, pour télécharger le titre, entrez dans la section « Avantages » et mettez la liste à jour',
                    confermaCompletatoBorsellino: 'Le crédit du porte-monnaie électronique a été mis à jour',
                    confermaCompletatoFallita: "Une erreur s'est produite pendant le paiement",
                    confermaCompletatoTitoli: 'Vous pouvez trouver le ticket acheté dans la section « mes titres »',
                    risultatoAcquisto: '',
                    risultatoAcquistoBorsellino:
                        'Dès que nous recevrons la confirmation de Sisal Bill, l’achat sera terminé.',
                },
                staiAcquistando: 'Vous êtes sur le point d’acheter :',
                staiPagando: 'Vous êtes sur le point de payer :',
                staiPrenotando: 'Vous êtes sur le point de réserver le paiement de :',
                stpay: {
                    descr: '<p>Satispay est un système de paiement indépendant de cartes de crédit et de débit.</p>',
                    iscrivitiSubito: 'Inscrivez-vous immédiatement au service et recevez 5 € de bonus',
                },
                usaIlCredito: {
                    info1: 'Rechargez votre crédit et utilisez-le pour payer tous les services myCicero.',
                    info1Branded: 'Rechargez votre crédit et utilisez-le pour payer tous les services.',
                    info2:
                        "Vous évitez ainsi de saisir chaque fois les données de votre carte et vous n'avez aucune commission supplémentaire. Nombreux sont les moyens de paiement autorisés.",
                    info2Branded:
                        "Vous évitez ainsi de saisir chaque fois les données de votre carte et vous n'avez aucune commission supplémentaire.",
                    ricaricaCredito: 'Recharger le crédit',
                    titolo: 'Pourquoi cela vaut mieux',
                },
            },
            dettaglioSinteticoFermata: {
                direzione: '{0}',
                distanzaDaTe: '{0} de vous',
            },
            dettaglioSisnteticoBus: {
                direzione: 'Direction : {0}',
                distanzaDaTe: 'Arrêt à {0} de vous',
            },
            difonzo: {
                acquistaTitoli: 'Acheter des titres',
                fermateEdOrari: 'Arrêts et horaires',
                mieiTitoli: 'Mes titres',
                soluzioniDiViaggio: 'Solutions de voyage',
            },
            dolomiti: {
                AcquistaBiglietti: 'Acheter des tickets',
                CalcolaPercorso: 'Calcul du parcours',
                Eventi: 'Événements',
                FermateOrari: 'Arrêts et horaires',
                Luoghi: 'Lieux',
                MieiTitoli: 'Mes titres',
                ServiziTuristici: 'Services touristiques',
            },
            eav: {
                AcquistaBiglietti: '',
                CalcolaPercorsoHTML: '',
                CampaniaExpress: 'Campania Express',
                CampaniaExpressHTML: '',
                CumaExpress: 'Cuma Express',
                CumaExpressHTML: '',
                FermateOrari: 'Arrêts et horaires',
                FermateOrariHTML: '',
                MieiTitoli: 'Mes titres',
                bigliettiBus: 'Tickets de bus',
                bigliettiFunivia: 'Tickets de téléphérique',
                bigliettiTreno: 'Tickets de train',
                fermate: 'Arrêts',
            },
            elbasharing: {
                bachecaTab: {
                    conducenti: 'Conducteurs',
                    passeggeri: 'Passagers',
                    taxi: 'Taxi',
                },
                common: {
                    cercaUnPassaggio: 'Chercher une solution de voyage',
                    filtraLabel: 'Filtrer',
                    filtriAttivi: 'Filtres actifs',
                    filtroAttivo: 'Filtre actif',
                    infomobilita: 'Info-mobilité',
                    nuovaRicerca: 'Nouvelle recherche',
                    trovaSoluzioneViaggio: 'Trouvez le voyage le plus indiqué pour vous',
                },
                homepage: {
                    bacheca: "Panneau d'affichage",
                    consultaOfferteRichieste: 'Consultez les offres et les demandes actives',
                    controllaViaggi: 'Contrôlez vos voyages',
                    iMieiViaggi: 'Mes voyages',
                    offriUnPassaggio: 'Offrez un accompagnement',
                    partecipaOpinione: 'Participez avec votre opinion',
                    questionari: 'Questionnaires',
                    rendiDisponibileAuto: 'Rendez votre voiture disponible',
                    servizi: 'Services',
                    viviIlTerritorio: 'Vivez le territoire',
                },
                review: {
                    reviewLabel: "Avis d'autres voyageurs :",
                },
                soluzioniDiViaggio: {
                    posizioniNonValideOffriPassaggio:
                        'Il est possible d’offrir un accompagnement seulement avec départ et arrivée sur le territoire de l’île d’Elbe.',
                    posizioniNonValideRichiediPassaggio:
                        'Il est possible de demander un accompagnement seulement avec départ et arrivée sur le territoire de l’île d’Elbe.',
                },
                tabelloneOrari: {
                    intornoAllIndirizzo: 'Près de l’adresse',
                },
                taxiCondivisoStatus: {
                    taxiStatus: 'Confirmé',
                },
                vetrinaVettori: {
                    description:
                        'Pour de plus amples informations sur les horaires officiels et sur l’achat de tickets de voyage, il est possible de consulter les pages Internet des transporteurs locaux, CTT Nord et Tiemme',
                },
            },
            event: {
                allCategories: 'Toutes les catégories',
                arrivi: 'Arrivées',
                caricaAltriEventi: 'Charger d’autres événements',
                definisciRaggio: 'Définissez le rayon de recherche dans les alentours de : ',
                dettaglio: 'Détail événement',
                elenco: 'Liste',
                entroIl: 'Événements avant',
                eventi: 'Événements',
                eventiCorrelati: 'Événements associés',
                finePrevista: 'Fin prévue',
                inPartenzaEntro: 'Tour au départ avant',
                info: 'Infos',
                infoContatti: {
                    cellulare: 'Numéro de portable',
                    email: 'E-mail',
                    facebook: 'Facebook',
                    organizzatoDa: 'Organisé par',
                    sitoWeb: 'Internet',
                    social: 'Réseaux sociaux',
                    telefono: 'Numéro de téléphone',
                    vaiAlSito: 'Aller sur le site',
                },
                ingresso: 'Entrée',
                inizio: 'Début',
                itinerariCorrelati: 'Itinéraires qui passent par ici',
                itinerario: 'Itinéraire',
                mappa: 'Carte',
                noEventi: 'Aucun événement au programme',
                nomeEvent: 'Nom de l’événement',
                ospiti: 'Hôtes importants',
                partenze: 'Départs',
                prossimiEventi: 'Prochains événements',
                prossimiEventiPoi: 'Prochains événements dans ce lieu',
                quando: 'Quand',
                raggioRicerca: 'Rayon de recherche',
                searchAllCat: 'Chercher dans toutes les catégories',
                selezionaEvento: 'Sélectionner un événement',
                serviziUtili: 'Services utiles',
                specialitaCorrelate: 'Produits associés',
                tab: {
                    allegati: 'Pièces jointes',
                    info: 'Infos',
                    mappa: 'Carte',
                },
                vetrina: 'Vitrine',
                warnTariffe:
                    'Le prix indiqué fait référence au tarif de base. Vérifier à l’intérieur pour la liste complète.',
                when: {
                    '30days': {
                        long: 'Les 30 prochains jours',
                        short: '30 jours',
                    },
                    '7days': {
                        long: 'Les 7 prochains jours',
                        short: '7 jours',
                    },
                    specifica: 'Jour spécifique...',
                    today: {
                        long: 'Aujourd’hui',
                        short: 'Aujourd’hui',
                    },
                    tomorrow: {
                        long: 'Demain',
                        short: 'Demain',
                    },
                },
            },
            flussoPagamento: {
                acquistoAbbSosta:
                    "Trouvez l'abonnement acheté dans la section « Stationnement et ZTL - Avantages / Abonnements ».",
                acquistoBigliettoTrasporto: 'Trouvez le titre acheté dans la section « Transport ».',
                acquistoRicaricaBorsellino: 'Le crédit du porte-monnaie électronique a été mis à jour.',
                acquistoSatispayAbbSosta:
                    "Dès que nous recevrons la confirmation de Satispay, vous trouverez l'abonnement dans la section « Stationnement et ZTL - Avantages/ Abonnements ».",
                acquistoSatispayBigliettoTrasporto:
                    "Dès que nous recevrons la confirmation de Satispay, vous trouverez l'abonnement dans la section « Transport ».",
                acquistoSatispayRicaricaBorsellino:
                    'Dès que nous aurons reçu la confirmation de Satispay, le crédit du porte-monnaie électronique sera mis à jour.',
                attesaConfermaSatispay: 'En attente de confirmation de Satispay',
                attesaTransazioneSatispay: 'Certaines transactions peuvent prendre plus de temps que prévu.',
                confermaPinCode: 'Confirmer code PIN',
                creditoMyCicero: 'Crédit myCicero',
                creditoPrecedente: 'Crédit précédent',
                errorePagamento: "Une erreur s'est produite pendant le paiement.",
                importoAcquisto: "Montant de l'achat",
                messaggioTransazioneFallita:
                    "Une erreur s’est produite et nous n'avons pas réussi à terminer l'activité.",
                pagamentoSanzioneEseguito:
                    'D’ici peu vous recevrez un e-mail avec le reçu du paiement effectué. Vous pourrez vérifier la transaction dans la liste des mouvements de votre profil utilisateur.',
                pagamentoSkidataEseguito:
                    'Rendez-vous à la sortie du parking et insérez le ticket dans la colonne pour soulever la barre.',
                pinErrato: 'Code PIN erroné',
                richiestaAcquistoSatispayAbbSosta:
                    "Dès que vous aurez complété l'achat vous trouverez l'abonnement dans la section « Stationnement et ZTL - Avantages/ Abonnements ».",
                richiestaAcquistoSatispayBigliettoTrasporto:
                    "Dès que vous aurez terminé l'achat vous trouverez l'abonnement dans la section « Transport ».",
                richiestaAcquistoSatispayRicaricaBorsellino:
                    'Dès que vous aurez complété l’achat, le crédit du porte-monnaie électronique sera mis à jour.',
                saldoAttuale: 'Solde actuel',
                scegliAltriMetodi: 'Ou choisissez',
                scegliCarta: 'Choisissez la carte',
                scorriPerPagare: 'Défilez pour payer',
                transazioneAnnullata: 'Transaction annulée par l’utilisateur.',
                transazioneEffettuata: 'Transaction effectuée.',
                transazioneFallita: 'Transaction échouée.',
                usaAltraCarta: 'Payez avec une autre carte...',
                verificaTransazioneSatispay: 'Vérifier la transaction',
            },
            flybus: {
                gtSearch: {
                    soluzioniDiViaggio: 'Solutions</br>de voyage',
                },
                homepage: {
                    elencoMovimenti: 'Liste</br>des mouvements',
                    myTickets: 'Mes</br>tickets',
                    ricaricaCredito: 'Recharger</br>crédit',
                    soluzioniDiViaggio: 'Solutions</br>de voyage',
                    subtitle:
                        '<span class="bold">Achetez votre voyage</span><span style="font-weight: 200"></br>en autobus</br>pour les Dolomites</span>',
                },
            },
            geocode: {
                fail: 'Détection position pas réussie',
                indirizziTrovati: 'Adresses trouvées',
                istruzioniChangePositionPageHtml:
                    'Saisissez une adresse, puis cliquez sur <div class="ui-icon-plus-submit" style="width:16px;height:15px;display:inline-block;"></div> pour commencer la recherche',
                lookForPos: 'Détection position en cours...',
                noLocalitaTrovata: 'Aucune localité identifiée',
                nodata: {
                    empty: 'aucune localité identifiée',
                },
                posNotAvailable: 'Position pas disponible.',
                slowGeocoder: 'Le geocoder prend trop de temps pour répondre',
            },
            gps: {
                abilitaGpsHtml:
                    'les configurations de la confidentialité empêchent l\'accès à la position actuelle : vous pouvez les modifier à tout moment à partir du panneau</br><a href="#position-page">options > gérer position</a>',
                addressNotFound: 'Adresse pas trouvée.',
                auto: 'GPS',
                buona: 'Bonne',
                cambiaIndirizzo: 'Changer adresse',
                cambiaPosizione: 'Changer position',
                discreta: 'Discrète',
                eccellente: 'Excellente',
                enable: 'activer la détection position par GPS',
                errors: {
                    '0': 'Service de localisation pas supportée',
                    '1': "Impossible d'accéder aux services de localisation",
                    '2': 'Position actuelle pas détectée',
                    '3': 'Position actuelle pas détectée',
                    '4': 'Opération éliminée',
                    '410': 'Erreur http',
                    authorizationDenied: 'Vous n’avez pas fourni les autorisations pour la localisation',
                    genericInObliteration:
                        'Position pas disponible, vérifiez que le service de localisation soit actif.',
                    hardwareDisabled: 'Localisation GPS désactivée.',
                    positionUnavailable: 'Impossible de récupérer la position actuelle.',
                },
                info:
                    "les informations relatives à la position sont utilisées exclusivement pour fournir un service précis et fiable : la protection de la confidentialité est extrêmement importante pour PluService, par conséquent, votre position ne sera jamais utilisée sans votre consentement ; de plus, PluService n'enregistre en aucune façon votre position sur ses serveurs.",
                infoAttivaGps:
                    "Pour fonctionner au mieux, l'application a besoin que le GPS et la détection de la position réseau soient actifs",
                infoAttivaGpsIphone:
                    "Pour un fonctionnement correct de myCicero, il est utile d'avoir la détection GPS active.",
                inserisciPosizione: 'saisissez l’adresse',
                manuale: 'manuel',
                miaPosizione: 'Ma position',
                noGps:
                    'Le GPS pourrait être éteint ou désactivé, ou vous pourriez vous trouver dans une zone sans signal.',
                nuovoIndirizzo: 'Nouvelle adresse',
                portamiQui: 'Amenez-moi ici',
                posAttuale: 'position actuelle',
                posNonDisponibile: 'Position pas disponible',
                posRilevata: 'Votre position détectée est',
                posizioneNonDefinita: 'Position actuelle pas définie',
                precisione: 'Précision',
                rilevaPosizione: 'détecter position',
                rilevamentoPosInCorso: 'Détection position...',
                scarsa: 'Faible',
                searching: 'Je localise...',
                segnaleDebole: 'signal GPS faible',
                tuaPosizione: 'Vous vous trouvez',
            },
            home: {
                all: 'Toutes',
                en: 'anglais',
                gps: 'à partir de GPS',
                it: 'italien',
                manual: 'adresse',
                manualdialog: {
                    header: 'adresse',
                    placeholder: 'saisissez l’adresse',
                },
                optionsdialog: {
                    header: 'options',
                },
                search: 'chercher dans les alentours',
            },
            iccrea: {
                cambiaZona: 'Changer zone',
                homeTitle: 'CartaBCC Club<br />vous souhaite la bienvenue à <b>{0}</b>',
                hometitleNoPos: 'CartaBCC Club<br />vous souhaite la bienvenue',
                serviziTuttaItalia: 'Nos services sont actifs dans toutes l’Italie.',
                tutorial: {
                    subtitle1: 'Tous les services les plus utiles pour économiser du temps et de l’argent en un clic.',
                    subtitle2:
                        'Vous ne payez que les minutes effectives sans avoir besoin des colonnes pour le parking.',
                    subtitle3: 'Découvrez les réductions et les coupons dédiés dans les magasins dans vos environs.',
                    subtitle4:
                        "Achetez l'abonnement et les tickets de train ou du bus par le biais de l’application sans files d'attente.",
                    subtitle5:
                        "Vous pouvez directement accéder avec les données d’identification de CartaBCC, en effectuant l’identification à partir de l'application MyCartaBCC.",
                    subtitle6:
                        "Rechargez le porte-monnaie électronique à partir de l'application avec CartaBCC ou Satispay et payez tous les services sur le territoire avec un simple clic !",
                    title1: 'CartaBCC toujours à vos côtés !',
                    title2: 'Économisez sur le stationnement',
                    title3: 'La convenance du shopping avec CartaBCC !',
                    title4: 'Prendre un train ou un autobus n’a jamais été aussi simple !',
                    title5: "Il n'est pas nécessaire de s'enregistrer !",
                    title6: 'Rechargez votre crédit',
                },
            },
            inserimentoPin: {
                placeholder: '5 chiffres',
            },
            insiel: {
                centralinoUffici: 'Centrale Bureaux Villa Chiozza tél',
                infoPrezziBiglietti: 'Infos prix tickets',
                luoghi: 'Lieux et territoire',
                mobilitaRegione: 'Mobilité dans la région',
                progetto:
                    'Projet co-financé par l’Union Européenne avec le POR FESR 2007- 2013 - activité 3.2.b « Développement services informatiques avancés pour le système tourisme »',
                scopriEventi: 'Découvrez tous les événements',
            },
            isosta: {
                abb: {
                    abbonamenti: 'Avantages / Abonnements',
                    abbonamentiSubTitle: 'Journaliers et abonnements',
                    abbonamento: 'Avantage / Abonnement',
                    acquista: 'Acheter',
                    acquistoAbbonamenti: 'Achat',
                    attivi: 'Activées',
                    cambioTargaFail: 'Changement plaque d’immatriculation pas effectué',
                    cambioTargaSuccess: 'Changement plaque d’immatriculation effectué avec succès',
                    campoNonValido: 'Les champs mis en évidence en rouge ont une valeur pas valable',
                    campoObbligatorio: 'Les champs mis en évidence en rouge sont obligatoires',
                    caricaAbbonamentiErroreTesto: 'Erreur : Impossible de charger les abonnements',
                    caricaAbbonamentiErroreTitolo: 'Charger abonnements',
                    categoriaAbbonamento: 'Catégorie',
                    confermaAcquistoAbbSovrapposto: "Vous souhaitez quand-même continuer l'achat ?",
                    dataFineValidita: 'Jusqu’au :',
                    dataInizioValidita: 'Valide à partir de :',
                    datiAggiuntivi: 'Données supplémentaires :',
                    datiIncompleti:
                        "Données abonnement incomplètes. Essayez d’ouvrir de nouveau l’abonnement, ou contactez l'assistance si le problème persiste !",
                    erroreCambioTargaListaAbb:
                        "Changement de plaque d’immatriculation effectué, mais il n'est pas possible de récupérer les abonnements localement. Vous serez donc redirigé vers la page principale des abonnements.",
                    failAcquistoAbb: 'Achat abonnement échoué ! Veuillez contacter l’assistance',
                    infoTipologiaNonAcquistabileDaUtente:
                        "Votre utilisateur est dépourvu des autorisations nécessaires et des autorisations pour acheter ce type d'abonnement.",
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Une fois l’achat terminé, pour télécharger le titre, entrez dans la section « Avantages » et mettez la liste à jour',
                    noAbbInCorsoDiValidita: 'Aucun abonnement / avantage en cours de validité n’a été trouvé',
                    noAbbNonAttivi: 'Aucun abonnement / avantage pas encore actif n’a été trouvé',
                    noAbbScaduti: 'Aucun abonnement / avantage expiré n’a été trouvé',
                    noAgevolazioni: "Vous n'avez pas encore d'avantages ou d'abonnements.",
                    noAgevolazioniZtl: "Vous n'avez encore aucun titre ZTL.",
                    noZtlInCorsoDiValidita: 'Aucune autorisation en cours de validité n’a été trouvée',
                    noZtlNonAttivi: 'Aucune autorisation pas encore activée n’a été trouvée',
                    noZtlScaduti: 'Aucune autorisation expirée n’a été trouvée',
                    nonAcquistabile: 'Abonnement pas disponible',
                    nonAncoraAttivi: 'Pas actifs',
                    oraFineValidita: 'À :',
                    oraInizioValidita: 'À partir de :',
                    ore: ' heures ',
                    oreMeno: ' - heure ',
                    scaduti: 'Expirées',
                    scegliComuneAreaSosta: 'Sélectionnez la municipalité',
                    scegliTipoAbbonamento: 'Choisissez le type...',
                    scegliTitolo: 'Sélectionnez le titre',
                    scegliVeicolo: 'Choisissez le véhicule',
                    successAcquistoAbb: 'Achat terminé avec succès !',
                    tipoAbbonamento: 'Type',
                    tipologiaNonAcquistabileDaUtente: "Type d'abonnement pas disponible pour cet utilisateur.",
                    validitaAbbonamento: 'Validité',
                    warnAbbSovrapposto: 'Vous avez déjà quelques titres valables pendant la période indiquée :',
                },
                accettoCondizioniTerminiServizio: "J'accepte <action>les Conditions de service</action>",
                affinaRicerca: 'Essayez de saisir une adresse plus précise...',
                attivaServizio: 'Activer service',
                attivaServizioTesto: 'Pour stationner il est nécessaire de saisir les données d’un véhicule',
                attivazioneAccediPreferenzeAziendaHtml:
                    'Accédez avec un PC à l\'espace réservé sur <span class="underline" onclick="openLinkOnBrowser(\'http://www.mycicero.it\')">www.mycicero.it</span>, section données personnelles, puis remplissez les données nécessaires pour être enregistré comme entreprise/professionnel et recevoir la facture/le reçu.',
                attivazioneAccediPreferenzeAziendaTitle: 'Vous êtes une entreprise/un professionnel ?',
                attivazioneAccediPreferenzeHtml:
                    'Pour choisir comment payer, gérer vos préférences de stationnement ou demander une facture, entrez dans votre profil.',
                attivazioneAccediPreferenzeTitle: 'Gérez vos préférences',
                attivazioneCompletata: 'Vous avez activé le service « {0} »',
                attivazioneCompletataInfo: '',
                attivazioneCompletataInfo1: '<i><b class="underline">Rechargez votre crédit</b></i>',
                attivazioneCompletataInfo2:
                    '<i> et commencez à stationner en ne payant que les minutes effectives.</i>',
                attivazionePromemoriaHeader: 'N’oubliez pas de recharger le crédit de stationnement',
                attivazionePromemoriaText:
                    'Pour stationner il sera nécessaire de recharger votre crédit de stationnement',
                autoricarica: {
                    erroreCaricamento:
                        'Une erreur s’est produite. Impossible de charger les données, veuillez réessayer plus tard',
                    erroreSalvataggio:
                        'Une erreur s’est produite. Impossible de sauvegarder les modifications, veuillez réessayer plus tard',
                    infoAutoricarica:
                        'Le service permet de recharger automatiquement votre crédit quand il se trouve sous un seuil que vous avez configuré.',
                    labelAttiva: 'Activer recharge automatique',
                    labelCartaDiCreditoNecessaria:
                        'Pour utiliser ce service, il est nécessaire de mémoriser une carte de crédit.',
                    labelDisattiva: 'Désactiver recharge automatique',
                    labelProcedi: 'Continuer',
                    labelSaldoInferioreA: 'Quand le solde est inférieur à',
                    labelTaglioRicarica: 'Effectuez une recharge de',
                    titolo: 'Recharge automatique',
                },
                avvisoInizioSostaDomani:
                    'Si vous ne terminez ou ne prolongez pas le stationnement à l\'avance, celui-ci sera arrêté automatiquement <span class="bold">demain</span> à <span class="bold">{0}</span>',
                avvisoInizioSostaIl:
                    'Si vous ne terminez ou ne prolongez pas le stationnement à l\'avance, celui-ci sera arrêté automatiquement le <span class="bold">{0}</span> à <span class="bold">{1}</span>',
                avvisoInizioSostaOggi:
                    'Si vous ne terminez ou ne prolongez pas le stationnement à l\'avance, celui-ci sera arrêté automatiquement <span class="bold">aujourd’hui</span> à <span class="bold">{0}</span>',
                calendar: {
                    aggiungiPromemoria: 'Ajouter un rappel',
                    askAggiungiPromemoria:
                        'Vous souhaitez que votre smartphone vous rappelle l’expiration de la période de stationnement 15 minutes avant l’expiration ?',
                    nonAggiungere: 'Ne pas l’ajouter',
                    procedi: 'Continuer',
                    text:
                        "Un rappel sera ajouté à votre calendrier. Il vous avertira 15 minutes avant l'expiration du stationnement.",
                    title: 'Ajouter un rappel ?',
                },
                caricaAltrePromozioni: 'Charger d’autres promotions',
                cercaLocalita: 'Chercher localité',
                codiceStallo: 'Code place',
                codiceStalloPlaceholder: 'Saisissez le code de la place',
                condizioniServizio: 'Conditions du service',
                countdownPagamento: 'Vous avez {0} secondes pour continuer le paiement',
                daConfermareEntro: 'À confirmer avant',
                dettaglioPrenotazione: {
                    annulla: 'Annuler la réservation',
                    cognome: 'Nom',
                    confermaAnnulla: 'Êtes-vous certain de vouloir annuler la réservation ?',
                    cosaFare: 'Que dois-je faire ?',
                    datiAggiuntivi: 'Données supplémentaires',
                    email: 'E-mail',
                    erroreAnnulla: 'Impossible d’annuler la réservation',
                    importo: 'Montant',
                    importoSosta: 'Montant stationnement',
                    importoTotale: 'Total payé',
                    indirizzo: 'Adresse',
                    intestazioneInfoPrenotazione: 'Infos réservation',
                    messaggioInformativoSostaAttiva:
                        'Pour mettre fin au stationnement, rendez-vous au parking et demandez la sortie du véhicule. Seul le coût du stationnement en fonction de l’horaire d’entrée effective selon le tarif en vigueur vous sera débité.',
                    messaggioInformativoSostaPrenotata:
                        'Montrez la réservation au gestionnaire pour accéder au parking. En cas d’entrée avant l’horaire réservé ou de sortie outre 4 (quatre) heures le terme prévu, le prix sera augmenté en conséquence.',
                    modelloVeicolo: 'Modèle du véhicule',
                    nome: 'Prénom',
                    nonSpecificato: 'Pas spécifié',
                    numeroPasseggeri: 'Passagers',
                    numeroVolo: 'Numéro de vol',
                    provenienzaVolo: 'Provenance de vol',
                    serviziAggiuntivi: 'Services supplémentaires',
                    sitoWeb: 'Site Internet',
                    targa: "Plaque d'immatriculation",
                    telefono: 'Numéro de téléphone',
                    titolo: 'Réservation',
                },
                disambiguaDescrizione:
                    'Nous avons trouvé plusieurs zones de stationnement dans les alentours de votre position. Sélectionnez la zone dans laquelle vous vous trouvez, en consultant les panneaux verticaux ou le parcmètre le plus proche.',
                disambiguaHeading: 'Zones de stationnement multiple',
                disambiguaLabel: 'Choisissez où stationner',
                disambiguaTitolo: 'Zones de stationnement multiple',
                durataSosta: 'Durée du stationnement :',
                elencoMovimenti: 'Liste des mouvements',
                elencoParcheggi: 'Liste des parkings',
                findMyCar: {
                    aggiungiPosizione: 'Ajouter',
                    cancellaPosizione: 'Éliminer cette position',
                    cancellaPosizioneTesto:
                        'Vous souhaitez éliminer cette position ? Cette opération ne peut pas être annulée et ne désactivera pas les éventuels stationnements actifs.',
                    cancellaPosizioniTesto:
                        'Vous souhaitez éliminer les positions mémorisées ? Cette opération ne peut pas être annulée et ne désactivera pas les éventuels stationnements actifs.',
                    clean: 'Nettoyer',
                    erroreSalvataggio:
                        'Une erreur s’est produite pendant la sauvegarde de la position. Veuillez réessayer.',
                    header: 'Trouver ma voiture',
                    inserisciPosizione: 'Saisissez l’adresse...',
                    nessunaPosizioneSalvata: 'Aucune voiture en stationnement',
                    oppureUsaMappa: 'Ou appuyez sur la carte :',
                    posizione: 'Position',
                    posizioni: 'Positions',
                    posizioniRecenti: 'Récents',
                    posizioniSalvate: 'Liste des positions',
                    pulisci: 'Nettoyer',
                    pulisciPosizioni: 'Nettoyer les positions',
                    pulisciQuestaPosizione: 'Nettoyer cette position',
                    salvaPosizione: 'Confirmer',
                    targaOrDescrizione: 'Plaque d’immatriculation ou description',
                    whereIsMyCar: 'Où se trouve ma voiture ?',
                },
                fineSosta: 'Fin de stationnement',
                finoA: "Jusqu'à",
                fraBrevePotraiRipetere: 'D’ici peu vous pourrez répéter l’opération...',
                gestioneCarte: {
                    aggiungiCarta: 'Ajoutez une carte',
                    confermaEliminazione: 'Vous souhaitez éliminer la carte de crédit qui termine par',
                    scaduta: 'Expiré',
                    titolo: 'Cartes de crédit',
                },
                importoSosta: 'Montant stationnement',
                importoSostaAttuale: 'Montant stationnement actuel',
                importoSostaPrevisto: 'Montant prévu',
                indirizzoZona: 'Chercher par rue ou zone de stationnement',
                infoMemoComunePreferito:
                    'Si vous choisissez de mémoriser la ville indiquée, celle-ci sera sélectionnée chaque fois que myCicero n’arrive pas à récupérer votre position',
                infoStalloLabel: 'Où puis-je trouver le numéro de place ?',
                ingressoAlleOre: 'Entrée à :',
                inizioSosta: {
                    altreZoneDiSosta: 'Autres zones de stationnement',
                    askRegistraPosizione:
                        "Grâce au GPS j’ai détecté la position précise de votre voiture. Vous souhaitez l'enregistrer de manière à la retrouver facilement ?",
                    avvisoDisattivazioneAutomaticaSosta: 'Le stationnement sera désactivé automatiquement',
                    avvisoTermineSosta: 'Le stationnement sera terminé',
                    calcoloImporto: 'Calcul montant',
                    confermaInizioSosta: 'Confirmer le début du stationnement',
                    finePrevistaMediaHide: 'Fin prévue :',
                    finoQuando: 'Jusque quand souhaitez-vous stationner ?',
                    impossibileCalcolareImporto: 'Erreur : Impossible de terminer le calcul du montant',
                    infoCoupon: 'Comment cela fonctionne-t-il ?',
                    infoCouponNoLogin: 'Vous possédez un coupon ? Effectuer l’identification pour saisir le code',
                    infoLimiteTariffario: "Dans cette zone de stationnement il n'est pas permis de stationner après :",
                    infoPrezzoTariffario: 'Le montant tarifaire vous permet de stationner quoi qu’il en soit jusqu’à :',
                    infoTariffeSu: 'Infos et tarifs sur ',
                    iniziaSosta: 'Commencer le stationnement',
                    inizio: 'Début :',
                    noParcheggiRecenti: "Aucun stationnement récent n'est présent",
                    noParkingsInAddress:
                        "Nous n'avons pas trouvé de zones de stationnement couvertes par le service correspondantes à votre recherche.",
                    noParkingsInCity:
                        'Dans la municipalité sélectionnée il n’y a pas de zones utilisées pour le stationnement',
                    noParkingsInCitySeason:
                        'Dans la municipalité sélectionnée le stationnement a un tarif saisonnier. En ce moment il n’y a pas de zone de stationnement payante couverte par notre service.',
                    parcheggiRecenti: 'Parkings récents',
                    placeholderCoupon: 'Saisissez le code de votre coupon',
                    promozioniIntornoATe: 'Promotions dans vos alentours',
                    recenti: 'Récents',
                    registraPosizione: 'Enregistrement position',
                    registraPosizioneAuto: 'Mémoriser position voiture',
                    salvaPosizionePrefix: 'Sauvegarder la position GPS actuellement détectée',
                    salvaPosizioneShort: 'Rappelez-vous la position de la voiture pour ce stationnement',
                    salvaPosizioneSuffix: 'comme position du véhicule pour ce stationnement',
                    scegliParcheggio: 'Choisissez le parking',
                    scopriCoupon: 'Vous souhaitez stationner gratuitement ? Découvrez comment !',
                    scopriCoupon1: 'Vous souhaitez stationner gratuitement ?',
                    scopriCoupon2: 'Découvrez comment...',
                    success: 'Début du stationnement enregistré correctement',
                },
                inizioSostaAutorimesse: {
                    avviaNavigatore: 'Démarrer navigateur',
                    cercaPerNomeIndirizzo: 'Chercher par adresse ou nom',
                    chiudereSosta:
                        'Pour mettre fin au stationnement, rendez-vous au parking et demandez la sortie du véhicule.<br/>Seul le coût du stationnement en fonction de l’horaire d’entrée effective selon le tarif en vigueur vous sera débité.',
                    cittaNonSupportata:
                        "La ville dans laquelle vous vous trouvez n'est pas supportée, nous avons choisi la ville supportée la plus proche.",
                    creditoInsufficiente:
                        "Votre crédit n'est pas suffisant pour effectuer le remplacement. Pour stationner, vous devez recharger votre crédit de stationnement.",
                    dataOraPerPreventivo: 'Vous prévoyez de stationner à partir de maintenant jusqu’à :',
                    durataEccessiva:
                        'Devis coût ne pouvant pas être calculé pour des stationnements supérieurs à 7 jours',
                    elencoStrutture: 'Liste des structures',
                    emissioneFattura:
                        'Sur demande, la facture créée par MyCicero n’inclut pas le montant payé directement au gestionnaire du parking mais seulement celui payé par l’intermédiaire de la plateforme.',
                    finePrevista: 'Fin prévue :',
                    importoTotale: 'Montant total pour cette durée :',
                    infoTariffe:
                        'Le tarif en vigueur dans le parking ne peut pas être fractionné pour les minutes de stationnement effectives mais ne prévoit que des heures entières',
                    iniziaSostaEntroTrentaMin:
                        "La demande de stationnement sera automatiquement éliminée si vous n'accédez pas au parking dans les 30 minutes. Aucun coût ne sera débité.",
                    inizioSosta: 'Début du stationnement :',
                    inizioSostaRichiesto: 'Demande début de stationnement envoyée correctement.',
                    noResult: "La recherche n'a pas donné de résultat",
                    parcheggioAlCompleto: 'Parking fermé',
                    ricaricaIlBorsellino:
                        'Rechargez le porte-monnaie électronique si vous souhaitez payer le montant total avec MyCicero, dans le cas contraire vous paierez la différence à l’opérateur du parking.',
                    richiediInizioSosta: 'Demander début du stationnement',
                    sostaSaraAttivata:
                        "Le stationnement sera activé quand l’opérateur du parking vérifiera votre entrée L’horaire configuré n'est pas contraignant pour la sortie du parking et il sera quoi qu'il en soit possible de mettre fin au stationnement à l'avance. Le coût sera débité en fonction de l’horaire d’entrée effective selon le tarif en vigueur.",
                    statoSosta: {
                        attiva: 'Stationnement actif',
                        conclusa: 'Stationnement terminé',
                        inAttesa: 'Expiration avant : ',
                    },
                },
                insertCode: {
                    confirmDescription:
                        "Scannez avec votre smartphone le code imprimé à l'avant du ticket pour afficher le montant à payer",
                    confirmTitle: 'Vous possédez un ticket de stationnement prélevé d’un parking dans la structure ?',
                    description: "Saisissez le code imprimé à l'avant du ticket pour afficher le montant à payer",
                    nonMostrarePiu: 'Ne plus montrer ce message',
                    okGoOn: 'Ok, continuez',
                    placeholder: 'Saisissez le code du ticket',
                    title: 'Vous possédez un ticket de stationnement prélevé d’un parking dans la structure ?',
                    verifica: 'Vérifier',
                },
                laMiaAuto: 'Ma voiture',
                map: {
                    areaNonServitaDaTitle: 'Zone pas desservie par {0}',
                    areaNonServitaDesc:
                        'Vérifiez si la zone est payante sur les panneaux verticaux ou dans le parcmètre le plus proche.',
                    areaNonServitaHtml:
                        'Pour des informations, contactez-nous au <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> ou <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">par chat</a>',
                    areaNonServitaTitle: 'Zone pas desservie',
                    avviaNavigatore: 'Démarrer navigateur',
                    cambiaCitta: 'Changer de ville',
                    caricamentoCompletato: 'Chargement terminé !',
                    caricamentoLento: 'Le chargement prend plus de temps que prévu.',
                    caricamentoMappa: 'Chargement carte...',
                    cercaIndirizzo: 'Chercher adresse',
                    disclaimerBtnText: "J'ai compris",
                    disclaimerText: 'Assurez-vous d’indiquer exactement où se trouve votre véhicule',
                    ingrandisciMappa: 'Augmentez le zoom pour identifier la zone de stationnement',
                    localitaSconosciuta: 'Localité inconnue',
                    mappaSosta: 'Carte stationnement',
                    noIsostaLayer: 'Impossible de récupérer les zones autorisées',
                    posizioneAmbiguaTemplateString:
                        'La position actuelle est à cheval de {0} zones de stationnement différentes. Sélectionnez celle dans laquelle vous vous trouvez :',
                    postiLiberi: 'Places libres',
                    postoLibero: 'Place libre',
                    ricercaHeaderTemplate: 'Chercher à {0}',
                    ricercaLocalitaInCorso: 'Recherche localité en cours...',
                    ricercaPlaceholder: 'Adresse, lieux, points d’intérêt...',
                    scegliPosizione: 'Touchez une zone de stationnement...',
                    staiVedendo: 'Vous regardez :',
                    zonaImprecisa:
                        "Vérifiez l'exactitude de la zone de stationnement sur les panneaux verticaux ou dans le parcmètre le plus proche",
                    zonaNonCoperta:
                        'Dans {0} en ce moment il n’y a pas de zone payante.<br/>En cas de doute, contactez-nous au <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> ou <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">par chat</a>',
                    zonaSenzaParcheggi: 'Ici en ce moment il n’y a pas de zones payantes. Vous pensez le contraire ?',
                },
                memorizzaComunePreferito: 'Mémoriser comme ville habituelle',
                minuti: 'minutes',
                minuto: 'minute',
                modalitaPagamento: {
                    attivaPagamentoContestuale: 'Activer le paiement selon la consommation',
                    erroreCaricamento:
                        'Une erreur s’est produite. Impossible de charger les données, veuillez réessayer plus tard',
                    erroreNessunaCartaDiCredito:
                        'Pour activer le paiement contextuel vous devez enregistrer une carte de crédit',
                    erroreSalvataggio:
                        'Une erreur s’est produite. Impossible de sauvegarder les modifications, veuillez réessayer plus tard',
                    infoCostiPagamentoContestuale:
                        'Il prévoit le débit du montant de chaque stationnement directement sur la carte de crédit enregistrée. Ce service prévoit <b>un coût supplémentaire de 0,08 €</b> pour chaque stationnement avec un montant minimum de la transaction égal à 0,20 €.',
                    infoCostiPagamentoContestualeActv:
                        'Il prévoit le débit du montant de chaque stationnement directement sur la carte de crédit enregistrée.',
                    infoCostiPagamentoContestualeRoger:
                        'Il prévoit le débit du montant de chaque stationnement directement sur la carte de crédit enregistrée.',
                    infoCredito:
                        'Votre crédit, en le chargeant par carte de crédit, Satispay, PayPal ou en vous rendant dans un point de vente habilité SisalPay. <b>Ce mode ne prévoit PAS de frais supplémentaires.</b> Le crédit peut également être utilisé pour acheter des titres de voyage et pour tous les autres services disponibles.',
                    infoCreditoACTV:
                        '<b>Ce mode ne prévoit PAS de frais supplémentaires.</b> Le crédit peut également être utilisé pour acheter des titres de voyage et pour tous les autres services disponibles.',
                    infoCreditoRoger:
                        'Votre crédit, en le chargeant par Carte de crédit. Le crédit peut également être utilisé pour acheter des titres de voyage et pour tous les autres services disponibles.',
                    labelCartaDiCreditoNecessaria:
                        'Pour utiliser ce service, il est nécessaire de mémoriser une carte de crédit.',
                    labelCredito: 'Crédit',
                    labelModalita: 'Payez chaque stationnement avec :',
                    labelNoCarteRegistrate: "Vous n'avez pas de carte enregistrée.",
                    labelPagamentoContestuale: 'Paiement contextuel',
                    labelProcedi: 'Continuer',
                    labelRegistraCarta: 'Enregistrer une carte',
                    labelRicarica: 'Recharger',
                    labelSaldo: 'Solde crédit',
                    labelScegliCartaDiCredito: 'Choisissez la carte de crédit parmi celles enregistrées :',
                    labelUtilizzaQuestaCarta: 'Utilisez cette carte de crédit enregistrée :',
                    titolo: 'Comment payer',
                },
                mostraParcheggi: 'Montrer parkings',
                numeroStallo: 'Numéro place',
                ongoingNotification: {
                    extendButtonLabel: 'Prolonger 30 min',
                    message: 'jusqu’à {0}',
                    stopButtonLabel: 'Fin',
                    title: '{0} en stationnement',
                },
                oopsAnnullaSosta: 'Oups ! Annuler stationnement.',
                parcheggiGestiti: {
                    avvisoDurataPrenotazione:
                        "La réservation sera automatiquement éliminée à l'expiration de la période sélectionnée",
                    avvisoOrarioNonConsentito:
                        'L’horaire d’arrivée au parking devra être comprise entre {0} et {1} en fonction du règlement appliqué dans la structure sélectionnée.',
                    avvisoSostaNonDisponibile:
                        "Il n'est pas possible de réserver le parking pour les dates sélectionnées, réessayez en saisissant des dates différentes",
                    avvisoTermineSosta: 'Le service termine à <span class="bold">{0}</span>.',
                    cantAddService:
                        'Impossible de saisir les services demandés suivants : <ul><% _.forEach(articlesKo, function(article) { %> <li><%- article.descArticolo %></li> <% }); %></ul>',
                    cercaAeroportoLocalita: 'Chercher par nom ou localité',
                    cercaAeroportoTitle: 'Choisir le lieu',
                    cercaPlaceholder: 'Chercher par nom ou localité',
                    condizioni: 'Je déclare avoir lu et accepter les <em>conditions de service</em>',
                    confermaConPagamento: 'Réservez et payez maintenant',
                    confermaSenzaPagamento: 'Réservez et payez à la fin du stationnement',
                    dataInizioSostaNonConsentita: "Il n'est pas possible de réserver le parking avant le {0} à {1}",
                    erroreAggiornamentoPrezzi:
                        'Impossible de mettre le total à jour pour les jours sélectionnés. Veuillez réessayer plus tard.',
                    erroreGenericoDisponibilita:
                        "La vérification de la disponibilité du parking avec le gestionnaire n'a pas réussi Réessayez dans un second temps ou contactez l'assistance.",
                    importoPagato: 'Montant payé',
                    importoTotaleDurata: 'Montant total pour cette durée',
                    info: {
                        mail: 'E-mail',
                        orarioAp: 'Horaires d’ouverture',
                        servizi: 'Services inclus',
                        sitoWeb: 'Site Internet',
                        social: 'Réseaux sociaux',
                        telefono: 'Numéro de téléphone',
                        tipo: 'Type',
                        tipoPosti: 'Type de places',
                    },
                    infoDesigna:
                        "Montrez le code QR à la colonne d'accès du parking. Rappelez-vous de retirer le ticket papier délivré par la colonne pour la sortie du parking ou pour payer l’éventuelle différence à la caisse, en cas de sortie en dehors de la période réservée.",
                    infoPrenotazioneEffettuata:
                        'Vous pouvez trouver la réservation du parking dans la section « Stationnement et ZTL »',
                    intestazionePrenotazione: 'Réservation d’1 place voiture pour la plaque d’immatriculation',
                    istruzioniDownloadTitoli:
                        'Une fois l’achat terminé, vous trouverez la réservation dans la section « Stationnement » de l’application',
                    menuTitle: 'Parkings gérés',
                    nessunParcheggioRecente: "Aucun stationnement récent n'est présent",
                    nessunRisultato: "La recherche n'a donné aucun résultat",
                    parkAvail: 'Le parking est disponible.',
                    parkNotAvail: 'Pendant les dates spécifiques le parking est au complet.',
                    placeholderRicercaTestuale: 'Chercher par nom',
                    postiNonPrenotabili: '{0} places libres',
                    postiNonPrenotabiliEsauriti: 'Aucune place libre',
                    prenota: 'Réserver',
                    prenotaParcheggio: 'Réserver le parking',
                    prenotazioneSosta: 'Réservation stationnement',
                    richiediDisponibilita: 'Demander disponibilité',
                    scegliParcheggioTitle: 'Choisissez le parking',
                    tabCondizioni: 'Conditions',
                    tabElenco: 'Liste',
                    tabInfo: 'Infos',
                    tabMappa: 'Carte',
                    tabRecenti: 'Récents',
                    tabTariffe: 'Tarifs',
                    titleConferma: 'Réserver stationnement',
                    titleConfermata: 'Réservation confirmée',
                    titleDettaglio: 'Détail',
                    titlePrenota: 'Réserver stationnement',
                    tutteLeAree: 'Toutes les localités',
                    vaiAllaPrenotazione: 'Aller à la réservation',
                    verificaDisponibilita: 'Vérifier la disponibilité',
                    verificaDisponibilitaInCorso: 'Nous sommes en train de contacter le gestionnaire du parking',
                    visualizzaPrenotazione: 'Afficher la réservation',
                },
                parcheggio: 'Parking',
                posizioneNonDisponibile: 'Je ne réussis pas à trouver votre position',
                preferenzeSosta: {
                    categorieAgevolate: 'Catégories avantagées gérées',
                    disclaimerCategorieSosta:
                        'L’utilisateur assume la responsabilité de ce qui a été déclaré, conformément à la loi',
                    erroreSalvataggio:
                        'Une erreur s’est produite. Impossible de sauvegarder les modifications, veuillez réessayer plus tard',
                    etichettaDurataDueOre: '120 minutes',
                    etichettaDurataFineGiornata: 'Fin de la journée',
                    etichettaDurataQuattroOre: '240 minutes',
                    etichettaDurataUnOra: '60 minutes',
                    infoAreaNotifiche:
                        'Prolongez et terminez le stationnement avec un clic directement à partir de la zone notifications de votre dispositif.',
                    infoCategorieUtente:
                        "Des avantages tarifaires pour des catégories particulières sont prévus dans certaines villes. Si vous faites partie de l’une d'entre elles, activez le menu relatif pour bénéficier des tarifs vous étant réservés.",
                    infoCittaAbituale:
                        "Cette ville sera automatiquement sélectionnée quand il n'est pas possible de récupérer la position par GPS.",
                    infoDurataSosta:
                        "Les minutes configurées seront utilisées pendant la phase d'activation stationnement pour proposer la durée prévue.<br/>L'option « Fin de journée » veut dire que la fin du stationnement sera configurée pareille à l’horaire de fin de paiement de la zone choisie ou jusqu’à épuisement du crédit disponible, si cela n'est pas suffisant pour arriver à la fin de la journée",
                    infoNotificheSms:
                        'Le coût du service est de 0,08 € par SMS reçu.<br/>Si vous activez et terminez le stationnement par SMS les notifications sont automatiques et ne peuvent pas être désactivées.',
                    labelAreaNotifiche: 'Notifications dispositif',
                    labelAttiva: 'Activer',
                    labelCittaAbituale: 'Ville habituelle',
                    labelDurataSosta: "Durée de l'arrêt proposé :",
                    labelInLista: 'Dans la liste',
                    labelInMappa: 'Sur la carte',
                    labelNotificheSms: 'Confirmer l’arrêt SMS',
                    labelScegli: 'Choisir',
                    labelSmsFineSosta: 'Confirmer la fin du stationnement',
                    labelSmsInizioSosta: 'Confirmer le début du stationnement',
                    labelVisualizzazioneCercaParcheggio: 'Quand vous cherchez le parking préférez l’affichage',
                    mieCategorie: 'Mes catégories avantageuses',
                    titolo: 'Préférences de stationnement',
                },
                prenotazioneDal: 'Réservation à partir de',
                procedi: 'Continuer',
                prolunga: 'Prolonger',
                prolungaSosta: 'Prolonger le stationnement',
                prolungaSostaFail: 'Impossible de prolonger le stationnement',
                prolungaSostaSuccess: 'Prolongement du stationnement enregistré correctement',
                qrCode: {
                    accediEntroLeOre: 'Accédez avant',
                    accediPagaAllUscita: 'Vous souhaitez accéder au parking maintenant et payer à la sortie ?',
                    entraNelParcheggio: 'Entrer dans le parking',
                    erroreGenerazioneQrCode: 'Une erreur s’est produite pendant la création du code QR',
                    esciDalParcheggio: 'Sortez du parking',
                    esciDalParcheggioScansionaQrCode:
                        'Rendez-vous à la sortie du parking et scannez le code QR à la barre',
                    infoIngressoQrCode:
                        "<span class='bold'>Scannez</span> le <span class='bold'>Code QR</span> à la colonne d’entrée et retirez le ticket. Rappelez-vous que vous avez <span class='bold'>15 minutes</span> pour entrer dans le parking.",
                    infoPagamentoClassico:
                        'Alternativement, vous pouvez payer en insérant le ticket dans la caisse automatique du parking.',
                    infoUscitaQrCode:
                        "<span class='bold'>Payez à partir de l’application</span> en cliquant sur le panneau du <span class='bold'>stationnement actif</span>.</br><span class='bold'>Scannez le code QR</span> à la colonne de sortie.",
                    ingressoEffettuatoAlleOre: 'Entrée effectuée à',
                    nuovoQrCode: 'Nouveau code QR',
                    pagamentoClassico: 'Paiement classique',
                    perEntrare: 'Pour entrer',
                    perUscire: 'Pour sortir',
                    qrCodeScaduto: 'Votre code QR a expiré, demandez-en un nouveau !',
                    tornaAllaSosta: 'Retour au stationnement',
                    visualizzaQrCode: 'Afficher le code QR',
                },
                reminderUscita: 'Rappelez-vous que vous avez 15 minutes pour sortir du parking après le paiement.',
                ricaricaCredito: 'Recharger le crédit',
                ricaricaCreditoAssociaCarta: 'Recharger le crédit ou associer la carte...',
                rifSosta: 'Réf. Stationnement',
                salvaPosizione: 'Sauvegarder la position',
                scegliArea: 'Sélectionnez la zone',
                scegliCitta: 'Choisissez la ville',
                selezionaComune: 'Sélectionnez une municipalité :',
                selezionaFineSosta: 'Sélectionnez l’horaire prévu de fin de stationnement.',
                servizioNonAttivo:
                    'Vous n’avez pas encore activé le service « Stationnements et ZTL ». Il suffit d’un instant.',
                skidata: {
                    activateIn: 'Vous devrez activer le ticket avant : ',
                    bsb: 'Ticket stationnement bref',
                    cassaAutomatica: 'Caisse automatique',
                    disambiguaStruttura: 'Sélectionnez le parking',
                    emissioneFattura:
                        'Sur demande, la facture créée par MyCicero n’inclut pas le montant payé directement au gestionnaire du parking mais seulement celui payé par l’intermédiaire de la plateforme.',
                    expiredTicket: 'Ticket créé expiré.',
                    garage: 'Garage : ',
                    generationOk: 'Ticket créé correctement.',
                    goToHome: "Retour à la page d'accueil",
                    infoStruttura:
                        'le stationnement sera activé quand vous utiliserez le code QR pour soulever la barre de parking. Le coût sera débité en fonction de l’horaire d’entrée effective selon le tarif en vigueur.',
                    labelHour: ' heure',
                    labelHours: ' heures',
                    labelMinute: ' min',
                    labelMinutes: ' min',
                    labelSecond: ' sec',
                    labelSeconds: ' sec',
                    pagamentoOk: 'Paiement effectué avec succès',
                    pagamentoOkDescHtmlTemplate:
                        'Le paiement du stationnement dans le parking <span class="bold">{0}</span> a été terminé avec succès.',
                    parcheggiInStruttura: 'Places de parking dans la structure',
                    remainingTime: 'Temps résiduel : ',
                    scansioneBiglietto: 'Scannage du ticket',
                    statusActive: 'Stationnement actif',
                    statusExpired: 'Ticket expiré',
                    statusGenerated: 'Activer le stationnement avant :',
                    statusPaid: 'Sortir du parking avant :',
                    subscription: 'Abonnement',
                },
                sosta: 'Stationnement',
                sostaAPagamento: 'Lignes bleues',
                sostaAutorimesse: 'Garage',
                sostaFinoA: 'Stationnement jusqu’à',
                sostaValidaFinoA: 'Stationnement valable jusqu’à',
                sosteAttive: 'Active(s)',
                sosteParcheggi: 'Stationnement et ZTL',
                sostePrenotate: 'Réservations',
                stallo: 'Place :',
                stalloMancante: 'Il est nécessaire d’installer le numéro de la place',
                stalloNonValido: 'Numéro de la place erroné',
                stalloTargaUsataDiRecente:
                    'Vous avez déjà activé récemment un stationnement sur cette plaque d’immatriculation.',
                stalloUsatoDiRecente: '',
                stalloX: 'Place {0}',
                talloncinoInviatoInfo:
                    'Le coupon relatif à cette plaque d’immatriculation a été envoyé à votre compte e-mail',
                targhe: {
                    aggiungi: 'Nouvelle plaque d’immatriculation',
                    attr: {
                        disponibile: 'Disponible',
                        occasionale: 'Libre',
                        occupata: 'Utilisée',
                        principale: 'Principale',
                        secondaria: 'Secondaire',
                    },
                    cambiaTarga: 'Changer la plaque d’immatriculation',
                    conferma: 'Confirmer',
                    confermaFormatoTarga:
                        'La plaque d’immatriculation a un format différent de celui standard. Vous souhaitez continuer quand-même ?',
                    confermaIvioTalloncino: 'Opération terminée',
                    confermaRimozioneTarga: 'Vous souhaitez éliminer définitivement cette plaque d’immatriculation ?',
                    descrizioneBreve: 'Description brève',
                    erroreComuniTalloncino:
                        'Une erreur s’est produite. Impossible de récupérer la liste des villes, veuillez réessayer plus tard',
                    impossibileCambiareTarga: 'Impossible de changer la plaque d’immatriculation',
                    inUso: 'utilisé',
                    infoCancellazioneTargaPrincipale: 'La plaque d’immatriculation favorite ne peut pas être éliminée',
                    infoTalloncino: 'Vous recevrez un e-mail avec le coupon à exposer dans ',
                    infoTalloncinoCitta: 'certaines villes.',
                    infoTalloncinoObbligatorioParte1: 'À l’adresse ',
                    infoTalloncinoObbligatorioParte2:
                        ' un e-mail sera envoyé avec le coupon à exposer obligatoirement dans les municipalités de : ',
                    infoTargaPrincipale1:
                        'La <span class="bold">plaque favorite</span> sera proposée automatiquement à chaque début de stationnement.',
                    infoTargaPrincipale2: 'En outre, elle est utilisée pour les services SMS et NoCall.',
                    infoTargaPrincipaleInUso:
                        'La plaque d’immatriculation actuellement sélectionnée comme favorite est utilisée en ce moment, par conséquent vous ne pouvez pas choisir une autre plaque d’immatriculation en tant que favorite.',
                    infoTargaPrincipaleInUsoHeader: 'Plaque d’immatriculation utilisée',
                    infoTargaPrincipaleOwn:
                        'Celle-ci est la <span class="bold">plaque favorite</span>.<br/>Elle sera proposée automatiquement à chaque début de stationnement. En outre, elle est utilisée pour les services SMS et NoCall.',
                    inserisciDatiTarga:
                        'Pour utiliser le service il est nécessaire d’enregistrer les données d’un véhicule :',
                    inserisciTargaOccasionale: 'Saisissez la plaque à utiliser pour ce stationnement :',
                    inviaTalloncino: 'Envoi du coupon',
                    limiteRaggiunto:
                        "Vous avez déjà atteint le nombre maximal de plaques d’immatriculation qu'il est possible d’enregistrer",
                    memorizza: 'Mémoriser',
                    'memorizza e scegli': 'Mémoriser et choisir',
                    modificaTarga: 'Modifier la plaque d’immatriculation',
                    nessunaTargaRegistrata: 'Aucune plaque d’immatriculation',
                    noCallInfoTarga:
                        'Pour les services « No Call/SMS », cette plaque d’immatriculation sera toujours utilisée.',
                    nuova: 'Nouvelle plaque d’immatriculation',
                    propostaDefault: 'proposition par défaut',
                    registraneUna: 'En enregistrer une',
                    registrazionePrimaTargaOk: 'Vous avez enregistré la plaque d’immatriculation',
                    registrazioneTargaKo:
                        'Une erreur s’est produite dans l’enregistrement de la plaque d’immatriculation',
                    registrazioneTargaOk:
                        'Modifications apportées avec succès.<br/>Le coupon relatif à cette plaque d’immatriculation a été envoyé à votre compte e-mail<br/>{0}',
                    rendiTargaPrincipale: 'Plaque d’immatriculation favorite',
                    rendiTargaPrincipaleKo:
                        'Impossible de mémoriser cette plaque d’immatriculation en tant que favorite.',
                    rimozioneTargaKo: 'Une erreur s’est produite dans l’élimination de la plaque d’immatriculation',
                    rimozioneTargaOk: 'Plaque d’immatriculation éliminée avec succès.',
                    rimuovi: 'Éliminer la plaque d’immatriculation',
                    rules: {
                        accettaCondizioni: 'Vous devez accepter les conditions du service',
                        troppoCorta: 'La plaque d’immatriculation doit contenir plus de 3 caractères',
                    },
                    salvaInviaTalloncino: 'Sauvegarder et envoyer le coupon',
                    scegliTarga:
                        'Sélectionnez une des plaques d’immatriculation associées pour commencer le stationnement.',
                    scegliTargaShort: 'Personnels',
                    targaNonValida: 'Plaque d’immatriculation pas valable',
                    targaOccasionale: 'Plaque d’immatriculation occasionnelle',
                    targaPrincipale: 'Plaque d’immatriculation favorite',
                    targaSecondaria: 'Plaque d’immatriculation secondaire',
                    targaVeicolo: "Plaque d'immatriculation du véhicule",
                    targheRegistrate: 'Plaques d’immatriculation enregistrées',
                    targheSosta: 'Gestion des plaques d’immatriculation',
                    targheSostaRegistra: 'Enregistrer la plaque d’immatriculation',
                    troppeTarghe:
                        "Attention ! Le cas dans lequel sont présentes plus de 2 plaques d’immatriculation n'est pas géré !",
                },
                termina: 'Arrêt',
                terminaSosta: 'Mettre fin au stationnement',
                terminaSostaPrefix: 'Votre stationnement est sur le point de finir',
                terminaSostaSuccess: 'Fin du stationnement enregistré correctement',
                terminaSostaSuffix: 'minutes avant la fin prévue',
                termineBreve: 'Le stationnement terminera d’ici peu',
                termineSpecifico: 'Le stationnement terminera le {0} à {1}',
                trovaLaMiaAuto: 'Trouver ma voiture',
                ultimi30MovFinoAlGiorno: '30 derniers mouvements jusqu’au jour',
                usaMyCicero: 'Utiliser myCicero...',
                uscitaAlleOre: 'Sortie à :',
                validaFinoA: 'Valable jusqu’à',
                ztl: {
                    label: 'Permis ZTL',
                    subtitle: 'Zones à trafic limité',
                },
            },
            lardini: {
                aggiornamentoRisultatiInCorso: 'Mise à jour des résultats en cours',
                catalogoBuoni: 'Catalogue des bons',
                classifica: 'Classement',
                infoGiornataCampionato: '{0}° journée - {1}',
                inizioAlle: 'Début à : {0}',
                livescore: 'Livescore',
                mondoLardiniFilottrano: 'Le monde Lardini Filottrano',
                parcheggiaCon: 'Stationnez avec',
                partiteDel: 'Matchs du {0}',
                partiteLive: 'Les matchs LIVE',
                rilasciaPerAggiornare: 'Relâchez pour mettre les résultats à jour',
                scopriNovita: 'Découvrez les nouveautés',
                scorriVersoIlBassoPerAggiornare: 'Défilez vers le bas pour mettre les résultats à jour',
                sponsor: 'Sponsor',
                tableClassifica: {
                    labelSquadre: 'Nom de l’équipe',
                    partiteGiocate: 'Matchs joués',
                    partiteGiocateShort: 'MJ',
                    partitePerse: 'Matchs perdus',
                    partitePerseShort: 'MP',
                    partiteVinte: 'Matchs gagnés',
                    partiteVinteShort: 'MG',
                    punti: 'Points',
                    puntiShort: 'PT',
                    setPersi: 'Sets perdus',
                    setPersiShort: 'SP',
                    setVinti: 'Sets gagnés',
                    setVintiShort: 'SG',
                },
                viaggiaCon: 'Voyagez avec',
                visualizzaParzialiSet: 'Afficher les sets partiels',
            },
            lecceclick: {
                bagniPubblici: 'Toilettes publiques',
                colonnineAutoEnel: 'Colonnes voiture Enel',
                defibrillatori: 'Défibrillateurs',
                esperienze: 'Expériences',
                fontanelleAcquaPotabile: 'Eau potable',
                giochi: 'Jeux',
                gioco: '',
                infoProgettoEuropeo:
                    'Projet financé par l’Union européenne sur le P.O.R. Pouilles 2014-2020, Fonds FESR, Action2.2',
                itinerari: 'Itinéraires',
                parcheggiPubbliciPrivati: 'Parkings publics privés',
                runninCity: "Runnin'City",
                servizi: 'Services',
                wifiHotspot: 'Wi-Fi Hotspot',
            },
            media: {
                acquisisciImmagine: 'Acquérir une image',
                fotocamera: 'Caméra',
                gallery: 'Images sauvegardées',
                importaGallery: 'Importer une image sauvegardée',
                scattaFoto: 'Prendre une photo',
                sceltaFotoGallery: 'Vous souhaitez prendre une photo ou importer une de vos images sauvegardées ?',
            },
            mobilita: {
                acquistaDiNuovo: 'Acheter de nouveau',
                acquistiRecenti: 'Achats récents',
                biglietteria: 'Billetterie',
                cercaFermata: 'Chercher arrêt',
                cercaIndirizzo: 'Chercher par adresse',
                cercaLinea: 'Chercher ligne',
                cercaPerCodice: 'Chercher par code',
                cercaPerCodiceOrDescrizioneFermata: 'Code ou description arrêt',
                cercaPerCodiceOrDescrizioneLinea: 'Chercher par code ou description',
                cercaPerFermata: 'Chercher par arrêt',
                cercaPerNumero: 'Chercher par numéro',
                cercaPerStazione: 'Chercher par gare',
                cercaStazione: 'Chercher gare',
                cercaTreno: 'Chercher train',
                cittaOrLocalita: 'Ville ou localité',
                codiceDescrizioneFermata: 'Code /Description arrêt',
                codiceDescrizioneLinea: 'Code / Description ligne',
                codiceFermata: 'Ou code arrêt',
                codiceLinea: 'Ou code ligne',
                codiceOrDescrizioneFermata: 'Code ou description arrêt',
                codiceOrDescrizioneLinea: 'Code ou description ligne',
                deleteAllConfirmMsg:
                    'Si vous confirmez, TOUS les titres expirés de « {0} » seront éliminés du dispositif.',
                deleteConfirmMsg: 'Si vous confirmez, le titre sera éliminé par le dispositif',
                dettaglioFermata: 'Détail arrêt',
                fermate: 'Horaires Arrêt',
                fermateIntorno: 'Arrêts dans les alentours',
                fermatePreferite: 'Arrêts favoris',
                header: 'Transport',
                inserisciIDati: 'Pour continuer, saisissez les données demandées',
                intornoA: 'Aux alentours de',
                intornoAllIndirizzo: "Dans les alentours de l'adresse de départ/destination",
                linea: 'Ligne',
                linee: 'Horaires Ligne',
                lineePreferite: 'Lignes favorites',
                lineeServite: 'Lignes desservies',
                mieiTitoli: 'Mes titres',
                navette: 'Navettes',
                needToLogin: ' pour visualiser les tickets achetés',
                nessunRisultato: 'Aucun résultat trouvé',
                nessunaSoluzione: 'Aucune solution',
                noTitoliAttiviScaduti: 'Il n’y a pas de titres à activer ou expirés',
                numeroOrCodiceTreno: 'Numéro ou code train',
                numeroTreno: 'Numéro de train',
                ogniXminuti: 'Toutes les {0} min.',
                orariAlleFermateLinee: 'Horaires des arrêts et lignes',
                parlaConNoi: 'Parlez avec nous',
                popolari: 'Les plus populaires',
                reti: 'Réseaux',
                scegliPercorso: 'Choisir parcours',
                searchingTickets: 'Je cherche les tickets achetés',
                stazione: 'Gare',
                stazioni: 'Gares',
                stazioniIntorno: 'Gares dans les alentours de',
                stazioniPreferite: 'Gares favorites',
                tabelloneOrari: 'Tableau horaires',
                titoliAttivi: 'Titres actifs',
                trattaXdiY: 'Trajet {0} de {1}',
                treni: 'Trenitalia',
                tuttiPassaggi: 'Tous les passages',
            },
            momup: {
                AcquistaBiglietti: 'Acheter des tickets',
                CalcolaPercorso: 'Calcul du parcours',
                Eventi: 'Événements',
                FermateOrari: 'Arrêts et horaires',
                Luoghi: 'Lieux',
                MieiTitoli: 'Mes titres',
                abilitaNfc: 'Activez l’NFC sur les configurations du dispositif pour pouvoir lire la carte NFC',
                letturaTessera: 'Lecture carte',
                letturaTitoli: 'Lire les titres',
                navette: 'Treviso AirBus - Tickets touristiques',
                nfc: {
                    arrival: 'Loc.',
                    article: 'Article',
                    contract: 'Contrat',
                    dataOraFineValidita: 'Date fin de validité',
                    dataOraValidazione: 'Date heure validation',
                    departure: 'Loc. Départ',
                    endDate: 'Fin de validité',
                    fermata: 'Arrêt',
                    linea: 'Ligne',
                    residuals: 'Voyages résiduels',
                    startDate: 'Début de validité',
                    vediValidazioni: 'Voir les validations',
                },
                scansiona: 'Scanner',
                scansioneFallita: 'Erreur scannage',
                scopriAltreApp: 'Découvrez le monde Mom',
            },
            mp: {
                archeologia: 'Archéologie',
                arteStoria: 'Art et histoire',
                bikeTrekking: 'Vélos et trekking',
                cominciaViaggio: 'Commencez le voyage...',
                contattaci: 'Contactez-nous',
                culturaTradizione: 'Culture et tradition',
                eccellenze: 'Excellences',
                esperienze: 'Expériences',
                eventi: 'Événements',
                facebook: 'Suivez-nous sur FB',
                instagram: 'Instagram',
                itinerari: 'Itinéraires',
                luoghi: 'Lieux',
                mail: 'Contacts',
                naturaScienza: 'Nature et science',
                ospitalita: 'Hospitalité',
                prodotti: 'Produits',
                scegliMuseo: 'Choisissez votre musée...',
                sosta: 'Stationnement',
                trasporto: 'Transport',
                youtube: 'YouTube',
            },
            mycicero: {
                biglietteria: {
                    header: 'Billetterie',
                },
                changePosition: {
                    header: 'Chercher ville',
                    inputPlaceholder: 'Chercher ville',
                    noResults: 'Choisissez la ville et découvrez tous les services myCicero',
                },
                home: {
                    descrizioneSosta: 'Lignes bleues, parkings, ZTL',
                    descrizioneViaggia: 'Train, bus, métro, navire',
                    highlightTitle: 'En évidence',
                    titoloSosta: 'Stationnez',
                    titoloViaggia: 'Voyagez',
                },
                viaggia: {
                    abbonamenti: 'Abonnements',
                    abbonamentiExt: 'Abonnements',
                    acquistoOd: 'Achat à partir de solutions de voyage',
                    acquistoOdTessera: 'Chercher tarif',
                    acquistoSMS: 'Achetez par SMS',
                    bigliettiSuPrenotazione: 'Tickets sur réservation',
                    header: 'Voyagez',
                    multiacquisto: 'Services touristiques',
                    tariffaFissa: 'Tickets à tarif fixe',
                },
            },
            mytrasfer: {
                acquistaBiglietti: 'Acheter des tickets',
                calcolaPercorso: 'Calcul du parcours',
                fermateOrari: 'Arrêts et horaires',
            },
            navette: {
                allResults: 'Tous les résultats',
                anErrorOccurredRetry: 'Une erreur s’est produite. <b>Réessayer</b>',
                busAndStops: 'Autobus et arrêts',
                cercaPlaceHolder: 'Chercher par nom',
                cosaVedere: 'Que voir',
                detinazione: 'Destination',
                durata: 'Durée',
                emptyPoiList: 'Aucun résultat',
                infoArrivoPrevistoNonDisponibili: 'Informations accompagnement pas disponibles',
                infoDirezioneNonDisponibili: 'Informations direction pas disponibles',
                infoNomeFermataNonDisponibile: 'Nom de l’arrêt pas disponible',
                infoNonDisponibili: 'De plus amples informations ne sont pas disponibles',
                informazioni: 'Informations',
                kmTotali: 'Km totaux',
                navettaDaEPer: 'Navettes DE et VERS :',
                searchByNameOrLocation: 'Chercher par nom ou localité',
                serviziTuristici: 'Services touristiques',
                social: 'Réseaux sociaux',
                tab: {
                    agenda: 'Agenda',
                    condizioni: 'Conditions',
                    dettagli: 'Détails',
                    info: 'Infos',
                    itinerario: 'Itinéraire',
                    mappa: 'Carte',
                    orari: 'Horaires',
                    partenzeArrivi: 'Départs et arrivées',
                    tappe: 'Étapes',
                },
                tappe: 'Étapes',
                telefono: 'Numéro de téléphone',
                'title-elenco': 'Navettes',
                titleMenu: 'Navettes',
                updatingData: 'Mise à jour en cours...',
                web: 'Internet',
            },
            notification: {
                connectionErrorHeader: 'Connexion pas disponible',
                connectionErrorMessage:
                    'Impossible de se connecter au serveur : vérifier la connexion des données et réessayer.',
                errorGeneric: 'Impossible de terminer l’opération, une erreur s’est produite.',
                noConnection: 'Connexion pas disponible.',
                offline: 'Hors ligne',
                successGeneric: 'Opération effectuée avec succès',
                successGenericHeader: 'Succès',
                templateBorsellinoSosta: 'Crédit : &euro; {0}',
                templateContactUs: 'Contactez-nous...',
                templateCreditoNonDisponibile: 'Erreur dans le nouveau calcul du crédit',
                templateRicalcoloCredito: 'Nouveau calcul crédit en cours...',
            },
            notify: {
                header: 'attention',
                questionAreaTariffabile: 'Vous pensez que cette zone fait partie d’une zone payante ?',
                segnalaAnomalie: 'Signaler anomalies',
            },
            plusPayment: {
                cambiaMetodo: 'Autre méthode',
                confermaInizioSosta: 'Confirmer le début du stationnement',
                effettuaLogin: 'Effectuer l’identification',
                erroreAggiornamentoMetodiDiPagamento:
                    'Impossible de de mettre les méthodes de paiement à jour. Contrôlez votre connexion Internet et réessayez.',
                erroreAggiornamentoSaldoBorsellino:
                    'Impossible de mettre le crédit à jour. Contrôlez votre connexion Internet et réessayez.',
                erroreAggiornamentoSaldoBorsellinoParent:
                    'Impossible de mettre le crédit de {0} à jour. Contrôlez votre connexion Internet et réessayez.',
                ilTuoProfilo: 'Votre profil',
                modalitaPagamentoNonSupportata: 'En ce moment il n’est pas possible de payer avec le mode sélectionné',
                nessunMetodoAlternativo: 'Aucune méthode de paiement alternative disponible',
                paga: 'Payer',
                pagaConBorsellinoParent: 'Payer avec {0}',
                pagaConCartaDiCredito: 'Carte enregistrée',
                profiloPagamento: 'Profil de</br>paiement',
                ricaricaCreditoMyCicero: 'Recharger le crédit',
                usaCreditoMyCicero: 'Payez immédiatement avec le crédit',
                usaIlCredito: 'Rechargez le crédit myCicero. Cela vaut mieux !',
                usaIlCreditoBranded: 'Rechargez votre crédit',
            },
            poi: {
                apriMacrocategoria: 'Ouvrez macrocatégorie',
                categoria: 'Catégorie',
                categorie: 'Catégories',
                categorieSelezionate: 'Catégories sélectionnées',
                contatti: {
                    email: 'e-mail',
                    fax: 'fax',
                    header: 'Contacts',
                    tel: 'tél',
                    url: 'Internet',
                },
                deselezionaTutto: 'Aucune',
                dettaglio: 'Localité',
                elenco: 'Liste',
                espositori: 'Exposants',
                eventi: 'Événements',
                eventiCorrelati: 'Événements associés',
                header: 'Points d’intérêt',
                info: 'Infos et contacts',
                infoContatti: {
                    cellulare: 'Numéro de portable',
                    email: 'E-mail',
                    facebook: 'Facebook',
                    gestione: 'Gestion',
                    sitoWeb: 'Internet',
                    social: 'Réseaux sociaux',
                    telefono: 'Numéro de téléphone',
                    vaiAlSito: 'Aller sur le site',
                },
                istruzioniNoCategorie: 'Choisissez une catégorie',
                itinerariCorrelati: 'Itinéraires qui passent par ici',
                loadMore: "Charger d'autres POI",
                luoghiCorrelati: 'Lieux associés',
                macrocategorie: 'Macrocatégories',
                mappa: 'Carte',
                nessunPoiTrovato: 'Aucun résultat correspondant aux caractères de recherche sélectionnés',
                ospiti: 'Hôtes importants',
                placeholderRicerca: 'Chercher...',
                posizioneNonCoperta: 'Votre position ne se trouve pas dans une zone couverte.',
                promozioni: {
                    promoPerTe: 'Promotions vous étant réservées',
                    promoPerTutti: 'Disponible à tous les utilisateurs',
                },
                ricercaInfoTerritorio: 'Pour quel territoire cherchez-vous des informations ?',
                ricercaTutteCategorie: 'Chercher dans toutes les catégories',
                scegliCategoria: 'Sélectionner',
                scegliPoi: 'Sélectionnez un POI',
                scegliTerritorio: 'Liste des zones couvertes. Laquelle choisissez-vous ?',
                selezionaPoi: 'Sélectionnez un POI',
                selezionaTutto: 'Toutes',
                serviziInclusi: 'Services inclus',
                serviziUtili: 'Services utiles',
                specialitaCorrelate: 'Produits associés',
                staiCercandoAllCategories: 'Dans toutes les catégories',
                tab: {
                    allegati: 'Pièces jointes',
                    info: 'Infos',
                    mappa: 'Carte',
                },
                tutteLeCategorie: 'Toutes les catégories',
                vetrina: 'Vitrine',
                virtualTour: {
                    info: 'La visite virtuelle sera ouverte dans une fenêtre du navigateur de ce dispositif',
                    intro: 'Si vous souhaitez découvrir les merveilles de ce lieu, naviguez avec la visite virtuelle',
                    lancia: 'Lancez la visite virtuelle...',
                },
            },
            primoAvvio: {
                tutorial: {
                    biglietti: {
                        testo: 'Acheter des tickets et des abonnements en un clic',
                        titolo: 'Plus aucune file d’attente',
                    },
                    borsellino: {
                        testo: 'Et utilisez-le pour payer tous les services',
                        titolo: 'Rechargez votre crédit',
                    },
                    buoniMotivi: {
                        testo: 'Les bonnes raisons pour aimer myCicero',
                        titolo: 'À se lécher les babines',
                    },
                    dolomiti: {
                        scopriLeBellezze: {
                            testo: 'Découvrez les beautés des Dolomites avec nous',
                        },
                    },
                    masterpass: {
                        testo: 'Avec Masterpass de Mastercard il est sûr et vous avez immédiatement un bonus',
                        titolo: 'Enregistrez votre carte',
                    },
                    seguiIlViaggio: {
                        testo: "Ponctualité, prochains arrêts et horaires d'arrivée",
                        titolo: 'Suivez le voyage en train',
                    },
                    soluzioniDiViaggio: {
                        testo: 'Solutions intégrées avec train, bus et métro',
                        titolo: 'Planifier le voyage',
                    },
                    sosta: {
                        testo: 'Ne payez que les minutes effectives',
                        titolo: 'Économisez sur le stationnement',
                    },
                },
            },
            profilazione: {
                accedi: 'Accédez',
                accediAccount: 'Vous êtes déjà inscrit',
                aci: {
                    registrazioneEseguiLogin:
                        'Effectuez l’identification pour utiliser les fonctions mises à disposition par ACI sur votre compte myCicero.',
                    registrazioneUtenteEsistenteConTessera:
                        'Carte associé ACI correctement associée à l’utilisateur myCicero correspondant à l’utilisateur ACI.',
                    registrazioneUtenteNuovoConTessera:
                        "Enregistrement effectué. Trouvez les données d’identification pour accéder à l’e-mail envoyé à l'adresse associée à votre compte ACI. Votre carte associé ACI a été activée.",
                    registrazioneUtenteNuovoSenzaTessera:
                        "Enregistrement effectué. Trouvez les données d’identification pour accéder à l’e-mail envoyé à l'adresse associée à votre compte ACI.",
                },
                activateServices: 'Activez les services en une minute',
                alreadySubscribed: 'Vous possédez déjà un compte ?',
                associaFoto: 'Associer photo',
                azienda: 'Société',
                benvenuto: 'Bienvenue ',
                cambiaEmail: 'Changer l’e-mail',
                cap: 'C.P.',
                cartaRegistrata: 'Carte enregistrée',
                cell: 'Tél. mobile',
                cellFormatInvalid: 'Numéro de téléphone mobile pas valable.',
                cellulare: 'Téléphone mobile',
                checkAccetto: "J'accepte la ",
                checkComunicazioni: 'Recevez les communications et les nouveautés',
                checkCondizioniPrivacy: "J'accepte les ",
                checkCondizioniUtilizzo: 'J’ai lu les ',
                checkCondizioniUtilizzoAlternativelabel: 'J’ai lu le',
                chiudi: 'Fermer',
                citta: 'Ville',
                cittaNascita: 'Municipalité de naissance',
                cittaResidenza: 'Municipalité de résidence',
                codTessera: 'Numéro de carte',
                codiceCliente: 'Code client',
                codiceFiscale: 'Numéro fiscal',
                codiceUnivocoDestinatario: 'Code unique destinataire',
                cognome: 'Nom',
                cohesion: {
                    erroreRegistrazione: 'Enregistrement par le biais de Cohesion échoué',
                    labelHtml: 'Enregistrement par le biais de <b>Cohesion 2.0</b> :',
                },
                condizioniAltriFini: 'Autorisation envoi promotions',
                condizioniCommerciali: 'Informations commerciales',
                condizioniContrattuali: 'conditions contractuelles',
                condizioniDiUtilizzo: 'conditions d’utilisation',
                condizioniDiUtilizzoAlternativeLabel: 'politique de confidentialité',
                condizioniFiniCommerciali: 'Autorisation envoi matériel d’information',
                condizioniIscritti: 'Politique inscrits',
                condizioniPrivacy: 'conditions de confidentialité',
                condizioniUtilizzo: 'Conditions d’utilisation',
                condizioniUtilizzoCredito: 'Conditions d’utilisation Crédit',
                condizioniUtilizzoGenerali: 'Conditions générales d’utilisation',
                condizioniUtilizzoPrivacy: 'Conditions d’utilisation et confidentialité',
                condizioniUtilizzoSosta: 'Conditions d’utilisation Stationnement',
                condizioniUtilizzoTrasporto: 'Conditions d’utilisation Transport',
                confirmRollback:
                    'Ceci annulera les informations saisies jusqu’à maintenant. Vous souhaitez continuer ?',
                confirmation: 'Confirmer code PIN',
                contattaAssistenza: "Contactez l'assistance",
                continuaSenzaRegistrazione: 'Continuez sans enregistrement',
                continuaSenzaRegistrazioneAvvertimento:
                    'En continuant sans enregistrement il ne sera pas permis d’effectuer des achats',
                controllaCodice: 'Contrôler le code',
                controllaEmail: 'Contrôlez que l’e-mail saisi soit correct.',
                creaUtente: 'Créez votre utilisateur',
                creaUtenteDesc: 'Créez votre utilisateur en une minute...',
                dataNascita: 'Date de naissance',
                descrizionePromo: 'Vous possédez un code promotionnel ? Saisissez-le ici et activez la promotion',
                ebbeneSi: 'Oui, recommencer',
                email: 'Adresse e-mail',
                emailConfirmed: 'Compte e-mail confirmé avec succès',
                emailReminder:
                    ' Rappelez-vous de confirmer votre adresse e-mail par le biais du lien envoyé. Vous pouvez également le faire dans un deuxième temps.',
                emailSent: 'E-mail envoyé à ',
                erroreRegistrazioneCarta: 'L’enregistrement de la carte de crédit n’a pas réussi.',
                esclamaBenvenuto: 'Bienvenue !',
                fatturazioneElettronica: 'Facture électronique',
                fine: 'Fin',
                indirizzo: 'Adresse',
                indirizzoResidenza: 'Adresse de résidence.',
                infoMoficaDati:
                    'Pour des éventuelles modifications, avant de confirmer, contactez assistenza@mycicero.it ou appelez le +39 071 920 7000',
                infoNecessaria: 'Information nécessaire.',
                informativaFatturazione:
                    "L’émission d’une facture pour les titres de stationnement ou de voyage (trajets urbains) n'est pas obligatoire car HORS CHAMP TVA, car réglementée par l'art. 74 DPR 633/72, lettre e), qui introduit le régime de monophase dans la discipline TVA. Si une facture est demandée, celle-ci devra être émise et gérée comme facture électronique, avec une augmentation inévitable des coûts également pour l’acheteur qui devra conserver la facture électroniquement. Par conséquent, il est recommandé, dans la mesure du possible, de décharger gratuitement les frais engagés via le reçu émis lors de chaque achat. Si, en revanche, une facture est requise, une seule facture mensuelle sera émise récapitulant tous les stationnements activés dans les différentes villes desservies par myCicero, avec une charge annuelle maximale de 1,2 €/an. C'est avec grand plaisir que nous tenons à rappeler que les services de paiement du stationnement et du transport (bus-métro-train) offerts par myCicero, contrairement à d'autres concurrents, ne prévoient pas de frais périodiques, ni de commissions à la charge du client.",
                informativaPrivacy: 'Politique zone inscrits',
                inizia: 'Commencer',
                insertPinCode: "Saisissez le code d'activation",
                intestatario: 'Détails de la carte',
                inviaSms: 'Envoi SMS',
                inviaSmsConferma: 'Oui, envoyer',
                inviaSmsInfo: 'J’envoie de nouveau le code d’activation par SMS. En êtes-vous sûr ?',
                iscrizione: 'Vous êtes inscrit avec',
                iscrizioneNonCompletataPopupAnnullaEdElimina: 'Annuler et éliminer l’utilisateur',
                iscrizioneNonCompletataPopupCompletaIscrizione: 'Terminer l’inscription',
                iscrizioneNonCompletataPopupMsg:
                    'Nous avons essayé de créer un utilisateur mais la procédure a été interrompue',
                iscrizioneNonCompletataPopupTitle: 'Inscription pas terminée',
                iscrizioneServizi:
                    'Vous êtes déjà inscrit à un de ces services, vous pouvez utiliser les mêmes données d’identification',
                localitaProvenienza: 'Localité de provenance du vol',
                messaggioAssociaFoto:
                    'ATTENTION : Cette photo sera reportée sur votre abonnement et il ne sera plus possible de la changer',
                modelloVeicolo: 'Modèle véhicule',
                modelloVeicoloObbligatorio: 'Modèle véhicule',
                modelloVeicoloOpzionale: 'Modèle du véhicule (facultatif)',
                msgAssistenzaActv: 'app.support@avmspa.it',
                msgAssistenzaDefault: "assistenza@mycicero.it et centre d'appel 071 920 7000",
                nazione: 'Pays',
                nazioneNascita: 'Pays de naissance',
                nome: 'Prénom',
                nonHaiTessera: 'Vous ne possédez pas de carte ?',
                normativaPrivacy: 'Règlementation sur la confidentialité',
                numVolo: 'Num. vol de retour',
                numeroTelefonoConfermato: 'Numéro de téléphone confirmé',
                numeroVerde: 'Num. Vert',
                nuovoUtente: 'Nouvel utilisateur',
                partitaIva: 'Numéro de TVA',
                password: 'Mot de passe',
                passwordConfirm: 'Saisir de nouveau le mot de passe',
                passwordNotMatch: 'Les mots de passe ne correspondent pas.',
                pecEmail: 'Courrier électronique certifié destinataire',
                perAssistenza: "Pour de l'assistance envoyer un e-mail à :",
                perAssistenzaActv: "Pour de l'assistance envoyer un e-mail à :",
                perAssistenzaSito: "Pour l'assistance, cliquez sur ",
                perAssistenzaTelefono: 'Ou appelez :',
                perAssistenzaUlteriore: 'Pour des problèmes concernant la réception des tickets :',
                perInfo: 'Pour des informations : ',
                perUlterioriInfo: 'Pour de plus amples informations : ',
                perUlterioriInfoInfoActv: 'Pour de plus amples informations : ',
                pinCode: 'Confirmer code',
                pinCodeDesc: "Nous vous avons envoyé un SMS avec un code d'activation",
                privato: 'Particulier',
                procedi: 'Continuer',
                profiloPreferito: 'Profil favori',
                profiloPreferitoMessage: 'Ce profil sera utilisé comme en-tête des factures émises',
                promoCodePlaceholder: 'Saisissez le code promotionnel',
                promozioni: 'Promotions',
                provincia: 'Prov.',
                ragioneSociale: 'Raison sociale',
                recapiti: 'Adresses',
                registraNuovoUtente: 'Inscrivez-vous comme nouvel utilisateur',
                registratiOra: 'Enregistrez-vous maintenant',
                registrationCompleted: 'Enregistrement terminé.',
                registrationFailed: 'Enregistrement échoué',
                registrazione1: 'Enregistrement 1/2',
                registrazione2: 'Enregistrement 2/2',
                reinviaSMS: 'Envoyer de nouveau',
                requiredFields: 'Remplir tous les champs obligatoires.',
                resendBtn: 'Oui, envoie-le',
                resendOk:
                    'Je viens d’envoyer de nouveau le code d’activation par SMS. Vous devriez le recevoir d’ici peu.',
                resendText: 'J’envoie de nouveau le code d’activation par SMS. En êtes-vous sûr ?',
                resended: 'Code envoyé',
                rightNumber: 'Le numéro est-il correct ?',
                rimuoviProfilo: 'Éliminer profil',
                salvaModifiche: 'Sauvegarder les modifications',
                sendSms: ' Envoi SMS e-mail de confirmation ...',
                sendingEmailDesc: "En outre j'envoie un e-mail avec un lien d'activation à l'adresse : ",
                sendingSmsDesc: "J'envoie le code de confirmation par SMS au numéro : ",
                smsNotSent: 'SMS pas envoyé à ',
                smsSent: 'SMS envoyé à ',
                splitPayment: 'Entreprise en régime de Split Payment',
                startAgain: 'Changer numéro',
                targaObbligatoria: "Plaque d'immatriculation du véhicule",
                targaOpzionale: "Plaque d'immatriculation du véhicule (facultatif)",
                titoliAtac: 'Titres ATAC',
                titoloPersonale: 'Saisissez et/ou contrôlez les données de la carte d’abonné avant de confirmer',
                titoloPesonale: 'Carte transport',
                usaCodice: 'Utilisez le code',
                username: 'Nom d’utilisateur',
                vaiAllApp: "Commencez à utiliser l'application",
                vediPromo: 'Visualisez les promotions actives',
                verificaCodiceSms: 'Vérifier le code SMS',
                wrongNumber: 'Le numéro est-il erroné ?',
            },
            profiloUtente: {
                carte: 'Cartes de crédit enregistrées',
                impostazioniNotifiche: {
                    description:
                        'Prolongez et terminez le stationnement avec un clic directement à partir de la zone notifications de votre dispositif.',
                    header: 'Intégration zone notifications',
                    title: 'Configurations notifications',
                    toggleActive: 'Désactiver',
                    toggleInactive: 'Activer',
                },
                mostraCod: 'Montrer le code d’utilisateur',
                nessunaCarta: 'Aucune carte de crédit',
                nessunaTessera: 'Aucune carte associée',
                pref: 'Préférences',
                tessere: 'Cartes et contrats',
                title: 'Profil utilisateur',
            },
            promozione: {
                atmaBullet1:
                    'Faites scanner le code-barres qui identifie votre utilisateur par le lecteur placé sur les compacteuses écologiques',
                atmaBullet2:
                    'Insérez seulement les bouteilles en PET de 0,5 à 2 litres et recevez votre bonus écologique',
                atmaBullet3: 'Achetez les tickets en utilisant le bonus accumulé',
                bullet1:
                    'Faites scanner le code-barres qui identifie votre utilisateur par le lecteur placé sur les compacteuses écologiques',
                bullet2:
                    'Insérez seulement des bouteilles en PET de 0,5 à 2 litres et recevez votre bonus écologique. Vous pouvez en insérer maximum 30 par jour.',
                bullet3: 'Achetez les titres en utilisant le bonus accumulé',
                caricaNuovoBuono: 'Charger un nouveau bon',
                caricaNuovoCredito: 'Charger un nouveau crédit',
                compraAtac: 'Acheter des titres B+',
                compraAtma: 'Acheter des titres ATMA',
                dataOraMovimento: 'Date et heure',
                descrizione: 'Vous pouvez bénéficier du montant pour </br> acheter des titres',
                descrizioneMovimento: 'Description',
                elencoPromozioniMobilita: {
                    nessunaPromozione: 'Aucune promotion présente',
                    title: 'Liste des crédits',
                },
                importoMovimento: 'Montant',
                invalidTxt: 'La donnée saisie ne respecte pas le format prévu',
                istruzioniPrincipaliHTML:
                    '<span class="bold">Recyclez vos bouteilles en plastique et vous pourrez accumuler le crédit pour acheter des tickets et des abonnements <span class="bold atac-red">ATAC</span></span>',
                istruzioniPrincipaliHTMLATMA:
                    '<span class="bold">Recyclez vos bouteilles en plastique et vous pourrez accumuler le crédit pour acheter des tickets ATMA</span>',
                labelProfilo: 'ATAC Rome +Recyclages +Voyages',
                labelProfiloAtma: 'ATMA Ancône Recyclage Bouteilles',
                labelSaldo: 'Solde',
                movimenti: 'Mouvements',
                noMovimenti: 'Il n’y a pas de mouvements à visualiser',
                scadenza: 'Expiration ',
                titoliBAtac: 'B+ ATAC',
                titoliBAtma: 'ATMA',
                tuttiMovimenti: 'Tous les mouvements',
                txtInstructions:
                    'Saisissez les données demandées et vérifiez le code bon pour recharger le crédit relatif à',
                ultimiMovimenti: 'Derniers mouvements',
                usaCreditiMobilita: 'Utilisez les crédits de mobilité',
                utilizzoEcobonus: 'Utilisation bonus écologique ({0} €)',
            },
            rockinroma: {
                atac: 'Tickets ATAC',
                festival: 'Festival',
                lineUp: 'Lineup',
                location: 'Lieu',
                mieiTitoli: 'Mes titres',
                tickets: 'Tickets',
                travel: 'Travel',
                treniDelRock: 'Trains après concert',
            },
            rss: {
                dettaglioHeader: 'Détail',
                filterPlaceholder: 'Chercher...',
                latestNews: 'Dernières nouveautés',
                news: 'Nouveautés',
                newsFontiNotificheHeader: 'Liste des feeds',
                newsNotificheHeader: 'Nouveautés et notifications',
                noResults: 'Aucun résultat',
                scegliFeed: 'Choisissez le feed',
                updating: 'Contrôle nouveautés...',
            },
            rundetails: {
                nodata: {
                    empty: 'aucun détail trouvé',
                },
                realTime: {
                    arrivoPrevisto: 'Arrivée prévue',
                    arrivoReale: 'Réel',
                    arrivoStimato: 'Estimé',
                    binarioPrevisto: 'Voie prévue',
                    binarioReale: 'Réel',
                    inAnticipo: "à l'avance",
                    inOrario: 'à l’heure',
                    inRitardo: 'en retard',
                    minuti: 'minutes',
                    minuto: 'minute',
                    partenzaPrevista: 'Départ prévu',
                    partenzaReale: 'Réel',
                    ultimoRilevamento: 'Dernière détection : ',
                },
            },
            sanzioni: {
                cercaVerbale: 'Chercher procès-verbal',
                codiceFiscale: 'Numéro fiscal',
                codiceInfrazione: 'Code infraction',
                cognome: 'Nom',
                cognomeSanzionato: 'Nom sanctionné',
                controllareDatiInseriti: 'Contrôler les données saisies.',
                data: 'Date',
                dataNascita: 'Date de naissance',
                dataVerbale: 'Date du procès-verbal',
                datiIncompleti: 'Données incomplètes',
                datiSanzionato: 'Données sanctionné',
                datiVerbale: 'Données procès-verbal',
                descrizione: 'Description',
                dettaglioVerbale: 'Détail procès-verbal',
                erroreIdSistema: 'ID système pas spécifié',
                idVerbale: 'ID procès-verbal',
                importoBiglietto: 'Montant du ticket',
                infoDatiVerbale: 'Saisissez les données nécessaires pour la recherche du procès-verbal.',
                noVettoriAbilitatiPagamentoSanzioni: 'Aucun transporteur autorisé pour le paiement des sanctions.',
                nome: 'Prénom',
                nomeSanzionato: 'Prénom sanctionné',
                numero: 'Numéro',
                numeroVerbale: 'Numéro procès-verbal',
                pagamentoSanzioni: 'Paiement sanctions',
                sanzionato: 'Sanctionné',
                sanzione: 'Sanction',
                serialeVerbale: 'Numéro de série procès-verbal',
                serie: 'Série',
                speseAmministrative: 'Frais administratifs',
                totale: 'Total',
                verbale: 'Procès-verbal',
                verbaleNonPagabile: '<b>Procès-verbal déjà payé</b>',
                verbaleNonTrovato: '<b>Procès-verbal pas trouvé</b><br>Contrôlez les données saisies.',
            },
            selectPositionOnMap: {
                areaNonServitaHtml:
                    'Pour des informations, contactez-nous au <a href="tel:+390719207000">+39&nbsp;071&nbsp;9207000</a> ou <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.mycicero.it/chat/\',true)">par chat</a>',
                areaNonServitaLabel: 'Sélectionner un point valide sur la carte.',
                areaNonServitaTitle: 'Zone pas desservie',
                disclaimerBtn: "J'ai compris",
                disclaimerMsg: 'Assurez-vous d’indiquer correctement la position',
                ricercaLocalitaInCorso: 'Recherche localité en cours...',
                scegli: 'Choisir',
                warningAumentaZoom: 'Augmentez le zoom',
                warningZoomInsufficiente: 'Augmentez le zoom pour identifier votre position',
            },
            selezionaModalitaDiPagamento: {
                comeVuoiPagare: 'Comment souhaitez-vous payer ?',
                modalita: {
                    acipg: 'ACI Pay',
                    amonw: 'Cartes de paiement',
                    bbol: '',
                    bill: 'Bill by SisalPay',
                    brsel: 'Crédit myCicero',
                    cc: '',
                    ccric: 'Cartes de paiement',
                    'ccs-2-s': '',
                    mpass: 'Masterpass™',
                    pbemo: 'BeMoov',
                    ppay: 'Postepay',
                    ppexp: 'PayPal',
                    ppric: 'PayPal',
                    sisal: 'SisalPay',
                    stpay: 'SatisPay®',
                },
            },
            serCom: {
                NessunServizioAzienda: 'Il n’y a pas de service autorisé pour l’utilisateur avec profil d’entreprise',
                NessunServizioPrivato: 'Il n’y a pas de service autorisé pour l’utilisateur particulier',
                avvisiPagamento: {
                    header: 'Avertissements de paiement',
                    inScadenza: 'En échéance ou à payer',
                },
                azienda: 'Société',
                certificazioneInfoHTML:
                    "Pour visualiser les avertissements de paiement envoyés par les organismes, vous devez être un utilisateur certifié. Pour certifier votre utilisateur il suffit de vous rendre, avec un document d’identité, dans les bureaux d’une des municipalités autorisées, ou d’utiliser, dans l'espace réservé Internet accessible à partir du PC, les données d’identification d’un des systèmes de certifications fédérés (Cohésion)",
                comune: 'Municipalité',
                comuniRecenti: 'Municipalités visualisées récemment',
                comuniSerCom: 'Municipalités qui exposent des services municipaux',
                contattaAssistenza: 'Veuillez contacter l’assistance',
                contatti: 'Contacts',
                costoServizio: 'Coût du service',
                dataInfrazione: 'Date infraction',
                elencoMovimenti: {
                    header: 'Liste des mouvements',
                    noResults: "Aucun mouvement n'est présent pendant la période spécifiée",
                    ricercaMovimenti: 'Effectuer recherche',
                },
                mainHeader: 'Services municipaux',
                nessunImportoDovuto: 'Le montant dû est égal à 0, aucun paiement nécessaire !',
                news: {
                    header: 'Nouveautés et communications',
                },
                oraInfrazione: 'Heure de l’infraction',
                pagamentiSpontanei: {
                    compilaTutto: 'Attention : veuillez remplir tous les champs requis',
                    header: 'Paiement services',
                    pagSpontaneo: 'Paiement spontané',
                },
                pagamento: {
                    dataEmissione: "Date d'émission",
                    dataFine: 'Date de fin',
                    dataInizio: 'Date de début',
                    dataSanzione: 'Date de sanction',
                    dataScadenza: "Date d'expiration",
                    descr: 'Description',
                    errorePagamento: "Une erreur s'est produite pendant le paiement.",
                    header: 'Paiement',
                    importoDaPagare: 'Montant à payer',
                    importoNonValido: 'Montant pas valable.',
                    pagamentoGuidato: 'Paiement guidé',
                    scegliData: 'Choisissez la date',
                    soggetto: 'Sujet',
                    targa: "Plaque d'immatriculation",
                    verbale: 'Procès-verbal',
                },
                pagamentoEffettuato: 'Paiement effectué',
                pagamentoNonAbilitato: 'Paiement pas autorisé',
                privato: 'Particulier',
                richiediCert: 'Demander certification',
                richiediCertInfoHTML:
                    'Vous serez dirigé vers votre espace réservé Internet accessible <strong>par le biais d’un PC traditionnel.</strong>',
                segnalazioni: {
                    cat: 'Catégorie',
                    descr: 'Description',
                    header: 'Signalisation',
                    img: 'Image',
                    indirizzo: 'Adresse signalisation',
                    inserite: 'Signalisations insérées',
                    invia: 'Envoi signalisation',
                    noCategorie: "Aucune catégorie n'est disponible pour votre position.",
                    nuova: {
                        abbandona: 'Abandonner la signalisation et sortir',
                        attendiCaricamentoImmagine: 'Attendez le chargement de l’image',
                        caricamentoImmagineFallito: 'Chargement de l’image échoué',
                        fail: 'Impossible de sauvegarder la signalisation !',
                        header: 'Nouvelle signalisation',
                        inserisciQui: 'Saisissez la signalisation ici',
                        success: 'Signalisation sauvegardée avec succès',
                        torna: 'Retour à la signalisation',
                    },
                    subCat: 'Sous-catégorie',
                    tue: 'Vos signalisations',
                    welcome: 'Bienvenue !',
                    welcomeIntroTemplate:
                        "<p>Sur cette page vous pouvez envoyer une signalisation au {0}.</p><p>Tout d'abord, choisissez une des {1} catégories disponibles :</p>",
                },
                serviziAbilitatiAzienda: 'Services activés pour l’utilisateur avec profil d’entreprise',
                serviziAbilitatiPrivato: 'Services activés pour l’utilisateur particulier',
                tipoSoggetto: 'Type de sujet',
                tornaAiServizi: 'Retour aux services',
                totale: 'Total',
                transazioneOK: 'La transaction a réussi',
                utenteNonCertificato: 'Utilisateur pas certifié',
            },
            siae: {
                acquistaBiglietti: 'Acheter des tickets',
                chooseSector: {
                    apriMappa: 'Ouvrir la carte',
                    headerScegliDaLista: 'Sélection places automatique',
                    headerScegliDaMappa: 'Sélection places manuelle',
                    noSettori: 'Aucun secteur trouvé',
                    scegliBiglietti: 'Choisissez les tickets',
                },
                mieiBiglietti: 'Mes tickets',
                myTickets: {
                    mieiTitoli: 'Mes tickets',
                    passati: 'Passés',
                    validi: 'Valables',
                },
                posto: 'Place',
                seasonTicket: 'Abonnement',
                settore: 'Secteur',
                ticketDetails: {
                    carta: 'Carte',
                    cfOrganizzazione: 'NF Org.',
                    cfTitolo: 'NF Tit.',
                    data: 'Date',
                    idSistema: 'ID Système',
                    progressiva: 'Progressif',
                    sf: 'S.F:',
                    tipoEvento: 'Type événement',
                },
                ticketsSummary: {
                    commissioni: 'Commissions de service',
                    pagaConCarta: 'Payez par carte de crédit',
                    prevendita: 'Prévente',
                    removeTicketConfirm: 'Êtes-vous sûr de vouloir éliminer cet article ?',
                    staiPerAcquistare: 'Vous êtes sur le point d’acheter',
                },
            },
            smartArea: {
                cambiaCitta: 'Changer ville...',
                confermaReset: 'Toutes les données de la Zone Smart mémorisées localement seront éliminées.',
                defaultTitleHtml: 'Le monde des services smart',
                nonScegliNulla: 'Ne rien choisir...',
                oppureAreaSmartHtml: 'Ou sélectionnez un territoire <i>smart</i> :',
                reset: 'Éliminer les données locales de la Zone Smart',
                resetDone:
                    'Données éliminées. À votre prochain accès à la page d’accueil, les données seront rechargées.',
                scegli: 'Choisissez ville smart',
                seiQui: 'Vous êtes ici ',
                selezionaAreaSmart: 'Sélectionnez un territoire ou une ville smart',
                servizioNonDisponibile: 'Service pas disponible en ce moment.',
            },
            solutions: {
                acquista: {
                    aPiedi: 'à pied',
                    arrivo: 'arrivée',
                    articolo: 'article',
                    dilloAlVettore: 'Oui, j’aimerais pouvoir acheter cette solution de voyage',
                    dilloAlVettorePre:
                        'La solution de voyage ne peut pas encore être achetée. Vous voulez nous le signaler ?',
                    dilloAlVettoreStatement: 'La solution de voyage ne peut pas encore être achetée.',
                    durata: 'durée',
                    fromStop: "à partir de l'arrêt",
                    header: 'Acheter solution',
                    importo: 'montant',
                    infoAddizionali: 'Infos supplémentaires',
                    nonDisponibile: 'Pas disponible',
                    partenza: 'départ',
                    toStop: "à l'arrêt",
                    tratta: 'trajet',
                },
                dialog: {
                    partenzaArrivoUguali:
                        'Le départ et la destination correspondent. Il n’existe pas de solutions de voyage.',
                },
                fav: {
                    header: 'Sauvegarder solution',
                    info:
                        "Enregistrez cette solution de voyage parmi les favoris « pour pouvoir la retrouver rapidement à l'avenir »",
                },
                form: {
                    cercasoluzioni: 'Chercher solutions de voyage',
                    elimina: 'Éliminer',
                    itinerariPreferiti: 'Itinéraires favoris',
                    nessunPreferito: 'Aucun favori',
                    preferiti: 'Favoris',
                    recenti: 'Récents',
                    searchbutton: 'Recherche',
                },
                list: {
                    arrivi: 'arrivées',
                    arrivo: 'arrivée',
                    loadMore: 'Charger d’autres solutions',
                    ordinaPerDataArrivoAsc: "Par heure d'arrivée",
                    ordinaPerDataDiPartenzaAsc: 'Par heure de départ',
                    ordinaPerDataDiPartenzaDesc: 'Horaire départ ↓',
                    ordinaPerDurataTragittoAsc: 'Par durée',
                    ordinaPerDurataTragittoDesc: 'Durée voyage ↓',
                    ordinaPerNumCambiAsc: 'Nombre de changements',
                    ordinaPerPrezzoAsc: 'Prix le plus bas',
                    ordinaPerPrezzoDesc: 'Prix le plus haut',
                    ordinaRisultati: 'Trier les solutions',
                    partenza: 'départ',
                    partenze: 'départs',
                },
                nodata: {
                    empty: 'Aucune solution de voyage trouvée',
                },
                nome: 'Nom solution',
                type: {
                    auto: 'Voiture',
                    autobus: 'Autobus seulement',
                    busTreni: 'Autobus et trains',
                    pedonale: 'À pied',
                    treno: 'Train seulement',
                },
            },
            stopdetails: {
                nodata: {
                    empty: 'aucun détail trouvé',
                },
                settings: 'Configurations arrêt',
            },
            stops: {
                arrivi: "Arrivées à l'arrêt",
                fav: {
                    conferma: "L'arrêt a été ajouté à vos arrêts préférés",
                    header: 'Sauvegarder arrêt',
                    info: "Enregistrez cet arrêt parmi les « Favoris » pour pouvoir le retrouver rapidement à l'avenir",
                    nomePreferito: 'Nom favori',
                },
                partenze: "Départs à partir de l'arrêt",
            },
            summerjamboree: {
                alloggi: 'Où loger',
                festival: 'Le festival',
                foodAndBeverages: 'Food & Drink',
                locations: 'Les lieux',
                mappa: 'La carte',
                mercatino: 'Vintage Market',
                navette: 'Train du rock et navettes',
                programma: 'Le programme',
            },
            sunsen: {
                cercaAlloggio: 'Chercher logement',
                elencoTornei: 'Liste des tournois',
                home: {
                    classifica: 'Résultats et classements',
                    eventi: 'Événements',
                    informazioni: 'Informations',
                    iscrizioni: 'Inscriptions',
                    partners: 'Partenaires',
                    sosta: 'Stationnement',
                    trasporto: 'Transport',
                },
            },
            taxi: {
                common: {
                    aggiornatoAlle: 'Mis à jour à',
                    descrAnnullata: 'Réservation annulée',
                    descrArrivato: 'Arrivé',
                    descrConfermata: 'Réservation confirmée',
                    descrDaConfermare: 'En attente de confirmation',
                    descrInArrivo: 'Arrivée dans {0} minutes',
                    descrPagato: 'Payé ({0} €)',
                    ultimoAggiornamento: 'Dernière mise à jour',
                },
                dettaglio: {
                    annullaPrenotazione: 'Annuler la réservation',
                    dataAssegnazione: 'Date attribution',
                    pagaTaxi: 'Payer le taxi',
                    promptHeader: 'Annuler',
                    promptKo: 'Non',
                    promptMessage: 'Êtes-vous certain de vouloir annuler cette réservation ?',
                    promptOk: 'Oui',
                    title: 'Détail réservation',
                },
                home: {
                    aggiornamentoInCorso: 'Mise à jour des données en cours...',
                    miePrenotazioni: 'Mes réservations',
                    paga: 'Payer',
                    prenota: 'Demander',
                    title: 'Recherche taxi',
                },
                mappa: {
                    disclaimerBtn: "J'ai compris",
                    disclaimerMsg: 'Assurez-vous d’indiquer exactement ou vous vous trouvez',
                    procedi: 'Continuer',
                    title: 'Recherche taxi',
                    warningZoomInsufficiente: 'Augmentez le zoom pour identifier votre position',
                },
                pagamento: {
                    importoViaggio: 'Montant voyage',
                    numeroLicenza: 'Numéro licence',
                    pagamentoEffettuato: 'Le paiement du voyage a été effectué avec succès.',
                    promptNumeroLicenza: 'Demandez au chauffeur de taxi son numéro de licence',
                    scansiona: 'Scanner',
                    scegliComePagare: 'Choisissez comment payer',
                    title: 'Payer le taxi',
                    totale: 'Total',
                },
                prenotazione: {
                    conferma: 'Confirmer',
                    promptHeader: 'Recherche taxi',
                    promptMessage:
                        'Nous sommes dans l’attente de recevoir une confirmation de la centrale opérationnelle.',
                    promptNote:
                        'Vous recevrez un e-mail de confirmation quand la réservation sera acceptée et le taxi attribué. En cas de demande en différé, celle-ci aura lieu quelques minutes avant l’horaire indiqué.',
                    title: 'Demande taxi',
                },
            },
            tessere: {
                EliminaFail: 'Une erreur s’est produite pendant l’élimination de la carte.',
                EliminaSuccess: 'La carte a été éliminée.',
                EliminaTesseraConf: 'Vous souhaitez vraiment éliminer cette carte ?',
                aggiungiTesseraTrasporto: 'Ajouter une carte...',
                apriControllo: 'Ouvrir contrôle',
                attivaTessera: 'Activer carte',
                card: 'Carte',
                cerca: 'Chercher carte',
                cercaAttiva: "Chercher la carte et l'activer...",
                cercaPlaceHolder: 'Nom carte ou contrat',
                chiudiControllo: 'Fermer contrôle',
                codice: 'Code carte',
                dettagliTessera: 'Détails carte et contrat',
                haiTessera: 'Vous possédez une carte ?',
                identificativoTessera: 'Identifiant carte',
                inAttesaValidazione: 'En attente de confirmation.',
                inserisciCodice: 'Saisissez le code de la carte',
                inserisciIdentificativoTessera:
                    "Saisissez le numéro d’identification de la carte pour effectuer l'achat du titre de voyage",
                noResultTessere: 'Aucune carte disponible',
                noResultTessereTrasporto: 'Aucune carte disponible',
                nomeTesseraContratto: 'Nom carte ou contrat',
                nonAttiva: 'Carte pas encore active',
                rimuovi: 'Éliminer la carte',
                scegliVettoreTessera: 'Choisissez le transporteur',
                siHoTesseraVettore: 'Oui, j’ai une carte ',
                tessera: 'Carte : ',
                tesseraRegistrata: 'Carte enregistrée avec succès',
                toBeCertified: "Cette carte demande une certification manuelle de la part de l'administrateur",
                tutte: 'Toutes les cartes',
                valida: 'Carte valable',
                validita: 'Validité',
                verifica: 'Vérifier',
            },
            tir: {
                login: {
                    appName: 'TRANSPark',
                    appNonDisponibile: "L’application n’est pour l'instant pas disponible sur Windows Phone",
                    areeStazioni: 'Zones de stationnement et stations-service',
                    cerca: 'Chercher mouvements',
                    cercaParcheggi: 'Chercher parkings',
                    codice: 'Code d’utilisateur',
                    scarica: 'Télécharger l’application',
                    targa: "Plaque d'immatriculation du véhicule",
                    testo1:
                        'Projet européen (<a href="javascript:openLinkOnBrowser(\'http://www.cogistics.eu\')">www.cogistics.eu</a>) pilote à Trieste pour la promotion du service de stationnement TIR.',
                    testo2:
                        "Ci-dessous, les transporteurs peuvent visualiser les arrêts effectués à la zone de stationnement de l’interport de Trieste dans la section Mouvements stationnements ou trouver des zones de stationnement et des stations-service par le biais du lien vers l'application Transpark de IRU.",
                    testo3: 'Réservé aux transporteurs en stationnement auprès de l’interport de Trieste.',
                    title: 'Stationnement TIR',
                    titoloApp: 'Application TransPark',
                    titoloMovimenti: 'Visualiser Mouvements stationnements',
                },
                movimenti: {
                    nessuno: 'Il n’y a pas de mouvement présent.',
                    title: 'Liste des mouvements',
                },
            },
            tours: {
                allCategories: 'Toutes les catégories',
                arrivi: 'Arrivées',
                cercaPrenota: 'Chercher et réserver un tour',
                definisciRaggio: 'Définissez le rayon de recherche dans les alentours de : ',
                dettaglio: 'Détail tour',
                elenco: 'Liste',
                inPartenzaEntro: 'Tour au départ avant',
                info: 'Infos',
                itinerario: 'Itinéraire',
                mappa: 'Carte',
                nomeTour: 'Nom tour',
                partenze: 'Départs',
                raggioRicerca: 'Rayon de recherche : ',
                vetrina: 'Vitrine',
                viaggioOrg: 'Voyages organisés',
                warnTariffe:
                    'Le prix indiqué fait référence au tarif de base. Vérifier à l’intérieur pour la liste complète.',
            },
            tplfvg: {
                AcquistaBiglietti: 'Acheter des tickets',
                CalcolaPercorso: 'Calcul du parcours',
                Eventi: 'Événements',
                FermateOrari: 'Arrêts et horaires',
                Luoghi: 'Lieux',
                MieiTitoli: 'Mes titres',
                ServiziTuristici: 'Services touristiques',
                accediRegistrati: 'Accédez / Enregistrez-vous',
                loginMessage:
                    "Pour pouvoir utiliser cette application, il est nécessaire d'accéder comme utilisateur enregistré <b>TPLFVG</b>.",
                newsEventi: 'Info-mobilité et événements',
                rivendite: 'Reventes',
            },
            trasportoGT: {
                accedi: {
                    header: 'Accédez au GT',
                },
                elencoMovimenti: {
                    header: 'Liste des mouvements',
                },
                header: 'Bus longue distance',
                mieiAbbonamenti: {
                    goToMyAbbonamenti: 'Aller à « Mes abonnements »',
                    header: 'Mes abonnements',
                    infoTitoliAcquistati:
                        'Vous pouvez trouver le titre de voyage dans la section « Mes abonnements » du « Transport GT »',
                },
                mieiBiglietti: {
                    aggiornaElenco: 'Mettre liste à jour...',
                    elencoBigliettiDaObliterare: 'Liste des titres achetés à oblitérer',
                    elencoBigliettiScaduti: 'Liste des titres expirés',
                    elencoBigliettiUsati: 'Liste des titres utilisés',
                    elencoBigliettiValidi: 'Liste des titres en cours de validité',
                    goToMyTickets: 'Aller à « Mes titres »',
                    header: 'Mes titres',
                    infoTitoliAcquistati:
                        'Vous pouvez trouver le ticket acheté dans la section « Mes titres » du « Transport interrégional »',
                    nessunBigliettoTrovato: 'Aucun titre de voyage n’a été trouvé',
                    obliterati: 'Oblitérés et validés',
                    ore: 'heures',
                    partenza: 'Départ',
                    scadenzaTime: 'valide jusqu’à',
                    validoFinoAl: 'Valable jusqu’à',
                },
                soluzioniViaggio: {
                    andata: 'Aller',
                    arrivoA: 'Arrivée à',
                    avvisoDataDifferente:
                        'Il n’y a pas de solutions pour la date choisie.  Les premières solutions disponibles suivent.',
                    cercaFraLocalitaElencate: 'Chercher parmi les localités énumérées.',
                    cercaSoluzioni: 'Solutions de voyage',
                    descrizioneViaggio: 'Description du voyage',
                    dettaglio: 'Détail solution',
                    dettaglioAndata: 'Détail aller',
                    dettaglioRitorno: 'Détail retour',
                    header: 'Solutions de voyage',
                    infoCoperturaHTML:
                        '<b>Le système</b> couvre tout le territoire national. Vérifiez quelles municipalités de votre zone sont atteintes par le service de transport interrégional...',
                    infoPasseggero: 'Informations sur le passager',
                    localitaDestinazione: 'Localité de destination',
                    localitaPartenza: 'Localité de départ',
                    maxUnCambio: 'Maximum un changement',
                    mostraSoluzioni: 'Montrer les solutions',
                    mostraTutteLeDestinazioni:
                        'Je montre toutes les destinations rejoignables de la localité de départ',
                    nessunCambio: 'Aucun changement',
                    nomeObbligatorio: 'Nom obligatoire',
                    partenzaDa: 'Départ depuis',
                    riassuntoInfoAcquisto: 'Récapitulatif informations d’achat',
                    ritorno: 'Retour',
                    scegliDataRitorno: 'Choisissez la date de retour',
                    scegliRitorno: 'Choisissez le voyage de retour',
                    scegliTariffa: 'Choisissez un tarif',
                    selezionaDest: 'Choisissez une localité de destination',
                    soluzioneSenzaPosti: 'la solution sélectionnée n’a pas de places libres disponibles',
                    tariffa: 'Tarif',
                    tratta: 'Trajet',
                    tutteLeSoluzioni: 'Toutes les solutions',
                    viaggioRitorno: 'Voyage de retour',
                    zoneCoperte: 'Zones rejoignables par le service',
                },
            },
            trasportoRegionale: {
                acquistaBiglietti: 'Achetez un titre',
                acquistaSMS: {
                    acquistaAltroBiglietto: 'Achetez un autre ticket',
                    confermaAcquistoTitolo: 'Le titre de voyage a été acheté',
                    elencoTitoliAcquistabili: 'Liste des titres pouvant être achetés',
                    erroreAcquisto: "Une erreur s’est produite. Vous souhaitez réessayer l'achat ?",
                    header: 'Achetez par SMS',
                    infoObliterazioneAuto: 'Le ticket que vous venez d’acheter a été oblitéré automatiquement',
                    infoObliterazioneBiglietti: 'chaque ticket acheté doit être oblitéré avant d’être utilisé',
                    invioManualeSmsInfo:
                        'Impossible d’envoyer le message. Envoi d’un SMS au numéro {0} avec le texte {1}',
                    invioManualeSmsTitle: 'Envoi manuel SMS',
                    noArticoliVendibili: "Il n'existe pas d’articles pouvant être vendus",
                    riassuntoInfoBiglietto: 'Récapitulatif informations ticket',
                    richiestaInoltrataInfo:
                        'Cher client, si la demande a réussi, vous recevrez d’ici peu le titre acheté par SMS',
                    richiestaInoltrataTitle: 'Demande envoyée',
                },
                acquistaScaffale: {
                    elencoTitoliAcquistabili: 'Titres pouvant être achetés à tarif fixe',
                    elencoTitoliAcquistabiliActv: 'Liste des titres de voyage ACTV pouvant être achetés',
                    elencoTitoliAcquistabiliMomup: 'Titres pouvant être achetés à tarif fixe sans supplément',
                    gotoTitoliGT: 'Achetez des titres avec réservation',
                    gotoTitoliSMS: 'Achetez par SMS',
                    header: 'Achetez un titre',
                    headerActv: 'Achetez des titres ACTV',
                    infoAcquistoSms:
                        "Ce titre de voyage sera acheté en utilisant le <span class='bold'>crédit téléphonique</span> associé au numéro de téléphone que vous utilisez.<br/> <br/>Le système de vente SMS ne prévoit pas l'achat de titres de voyage de montants différents et inférieurs par rapport à ceux de voyage complet de terminus à terminus. Il n'y a donc aucun remboursement prévu pour les trajets plus courts.</br> </br>Tous les titres de voyage ne sont pas remboursables<br/> <br/>Après l'envoi de la demande, vous recevrez un SMS de confirmation à utiliser comme titre de voyage",
                    infoCoperturaATAC:
                        'Les titres peuvent être utilisés sur tous les services de surface du circuit Metrebus : bus ATAC, trams et trolleybus Atac, moyens de transport Roma TPL et Cotral.<br />Dans les métros, le service peut être utilisé sur les lignes A, B, B1, la ligne de chemin de fer Rome-Lido et à la gare Flaminio de la ligne de chemin de fer Rome-Viterbe.<br /><br />Le service sera prochainement actif sur tout le trajet Rome-Viterbe et sur la ligne C.<br />',
                    infoCostiSms:
                        'Au coût du ticket doit être ajouté le coût de l’SMS de demande, qui change en fonction de l’opérateur téléphonique auquel il appartient.',
                    infoObliterazioneAuto: 'le titre que vous venez d’acheter a été oblitéré automatiquement',
                    infoObliterazioneBiglietti: 'chaque ticket acheté doit être oblitéré avant d’être utilisé',
                    infoObliterazioneContestuale: 'L’oblitération est contextuelle à l’achat.',
                    infoTrenitaliaATAC:
                        'Conformément à la directive Atac Spa, les titres électroniques (Bit 100 et AIMOP) ne sont momentanément pas valables sur les moyens de transport Trenitalia. Pour tout besoin, vous pouvez nous contacter en écrivant à assistenza@mycicero.it ou en appelant le numéro +39 0719207000.',
                    noArticoliVendibili: "Il n'existe pas d’articles pouvant être vendus",
                    origineDestinazione: 'Acheter à partir de solutions de voyage',
                    polimetrica: 'Abonnements extra-urbains',
                    polimetrica2: 'Abonnements extra-urbains',
                    riassuntoInfoBiglietto: 'Récapitulatif informations ticket',
                    rinnovaAbbonamenti: 'Renouveler es ’abonnements',
                    scegliTitoliTessera: 'Achat titres par carte',
                    scegliTitoliTesseraActv: 'Achat titres par carte',
                    smsDiAcquisto: 'Numéro de téléphone : {0} <br/> Message : {1}',
                    titoliGT: 'Titres avec réservation',
                    titoliTessera: 'Titres sur carte',
                    titoloSelezioneTessera: 'Achat titres sur carte',
                },
                acquistoTitoli: {
                    acquistaGratis: 'Téléchargez gratuitement',
                    scegliComePagare: 'Choisissez comment payer',
                    scegliComePagareFmt: 'Choisissez comment payer {0}',
                    scegliTipologia: 'Choisissez le type',
                    tipiDiAttivazione: {
                        automatica: "Le titre est déjà actif au moment de l'achat.",
                        multipla:
                            'Le titre doit être activé manuellement à la première utilisation. Il faut en outre valider à chaque accès aux moyens de transport.',
                        normale: 'Le titre doit être activé manuellement à la première utilisation.',
                        obbligatoria: 'Le titre doit être activé manuellement à la première utilisation.',
                    },
                    tipoDiAttivazione: 'Type de validation :',
                },
                alCompleto: 'Terminé',
                anticipo: 'Avance',
                arrivi: 'Arrivées',
                avvisoSD:
                    "Cher utilisateur, nous avons vérifié l'apparition éventuelle d'anomalies de fonctionnement lors de l'installation de l'application dans la mémoire externe (carte SD) ; pour cette raison, à partir des versions futures, l'application ne sera installée que dans la mémoire interne. Pour éviter des dysfonctionnements, nous vous invitons à procéder dès maintenant et de manière autonome au déplacement manuel. Nous nous excusons pour le dérangement. Pour toute information, contactez-nous à assistenza@mycicero.it ou au 071 920 7000",
                avvisoSDAVM:
                    "Cher utilisateur, suite à des anomalies qui se produisent lorsque l'application est installée sur la carte SD, à partir des versions futures, celle-ci ne sera installée que dans la mémoire interne. Pour éviter des dysfonctionnements, nous vous invitons à procéder dès maintenant au déplacement manuel. Nous nous excusons pour le dérangement. Pour des informations, écrivez à app.support@avmspa.it",
                cercaFermate: {
                    cercoPassaggi: 'Je cherche des accompagnements...',
                    codDescriz: 'Code /Description',
                    comune: 'Municipalité dans laquelle chercher',
                    elencoFermate: 'Liste des arrêts',
                    elencoFermateTuaPosizione: 'Liste des arrêts dans les alentours de la position',
                    header: 'Chercher arrêts',
                    headerActv: 'Recherche horaires et parcours',
                    indirizzo: 'Adresse',
                    indirizzoFermata: 'Adresse/Arrêt',
                    inserisciIndirizzo: 'Saisissez l’adresse',
                    intornoA: 'Montrer arrêts dans les alentours de :',
                    lineeServite: 'Lignes desservies',
                    mostra: 'Montrer arrêts',
                    mostraFermate: 'Montrer arrêts ...',
                    msgNoFermatePreferite:
                        'Il n’y a pas d’arrêts favoris enregistrés</p><p>Pour en ajouter un, appuyez sur la touche « Sauvegarder » dans le détail de chaque arrêt.</p> »',
                    nessunaFermata: 'Aucun arrêt trouvé.',
                    nessunaLocalita: 'Aucune localité trouvée',
                    noFermateVicine: 'Il n’y a pas d’arrêt à proximité de la position actuelle',
                    noLineeServite: 'Aucune ligne desservie',
                    noPassaggi: "Il n’y a pas d'accompagnements",
                    oppure: 'Ou...',
                    passaggiNonPrevisti: 'Aucune arrivée/aucun départ ne sont prévus',
                    ricerca: 'Recherche arrêts',
                    ricercheRecenti: 'Recherches récentes',
                    stazioneIndirizzo: 'Gare ou adresse',
                    tramiteCodDescr: 'Par code ou description',
                    tuttiPassaggi: 'Tous les passages à cet arrêt',
                },
                cercaLinee: {
                    comune: 'Municipalité dans laquelle chercher',
                    header: 'Chercher lignes',
                    indirizzo: 'Adresse...',
                    intornoA: 'Lignes qui passent aux alentours de',
                    mostra: 'Montrer lignes',
                    nessunaLineaTrovata: 'Aucune ligne n’a été trouvée',
                    oppure: 'Ou...',
                    ricerchePreferite: 'Favoris',
                    ricercheRecenti: 'Récents',
                    tramiteCodDescr: 'Par code ou description',
                },
                cercaLocalita: 'Chercher localité',
                cercaVettore: 'Chercher transporteur',
                comuneAziendaEvento: 'Municipalité / Entreprise / Événement',
                daConvalidare: 'À valider',
                daObliterare: 'À oblitérer',
                daValidare: 'À activer',
                dettaglioCorsa: 'Détail voyage',
                dettaglioLinea: {
                    dettaglioLinea: 'Détail ligne',
                    dimentica: 'Oublier',
                    disponibilitaFermate: 'Disponibilité arrêts :',
                    nessunaCoincidenza: 'Aucune association',
                    nessunaFermata: 'Aucun arrêt',
                    ricorda: 'Mémoriser',
                },
                elencoFermate: 'Arrêts',
                elencoFermateA: 'Liste des arrêts à : ',
                elencoLinee: {
                    descrizione: 'Description',
                    direzione: 'Direction',
                    elencoLinee: 'Liste des lignes à proximité',
                    elencoPercorsi: 'Parcours de la ligne',
                    haiCercato: 'Vous avez cherché :',
                    noPercorsi: 'Il n’y a pas de parcours',
                    noSoluzioniVisibili: 'Aucune ligne',
                    nonDisponibile: 'Pas disponible',
                    passaggio: 'Passage prévu',
                    passaggioAlle: 'Passage à',
                    passaggioOgni: 'Passages toutes les',
                },
                elencoMovimenti: {
                    header: 'Liste des mouvements',
                },
                fermata: 'Arrêt',
                fermate: 'Arrêts',
                header: 'Transport régional',
                linee: 'Liste des lignes',
                mieiAbbonamenti: {
                    abbonamentiNonTrovati: "Il n’y a pas d'abonnements valables sur ce dispositif.",
                    acquistaRinnova: 'Acheter/Renouveler',
                    articoliDisponibili: 'Articles disponibles',
                    elencoAbbonamenti: 'Liste des abonnements',
                    elencoTessereAttive: 'Cartes actives',
                    extraUrbano: 'Extra-urbain',
                    goToMyAbbonamenti: 'Aller à « Abonnements »',
                    header: 'Abonnements',
                    infoAbbonamentiNonTrovati:
                        "Il n’y a pas d'abonnements valables sur ce dispositif. Essayez de charger les abonnements déjà existants en cliquant sur le bouton ci-dessus.",
                    infoRequisitiAcquistoHTML:
                        'Pour effectuer l\'achat, il est nécessaire d’associer une carte du transporteur choisi. Vous pouvez en ajouter une en quelques clics, en accédant à votre espace réservé sur <a href="#" style="text-decoration: none;">www.mycicero.it</a> par le biais d’un PC traditionnel. D’ici peu il sera possible d’effectuer cette opération même à partir d’un dispositif mobile',
                    infoTitoliAcquistati:
                        'Vous pouvez trouver le titre de voyage dans la section « Abonnements » du « Transport régional »',
                    istruzioniDownloadAbbonamentiAsincroni:
                        'Une fois l’achat terminé, pour télécharger le titre, entrez dans la section « Abonnements » et mettez la liste à jour',
                    nessunaTesseraValida:
                        "Il n’y a pas d'abonnement associé à vos cartes, il n'est pas possible d'effectuer le renouvellement, pour acheter un nouvel abonnement adressez-vous à votre transporteur.",
                    rinnovaAbbonamento: 'Renouveler l’abonnement',
                    scegliTessera: 'Choisir la carte',
                    scegliVettoreAbbonamento:
                        "Choisir le transporteur dont vous souhaitez acheter ou renouveler l'abonnement.",
                    selezionaArticolo: "Sélectionner l'article",
                    soluzioniPossibili: 'Solutions possibles',
                    templateTratta: 'De {0} à {1}',
                    ultimaObliterazione: 'Dernière oblitération',
                    urbano: 'Urbain',
                    validitaLinee: 'Valable pour les lignes',
                },
                mieiBiglietti: {
                    acquista: 'Achetez un titre',
                    attivi: 'Actifs',
                    daobliterare: 'À activer',
                    elencoBigliettiDaObliterare: 'Liste des titres achetés à oblitérer',
                    elencoBigliettiUsati: 'Liste des titres utilisés',
                    elencoBigliettiValidi: 'Liste des titres en cours de validité',
                    finoAl: 'Jusqu’au',
                    goToMyTickets: 'Voir les titres',
                    header: 'Mes titres',
                    infoTitoliAcquistati: 'Vous pouvez trouver le titre de voyage dans la section « Transport »',
                    noTitoliAttivi: 'Aucun titre actif n’a été trouvé',
                    noTitoliDaObliterare: 'Aucun titre à valider n’a été trouvé',
                    noTitoliScaduti: 'Aucun titre expiré n’a été trouvé',
                    obliterati: 'Oblitérés et validés',
                    scadenzaTime: 'valide jusqu’à',
                    scaduti: 'Expirés',
                    validita: 'Validité',
                    validoDal: 'Valable à partir de',
                    validoFinoAl: 'Valable jusqu’à',
                },
                mostraAltreFermate: 'Montrer d’autres arrêts',
                mostraAltreLinee: 'Montrer d’autres lignes',
                mostraAltreStazioni: 'Montrer d’autres gares',
                mostraAltriPassaggi: 'Montrer d’autres passages',
                obliterazioneAutomatica: 'Oblitération automatique',
                partenze: 'Départs',
                passaggi: 'Passages',
                percorsi: 'Parcours',
                prossimoTra: 'Le prochain est ',
                pulisci: 'Nettoyer',
                ricaricaCredito: {
                    header: 'Recharger le crédit',
                    ricaricaActvWarning:
                        'Le crédit résiduel éventuellement présent compte tenu des achats effectués ou de recharges effectuées et pas utilisées, n’est remboursable d’aucune manière.',
                },
                ritardo: 'Retard',
                scaduti: 'Expirés',
                scegliVettore: 'Chercher par municipalité, entreprise ou événement :',
                scegliVettorePlaceholder: 'Entreprise/Événement',
                seiVicino: 'vous vous trouvez près d’ici',
                servizioNonAttivo:
                    'Vous n’avez pas encore activé le service « Transport public ». Il suffit d’un instant.',
                soluzioniViaggio: {
                    cercaCollegamentiLocali: 'Chercher des liaisons locales',
                    cercaSoluzioni: 'Chercher des solutions',
                    elencoSoluzioni: 'Liste des solutions',
                    frequenzaOgni: 'Chaque',
                    header: 'Solutions de voyage',
                    headerAndata: 'Solutions aller',
                    headerRitorno: 'Solutions retour',
                    invertiDirezione: 'Inverser la direction',
                    mostra: 'Montrer :',
                    mostraSuMappa: 'Itinéraire sur carte',
                    nessunCollegamentoLocale: 'Aucune liaison locale',
                    nessunaDestinazione: 'Aucune destination trouvée pour le critère de recherche précisé',
                    nessunaSoluzione: 'Aucune solution de voyage trouvée',
                    noSoluzioniVisibili: 'Il n’y a pas de solution visible.',
                    nonAcquistabile: 'Solution pas disponible',
                    nonTuttiBigliettiAcquistabili: 'Certains tickets ne sont pas disponibles',
                    ordinaPerOrarioArrivo: 'Trier par heure d’arrivée',
                    ordinaPerOrarioPartenza: 'Trier par heure de départ',
                    ordinaPerSoluzioniAcquistabili: 'Trier par solutions disponibles',
                    ordinaPerTempoTotale: 'Trier par durée totale',
                    salvaRicercaPreferitaInfo:
                        'Pour en ajouter une, appuyez sur la touche « Sauvegarder » sur la page de résultat de la recherche Solution de voyage.',
                    scambia: 'Échanger',
                    tempoTotale: 'Durée totale',
                    tuttiBigliettiAcquistabili: 'Tous les tickets sont disponibles',
                },
                tipoServizio: 'Type de service',
                trenitalia: {
                    altreInfo: 'Autres informations',
                    cartaFreccia: 'CartaFRECCIA',
                    condizioni:
                        "Le ticket électronique régional est émis déjà validé. Il n'est pas possible d’anticiper le départ, le changement de ticket n'est pas autorisé et ne peut pas être remboursé. Le ticket est nominatif et associé au prénom et au nom saisis lors de l’enregistrement en ligne ou dans les données du voyageur ; le ticket acheté en ligne pour des voyages sur des trains régionaux doit être présenté - sur demande du personnel de contrôle - sous format papier (avant de partir, imprimez le PDF joint à l’e-mail d'achat) ou par écran de dispositif informatique (PC, tablette, smartphone) en mesure d’afficher correctement le fichier .pdf, avec un document d’identité valide.",
                    condizioniAcquistoTrenitalia:
                        'J’accepte les <a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/tcom/Informazioni/Condizioni-Generali-di-trasporto/Condizioni-Generali-di-trasporto\',true)">conditions de transport</a> du transporteur et j’ai lu la<a href="#" onclick="javascript:openLinkOnBrowser(\'http://www.trenitalia.com/cms-file/html/trenitalia/Informativa_sulla_privacy.html\',true)"> politique de confidentialité</a>.',
                    infoTariffa: 'Info tarifs',
                    menu: 'Trenitalia',
                    modificaBigliettoHeader: 'Modifier le ticket',
                    modificaBigliettoMessage:
                        "<div class='textAlignLeft'><p>Pour effectuer :<br/><ul><li>le changement de la réservation (date/heure de départ)</li><li>le changement du ticket (ville de départ ou d’arrivée ; type de ticket ; nombre de voyageurs etc.)</li><li>la demande de remboursement pour renonciation au voyage</li></ul></p><p class='bold'>Rendez-vous à la gare la plus proche et montrez ce titre de voyage.</p></div>",
                    percorsoFerroviario: 'Parcours',
                    popupDiniego: {
                        cancelLabel: 'Je ne veux pas laisser de coordonnées',
                        confirmLabel: 'Saisissez les coordonnées',
                        content:
                            'Vous n’avez pas indiqué de coordonnées pour tous les passagers. Trenitalia ne pourra pas les contacter concernant ce voyage',
                        title: 'Attention',
                    },
                    riepilogo: 'Récapitulatif',
                    stazioneArrivo: "Gare d'arrivée",
                    stazioneNonValida: 'Gare pas valide',
                    stazionePartenza: 'Gare de départ',
                    tariffe: 'Tarifs',
                    viaggioAndata: 'Voyage d’aller',
                    viaggioRitorno: 'Voyage de retour',
                    vuoiModificareIlBiglietto: 'Vous souhaitez modifier le ticket ?',
                },
                tutteLeLocalita: 'Toutes les localités',
                vaiAlleImpostazioni: 'Aller aux configurations',
                validazioneAutomatica: 'Titre validé automatiquement',
                zoneServite: {
                    header: 'Zones couvertes par le service',
                },
            },
            travels: {
                details: {
                    header: 'détails',
                },
            },
            treasureHunt: {
                abbandonaSquadra: 'Êtes-vous certain de vouloir abandonner l’équipe ?',
                aggiornaProcedi: 'Mettez à jour et continuez',
                aggiungiGiocatore: 'Ajouter joueur',
                cacciaAlTesoro: 'Chasse au trésor',
                checkVideoCaricato: "êtes-vous certain d'avoir chargé la vidéo et de vouloir continuer ?",
                codiceSquadra: 'Code équipe',
                comeFunziona: 'Comment cela fonctionne-t-il ?',
                compilaCampi: 'Remplissez les champs',
                compitoCompletato: 'Tâche terminée',
                completaPagamenti: 'Terminer les paiements',
                countDownInizioGiocoAfter: 'Le jeu est commencé par {0}',
                countDownInizioGiocoBefore: 'Il manque {0} au début du jeu',
                countDownInizioGiocoSame: 'Nous y sommes...',
                createTeam: 'Je veux créer une nouvelle équipe',
                erroreAggiungiGiocatore: 'Impossible d’ajouter la personne à la propre équipe.',
                erroreCaricamentoGiochi:
                    'Une erreur s’est produite pendant le chargement des jeux. Veuillez réessayer plus tard.',
                erroreCaricamentoGioco:
                    'Une erreur s’est produite pendant le chargement du jeu. Veuillez réessayer plus tard.',
                erroreCheckLocation: 'Désolé.>br />Une erreur s’est produite.',
                erroreInfoTeam: 'Impossible de récupérer les infos de l’équipe',
                erroreRimozioneGiocatoreQuotaPagata:
                    'Impossible d’éliminer le joueur parce que vous avez déjà payé les frais d’inscription.',
                erroreRimozioneGiocatoreQuotaSquadraPagata:
                    'Impossible d’éliminer le joueur parce que vous avez payé les frais d’inscription de l’équipe.',
                faseRisoltaDalTeam: 'Votre groupe a déjà résolu cette phase.',
                garaFinita: 'La compétition est terminée.',
                giocaNoSmartphone:
                    'Dans ce mode, le joueur participera à la chasse mais vous ne pourrez pas utiliser votre smartphone.',
                giocatori: 'joueurs',
                gpsGenericError:
                    "Désolé.<br />Vous n'avez pas fourni les autorisations pour récupérer la position GPS.Désolé.<br />Une erreur s’est produite.",
                gpsPermissionDenied:
                    "Désolé.<br />Vous n'avez pas fourni les autorisations pour récupérer la position GPS.",
                gpsPositionUnavailable: 'Désolé.<br />Impossible de récupérer la position GPS.',
                gpsTimeout:
                    'Désolé.<br/>Une erreur s’est produite avec le GPS. <br />Contrôlez l’état de l’antenne GPS et les autorisations et redémarrez l’application.',
                graziePerLaRisposta: 'Merci pour la réponse !',
                indizio: 'Indice',
                infoIscrizione:
                    'L’inscription de chacun est valide après avoir effectué le paiement. L’équipe pourra jouer quand toutes les participations ont été payées.',
                invitaGiocatore:
                    'Envoyez une invitation à un nouveau joueur. Vous recevrez un code par le biais duquel vous pourrez accéder directement au groupe {0}.',
                invitaGiocatoreNoEmail:
                    'Le joueur ne possède pas d’e-mail ou un contact social ? Ajoutez-le directement à {0}.',
                iscrizioneSquadra: 'Inscription équipe',
                iscrizioniChiuse: 'Désolé, mais vous ne pouvez pas vous enregistrer à cette compétition.',
                itinerariSorpresa: 'Itinéraires surprise',
                itinerarioSorpresa: 'Itinéraire surprise',
                joinTeam: 'J’ai été invité et j’ai un code',
                luogo: 'Lieu',
                luogoGiusto: 'Félicitation !<br />C’est le bon endroit.',
                luogoSbagliato: "Désolé.<br />Ce n'est pas le bon endroit.",
                nessunGioco:
                    'Vous pourrez bientôt trouver des jeux amusants pour découvrir les beautés de la ville de Lecce !<br />Des chasses au trésor, des quiz et des itinéraires surprise vous guideront dans les lieux les plus caractéristiques, à travers l’histoire, l’art et l’œnogastronomie d’une des villes les plus belles d’Italie.',
                nomeSquadra: 'Nom de l’équipe',
                nomeSquadraErrore: 'Maximum 20 caractères',
                pagaQuotaGiocatore: "Êtes-vous sûr de vouloir payer pour le joueur '{0}' ?",
                pagaQuotaSquadra: 'Êtes-vous sûr de vouloir payer les frais d’inscription de l’équipe ?',
                pagamentiNonCompletati: "Vous n'avez pas encore terminé les paiements",
                prossimoIndizioConPenalita: 'Prochain indice (mais vous perdez {0} points)',
                quizzone: 'Quizzone',
                quotaGiocatoreNonPagata:
                    'Un des membres de l’équipe n’a pas payé les frais d’inscription. Éliminez-le ou payez ses frais d’inscription',
                quotaSquadraNonPagata: 'Pour continuer il est nécessaire de payer les frais d’inscription de l’équipe',
                raggiungiLuogo: 'Rejoignez le lieu',
                rimuoviGiocatore: 'Êtes-vous sûr de vouloir éliminer {0} ?',
                rispostaEsatta: 'Réponse exacte',
                rispostaSbgliata: 'Réponse erronée',
                scegliNomeSquadra: 'Choisissez un nom sympa et facile à mémoriser',
                shareEvent: 'Partagez l’événement avec vos amis',
                svelamiLuogo: 'Oui, dévoilez-moi le lieu',
                svelamiLuogoConPenalita: 'Dévoilez-moi le lieu (mais je perds {0} points)',
                tornaAlGioco: 'Retour au jeu',
                tornaAllInizio: 'Non, retour au début',
                traguardo: 'Objectif',
                verificaLuogo: 'Vérifier si je suis arrivé au bon endroit',
                whoo: 'Whoo-hoo !',
            },
            tua: {
                AcquistaBiglietti: '',
                AcquistaBigliettiHTML: 'Acheter<br/>des titres',
                CalcolaPercorsoHTML: 'Calculer<br/>le parcours',
                FermateOrariHTML: 'Arrêts<br/>et horaires',
                MieiTitoli: '',
                MieiTitoliHTML: 'Mes<br/>titres',
                SostaInAbruzzoHTML: 'Stationner dans les<br/>Abruzzes',
                UltimeNotizieHTML: 'Dernières<br/>nouveautés',
                bigliettiTariffaFissa: 'Tickets à tarif fixe',
                soluzioneNonAcquistabile:
                    'Malheureusement ce ticket n’est pas disponible en ce moment.<br/>Vous souhaitez savoir quand ce sera possible ?<br/><br/>Contactez-nous au numéro <a href="tel:800762622">+39 800762622</a> ou envoyez un e-mail à <a href="mailto:infotrasporto@mycicero.it">infotrasporto@mycicero.it</a>',
            },
            turismo: {
                buoniDisponibili: 'Bons disponibles',
                buoniEsauriti: 'Bons terminés',
                buoniUtilizzati: 'Bons utilisés',
                caricaAltri: 'Montrer 10 trajets',
                caricamentoInCorso: 'Chargement en cours',
                cerca: 'Recherche',
                cercaCoupon: 'Chercher offres spéciales',
                cercaCouponPlaceholder: 'Chercher une offre',
                cercaEventi: 'Chercher des événements',
                cercaEventiPlaceholder: 'Chercher un événement',
                cercaIndirizzoPlaceholder: 'Adresse ou localité',
                cercaItinerariPlaceholder: 'Chercher un itinéraire',
                cercaItinerario: 'Chercher des itinéraires',
                cercaPoi: 'Chercher des lieux',
                cercaPoiPlaceholder: 'Chercher un lieu',
                cercaProdotti: 'Chercher des produits',
                cercaProdottiPlaceholder: 'Chercher un produit',
                cercaServiziPlaceholder: 'Chercher un service',
                cercaServizio: 'Chercher des services',
                concluso: 'Terminé',
                condizioni: 'Conditions',
                costoDelBuono: 'Coût du bon :',
                costoInCrediti: 'Coût en crédits :',
                couponCorrelati: 'Ici vous trouvez également',
                couponGratuito:
                    "Ce bon est gratuit et vous pouvez l'avoir sans utiliser de crédits : il vous suffit de cliquer sur « Obtenir le bon » pour pouvoir l'activer.",
                creditiConvertiti: 'Crédits convertis :',
                creditiPerCouponsPresso:
                    'Vous avez encore {0} crédits que vous pouvez transformer en bons à dépenser auprès de {1}',
                creditiPerCouponsTerminatiPresso:
                    "Vous n'avez pas de crédits suffisants pour obtenir des bons auprès de {0}",
                creditiResiduiTotali: 'Crédits résiduels totaux',
                creditiRimanenti: 'Crédits résiduels :',
                creditiTotali: 'Crédits totaux :',
                creditoPerCouponsPresso:
                    'Vous avez encore {0} crédit que vous pouvez transformer en bons à dépenser auprès de {1}',
                dataAlle: '{0} à {1}',
                dataCreazione: 'Date création :',
                dataDalleAlle: '{0} de {1} à {2}',
                dataInizioDalleDataFineAlle: 'Du {0} à {1} au {2} à {3}',
                dataInizioDataFine: 'Du {0} au {1}',
                dataOra: 'Date et heure',
                detail: {
                    cellulare: 'Numéro de portable',
                    certificazioni: 'Certifications',
                    citta: 'Ville',
                    contatto: 'Contact',
                    costs: 'Entrée',
                    couponCorrelati: 'Offres spéciales',
                    email: 'E-mail',
                    eventiCorrelati: 'Événements associés',
                    facebook: 'Facebook',
                    fax: 'Fax',
                    gestione: 'Gestion',
                    giorno: 'Jour {0}',
                    header: 'Contacts',
                    indirizzo: 'Adresse',
                    itinerariCorrelati: 'Itinéraires associés',
                    luoghiCorrelati: 'Lieux associés',
                    navetteCorrelate: 'Navettes qui vous y emmènent',
                    note: 'Notes',
                    ospiti: 'Hôtes importants',
                    promo: 'Promotions',
                    propostoDa: 'Proposé par',
                    quando: 'Quand',
                    scaricaAllegati: 'Télécharger les documents joints',
                    serviziInclusi: 'Services inclus',
                    serviziUtili: 'Services utiles',
                    sitoWeb: 'Site Internet',
                    sitoWebOrganizzatore: 'Site Internet organisateur',
                    social: 'Réseaux sociaux',
                    specialitaCorrelate: 'Produits associés',
                    tappa: 'Étape {0} :',
                    tel: 'Tél',
                    telefono: 'Numéro de téléphone',
                    temi: 'Thèmes',
                    troviAnche: 'Promos associées',
                    url: 'Internet',
                    vaiAlSito: 'Aller sur le site',
                    zoneProduzione: 'Zones de production',
                },
                details: 'Détails',
                dettagli: 'Détails',
                diarioDiViaggio: 'Journal',
                downloads: 'Téléchargements',
                error: {
                    cantFilterAroundYou:
                        "Impossible de configurer le filtre « Dans vos alentours » si la position GPS n'est pas disponible.",
                    cantOrderByDistance:
                        "Impossible de configurer le tri « Par distance » si la position GPS n'est pas disponible.",
                },
                erroreGenerazioneQrCode: 'Une erreur s’est produite pendant la création du code QR',
                esperienze: 'Expériences',
                estendiRaggioRicerca: 'Étendre le rayon de recherche',
                eventi: 'Événements',
                favorites: {
                    errorAddFavorites:
                        'Une erreur s’est produite pendant la sauvegarde du favori. Assurez-vous d’être connecté à Internet et réessayez.',
                    errorDeleteFavorites:
                        'Une erreur s’est produite pendant l’élimination du favori. Assurez-vous d’être connecté à Internet et réessayez.',
                    errorGetFavorites: 'Une erreur s’est produite pendant le chargement des favoris.',
                    errorUpdateFavorites:
                        'Une erreur s’est produite pendant la modification du favori. Assurez-vous d’être connecté à Internet et réessayez.',
                },
                filters: {
                    afternoon: 'Après-midi',
                    allDay: 'Toute la journée',
                    aroundYou: 'Dans vos alentours',
                    cosa: 'Quoi',
                    dataSpecifica: 'Choisissez la date spécifique',
                    everywhere: 'Partout',
                    fasciaOraria: 'Plage horaire',
                    morning: 'Matin',
                    night: 'Soir',
                    oggi: 'Aujourd’hui',
                    perData: 'Par date',
                    perDistanza: 'Par distance',
                    perRilevanza: 'Par importance',
                    perScadenza: 'En échéance',
                    perSconto: 'Par réduction',
                    periodoSpecifico: 'Choisissez la période spécifique',
                    prossimi30Giorni: 'Les 30 prochains jours',
                    prossimi7Giorni: 'Les 7 prochains jours',
                    quando: 'Quand',
                },
                filtra: 'Filtrer',
                filtraEventi: 'Filtrer les événements',
                filtraItinerari: 'Filtrer les itinéraires',
                filtraLuoghi: 'Filtrer les lieux',
                filtraOrdina: 'Filtrer et trier',
                filtraProdotti: 'Filtrer les produits',
                filtraPromo: 'Filtrer les promos',
                filtraServizi: 'Filtrer les services',
                inserisciNota: 'Insérez une note...',
                itinerari: 'Itinéraires',
                leggiCondizioni: 'Lisez les conditions',
                luoghi: 'Lieux',
                mostraQrCodeAllaCassa: 'Montrer le code QR à la caisse pour utiliser le bon',
                neiParaggi: 'Dans les parages',
                nessunPreferitoSalvato: 'Cette section est vide pour le moment.',
                noAvailableCoupons: 'Vous trouverez ici les bons à utiliser',
                noCreditsReport: 'Ici vous trouverez le récapitulatif de vos crédits',
                noResults: 'Aucun résultat trouvé',
                noUsedCoupons: 'Vous trouverez ici le récapitulatif des bons que vous avez utilisés',
                note: 'Notes',
                numCrediti: '{0} crédits',
                numOfRemainingCoupons: '{0} bons</br>résiduels',
                offerteSpeciali: 'Offres spéciales',
                oneRemainingCoupon: '1 bon</br>résiduel',
                ora: 'Maintenant',
                ordina: 'Trier',
                ordinaEventi: 'Trier les événements',
                ordinaItinerari: 'Trier les itinéraires',
                ordinaLuoghi: 'Trier les lieux',
                ordinaPromo: 'Trier les promos',
                ordinaServizi: 'Trier les services',
                ottieniBuoni: 'Obtenir des bons',
                pisteCiclabili: 'Pistes cyclables',
                preferiti: 'Favoris',
                preferitiDiarioViaggio: 'Favoris et journal de voyage',
                presso: 'Auprès de : {0}',
                prodotti: 'Produits',
                prodottiTipici: 'Produits typiques',
                promo: 'Promo',
                quantiBuoniVuoi: 'Combien de bons voulez-vous ?',
                ricercaIncorso: 'Recherche en cours',
                rimuoviDataOra: 'Éliminer date et heure',
                rimuoviOrario: 'Éliminer horaire',
                risultatiEntro: 'Vous avez cherché dans{0}',
                saldoRimanente: 'Solde résiduel',
                scansionaQrCode: 'Scanner le code QR',
                scansionaQrCodeAllaCassa: 'Scanner le code QR présent à la caisse',
                scaricaAllegati: '',
                scegliData: 'Choisissez la date',
                sconto: 'Réduction',
                servizi: 'Services',
                serviziUtili: 'Services utiles',
                shopping: 'Shopping',
                toccaPerIngrandire: 'Toucher pour agrandir',
                trasformaCreditoInBuoni: 'Transformez votre crédit en bons',
                trasformaTotCreditoInBuoni:
                    "Vous êtes sur le point d’utiliser <span class='secondary bold'>{0}</span> pour obtenir un bon de réduction de la valeur de <span class='secondary bold'>{1}€</span> à dépenser auprès de ce sponsor.",
                tuoiCreditiBuoni: 'Vos crédits et vos bons',
                unCredito: '1 crédit',
                utilizzaTuoiCrediti: 'Utilisez vos crédits',
                utilizzatoIl: 'Utilisé le :',
                validoFinoA: 'Valide jusqu’à',
                valoreBuono: 'Valeur du bon :',
                valoreBuonoPressoSponsor: 'Ce sponsor met à disposition des bons de {0}€.',
                valoreCumulativoBuono: 'Valeur cumulative bon :',
                valoreInEuro: 'Valeur en euros :',
                withinRange: 'Jusqu’à {0}',
            },
            unicoc: {
                acquistaTicket: 'Acheter le ticket',
                calcolaPercorso: 'Calculer le parcours',
                mieiTitoli: 'Mes titres',
                puntiVendita: 'Points de vente',
                trovaTariffa: 'Trouvez le tarif',
            },
            ventis: {
                cambiaZona: 'Changer zone',
                effettuaLogin: 'Effectuer l’identification',
                homeTitle: 'Ventis vous souhaite la bienvenue à {0}',
                hometitleNoPos: 'Ventis vous souhaite la bienvenue',
                infoCredito:
                    'Votre crédit, en le chargeant par Carte de crédit, MasterPass ou Satispay. <b>Ce mode ne prévoit PAS de frais supplémentaires.</b> Le crédit peut également être utilisé pour acheter des titres de voyage et pour tous les autres services disponibles.',
                loginMessage:
                    "Pour pouvoir utiliser cette application, il est nécessaire d'accéder comme utilisateur enregistré <b>Ventis</b>.",
                registrati: 'Enregistrez-vous',
                requisitiAccesso: '',
                serviziTuttaItalia: 'Nos services sont actifs dans toutes l’Italie.',
                tutorial: {
                    subtitle1: 'Découvrez les avantages réservés aux clients Ventis',
                    subtitle2: 'Avec Ventis Mobility vous ne payez que les minutes effectives',
                    subtitle3: 'Confortablement depuis l’application Ventis Mobility en un clic',
                    subtitle4:
                        'Le site à ne pas manquer, vous trouverez de grandes marques avec des réductions jusqu’à 70 %',
                    subtitle5: 'Simplicité et économie sur mesure pour vous',
                    subtitle6: '',
                    title1: 'Bienvenue dans Ventis Mobility',
                    title2: 'Économisez sur le stationnement',
                    title3: 'Achetez les tickets de train, bus et métro',
                    title4: 'Ventis.it',
                    title5: 'Tout dans une seule application',
                    title6: '',
                },
            },
            visitRomagna: {
                dormi: 'Dormez',
                erroreCaricamentoDati: 'Une erreur s’est produite pendant le chargement des données.',
                fermati: 'Arrêtez-vous',
                mostraTuttiEventi: 'Montrer tous les événements',
                muoviti: 'Déplacez-vous',
            },
        },
    },
    /*### GENERATED_CONTENT_END ###*/

    outputCode: {
        tmpStr: '',
        addBreadCumb: function(name) {
            var s = translation.outputCode;
            if (s.tmpStr === '') {
                s.tmpStr += name;
            } else {
                s.tmpStr += '.' + name;
            }
        },

        resultArray: [],

        addResult: function() {
            translation.outputCode.resultArray.push(translation.outputCode.tmpStr);
        },

        goBackOneLevel: function() {
            var s = translation.outputCode;
            if (s.tmpStr !== '') {
                var b = s.tmpStr.split('.');

                if (b.length > 0) {
                    b = b.slice(0, b.length - 1);
                }

                s.tmpStr = b.join('.');
            }
        },

        capitalize: function(string) {
            return string.charAt(0).toUpperCase() + string.slice(1);
        },
    },

    loopObjProps: function(obj) {
        $.each(obj, function(key, value) {
            translation.outputCode.addBreadCumb(key);

            if (typeof value == 'object') {
                translation.loopObjProps(value);
            } else {
                translation.outputCode.addResult();
                translation.outputCode.goBackOneLevel();
            }
        });
        translation.outputCode.goBackOneLevel();

        //end of loop
    },

    generateCode: function() {
        var sourceObj = this.it.translation;
        var s = translation.outputCode;
        //console.log(sourceObj);

        translation.loopObjProps(sourceObj);

        //displaying results
        console.log(translation.outputCode.resultArray);

        //generating translations selectors code

        var vArray = translation.outputCode.resultArray.slice();
        var finalArray = [];

        $.each(vArray, function(idx, data) {
            var ref = data.split('.');
            $.each(ref, function(i, d) {
                ref[i] = s.capitalize(d);
            });

            var formatVarData = ref.join('');

            var outVar = 'this.l_{0} = ko.observable("")';
            outVar = outVar.format(formatVarData);

            var outInit = 'self.l_{0}($.t("{1}"))';
            outInit = outInit.format(formatVarData, data);
            finalArray.push({ variable: outVar, init: outInit });
        });

        //   console.log(finalArray);
        console.log('************ VARIABLES **********');
        $.each(finalArray, function(idx, data) {
            console.log(data.variable);
        });
        console.log('************ END VARIABLES **********');

        console.log('************ INIT VARIABLES **********');
        $.each(finalArray, function(idx, data) {
            console.log(data.init);
        });
        console.log('************ END OF INIT VARIABLES **********');
    },
};

// hook per il translation manager
if (typeof module !== 'undefined' && typeof module.exports !== 'undefined') module.exports = translation;

/*
 Codifica caratteri in formato ottale: http://unicodelookup.com/
 Caratteri comuni:
 è       \350
 é       \351
 È       \310
 à       \340
 ù       \371
 ò       \362
 ì       \354
 ä       \344
 ö       \366
 ü       \374
 Ü       \334
 ß       \337
 */
